(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $Authenticator_spec_ed25519_authentication_key (T@$Value) T@$Value)
(declare-fun $Authenticator_spec_multi_ed25519_authentication_key (T@$Value) T@$Value)
(declare-fun $Authenticator_MultiEd25519PublicKey_public_keys () Int)
(declare-fun $Authenticator_MultiEd25519PublicKey_threshold () Int)
(declare-fun $Authenticator_MultiEd25519PublicKey_type_value () T@$TypeValue)
(declare-fun $Authenticator_MultiEd25519PublicKey () T@$TypeName)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((public_key@@1 T@$Value) )  (and (and ((_ is $Vector) ($Authenticator_spec_ed25519_authentication_key public_key@@1)) (let ((va@@8 (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0))
)))))
(assert (forall ((k T@$Value) )  (and (and ((_ is $Vector) ($Authenticator_spec_multi_ed25519_authentication_key k)) (let ((va@@9 (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0))
)))))
(assert (= $Authenticator_MultiEd25519PublicKey_public_keys 0))
(assert (= $Authenticator_MultiEd25519PublicKey_threshold 1))
(assert (= $Authenticator_MultiEd25519PublicKey_type_value ($StructType $Authenticator_MultiEd25519PublicKey $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k@@0 Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k@@0) (ite  (and (<= |l#0@@3| k@@0) (< k@@0 |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k@@0)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k@@0))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun public_keys () T@$Value)
(declare-fun threshold () T@$Value)
(declare-fun inline$$Authenticator_MultiEd25519PublicKey_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Le$1$dst@1 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$CastU64$0$dst@1 () T@$Value)
(declare-fun inline$$CastU64$0$dst@0 () T@$Value)
(declare-fun inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t12@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26132) (let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon57_Else_correct true))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon57_Then_correct true))
(let ((inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 19432) 19464) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 19432) 19454) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 19438) 19464) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 19438) 19454) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon57_Else_correct))))
(let ((inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 19426) 19438) inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 19426) 19432) inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon4_Else_correct)))))
(let ((inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 19418) 19464) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 19418) 19454) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon0_correct  (=> (and (and ((_ is $Vector) public_keys) (let ((va@@10 (|v#$Vector| public_keys)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (forall ((inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0 0) (< inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| public_keys)))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (forall ((inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$1 Int) ) (!  (=> (and (>= inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$1 0) (< inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0))) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0))) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0))) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0))) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) inline$$Authenticator_MultiEd25519PublicKey_pack$0$$$0))
))) (=> (and (and (and ((_ is $Integer) threshold) (>= (|i#$Integer| threshold) 0)) (<= (|i#$Integer| threshold) $MAX_U8)) (= inline$$Authenticator_MultiEd25519PublicKey_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 public_keys) 1 threshold) 2)))) (and (=> (= (ControlFlow 0 19410) 19426) inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 19410) 19418) inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon3_Else_correct))))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon55_Then_correct  (=> (and (|b#$Boolean| inline$$Le$1$dst@1) (= (ControlFlow 0 19444) 19410)) inline$$Authenticator_MultiEd25519PublicKey_pack$0$anon0_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct true))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 19534) 18716)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 19544) 18716) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon43_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 19528) 19544) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 19528) 19534) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 19514) 18716)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 19524) 18716) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon47_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 19508) 19524) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 19508) 19514) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 19494) 18716)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 19504) 18716) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon49_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 19488) 19504) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 19488) 19494) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 19474) 18716)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 19484) 18716) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon53_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 19468) 19484) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 19468) 19474) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 19079) 18716)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon56_Then_correct  (=> (= (ControlFlow 0 19089) 18716) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon55_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$1$dst@1)) (= $abort_code@6 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 19073) 19089) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 19073) 19079) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon53_Else_correct  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 19061) 19444) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 19061) 19073) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon51_Then$1_correct  (=> (and (and (and (= inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t21@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3)) (and (=> $abort_flag@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 19055) 19468) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 19055) 19061) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$Le$1$anon0_correct  (=> (and (= inline$$Le$1$dst@1 ($Boolean (<= (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t19@1)))) (= (ControlFlow 0 19043) 19055)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon51_Then$1_correct)))
(let ((inline$$Le$1$Entry_correct  (and (=> (= (ControlFlow 0 19029) (- 0 27051)) true) (=> (= (ControlFlow 0 19029) 19043) inline$$Le$1$anon0_correct))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon51_Then_correct  (=> (|b#$Boolean| inline$$Le$0$dst@1) (=> (and (= inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t19@1 ($Integer 32)) (= (ControlFlow 0 19049) 19029)) inline$$Le$1$Entry_correct))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 18967) 18716)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 18977) 18716) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon51_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$0$dst@1)) (= $abort_code@4 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 18961) 18977) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 18961) 18967) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 18949) 19049) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 18949) 18961) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon47_Else$1_correct  (=> (and (and (and (= inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t17@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2)) (and (=> $abort_flag@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 18943) 19488) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 18943) 18949) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Le$0$anon0_correct  (=> (and (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| inline$$CastU64$0$dst@1) (|i#$Integer| inline$$Vector_length$0$l@1)))) (= (ControlFlow 0 18931) 18943)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon47_Else$1_correct)))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 18917) (- 0 26917)) true) (=> (= (ControlFlow 0 18917) 18931) inline$$Le$0$anon0_correct))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon47_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 18937) 18917)) inline$$Le$0$Entry_correct)))
(let ((inline$$CastU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1 true) (= inline$$CastU64$0$dst@1 inline$$CastU64$0$dst@0)) (and (=> (= (ControlFlow 0 18861) 19508) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 18861) 18937) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$CastU64$0$anon3_Then_correct  (=> (and (> (|i#$Integer| threshold) $MAX_U64) (= (ControlFlow 0 18859) 18861)) inline$$CastU64$0$anon3_Then$1_correct)))
(let ((inline$$CastU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (|i#$Integer| threshold)) (=> (and (= $abort_flag@1 $abort_flag@0) (= inline$$CastU64$0$dst@1 threshold)) (and (=> (= (ControlFlow 0 18809) 19508) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 18809) 18937) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$CastU64$0$Entry_correct  (and (=> (= (ControlFlow 0 18795) (- 0 26854)) true) (and (=> (= (ControlFlow 0 18795) 18859) inline$$CastU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 18795) 18809) inline$$CastU64$0$anon3_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t12@1) (= (ControlFlow 0 18867) 18795)) inline$$CastU64$0$Entry_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 18708) 18716)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 18724) 18716) inline$$Authenticator_create_multi_ed25519_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t12@1)) (= $abort_code@2 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 18702) 18724) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 18702) 18708) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon43_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 18690) 18867) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 18690) 18702) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon41_Else_correct  (=> (not false) (=> (and (= inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t11@1 ($Integer 0)) (= inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t12@1 ($Boolean  (not ($IsEqual_stratified threshold inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t11@1))))) (=> (and (and (and (= inline$$Authenticator_create_multi_ed25519_$def_verify$0$$t13@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0)) (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 18684) 19528) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 18684) 18690) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon43_Else_correct)))))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon41_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) public_keys) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| public_keys))))) (and (=> (= (ControlFlow 0 18652) 19548) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 18652) 18684) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 18640) 18652)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 18531) 18640)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 19572) 18640) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon39_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18523) 19572) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 18523) 18531) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon39_Then_correct  (and (=> (= (ControlFlow 0 19580) 19572) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 19580) 18531) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon40_Else_correct))))
(let ((inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18517) 19580) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 18517) 18523) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon39_Else_correct)))))
(let ((anon0_correct  (=> (and (and ((_ is $Vector) public_keys) (let ((va@@12 (|v#$Vector| public_keys)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| public_keys)))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) $$0@@1)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) $$0@@1))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (forall (($$1 Int) ) (!  (=> (and (>= $$1 0) (< $$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) $$0@@1))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) $$0@@1))) $$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) $$0@@1))) $$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) $$0@@1))) $$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) $$0@@1))) $$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_keys)) $$0@@1))
))) (=> (and (and (and ((_ is $Integer) threshold) (>= (|i#$Integer| threshold) 0)) (<= (|i#$Integer| threshold) $MAX_U8)) (= (ControlFlow 0 17877) 18517)) inline$$Authenticator_create_multi_ed25519_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 26132) 17877) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun k@@1 () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $Authenticator_MultiEd25519PublicKey_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27418) (let ((inline$$Authenticator_public_keys_$def_verify$0$anon6_Else_correct true))
(let ((inline$$Authenticator_public_keys_$def_verify$0$anon6_Then_correct true))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys)) (and (=> (= (ControlFlow 0 20019) 20045) inline$$Authenticator_public_keys_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 20019) 20035) inline$$Authenticator_public_keys_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$Authenticator_public_keys_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 19943) 20019)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$Authenticator_public_keys_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 20053) 20019) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$Authenticator_public_keys_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 19937) 20053) inline$$Authenticator_public_keys_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 19937) 19943) inline$$Authenticator_public_keys_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@2)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@2))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (forall (($$1@@0 Int) ) (!  (=> (and (>= $$1@@0 0) (< $$1@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@2))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@2))) $$1@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@2))) $$1@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@2))) $$1@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@2))) $$1@@0))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@2))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_threshold)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_threshold)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $Authenticator_MultiEd25519PublicKey_threshold)) $MAX_U8))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 20059) 19937)) inline$$Authenticator_public_keys_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> (and (and (and (and (and (and (and ((_ is $Vector) k@@1) (let ((va@@17 (|v#$Vector| k@@1)))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| k@@1)) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@3)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@3))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (forall (($$1@@1 Int) ) (!  (=> (and (>= $$1@@1 0) (< $$1@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@3))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@3))) $$1@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@3))) $$1@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@3))) $$1@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@3))) $$1@@1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@3))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_threshold)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_threshold)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@1)) $Authenticator_MultiEd25519PublicKey_threshold)) $MAX_U8))) true) (= (ControlFlow 0 19802) 20059)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 27418) 19802) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun k@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27573) (let ((inline$$Authenticator_threshold_$def_verify$0$anon6_Else_correct true))
(let ((inline$$Authenticator_threshold_$def_verify$0$anon6_Then_correct true))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_threshold)) (and (=> (= (ControlFlow 0 20369) 20395) inline$$Authenticator_threshold_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 20369) 20385) inline$$Authenticator_threshold_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$Authenticator_threshold_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 20293) 20369)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$Authenticator_threshold_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 20403) 20369) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$Authenticator_threshold_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 20287) 20403) inline$$Authenticator_threshold_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 20287) 20293) inline$$Authenticator_threshold_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@4)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@4))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (forall (($$1@@2 Int) ) (!  (=> (and (>= $$1@@2 0) (< $$1@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@4))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@4))) $$1@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@4))) $$1@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@4))) $$1@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@4))) $$1@@2))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@4))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_threshold)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_threshold)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Authenticator_MultiEd25519PublicKey_threshold)) $MAX_U8))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (= (ControlFlow 0 20409) 20287)) inline$$Authenticator_threshold_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and (and (and (and (and (and (and ((_ is $Vector) k@@2) (let ((va@@23 (|v#$Vector| k@@2)))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| k@@2)) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys)) (let ((va@@24 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@5)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@5))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (forall (($$1@@3 Int) ) (!  (=> (and (>= $$1@@3 0) (< $$1@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@5))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@5))) $$1@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@5))) $$1@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@5))) $$1@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@5))) $$1@@3))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@5))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_threshold)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_threshold)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@2)) $Authenticator_MultiEd25519PublicKey_threshold)) $MAX_U8))) true) (= (ControlFlow 0 20152) 20409)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 27573) 20152) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun call1formal@res@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun public_key@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$Authenticator_ed25519_authentication_key_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27728) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 21260) (- 0 28220)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0) (=> (= (ControlFlow 0 21260) (- 0 28229)) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@0@@0 false) (= (ControlFlow 0 21190) 21260)) anon0$2_correct)))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 21188) 21190)) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon12_correct)))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 21198) 21190) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon12_correct)))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon16_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 21182) 21198) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 21182) 21188) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon16_Then_correct true))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon14_Else$2_correct  (=> (= call1formal@res@0 ($Hash_sha3_core |inline$$WritebackToValue$0$vdst'@2|)) (=> (and (and (and ((_ is $Vector) call1formal@res@0) (let ((va@@26 (|v#$Vector| call1formal@res@0)))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (forall ((i@@10 Int) ) (!  (=> (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| call1formal@res@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0)) i@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0)) i@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0)) i@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0)) i@@10))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0)) 32)) (and (=> (= (ControlFlow 0 21174) 21202) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 21174) 21182) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| public_key@@2) (= (ControlFlow 0 21140) 21174)) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon14_Else$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 1)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 public_key@@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 21166) 21174))) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon14_Else$2_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) |inline$$Vector_push_back$0$v'@1|)) (and (=> (= (ControlFlow 0 21041) 21166) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 21041) 21140) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon14_Else_correct  (=> (and (not false) (= (ControlFlow 0 21047) 21041)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon14_Then_correct true))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) len@@0 inline$$Authenticator_ed25519_authentication_key_$def_verify$0$$t3@1) (+ len@@0 1)))))) (and (=> (= (ControlFlow 0 20976) 21228) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 20976) 21047) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct  (=> (and (= inline$$Vector_push_back$0$ta@0 $IntegerType) (= (ControlFlow 0 20964) 20976)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 20913) 20964)) inline$$Vector_push_back$0$Entry_correct)))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon2$2_correct  (=> (and (= inline$$Authenticator_ed25519_authentication_key_$def_verify$0$$t3@1 ($Integer 0)) (= (ControlFlow 0 20919) 20913)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 1) $EmptyPath public_key@@2)) (= (ControlFlow 0 20871) 20919)) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon2$2_correct)))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 20787) 20871)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 21252) 20871) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 20781) 21252) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 20781) 20787) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and (and ((_ is $Vector) public_key@@2) (let ((va@@27 (|v#$Vector| public_key@@2)))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| public_key@@2)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| public_key@@2)) $$0@@6))
))) (= (ControlFlow 0 20540) 20781)) inline$$Authenticator_ed25519_authentication_key_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 27728) 20540) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1 () T@$Value)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t12@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun |inline$$WriteRef$2$to'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@2| () T@$Value)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1 () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@2 () T@$Mutation)
(declare-fun |inline$$Vector_append$1$v'@2| () T@$Value)
(declare-fun inline$$ReadRef$2$v@2 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@3 () T@$Value)
(declare-fun inline$$Vector_append$1$ta@1 () T@$TypeValue)
(declare-fun inline$$Vector_borrow$0$dst@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@2 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@2 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$Vector_borrow$0$ta@1 () T@$TypeValue)
(declare-fun inline$$Lt$0$dst@2 () T@$Value)
(declare-fun call1formal@res@0@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_append$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun call2formal@res@0 () T@$Value)
(declare-fun inline$$Vector_append$0$ta@0 () T@$TypeValue)
(declare-fun call0formal@ta@0 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun k@@3 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@0 () T@$Value)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$public_key@1 () T@$Value)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t10@1 () T@$Mutation)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_length$0$ta@0@@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28316) (let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon32_correct true))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 24711) 24713)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon32_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 24721) 24713) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon32_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon64_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 24705) 24721) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 24705) 24711) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon66_Else_correct)))))
(let ((GeneratedUnifiedExit_correct  (and (=> (= (ControlFlow 0 28310) (- 0 30272)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4) (=> (= (ControlFlow 0 28310) (- 0 30281)) (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))))))))
(let ((anon0$2_correct@@0  (=> (and (= $abort_flag@4 $abort_flag@3@@0) (= (ControlFlow 0 24861) 28310)) GeneratedUnifiedExit_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct  (=> (= inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@3@@0 true) (= (ControlFlow 0 23813) 24861)) anon0$2_correct@@0))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 24779) 23813)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 24789) 23813) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon59_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 24773) 24789) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 24773) 24779) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 24751) 23813)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 24761) 23813) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon62_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 24745) 24761) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 24745) 24751) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 24731) 23813)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon65_Then_correct  (=> (= (ControlFlow 0 24741) 23813) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon64_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 24725) 24741) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 24725) 24731) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@0 true) (and (=> (= (ControlFlow 0 24691) 24725) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 24691) 24705) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1) (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t12@2)) $MAX_U64) (= (ControlFlow 0 24689) 24691)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1) (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t12@2))) (=> (and (= inline$$AddU64$0$dst@2 ($Integer (+ (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1) (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t12@2)))) (= $abort_flag@2@@0 $abort_flag@1@@0)) (and (=> (= (ControlFlow 0 24633) 24725) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 24633) 24705) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon64_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 24603) (- 0 30092)) true) (and (=> (= (ControlFlow 0 24603) 24689) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 24603) 24633) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon62_Else$2_correct  (=> (and (= inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t12@2 ($Integer 1)) (= (ControlFlow 0 24697) 24603)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@2|) ($Local 1))) (= (ControlFlow 0 24474) 24697)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon62_Else$2_correct)))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$2$to'@2|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$2$vdst'@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@2|) 0 inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1 (|v#$Mutation| |inline$$WriteRef$2$to'@2|))) (= (ControlFlow 0 24500) 24697)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon62_Else$2_correct))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@2) (|p#$Mutation| inline$$BorrowLoc$2$dst@2) |inline$$Vector_append$1$v'@2|)) (and (=> (= (ControlFlow 0 24375) 24500) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 24375) 24474) inline$$WritebackToValue$2$anon3_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon62_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 24381) 24375)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$Vector_append$1$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$2$v@2) (=> (and ((_ is $Vector) inline$$Vector_borrow$0$dst@3) (= |inline$$Vector_append$1$v'@2| ($Vector (let ((m2 (|v#$ValueArray| (|v#$Vector| inline$$Vector_borrow$0$dst@3))))
(let ((l2 (|l#$ValueArray| (|v#$Vector| inline$$Vector_borrow$0$dst@3))))
(let ((m1 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2))))
(let ((l1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@2))))
($ValueArray (|lambda#2| 0 (+ l1 l2) l1 m1 m2 l1 $Error) (+ l1 l2))))))))) (and (=> (= (ControlFlow 0 24310) 24745) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 24310) 24381) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon62_Else_correct))))))
(let ((inline$$Vector_append$1$Entry_correct  (=> (and (= inline$$Vector_append$1$ta@1 $IntegerType) (= (ControlFlow 0 24294) 24310)) inline$$Vector_append$1$anon0_correct)))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@2 (|v#$Mutation| inline$$BorrowLoc$2$dst@2)) (= (ControlFlow 0 24239) 24294)) inline$$Vector_append$1$Entry_correct)))
(let ((inline$$BorrowLoc$2$anon0_correct  (=> (and (= inline$$BorrowLoc$2$dst@2 ($Mutation ($Local 1) $EmptyPath inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1)) (= (ControlFlow 0 24201) 24239)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 24151) 24201)) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon61_Then_correct  (=> (= (ControlFlow 0 24769) 24201) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon59_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 24143) 24769) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 24143) 24151) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@0 true) (= inline$$Vector_borrow$0$dst@3 inline$$Vector_borrow$0$dst@1)) (and (=> (= (ControlFlow 0 24097) 24773) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 24097) 24143) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$0$i_ind@2 0) (>= inline$$Vector_borrow$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1)))) (= (ControlFlow 0 24095) 24097)) inline$$Vector_borrow$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@2 0) (>= inline$$Vector_borrow$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1))))) (= inline$$Vector_borrow$0$dst@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1)) inline$$Vector_borrow$0$i_ind@2))) (and (= $abort_flag@1@@0 $abort_flag@0@@1) (= inline$$Vector_borrow$0$dst@3 inline$$Vector_borrow$0$dst@2))) (and (=> (= (ControlFlow 0 24037) 24773) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 24037) 24143) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct  (=> ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1@@1) (=> (and ((_ is $Integer) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1) (= inline$$Vector_borrow$0$i_ind@2 (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1))) (and (=> (= (ControlFlow 0 24011) 24095) inline$$Vector_borrow$0$anon3_Then_correct) (=> (= (ControlFlow 0 24011) 24037) inline$$Vector_borrow$0$anon3_Else_correct))))))
(let ((inline$$Vector_borrow$0$Entry_correct  (=> (and (= inline$$Vector_borrow$0$ta@1 ($VectorType $IntegerType)) (= (ControlFlow 0 23997) 24011)) inline$$Vector_borrow$0$anon0_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon58_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@2) (= (ControlFlow 0 24103) 23997)) inline$$Vector_borrow$0$Entry_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 23871) 23813)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon68_Then_correct  (=> (= (ControlFlow 0 23881) 23813) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon67_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 23865) 23881) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 23865) 23871) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 23851) 23813)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 23861) 23813) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon69_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 23845) 23861) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 23845) 23851) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 23831) 23813)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 23841) 23813) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon71_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 23825) 23841) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 23825) 23831) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 23805) 23813)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 23821) 23813) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$Abort_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon73_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 23799) 23821) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 23799) 23805) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon50_correct  (=> (and (= $abort_flag@3@@0 $abort_flag@0@@1) (= (ControlFlow 0 23787) 24861)) anon0$2_correct@@0)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 23785) 23787)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon50_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon75_Then_correct  (=> (= (ControlFlow 0 23795) 23787) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon50_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon73_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 23779) 23795) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 23779) 23785) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon71_Else$2_correct  (=> (= call1formal@res@0@@0 ($Hash_sha3_core |inline$$WritebackToValue$1$vdst'@2|)) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@0) (let ((va@@28 (|v#$Vector| call1formal@res@0@@0)))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (forall ((i@@11 Int) ) (!  (=> (and (<= 0 i@@11) (< i@@11 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) i@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) i@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) i@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) i@@11))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) 32)) (and (=> (= (ControlFlow 0 23771) 23799) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 23771) 23779) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon73_Else_correct))))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$0$vdst'@2@@0|) (= (ControlFlow 0 23737) 23771)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon71_Else$2_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 1)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1|) 0 |inline$$WritebackToValue$0$vdst'@2@@0| (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 23763) 23771))) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon71_Else$2_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1) |inline$$Vector_push_back$0$v'@1@@0|)) (and (=> (= (ControlFlow 0 23638) 23763) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 23638) 23737) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon71_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 23644) 23638)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$Vector_push_back$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1) (= |inline$$Vector_push_back$0$v'@1@@0| ($Vector (let ((len@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) len@@1 inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t17@1) (+ len@@1 1)))))) (and (=> (= (ControlFlow 0 23573) 23825) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 23573) 23644) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@0  (=> (and (= inline$$Vector_push_back$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 23561) 23573)) inline$$Vector_push_back$0$anon0_correct@@0)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowLoc$1$dst@1)) (= (ControlFlow 0 23510) 23561)) inline$$Vector_push_back$0$Entry_correct@@0)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon69_Else$3_correct  (=> (and (= inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t17@1 ($Integer 1)) (= (ControlFlow 0 23516) 23510)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 1) $EmptyPath |inline$$WritebackToValue$0$vdst'@2@@0|)) (= (ControlFlow 0 23468) 23516)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon69_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@0| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1) (= (ControlFlow 0 23386) 23468)) inline$$BorrowLoc$1$anon0_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 1)) (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|) 0 inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@0|) (= (ControlFlow 0 23412) 23468))) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0) |inline$$Vector_append$0$v'@1|)) (and (=> (= (ControlFlow 0 23287) 23412) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 23287) 23386) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon69_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 23293) 23287)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$Vector_append$0$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$0$v@1@@0) (=> (and ((_ is $Vector) call2formal@res@0) (= |inline$$Vector_append$0$v'@1| ($Vector (let ((m2@@0 (|v#$ValueArray| (|v#$Vector| call2formal@res@0))))
(let ((l2@@0 (|l#$ValueArray| (|v#$Vector| call2formal@res@0))))
(let ((m1@@0 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0))))
(let ((l1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0))))
($ValueArray (|lambda#2| 0 (+ l1@@0 l2@@0) l1@@0 m1@@0 m2@@0 l1@@0 $Error) (+ l1@@0 l2@@0))))))))) (and (=> (= (ControlFlow 0 23222) 23845) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 23222) 23293) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon69_Else_correct))))))
(let ((inline$$Vector_append$0$Entry_correct  (=> (and (= inline$$Vector_append$0$ta@0 $IntegerType) (= (ControlFlow 0 23206) 23222)) inline$$Vector_append$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 23151) 23206)) inline$$Vector_append$0$Entry_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon67_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 23157) 23151)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon58_Else$2_correct  (=> (and (= call0formal@ta@0 $IntegerType) (= call2formal@res@0 ($BCS_serialize_core inline$$GetFieldFromValue$1$dst@1))) (=> (and (and ((_ is $Vector) call2formal@res@0) (let ((va@@29 (|v#$Vector| call2formal@res@0)))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (forall ((i@@12 Int) ) (!  (=> (and (<= 0 i@@12) (< i@@12 (|l#$ValueArray| (|v#$Vector| call2formal@res@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@12))
))) (and (=> (= (ControlFlow 0 23115) 23865) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 23115) 23157) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon67_Else_correct))))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_threshold)) (= (ControlFlow 0 23107) 23115)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon58_Else$2_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 1) $EmptyPath inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1)) (= (ControlFlow 0 23059) 23107)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon58_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@2)) (= (ControlFlow 0 23065) 23059)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$Lt$0$anon0_correct  (=> (= inline$$Lt$0$dst@2 ($Boolean (< (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1) (|i#$Integer| inline$$Vector_length$0$l@1@@0)))) (and (=> (= (ControlFlow 0 22995) 24103) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 22995) 23065) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 22981) (- 0 29313)) true) (=> (= (ControlFlow 0 22981) 22995) inline$$Lt$0$anon0_correct))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$L3_correct  (=> (not $abort_flag@0@@1) (=> (and (and (and ((_ is $Vector) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1) (let ((va@@30 (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1)))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (forall ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0 Int) ) (!  (=> (and (>= inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0 0) (< inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$authentication_key_preimage@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0))
))) (and (and ((_ is $Integer) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1) (>= (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1) 0)) (<= (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$i@1) $MAX_U64))) (=> (and (and (and (and (and ((_ is $Vector) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$public_key@1) (let ((va@@31 (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$public_key@1)))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (forall ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@0 0) (< inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$public_key@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$public_key@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$public_key@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$public_key@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$public_key@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@0))
))) ((_ is $Boolean) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t8@1)) (and (and ((_ is $Vector) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t9@1) (let ((va@@32 (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t9@1)))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (forall ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@1 Int) ) (!  (=> (and (>= inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@1 0) (< inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@1 (|l#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t9@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t9@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t9@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t9@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t9@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@1))
)))) (and (and (and (and ((_ is $Vector) (|v#$Mutation| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t10@1)) (let ((va@@33 (|v#$Vector| (|v#$Mutation| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t10@1))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (forall ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$1 Int) ) (!  (=> (and (>= inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$1 0) (< inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$1 (|l#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t10@1))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t10@1))) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t10@1))) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t10@1))) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t10@1))) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$1))
))) (and (and ((_ is $Vector) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t11@1) (let ((va@@34 (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t11@1)))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (forall ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@2 Int) ) (!  (=> (and (>= inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@2 0) (< inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@2 (|l#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t11@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t11@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t11@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t11@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t11@1)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$$0@@2))
)))) (and (and (and ((_ is $Integer) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t12@1) (>= (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t12@1) 0)) (<= (|i#$Integer| inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t12@1) $MAX_U64)) (= (ControlFlow 0 23001) 22981)))) inline$$Lt$0$Entry_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 22701) 23001)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$L3_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 24797) 23001) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$L3_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon55_Else_correct  (=> (and (not false) (= inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$$t7@1 ($Integer 0))) (and (=> (= (ControlFlow 0 22693) 24797) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 22693) 22701) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon55_Then_correct true))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 22643) 24801) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 22643) 22693) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 $IntegerType) (= (ControlFlow 0 22639) 22643)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon53_Else_correct  (=> (and (not false) (= (ControlFlow 0 22649) 22639)) inline$$Vector_empty$0$Entry_correct)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon53_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1@@1) (= inline$$Vector_length$0$l@1@@0 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1))))) (and (=> (= (ControlFlow 0 22602) 24821) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 22602) 22649) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@0  (=> (and (= inline$$Vector_length$0$ta@0@@0 ($VectorType $IntegerType)) (= (ControlFlow 0 22590) 22602)) inline$$Vector_length$0$anon0_correct@@0)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 22549) 22590)) inline$$Vector_length$0$Entry_correct@@0)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 24845) 22590) inline$$Vector_length$0$Entry_correct@@0)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys)) (and (=> (= (ControlFlow 0 22535) 24845) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 22535) 22549) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 22459) 22535)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 24853) 22535) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 22453) 24853) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 22453) 22459) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon51_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@7)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@7))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (forall (($$1@@4 Int) ) (!  (=> (and (>= $$1@@4 0) (< $$1@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@7))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@7))) $$1@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@7))) $$1@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@7))) $$1@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@7))) $$1@@4))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@7))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_threshold)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_threshold)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Authenticator_MultiEd25519PublicKey_threshold)) $MAX_U8))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Authenticator_MultiEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (= (ControlFlow 0 24859) 22453)) inline$$Authenticator_multi_ed25519_authentication_key_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and (and (and (and (and (and ((_ is $Vector) k@@3) (let ((va@@38 (|v#$Vector| k@@3)))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| k@@3)) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@8)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@8))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (forall (($$1@@5 Int) ) (!  (=> (and (>= $$1@@5 0) (< $$1@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@8))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@8))) $$1@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@8))) $$1@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@8))) $$1@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@8))) $$1@@5))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_public_keys))) $$0@@8))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_threshold)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_threshold)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| k@@3)) $Authenticator_MultiEd25519PublicKey_threshold)) $MAX_U8))) true) (= (ControlFlow 0 21412) 24859)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 28316) 21412) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
