(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t18@2 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t17@2 () T@$Value)
(declare-fun |inline$$Compare_cmp_u8_$def$0$tmp#$3@2| () T@$Value)
(declare-fun inline$$Compare_cmp_u8_$def$0$$t7@2 () T@$Value)
(declare-fun inline$$Compare_cmp_u8_$def$0$$t6@2 () T@$Value)
(declare-fun |inline$$Compare_cmp_u8_$def$0$tmp#$2@2| () T@$Value)
(declare-fun inline$$Compare_cmp_u8_$def$0$$t9@2 () T@$Value)
(declare-fun inline$$Lt$1$dst@2 () T@$Value)
(declare-fun inline$$Compare_cmp_u8_$def$0$$t10@2 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@3 () T@$Value)
(declare-fun inline$$Vector_borrow$1$dst@3 () T@$Value)
(declare-fun inline$$Vector_borrow$1$dst@1 () T@$Value)
(declare-fun inline$$Vector_borrow$1$i_ind@2 () Int)
(declare-fun v2@@7 () T@$Value)
(declare-fun inline$$Vector_borrow$1$dst@2 () T@$Value)
(declare-fun inline$$Sub$1$dst@3 () T@$Value)
(declare-fun inline$$Vector_borrow$1$ta@1 () T@$TypeValue)
(declare-fun inline$$Vector_borrow$0$dst@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@2 () Int)
(declare-fun v1@@7 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@2 () T@$Value)
(declare-fun inline$$Sub$0$dst@3 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@1 () T@$TypeValue)
(declare-fun inline$$Sub$1$dst@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$i2@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t14@2 () T@$Value)
(declare-fun inline$$Sub$1$dst@2 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$i1@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t13@2 () T@$Value)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun |inline$$Compare_cmp_bcs_bytes_$def_verify$0$tmp#$6@2| () T@$Value)
(declare-fun inline$$Gt$1$dst@2 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t11@2 () T@$Value)
(declare-fun inline$$Gt$0$dst@2 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t12@2 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t9@2 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$elem_cmp@1 () T@$Value)
(declare-fun |inline$$Compare_cmp_bcs_bytes_$def_verify$0$tmp#$6@1| () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$Compare_cmp_u64_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$Compare_cmp_u64_$def$0$$t7@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun inline$$Compare_cmp_u64_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$Compare_cmp_u64_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$Vector_length$1$l@1 () T@$Value)
(declare-fun inline$$Vector_length$1$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20024) (let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct true))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 16383) 16297)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 16393) 16297) inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon62_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 16377) 16393) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 16377) 16383) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 16355) 16297)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 16365) 16297) inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon65_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 16349) 16365) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 16349) 16355) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 16327) 16297)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 16337) 16297) inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon68_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 16321) 16337) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 16321) 16327) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 16307) 16297)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon71_Then_correct  (=> (= (ControlFlow 0 16317) 16297) inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon70_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 16301) 16317) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 16301) 16307) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon72_Then_correct  (=> (and $abort_flag@4 (= (ControlFlow 0 16291) 16297)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$Abort_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon74_Else_correct true))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon74_Then_correct true))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon73_Then_correct  (=> (|b#$Boolean| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t18@2) (and (=> (= (ControlFlow 0 16271) 16287) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 16271) 16277) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon73_Else_correct true))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon72_Else_correct  (=> (not $abort_flag@4) (=> (and (= inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t17@2 ($Integer 0)) (= inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t18@2 ($Boolean  (not ($IsEqual_stratified |inline$$Compare_cmp_u8_$def$0$tmp#$3@2| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t17@2))))) (and (=> (= (ControlFlow 0 16255) 16271) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 16255) 16263) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon73_Else_correct))))))
(let ((inline$$Compare_cmp_u8_$def$0$anon27_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 16057) 16291) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 16057) 16255) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def$0$anon27_Then_correct  (and (=> (= (ControlFlow 0 16067) 16291) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 16067) 16255) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon72_Else_correct))))
(let ((inline$$Compare_cmp_u8_$def$0$anon8_correct  (=> (= |inline$$Compare_cmp_u8_$def$0$tmp#$3@2| inline$$Compare_cmp_u8_$def$0$$t7@2) (and (=> (= (ControlFlow 0 16195) 16067) inline$$Compare_cmp_u8_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 16195) 16057) inline$$Compare_cmp_u8_$def$0$anon27_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 16193) 16195)) inline$$Compare_cmp_u8_$def$0$anon8_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 16203) 16195) inline$$Compare_cmp_u8_$def$0$anon8_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Compare_cmp_u8_$def$0$$t6@2) (= inline$$Compare_cmp_u8_$def$0$$t7@2 ($Integer 0))) (and (=> (= (ControlFlow 0 16185) 16203) inline$$Compare_cmp_u8_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 16185) 16193) inline$$Compare_cmp_u8_$def$0$anon22_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def$0$anon16_correct  (=> (= |inline$$Compare_cmp_u8_$def$0$tmp#$3@2| |inline$$Compare_cmp_u8_$def$0$tmp#$2@2|) (and (=> (= (ControlFlow 0 16047) 16067) inline$$Compare_cmp_u8_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 16047) 16057) inline$$Compare_cmp_u8_$def$0$anon27_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 16045) 16047)) inline$$Compare_cmp_u8_$def$0$anon16_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 16075) 16047) inline$$Compare_cmp_u8_$def$0$anon16_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon12_correct  (=> (= |inline$$Compare_cmp_u8_$def$0$tmp#$2@2| inline$$Compare_cmp_u8_$def$0$$t9@2) (and (=> (= (ControlFlow 0 16135) 16075) inline$$Compare_cmp_u8_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 16135) 16045) inline$$Compare_cmp_u8_$def$0$anon26_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 16133) 16135)) inline$$Compare_cmp_u8_$def$0$anon12_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 16143) 16135) inline$$Compare_cmp_u8_$def$0$anon12_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon23_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$1$dst@2) (= inline$$Compare_cmp_u8_$def$0$$t9@2 ($Integer 1))) (and (=> (= (ControlFlow 0 16125) 16143) inline$$Compare_cmp_u8_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 16125) 16133) inline$$Compare_cmp_u8_$def$0$anon24_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def$0$anon14_correct  (=> (= |inline$$Compare_cmp_u8_$def$0$tmp#$2@2| inline$$Compare_cmp_u8_$def$0$$t10@2) (and (=> (= (ControlFlow 0 16003) 16075) inline$$Compare_cmp_u8_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 16003) 16045) inline$$Compare_cmp_u8_$def$0$anon26_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 16001) 16003)) inline$$Compare_cmp_u8_$def$0$anon14_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 16083) 16003) inline$$Compare_cmp_u8_$def$0$anon14_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$1$dst@2)) (= inline$$Compare_cmp_u8_$def$0$$t10@2 ($Integer 2))) (and (=> (= (ControlFlow 0 15993) 16083) inline$$Compare_cmp_u8_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 15993) 16001) inline$$Compare_cmp_u8_$def$0$anon25_Else_correct)))))
(let ((inline$$Lt$1$anon0_correct  (=> (= inline$$Lt$1$dst@2 ($Boolean (< (|i#$Integer| inline$$Vector_borrow$0$dst@3) (|i#$Integer| inline$$Vector_borrow$1$dst@3)))) (and (=> (= (ControlFlow 0 15941) 16125) inline$$Compare_cmp_u8_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 15941) 15993) inline$$Compare_cmp_u8_$def$0$anon23_Else_correct)))))
(let ((inline$$Lt$1$Entry_correct  (and (=> (= (ControlFlow 0 15927) (- 0 21980)) true) (=> (= (ControlFlow 0 15927) 15941) inline$$Lt$1$anon0_correct))))
(let ((inline$$Compare_cmp_u8_$def$0$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Compare_cmp_u8_$def$0$$t6@2)) (= (ControlFlow 0 15947) 15927)) inline$$Lt$1$Entry_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon4$2_correct  (=> (= inline$$Compare_cmp_u8_$def$0$$t6@2 ($Boolean ($IsEqual_stratified inline$$Vector_borrow$0$dst@3 inline$$Vector_borrow$1$dst@3))) (and (=> (= (ControlFlow 0 15877) 16185) inline$$Compare_cmp_u8_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 15877) 15947) inline$$Compare_cmp_u8_$def$0$anon21_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 15799) 15877)) inline$$Compare_cmp_u8_$def$0$anon4$2_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 16211) 15877) inline$$Compare_cmp_u8_$def$0$anon4$2_correct)))
(let ((inline$$Compare_cmp_u8_$def$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15791) 16211) inline$$Compare_cmp_u8_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 15791) 15799) inline$$Compare_cmp_u8_$def$0$anon20_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 16219) 16211) inline$$Compare_cmp_u8_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 16219) 15799) inline$$Compare_cmp_u8_$def$0$anon20_Else_correct))))
(let ((inline$$Compare_cmp_u8_$def$0$anon0_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 15785) 16219) inline$$Compare_cmp_u8_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 15785) 15791) inline$$Compare_cmp_u8_$def$0$anon19_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$direct_intra$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$Vector_borrow$0$dst@3) (>= (|i#$Integer| inline$$Vector_borrow$0$dst@3) 0)) (<= (|i#$Integer| inline$$Vector_borrow$0$dst@3) $MAX_U8)) (=> (and (and (and ((_ is $Integer) inline$$Vector_borrow$1$dst@3) (>= (|i#$Integer| inline$$Vector_borrow$1$dst@3) 0)) (<= (|i#$Integer| inline$$Vector_borrow$1$dst@3) $MAX_U8)) (= (ControlFlow 0 16225) 15785)) inline$$Compare_cmp_u8_$def$0$anon0_correct))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon70_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 16233) 16225)) inline$$Compare_cmp_u8_$direct_intra$0$anon0_correct)))
(let ((inline$$Vector_borrow$1$anon3_Then$1_correct  (=> (and (= inline$$Vector_borrow$1$dst@3 inline$$Vector_borrow$1$dst@1) (= $abort_flag@4 true)) (and (=> (= (ControlFlow 0 15377) 16301) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 15377) 16233) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$Vector_borrow$1$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$1$i_ind@2 0) (>= inline$$Vector_borrow$1$i_ind@2 (|l#$ValueArray| (|v#$Vector| v2@@7)))) (= (ControlFlow 0 15375) 15377)) inline$$Vector_borrow$1$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$1$anon3_Else_correct  (=> (and (and (not (or (< inline$$Vector_borrow$1$i_ind@2 0) (>= inline$$Vector_borrow$1$i_ind@2 (|l#$ValueArray| (|v#$Vector| v2@@7))))) (= inline$$Vector_borrow$1$dst@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@7)) inline$$Vector_borrow$1$i_ind@2))) (and (= inline$$Vector_borrow$1$dst@3 inline$$Vector_borrow$1$dst@2) (= $abort_flag@4 $abort_flag@3))) (and (=> (= (ControlFlow 0 15317) 16301) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 15317) 16233) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$Vector_borrow$1$anon0_correct  (=> ((_ is $Vector) v2@@7) (=> (and ((_ is $Integer) inline$$Sub$1$dst@3) (= inline$$Vector_borrow$1$i_ind@2 (|i#$Integer| inline$$Sub$1$dst@3))) (and (=> (= (ControlFlow 0 15291) 15375) inline$$Vector_borrow$1$anon3_Then_correct) (=> (= (ControlFlow 0 15291) 15317) inline$$Vector_borrow$1$anon3_Else_correct))))))
(let ((inline$$Vector_borrow$1$Entry_correct  (=> (and (= inline$$Vector_borrow$1$ta@1 $IntegerType) (= (ControlFlow 0 15277) 15291)) inline$$Vector_borrow$1$anon0_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon68_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 15383) 15277)) inline$$Vector_borrow$1$Entry_correct)))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct  (=> (and (= inline$$Vector_borrow$0$dst@3 inline$$Vector_borrow$0$dst@1) (= $abort_flag@3 true)) (and (=> (= (ControlFlow 0 15155) 16321) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 15155) 15383) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$0$i_ind@2 0) (>= inline$$Vector_borrow$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| v1@@7)))) (= (ControlFlow 0 15153) 15155)) inline$$Vector_borrow$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@2 0) (>= inline$$Vector_borrow$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| v1@@7))))) (= inline$$Vector_borrow$0$dst@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@7)) inline$$Vector_borrow$0$i_ind@2))) (and (= inline$$Vector_borrow$0$dst@3 inline$$Vector_borrow$0$dst@2) (= $abort_flag@3 $abort_flag@2))) (and (=> (= (ControlFlow 0 15095) 16321) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 15095) 15383) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct  (=> ((_ is $Vector) v1@@7) (=> (and ((_ is $Integer) inline$$Sub$0$dst@3) (= inline$$Vector_borrow$0$i_ind@2 (|i#$Integer| inline$$Sub$0$dst@3))) (and (=> (= (ControlFlow 0 15069) 15153) inline$$Vector_borrow$0$anon3_Then_correct) (=> (= (ControlFlow 0 15069) 15095) inline$$Vector_borrow$0$anon3_Else_correct))))))
(let ((inline$$Vector_borrow$0$Entry_correct  (=> (and (= inline$$Vector_borrow$0$ta@1 $IntegerType) (= (ControlFlow 0 15055) 15069)) inline$$Vector_borrow$0$anon0_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 14945) 15055)) inline$$Vector_borrow$0$Entry_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon67_Then_correct  (=> (= (ControlFlow 0 16345) 15055) inline$$Vector_borrow$0$Entry_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon65_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 14939) 16345) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 14939) 14945) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$Sub$1$anon3_Then$1_correct  (=> (and (= inline$$Sub$1$dst@3 inline$$Sub$1$dst@1) (= $abort_flag@2 true)) (and (=> (= (ControlFlow 0 14925) 16349) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 14925) 14939) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$Sub$1$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i2@1) (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t14@2)) (= (ControlFlow 0 14923) 14925)) inline$$Sub$1$anon3_Then$1_correct)))
(let ((inline$$Sub$1$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t14@2) (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i2@1)) (= inline$$Sub$1$dst@2 ($Integer (- (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i2@1) (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t14@2))))) (and (= inline$$Sub$1$dst@3 inline$$Sub$1$dst@2) (= $abort_flag@2 $abort_flag@1))) (and (=> (= (ControlFlow 0 14871) 16349) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 14871) 14939) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$Sub$1$Entry_correct  (and (=> (= (ControlFlow 0 14845) (- 0 21539)) true) (and (=> (= (ControlFlow 0 14845) 14923) inline$$Sub$1$anon3_Then_correct) (=> (= (ControlFlow 0 14845) 14871) inline$$Sub$1$anon3_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon28_correct  (=> (and (= inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t14@2 ($Integer 1)) (= (ControlFlow 0 14931) 14845)) inline$$Sub$1$Entry_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 14756) 14931)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon28_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 16373) 14931) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon28_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon62_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 14750) 16373) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 14750) 14756) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1 true) (= inline$$Sub$0$dst@3 inline$$Sub$0$dst@1)) (and (=> (= (ControlFlow 0 14736) 16377) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 14736) 14750) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i1@1) (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t13@2)) (= (ControlFlow 0 14734) 14736)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t13@2) (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i1@1)) (= inline$$Sub$0$dst@2 ($Integer (- (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i1@1) (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t13@2))))) (and (= $abort_flag@1 $abort_flag@0) (= inline$$Sub$0$dst@3 inline$$Sub$0$dst@2))) (and (=> (= (ControlFlow 0 14682) 16377) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 14682) 14750) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 14656) (- 0 21439)) true) (and (=> (= (ControlFlow 0 14656) 14734) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 14656) 14682) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon61_Then_correct  (=> (|b#$Boolean| |inline$$Compare_cmp_bcs_bytes_$def_verify$0$tmp#$6@2|) (=> (and (= inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t13@2 ($Integer 1)) (= (ControlFlow 0 14742) 14656)) inline$$Sub$0$Entry_correct))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon75_Else_correct true))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon75_Then_correct true))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon61_Else_correct  (=> (not (|b#$Boolean| |inline$$Compare_cmp_bcs_bytes_$def_verify$0$tmp#$6@2|)) (and (=> (= (ControlFlow 0 14547) 14563) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 14547) 14553) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon18_correct  (=> (= |inline$$Compare_cmp_bcs_bytes_$def_verify$0$tmp#$6@2| inline$$Gt$1$dst@2) (and (=> (= (ControlFlow 0 16483) 14742) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 16483) 14547) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 16481) 16483)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon18_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 16491) 16483) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon18_correct)))
(let ((inline$$Gt$1$anon0_correct  (=> (= inline$$Gt$1$dst@2 ($Boolean (> (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i2@1) (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t11@2)))) (and (=> (= (ControlFlow 0 16467) 16491) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 16467) 16481) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Gt$1$Entry_correct  (and (=> (= (ControlFlow 0 16453) (- 0 21361)) true) (=> (= (ControlFlow 0 16453) 16467) inline$$Gt$1$anon0_correct))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon58_Then_correct  (=> (|b#$Boolean| inline$$Gt$0$dst@2) (=> (and (= inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t11@2 ($Integer 0)) (= (ControlFlow 0 16473) 16453)) inline$$Gt$1$Entry_correct))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon20_correct  (=> (= |inline$$Compare_cmp_bcs_bytes_$def_verify$0$tmp#$6@2| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t12@2) (and (=> (= (ControlFlow 0 14535) 14742) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 14535) 14547) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 14533) 14535)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon20_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 16401) 14535) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon20_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon58_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@2)) (= inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t12@2 ($Boolean false))) (and (=> (= (ControlFlow 0 14525) 16401) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 14525) 14533) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct  (=> (= inline$$Gt$0$dst@2 ($Boolean (> (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i1@1) (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t9@2)))) (and (=> (= (ControlFlow 0 14473) 16473) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 14473) 14525) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 14459) (- 0 21286)) true) (=> (= (ControlFlow 0 14459) 14473) inline$$Gt$0$anon0_correct))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$L10_correct  (=> (not $abort_flag@0) (=> (and (and (and (and (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$elem_cmp@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$elem_cmp@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$elem_cmp@1) $MAX_U8)) (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$i1@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i1@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i1@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$i2@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i2@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$i2@1) $MAX_U64)) ((_ is $Boolean) |inline$$Compare_cmp_bcs_bytes_$def_verify$0$tmp#$6@1|))) (and (and (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t9@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t9@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t9@1) $MAX_U64)) ((_ is $Boolean) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t10@1)) (and (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t11@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t11@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t11@1) $MAX_U64)) ((_ is $Boolean) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t12@1)))) (and (and (and (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t13@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t13@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t13@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t14@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t14@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t14@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t15@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t15@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t15@1) $MAX_U8)) (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t16@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t16@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t16@1) $MAX_U8)))) (and (and (and (and ((_ is $Integer) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t17@1) (>= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t17@1) 0)) (<= (|i#$Integer| inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t17@1) $MAX_U8)) ((_ is $Boolean) inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t18@1)) (and (= inline$$Compare_cmp_bcs_bytes_$def_verify$0$$t9@2 ($Integer 0)) (= (ControlFlow 0 14479) 14459))))) inline$$Gt$0$Entry_correct))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon57_Else_correct  (=> (and (not false) (= (ControlFlow 0 14351) 14479)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$L10_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon57_Then_correct true))
(let ((inline$$Compare_cmp_u64_$def$0$anon27_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14167) 16495) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 14167) 14351) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def$0$anon27_Then_correct  (and (=> (= (ControlFlow 0 14177) 16495) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 14177) 14351) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon57_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def$0$anon22_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14303) 14177) inline$$Compare_cmp_u64_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 14303) 14167) inline$$Compare_cmp_u64_$def$0$anon27_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def$0$anon22_Then_correct  (and (=> (= (ControlFlow 0 14313) 14177) inline$$Compare_cmp_u64_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 14313) 14167) inline$$Compare_cmp_u64_$def$0$anon27_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def$0$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Compare_cmp_u64_$def$0$$t6@1) (= inline$$Compare_cmp_u64_$def$0$$t7@1 ($Integer 0))) (and (=> (= (ControlFlow 0 14295) 14313) inline$$Compare_cmp_u64_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 14295) 14303) inline$$Compare_cmp_u64_$def$0$anon22_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def$0$anon26_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14155) 14177) inline$$Compare_cmp_u64_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 14155) 14167) inline$$Compare_cmp_u64_$def$0$anon27_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def$0$anon26_Then_correct  (and (=> (= (ControlFlow 0 14185) 14177) inline$$Compare_cmp_u64_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 14185) 14167) inline$$Compare_cmp_u64_$def$0$anon27_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def$0$anon24_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14243) 14185) inline$$Compare_cmp_u64_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 14243) 14155) inline$$Compare_cmp_u64_$def$0$anon26_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def$0$anon24_Then_correct  (and (=> (= (ControlFlow 0 14253) 14185) inline$$Compare_cmp_u64_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 14253) 14155) inline$$Compare_cmp_u64_$def$0$anon26_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def$0$anon23_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@1) (= inline$$Compare_cmp_u64_$def$0$$t9@1 ($Integer 1))) (and (=> (= (ControlFlow 0 14235) 14253) inline$$Compare_cmp_u64_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 14235) 14243) inline$$Compare_cmp_u64_$def$0$anon24_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14111) 14185) inline$$Compare_cmp_u64_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 14111) 14155) inline$$Compare_cmp_u64_$def$0$anon26_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 14193) 14185) inline$$Compare_cmp_u64_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 14193) 14155) inline$$Compare_cmp_u64_$def$0$anon26_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= inline$$Compare_cmp_u64_$def$0$$t10@1 ($Integer 2))) (and (=> (= (ControlFlow 0 14103) 14193) inline$$Compare_cmp_u64_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 14103) 14111) inline$$Compare_cmp_u64_$def$0$anon25_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct  (=> (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$Vector_length$1$l@1)))) (and (=> (= (ControlFlow 0 14051) 14235) inline$$Compare_cmp_u64_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 14051) 14103) inline$$Compare_cmp_u64_$def$0$anon23_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 14037) (- 0 20803)) true) (=> (= (ControlFlow 0 14037) 14051) inline$$Lt$0$anon0_correct))))
(let ((inline$$Compare_cmp_u64_$def$0$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Compare_cmp_u64_$def$0$$t6@1)) (= (ControlFlow 0 14057) 14037)) inline$$Lt$0$Entry_correct)))
(let ((inline$$Compare_cmp_u64_$def$0$anon4$2_correct  (=> (= inline$$Compare_cmp_u64_$def$0$$t6@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1 inline$$Vector_length$1$l@1))) (and (=> (= (ControlFlow 0 13987) 14295) inline$$Compare_cmp_u64_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 13987) 14057) inline$$Compare_cmp_u64_$def$0$anon21_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 13909) 13987)) inline$$Compare_cmp_u64_$def$0$anon4$2_correct)))
(let ((inline$$Compare_cmp_u64_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 14321) 13987) inline$$Compare_cmp_u64_$def$0$anon4$2_correct)))
(let ((inline$$Compare_cmp_u64_$def$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 13901) 14321) inline$$Compare_cmp_u64_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 13901) 13909) inline$$Compare_cmp_u64_$def$0$anon20_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 14329) 14321) inline$$Compare_cmp_u64_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 14329) 13909) inline$$Compare_cmp_u64_$def$0$anon20_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13895) 14329) inline$$Compare_cmp_u64_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 13895) 13901) inline$$Compare_cmp_u64_$def$0$anon19_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$direct_intra$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$Vector_length$0$l@1) (>= (|i#$Integer| inline$$Vector_length$0$l@1) 0)) (<= (|i#$Integer| inline$$Vector_length$0$l@1) $MAX_U64)) (=> (and (and (and ((_ is $Integer) inline$$Vector_length$1$l@1) (>= (|i#$Integer| inline$$Vector_length$1$l@1) 0)) (<= (|i#$Integer| inline$$Vector_length$1$l@1) $MAX_U64)) (= (ControlFlow 0 14335) 13895)) inline$$Compare_cmp_u64_$def$0$anon0_correct))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon55_Else_correct  (=> (and (not false) (= (ControlFlow 0 14343) 14335)) inline$$Compare_cmp_u64_$direct_intra$0$anon0_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon55_Then_correct true))
(let ((inline$$Vector_length$1$anon0_correct  (=> (and ((_ is $Vector) v2@@7) (= inline$$Vector_length$1$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| v2@@7))))) (and (=> (= (ControlFlow 0 13487) 16499) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 13487) 14343) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$Vector_length$1$Entry_correct  (=> (and (= inline$$Vector_length$1$ta@0 $IntegerType) (= (ControlFlow 0 13475) 13487)) inline$$Vector_length$1$anon0_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon53_Else_correct  (=> (and (not false) (= (ControlFlow 0 13493) 13475)) inline$$Vector_length$1$Entry_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon53_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) v1@@7) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| v1@@7))))) (and (=> (= (ControlFlow 0 13424) 16519) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 13424) 13493) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $IntegerType) (= (ControlFlow 0 13412) 13424)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 13305) 13412)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 16543) 13412) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon51_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 13297) 16543) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 13297) 13305) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon51_Then_correct  (and (=> (= (ControlFlow 0 16551) 16543) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 16551) 13305) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon52_Else_correct))))
(let ((inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13291) 16551) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 13291) 13297) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon51_Else_correct)))))
(let ((anon0_correct  (=> (and (and ((_ is $Vector) v1@@7) (let ((va@@8 (|v#$Vector| v1@@7)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| v1@@7)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@7)) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@7)) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@7)) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@7)) $$0))
))) (=> (and (and (and ((_ is $Vector) v2@@7) (let ((va@@9 (|v#$Vector| v2@@7)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| v2@@7)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@7)) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@7)) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@7)) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@7)) $$0@@0))
))) (= (ControlFlow 0 12459) 13291)) inline$$Compare_cmp_bcs_bytes_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 20024) 12459) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$Compare_cmp_u64_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Compare_cmp_u64_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Compare_cmp_u64_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Compare_cmp_u64_$def_verify$0$$t10@1 () T@$Value)
(declare-fun i1 () T@$Value)
(declare-fun i2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 22299) (let ((inline$$Compare_cmp_u64_$def_verify$0$anon27_Else_correct true))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon27_Then_correct true))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon22_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17902) 17776) inline$$Compare_cmp_u64_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 17902) 17766) inline$$Compare_cmp_u64_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon22_Then_correct  (and (=> (= (ControlFlow 0 17912) 17776) inline$$Compare_cmp_u64_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 17912) 17766) inline$$Compare_cmp_u64_$def_verify$0$anon27_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Compare_cmp_u64_$def_verify$0$$t6@1) (= inline$$Compare_cmp_u64_$def_verify$0$$t7@1 ($Integer 0))) (and (=> (= (ControlFlow 0 17894) 17912) inline$$Compare_cmp_u64_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17894) 17902) inline$$Compare_cmp_u64_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon26_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17754) 17776) inline$$Compare_cmp_u64_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 17754) 17766) inline$$Compare_cmp_u64_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon26_Then_correct  (and (=> (= (ControlFlow 0 17784) 17776) inline$$Compare_cmp_u64_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 17784) 17766) inline$$Compare_cmp_u64_$def_verify$0$anon27_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon24_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17842) 17784) inline$$Compare_cmp_u64_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 17842) 17754) inline$$Compare_cmp_u64_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon24_Then_correct  (and (=> (= (ControlFlow 0 17852) 17784) inline$$Compare_cmp_u64_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 17852) 17754) inline$$Compare_cmp_u64_$def_verify$0$anon26_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon23_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@1@@0) (= inline$$Compare_cmp_u64_$def_verify$0$$t9@1 ($Integer 1))) (and (=> (= (ControlFlow 0 17834) 17852) inline$$Compare_cmp_u64_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 17834) 17842) inline$$Compare_cmp_u64_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17710) 17784) inline$$Compare_cmp_u64_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 17710) 17754) inline$$Compare_cmp_u64_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 17792) 17784) inline$$Compare_cmp_u64_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 17792) 17754) inline$$Compare_cmp_u64_$def_verify$0$anon26_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1@@0)) (= inline$$Compare_cmp_u64_$def_verify$0$$t10@1 ($Integer 2))) (and (=> (= (ControlFlow 0 17702) 17792) inline$$Compare_cmp_u64_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 17702) 17710) inline$$Compare_cmp_u64_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct@@0  (=> (= inline$$Lt$0$dst@1@@0 ($Boolean (< (|i#$Integer| i1) (|i#$Integer| i2)))) (and (=> (= (ControlFlow 0 17650) 17834) inline$$Compare_cmp_u64_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 17650) 17702) inline$$Compare_cmp_u64_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 17636) (- 0 22520)) true) (=> (= (ControlFlow 0 17636) 17650) inline$$Lt$0$anon0_correct@@0))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Compare_cmp_u64_$def_verify$0$$t6@1)) (= (ControlFlow 0 17656) 17636)) inline$$Lt$0$Entry_correct@@0)))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon4$2_correct  (=> (= inline$$Compare_cmp_u64_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified i1 i2))) (and (=> (= (ControlFlow 0 17586) 17894) inline$$Compare_cmp_u64_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17586) 17656) inline$$Compare_cmp_u64_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 17508) 17586)) inline$$Compare_cmp_u64_$def_verify$0$anon4$2_correct)))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 17920) 17586) inline$$Compare_cmp_u64_$def_verify$0$anon4$2_correct)))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17500) 17920) inline$$Compare_cmp_u64_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17500) 17508) inline$$Compare_cmp_u64_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 17928) 17920) inline$$Compare_cmp_u64_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17928) 17508) inline$$Compare_cmp_u64_$def_verify$0$anon20_Else_correct))))
(let ((inline$$Compare_cmp_u64_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17494) 17928) inline$$Compare_cmp_u64_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 17494) 17500) inline$$Compare_cmp_u64_$def_verify$0$anon19_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and ((_ is $Integer) i1) (>= (|i#$Integer| i1) 0)) (<= (|i#$Integer| i1) $MAX_U64)) (=> (and (and (and ((_ is $Integer) i2) (>= (|i#$Integer| i2) 0)) (<= (|i#$Integer| i2) $MAX_U64)) (= (ControlFlow 0 17152) 17494)) inline$$Compare_cmp_u64_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 22299) 17152) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$Compare_cmp_u8_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Compare_cmp_u8_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Compare_cmp_u8_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Compare_cmp_u8_$def_verify$0$$t10@1 () T@$Value)
(declare-fun i1@@0 () T@$Value)
(declare-fun i2@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 22674) (let ((inline$$Compare_cmp_u8_$def_verify$0$anon27_Else_correct true))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon27_Then_correct true))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon22_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18866) 18740) inline$$Compare_cmp_u8_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 18866) 18730) inline$$Compare_cmp_u8_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon22_Then_correct  (and (=> (= (ControlFlow 0 18876) 18740) inline$$Compare_cmp_u8_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 18876) 18730) inline$$Compare_cmp_u8_$def_verify$0$anon27_Else_correct))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Compare_cmp_u8_$def_verify$0$$t6@1) (= inline$$Compare_cmp_u8_$def_verify$0$$t7@1 ($Integer 0))) (and (=> (= (ControlFlow 0 18858) 18876) inline$$Compare_cmp_u8_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 18858) 18866) inline$$Compare_cmp_u8_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon26_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18718) 18740) inline$$Compare_cmp_u8_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 18718) 18730) inline$$Compare_cmp_u8_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon26_Then_correct  (and (=> (= (ControlFlow 0 18748) 18740) inline$$Compare_cmp_u8_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 18748) 18730) inline$$Compare_cmp_u8_$def_verify$0$anon27_Else_correct))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon24_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18806) 18748) inline$$Compare_cmp_u8_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 18806) 18718) inline$$Compare_cmp_u8_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon24_Then_correct  (and (=> (= (ControlFlow 0 18816) 18748) inline$$Compare_cmp_u8_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 18816) 18718) inline$$Compare_cmp_u8_$def_verify$0$anon26_Else_correct))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon23_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@1@@1) (= inline$$Compare_cmp_u8_$def_verify$0$$t9@1 ($Integer 1))) (and (=> (= (ControlFlow 0 18798) 18816) inline$$Compare_cmp_u8_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 18798) 18806) inline$$Compare_cmp_u8_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18674) 18748) inline$$Compare_cmp_u8_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 18674) 18718) inline$$Compare_cmp_u8_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 18756) 18748) inline$$Compare_cmp_u8_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 18756) 18718) inline$$Compare_cmp_u8_$def_verify$0$anon26_Else_correct))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1@@1)) (= inline$$Compare_cmp_u8_$def_verify$0$$t10@1 ($Integer 2))) (and (=> (= (ControlFlow 0 18666) 18756) inline$$Compare_cmp_u8_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 18666) 18674) inline$$Compare_cmp_u8_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct@@1  (=> (= inline$$Lt$0$dst@1@@1 ($Boolean (< (|i#$Integer| i1@@0) (|i#$Integer| i2@@0)))) (and (=> (= (ControlFlow 0 18614) 18798) inline$$Compare_cmp_u8_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 18614) 18666) inline$$Compare_cmp_u8_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 18600) (- 0 22895)) true) (=> (= (ControlFlow 0 18600) 18614) inline$$Lt$0$anon0_correct@@1))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Compare_cmp_u8_$def_verify$0$$t6@1)) (= (ControlFlow 0 18620) 18600)) inline$$Lt$0$Entry_correct@@1)))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon4$2_correct  (=> (= inline$$Compare_cmp_u8_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified i1@@0 i2@@0))) (and (=> (= (ControlFlow 0 18550) 18858) inline$$Compare_cmp_u8_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 18550) 18620) inline$$Compare_cmp_u8_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 18472) 18550)) inline$$Compare_cmp_u8_$def_verify$0$anon4$2_correct)))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 18884) 18550) inline$$Compare_cmp_u8_$def_verify$0$anon4$2_correct)))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18464) 18884) inline$$Compare_cmp_u8_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 18464) 18472) inline$$Compare_cmp_u8_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 18892) 18884) inline$$Compare_cmp_u8_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 18892) 18472) inline$$Compare_cmp_u8_$def_verify$0$anon20_Else_correct))))
(let ((inline$$Compare_cmp_u8_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18458) 18892) inline$$Compare_cmp_u8_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 18458) 18464) inline$$Compare_cmp_u8_$def_verify$0$anon19_Else_correct)))))
(let ((anon0_correct@@1  (=> (and (and ((_ is $Integer) i1@@0) (>= (|i#$Integer| i1@@0) 0)) (<= (|i#$Integer| i1@@0) $MAX_U8)) (=> (and (and (and ((_ is $Integer) i2@@0) (>= (|i#$Integer| i2@@0) 0)) (<= (|i#$Integer| i2@@0) $MAX_U8)) (= (ControlFlow 0 18116) 18458)) inline$$Compare_cmp_u8_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 22674) 18116) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
