(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun inline$$CoreAddresses_CORE_CODE_ADDRESS_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20276) (let ((inline$$CoreAddresses_CORE_CODE_ADDRESS_$def_verify$0$anon3_Else_correct true))
(let ((inline$$CoreAddresses_CORE_CODE_ADDRESS_$def_verify$0$anon3_Then_correct true))
(let ((inline$$CoreAddresses_CORE_CODE_ADDRESS_$def_verify$0$anon0_correct  (=> (and (not false) (= inline$$CoreAddresses_CORE_CODE_ADDRESS_$def_verify$0$$t0@1 ($Address 1))) (and (=> (= (ControlFlow 0 16101) 16117) inline$$CoreAddresses_CORE_CODE_ADDRESS_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 16101) 16107) inline$$CoreAddresses_CORE_CODE_ADDRESS_$def_verify$0$anon3_Else_correct)))))
(let ((anon0_correct  (=> (= (ControlFlow 0 20276) 16101) inline$$CoreAddresses_CORE_CODE_ADDRESS_$def_verify$0$anon0_correct)))
anon0_correct)))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20356) (let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def_verify$0$anon3_Else_correct true))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def_verify$0$anon3_Then_correct true))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def_verify$0$anon0_correct  (=> (and (not false) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def_verify$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 16256) 16272) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 16256) 16262) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def_verify$0$anon3_Else_correct)))))
(let ((anon0_correct@@0  (=> (= (ControlFlow 0 20356) 16256) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def_verify$0$anon0_correct)))
anon0_correct@@0)))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20428) (let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def_verify$0$anon3_Else_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def_verify$0$anon3_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def_verify$0$anon0_correct  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def_verify$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 16411) 16427) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 16411) 16417) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def_verify$0$anon3_Else_correct)))))
(let ((anon0_correct@@1  (=> (= (ControlFlow 0 20428) 16411) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def_verify$0$anon0_correct)))
anon0_correct@@1)))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20500) (let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def_verify$0$anon3_Else_correct true))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def_verify$0$anon3_Then_correct true))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def_verify$0$anon0_correct  (=> (and (not false) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def_verify$0$$t0@1 ($Address 186537453))) (and (=> (= (ControlFlow 0 16566) 16582) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 16566) 16572) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def_verify$0$anon3_Else_correct)))))
(let ((anon0_correct@@2  (=> (= (ControlFlow 0 20500) 16566) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def_verify$0$anon0_correct)))
anon0_correct@@2)))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20572) (let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def_verify$0$anon3_Else_correct true))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def_verify$0$anon3_Then_correct true))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def_verify$0$anon0_correct  (=> (and (not false) (= inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def_verify$0$$t0@1 ($Address 0))) (and (=> (= (ControlFlow 0 16721) 16737) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 16721) 16727) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def_verify$0$anon3_Else_correct)))))
(let ((anon0_correct@@3  (=> (= (ControlFlow 0 20572) 16721) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def_verify$0$anon0_correct)))
anon0_correct@@3)))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun inline$$CoreAddresses_assert_currency_info_$def_verify$0$$t6@1 () T@$Value)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$CoreAddresses_assert_currency_info_$def_verify$0$$t7@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20644) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 17372) (- 0 21248)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@2) (and (=> (= (ControlFlow 0 17372) (- 0 21265)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816)))))) (=> (= (ControlFlow 0 17372) (- 0 21282)) (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (= $abort_code@5 (|i#$Integer| ($Integer 2))))))))))))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$Abort_correct  (=> (= $abort_flag@2 true) (=> (and (= $abort_code@5 $abort_code@4) (= (ControlFlow 0 17300) 17372)) anon0$2_correct))))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 17350) 17300)) inline$$CoreAddresses_assert_currency_info_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 17348) 17350)) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon5_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 17358) 17350) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon5_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 17342) 17358) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 17342) 17348) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon11_correct  (=> (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 17326) 17300)) inline$$CoreAddresses_assert_currency_info_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 17324) 17326)) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon11_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 17334) 17326) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon11_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 17318) 17334) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17318) 17324) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon16_correct  (=> (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 17296) 17300)) inline$$CoreAddresses_assert_currency_info_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 17294) 17296)) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon16_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 17308) 17296) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon16_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$CoreAddresses_assert_currency_info_$def_verify$0$$t6@1)) (= $abort_code@3 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 17288) 17308) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 17288) 17294) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0 (=> (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 17338) 17300)) inline$$CoreAddresses_assert_currency_info_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon23_Then_correct  (=> (and (and (|b#$Boolean| inline$$CoreAddresses_assert_currency_info_$def_verify$0$$t6@1) (= $abort_flag@2 $abort_flag@1)) (and (= $abort_code@5 $abort_code@2) (= (ControlFlow 0 17314) 17372))) anon0$2_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 17276) 17314) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 17276) 17288) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0) (= inline$$CoreAddresses_assert_currency_info_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1)))) (=> (and (and (and (= inline$$CoreAddresses_assert_currency_info_$def_verify$0$$t7@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 2))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 17270) 17318) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17270) 17276) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17226) 17338) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17226) 17270) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 17236) 17338) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17236) 17270) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon20_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@0) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 17220) 17236) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 17220) 17226) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 17250) 17220)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 account)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 17115) 17342) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 17115) 17250) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 17079) 17115)) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon2$1_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 17366) 17115) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon2$1_correct)))
(let ((inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17073) 17366) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 17073) 17079) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) account) (= (ControlFlow 0 16801) 17073)) inline$$CoreAddresses_assert_currency_info_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 20644) 16801) anon0_correct@@4)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun inline$$CoreAddresses_assert_diem_root_$def_verify$0$$t6@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$CoreAddresses_assert_diem_root_$def_verify$0$$t7@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21314) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 18040) (- 0 21918)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 173345816))))) $abort_flag@2@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 173345816))))) $abort_flag@2@@0) (and (=> (= (ControlFlow 0 18040) (- 0 21935)) (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 173345816))))))) (=> (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 173345816)))))) (=> (= (ControlFlow 0 18040) (- 0 21952)) (=> $abort_flag@2@@0 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 173345816))))) (= $abort_code@5@@0 (|i#$Integer| ($Integer 2))))))))))))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$Abort_correct  (=> (= $abort_flag@2@@0 true) (=> (and (= $abort_code@5@@0 $abort_code@4@@0) (= (ControlFlow 0 17968) 18040)) anon0$2_correct@@0))))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@0 $abort_code@1@@0) (= (ControlFlow 0 18018) 17968)) inline$$CoreAddresses_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 18016) 18018)) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon5_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 18026) 18018) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon5_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 18010) 18026) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 18010) 18016) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon11_correct  (=> (and (= $abort_code@4@@0 $abort_code@2@@0) (= (ControlFlow 0 17994) 17968)) inline$$CoreAddresses_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 17992) 17994)) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon11_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 18002) 17994) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon11_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 17986) 18002) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17986) 17992) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon16_correct  (=> (and (= $abort_code@4@@0 $abort_code@3@@0) (= (ControlFlow 0 17964) 17968)) inline$$CoreAddresses_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 17962) 17964)) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon16_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 17976) 17964) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon16_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$CoreAddresses_assert_diem_root_$def_verify$0$$t6@1)) (= $abort_code@3@@0 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 17956) 17976) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 17956) 17962) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@0 (=> (and (= $abort_code@4@@0 $abort_code@1@@0) (= (ControlFlow 0 18006) 17968)) inline$$CoreAddresses_assert_diem_root_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon23_Then_correct  (=> (and (and (|b#$Boolean| inline$$CoreAddresses_assert_diem_root_$def_verify$0$$t6@1) (= $abort_flag@2@@0 $abort_flag@1@@0)) (and (= $abort_code@5@@0 $abort_code@2@@0) (= (ControlFlow 0 17982) 18040))) anon0$2_correct@@0)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 17944) 17982) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 17944) 17956) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@0) (= inline$$CoreAddresses_assert_diem_root_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)))) (=> (and (and (and (= inline$$CoreAddresses_assert_diem_root_$def_verify$0$$t7@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0)) (and (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 2))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 17938) 17986) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17938) 17944) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17894) 18006) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17894) 17938) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 17904) 18006) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17904) 17938) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon20_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@0@@0) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 17888) 17904) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 17888) 17894) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 17918) 17888)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 17783) 18010) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 17783) 17918) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 17747) 17783)) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon2$1_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 18034) 17783) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon2$1_correct)))
(let ((inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17741) 18034) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 17741) 17747) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@5  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 17469) 17741)) inline$$CoreAddresses_assert_diem_root_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 21314) 17469) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@1 () T@$Value)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$$t6@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$$t7@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21984) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 18708) (- 0 22588)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) $abort_flag@2@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) $abort_flag@2@@1) (and (=> (= (ControlFlow 0 18708) (- 0 22605)) (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))))) (=> (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453)))))) (=> (= (ControlFlow 0 18708) (- 0 22622)) (=> $abort_flag@2@@1 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) (= $abort_code@5@@1 (|i#$Integer| ($Integer 2))))))))))))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$Abort_correct  (=> (= $abort_flag@2@@1 true) (=> (and (= $abort_code@5@@1 $abort_code@4@@1) (= (ControlFlow 0 18636) 18708)) anon0$2_correct@@1))))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@1 $abort_code@1@@1) (= (ControlFlow 0 18686) 18636)) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 18684) 18686)) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon5_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 18694) 18686) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon5_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 18678) 18694) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 18678) 18684) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon11_correct  (=> (and (= $abort_code@4@@1 $abort_code@2@@1) (= (ControlFlow 0 18662) 18636)) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 18660) 18662)) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon11_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 18670) 18662) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon11_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 18654) 18670) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 18654) 18660) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon16_correct  (=> (and (= $abort_code@4@@1 $abort_code@3@@1) (= (ControlFlow 0 18632) 18636)) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 18630) 18632)) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon16_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 18644) 18632) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon16_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$$t6@1)) (= $abort_code@3@@1 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 18624) 18644) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 18624) 18630) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@1 (=> (and (= $abort_code@4@@1 $abort_code@1@@1) (= (ControlFlow 0 18674) 18636)) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon23_Then_correct  (=> (and (and (|b#$Boolean| inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$$t6@1) (= $abort_flag@2@@1 $abort_flag@1@@1)) (and (= $abort_code@5@@1 $abort_code@2@@1) (= (ControlFlow 0 18650) 18708))) anon0$2_correct@@1)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 18612) 18650) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 18612) 18624) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@1) (= inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1)))) (=> (and (and (and (= inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$$t7@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 2))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 18606) 18654) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 18606) 18612) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18562) 18674) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 18562) 18606) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 18572) 18674) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 18572) 18606) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon20_Else_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@0@@1) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 ($Address 186537453))) (and (=> (= (ControlFlow 0 18556) 18572) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 18556) 18562) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 18586) 18556)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 account@@1)))) ((_ is $Address) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 18451) 18678) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 18451) 18586) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 18415) 18451)) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon2$1_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 18702) 18451) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon2$1_correct)))
(let ((inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18409) 18702) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 18409) 18415) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@6  (=> (and ((_ is $Address) account@@1) (= (ControlFlow 0 18137) 18409)) inline$$CoreAddresses_assert_treasury_compliance_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 21984) 18137) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@2 () T@$Value)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun inline$$CoreAddresses_assert_vm_$def_verify$0$$t6@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$CoreAddresses_assert_vm_$def_verify$0$$t7@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 22654) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 19376) (- 0 23258)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 0))))) $abort_flag@2@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 0))))) $abort_flag@2@@2) (and (=> (= (ControlFlow 0 19376) (- 0 23275)) (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 0))))))) (=> (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 0)))))) (=> (= (ControlFlow 0 19376) (- 0 23292)) (=> $abort_flag@2@@2 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 0))))) (= $abort_code@5@@2 (|i#$Integer| ($Integer 2))))))))))))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$Abort_correct  (=> (= $abort_flag@2@@2 true) (=> (and (= $abort_code@5@@2 $abort_code@4@@2) (= (ControlFlow 0 19304) 19376)) anon0$2_correct@@2))))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@2 $abort_code@1@@2) (= (ControlFlow 0 19354) 19304)) inline$$CoreAddresses_assert_vm_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 19352) 19354)) inline$$CoreAddresses_assert_vm_$def_verify$0$anon5_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 19362) 19354) inline$$CoreAddresses_assert_vm_$def_verify$0$anon5_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 19346) 19362) inline$$CoreAddresses_assert_vm_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 19346) 19352) inline$$CoreAddresses_assert_vm_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon11_correct  (=> (and (= $abort_code@4@@2 $abort_code@2@@2) (= (ControlFlow 0 19330) 19304)) inline$$CoreAddresses_assert_vm_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 19328) 19330)) inline$$CoreAddresses_assert_vm_$def_verify$0$anon11_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 19338) 19330) inline$$CoreAddresses_assert_vm_$def_verify$0$anon11_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 19322) 19338) inline$$CoreAddresses_assert_vm_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 19322) 19328) inline$$CoreAddresses_assert_vm_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon16_correct  (=> (and (= $abort_code@4@@2 $abort_code@3@@2) (= (ControlFlow 0 19300) 19304)) inline$$CoreAddresses_assert_vm_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 19298) 19300)) inline$$CoreAddresses_assert_vm_$def_verify$0$anon16_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 19312) 19300) inline$$CoreAddresses_assert_vm_$def_verify$0$anon16_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$CoreAddresses_assert_vm_$def_verify$0$$t6@1)) (= $abort_code@3@@2 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 19292) 19312) inline$$CoreAddresses_assert_vm_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 19292) 19298) inline$$CoreAddresses_assert_vm_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@2 (=> (and (= $abort_code@4@@2 $abort_code@1@@2) (= (ControlFlow 0 19342) 19304)) inline$$CoreAddresses_assert_vm_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon23_Then_correct  (=> (and (and (|b#$Boolean| inline$$CoreAddresses_assert_vm_$def_verify$0$$t6@1) (= $abort_flag@2@@2 $abort_flag@1@@2)) (and (= $abort_code@5@@2 $abort_code@2@@2) (= (ControlFlow 0 19318) 19376))) anon0$2_correct@@2)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@1@@2) (and (=> (= (ControlFlow 0 19280) 19318) inline$$CoreAddresses_assert_vm_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 19280) 19292) inline$$CoreAddresses_assert_vm_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@2) (= inline$$CoreAddresses_assert_vm_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$$t0@1)))) (=> (and (and (and (= inline$$CoreAddresses_assert_vm_$def_verify$0$$t7@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@2)) (and (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 2))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 19274) 19322) inline$$CoreAddresses_assert_vm_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 19274) 19280) inline$$CoreAddresses_assert_vm_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 19230) 19342) inline$$CoreAddresses_assert_vm_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 19230) 19274) inline$$CoreAddresses_assert_vm_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 19240) 19342) inline$$CoreAddresses_assert_vm_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 19240) 19274) inline$$CoreAddresses_assert_vm_$def_verify$0$anon20_Else_correct))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@0@@2) (= inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$$t0@1 ($Address 0))) (and (=> (= (ControlFlow 0 19224) 19240) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 19224) 19230) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 19254) 19224)) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2) (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 account@@2)))) ((_ is $Address) call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 19119) 19346) inline$$CoreAddresses_assert_vm_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 19119) 19254) inline$$CoreAddresses_assert_vm_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 19083) 19119)) inline$$CoreAddresses_assert_vm_$def_verify$0$anon2$1_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 19370) 19119) inline$$CoreAddresses_assert_vm_$def_verify$0$anon2$1_correct)))
(let ((inline$$CoreAddresses_assert_vm_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 19077) 19370) inline$$CoreAddresses_assert_vm_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 19077) 19083) inline$$CoreAddresses_assert_vm_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@7  (=> (and ((_ is $Address) account@@2) (= (ControlFlow 0 18805) 19077)) inline$$CoreAddresses_assert_vm_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 22654) 18805) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
