(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2 () T@$Value)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@0 () Int)
(declare-fun inline$$DiemTimestamp_assert_genesis_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun inline$$DiemTimestamp_is_genesis_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27639) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 20631) (- 0 28215)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2) (and (=> (= (ControlFlow 0 20631) (- 0 28230)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> (= (ControlFlow 0 20631) (- 0 28245)) (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@4 (|i#$Integer| ($Integer 1))))))))))))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$Abort_correct  (=> (= $abort_code@4 $abort_code@3) (=> (and (= $abort_flag@2 true) (= (ControlFlow 0 20587) 20631)) anon0$2_correct))))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon5_correct  (=> (and (= $abort_code@3 $abort_code@1) (= (ControlFlow 0 20613) 20587)) inline$$DiemTimestamp_assert_genesis_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 20611) 20613)) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon5_correct)))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 20621) 20613) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon5_correct)))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon12_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 20605) 20621) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 20605) 20611) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon10_correct  (=> (and (= $abort_code@3 $abort_code@2) (= (ControlFlow 0 20583) 20587)) inline$$DiemTimestamp_assert_genesis_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 20581) 20583)) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon10_correct)))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 20595) 20583) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon10_correct)))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon14_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2)) (= $abort_code@2 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 20575) 20595) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 20575) 20581) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon11_Then_correct  (=> $abort_flag@0 (=> (and (= $abort_code@3 $abort_code@0) (= (ControlFlow 0 20625) 20587)) inline$$DiemTimestamp_assert_genesis_$def_verify$0$Abort_correct))))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon14_Then_correct  (=> (and (and (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2) (= $abort_code@4 $abort_code@1)) (and (= $abort_flag@2 $abort_flag@1) (= (ControlFlow 0 20601) 20631))) anon0$2_correct)))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon12_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 20563) 20601) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 20563) 20575) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon11_Else_correct  (=> (not $abort_flag@0) (=> (and (and (and (= inline$$DiemTimestamp_assert_genesis_$def_verify$0$$t3@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 20557) 20605) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 20557) 20563) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct  (=> (and (= $abort_flag@0 false) (= inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2 inline$$Not$0$dst@1)) (and (=> (= (ControlFlow 0 20515) 20625) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 20515) 20557) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 20513) 20515)) inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct)))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 20523) 20515) inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct)))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$t1@1)))) (and (=> (= (ControlFlow 0 20497) 20523) inline$$DiemTimestamp_is_genesis_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 20497) 20513) inline$$DiemTimestamp_is_genesis_$def$0$anon6_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 20487) (- 0 28016)) true) (=> (= (ControlFlow 0 20487) 20497) inline$$Not$0$anon0_correct))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct  (=> (not false) (=> (and (= inline$$DiemTimestamp_is_genesis_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)))) (= (ControlFlow 0 20503) 20487)) inline$$Not$0$Entry_correct))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 20415) 20531) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 20415) 20503) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 20425) 20531) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 20425) 20503) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 20409) 20425) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 20409) 20415) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 20439) 20409)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 20545) 20439)) inline$$DiemTimestamp_is_genesis_$def$0$anon0_correct)))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 20629) 20545)) inline$$DiemTimestamp_assert_genesis_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (= (ControlFlow 0 27639) 20629) anon0$1_correct)))
anon0_correct)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun inline$$DiemTimestamp_is_operating_$def$0$$ret0@2 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@0@@0 () Int)
(declare-fun inline$$DiemTimestamp_assert_operating_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$DiemTimestamp_is_operating_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28283) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 21354) (- 0 28828)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@0) (and (=> (= (ControlFlow 0 21354) (- 0 28843)) (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (= (ControlFlow 0 21354) (- 0 28858)) (=> $abort_flag@2@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@0 (|i#$Integer| ($Integer 1))))))))))))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$Abort_correct  (=> (= $abort_code@4@@0 $abort_code@3@@0) (=> (and (= $abort_flag@2@@0 true) (= (ControlFlow 0 21310) 21354)) anon0$2_correct@@0))))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon5_correct  (=> (and (= $abort_code@3@@0 $abort_code@1@@0) (= (ControlFlow 0 21336) 21310)) inline$$DiemTimestamp_assert_operating_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 21334) 21336)) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon5_correct)))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 21344) 21336) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon5_correct)))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon12_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 21328) 21344) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 21328) 21334) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon10_correct  (=> (and (= $abort_code@3@@0 $abort_code@2@@0) (= (ControlFlow 0 21306) 21310)) inline$$DiemTimestamp_assert_operating_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 21304) 21306)) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon10_correct)))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 21318) 21306) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon10_correct)))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon14_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemTimestamp_is_operating_$def$0$$ret0@2)) (= $abort_code@2@@0 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 21298) 21318) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 21298) 21304) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon11_Then_correct  (=> $abort_flag@0@@0 (=> (and (= $abort_code@3@@0 $abort_code@0@@0) (= (ControlFlow 0 21348) 21310)) inline$$DiemTimestamp_assert_operating_$def_verify$0$Abort_correct))))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon14_Then_correct  (=> (and (and (|b#$Boolean| inline$$DiemTimestamp_is_operating_$def$0$$ret0@2) (= $abort_code@4@@0 $abort_code@1@@0)) (and (= $abort_flag@2@@0 $abort_flag@1@@0) (= (ControlFlow 0 21324) 21354))) anon0$2_correct@@0)))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon12_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 21286) 21324) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 21286) 21298) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon11_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (and (and (= inline$$DiemTimestamp_assert_operating_$def_verify$0$$t3@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0)) (and (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 21280) 21328) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 21280) 21286) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$DiemTimestamp_is_operating_$def$0$anon4_correct  (=> (and (= $abort_flag@0@@0 false) (= inline$$DiemTimestamp_is_operating_$def$0$$ret0@2 inline$$DiemTimestamp_is_operating_$def$0$$t1@1)) (and (=> (= (ControlFlow 0 21238) 21348) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 21238) 21280) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$DiemTimestamp_is_operating_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 21236) 21238)) inline$$DiemTimestamp_is_operating_$def$0$anon4_correct)))
(let ((inline$$DiemTimestamp_is_operating_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 21246) 21238) inline$$DiemTimestamp_is_operating_$def$0$anon4_correct)))
(let ((inline$$DiemTimestamp_is_operating_$def$0$anon5_Else_correct  (=> (and (not false) (= inline$$DiemTimestamp_is_operating_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0))))) (and (=> (= (ControlFlow 0 21230) 21246) inline$$DiemTimestamp_is_operating_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 21230) 21236) inline$$DiemTimestamp_is_operating_$def$0$anon6_Else_correct)))))
(let ((inline$$DiemTimestamp_is_operating_$def$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 21188) 21254) inline$$DiemTimestamp_is_operating_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 21188) 21230) inline$$DiemTimestamp_is_operating_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 21198) 21254) inline$$DiemTimestamp_is_operating_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 21198) 21230) inline$$DiemTimestamp_is_operating_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 21182) 21198) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 21182) 21188) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$DiemTimestamp_is_operating_$def$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 21212) 21182)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0)))
(let ((inline$$DiemTimestamp_assert_operating_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 21268) 21212)) inline$$DiemTimestamp_is_operating_$def$0$anon0_correct)))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 21352) 21268)) inline$$DiemTimestamp_assert_operating_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (= (ControlFlow 0 28283) 21352) anon0$1_correct@@0)))
anon0_correct@@0)))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun inline$$DiemTimestamp_is_genesis_$def_verify$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28889) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 21837) (- 0 29136)) (not $abort_flag@0@@1))))
(let ((inline$$DiemTimestamp_is_genesis_$def_verify$0$anon4_correct  (=> (and (= $abort_flag@0@@1 false) (= (ControlFlow 0 21813) 21837)) anon0$2_correct@@1)))
(let ((inline$$DiemTimestamp_is_genesis_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 21811) 21813)) inline$$DiemTimestamp_is_genesis_$def_verify$0$anon4_correct)))
(let ((inline$$DiemTimestamp_is_genesis_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 21821) 21813) inline$$DiemTimestamp_is_genesis_$def_verify$0$anon4_correct)))
(let ((inline$$Not$0$anon0_correct@@0  (=> (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def_verify$0$$t1@1)))) (and (=> (= (ControlFlow 0 21795) 21821) inline$$DiemTimestamp_is_genesis_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 21795) 21811) inline$$DiemTimestamp_is_genesis_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 21785) (- 0 29091)) true) (=> (= (ControlFlow 0 21785) 21795) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$DiemTimestamp_is_genesis_$def_verify$0$anon5_Else_correct  (=> (not false) (=> (and (= inline$$DiemTimestamp_is_genesis_$def_verify$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1)))) (= (ControlFlow 0 21801) 21785)) inline$$Not$0$Entry_correct@@0))))
(let ((inline$$DiemTimestamp_is_genesis_$def_verify$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 21713) 21829) inline$$DiemTimestamp_is_genesis_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 21713) 21801) inline$$DiemTimestamp_is_genesis_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@1  (and (=> (= (ControlFlow 0 21723) 21829) inline$$DiemTimestamp_is_genesis_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 21723) 21801) inline$$DiemTimestamp_is_genesis_$def_verify$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@1  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 21707) 21723) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 21707) 21713) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@1)))))
(let ((inline$$DiemTimestamp_is_genesis_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 21737) 21707)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@1)))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 21835) 21737)) inline$$DiemTimestamp_is_genesis_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (= (ControlFlow 0 28889) 21835) anon0$1_correct@@1)))
anon0_correct@@1)))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$DiemTimestamp_is_operating_$def_verify$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29144) (let ((anon0$2_correct@@2  (=> (= (ControlFlow 0 22263) (- 0 29360)) (not $abort_flag@0@@2))))
(let ((inline$$DiemTimestamp_is_operating_$def_verify$0$anon4_correct  (=> (and (= $abort_flag@0@@2 false) (= (ControlFlow 0 22239) 22263)) anon0$2_correct@@2)))
(let ((inline$$DiemTimestamp_is_operating_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 22237) 22239)) inline$$DiemTimestamp_is_operating_$def_verify$0$anon4_correct)))
(let ((inline$$DiemTimestamp_is_operating_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 22247) 22239) inline$$DiemTimestamp_is_operating_$def_verify$0$anon4_correct)))
(let ((inline$$DiemTimestamp_is_operating_$def_verify$0$anon5_Else_correct  (=> (and (not false) (= inline$$DiemTimestamp_is_operating_$def_verify$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2))))) (and (=> (= (ControlFlow 0 22231) 22247) inline$$DiemTimestamp_is_operating_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 22231) 22237) inline$$DiemTimestamp_is_operating_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$DiemTimestamp_is_operating_$def_verify$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 22189) 22255) inline$$DiemTimestamp_is_operating_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 22189) 22231) inline$$DiemTimestamp_is_operating_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@2  (and (=> (= (ControlFlow 0 22199) 22255) inline$$DiemTimestamp_is_operating_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 22199) 22231) inline$$DiemTimestamp_is_operating_$def_verify$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@2  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2 ($Address 173345816))) (and (=> (= (ControlFlow 0 22183) 22199) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 22183) 22189) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@2)))))
(let ((inline$$DiemTimestamp_is_operating_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 22213) 22183)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@2)))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 22261) 22213)) inline$$DiemTimestamp_is_operating_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (= (ControlFlow 0 29144) 22261) anon0$1_correct@@2)))
anon0_correct@@2)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun inline$$DiemTimestamp_now_microseconds_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$DiemTimestamp_now_microseconds_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@3 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29368) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 23050) (- 0 30006)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@1) (and (=> (= (ControlFlow 0 23050) (- 0 30021)) (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 23050) (- 0 30036)) (=> $abort_flag@2@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@1 (|i#$Integer| ($Integer 1)))))) (=> (=> $abort_flag@2@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@1 (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 23050) (- 0 30062)) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemTimestamp_now_microseconds_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))))))))))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$Abort_correct  (=> (= inline$$DiemTimestamp_now_microseconds_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@4@@1 $abort_code@3@@1) (= inline$$DiemTimestamp_now_microseconds_$def_verify$0$$ret0@2 inline$$DiemTimestamp_now_microseconds_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@1 true) (= (ControlFlow 0 23010) 23050))) anon0$2_correct@@3))))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon3_correct  (=> (and (= $abort_code@3@@1 $abort_code@1@@1) (= (ControlFlow 0 23034) 23010)) inline$$DiemTimestamp_now_microseconds_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 23032) 23034)) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon3_correct)))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 23042) 23034) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon3_correct)))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 23026) 23042) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 23026) 23032) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon9_correct  (=> (and (= $abort_code@3@@1 $abort_code@2@@1) (= (ControlFlow 0 23004) 23010)) inline$$DiemTimestamp_now_microseconds_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 23002) 23004)) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon9_correct)))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 23018) 23004) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon9_correct)))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 22996) 23018) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 22996) 23002) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@3 (=> (and (= $abort_code@3@@1 $abort_code@1@@1) (= (ControlFlow 0 23022) 23010)) inline$$DiemTimestamp_now_microseconds_$def_verify$0$Abort_correct))))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon12_correct  (=> (and (and (= $abort_code@4@@1 $abort_code@2@@1) (= inline$$DiemTimestamp_now_microseconds_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1)) (and (= $abort_flag@2@@1 $abort_flag@1@@1) (= (ControlFlow 0 22984) 23050))) anon0$2_correct@@3)))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 22982) 22984)) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon12_correct)))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 22992) 22984) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (and (=> (= (ControlFlow 0 22966) 22992) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 22966) 22982) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 22972) 22966)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@1@@1 true) (=> (and (= $abort_code@2@@1 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 22912) 22996) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 22912) 22972) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 22910) 22912)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@3))) (= $abort_flag@1@@1 $abort_flag@0@@3)) (and (= $abort_code@2@@1 $abort_code@1@@1) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 22858) 22996) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 22858) 22972) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@3)) (and (=> (= (ControlFlow 0 22840) 22910) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 22840) 22858) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 22834) (- 0 29812)) true) (=> (= (ControlFlow 0 22834) 22840) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 22918) 22834)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 22713) 23022) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 22713) 22918) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@3  (and (=> (= (ControlFlow 0 22723) 23022) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 22723) 22918) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@3  (=> (and (not $abort_flag@0@@3) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@3 ($Address 173345816))) (and (=> (= (ControlFlow 0 22707) 22723) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 22707) 22713) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@3)))))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 22737) 22707)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@3)))
(let ((inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon0_correct  (=> (and (and (not false) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@3)) (and (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 1))))))) (and (=> (= (ControlFlow 0 22602) 23026) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 22602) 22737) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 23048) 22602)) inline$$DiemTimestamp_now_microseconds_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@3  (=> (= (ControlFlow 0 29368) 23048) anon0$1_correct@@3)))
anon0_correct@@3))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun inline$$DiemTimestamp_now_seconds_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$DiemTimestamp_now_seconds_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$Div$0$dst@2 () T@$Value)
(declare-fun inline$$Div$0$dst@0 () T@$Value)
(declare-fun inline$$DiemTimestamp_now_seconds_$def_verify$0$$t1@1 () T@$Value)
(declare-fun inline$$Div$0$dst@1 () T@$Value)
(declare-fun call2formal@$ret0@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 30082) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 23657) (- 0 30688)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@2) (and (=> (= (ControlFlow 0 23657) (- 0 30703)) (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 23657) (- 0 30718)) (=> $abort_flag@2@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@2 (|i#$Integer| ($Integer 1)))))) (=> (=> $abort_flag@2@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@2 (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 23657) (- 0 30744)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemTimestamp_now_seconds_$def_verify$0$$ret0@2 ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 1000000)))))))))))))))))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$Abort_correct  (=> (= inline$$DiemTimestamp_now_seconds_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_flag@2@@2 true) (= $abort_code@4@@2 $abort_code@3@@2)) (and (= inline$$DiemTimestamp_now_seconds_$def_verify$0$$ret0@2 inline$$DiemTimestamp_now_seconds_$def_verify$0$$ret0@1) (= (ControlFlow 0 23621) 23657))) anon0$2_correct@@4))))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon3_correct  (=> (and (= $abort_code@3@@2 $abort_code@1@@2) (= (ControlFlow 0 23641) 23621)) inline$$DiemTimestamp_now_seconds_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 23639) 23641)) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon3_correct)))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 23649) 23641) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon3_correct)))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon11_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 23633) 23649) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 23633) 23639) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon7_correct  (=> (and (= $abort_code@3@@2 $abort_code@2@@2) (= (ControlFlow 0 23615) 23621)) inline$$DiemTimestamp_now_seconds_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 23613) 23615)) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon7_correct)))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 23629) 23615) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon7_correct)))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon13_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 23607) 23629) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 23607) 23613) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon10_correct  (=> (and (and (= $abort_flag@2@@2 $abort_flag@1@@2) (= $abort_code@4@@2 $abort_code@2@@2)) (and (= inline$$DiemTimestamp_now_seconds_$def_verify$0$$ret0@2 inline$$Div$0$dst@2) (= (ControlFlow 0 23595) 23657))) anon0$2_correct@@4)))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 23593) 23595)) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon10_correct)))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 23603) 23595) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon10_correct)))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@1@@2) (and (=> (= (ControlFlow 0 23587) 23603) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 23587) 23593) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Div$0$anon3_Then$1_correct  (=> (= $abort_flag@1@@2 true) (=> (and (= $abort_code@2@@2 $EXEC_FAILURE_CODE) (= inline$$Div$0$dst@2 inline$$Div$0$dst@0)) (and (=> (= (ControlFlow 0 23571) 23607) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 23571) 23587) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$Div$0$anon3_Then_correct  (=> (and (= (|i#$Integer| inline$$DiemTimestamp_now_seconds_$def_verify$0$$t1@1) 0) (= (ControlFlow 0 23569) 23571)) inline$$Div$0$anon3_Then$1_correct)))
(let ((inline$$Div$0$anon3_Else_correct  (=> (not (= (|i#$Integer| inline$$DiemTimestamp_now_seconds_$def_verify$0$$t1@1) 0)) (=> (and (and (= inline$$Div$0$dst@1 ($Integer (div (|i#$Integer| call2formal@$ret0@0) (|i#$Integer| inline$$DiemTimestamp_now_seconds_$def_verify$0$$t1@1)))) (= $abort_flag@1@@2 $abort_flag@0@@4)) (and (= $abort_code@2@@2 $abort_code@1@@2) (= inline$$Div$0$dst@2 inline$$Div$0$dst@1))) (and (=> (= (ControlFlow 0 23519) 23607) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 23519) 23587) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$Div$0$Entry_correct  (and (=> (= (ControlFlow 0 23495) (- 0 30522)) true) (and (=> (= (ControlFlow 0 23495) 23569) inline$$Div$0$anon3_Then_correct) (=> (= (ControlFlow 0 23495) 23519) inline$$Div$0$anon3_Else_correct)))))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon11_Else_correct  (=> (not $abort_flag@0@@4) (=> (and (= inline$$DiemTimestamp_now_seconds_$def_verify$0$$t1@1 ($Integer 1000000)) (= (ControlFlow 0 23577) 23495)) inline$$Div$0$Entry_correct))))
(let ((inline$$DiemTimestamp_now_seconds_$def_verify$0$anon0_correct  (=> (not false) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@4) (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@0@@4 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (and (and ((_ is $Integer) call2formal@$ret0@0) (>= (|i#$Integer| call2formal@$ret0@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 23404) 23633) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 23404) 23577) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon11_Else_correct))))))
(let ((anon0$1_correct@@4  (=> (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 23655) 23404)) inline$$DiemTimestamp_now_seconds_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@4  (=> (= (ControlFlow 0 30082) 23655) anon0$1_correct@@4)))
anon0_correct@@4)))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@6 () Bool)
(declare-fun account () T@$Value)
(declare-fun proposer () T@$Value)
(declare-fun timestamp () T@$Value)
(declare-fun $abort_code@10 () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemTimestamp_update_global_time_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$DiemTimestamp_update_global_time_$def_verify$0$$t16@1 () T@$Value)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$DiemTimestamp_update_global_time_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$DiemTimestamp_update_global_time_$def_verify$0$$t17@1 () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$DiemTimestamp_update_global_time_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@4 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 30778) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 26432) (- 0 33047)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 26432) (- 0 33061)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 0))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 0))))) $abort_flag@6) (and (=> (= (ControlFlow 0 26432) (- 0 33078)) (=> (|b#$Boolean| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified proposer ($Address 0)))) ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp))) ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| timestamp))))) $abort_flag@6)) (=> (=> (|b#$Boolean| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified proposer ($Address 0)))) ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp))) ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| timestamp))))) $abort_flag@6) (and (=> (= (ControlFlow 0 26432) (- 0 33119)) (=> $abort_flag@6 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 0)))))) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified proposer ($Address 0)))) ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp))) ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| timestamp)))))))) (=> (=> $abort_flag@6 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 0)))))) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified proposer ($Address 0)))) ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp))) ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| timestamp))))))) (and (=> (= (ControlFlow 0 26432) (- 0 33189)) (=> $abort_flag@6 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 0))))) (= $abort_code@10 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified proposer ($Address 0)))) ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp))) ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| timestamp))))) (= $abort_code@10 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@6 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 0))))) (= $abort_code@10 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified proposer ($Address 0)))) ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp))) ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| timestamp))))) (= $abort_code@10 (|i#$Integer| ($Integer 7)))))) (=> (= (ControlFlow 0 26432) (- 0 33292)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp)))))))))))))))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon44$2_correct  (and (=> (= (ControlFlow 0 26218) (- 0 32870)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 26218) (- 0 32890)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)))))))) (=> (and (and (= $abort_flag@6 $abort_flag@5) (= $abort_code@10 $abort_code@7)) (and (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@0 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 26218) 26432))) anon0$2_correct@@5)))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $DiemTimestamp_CurrentTimeMicroseconds_$memory) (= (ControlFlow 0 26104) 26218)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon44$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 26158) 26218))) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon44$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 26094) 26158) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 26094) 26104) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 25914) 26094)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 25970) 26094))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 25878) 25970) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 25878) 25914) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 25741) 25878)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon66_Then_correct  (=> (and (= inline$$DiemTimestamp_update_global_time_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 26228) 25878)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) timestamp)) (and (=> (= (ControlFlow 0 25727) 26228) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 25727) 25741) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))) (= (ControlFlow 0 25668) 25727))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon60_Then_correct  (=> (and (and (|b#$Boolean| inline$$DiemTimestamp_update_global_time_$def_verify$0$$t16@1) (= $abort_code@7 $abort_code@4@@3)) (and (= $abort_flag@5 $abort_flag@3) (= (ControlFlow 0 26306) 25668))) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon64_Then_correct  (=> (and (and (|b#$Boolean| inline$$Lt$0$dst@1) (= $abort_code@7 $abort_code@5)) (and (= $abort_flag@5 $abort_flag@4) (= (ControlFlow 0 25550) 25668))) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@6 true) (= $abort_code@10 $abort_code@9)) (and (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@0 $DiemTimestamp_CurrentTimeMicroseconds_$memory) (= (ControlFlow 0 25536) 26432))) anon0$2_correct@@5)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon9_correct  (=> (and (= $abort_code@9 $abort_code@1@@3) (= (ControlFlow 0 26394) 25536)) inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 26392) 26394)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon9_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 26402) 26394) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon9_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon48_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 26386) 26402) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 26386) 26392) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon13_correct  (=> (and (= $abort_code@9 $abort_code@2@@3) (= (ControlFlow 0 26374) 25536)) inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 26372) 26374)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon13_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 26382) 26374) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon13_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon50_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 26366) 26382) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 26366) 26372) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon19_correct  (=> (and (= $abort_code@9 $abort_code@3@@3) (= (ControlFlow 0 26350) 25536)) inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 26348) 26350)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon19_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 26358) 26350) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon19_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon53_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 26342) 26358) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 26342) 26348) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon29_correct  (=> (and (= $abort_code@9 $abort_code@4@@3) (= (ControlFlow 0 26318) 25536)) inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 26316) 26318)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon29_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 26326) 26318) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon29_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon58_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 26310) 26326) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 26310) 26316) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon34_correct  (=> (and (= $abort_code@9 $abort_code@8) (= (ControlFlow 0 26292) 25536)) inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 26290) 26292)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon34_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon61_Then_correct  (=> (= (ControlFlow 0 26300) 26292) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon34_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon60_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemTimestamp_update_global_time_$def_verify$0$$t16@1)) (= $abort_code@8 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 26284) 26300) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 26284) 26290) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon58_Else_correct  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 26272) 26306) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 26272) 26284) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon57_Then_correct  (=> (and (|b#$Boolean| inline$$DiemTimestamp_update_global_time_$def_verify$0$$t15@1) (= inline$$DiemTimestamp_update_global_time_$def_verify$0$$t16@1 ($Boolean ($IsEqual_stratified inline$$ReadRef$0$v@1 timestamp)))) (=> (and (and (and (= inline$$DiemTimestamp_update_global_time_$def_verify$0$$t17@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3)) (and (=> $abort_flag@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 26266) 26310) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 26266) 26272) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon58_Else_correct))))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon37_correct  (=> (and (= $abort_code@9 $abort_code@5) (= (ControlFlow 0 26240) 25536)) inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 26238) 26240)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon37_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 26248) 26240) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon37_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon62_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 26232) 26248) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 26232) 26238) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon42_correct  (=> (and (= $abort_code@9 $abort_code@6) (= (ControlFlow 0 25532) 25536)) inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 25530) 25532)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon42_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon65_Then_correct  (=> (= (ControlFlow 0 25544) 25532) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon42_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon64_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= $abort_code@6 (|i#$Integer| call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 25524) 25544) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 25524) 25530) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon62_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 25512) 25550) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 25512) 25524) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon57_Else$1_correct  (=> (and (and (and (= inline$$DiemTimestamp_update_global_time_$def_verify$0$$t20@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 25506) 26232) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 25506) 25512) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct  (=> (and (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| timestamp)))) (= (ControlFlow 0 25494) 25506)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon57_Else$1_correct)))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 25480) (- 0 32370)) true) (=> (= (ControlFlow 0 25480) 25494) inline$$Lt$0$anon0_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon57_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemTimestamp_update_global_time_$def_verify$0$$t15@1)) (= (ControlFlow 0 25500) 25480)) inline$$Lt$0$Entry_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon56_Else_correct  (=> (and (not $abort_flag@2@@3) (= inline$$DiemTimestamp_update_global_time_$def_verify$0$$t15@1 ($Boolean ($IsEqual_stratified proposer inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$$t0@1)))) (and (=> (= (ControlFlow 0 25430) 26266) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 25430) 25500) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon56_Then_correct  (=> $abort_flag@2@@3 (=> (and (= $abort_code@9 $abort_code@3@@3) (= (ControlFlow 0 26330) 25536)) inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 25390) 26330) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 25390) 25430) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 25400) 26330) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 25400) 25430) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon56_Else_correct))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@2@@3) (= inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$$t0@1 ($Address 0))) (and (=> (= (ControlFlow 0 25384) 25400) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 25384) 25390) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 25283) 25384)) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 26338) 25384) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (and (=> (= (ControlFlow 0 25227) 26338) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 25227) 25283) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))) (= (ControlFlow 0 25189) 25227))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon53_Else_correct  (=> (and (not $abort_flag@2@@3) (= (ControlFlow 0 25241) 25189)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@3 true) (=> (and (= $abort_code@3@@3 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 25023) 26342) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 25023) 25241) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon53_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 25021) 25023)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_flag@2@@3 $abort_flag@1@@3)) (and (= $abort_code@3@@3 $abort_code@2@@3) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 24969) 26342) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 24969) 25241) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon53_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@4)) (and (=> (= (ControlFlow 0 24939) 25021) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 24939) 24969) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 24933) (- 0 32003)) true) (=> (= (ControlFlow 0 24933) 24939) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon52_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 25029) 24933)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon52_Then_correct  (=> $abort_flag@1@@3 (=> (and (= $abort_code@9 $abort_code@2@@3) (= (ControlFlow 0 26362) 25536)) inline$$DiemTimestamp_update_global_time_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@4  (=> (not true) (and (=> (= (ControlFlow 0 24802) 26362) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 24802) 25029) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@4  (and (=> (= (ControlFlow 0 24812) 26362) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 24812) 25029) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon52_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@4  (=> (and (not $abort_flag@1@@3) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@4 ($Address 173345816))) (and (=> (= (ControlFlow 0 24796) 24812) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 24796) 24802) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@4)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon50_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 24826) 24796)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@4)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon48_Else_correct  (=> (and (and (not $abort_flag@0@@5) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 0))))) $abort_flag@1@@3)) (and (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 0)))))) (=> $abort_flag@1@@3 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 0))))) (= $abort_code@2@@3 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 24691) 26366) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 24691) 24826) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@5) (=> (and (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 24685) 26386) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 24685) 24691) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon48_Else_correct))))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 24581) 24685)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon6$3_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 26410) 24685) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon6$3_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon46_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 24573) 26410) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 24573) 24581) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon46_Then_correct  (and (=> (= (ControlFlow 0 26418) 26410) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 26418) 24581) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon47_Else_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 24565) 26418) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 24565) 24573) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 26426) 26418) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 26426) 24573) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon46_Else_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 24559) 26426) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 24559) 24565) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon45_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 26430) 24559)) inline$$DiemTimestamp_update_global_time_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@5  (=> (and ((_ is $Address) account) ((_ is $Address) proposer)) (=> (and (and (and ((_ is $Integer) timestamp) (>= (|i#$Integer| timestamp) 0)) (<= (|i#$Integer| timestamp) $MAX_U64)) (= (ControlFlow 0 23748) 26430)) anon0$1_correct@@5))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 30778) 23748) anon0_correct@@5)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
