(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$Errors_already_published_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_already_published_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun inline$$Errors_already_published_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19594) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 14375) (- 0 19934)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1) (and (=> (= (ControlFlow 0 14375) (- 0 19943)) (=> $abort_flag@1 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 14375) (- 0 19952)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_already_published_$def_verify$0$$ret0@2 ($Integer 6))))))))))))
(let ((inline$$Errors_already_published_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_already_published_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1 true)) (and (= inline$$Errors_already_published_$def_verify$0$$ret0@2 inline$$Errors_already_published_$def_verify$0$$ret0@1) (= (ControlFlow 0 14351) 14375))) anon0$2_correct)))
(let ((inline$$Errors_already_published_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 14345) 14351)) inline$$Errors_already_published_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_already_published_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 14359) 14351) inline$$Errors_already_published_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_already_published_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 14339) 14359) inline$$Errors_already_published_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 14339) 14345) inline$$Errors_already_published_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_already_published_$def_verify$0$anon8_correct  (=> (= $abort_flag@1 $abort_flag@0) (=> (and (= inline$$Errors_already_published_$def_verify$0$$ret0@2 call4formal@$ret0@0) (= (ControlFlow 0 14327) 14375)) anon0$2_correct))))
(let ((inline$$Errors_already_published_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 14325) 14327)) inline$$Errors_already_published_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_already_published_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 14335) 14327) inline$$Errors_already_published_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_already_published_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 14319) 14335) inline$$Errors_already_published_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 14319) 14325) inline$$Errors_already_published_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_already_published_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_already_published_$def_verify$0$$t2@1 ($Integer 6)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0)) (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 inline$$Errors_already_published_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0) (>= (|i#$Integer| call4formal@$ret0@0) 0)) (<= (|i#$Integer| call4formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 14311) 14339) inline$$Errors_already_published_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 14311) 14319) inline$$Errors_already_published_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_already_published_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 14271) 14311)) inline$$Errors_already_published_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_already_published_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 14367) 14311) inline$$Errors_already_published_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_already_published_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14265) 14367) inline$$Errors_already_published_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 14265) 14271) inline$$Errors_already_published_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct  (=> (and (and (and ((_ is $Integer) reason) (>= (|i#$Integer| reason) 0)) (<= (|i#$Integer| reason) $MAX_U64)) (= (ControlFlow 0 14086) 14265)) inline$$Errors_already_published_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 19594) 14086) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$Errors_custom_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_custom_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Errors_custom_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19981) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 14742) (- 0 20321)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0) (and (=> (= (ControlFlow 0 14742) (- 0 20330)) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 14742) (- 0 20339)) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_custom_$def_verify$0$$ret0@2 ($Integer 255))))))))))))
(let ((inline$$Errors_custom_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_custom_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@0 true)) (and (= inline$$Errors_custom_$def_verify$0$$ret0@2 inline$$Errors_custom_$def_verify$0$$ret0@1) (= (ControlFlow 0 14718) 14742))) anon0$2_correct@@0)))
(let ((inline$$Errors_custom_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 14712) 14718)) inline$$Errors_custom_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_custom_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 14726) 14718) inline$$Errors_custom_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_custom_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 14706) 14726) inline$$Errors_custom_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 14706) 14712) inline$$Errors_custom_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_custom_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@0 $abort_flag@0@@0) (=> (and (= inline$$Errors_custom_$def_verify$0$$ret0@2 call4formal@$ret0@0@@0) (= (ControlFlow 0 14694) 14742)) anon0$2_correct@@0))))
(let ((inline$$Errors_custom_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 14692) 14694)) inline$$Errors_custom_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_custom_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 14702) 14694) inline$$Errors_custom_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_custom_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 14686) 14702) inline$$Errors_custom_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 14686) 14692) inline$$Errors_custom_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_custom_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_custom_$def_verify$0$$t2@1 ($Integer 255)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0)) (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 inline$$Errors_custom_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@0) (>= (|i#$Integer| call4formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 14678) 14706) inline$$Errors_custom_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 14678) 14686) inline$$Errors_custom_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_custom_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 14638) 14678)) inline$$Errors_custom_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_custom_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 14734) 14678) inline$$Errors_custom_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_custom_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14632) 14734) inline$$Errors_custom_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 14632) 14638) inline$$Errors_custom_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and (and ((_ is $Integer) reason@@0) (>= (|i#$Integer| reason@@0) 0)) (<= (|i#$Integer| reason@@0) $MAX_U64)) (= (ControlFlow 0 14453) 14632)) inline$$Errors_custom_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 19981) 14453) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun inline$$Errors_internal_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_internal_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun call4formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$Errors_internal_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20360) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 15109) (- 0 20700)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1) (and (=> (= (ControlFlow 0 15109) (- 0 20709)) (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 15109) (- 0 20718)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_internal_$def_verify$0$$ret0@2 ($Integer 10))))))))))))
(let ((inline$$Errors_internal_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_internal_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@1 true)) (and (= inline$$Errors_internal_$def_verify$0$$ret0@2 inline$$Errors_internal_$def_verify$0$$ret0@1) (= (ControlFlow 0 15085) 15109))) anon0$2_correct@@1)))
(let ((inline$$Errors_internal_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 15079) 15085)) inline$$Errors_internal_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_internal_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 15093) 15085) inline$$Errors_internal_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_internal_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 15073) 15093) inline$$Errors_internal_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 15073) 15079) inline$$Errors_internal_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_internal_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@1 $abort_flag@0@@1) (=> (and (= inline$$Errors_internal_$def_verify$0$$ret0@2 call4formal@$ret0@0@@1) (= (ControlFlow 0 15061) 15109)) anon0$2_correct@@1))))
(let ((inline$$Errors_internal_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 15059) 15061)) inline$$Errors_internal_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_internal_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 15069) 15061) inline$$Errors_internal_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_internal_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 15053) 15069) inline$$Errors_internal_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 15053) 15059) inline$$Errors_internal_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_internal_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_internal_$def_verify$0$$t2@1 ($Integer 10)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1)) (and (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@1 inline$$Errors_internal_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@1) (>= (|i#$Integer| call4formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 15045) 15073) inline$$Errors_internal_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 15045) 15053) inline$$Errors_internal_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_internal_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 15005) 15045)) inline$$Errors_internal_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_internal_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 15101) 15045) inline$$Errors_internal_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_internal_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14999) 15101) inline$$Errors_internal_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 14999) 15005) inline$$Errors_internal_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@1  (=> (and (and (and ((_ is $Integer) reason@@1) (>= (|i#$Integer| reason@@1) 0)) (<= (|i#$Integer| reason@@1) $MAX_U64)) (= (ControlFlow 0 14820) 14999)) inline$$Errors_internal_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 20360) 14820) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$Errors_invalid_argument_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_invalid_argument_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun call4formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$Errors_invalid_argument_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20739) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 15476) (- 0 21079)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@2)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@2) (and (=> (= (ControlFlow 0 15476) (- 0 21088)) (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 15476) (- 0 21097)) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_invalid_argument_$def_verify$0$$ret0@2 ($Integer 7))))))))))))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_invalid_argument_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@2 true)) (and (= inline$$Errors_invalid_argument_$def_verify$0$$ret0@2 inline$$Errors_invalid_argument_$def_verify$0$$ret0@1) (= (ControlFlow 0 15452) 15476))) anon0$2_correct@@2)))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 15446) 15452)) inline$$Errors_invalid_argument_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 15460) 15452) inline$$Errors_invalid_argument_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 15440) 15460) inline$$Errors_invalid_argument_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 15440) 15446) inline$$Errors_invalid_argument_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@2 $abort_flag@0@@2) (=> (and (= inline$$Errors_invalid_argument_$def_verify$0$$ret0@2 call4formal@$ret0@0@@2) (= (ControlFlow 0 15428) 15476)) anon0$2_correct@@2))))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 15426) 15428)) inline$$Errors_invalid_argument_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 15436) 15428) inline$$Errors_invalid_argument_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 15420) 15436) inline$$Errors_invalid_argument_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 15420) 15426) inline$$Errors_invalid_argument_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_invalid_argument_$def_verify$0$$t2@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2)) (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@2 inline$$Errors_invalid_argument_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@2) (>= (|i#$Integer| call4formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 15412) 15440) inline$$Errors_invalid_argument_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 15412) 15420) inline$$Errors_invalid_argument_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 15372) 15412)) inline$$Errors_invalid_argument_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 15468) 15412) inline$$Errors_invalid_argument_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_invalid_argument_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15366) 15468) inline$$Errors_invalid_argument_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 15366) 15372) inline$$Errors_invalid_argument_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and (and ((_ is $Integer) reason@@2) (>= (|i#$Integer| reason@@2) 0)) (<= (|i#$Integer| reason@@2) $MAX_U64)) (= (ControlFlow 0 15187) 15366)) inline$$Errors_invalid_argument_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 20739) 15187) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun inline$$Errors_invalid_state_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_invalid_state_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun call4formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$Errors_invalid_state_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason@@3 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21118) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 15843) (- 0 21458)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3) (and (=> (= (ControlFlow 0 15843) (- 0 21467)) (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 15843) (- 0 21476)) (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_invalid_state_$def_verify$0$$ret0@2 ($Integer 1))))))))))))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_invalid_state_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@3 true)) (and (= inline$$Errors_invalid_state_$def_verify$0$$ret0@2 inline$$Errors_invalid_state_$def_verify$0$$ret0@1) (= (ControlFlow 0 15819) 15843))) anon0$2_correct@@3)))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 15813) 15819)) inline$$Errors_invalid_state_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 15827) 15819) inline$$Errors_invalid_state_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 15807) 15827) inline$$Errors_invalid_state_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 15807) 15813) inline$$Errors_invalid_state_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@3 $abort_flag@0@@3) (=> (and (= inline$$Errors_invalid_state_$def_verify$0$$ret0@2 call4formal@$ret0@0@@3) (= (ControlFlow 0 15795) 15843)) anon0$2_correct@@3))))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 15793) 15795)) inline$$Errors_invalid_state_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 15803) 15795) inline$$Errors_invalid_state_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@3) (and (=> (= (ControlFlow 0 15787) 15803) inline$$Errors_invalid_state_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 15787) 15793) inline$$Errors_invalid_state_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_invalid_state_$def_verify$0$$t2@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@3)) (and (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@3 inline$$Errors_invalid_state_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@3) (>= (|i#$Integer| call4formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 15779) 15807) inline$$Errors_invalid_state_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 15779) 15787) inline$$Errors_invalid_state_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 15739) 15779)) inline$$Errors_invalid_state_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 15835) 15779) inline$$Errors_invalid_state_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_invalid_state_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15733) 15835) inline$$Errors_invalid_state_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 15733) 15739) inline$$Errors_invalid_state_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@3  (=> (and (and (and ((_ is $Integer) reason@@3) (>= (|i#$Integer| reason@@3) 0)) (<= (|i#$Integer| reason@@3) $MAX_U64)) (= (ControlFlow 0 15554) 15733)) inline$$Errors_invalid_state_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 21118) 15554) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun inline$$Errors_limit_exceeded_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_limit_exceeded_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun call4formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Errors_limit_exceeded_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason@@4 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21497) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 16210) (- 0 21837)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@4)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@4) (and (=> (= (ControlFlow 0 16210) (- 0 21846)) (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 16210) (- 0 21855)) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_limit_exceeded_$def_verify$0$$ret0@2 ($Integer 8))))))))))))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_limit_exceeded_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@4 true)) (and (= inline$$Errors_limit_exceeded_$def_verify$0$$ret0@2 inline$$Errors_limit_exceeded_$def_verify$0$$ret0@1) (= (ControlFlow 0 16186) 16210))) anon0$2_correct@@4)))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 16180) 16186)) inline$$Errors_limit_exceeded_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 16194) 16186) inline$$Errors_limit_exceeded_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 16174) 16194) inline$$Errors_limit_exceeded_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 16174) 16180) inline$$Errors_limit_exceeded_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@4 $abort_flag@0@@4) (=> (and (= inline$$Errors_limit_exceeded_$def_verify$0$$ret0@2 call4formal@$ret0@0@@4) (= (ControlFlow 0 16162) 16210)) anon0$2_correct@@4))))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 16160) 16162)) inline$$Errors_limit_exceeded_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 16170) 16162) inline$$Errors_limit_exceeded_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@4) (and (=> (= (ControlFlow 0 16154) 16170) inline$$Errors_limit_exceeded_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 16154) 16160) inline$$Errors_limit_exceeded_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_limit_exceeded_$def_verify$0$$t2@1 ($Integer 8)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@4)) (and (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@4 inline$$Errors_limit_exceeded_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@4) (>= (|i#$Integer| call4formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 16146) 16174) inline$$Errors_limit_exceeded_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 16146) 16154) inline$$Errors_limit_exceeded_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 16106) 16146)) inline$$Errors_limit_exceeded_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 16202) 16146) inline$$Errors_limit_exceeded_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_limit_exceeded_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16100) 16202) inline$$Errors_limit_exceeded_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 16100) 16106) inline$$Errors_limit_exceeded_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@4  (=> (and (and (and ((_ is $Integer) reason@@4) (>= (|i#$Integer| reason@@4) 0)) (<= (|i#$Integer| reason@@4) $MAX_U64)) (= (ControlFlow 0 15921) 16100)) inline$$Errors_limit_exceeded_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 21497) 15921) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$Errors_make_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun category () T@$Value)
(declare-fun reason@@5 () T@$Value)
(declare-fun inline$$Errors_make_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$CastU64$0$dst@1 () T@$Value)
(declare-fun inline$$Shl$0$dst@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$Shl$0$po2@1 () Int)
(declare-fun inline$$Errors_make_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$CastU64$0$dst@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21877) (let ((anon0$2_correct@@5  (=> (= (ControlFlow 0 17178) (- 0 22378)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_make_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| category) (|i#$Integer| ($shl reason@@5 ($Integer 8))))))))))))
(let ((inline$$Errors_make_$def_verify$0$Abort_correct  (=> (and (and (= inline$$Errors_make_$def_verify$0$$ret0@1 $Error) (= inline$$Errors_make_$def_verify$0$$ret0@2 inline$$Errors_make_$def_verify$0$$ret0@1)) (and (= $abort_flag@2 true) (= (ControlFlow 0 17126) 17178))) anon0$2_correct@@5)))
(let ((inline$$Errors_make_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 17144) 17126)) inline$$Errors_make_$def_verify$0$Abort_correct)))
(let ((inline$$Errors_make_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 17154) 17126) inline$$Errors_make_$def_verify$0$Abort_correct)))
(let ((inline$$Errors_make_$def_verify$0$anon17_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 17138) 17154) inline$$Errors_make_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 17138) 17144) inline$$Errors_make_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Errors_make_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 17118) 17126)) inline$$Errors_make_$def_verify$0$Abort_correct)))
(let ((inline$$Errors_make_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 17134) 17126) inline$$Errors_make_$def_verify$0$Abort_correct)))
(let ((inline$$Errors_make_$def_verify$0$anon19_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 17112) 17134) inline$$Errors_make_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17112) 17118) inline$$Errors_make_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Errors_make_$def_verify$0$anon14_correct  (=> (= inline$$Errors_make_$def_verify$0$$ret0@2 inline$$AddU64$0$dst@2) (=> (and (= $abort_flag@2 $abort_flag@1@@5) (= (ControlFlow 0 17100) 17178)) anon0$2_correct@@5))))
(let ((inline$$Errors_make_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 17098) 17100)) inline$$Errors_make_$def_verify$0$anon14_correct)))
(let ((inline$$Errors_make_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 17108) 17100) inline$$Errors_make_$def_verify$0$anon14_correct)))
(let ((inline$$Errors_make_$def_verify$0$anon19_Else_correct  (=> (not $abort_flag@1@@5) (and (=> (= (ControlFlow 0 17092) 17108) inline$$Errors_make_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17092) 17098) inline$$Errors_make_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@5 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 17076) 17112) inline$$Errors_make_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 17076) 17092) inline$$Errors_make_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$CastU64$0$dst@1) (|i#$Integer| inline$$Shl$0$dst@1)) $MAX_U64) (= (ControlFlow 0 17074) 17076)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$CastU64$0$dst@1) (|i#$Integer| inline$$Shl$0$dst@1))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$CastU64$0$dst@1) (|i#$Integer| inline$$Shl$0$dst@1))))) (and (= $abort_flag@1@@5 $abort_flag@0@@5) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 17018) 17112) inline$$Errors_make_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 17018) 17092) inline$$Errors_make_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 16988) (- 0 22225)) true) (and (=> (= (ControlFlow 0 16988) 17074) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 16988) 17018) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$Shl$0$anon0_correct  (=> (= inline$$Shl$0$po2@1 ($power_of_2 inline$$Errors_make_$def_verify$0$$t5@1)) (and (=> (= (ControlFlow 0 16889) (- 0 22200)) (>= inline$$Shl$0$po2@1 1)) (=> (>= inline$$Shl$0$po2@1 1) (=> (and (= inline$$Shl$0$dst@1 ($Integer (* (|i#$Integer| reason@@5) inline$$Shl$0$po2@1))) (= (ControlFlow 0 16889) 16988)) inline$$AddU64$0$Entry_correct))))))
(let ((inline$$Shl$0$Entry_correct  (and (=> (= (ControlFlow 0 16867) (- 0 22177)) (and ((_ is $Integer) reason@@5) ((_ is $Integer) inline$$Errors_make_$def_verify$0$$t5@1))) (=> (and ((_ is $Integer) reason@@5) ((_ is $Integer) inline$$Errors_make_$def_verify$0$$t5@1)) (=> (= (ControlFlow 0 16867) 16889) inline$$Shl$0$anon0_correct)))))
(let ((inline$$Errors_make_$def_verify$0$anon17_Else_correct  (=> (not $abort_flag@0@@5) (=> (and (= inline$$Errors_make_$def_verify$0$$t5@1 ($Integer 8)) (= (ControlFlow 0 16895) 16867)) inline$$Shl$0$Entry_correct))))
(let ((inline$$CastU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@5 true) (= inline$$CastU64$0$dst@1 inline$$CastU64$0$dst@0)) (and (=> (= (ControlFlow 0 16780) 17138) inline$$Errors_make_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 16780) 16895) inline$$Errors_make_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$CastU64$0$anon3_Then_correct  (=> (and (> (|i#$Integer| category) $MAX_U64) (= (ControlFlow 0 16778) 16780)) inline$$CastU64$0$anon3_Then$1_correct)))
(let ((inline$$CastU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (|i#$Integer| category)) (=> (and (= $abort_flag@0@@5 false) (= inline$$CastU64$0$dst@1 category)) (and (=> (= (ControlFlow 0 16728) 17138) inline$$Errors_make_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 16728) 16895) inline$$Errors_make_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$CastU64$0$Entry_correct  (and (=> (= (ControlFlow 0 16714) (- 0 22104)) true) (and (=> (= (ControlFlow 0 16714) 16778) inline$$CastU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 16714) 16728) inline$$CastU64$0$anon3_Else_correct)))))
(let ((inline$$Errors_make_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 16579) 16714)) inline$$CastU64$0$Entry_correct)))
(let ((inline$$Errors_make_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 17162) 16714) inline$$CastU64$0$Entry_correct)))
(let ((inline$$Errors_make_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 16571) 17162) inline$$Errors_make_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 16571) 16579) inline$$Errors_make_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Errors_make_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 17170) 17162) inline$$Errors_make_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 17170) 16579) inline$$Errors_make_$def_verify$0$anon16_Else_correct))))
(let ((inline$$Errors_make_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16565) 17170) inline$$Errors_make_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 16565) 16571) inline$$Errors_make_$def_verify$0$anon15_Else_correct)))))
(let ((anon0_correct@@5  (=> (and (and ((_ is $Integer) category) (>= (|i#$Integer| category) 0)) (<= (|i#$Integer| category) $MAX_U8)) (=> (and (and (and ((_ is $Integer) reason@@5) (>= (|i#$Integer| reason@@5) 0)) (<= (|i#$Integer| reason@@5) $MAX_U64)) (= (ControlFlow 0 16292) 16565)) inline$$Errors_make_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 21877) 16292) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5)))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun inline$$Errors_not_published_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_not_published_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun call4formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$Errors_not_published_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason@@6 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 22413) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 17611) (- 0 22753)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@6)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@6) (and (=> (= (ControlFlow 0 17611) (- 0 22762)) (=> $abort_flag@1@@6 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@6 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 17611) (- 0 22771)) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_not_published_$def_verify$0$$ret0@2 ($Integer 5))))))))))))
(let ((inline$$Errors_not_published_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_not_published_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@6 true)) (and (= inline$$Errors_not_published_$def_verify$0$$ret0@2 inline$$Errors_not_published_$def_verify$0$$ret0@1) (= (ControlFlow 0 17587) 17611))) anon0$2_correct@@6)))
(let ((inline$$Errors_not_published_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 17581) 17587)) inline$$Errors_not_published_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_not_published_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 17595) 17587) inline$$Errors_not_published_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_not_published_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 17575) 17595) inline$$Errors_not_published_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 17575) 17581) inline$$Errors_not_published_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_not_published_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@6 $abort_flag@0@@6) (=> (and (= inline$$Errors_not_published_$def_verify$0$$ret0@2 call4formal@$ret0@0@@5) (= (ControlFlow 0 17563) 17611)) anon0$2_correct@@6))))
(let ((inline$$Errors_not_published_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 17561) 17563)) inline$$Errors_not_published_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_not_published_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 17571) 17563) inline$$Errors_not_published_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_not_published_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@6) (and (=> (= (ControlFlow 0 17555) 17571) inline$$Errors_not_published_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 17555) 17561) inline$$Errors_not_published_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_not_published_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_not_published_$def_verify$0$$t2@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@6)) (and (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@5 inline$$Errors_not_published_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@5) (>= (|i#$Integer| call4formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 17547) 17575) inline$$Errors_not_published_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 17547) 17555) inline$$Errors_not_published_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_not_published_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 17507) 17547)) inline$$Errors_not_published_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_not_published_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 17603) 17547) inline$$Errors_not_published_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_not_published_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17501) 17603) inline$$Errors_not_published_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 17501) 17507) inline$$Errors_not_published_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@6  (=> (and (and (and ((_ is $Integer) reason@@6) (>= (|i#$Integer| reason@@6) 0)) (<= (|i#$Integer| reason@@6) $MAX_U64)) (= (ControlFlow 0 17322) 17501)) inline$$Errors_not_published_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 22413) 17322) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun inline$$Errors_requires_address_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_requires_address_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun call4formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$Errors_requires_address_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason@@7 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 22792) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 17978) (- 0 23132)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@7)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@7) (and (=> (= (ControlFlow 0 17978) (- 0 23141)) (=> $abort_flag@1@@7 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@7 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 17978) (- 0 23150)) (=> (not $abort_flag@1@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_requires_address_$def_verify$0$$ret0@2 ($Integer 2))))))))))))
(let ((inline$$Errors_requires_address_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_requires_address_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@7 true)) (and (= inline$$Errors_requires_address_$def_verify$0$$ret0@2 inline$$Errors_requires_address_$def_verify$0$$ret0@1) (= (ControlFlow 0 17954) 17978))) anon0$2_correct@@7)))
(let ((inline$$Errors_requires_address_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 17948) 17954)) inline$$Errors_requires_address_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_requires_address_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 17962) 17954) inline$$Errors_requires_address_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_requires_address_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 17942) 17962) inline$$Errors_requires_address_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 17942) 17948) inline$$Errors_requires_address_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_requires_address_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@7 $abort_flag@0@@7) (=> (and (= inline$$Errors_requires_address_$def_verify$0$$ret0@2 call4formal@$ret0@0@@6) (= (ControlFlow 0 17930) 17978)) anon0$2_correct@@7))))
(let ((inline$$Errors_requires_address_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 17928) 17930)) inline$$Errors_requires_address_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_requires_address_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 17938) 17930) inline$$Errors_requires_address_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_requires_address_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@7) (and (=> (= (ControlFlow 0 17922) 17938) inline$$Errors_requires_address_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 17922) 17928) inline$$Errors_requires_address_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_requires_address_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_requires_address_$def_verify$0$$t2@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@7)) (and (=> $abort_flag@0@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@6 inline$$Errors_requires_address_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@6) (>= (|i#$Integer| call4formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 17914) 17942) inline$$Errors_requires_address_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 17914) 17922) inline$$Errors_requires_address_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_requires_address_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 17874) 17914)) inline$$Errors_requires_address_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_requires_address_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 17970) 17914) inline$$Errors_requires_address_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_requires_address_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17868) 17970) inline$$Errors_requires_address_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 17868) 17874) inline$$Errors_requires_address_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@7  (=> (and (and (and ((_ is $Integer) reason@@7) (>= (|i#$Integer| reason@@7) 0)) (<= (|i#$Integer| reason@@7) $MAX_U64)) (= (ControlFlow 0 17689) 17868)) inline$$Errors_requires_address_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 22792) 17689) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@7))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun inline$$Errors_requires_capability_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_requires_capability_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun call4formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$Errors_requires_capability_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason@@8 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 23171) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 18345) (- 0 23511)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@8)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@8) (and (=> (= (ControlFlow 0 18345) (- 0 23520)) (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 18345) (- 0 23529)) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_requires_capability_$def_verify$0$$ret0@2 ($Integer 4))))))))))))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_requires_capability_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@8 true)) (and (= inline$$Errors_requires_capability_$def_verify$0$$ret0@2 inline$$Errors_requires_capability_$def_verify$0$$ret0@1) (= (ControlFlow 0 18321) 18345))) anon0$2_correct@@8)))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 18315) 18321)) inline$$Errors_requires_capability_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 18329) 18321) inline$$Errors_requires_capability_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@8 (and (=> (= (ControlFlow 0 18309) 18329) inline$$Errors_requires_capability_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 18309) 18315) inline$$Errors_requires_capability_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@8 $abort_flag@0@@8) (=> (and (= inline$$Errors_requires_capability_$def_verify$0$$ret0@2 call4formal@$ret0@0@@7) (= (ControlFlow 0 18297) 18345)) anon0$2_correct@@8))))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 18295) 18297)) inline$$Errors_requires_capability_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 18305) 18297) inline$$Errors_requires_capability_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@8) (and (=> (= (ControlFlow 0 18289) 18305) inline$$Errors_requires_capability_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 18289) 18295) inline$$Errors_requires_capability_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_requires_capability_$def_verify$0$$t2@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@8)) (and (=> $abort_flag@0@@8 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@7 inline$$Errors_requires_capability_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@7) (>= (|i#$Integer| call4formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 18281) 18309) inline$$Errors_requires_capability_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 18281) 18289) inline$$Errors_requires_capability_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 18241) 18281)) inline$$Errors_requires_capability_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 18337) 18281) inline$$Errors_requires_capability_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_requires_capability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18235) 18337) inline$$Errors_requires_capability_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 18235) 18241) inline$$Errors_requires_capability_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@8  (=> (and (and (and ((_ is $Integer) reason@@8) (>= (|i#$Integer| reason@@8) 0)) (<= (|i#$Integer| reason@@8) $MAX_U64)) (= (ControlFlow 0 18056) 18235)) inline$$Errors_requires_capability_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 23171) 18056) anon0_correct@@8)))
PreconditionGeneratedEntry_correct@@8))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun inline$$Errors_requires_role_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Errors_requires_role_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun call4formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$Errors_requires_role_$def_verify$0$$t2@1 () T@$Value)
(declare-fun reason@@9 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 23550) (let ((anon0$2_correct@@9  (and (=> (= (ControlFlow 0 18712) (- 0 23890)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@9)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@9) (and (=> (= (ControlFlow 0 18712) (- 0 23899)) (=> $abort_flag@1@@9 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@9 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 18712) (- 0 23908)) (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Errors_requires_role_$def_verify$0$$ret0@2 ($Integer 3))))))))))))
(let ((inline$$Errors_requires_role_$def_verify$0$anon5_correct  (=> (and (and (= inline$$Errors_requires_role_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@9 true)) (and (= inline$$Errors_requires_role_$def_verify$0$$ret0@2 inline$$Errors_requires_role_$def_verify$0$$ret0@1) (= (ControlFlow 0 18688) 18712))) anon0$2_correct@@9)))
(let ((inline$$Errors_requires_role_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 18682) 18688)) inline$$Errors_requires_role_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_requires_role_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 18696) 18688) inline$$Errors_requires_role_$def_verify$0$anon5_correct)))
(let ((inline$$Errors_requires_role_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 18676) 18696) inline$$Errors_requires_role_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 18676) 18682) inline$$Errors_requires_role_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Errors_requires_role_$def_verify$0$anon8_correct  (=> (= $abort_flag@1@@9 $abort_flag@0@@9) (=> (and (= inline$$Errors_requires_role_$def_verify$0$$ret0@2 call4formal@$ret0@0@@8) (= (ControlFlow 0 18664) 18712)) anon0$2_correct@@9))))
(let ((inline$$Errors_requires_role_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 18662) 18664)) inline$$Errors_requires_role_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_requires_role_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 18672) 18664) inline$$Errors_requires_role_$def_verify$0$anon8_correct)))
(let ((inline$$Errors_requires_role_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@9) (and (=> (= (ControlFlow 0 18656) 18672) inline$$Errors_requires_role_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 18656) 18662) inline$$Errors_requires_role_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Errors_requires_role_$def_verify$0$anon2$1_correct  (=> (and (and (and (= inline$$Errors_requires_role_$def_verify$0$$t2@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@9)) (and (=> $abort_flag@0@@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@8 inline$$Errors_requires_role_$def_verify$0$$t2@1)))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@8) (>= (|i#$Integer| call4formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 18648) 18676) inline$$Errors_requires_role_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 18648) 18656) inline$$Errors_requires_role_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Errors_requires_role_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 18608) 18648)) inline$$Errors_requires_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_requires_role_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 18704) 18648) inline$$Errors_requires_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Errors_requires_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18602) 18704) inline$$Errors_requires_role_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 18602) 18608) inline$$Errors_requires_role_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@9  (=> (and (and (and ((_ is $Integer) reason@@9) (>= (|i#$Integer| reason@@9) 0)) (<= (|i#$Integer| reason@@9) $MAX_U64)) (= (ControlFlow 0 18423) 18602)) inline$$Errors_requires_role_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (= (ControlFlow 0 23550) 18423) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@9))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
