(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun denominator () T@$Value)
(declare-fun $abort_flag@7 () Bool)
(declare-fun numerator () T@$Value)
(declare-fun $abort_code@12 () Int)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$FixedPoint32_FixedPoint32_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun inline$$CastU64$0$dst@1 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun inline$$CastU64$0$dst@0 () T@$Value)
(declare-fun inline$$Div$0$dst@2 () T@$Value)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun $abort_code@9 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t30@1 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t28@1 () T@$Value)
(declare-fun |inline$$FixedPoint32_create_from_rational_$def_verify$0$tmp#$9@2| () T@$Value)
(declare-fun $abort_code@7 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t26@1 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t23@1 () T@$Value)
(declare-fun |inline$$FixedPoint32_create_from_rational_$def_verify$0$tmp#$9@1| () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t25@1 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$Div$0$dst@0 () T@$Value)
(declare-fun inline$$Shl$1$dst@1 () T@$Value)
(declare-fun inline$$Div$0$dst@1 () T@$Value)
(declare-fun inline$$Shl$0$dst@1 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t19@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$Shl$1$po2@1 () Int)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0 () T@$Value)
(declare-fun inline$$Shl$0$po2@1 () Int)
(declare-fun inline$$FixedPoint32_create_from_rational_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@0 () T@$Value)
(declare-fun $abort_code@0 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28600) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 22141) (- 0 30613)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl denominator ($Integer 32)) ($Integer 0)))) $abort_flag@7)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl denominator ($Integer 32)) ($Integer 0)))) $abort_flag@7) (and (=> (= (ControlFlow 0 22141) (- 0 30630)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl numerator ($Integer 64)) ($Integer 0)))))))) $abort_flag@7)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl numerator ($Integer 64)) ($Integer 0)))))))) $abort_flag@7) (and (=> (= (ControlFlow 0 22141) (- 0 30671)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@7)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@7) (and (=> (= (ControlFlow 0 22141) (- 0 30694)) (=> $abort_flag@7 (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl denominator ($Integer 32)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl numerator ($Integer 64)) ($Integer 0))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (=> (=> $abort_flag@7 (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl denominator ($Integer 32)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl numerator ($Integer 64)) ($Integer 0))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> (= (ControlFlow 0 22141) (- 0 30773)) (=> $abort_flag@7 (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl denominator ($Integer 32)) ($Integer 0)))) (= $abort_code@12 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl numerator ($Integer 64)) ($Integer 0)))))))) (= $abort_code@12 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@12 (|i#$Integer| ($Integer 8))))))) (=> (=> $abort_flag@7 (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl denominator ($Integer 32)) ($Integer 0)))) (= $abort_code@12 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl numerator ($Integer 64)) ($Integer 0)))))))) (= $abort_code@12 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@12 (|i#$Integer| ($Integer 8)))))) (=> (= (ControlFlow 0 22141) (- 0 30885)) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$FixedPoint32_create_from_rational_$def_verify$0$$ret0@2 ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Integer (div (|i#$Integer| ($shl numerator ($Integer 64))) (|i#$Integer| ($shl denominator ($Integer 32)))))) (+ len@@0 1)))))))))))))))))))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon58_correct  (=> (and (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$ret0@2 inline$$FixedPoint32_FixedPoint32_pack$0$$struct@1) (= $abort_flag@7 $abort_flag@6)) (and (= $abort_code@12 $abort_code@10) (= (ControlFlow 0 21877) 22141))) anon0$2_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 21875) 21877)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon58_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon87_Then_correct  (=> (= (ControlFlow 0 21885) 21877) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon58_correct)))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 21853) 21885) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 21853) 21875) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 21859) 21885) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 21859) 21875) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon87_Else_correct))))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 21847) 21859) inline$$FixedPoint32_FixedPoint32_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 21847) 21853) inline$$FixedPoint32_FixedPoint32_pack$0$anon4_Else_correct)))))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 21839) 21885) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 21839) 21875) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$CastU64$0$dst@1) (>= (|i#$Integer| inline$$CastU64$0$dst@1) 0)) (<= (|i#$Integer| inline$$CastU64$0$dst@1) $MAX_U64)) (= inline$$FixedPoint32_FixedPoint32_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$CastU64$0$dst@1) 1)))) (and (=> (= (ControlFlow 0 21831) 21847) inline$$FixedPoint32_FixedPoint32_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 21831) 21839) inline$$FixedPoint32_FixedPoint32_pack$0$anon3_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon85_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 21865) 21831)) inline$$FixedPoint32_FixedPoint32_pack$0$anon0_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct  (=> (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$ret0@1 $Error) (=> (and (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$ret0@2 inline$$FixedPoint32_create_from_rational_$def_verify$0$$ret0@1) (= $abort_flag@7 true)) (and (= $abort_code@12 $abort_code@11) (= (ControlFlow 0 21169) 22141))) anon0$2_correct))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon7_correct  (=> (and (= $abort_code@11 $abort_code@1) (= (ControlFlow 0 22109) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 22107) 22109)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon7_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 22117) 22109) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon7_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon61_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 22101) 22117) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 22101) 22107) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon13_correct  (=> (and (= $abort_code@11 $abort_code@2) (= (ControlFlow 0 22081) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 22079) 22081)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon13_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon65_Then_correct  (=> (= (ControlFlow 0 22089) 22081) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon13_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon64_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 22073) 22089) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 22073) 22079) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon19_correct  (=> (and (= $abort_code@11 $abort_code@3) (= (ControlFlow 0 22053) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 22051) 22053)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon19_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon68_Then_correct  (=> (= (ControlFlow 0 22061) 22053) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon19_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon67_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 22045) 22061) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 22045) 22051) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon27_correct  (=> (and (= $abort_code@11 $abort_code@5) (= (ControlFlow 0 22033) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 22031) 22033)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon27_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 22041) 22033) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon27_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon71_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 22025) 22041) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 22025) 22031) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon39_correct  (=> (and (= $abort_code@11 $abort_code@6) (= (ControlFlow 0 21937) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 21935) 21937)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon39_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon78_Then_correct  (=> (= (ControlFlow 0 21945) 21937) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon39_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon77_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 21929) 21945) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 21929) 21935) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon47_correct  (=> (and (= $abort_code@11 $abort_code@8) (= (ControlFlow 0 21917) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 21915) 21917)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon47_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon82_Then_correct  (=> (= (ControlFlow 0 21925) 21917) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon47_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon81_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 21909) 21925) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 21909) 21915) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon55_correct  (=> (and (= $abort_code@11 $abort_code@10) (= (ControlFlow 0 21897) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 21895) 21897)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon55_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon86_Then_correct  (=> (= (ControlFlow 0 21905) 21897) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon55_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon85_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 21889) 21905) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 21889) 21895) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$CastU64$0$anon3_Then$1_correct  (=> (= $abort_code@10 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@6 true) (= inline$$CastU64$0$dst@1 inline$$CastU64$0$dst@0)) (and (=> (= (ControlFlow 0 21693) 21889) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 21693) 21865) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon85_Else_correct))))))
(let ((inline$$CastU64$0$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$Div$0$dst@2) $MAX_U64) (= (ControlFlow 0 21691) 21693)) inline$$CastU64$0$anon3_Then$1_correct)))
(let ((inline$$CastU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (|i#$Integer| inline$$Div$0$dst@2)) (= $abort_code@10 $abort_code@8)) (and (= $abort_flag@6 $abort_flag@5) (= inline$$CastU64$0$dst@1 inline$$Div$0$dst@2))) (and (=> (= (ControlFlow 0 21641) 21889) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 21641) 21865) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$CastU64$0$Entry_correct  (and (=> (= (ControlFlow 0 21627) (- 0 30323)) true) (and (=> (= (ControlFlow 0 21627) 21691) inline$$CastU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 21627) 21641) inline$$CastU64$0$anon3_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon83_Then_correct  (=> (and (|b#$Boolean| inline$$Le$0$dst@1) (= (ControlFlow 0 21699) 21627)) inline$$CastU64$0$Entry_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon52_correct  (=> (and (= $abort_code@11 $abort_code@9) (= (ControlFlow 0 21548) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 21546) 21548)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon52_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon84_Then_correct  (=> (= (ControlFlow 0 21556) 21548) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon52_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon83_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$0$dst@1)) (= $abort_code@9 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 21540) 21556) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 21540) 21546) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon81_Else_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 21528) 21699) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 21528) 21540) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon79_Then$1_correct  (=> (and (and (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t30@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5)) (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 21522) 21909) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 21522) 21528) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Le$0$anon0_correct  (=> (and (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| inline$$Div$0$dst@2) (|i#$Integer| inline$$FixedPoint32_create_from_rational_$def_verify$0$$t28@1)))) (= (ControlFlow 0 21510) 21522)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon79_Then$1_correct)))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 21496) (- 0 30202)) true) (=> (= (ControlFlow 0 21496) 21510) inline$$Le$0$anon0_correct))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon79_Then_correct  (=> (|b#$Boolean| |inline$$FixedPoint32_create_from_rational_$def_verify$0$tmp#$9@2|) (=> (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t28@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 21516) 21496)) inline$$Le$0$Entry_correct))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon44_correct  (=> (and (= $abort_code@11 $abort_code@7) (= (ControlFlow 0 21436) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 21434) 21436)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon44_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon80_Then_correct  (=> (= (ControlFlow 0 21444) 21436) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon44_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon79_Else_correct  (=> (and (not (|b#$Boolean| |inline$$FixedPoint32_create_from_rational_$def_verify$0$tmp#$9@2|)) (= $abort_code@7 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 21428) 21444) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 21428) 21434) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon77_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 21416) 21516) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 21416) 21428) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$L5_correct  (=> (and (and (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t26@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 21410) 21929) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 21410) 21416) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon34_correct  (=> (and (= |inline$$FixedPoint32_create_from_rational_$def_verify$0$tmp#$9@2| inline$$FixedPoint32_create_from_rational_$def_verify$0$$t24@1) (= (ControlFlow 0 22005) 21410)) inline$$FixedPoint32_create_from_rational_$def_verify$0$L5_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 22003) 22005)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon34_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon75_Then_correct  (=> (= (ControlFlow 0 22013) 22005) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon34_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon74_Then_correct  (=> (and (|b#$Boolean| inline$$FixedPoint32_create_from_rational_$def_verify$0$$t23@1) (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t24@1 ($Boolean true))) (and (=> (= (ControlFlow 0 21995) 22013) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 21995) 22003) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon36_correct  (=> (and (= |inline$$FixedPoint32_create_from_rational_$def_verify$0$tmp#$9@2| |inline$$FixedPoint32_create_from_rational_$def_verify$0$tmp#$9@1|) (= (ControlFlow 0 21404) 21410)) inline$$FixedPoint32_create_from_rational_$def_verify$0$L5_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 21402) 21404)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon36_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 21953) 21404) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon36_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon74_Else_correct  (=> (not (|b#$Boolean| inline$$FixedPoint32_create_from_rational_$def_verify$0$$t23@1)) (=> (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t25@1 ($Integer 0)) (= |inline$$FixedPoint32_create_from_rational_$def_verify$0$tmp#$9@1| ($Boolean ($IsEqual_stratified numerator inline$$FixedPoint32_create_from_rational_$def_verify$0$$t25@1)))) (and (=> (= (ControlFlow 0 21396) 21953) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 21396) 21402) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon76_Else_correct))))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon30_correct  (=> (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t22@1 ($Integer 0)) (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t23@1 ($Boolean  (not ($IsEqual_stratified inline$$Div$0$dst@2 inline$$FixedPoint32_create_from_rational_$def_verify$0$$t22@1))))) (and (=> (= (ControlFlow 0 21376) 21995) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 21376) 21396) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 21360) 21376)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon30_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon73_Then_correct  (=> (= (ControlFlow 0 22021) 21376) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon30_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon71_Else_correct  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 21354) 22021) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 21354) 21360) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$Div$0$anon3_Then$1_correct  (=> (= $abort_flag@3 true) (=> (and (= $abort_code@5 $EXEC_FAILURE_CODE) (= inline$$Div$0$dst@2 inline$$Div$0$dst@0)) (and (=> (= (ControlFlow 0 21340) 22025) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 21340) 21354) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon71_Else_correct))))))
(let ((inline$$Div$0$anon3_Then_correct  (=> (and (= (|i#$Integer| inline$$Shl$1$dst@1) 0) (= (ControlFlow 0 21338) 21340)) inline$$Div$0$anon3_Then$1_correct)))
(let ((inline$$Div$0$anon3_Else_correct  (=> (not (= (|i#$Integer| inline$$Shl$1$dst@1) 0)) (=> (and (and (= inline$$Div$0$dst@1 ($Integer (div (|i#$Integer| inline$$Shl$0$dst@1) (|i#$Integer| inline$$Shl$1$dst@1)))) (= $abort_flag@3 $abort_flag@2)) (and (= $abort_code@5 $abort_code@3) (= inline$$Div$0$dst@2 inline$$Div$0$dst@1))) (and (=> (= (ControlFlow 0 21288) 22025) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 21288) 21354) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon71_Else_correct))))))
(let ((inline$$Div$0$Entry_correct  (and (=> (= (ControlFlow 0 21264) (- 0 29895)) true) (and (=> (= (ControlFlow 0 21264) 21338) inline$$Div$0$anon3_Then_correct) (=> (= (ControlFlow 0 21264) 21288) inline$$Div$0$anon3_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon69_Then_correct  (=> (and (|b#$Boolean| inline$$FixedPoint32_create_from_rational_$def_verify$0$$t19@1) (= (ControlFlow 0 21346) 21264)) inline$$Div$0$Entry_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon24_correct  (=> (and (= $abort_code@11 $abort_code@4) (= (ControlFlow 0 21163) 21169)) inline$$FixedPoint32_create_from_rational_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 21161) 21163)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon24_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 21177) 21163) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon24_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon69_Else_correct  (=> (and (not (|b#$Boolean| inline$$FixedPoint32_create_from_rational_$def_verify$0$$t19@1)) (= $abort_code@4 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 21155) 21177) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 21155) 21161) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon67_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 21143) 21346) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 21143) 21155) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon16_correct  (=> (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t18@1 ($Integer 0)) (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t19@1 ($Boolean  (not ($IsEqual_stratified inline$$Shl$1$dst@1 inline$$FixedPoint32_create_from_rational_$def_verify$0$$t18@1))))) (=> (and (and (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t20@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2)) (and (=> $abort_flag@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 21137) 22045) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 21137) 21143) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon67_Else_correct))))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 21117) 21137)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon16_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 22069) 21137) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon16_correct)))
(let ((inline$$Shl$1$anon0_correct  (=> (= inline$$Shl$1$po2@1 ($power_of_2 inline$$FixedPoint32_create_from_rational_$def_verify$0$$t17@1)) (and (=> (= (ControlFlow 0 21103) (- 0 29739)) (>= inline$$Shl$1$po2@1 1)) (=> (>= inline$$Shl$1$po2@1 1) (=> (= inline$$Shl$1$dst@1 ($Integer (* (|i#$Integer| inline$$CastU128$1$dst@1) inline$$Shl$1$po2@1))) (and (=> (= (ControlFlow 0 21103) 22069) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 21103) 21117) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon66_Else_correct))))))))
(let ((inline$$Shl$1$Entry_correct  (and (=> (= (ControlFlow 0 21081) (- 0 29716)) (and ((_ is $Integer) inline$$CastU128$1$dst@1) ((_ is $Integer) inline$$FixedPoint32_create_from_rational_$def_verify$0$$t17@1))) (=> (and ((_ is $Integer) inline$$CastU128$1$dst@1) ((_ is $Integer) inline$$FixedPoint32_create_from_rational_$def_verify$0$$t17@1)) (=> (= (ControlFlow 0 21081) 21103) inline$$Shl$1$anon0_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon64_Else_correct  (=> (not $abort_flag@1) (=> (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t17@1 ($Integer 32)) (= (ControlFlow 0 21109) 21081)) inline$$Shl$1$Entry_correct))))
(let ((inline$$CastU128$1$anon3_Then$1_correct  (=> (= $abort_code@2 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@1 true) (= inline$$CastU128$1$dst@1 inline$$CastU128$1$dst@0)) (and (=> (= (ControlFlow 0 20994) 22073) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 20994) 21109) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon64_Else_correct))))))
(let ((inline$$CastU128$1$anon3_Then_correct  (=> (and (> (|i#$Integer| denominator) $MAX_U128) (= (ControlFlow 0 20992) 20994)) inline$$CastU128$1$anon3_Then$1_correct)))
(let ((inline$$CastU128$1$anon3_Else_correct  (=> (and (and (>= $MAX_U128 (|i#$Integer| denominator)) (= $abort_code@2 $abort_code@1)) (and (= $abort_flag@1 $abort_flag@0) (= inline$$CastU128$1$dst@1 denominator))) (and (=> (= (ControlFlow 0 20942) 22073) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 20942) 21109) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$CastU128$1$Entry_correct  (and (=> (= (ControlFlow 0 20928) (- 0 29634)) true) (and (=> (= (ControlFlow 0 20928) 20992) inline$$CastU128$1$anon3_Then_correct) (=> (= (ControlFlow 0 20928) 20942) inline$$CastU128$1$anon3_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 20861) 20928)) inline$$CastU128$1$Entry_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 22097) 20928) inline$$CastU128$1$Entry_correct)))
(let ((inline$$Shl$0$anon0_correct  (=> (= inline$$Shl$0$po2@1 ($power_of_2 inline$$FixedPoint32_create_from_rational_$def_verify$0$$t15@1)) (and (=> (= (ControlFlow 0 20847) (- 0 29600)) (>= inline$$Shl$0$po2@1 1)) (=> (>= inline$$Shl$0$po2@1 1) (=> (= inline$$Shl$0$dst@1 ($Integer (* (|i#$Integer| inline$$CastU128$0$dst@1) inline$$Shl$0$po2@1))) (and (=> (= (ControlFlow 0 20847) 22097) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 20847) 20861) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon63_Else_correct))))))))
(let ((inline$$Shl$0$Entry_correct  (and (=> (= (ControlFlow 0 20825) (- 0 29577)) (and ((_ is $Integer) inline$$CastU128$0$dst@1) ((_ is $Integer) inline$$FixedPoint32_create_from_rational_$def_verify$0$$t15@1))) (=> (and ((_ is $Integer) inline$$CastU128$0$dst@1) ((_ is $Integer) inline$$FixedPoint32_create_from_rational_$def_verify$0$$t15@1)) (=> (= (ControlFlow 0 20825) 20847) inline$$Shl$0$anon0_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon61_Else_correct  (=> (not $abort_flag@0) (=> (and (= inline$$FixedPoint32_create_from_rational_$def_verify$0$$t15@1 ($Integer 64)) (= (ControlFlow 0 20853) 20825)) inline$$Shl$0$Entry_correct))))
(let ((inline$$CastU128$0$anon3_Then$1_correct  (=> (= $abort_flag@0 true) (=> (and (= $abort_code@1 $EXEC_FAILURE_CODE) (= inline$$CastU128$0$dst@1 inline$$CastU128$0$dst@0)) (and (=> (= (ControlFlow 0 20738) 22101) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 20738) 20853) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon61_Else_correct))))))
(let ((inline$$CastU128$0$anon3_Then_correct  (=> (and (> (|i#$Integer| numerator) $MAX_U128) (= (ControlFlow 0 20736) 20738)) inline$$CastU128$0$anon3_Then$1_correct)))
(let ((inline$$CastU128$0$anon3_Else_correct  (=> (and (and (>= $MAX_U128 (|i#$Integer| numerator)) (= $abort_flag@0 false)) (and (= $abort_code@1 $abort_code@0) (= inline$$CastU128$0$dst@1 numerator))) (and (=> (= (ControlFlow 0 20686) 22101) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 20686) 20853) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$CastU128$0$Entry_correct  (and (=> (= (ControlFlow 0 20672) (- 0 29495)) true) (and (=> (= (ControlFlow 0 20672) 20736) inline$$CastU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 20672) 20686) inline$$CastU128$0$anon3_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 20537) 20672)) inline$$CastU128$0$Entry_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 22125) 20672) inline$$CastU128$0$Entry_correct)))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon59_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 20529) 22125) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 20529) 20537) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon59_Then_correct  (and (=> (= (ControlFlow 0 22133) 22125) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 22133) 20537) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon60_Else_correct))))
(let ((inline$$FixedPoint32_create_from_rational_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 20523) 22133) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 20523) 20529) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon59_Else_correct)))))
(let ((anon0_correct  (=> (and (and ((_ is $Integer) numerator) (>= (|i#$Integer| numerator) 0)) (<= (|i#$Integer| numerator) $MAX_U64)) (=> (and (and (and ((_ is $Integer) denominator) (>= (|i#$Integer| denominator) 0)) (<= (|i#$Integer| denominator) $MAX_U64)) (= (ControlFlow 0 19564) 20523)) inline$$FixedPoint32_create_from_rational_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 28600) 19564) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$FixedPoint32_FixedPoint32_pack$0$$struct@1@@0 () T@$Value)
(declare-fun value () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 30916) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 22786) (- 0 31126)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 22786) (- 0 31135)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 22786) (- 0 31144)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$FixedPoint32_FixedPoint32_pack$0$$struct@1@@0)) $FixedPoint32_FixedPoint32_value) value)))))))))))
(let ((inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 22760) 22786)) anon0$2_correct@@0)))
(let ((inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 22770) 22786) anon0$2_correct@@0)))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 22738) 22770) inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 22738) 22760) inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 22744) 22770) inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 22744) 22760) inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon6_Else_correct))))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 22732) 22744) inline$$FixedPoint32_FixedPoint32_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 22732) 22738) inline$$FixedPoint32_FixedPoint32_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon3_Else_correct@@0  (=> (>= 0 0) (and (=> (= (ControlFlow 0 22724) 22770) inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 22724) 22760) inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$FixedPoint32_FixedPoint32_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) value) (>= (|i#$Integer| value) 0)) (<= (|i#$Integer| value) $MAX_U64)) (= inline$$FixedPoint32_FixedPoint32_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 value) 1)))) (and (=> (= (ControlFlow 0 22716) 22732) inline$$FixedPoint32_FixedPoint32_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 22716) 22724) inline$$FixedPoint32_FixedPoint32_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 22556) 22716)) inline$$FixedPoint32_FixedPoint32_pack$0$anon0_correct@@0)))
(let ((inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 22778) 22716) inline$$FixedPoint32_FixedPoint32_pack$0$anon0_correct@@0)))
(let ((inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 22550) 22778) inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 22550) 22556) inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon5_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and (and ((_ is $Integer) value) (>= (|i#$Integer| value) 0)) (<= (|i#$Integer| value) $MAX_U64)) (= (ControlFlow 0 22437) 22550)) inline$$FixedPoint32_create_from_raw_value_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 30916) 22437) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun divisor () T@$Value)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun val@@0 () T@$Value)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun inline$$FixedPoint32_divide_u64_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$CastU64$0$dst@1@@0 () T@$Value)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun inline$$FixedPoint32_divide_u64_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun inline$$CastU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$Div$0$dst@2@@0 () T@$Value)
(declare-fun inline$$Le$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$FixedPoint32_divide_u64_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$FixedPoint32_divide_u64_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$Div$0$dst@0@@0 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1@@0 () T@$Value)
(declare-fun inline$$Div$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Shl$0$dst@1@@0 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0@@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$Shl$0$po2@1@@0 () Int)
(declare-fun inline$$FixedPoint32_divide_u64_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1@@0 () T@$Value)
(declare-fun inline$$CastU128$0$dst@0@@0 () T@$Value)
(declare-fun inline$$FixedPoint32_divide_u64_$def_verify$0$$t12@1 () T@$Value)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$FixedPoint32_divide_u64_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$FixedPoint32_divide_u64_$def_verify$0$$t13@1 () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $FixedPoint32_FixedPoint32_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 31168) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 24848) (- 0 32645)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 24848) (- 0 32664)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl val@@0 ($Integer 32))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl val@@0 ($Integer 32))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 24848) (- 0 32687)) (=> $abort_flag@6@@0 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl val@@0 ($Integer 32))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (=> (=> $abort_flag@6@@0 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl val@@0 ($Integer 32))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> (= (ControlFlow 0 24848) (- 0 32728)) (=> $abort_flag@6@@0 (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl val@@0 ($Integer 32))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 8))))))) (=> (=> $abort_flag@6@@0 (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl val@@0 ($Integer 32))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 8)))))) (=> (= (ControlFlow 0 24848) (- 0 32791)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$FixedPoint32_divide_u64_$def_verify$0$$ret0@2 ($Integer (div (|i#$Integer| ($shl val@@0 ($Integer 32))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value)))))))))))))))))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon42_correct  (=> (and (and (= inline$$FixedPoint32_divide_u64_$def_verify$0$$ret0@2 inline$$CastU64$0$dst@1@@0) (= $abort_flag@6@@0 $abort_flag@5@@0)) (and (= $abort_code@10@@0 $abort_code@8@@0) (= (ControlFlow 0 24680) 24848))) anon0$2_correct@@1)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 24678) 24680)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon42_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 24688) 24680) inline$$FixedPoint32_divide_u64_$def_verify$0$anon42_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon61_Else_correct  (=> (not $abort_flag@5@@0) (and (=> (= (ControlFlow 0 24672) 24688) inline$$FixedPoint32_divide_u64_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 24672) 24678) inline$$FixedPoint32_divide_u64_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$Abort_correct  (=> (= inline$$FixedPoint32_divide_u64_$def_verify$0$$ret0@1 $Error) (=> (and (and (= inline$$FixedPoint32_divide_u64_$def_verify$0$$ret0@2 inline$$FixedPoint32_divide_u64_$def_verify$0$$ret0@1) (= $abort_flag@6@@0 true)) (and (= $abort_code@10@@0 $abort_code@9@@0) (= (ControlFlow 0 23771) 24848))) anon0$2_correct@@1))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon7_correct  (=> (and (= $abort_code@9@@0 $abort_code@1@@0) (= (ControlFlow 0 24816) 23771)) inline$$FixedPoint32_divide_u64_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 24814) 24816)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon7_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 24824) 24816) inline$$FixedPoint32_divide_u64_$def_verify$0$anon7_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon45_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 24808) 24824) inline$$FixedPoint32_divide_u64_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 24808) 24814) inline$$FixedPoint32_divide_u64_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon15_correct  (=> (and (= $abort_code@9@@0 $abort_code@3@@0) (= (ControlFlow 0 24796) 23771)) inline$$FixedPoint32_divide_u64_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 24794) 24796)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon15_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 24804) 24796) inline$$FixedPoint32_divide_u64_$def_verify$0$anon15_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon49_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 24788) 24804) inline$$FixedPoint32_divide_u64_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 24788) 24794) inline$$FixedPoint32_divide_u64_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon21_correct  (=> (and (= $abort_code@9@@0 $abort_code@4@@0) (= (ControlFlow 0 24768) 23771)) inline$$FixedPoint32_divide_u64_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 24766) 24768)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon21_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 24776) 24768) inline$$FixedPoint32_divide_u64_$def_verify$0$anon21_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon52_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 24760) 24776) inline$$FixedPoint32_divide_u64_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 24760) 24766) inline$$FixedPoint32_divide_u64_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon25_correct  (=> (and (= $abort_code@9@@0 $abort_code@5@@0) (= (ControlFlow 0 24748) 23771)) inline$$FixedPoint32_divide_u64_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 24746) 24748)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon25_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 24756) 24748) inline$$FixedPoint32_divide_u64_$def_verify$0$anon25_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon54_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 24740) 24756) inline$$FixedPoint32_divide_u64_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 24740) 24746) inline$$FixedPoint32_divide_u64_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon31_correct  (=> (and (= $abort_code@9@@0 $abort_code@6@@0) (= (ControlFlow 0 24720) 23771)) inline$$FixedPoint32_divide_u64_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon58_Else_correct  (=> (and (not true) (= (ControlFlow 0 24718) 24720)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon31_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon58_Then_correct  (=> (= (ControlFlow 0 24728) 24720) inline$$FixedPoint32_divide_u64_$def_verify$0$anon31_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon57_Then_correct  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 24712) 24728) inline$$FixedPoint32_divide_u64_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 24712) 24718) inline$$FixedPoint32_divide_u64_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon39_correct  (=> (and (= $abort_code@9@@0 $abort_code@8@@0) (= (ControlFlow 0 24700) 23771)) inline$$FixedPoint32_divide_u64_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 24698) 24700)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon39_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 24708) 24700) inline$$FixedPoint32_divide_u64_$def_verify$0$anon39_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon61_Then_correct  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 24692) 24708) inline$$FixedPoint32_divide_u64_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 24692) 24698) inline$$FixedPoint32_divide_u64_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$CastU64$0$anon3_Then$1_correct@@0  (=> (= $abort_code@8@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@5@@0 true) (= inline$$CastU64$0$dst@1@@0 inline$$CastU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 24656) 24692) inline$$FixedPoint32_divide_u64_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 24656) 24672) inline$$FixedPoint32_divide_u64_$def_verify$0$anon61_Else_correct))))))
(let ((inline$$CastU64$0$anon3_Then_correct@@0  (=> (and (> (|i#$Integer| inline$$Div$0$dst@2@@0) $MAX_U64) (= (ControlFlow 0 24654) 24656)) inline$$CastU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$CastU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (|i#$Integer| inline$$Div$0$dst@2@@0)) (= $abort_code@8@@0 $abort_code@6@@0)) (and (= $abort_flag@5@@0 $abort_flag@4@@0) (= inline$$CastU64$0$dst@1@@0 inline$$Div$0$dst@2@@0))) (and (=> (= (ControlFlow 0 24604) 24692) inline$$FixedPoint32_divide_u64_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 24604) 24672) inline$$FixedPoint32_divide_u64_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$CastU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 24590) (- 0 32431)) true) (and (=> (= (ControlFlow 0 24590) 24654) inline$$CastU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 24590) 24604) inline$$CastU64$0$anon3_Else_correct@@0)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon59_Then_correct  (=> (and (|b#$Boolean| inline$$Le$0$dst@1@@0) (= (ControlFlow 0 24662) 24590)) inline$$CastU64$0$Entry_correct@@0)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon36_correct  (=> (and (= $abort_code@9@@0 $abort_code@7@@0) (= (ControlFlow 0 24511) 23771)) inline$$FixedPoint32_divide_u64_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 24509) 24511)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon36_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 24519) 24511) inline$$FixedPoint32_divide_u64_$def_verify$0$anon36_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon59_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$0$dst@1@@0)) (= $abort_code@7@@0 (|i#$Integer| call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 24503) 24519) inline$$FixedPoint32_divide_u64_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 24503) 24509) inline$$FixedPoint32_divide_u64_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon57_Else_correct  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 24491) 24662) inline$$FixedPoint32_divide_u64_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 24491) 24503) inline$$FixedPoint32_divide_u64_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon28$1_correct  (=> (and (and (and (= inline$$FixedPoint32_divide_u64_$def_verify$0$$t21@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@0)) (and (=> $abort_flag@4@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 24485) 24712) inline$$FixedPoint32_divide_u64_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 24485) 24491) inline$$FixedPoint32_divide_u64_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Le$0$anon0_correct@@0  (=> (and (= inline$$Le$0$dst@1@@0 ($Boolean (<= (|i#$Integer| inline$$Div$0$dst@2@@0) (|i#$Integer| inline$$FixedPoint32_divide_u64_$def_verify$0$$t19@1)))) (= (ControlFlow 0 24473) 24485)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon28$1_correct)))
(let ((inline$$Le$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 24459) (- 0 32310)) true) (=> (= (ControlFlow 0 24459) 24473) inline$$Le$0$anon0_correct@@0))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon28_correct  (=> (and (= inline$$FixedPoint32_divide_u64_$def_verify$0$$t19@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 24479) 24459)) inline$$Le$0$Entry_correct@@0)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 24411) 24479)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon28_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon56_Then_correct  (=> (= (ControlFlow 0 24736) 24479) inline$$FixedPoint32_divide_u64_$def_verify$0$anon28_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon54_Else_correct  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 24405) 24736) inline$$FixedPoint32_divide_u64_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 24405) 24411) inline$$FixedPoint32_divide_u64_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$Div$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@3@@0 true) (=> (and (= $abort_code@5@@0 $EXEC_FAILURE_CODE) (= inline$$Div$0$dst@2@@0 inline$$Div$0$dst@0@@0)) (and (=> (= (ControlFlow 0 24391) 24740) inline$$FixedPoint32_divide_u64_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 24391) 24405) inline$$FixedPoint32_divide_u64_$def_verify$0$anon54_Else_correct))))))
(let ((inline$$Div$0$anon3_Then_correct@@0  (=> (and (= (|i#$Integer| inline$$CastU128$1$dst@1@@0) 0) (= (ControlFlow 0 24389) 24391)) inline$$Div$0$anon3_Then$1_correct@@0)))
(let ((inline$$Div$0$anon3_Else_correct@@0  (=> (not (= (|i#$Integer| inline$$CastU128$1$dst@1@@0) 0)) (=> (and (and (= inline$$Div$0$dst@1@@0 ($Integer (div (|i#$Integer| inline$$Shl$0$dst@1@@0) (|i#$Integer| inline$$CastU128$1$dst@1@@0)))) (= $abort_flag@3@@0 $abort_flag@2@@0)) (and (= $abort_code@5@@0 $abort_code@4@@0) (= inline$$Div$0$dst@2@@0 inline$$Div$0$dst@1@@0))) (and (=> (= (ControlFlow 0 24339) 24740) inline$$FixedPoint32_divide_u64_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 24339) 24405) inline$$FixedPoint32_divide_u64_$def_verify$0$anon54_Else_correct))))))
(let ((inline$$Div$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 24315) (- 0 32203)) true) (and (=> (= (ControlFlow 0 24315) 24389) inline$$Div$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 24315) 24339) inline$$Div$0$anon3_Else_correct@@0)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon52_Else_correct  (=> (and (not $abort_flag@2@@0) (= (ControlFlow 0 24397) 24315)) inline$$Div$0$Entry_correct@@0)))
(let ((inline$$CastU128$1$anon3_Then$1_correct@@0  (=> (= $abort_code@4@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@2@@0 true) (= inline$$CastU128$1$dst@1@@0 inline$$CastU128$1$dst@0@@0)) (and (=> (= (ControlFlow 0 24220) 24760) inline$$FixedPoint32_divide_u64_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 24220) 24397) inline$$FixedPoint32_divide_u64_$def_verify$0$anon52_Else_correct))))))
(let ((inline$$CastU128$1$anon3_Then_correct@@0  (=> (and (> (|i#$Integer| inline$$GetFieldFromValue$1$dst@1) $MAX_U128) (= (ControlFlow 0 24218) 24220)) inline$$CastU128$1$anon3_Then$1_correct@@0)))
(let ((inline$$CastU128$1$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)) (= $abort_code@4@@0 $abort_code@3@@0)) (and (= $abort_flag@2@@0 $abort_flag@1@@0) (= inline$$CastU128$1$dst@1@@0 inline$$GetFieldFromValue$1$dst@1))) (and (=> (= (ControlFlow 0 24168) 24760) inline$$FixedPoint32_divide_u64_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 24168) 24397) inline$$FixedPoint32_divide_u64_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$CastU128$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 24154) (- 0 32131)) true) (and (=> (= (ControlFlow 0 24154) 24218) inline$$CastU128$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 24154) 24168) inline$$CastU128$1$anon3_Else_correct@@0)))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value)) (= (ControlFlow 0 24081) 24154)) inline$$CastU128$1$Entry_correct@@0)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 24039) 24081)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 24784) 24081) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Shl$0$anon0_correct@@0  (=> (= inline$$Shl$0$po2@1@@0 ($power_of_2 inline$$FixedPoint32_divide_u64_$def_verify$0$$t16@1)) (and (=> (= (ControlFlow 0 24025) (- 0 32077)) (>= inline$$Shl$0$po2@1@@0 1)) (=> (>= inline$$Shl$0$po2@1@@0 1) (=> (= inline$$Shl$0$dst@1@@0 ($Integer (* (|i#$Integer| inline$$CastU128$0$dst@1@@0) inline$$Shl$0$po2@1@@0))) (and (=> (= (ControlFlow 0 24025) 24784) inline$$FixedPoint32_divide_u64_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 24025) 24039) inline$$FixedPoint32_divide_u64_$def_verify$0$anon51_Else_correct))))))))
(let ((inline$$Shl$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 24003) (- 0 32054)) (and ((_ is $Integer) inline$$CastU128$0$dst@1@@0) ((_ is $Integer) inline$$FixedPoint32_divide_u64_$def_verify$0$$t16@1))) (=> (and ((_ is $Integer) inline$$CastU128$0$dst@1@@0) ((_ is $Integer) inline$$FixedPoint32_divide_u64_$def_verify$0$$t16@1)) (=> (= (ControlFlow 0 24003) 24025) inline$$Shl$0$anon0_correct@@0)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@1@@0) (=> (and (= inline$$FixedPoint32_divide_u64_$def_verify$0$$t16@1 ($Integer 32)) (= (ControlFlow 0 24031) 24003)) inline$$Shl$0$Entry_correct@@0))))
(let ((inline$$CastU128$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@1@@0 true) (=> (and (= $abort_code@3@@0 $EXEC_FAILURE_CODE) (= inline$$CastU128$0$dst@1@@0 inline$$CastU128$0$dst@0@@0)) (and (=> (= (ControlFlow 0 23916) 24788) inline$$FixedPoint32_divide_u64_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 23916) 24031) inline$$FixedPoint32_divide_u64_$def_verify$0$anon49_Else_correct))))))
(let ((inline$$CastU128$0$anon3_Then_correct@@0  (=> (and (> (|i#$Integer| val@@0) $MAX_U128) (= (ControlFlow 0 23914) 23916)) inline$$CastU128$0$anon3_Then$1_correct@@0)))
(let ((inline$$CastU128$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U128 (|i#$Integer| val@@0)) (= $abort_flag@1@@0 $abort_flag@0@@0)) (and (= $abort_code@3@@0 $abort_code@1@@0) (= inline$$CastU128$0$dst@1@@0 val@@0))) (and (=> (= (ControlFlow 0 23864) 24788) inline$$FixedPoint32_divide_u64_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 23864) 24031) inline$$FixedPoint32_divide_u64_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$CastU128$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 23850) (- 0 31972)) true) (and (=> (= (ControlFlow 0 23850) 23914) inline$$CastU128$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 23850) 23864) inline$$CastU128$0$anon3_Else_correct@@0)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon47_Then_correct  (=> (and (|b#$Boolean| inline$$FixedPoint32_divide_u64_$def_verify$0$$t12@1) (= (ControlFlow 0 23922) 23850)) inline$$CastU128$0$Entry_correct@@0)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon12_correct  (=> (and (= $abort_code@9@@0 $abort_code@2@@0) (= (ControlFlow 0 23765) 23771)) inline$$FixedPoint32_divide_u64_$def_verify$0$Abort_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 23763) 23765)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon12_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 23779) 23765) inline$$FixedPoint32_divide_u64_$def_verify$0$anon12_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon47_Else_correct  (=> (and (not (|b#$Boolean| inline$$FixedPoint32_divide_u64_$def_verify$0$$t12@1)) (= $abort_code@2@@0 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 23757) 23779) inline$$FixedPoint32_divide_u64_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 23757) 23763) inline$$FixedPoint32_divide_u64_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon45_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 23745) 23922) inline$$FixedPoint32_divide_u64_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 23745) 23757) inline$$FixedPoint32_divide_u64_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon4$3_correct  (=> (and (= inline$$FixedPoint32_divide_u64_$def_verify$0$$t11@1 ($Integer 0)) (= inline$$FixedPoint32_divide_u64_$def_verify$0$$t12@1 ($Boolean  (not ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1 inline$$FixedPoint32_divide_u64_$def_verify$0$$t11@1))))) (=> (and (and (and (= inline$$FixedPoint32_divide_u64_$def_verify$0$$t13@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0)) (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 23739) 24808) inline$$FixedPoint32_divide_u64_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 23739) 23745) inline$$FixedPoint32_divide_u64_$def_verify$0$anon45_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value)) (= (ControlFlow 0 23713) 23739)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon4$3_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 23603) 23713)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 24832) 23713) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon43_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 23595) 24832) inline$$FixedPoint32_divide_u64_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 23595) 23603) inline$$FixedPoint32_divide_u64_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon43_Then_correct  (and (=> (= (ControlFlow 0 24840) 24832) inline$$FixedPoint32_divide_u64_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 24840) 23603) inline$$FixedPoint32_divide_u64_$def_verify$0$anon44_Else_correct))))
(let ((inline$$FixedPoint32_divide_u64_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 23589) 24840) inline$$FixedPoint32_divide_u64_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 23589) 23595) inline$$FixedPoint32_divide_u64_$def_verify$0$anon43_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr))) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 24846) 23589)) inline$$FixedPoint32_divide_u64_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and (and ((_ is $Integer) val@@0) (>= (|i#$Integer| val@@0) 0)) (<= (|i#$Integer| val@@0) $MAX_U64)) (=> (and (and (and (and (and ((_ is $Vector) divisor) (let ((va@@9 (|v#$Vector| divisor)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| divisor)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| divisor)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) (= (ControlFlow 0 22875) 24846)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 31168) 22875) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(exit)
