(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $A_S () T@$TypeName)
(declare-fun $B_T () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $A_S_x () Int)
(declare-fun $A_S_type_value () T@$TypeValue)
(declare-fun $B_T_x () Int)
(declare-fun $B_T_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $A_S $B_T)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $A_S_x 0))
(assert (= $A_S_type_value ($StructType $A_S $EmptyTypeValueArray)))
(assert (= $B_T_x 0))
(assert (= $B_T_type_value ($StructType $B_T $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $A_S_$memory () T@$Memory)
(declare-fun addr () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $A_S_$memory@0 () T@$Memory)
(declare-fun $abort_flag@0 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$A_mutate_at_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$A_mutate_at_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$A_mutate_at_$def_verify$0$$A_S_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun $A_S_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 24155) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 16221) (- 0 24964)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) $abort_flag@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) $abort_flag@1) (and (=> (= (ControlFlow 0 16221) (- 0 24982)) (=> $abort_flag@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))))) (=> (=> $abort_flag@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr)))))))) (=> (= (ControlFlow 0 16221) (- 0 25000)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) $A_S_x) ($Integer 2))))))))))))
(let ((inline$$A_mutate_at_$def_verify$0$anon5_correct  (=> (= $A_S_$memory@0 $A_S_$memory) (=> (and (= $abort_flag@1 true) (= (ControlFlow 0 16199) 16221)) anon0$2_correct))))
(let ((inline$$A_mutate_at_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 16195) 16199)) inline$$A_mutate_at_$def_verify$0$anon5_correct)))
(let ((inline$$A_mutate_at_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 16207) 16199) inline$$A_mutate_at_$def_verify$0$anon5_correct)))
(let ((inline$$A_mutate_at_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 16189) 16207) inline$$A_mutate_at_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 16189) 16195) inline$$A_mutate_at_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$A_mutate_at_$def_verify$0$anon8$2_correct  (=> (= $A_S_$memory@0 |inline$$WritebackToGlobal$0$m'@2|) (=> (and (= $abort_flag@1 $abort_flag@0) (= (ControlFlow 0 16175) 16221)) anon0$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $A_S_$memory) (= (ControlFlow 0 16113) 16175)) inline$$A_mutate_at_$def_verify$0$anon8$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $A_S_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 16167) 16175))) inline$$A_mutate_at_$def_verify$0$anon8$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 16103) 16167) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 16103) 16113) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 15925) 16103)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 15981) 16103))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 15889) 15981) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 15889) 15925) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$A_mutate_at_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 15752) 15889)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$A_mutate_at_$def_verify$0$anon12_Then_correct  (=> (and (= inline$$A_mutate_at_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 16185) 15889)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) inline$$A_mutate_at_$def_verify$0$$t3@1)) (and (=> (= (ControlFlow 0 15738) 16185) inline$$A_mutate_at_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 15738) 15752) inline$$A_mutate_at_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $A_S_x) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $A_S_x))) (= (ControlFlow 0 15679) 15738))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$A_mutate_at_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0) (=> (and (= inline$$A_mutate_at_$def_verify$0$$t3@1 ($Integer 2)) (= (ControlFlow 0 15685) 15679)) inline$$BorrowField$0$anon0_correct))))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 15545) 16189) inline$$A_mutate_at_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 15545) 15685) inline$$A_mutate_at_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 15543) 15545)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)))) (and (= $abort_flag@0 false) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 15491) 16189) inline$$A_mutate_at_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 15491) 15685) inline$$A_mutate_at_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 15461) 15543) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 15461) 15491) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 15455) (- 0 24490)) true) (=> (= (ControlFlow 0 15455) 15461) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$A_mutate_at_$def_verify$0$anon2$1_correct  (and (=> (= (ControlFlow 0 15551) (- 0 24474)) (|Select_[$TypeValueArray,$int]$bool| inline$$A_mutate_at_$def_verify$0$$A_S_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$A_mutate_at_$def_verify$0$$A_S_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr)) (=> (= (ControlFlow 0 15551) 15455) inline$$BorrowGlobal$0$Entry_correct)))))
(let ((inline$$A_mutate_at_$def_verify$0$anon2_correct  (=> (and (= inline$$A_mutate_at_$def_verify$0$$A_S_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| addr) true)) (= (ControlFlow 0 15344) 15551)) inline$$A_mutate_at_$def_verify$0$anon2$1_correct)))
(let ((inline$$A_mutate_at_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 15296) 15344)) inline$$A_mutate_at_$def_verify$0$anon2_correct)))
(let ((inline$$A_mutate_at_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 16215) 15344) inline$$A_mutate_at_$def_verify$0$anon2_correct)))
(let ((inline$$A_mutate_at_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15290) 16215) inline$$A_mutate_at_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 15290) 15296) inline$$A_mutate_at_$def_verify$0$anon9_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr))) $A_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr))) $A_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr))) $A_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 16219) 15290)) inline$$A_mutate_at_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 15033) 16219)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| $A_S_$CallerDomain $EmptyTypeValueArray (|a#$Address| addr)) (= (ControlFlow 0 24155) 15033)) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun addr@@0 () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$A_read_at_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$A_read_at_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 25039) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 17031) (- 0 25436)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))))))) $abort_flag@1@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))))))) $abort_flag@1@@0) (and (=> (= (ControlFlow 0 17031) (- 0 25455)) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))))))))) (=> (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))))))) (=> (= (ControlFlow 0 17031) (- 0 25474)) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$A_read_at_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $A_S_x))))))))))))
(let ((inline$$A_read_at_$def_verify$0$anon5_correct  (=> (and (and (= inline$$A_read_at_$def_verify$0$$ret0@1 $Error) (= inline$$A_read_at_$def_verify$0$$ret0@2 inline$$A_read_at_$def_verify$0$$ret0@1)) (and (= $abort_flag@1@@0 true) (= (ControlFlow 0 17007) 17031))) anon0$2_correct@@0)))
(let ((inline$$A_read_at_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 17001) 17007)) inline$$A_read_at_$def_verify$0$anon5_correct)))
(let ((inline$$A_read_at_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 17015) 17007) inline$$A_read_at_$def_verify$0$anon5_correct)))
(let ((inline$$A_read_at_$def_verify$0$anon12_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 16995) 17015) inline$$A_read_at_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 16995) 17001) inline$$A_read_at_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$A_read_at_$def_verify$0$anon10_correct  (=> (= inline$$A_read_at_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1) (=> (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= (ControlFlow 0 16975) 17031)) anon0$2_correct@@0))))
(let ((inline$$A_read_at_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 16973) 16975)) inline$$A_read_at_$def_verify$0$anon10_correct)))
(let ((inline$$A_read_at_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 16983) 16975) inline$$A_read_at_$def_verify$0$anon10_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $A_S_x)) (and (=> (= (ControlFlow 0 16957) 16983) inline$$A_read_at_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 16957) 16973) inline$$A_read_at_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$A_read_at_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 16915) 16957)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$A_read_at_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 16991) 16957) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$A_read_at_$def_verify$0$anon12_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 16909) 16991) inline$$A_read_at_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 16909) 16915) inline$$A_read_at_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@0 true) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 16895) 16995) inline$$A_read_at_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 16895) 16909) inline$$A_read_at_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 16893) 16895)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (and (= $abort_flag@0@@0 false) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 16841) 16995) inline$$A_read_at_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 16841) 16909) inline$$A_read_at_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| addr@@0)) (and (=> (= (ControlFlow 0 16823) 16893) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 16823) 16841) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 16817) (- 0 25271)) true) (=> (= (ControlFlow 0 16817) 16823) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$A_read_at_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 16692) 16817)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$A_read_at_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 17023) 16817) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$A_read_at_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16686) 17023) inline$$A_read_at_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 16686) 16692) inline$$A_read_at_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@0))) $A_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@0))) $A_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@0))) $A_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (= (ControlFlow 0 17029) 16686)) inline$$A_read_at_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) addr@@0) (= (ControlFlow 0 16454) 17029)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 25039) 16454) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_flag@2 () Bool)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun addr2 () T@$Value)
(declare-fun $B_T_$memory () T@$Memory)
(declare-fun inline$$MoveFrom$0$a@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1| () T@$Memory)
(declare-fun addr1 () T@$Value)
(declare-fun inline$$B_move_from_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $B_T_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 25505) (let ((inline$$B_move_from_test_incorrect_$def_verify$0$Abort_correct true))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 18208) 18162)) inline$$B_move_from_test_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 18218) 18162) inline$$B_move_from_test_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 18202) 18218) inline$$B_move_from_test_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 18202) 18208) inline$$B_move_from_test_incorrect_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 18188) 18162)) inline$$B_move_from_test_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 18198) 18162) inline$$B_move_from_test_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 18182) 18198) inline$$B_move_from_test_incorrect_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 18182) 18188) inline$$B_move_from_test_incorrect_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 18154) 18162)) inline$$B_move_from_test_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 18170) 18162) inline$$B_move_from_test_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon28_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 18148) 18170) inline$$B_move_from_test_incorrect_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 18148) 18154) inline$$B_move_from_test_incorrect_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon30_Else_correct true))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon30_Then_correct true))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon28_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 18124) (- 0 26338)) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 call3formal@$ret0@0@@0)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 18124) 18144) inline$$B_move_from_test_incorrect_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 18124) 18134) inline$$B_move_from_test_incorrect_$def_verify$0$anon30_Else_correct)))))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon14$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2))))))) $abort_flag@2) (=> (and (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64)) (and (=> (= (ControlFlow 0 18076) 18148) inline$$B_move_from_test_incorrect_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 18076) 18124) inline$$B_move_from_test_incorrect_$def_verify$0$anon28_Else_correct)))))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 18040) 18076)) inline$$B_move_from_test_incorrect_$def_verify$0$anon14$1_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 18178) 18076) inline$$B_move_from_test_incorrect_$def_verify$0$anon14$1_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon25_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 18034) 18178) inline$$B_move_from_test_incorrect_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 18034) 18040) inline$$B_move_from_test_incorrect_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct  (=> (= $abort_flag@1@@1 true) (and (=> (= (ControlFlow 0 18018) 18182) inline$$B_move_from_test_incorrect_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 18018) 18034) inline$$B_move_from_test_incorrect_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1)) (= (ControlFlow 0 18016) 18018)) inline$$MoveFrom$0$anon3_Then$1_correct)))
(let ((inline$$MoveFrom$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1) (= inline$$MoveFrom$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1))) (and (= |inline$$MoveFrom$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1 $Error))) (= $abort_flag@1@@1 $abort_flag@0@@1))) (and (=> (= (ControlFlow 0 17964) 18182) inline$$B_move_from_test_incorrect_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 17964) 18034) inline$$B_move_from_test_incorrect_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$MoveFrom$0$anon0_correct  (=> (= inline$$MoveFrom$0$a@1 (|a#$Address| addr1)) (and (=> (= (ControlFlow 0 17918) 18016) inline$$MoveFrom$0$anon3_Then_correct) (=> (= (ControlFlow 0 17918) 17964) inline$$MoveFrom$0$anon3_Else_correct)))))
(let ((inline$$MoveFrom$0$Entry_correct  (and (=> (= (ControlFlow 0 17912) (- 0 26130)) true) (=> (= (ControlFlow 0 17912) 17918) inline$$MoveFrom$0$anon0_correct))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon23_Else$1_correct  (and (=> (= (ControlFlow 0 18026) (- 0 26114)) (|Select_[$TypeValueArray,$int]$bool| inline$$B_move_from_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$B_move_from_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr1)) (=> (= (ControlFlow 0 18026) 17912) inline$$MoveFrom$0$Entry_correct)))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 17782) 18026)) inline$$B_move_from_test_incorrect_$def_verify$0$anon23_Else$1_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon4$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2))))))) $abort_flag@0@@1) (=> (and (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64)) (and (=> (= (ControlFlow 0 17744) 18202) inline$$B_move_from_test_incorrect_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 17744) 17782) inline$$B_move_from_test_incorrect_$def_verify$0$anon23_Else_correct)))))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon4_correct  (=> (and (= inline$$B_move_from_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| addr2) true)) (= (ControlFlow 0 17674) 17744)) inline$$B_move_from_test_incorrect_$def_verify$0$anon4$3_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 17626) 17674)) inline$$B_move_from_test_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 18226) 17674) inline$$B_move_from_test_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17618) 18226) inline$$B_move_from_test_incorrect_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17618) 17626) inline$$B_move_from_test_incorrect_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 18234) 18226) inline$$B_move_from_test_incorrect_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 18234) 17626) inline$$B_move_from_test_incorrect_$def_verify$0$anon22_Else_correct))))
(let ((inline$$B_move_from_test_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17612) 18234) inline$$B_move_from_test_incorrect_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17612) 17618) inline$$B_move_from_test_incorrect_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@1))) $A_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@1))) $A_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@1))) $A_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (=> (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@2))) $B_T_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@2))) $B_T_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@2))) $B_T_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (= (ControlFlow 0 18240) 17612)) inline$$B_move_from_test_incorrect_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> ((_ is $Address) addr1) (=> (and ((_ is $Address) addr2) (= (ControlFlow 0 17154) 18240)) anon0$1_correct@@1))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (and (|Select_[$TypeValueArray,$int]$bool| $B_T_$CallerDomain $EmptyTypeValueArray (|a#$Address| addr2)) (= (ControlFlow 0 25505) 17154)) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun addr2@@0 () T@$Value)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$B_T_pack$0$$struct@1 () T@$Value)
(declare-fun account () T@$Value)
(declare-fun inline$$B_move_to_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$B_move_to_test_incorrect_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $B_T_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26422) (let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon20_Else_correct true))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon20_Then_correct true))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 19637) 19653) inline$$B_move_to_test_incorrect_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 19637) 19643) inline$$B_move_to_test_incorrect_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon22_Else_correct true))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon22_Then_correct true))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 19617) 19633) inline$$B_move_to_test_incorrect_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 19617) 19623) inline$$B_move_to_test_incorrect_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon24_Else_correct true))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon24_Then_correct true))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon23_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 19593) 19613) inline$$B_move_to_test_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 19593) 19599) inline$$B_move_to_test_incorrect_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@2@@0) (= (ControlFlow 0 19589) (- 0 27339))) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 call3formal@$ret0@0@@2))))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon21_Else$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@0))))))) $abort_flag@2@@0) (=> (and (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@0)))))))) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@0)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64)) (and (=> (= (ControlFlow 0 19573) 19593) inline$$B_move_to_test_incorrect_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 19573) 19589) inline$$B_move_to_test_incorrect_$def_verify$0$anon23_Else_correct)))))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon21_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 19571) 19573)) inline$$B_move_to_test_incorrect_$def_verify$0$anon21_Else$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@1@@2 true) (and (=> (= (ControlFlow 0 19517) 19617) inline$$B_move_to_test_incorrect_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 19517) 19571) inline$$B_move_to_test_incorrect_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 19515) 19517)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$B_T_pack$0$$struct@1))) (= $abort_flag@1@@2 $abort_flag@0@@2)) (and (=> (= (ControlFlow 0 19465) 19617) inline$$B_move_to_test_incorrect_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 19465) 19571) inline$$B_move_to_test_incorrect_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account)) (and (=> (= (ControlFlow 0 19523) 19515) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 19523) 19465) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 19311) (- 0 27148)) true) (=> (= (ControlFlow 0 19311) 19523) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Else$2_correct  (and (=> (= (ControlFlow 0 19531) (- 0 27113)) (|Select_[$TypeValueArray,$int]$bool| inline$$B_move_to_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| account))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$B_move_to_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| account)) (=> (= (ControlFlow 0 19531) 19311) inline$$Signer_borrow_address$0$Entry_correct)))))
(let ((inline$$B_T_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 19185) 19531)) inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Else$2_correct)))
(let ((inline$$B_T_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 19191) 19531) inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Else$2_correct)))
(let ((inline$$B_T_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 19179) 19191) inline$$B_T_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 19179) 19185) inline$$B_T_pack$0$anon4_Else_correct)))))
(let ((inline$$B_T_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 19171) 19531)) inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Else$2_correct)))
(let ((inline$$B_T_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$B_move_to_test_incorrect_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$B_move_to_test_incorrect_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$B_move_to_test_incorrect_$def_verify$0$$t7@1) $MAX_U64)) (= inline$$B_T_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$B_move_to_test_incorrect_$def_verify$0$$t7@1) 1)))) (and (=> (= (ControlFlow 0 19163) 19179) inline$$B_T_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 19163) 19171) inline$$B_T_pack$0$anon3_Else_correct)))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Else$1_correct  (=> (and (= inline$$B_move_to_test_incorrect_$def_verify$0$$t7@1 ($Integer 2)) (= (ControlFlow 0 19197) 19163)) inline$$B_T_pack$0$anon0_correct)))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 19033) 19197)) inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Else$1_correct)))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon4$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@0))))))) $abort_flag@0@@2) (=> (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@0)))))))) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@0)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64)) (and (=> (= (ControlFlow 0 18995) 19637) inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 18995) 19033) inline$$B_move_to_test_incorrect_$def_verify$0$anon19_Else_correct)))))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon4_correct  (=> (and (= inline$$B_move_to_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| addr2@@0) true)) (= (ControlFlow 0 18925) 18995)) inline$$B_move_to_test_incorrect_$def_verify$0$anon4$3_correct)))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 18877) 18925)) inline$$B_move_to_test_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 19661) 18925) inline$$B_move_to_test_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18869) 19661) inline$$B_move_to_test_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 18869) 18877) inline$$B_move_to_test_incorrect_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 19669) 19661) inline$$B_move_to_test_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 19669) 18877) inline$$B_move_to_test_incorrect_$def_verify$0$anon18_Else_correct))))
(let ((inline$$B_move_to_test_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18863) 19669) inline$$B_move_to_test_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 18863) 18869) inline$$B_move_to_test_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $A_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $A_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $A_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (=> (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@4))) $B_T_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@4))) $B_T_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@4))) $B_T_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (= (ControlFlow 0 19673) 18863)) inline$$B_move_to_test_incorrect_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> ((_ is $Address) account) (=> (and ((_ is $Address) addr2@@0) (= (ControlFlow 0 18454) 19673)) anon0$1_correct@@2))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (and (|Select_[$TypeValueArray,$int]$bool| $B_T_$CallerDomain@@0 $EmptyTypeValueArray (|a#$Address| addr2@@0)) (= (ControlFlow 0 26422) 18454)) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun $A_S_$memory@0@@0 () T@$Memory)
(declare-fun addr2@@1 () T@$Value)
(declare-fun inline$$B_mutate_S_test1_incorrect_$def_verify$0$$A_S_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun addr1@@0 () T@$Value)
(declare-fun $A_S_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27390) (let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon20_Else_correct true))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon20_Then_correct true))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 20532) 20548) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 20532) 20538) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon22_Else_correct true))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon22_Then_correct true))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 20512) 20528) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 20512) 20518) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon24_Else_correct true))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon24_Then_correct true))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon23_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 20488) 20508) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 20488) 20494) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 20484) (- 0 28327))) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 call3formal@$ret0@0@@4))))))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon21_Else$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr2@@1))))))) $abort_flag@2@@1) (=> (and (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr2@@1)))))))) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr2@@1)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64)) (and (=> (= (ControlFlow 0 20468) 20488) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 20468) 20484) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon23_Else_correct)))))))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon21_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 20466) 20468)) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon21_Else$1_correct)))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon19_Else$1_correct  (and (=> (= (ControlFlow 0 20428) (- 0 28101)) (|Select_[$TypeValueArray,$int]$bool| inline$$B_mutate_S_test1_incorrect_$def_verify$0$$A_S_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr1@@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$B_mutate_S_test1_incorrect_$def_verify$0$$A_S_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr1@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0))))))) $abort_flag@1@@3) (=> (and (and (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))))))) (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $A_S_x) ($Integer 2)))))) (and (= (|contents#$Memory| $A_S_$memory@0@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (= (|domain#$Memory| $A_S_$memory@0@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@0)))))) (and (=> (= (ControlFlow 0 20428) 20512) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 20428) 20466) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon21_Else_correct))))))))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon19_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 20426) 20428)) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon19_Else$1_correct)))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon4$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@1))))))) $abort_flag@0@@3) (=> (and (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@1)))))))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@1)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64)) (and (=> (= (ControlFlow 0 20388) 20532) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 20388) 20426) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon19_Else_correct)))))))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon4_correct  (=> (and (= inline$$B_mutate_S_test1_incorrect_$def_verify$0$$A_S_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| addr2@@1) true)) (= (ControlFlow 0 20318) 20388)) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon4$3_correct)))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 20270) 20318)) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 20556) 20318) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 20262) 20556) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 20262) 20270) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 20564) 20556) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 20564) 20270) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon18_Else_correct))))
(let ((inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 20256) 20564) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 20256) 20262) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@5))) $A_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@5))) $A_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@5))) $A_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (=> (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified addr1@@0 addr2@@1)))) (= (ControlFlow 0 20568) 20256)) inline$$B_mutate_S_test1_incorrect_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@3  (=> ((_ is $Address) addr1@@0) (=> (and ((_ is $Address) addr2@@1) (= (ControlFlow 0 19897) 20568)) anon0$1_correct@@3))))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (and (|Select_[$TypeValueArray,$int]$bool| $A_S_$CallerDomain@@0 $EmptyTypeValueArray (|a#$Address| addr2@@1)) (= (ControlFlow 0 27390) 19897)) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun $A_S_$memory@0@@1 () T@$Memory)
(declare-fun addr@@1 () T@$Value)
(declare-fun inline$$B_mutate_S_test2_incorrect_$def_verify$0$$A_S_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $A_S_$CallerDomain@@1 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28376) (let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon17_Else_correct true))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon17_Then_correct true))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon16_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 21258) 21274) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 21258) 21264) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon19_Else_correct true))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon19_Then_correct true))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon18_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 21238) 21254) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 21238) 21244) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon21_Else_correct true))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon21_Then_correct true))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon20_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 21214) 21234) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 21214) 21220) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@2@@2) (= (ControlFlow 0 21210) (- 0 29261))) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 call3formal@$ret0@0@@6))))))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon18_Else$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr@@1))))))) $abort_flag@2@@2) (=> (and (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr@@1)))))))) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64)) (and (=> (= (ControlFlow 0 21194) 21214) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 21194) 21210) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon20_Else_correct)))))))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@1@@4) (= (ControlFlow 0 21192) 21194)) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon18_Else$1_correct)))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon16_Else$1_correct  (and (=> (= (ControlFlow 0 21154) (- 0 29035)) (|Select_[$TypeValueArray,$int]$bool| inline$$B_mutate_S_test2_incorrect_$def_verify$0$$A_S_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr@@1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$B_mutate_S_test2_incorrect_$def_verify$0$$A_S_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))) $abort_flag@1@@4) (=> (and (and (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))))))) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $A_S_x) ($Integer 2)))))) (and (= (|contents#$Memory| $A_S_$memory@0@@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (= (|domain#$Memory| $A_S_$memory@0@@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr@@1)))))) (and (=> (= (ControlFlow 0 21154) 21238) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 21154) 21192) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon18_Else_correct))))))))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@0@@4) (= (ControlFlow 0 21152) 21154)) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon16_Else$1_correct)))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon2$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))) $abort_flag@0@@4) (=> (and (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))))))) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64)) (and (=> (= (ControlFlow 0 21114) 21258) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 21114) 21152) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon16_Else_correct)))))))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon2_correct  (=> (and (= inline$$B_mutate_S_test2_incorrect_$def_verify$0$$A_S_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| addr@@1) true)) (= (ControlFlow 0 21078) 21114)) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon2$2_correct)))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 21030) 21078)) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon2_correct)))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 21282) 21078) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon2_correct)))
(let ((inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 21024) 21282) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 21024) 21030) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $A_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $A_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $A_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (= (ControlFlow 0 21286) 21024)) inline$$B_mutate_S_test2_incorrect_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) addr@@1) (= (ControlFlow 0 20715) 21286)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (and (|Select_[$TypeValueArray,$int]$bool| $A_S_$CallerDomain@@1 $EmptyTypeValueArray (|a#$Address| addr@@1)) (= (ControlFlow 0 28376) 20715)) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun addr2@@2 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$B_mutate_at_test_incorrect_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$B_mutate_at_test_incorrect_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun addr1@@1 () T@$Value)
(declare-fun inline$$B_mutate_at_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $B_T_$CallerDomain@@1 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29311) (let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon22_Else_correct true))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon22_Then_correct true))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon21_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 23007) 23023) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 23007) 23013) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon24_Else_correct true))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon24_Then_correct true))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon23_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 22987) 23003) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 22987) 22993) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon27_Else_correct true))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon27_Then_correct true))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon26_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 22953) 22973) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 22953) 22959) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@2@@3) (= (ControlFlow 0 22949) (- 0 30517))) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 call3formal@$ret0@0@@8))))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon14$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@2))))))) $abort_flag@2@@3) (=> (and (=> $abort_flag@2@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@2)))))))) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@2)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64)) (and (=> (= (ControlFlow 0 22933) 22953) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 22933) 22949) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon26_Else_correct)))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (= (ControlFlow 0 22837) 22933)) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon14$3_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)))) (and (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $B_T_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0))) (= (ControlFlow 0 22891) 22933))) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon14$3_correct))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 22827) 22891) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 22827) 22837) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 22649) 22827)) inline$$WritebackToGlobal$0$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 22705) 22827))) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 22613) 22705) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 22613) 22649) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 22476) 22613)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon25_Then_correct  (=> (and (= inline$$B_mutate_at_test_incorrect_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 22983) 22613)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) inline$$B_mutate_at_test_incorrect_$def_verify$0$$t9@1)) (and (=> (= (ControlFlow 0 22462) 22983) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 22462) 22476) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $B_T_x) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $B_T_x))) (= (ControlFlow 0 22403) 22462))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon23_Else_correct  (=> (not $abort_flag@1@@5) (=> (and (= inline$$B_mutate_at_test_incorrect_$def_verify$0$$t9@1 ($Integer 2)) (= (ControlFlow 0 22285) 22403)) inline$$BorrowField$0$anon0_correct@@0))))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@1@@5 true) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 22235) 22987) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 22235) 22285) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 22233) 22235)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)))) (and (= $abort_flag@1@@5 $abort_flag@0@@5) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 22181) 22987) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 22181) 22285) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| addr1@@1)) (and (=> (= (ControlFlow 0 22151) 22233) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 22151) 22181) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 22145) (- 0 29983)) true) (=> (= (ControlFlow 0 22145) 22151) inline$$BorrowGlobal$0$anon0_correct@@0))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon21_Else$1_correct  (and (=> (= (ControlFlow 0 22241) (- 0 29967)) (|Select_[$TypeValueArray,$int]$bool| inline$$B_mutate_at_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr1@@1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$B_mutate_at_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr1@@1)) (=> (= (ControlFlow 0 22241) 22145) inline$$BorrowGlobal$0$Entry_correct@@0)))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon21_Else_correct  (=> (and (not $abort_flag@0@@5) (= (ControlFlow 0 22034) 22241)) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon21_Else$1_correct)))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon4$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@2))))))) $abort_flag@0@@5) (=> (and (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@2)))))))) (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray (|a#$Address| addr2@@2)))) $A_S_x)))))) (=> (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64)) (and (=> (= (ControlFlow 0 21996) 23007) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 21996) 22034) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon21_Else_correct)))))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon4_correct  (=> (and (= inline$$B_mutate_at_test_incorrect_$def_verify$0$$B_T_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| addr2@@2) true)) (= (ControlFlow 0 21926) 21996)) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon4$3_correct)))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 21878) 21926)) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 23031) 21926) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 21870) 23031) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 21870) 21878) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 23039) 23031) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 23039) 21878) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon20_Else_correct))))
(let ((inline$$B_mutate_at_test_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 21864) 23039) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 21864) 21870) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@7))) $A_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@7))) $A_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@7))) $A_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $A_S_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (=> (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@8))) $B_T_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@8))) $B_T_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@8))) $B_T_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $B_T_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (= (ControlFlow 0 23043) 21864)) inline$$B_mutate_at_test_incorrect_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@5  (=> ((_ is $Address) addr1@@1) (=> (and ((_ is $Address) addr2@@2) (= (ControlFlow 0 21416) 23043)) anon0$1_correct@@5))))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (and (|Select_[$TypeValueArray,$int]$bool| $B_T_$CallerDomain@@1 $EmptyTypeValueArray (|a#$Address| addr2@@2)) (= (ControlFlow 0 29311) 21416)) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
