(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $Offer_Offer_offered () Int)
(declare-fun $Offer_Offer_for () Int)
(declare-fun $Offer_Offer_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Offer_Offer () T@$TypeName)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $Offer_Offer_offered 0))
(assert (= $Offer_Offer_for 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Offer_Offer_type_value $tv0) ($StructType $Offer_Offer ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Offer_Offer_type_value $tv0))
)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $Offer_Offer_$memory () T@$Memory)
(declare-fun $tv0@@0 () T@$TypeValue)
(declare-fun offer_address () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun inline$$Offer_address_of_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$Offer_address_of_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$Offer_address_of_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$Offer_address_of_$def_verify$0$$t5@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 22698) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 17966) (- 0 23700)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| offer_address))))))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| offer_address))))))) $abort_flag@2) (and (=> (= (ControlFlow 0 17966) (- 0 23731)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| offer_address))))))))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| offer_address)))))))) (and (=> (= (ControlFlow 0 17966) (- 0 23762)) (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| offer_address))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| offer_address))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 17966) (- 0 23804)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Offer_address_of_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| offer_address)))) $Offer_Offer_for)))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Offer_address_of_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| offer_address)))) $Offer_Offer_for))))) (and (=> (= (ControlFlow 0 17966) (- 0 23840)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (forall ((ty T@$Value) )  (=> ((_ is $Type) ty) (|b#$Boolean| ($Boolean (forall ((addr T@$Value) )  (=> ((_ is $Address) addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty)) 1) (|a#$Address| addr))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty)) 1) (|a#$Address| addr)))))))))))))))))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (forall ((ty@@0 T@$Value) )  (=> ((_ is $Type) ty@@0) (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@0)) 1) (|a#$Address| addr@@0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@0)) 1) (|a#$Address| addr@@0))))))))))))))))))) (=> (= (ControlFlow 0 17966) (- 0 23937)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (forall ((ty@@1 T@$Value) )  (=> ((_ is $Type) ty@@1) (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@1)) 1) (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@1)) 1) (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@1)) 1) (|a#$Address| addr@@1)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@1)) 1) (|a#$Address| addr@@1)))))))))))))))))))))))))))))))))
(let ((inline$$Offer_address_of_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@5 $abort_code@3) (= inline$$Offer_address_of_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1)) (and (= $abort_flag@2 $abort_flag@1) (= (ControlFlow 0 17902) 17966))) anon0$2_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 17900) 17902)) inline$$Offer_address_of_$def_verify$0$anon16_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 17910) 17902) inline$$Offer_address_of_$def_verify$0$anon16_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $Offer_Offer_for)) (and (=> (= (ControlFlow 0 17884) 17910) inline$$Offer_address_of_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 17884) 17900) inline$$Offer_address_of_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Offer_address_of_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 17890) 17884)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$Abort_correct  (=> (= inline$$Offer_address_of_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@5 $abort_code@4) (= inline$$Offer_address_of_$def_verify$0$$ret0@2 inline$$Offer_address_of_$def_verify$0$$ret0@1)) (and (= $abort_flag@2 true) (= (ControlFlow 0 17637) 17966))) anon0$2_correct))))
(let ((inline$$Offer_address_of_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 17942) 17637)) inline$$Offer_address_of_$def_verify$0$Abort_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 17940) 17942)) inline$$Offer_address_of_$def_verify$0$anon5_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 17950) 17942) inline$$Offer_address_of_$def_verify$0$anon5_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 17934) 17950) inline$$Offer_address_of_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 17934) 17940) inline$$Offer_address_of_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Offer_address_of_$def_verify$0$anon13_correct  (=> (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 17922) 17637)) inline$$Offer_address_of_$def_verify$0$Abort_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 17920) 17922)) inline$$Offer_address_of_$def_verify$0$anon13_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 17930) 17922) inline$$Offer_address_of_$def_verify$0$anon13_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 17914) 17930) inline$$Offer_address_of_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 17914) 17920) inline$$Offer_address_of_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@1 true) (=> (and (= $abort_code@3 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 17830) 17914) inline$$Offer_address_of_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17830) 17890) inline$$Offer_address_of_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 17828) 17830)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) inline$$GetGlobal$0$ta@0 (|a#$Address| offer_address))) (= $abort_flag@1 $abort_flag@0)) (and (= $abort_code@3 $abort_code@1) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 17776) 17914) inline$$Offer_address_of_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17776) 17890) inline$$Offer_address_of_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| offer_address)) (and (=> (= (ControlFlow 0 17758) 17828) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 17758) 17776) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (=> (= inline$$GetGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1)) (and (=> (= (ControlFlow 0 17752) (- 0 23506)) true) (=> (= (ControlFlow 0 17752) 17758) inline$$GetGlobal$0$anon0_correct)))))
(let ((inline$$Offer_address_of_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| inline$$Offer_address_of_$def_verify$0$$t4@1) (= (ControlFlow 0 17836) 17752)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon10_correct  (=> (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 17631) 17637)) inline$$Offer_address_of_$def_verify$0$Abort_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 17629) 17631)) inline$$Offer_address_of_$def_verify$0$anon10_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 17645) 17631) inline$$Offer_address_of_$def_verify$0$anon10_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$Offer_address_of_$def_verify$0$$t4@1)) (= $abort_code@2 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 17623) 17645) inline$$Offer_address_of_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17623) 17629) inline$$Offer_address_of_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Offer_address_of_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 17611) 17836) inline$$Offer_address_of_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17611) 17623) inline$$Offer_address_of_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Offer_address_of_$def_verify$0$anon2$1_correct  (=> (= inline$$Offer_address_of_$def_verify$0$$t4@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| offer_address)))) (=> (and (and (and (= inline$$Offer_address_of_$def_verify$0$$t5@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0)) (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 17605) 17934) inline$$Offer_address_of_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 17605) 17611) inline$$Offer_address_of_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$Offer_address_of_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 17545) 17605)) inline$$Offer_address_of_$def_verify$0$anon2$1_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 17958) 17605) inline$$Offer_address_of_$def_verify$0$anon2$1_correct)))
(let ((inline$$Offer_address_of_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17539) 17958) inline$$Offer_address_of_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 17539) 17545) inline$$Offer_address_of_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $Offer_Offer_for))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))
)) (= (ControlFlow 0 17964) 17539)) inline$$Offer_address_of_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and ((_ is $Address) offer_address) (= (ControlFlow 0 17158) 17964)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 22698) 17158) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@1 () T@$TypeValue)
(declare-fun account () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun $Offer_Offer_$memory@1 () T@$Memory)
(declare-fun offered () T@$Value)
(declare-fun for () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $Offer_Offer_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$Offer_Offer_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Offer_create_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Offer_create_$def_verify$0$$t9@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 24093) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 19454) (- 0 25382)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account)))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account)))) $abort_flag@3) (and (=> (= (ControlFlow 0 19454) (- 0 25408)) (=> $abort_flag@3 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account)))))) (=> (=> $abort_flag@3 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account))))) (and (=> (= (ControlFlow 0 19454) (- 0 25434)) (=> $abort_flag@3 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account)))) (= $abort_code@6 (|i#$Integer| ($Integer 6)))))) (=> (=> $abort_flag@3 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account)))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (=> (= (ControlFlow 0 19454) (- 0 25471)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account)))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account))))) (and (=> (= (ControlFlow 0 19454) (- 0 25499)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account)) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 offered) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 offered) (+ len@@1 1)))) len@@0 for) (+ len@@0 1))))))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| account)) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 offered) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 offered) (+ len@@1 1)))) len@@0 for) (+ len@@0 1)))))))) (=> (= (ControlFlow 0 19454) (- 0 25543)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (forall ((ty@@2 T@$Value) )  (=> ((_ is $Type) ty@@2) (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@2)) 1) (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@2)) 1) (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@2)) 1) (|a#$Address| addr@@2)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@2)) 1) (|a#$Address| addr@@2)))))))))))))))))))))))))))))))))
(let ((inline$$Offer_create_$def_verify$0$anon32_Else_correct  (=> (not $abort_flag@2@@0) (=> (and (and (= $abort_code@6 $abort_code@4@@0) (= $abort_flag@3 $abort_flag@2@@0)) (and (= $Offer_Offer_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 19364) 19454))) anon0$2_correct@@0))))
(let ((inline$$Offer_create_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@6 $abort_code@5@@0) (= $abort_flag@3 true)) (and (= $Offer_Offer_$memory@1 $Offer_Offer_$memory@0) (= (ControlFlow 0 18825) 19454))) anon0$2_correct@@0)))
(let ((inline$$Offer_create_$def_verify$0$anon9_correct  (=> (= $abort_code@5@@0 $abort_code@1@@0) (=> (and (= $Offer_Offer_$memory@0 $Offer_Offer_$memory) (= (ControlFlow 0 19416) 18825)) inline$$Offer_create_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_create_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 19414) 19416)) inline$$Offer_create_$def_verify$0$anon9_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 19424) 19416) inline$$Offer_create_$def_verify$0$anon9_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon26_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 19408) 19424) inline$$Offer_create_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 19408) 19414) inline$$Offer_create_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Offer_create_$def_verify$0$anon13_correct  (=> (= $abort_code@5@@0 $abort_code@2@@0) (=> (and (= $Offer_Offer_$memory@0 $Offer_Offer_$memory) (= (ControlFlow 0 19396) 18825)) inline$$Offer_create_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_create_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 19394) 19396)) inline$$Offer_create_$def_verify$0$anon13_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 19404) 19396) inline$$Offer_create_$def_verify$0$anon13_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon28_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 19388) 19404) inline$$Offer_create_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 19388) 19394) inline$$Offer_create_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Offer_create_$def_verify$0$anon21_correct  (=> (= $abort_code@5@@0 $abort_code@4@@0) (=> (and (= $Offer_Offer_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 19376) 18825)) inline$$Offer_create_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_create_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 19374) 19376)) inline$$Offer_create_$def_verify$0$anon21_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 19384) 19376) inline$$Offer_create_$def_verify$0$anon21_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon32_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 19368) 19384) inline$$Offer_create_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 19368) 19374) inline$$Offer_create_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@0 true) (=> (and (= $abort_code@4@@0 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 19342) 19368) inline$$Offer_create_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 19342) 19364) inline$$Offer_create_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 19340) 19342)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 inline$$Offer_Offer_pack$0$$struct@1))) (= $abort_flag@2@@0 $abort_flag@1@@0)) (and (= $abort_code@4@@0 $abort_code@2@@0) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 19290) 19368) inline$$Offer_create_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 19290) 19364) inline$$Offer_create_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account)) (and (=> (= (ControlFlow 0 19348) 19340) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 19348) 19290) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 19136) (- 0 25171)) true) (=> (= (ControlFlow 0 19136) 19348) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1)) (= (ControlFlow 0 19108) 19136)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$Offer_Offer_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 19010) 19108)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$Offer_Offer_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 19016) 19108) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$Offer_Offer_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 19004) 19016) inline$$Offer_Offer_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 19004) 19010) inline$$Offer_Offer_pack$0$anon4_Else_correct)))))
(let ((inline$$Offer_Offer_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 18996) 19108)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$Offer_Offer_pack$0$anon0_correct  (=> (and ((_ is $Address) for) (= inline$$Offer_Offer_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 offered) 1 for) 2)))) (and (=> (= (ControlFlow 0 18988) 19004) inline$$Offer_Offer_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 18988) 18996) inline$$Offer_Offer_pack$0$anon3_Else_correct)))))
(let ((inline$$Offer_create_$def_verify$0$anon30_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 19022) 18988)) inline$$Offer_Offer_pack$0$anon0_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon18_correct  (=> (= $abort_code@5@@0 $abort_code@3@@0) (=> (and (= $Offer_Offer_$memory@0 $Offer_Offer_$memory) (= (ControlFlow 0 18821) 18825)) inline$$Offer_create_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_create_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 18819) 18821)) inline$$Offer_create_$def_verify$0$anon18_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 18833) 18821) inline$$Offer_create_$def_verify$0$anon18_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon30_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@3@@0 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 18813) 18833) inline$$Offer_create_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 18813) 18819) inline$$Offer_create_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Offer_create_$def_verify$0$anon28_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 18801) 19022) inline$$Offer_create_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 18801) 18813) inline$$Offer_create_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Offer_create_$def_verify$0$anon26_Else$1_correct  (=> (and (and (and (= inline$$Offer_create_$def_verify$0$$t11@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0)) (and (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 18795) 19388) inline$$Offer_create_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 18795) 18801) inline$$Offer_create_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Offer_create_$def_verify$0$$t9@1)))) (= (ControlFlow 0 18783) 18795)) inline$$Offer_create_$def_verify$0$anon26_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 18773) (- 0 24946)) true) (=> (= (ControlFlow 0 18773) 18783) inline$$Not$0$anon0_correct))))
(let ((inline$$Offer_create_$def_verify$0$anon26_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (= inline$$Offer_create_$def_verify$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| call3formal@$ret0@0@@1)))) (= (ControlFlow 0 18789) 18773)) inline$$Not$0$Entry_correct))))
(let ((inline$$Offer_create_$def_verify$0$anon6$3_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 account)))) ((_ is $Address) call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 18715) 19408) inline$$Offer_create_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 18715) 18789) inline$$Offer_create_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Offer_create_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 18611) 18715)) inline$$Offer_create_$def_verify$0$anon6$3_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 19432) 18715) inline$$Offer_create_$def_verify$0$anon6$3_correct)))
(let ((inline$$Offer_create_$def_verify$0$anon24_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18603) 19432) inline$$Offer_create_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 18603) 18611) inline$$Offer_create_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Offer_create_$def_verify$0$anon24_Then_correct  (and (=> (= (ControlFlow 0 19440) 19432) inline$$Offer_create_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 19440) 18611) inline$$Offer_create_$def_verify$0$anon25_Else_correct))))
(let ((inline$$Offer_create_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18595) 19440) inline$$Offer_create_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 18595) 18603) inline$$Offer_create_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Offer_create_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 19448) 19440) inline$$Offer_create_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 19448) 18603) inline$$Offer_create_$def_verify$0$anon24_Else_correct))))
(let ((inline$$Offer_create_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18589) 19448) inline$$Offer_create_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 18589) 18595) inline$$Offer_create_$def_verify$0$anon23_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@0 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))) $Offer_Offer_for))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))
)) (= (ControlFlow 0 19452) 18589)) inline$$Offer_create_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> ((_ is $Address) account) (=> (and ((_ is $Address) for) (= (ControlFlow 0 18105) 19452)) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 24093) 18105) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$Offer_exists_at_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $tv0@@2 () T@$TypeValue)
(declare-fun offer_address@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 25686) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 19941) (- 0 26164)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 19941) (- 0 26173)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 19941) (- 0 26182)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Offer_exists_at_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| offer_address@@0)))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Offer_exists_at_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| offer_address@@0))))))) (and (=> (= (ControlFlow 0 19941) (- 0 26214)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((ty@@3 T@$Value) )  (=> ((_ is $Type) ty@@3) (|b#$Boolean| ($Boolean (forall ((addr@@3 T@$Value) )  (=> ((_ is $Address) addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@3)) 1) (|a#$Address| addr@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@3)) 1) (|a#$Address| addr@@3)))))))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((ty@@4 T@$Value) )  (=> ((_ is $Type) ty@@4) (|b#$Boolean| ($Boolean (forall ((addr@@4 T@$Value) )  (=> ((_ is $Address) addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@4)) 1) (|a#$Address| addr@@4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@4)) 1) (|a#$Address| addr@@4))))))))))))))))))) (=> (= (ControlFlow 0 19941) (- 0 26311)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((ty@@5 T@$Value) )  (=> ((_ is $Type) ty@@5) (|b#$Boolean| ($Boolean (forall ((addr@@5 T@$Value) )  (=> ((_ is $Address) addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@5)) 1) (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@5)) 1) (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@5)) 1) (|a#$Address| addr@@5)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@5)) 1) (|a#$Address| addr@@5)))))))))))))))))))))))))))))))
(let ((inline$$Offer_exists_at_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 19915) 19941)) anon0$2_correct@@1)))
(let ((inline$$Offer_exists_at_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 19925) 19941) anon0$2_correct@@1)))
(let ((inline$$Offer_exists_at_$def_verify$0$anon2$1_correct  (=> (= inline$$Offer_exists_at_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| offer_address@@0)))) (and (=> (= (ControlFlow 0 19909) 19925) inline$$Offer_exists_at_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 19909) 19915) inline$$Offer_exists_at_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$Offer_exists_at_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 19851) 19909)) inline$$Offer_exists_at_$def_verify$0$anon2$1_correct)))
(let ((inline$$Offer_exists_at_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 19933) 19909) inline$$Offer_exists_at_$def_verify$0$anon2$1_correct)))
(let ((inline$$Offer_exists_at_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 19845) 19933) inline$$Offer_exists_at_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 19845) 19851) inline$$Offer_exists_at_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@1 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))) $Offer_Offer_for))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))
)) (= (ControlFlow 0 19939) 19845)) inline$$Offer_exists_at_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) offer_address@@0) (= (ControlFlow 0 19663) 19939)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 25686) 19663) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@3 () T@$TypeValue)
(declare-fun offer_address@@1 () T@$Value)
(declare-fun $abort_flag@4 () Bool)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_code@8 () Int)
(declare-fun $Offer_Offer_$memory@1@@0 () T@$Memory)
(declare-fun inline$$Offer_redeem_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Offer_Offer_unpack$0$offered@1 () T@$Value)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@2| () T@$Memory)
(declare-fun |inline$$Offer_redeem_$def_verify$0$tmp#$9@2| () T@$Value)
(declare-fun inline$$Offer_redeem_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@7 () Int)
(declare-fun $Offer_Offer_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$Offer_redeem_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$Offer_redeem_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$Offer_redeem_$def_verify$0$$t18@1 () T@$Value)
(declare-fun |inline$$Offer_redeem_$def_verify$0$tmp#$9@1| () T@$Value)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$Offer_Offer_unpack$0$for@1 () T@$Value)
(declare-fun inline$$MoveFrom$0$dst@2 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveFrom$0$a@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1| () T@$Memory)
(declare-fun inline$$Offer_redeem_$def_verify$0$$t12@1 () T@$Value)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Offer_redeem_$def_verify$0$$t13@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26459) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 21649) (- 0 28092)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1))))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1))))))) $abort_flag@4) (and (=> (= (ControlFlow 0 21649) (- 0 28122)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))) $Offer_Offer_for)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 offer_address@@1))))))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))) $Offer_Offer_for)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 offer_address@@1))))))))) $abort_flag@4) (and (=> (= (ControlFlow 0 21649) (- 0 28144)) (=> $abort_flag@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))) $Offer_Offer_for)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 offer_address@@1)))))))))))) (=> (=> $abort_flag@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))) $Offer_Offer_for)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 offer_address@@1))))))))))) (and (=> (= (ControlFlow 0 21649) (- 0 28195)) (=> $abort_flag@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1))))))) (= $abort_code@8 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))) $Offer_Offer_for)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 offer_address@@1))))))))) (= $abort_code@8 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1))))))) (= $abort_code@8 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))) $Offer_Offer_for)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@0 offer_address@@1))))))))) (= $abort_code@8 (|i#$Integer| ($Integer 7)))))) (and (=> (= (ControlFlow 0 21649) (- 0 28268)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))))))) (and (=> (= (ControlFlow 0 21649) (- 0 28300)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Offer_redeem_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))) $Offer_Offer_offered)))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Offer_redeem_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))) $Offer_Offer_offered))))) (=> (= (ControlFlow 0 21649) (- 0 28335)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (forall ((ty@@6 T@$Value) )  (=> ((_ is $Type) ty@@6) (|b#$Boolean| ($Boolean (forall ((addr@@6 T@$Value) )  (=> ((_ is $Address) addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@6)) 1) (|a#$Address| addr@@6))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| ty@@6)) 1) (|a#$Address| addr@@6))))))))))))))))))))))))))))))))))
(let ((inline$$Offer_redeem_$def_verify$0$anon40_correct  (=> (= inline$$Offer_redeem_$def_verify$0$$ret0@2 inline$$Offer_Offer_unpack$0$offered@1) (=> (and (and (= $abort_code@8 $abort_code@5@@1) (= $abort_flag@4 $abort_flag@3@@0)) (and (= $Offer_Offer_$memory@1@@0 |inline$$MoveFrom$0$m'@2|) (= (ControlFlow 0 21453) 21649))) anon0$2_correct@@2))))
(let ((inline$$Offer_redeem_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 21451) 21453)) inline$$Offer_redeem_$def_verify$0$anon40_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 21461) 21453) inline$$Offer_redeem_$def_verify$0$anon40_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon58_Then_correct  (=> (|b#$Boolean| |inline$$Offer_redeem_$def_verify$0$tmp#$9@2|) (and (=> (= (ControlFlow 0 21445) 21461) inline$$Offer_redeem_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 21445) 21451) inline$$Offer_redeem_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$Abort_correct  (=> (and (= inline$$Offer_redeem_$def_verify$0$$ret0@1 $Error) (= inline$$Offer_redeem_$def_verify$0$$ret0@2 inline$$Offer_redeem_$def_verify$0$$ret0@1)) (=> (and (and (= $abort_code@8 $abort_code@7) (= $abort_flag@4 true)) (and (= $Offer_Offer_$memory@1@@0 $Offer_Offer_$memory@0@@0) (= (ControlFlow 0 20924) 21649))) anon0$2_correct@@2))))
(let ((inline$$Offer_redeem_$def_verify$0$anon7_correct  (=> (= $abort_code@7 $abort_code@1@@1) (=> (and (= $Offer_Offer_$memory@0@@0 $Offer_Offer_$memory) (= (ControlFlow 0 21617) 20924)) inline$$Offer_redeem_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_redeem_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 21615) 21617)) inline$$Offer_redeem_$def_verify$0$anon7_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 21625) 21617) inline$$Offer_redeem_$def_verify$0$anon7_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon43_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 21609) 21625) inline$$Offer_redeem_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 21609) 21615) inline$$Offer_redeem_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon15_correct  (=> (= $abort_code@7 $abort_code@3@@1) (=> (and (= $Offer_Offer_$memory@0@@0 |inline$$MoveFrom$0$m'@2|) (= (ControlFlow 0 21597) 20924)) inline$$Offer_redeem_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_redeem_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 21595) 21597)) inline$$Offer_redeem_$def_verify$0$anon15_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 21605) 21597) inline$$Offer_redeem_$def_verify$0$anon15_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon47_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 21589) 21605) inline$$Offer_redeem_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 21589) 21595) inline$$Offer_redeem_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon23_correct  (=> (= $abort_code@7 $abort_code@4@@1) (=> (and (= $Offer_Offer_$memory@0@@0 |inline$$MoveFrom$0$m'@2|) (= (ControlFlow 0 21561) 20924)) inline$$Offer_redeem_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_redeem_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 21559) 21561)) inline$$Offer_redeem_$def_verify$0$anon23_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 21569) 21561) inline$$Offer_redeem_$def_verify$0$anon23_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon51_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 21553) 21569) inline$$Offer_redeem_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 21553) 21559) inline$$Offer_redeem_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon33_correct  (=> (= $abort_code@7 $abort_code@5@@1) (=> (and (= $Offer_Offer_$memory@0@@0 |inline$$MoveFrom$0$m'@2|) (= (ControlFlow 0 21473) 20924)) inline$$Offer_redeem_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_redeem_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 21471) 21473)) inline$$Offer_redeem_$def_verify$0$anon33_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 21481) 21473) inline$$Offer_redeem_$def_verify$0$anon33_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon56_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 21465) 21481) inline$$Offer_redeem_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 21465) 21471) inline$$Offer_redeem_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon38_correct  (=> (= $abort_code@7 $abort_code@6@@0) (=> (and (= $Offer_Offer_$memory@0@@0 |inline$$MoveFrom$0$m'@2|) (= (ControlFlow 0 21429) 20924)) inline$$Offer_redeem_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_redeem_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 21427) 21429)) inline$$Offer_redeem_$def_verify$0$anon38_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 21437) 21429) inline$$Offer_redeem_$def_verify$0$anon38_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon58_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Offer_redeem_$def_verify$0$tmp#$9@2|)) (= $abort_code@6@@0 (|i#$Integer| call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 21421) 21437) inline$$Offer_redeem_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 21421) 21427) inline$$Offer_redeem_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon56_Else_correct  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 21409) 21445) inline$$Offer_redeem_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 21409) 21421) inline$$Offer_redeem_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$L5_correct  (=> (and (and (and (= inline$$Offer_redeem_$def_verify$0$$t20@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0)) (and (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 21403) 21465) inline$$Offer_redeem_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 21403) 21409) inline$$Offer_redeem_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon28_correct  (=> (and (= |inline$$Offer_redeem_$def_verify$0$tmp#$9@2| inline$$Offer_redeem_$def_verify$0$$t19@1) (= (ControlFlow 0 21541) 21403)) inline$$Offer_redeem_$def_verify$0$L5_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 21539) 21541)) inline$$Offer_redeem_$def_verify$0$anon28_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 21549) 21541) inline$$Offer_redeem_$def_verify$0$anon28_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon53_Then_correct  (=> (and (|b#$Boolean| inline$$Offer_redeem_$def_verify$0$$t18@1) (= inline$$Offer_redeem_$def_verify$0$$t19@1 ($Boolean true))) (and (=> (= (ControlFlow 0 21531) 21549) inline$$Offer_redeem_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 21531) 21539) inline$$Offer_redeem_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon30_correct  (=> (and (= |inline$$Offer_redeem_$def_verify$0$tmp#$9@2| |inline$$Offer_redeem_$def_verify$0$tmp#$9@1|) (= (ControlFlow 0 21397) 21403)) inline$$Offer_redeem_$def_verify$0$L5_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 21395) 21397)) inline$$Offer_redeem_$def_verify$0$anon30_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 21489) 21397) inline$$Offer_redeem_$def_verify$0$anon30_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon53_Else_correct  (=> (and (not (|b#$Boolean| inline$$Offer_redeem_$def_verify$0$$t18@1)) (= |inline$$Offer_redeem_$def_verify$0$tmp#$9@1| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 offer_address@@1)))) (and (=> (= (ControlFlow 0 21389) 21489) inline$$Offer_redeem_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 21389) 21395) inline$$Offer_redeem_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon51_Else_correct  (=> (and (not $abort_flag@2@@1) (= inline$$Offer_redeem_$def_verify$0$$t18@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 inline$$Offer_Offer_unpack$0$for@1)))) (and (=> (= (ControlFlow 0 21373) 21531) inline$$Offer_redeem_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 21373) 21389) inline$$Offer_redeem_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon20_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@1) (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 21359) 21553) inline$$Offer_redeem_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 21359) 21373) inline$$Offer_redeem_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 21357) 21359)) inline$$Offer_redeem_$def_verify$0$anon20_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 21577) 21359) inline$$Offer_redeem_$def_verify$0$anon20_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon49_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 21315) 21577) inline$$Offer_redeem_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 21315) 21357) inline$$Offer_redeem_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon49_Then_correct  (and (=> (= (ControlFlow 0 21585) 21577) inline$$Offer_redeem_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 21585) 21357) inline$$Offer_redeem_$def_verify$0$anon50_Else_correct))))
(let ((inline$$Offer_Offer_unpack$0$anon0_correct  (=> (and (and ((_ is $Vector) inline$$MoveFrom$0$dst@2) (= inline$$Offer_Offer_unpack$0$offered@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$MoveFrom$0$dst@2)) $Offer_Offer_offered))) (and (= inline$$Offer_Offer_unpack$0$for@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$MoveFrom$0$dst@2)) $Offer_Offer_for)) ((_ is $Address) inline$$Offer_Offer_unpack$0$for@1))) (and (=> (= (ControlFlow 0 21265) 21585) inline$$Offer_redeem_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 21265) 21315) inline$$Offer_redeem_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon47_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 21273) 21265)) inline$$Offer_Offer_unpack$0$anon0_correct)))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct  (=> (and (and (= $abort_flag@1@@1 true) (= $abort_code@3@@1 $EXEC_FAILURE_CODE)) (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@0|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@0))) (and (=> (= (ControlFlow 0 21174) 21589) inline$$Offer_redeem_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 21174) 21273) inline$$Offer_redeem_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1)) (= (ControlFlow 0 21172) 21174)) inline$$MoveFrom$0$anon3_Then$1_correct)))
(let ((inline$$MoveFrom$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1) (=> (and (= inline$$MoveFrom$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1)) (= |inline$$MoveFrom$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 $Error)))) (=> (and (and (= $abort_flag@1@@1 $abort_flag@0@@1) (= $abort_code@3@@1 $abort_code@1@@1)) (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@1|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@1))) (and (=> (= (ControlFlow 0 21120) 21589) inline$$Offer_redeem_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 21120) 21273) inline$$Offer_redeem_$def_verify$0$anon47_Else_correct)))))))
(let ((inline$$MoveFrom$0$anon0_correct  (=> (= inline$$MoveFrom$0$a@1 (|a#$Address| offer_address@@1)) (and (=> (= (ControlFlow 0 21074) 21172) inline$$MoveFrom$0$anon3_Then_correct) (=> (= (ControlFlow 0 21074) 21120) inline$$MoveFrom$0$anon3_Else_correct)))))
(let ((inline$$MoveFrom$0$Entry_correct  (=> (= inline$$MoveFrom$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1)) (and (=> (= (ControlFlow 0 21068) (- 0 27496)) true) (=> (= (ControlFlow 0 21068) 21074) inline$$MoveFrom$0$anon0_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Offer_redeem_$def_verify$0$$t12@1) (= (ControlFlow 0 21182) 21068)) inline$$MoveFrom$0$Entry_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon12_correct  (=> (= $abort_code@7 $abort_code@2@@1) (=> (and (= $Offer_Offer_$memory@0@@0 $Offer_Offer_$memory) (= (ControlFlow 0 20918) 20924)) inline$$Offer_redeem_$def_verify$0$Abort_correct))))
(let ((inline$$Offer_redeem_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 20916) 20918)) inline$$Offer_redeem_$def_verify$0$anon12_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 20932) 20918) inline$$Offer_redeem_$def_verify$0$anon12_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$Offer_redeem_$def_verify$0$$t12@1)) (= $abort_code@2@@1 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 20910) 20932) inline$$Offer_redeem_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 20910) 20916) inline$$Offer_redeem_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon43_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 20898) 21182) inline$$Offer_redeem_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 20898) 20910) inline$$Offer_redeem_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon4$2_correct  (=> (= inline$$Offer_redeem_$def_verify$0$$t12@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| offer_address@@1)))) (=> (and (and (and (= inline$$Offer_redeem_$def_verify$0$$t13@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1)) (and (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 20892) 21609) inline$$Offer_redeem_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 20892) 20898) inline$$Offer_redeem_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$Offer_redeem_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 20798) 20892)) inline$$Offer_redeem_$def_verify$0$anon4$2_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 21633) 20892) inline$$Offer_redeem_$def_verify$0$anon4$2_correct)))
(let ((inline$$Offer_redeem_$def_verify$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 20790) 21633) inline$$Offer_redeem_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 20790) 20798) inline$$Offer_redeem_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$Offer_redeem_$def_verify$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 21641) 21633) inline$$Offer_redeem_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 21641) 20798) inline$$Offer_redeem_$def_verify$0$anon42_Else_correct))))
(let ((inline$$Offer_redeem_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 20784) 21641) inline$$Offer_redeem_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 20784) 20790) inline$$Offer_redeem_$def_verify$0$anon41_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (forall (($inv_addr@@2 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))) 2)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))) $Offer_Offer_for))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Offer_Offer_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@2))
)) (= (ControlFlow 0 21647) 20784)) inline$$Offer_redeem_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> ((_ is $Address) account@@0) (=> (and ((_ is $Address) offer_address@@1) (= (ControlFlow 0 20032) 21647)) anon0$1_correct@@2))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 26459) 20032) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
