(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $ValidatorOperatorConfig_ValidatorOperatorConfig)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory () T@$Memory)
(declare-fun validator_operator_addr () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 46768) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 43064) (- 0 47545)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr))))))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr))))))) $abort_flag@2) (and (=> (= (ControlFlow 0 43064) (- 0 47562)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr))))))))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr)))))))) (and (=> (= (ControlFlow 0 43064) (- 0 47579)) (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (=> (= (ControlFlow 0 43064) (- 0 47607)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr)))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))))))))))))))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon18_correct  (=> (and (and (= $abort_code@5 $abort_code@3) (= inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1)) (and (= $abort_flag@2 $abort_flag@1) (= (ControlFlow 0 42996) 43064))) anon0$2_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 42994) 42996)) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon18_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 43004) 42996) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon18_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name)) (and (=> (= (ControlFlow 0 42978) 43004) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 42978) 42994) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 42984) 42978)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$Abort_correct  (=> (= inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@5 $abort_code@4) (= inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$$ret0@2 inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$$ret0@1)) (and (= $abort_flag@2 true) (= (ControlFlow 0 42743) 43064))) anon0$2_correct))))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon7_correct  (=> (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 43036) 42743)) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 43034) 43036)) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon7_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 43044) 43036) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon7_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon21_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 43028) 43044) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 43028) 43034) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon15_correct  (=> (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 43016) 42743)) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 43014) 43016)) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon15_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 43024) 43016) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon15_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 43008) 43024) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 43008) 43014) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@1 true) (=> (and (= $abort_code@3 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 42924) 43008) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 42924) 42984) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 42922) 42924)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr))) (= $abort_flag@1 $abort_flag@0)) (and (= $abort_code@3 $abort_code@1) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 42870) 43008) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 42870) 42984) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| validator_operator_addr)) (and (=> (= (ControlFlow 0 42852) 42922) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 42852) 42870) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 42846) (- 0 47348)) true) (=> (= (ControlFlow 0 42846) 42852) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon23_Then_correct  (=> (and (|b#$Boolean| inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1) (= (ControlFlow 0 42930) 42846)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon12_correct  (=> (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 42737) 42743)) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 42735) 42737)) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon12_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 42751) 42737) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon12_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1)) (= $abort_code@2 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 42729) 42751) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 42729) 42735) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 42717) 42930) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 42717) 42729) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon20_Else_correct  (=> (not false) (=> (and (and (and (= inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0)) (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 42711) 43028) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 42711) 42717) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon20_Then_correct true))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 42667) 43048) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 42667) 42711) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 42677) 43048) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 42677) 42711) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon20_Else_correct))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon2$1_correct  (=> (= inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr)))) (and (=> (= (ControlFlow 0 42661) 42677) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 42661) 42667) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 42615) 42661)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon2$1_correct)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 42685) 42661) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon2$1_correct)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 42609) 42685) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 42609) 42615) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$direct_intra$0$anon0_correct  (=> (and ((_ is $Address) validator_operator_addr) (= (ControlFlow 0 42691) 42609)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon0_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 42423) 42691)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$direct_intra$0$anon0_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 43056) 42691) inline$$ValidatorOperatorConfig_has_validator_operator_config_$direct_intra$0$anon0_correct)))
(let ((inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 42417) 43056) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 42417) 42423) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name)) (let ((va@@9 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((addr T@$Value) )  (=> ((_ is $Address) addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (= (ControlFlow 0 43062) 42417)) inline$$ValidatorOperatorConfig_get_human_name_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and ((_ is $Address) validator_operator_addr) (= (ControlFlow 0 42045) 43062)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 46768) 42045) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$$t2@1 () T@$Value)
(declare-fun validator_operator_addr@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 47639) (let ((anon0$2_correct@@0  (=> (= (ControlFlow 0 43497) (- 0 47830)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr@@0))))))))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 43471) 43497)) anon0$2_correct@@0)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 43481) 43497) anon0$2_correct@@0)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon2$1_correct  (=> (= inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_addr@@0)))) (and (=> (= (ControlFlow 0 43465) 43481) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 43465) 43471) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 43419) 43465)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 43489) 43465) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 43413) 43489) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 43413) 43419) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@0))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (= (ControlFlow 0 43495) 43413)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) validator_operator_addr@@0) (= (ControlFlow 0 43238) 43495)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 47639) 43238) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun dr_account () T@$Value)
(declare-fun $abort_flag@6 () Bool)
(declare-fun validator_operator_account () T@$Value)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_code@9 () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@1 () T@$Memory)
(declare-fun $abort_flag@5 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_code@8 () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$struct@1 () T@$Value)
(declare-fun human_name () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$ValidatorOperatorConfig_publish_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 47854) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 45686) (- 0 51270)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51291)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51320)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51337)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51358)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51387)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51399)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51414)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51435)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51464)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51481)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51502)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) $abort_flag@6) (and (=> (= (ControlFlow 0 45686) (- 0 51531)) (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4)))))))) (=> (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))))) (and (=> (= (ControlFlow 0 45686) (- 0 51781)) (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) (= $abort_code@9 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) (= $abort_code@9 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) (= $abort_code@9 (|i#$Integer| ($Integer 3)))))) (=> (= (ControlFlow 0 45686) (- 0 52163)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@1) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))))))))))))))))))))))))))))))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon53_Else_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 45532) (- 0 51042)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@0)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (and (=> (= (ControlFlow 0 45532) (- 0 51076)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@1)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorOperatorConfig_publish_$def_verify$0$addr@@2))))))))))) (=> (and (and (= $abort_code@9 $abort_code@7) (= $abort_flag@6 $abort_flag@5)) (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 45532) 45686))) anon0$2_correct@@1))))))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@9 $abort_code@8) (= $abort_flag@6 true)) (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@1 $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0) (= (ControlFlow 0 44882) 45686))) anon0$2_correct@@1)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon9_correct  (=> (= $abort_code@8 $abort_code@1@@0) (=> (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0 $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) (= (ControlFlow 0 45648) 44882)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 45646) 45648)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon9_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 45656) 45648) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon9_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon40_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 45640) 45656) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 45640) 45646) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon13_correct  (=> (= $abort_code@8 $abort_code@2@@0) (=> (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0 $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) (= (ControlFlow 0 45628) 44882)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 45626) 45628)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 45636) 45628) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon42_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 45620) 45636) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 45620) 45626) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon17_correct  (=> (= $abort_code@8 $abort_code@3@@0) (=> (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0 $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) (= (ControlFlow 0 45608) 44882)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 45606) 45608)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon17_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 45616) 45608) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon17_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon44_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 45600) 45616) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 45600) 45606) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon21_correct  (=> (= $abort_code@8 $abort_code@4@@0) (=> (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0 $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) (= (ControlFlow 0 45588) 44882)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 45586) 45588)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 45596) 45588) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon46_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 45580) 45596) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 45580) 45586) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon27_correct  (=> (= $abort_code@8 $abort_code@5@@0) (=> (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0 $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) (= (ControlFlow 0 45564) 44882)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 45562) 45564)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon27_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 45572) 45564) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon27_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon49_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 45556) 45572) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 45556) 45562) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon35_correct  (=> (= $abort_code@8 $abort_code@7) (=> (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 45544) 44882)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 45542) 45544)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon35_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 45552) 45544) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon35_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon53_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 45536) 45552) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 45536) 45542) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@5 true) (=> (and (= $abort_code@7 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 45436) 45536) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 45436) 45532) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon53_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 45434) 45436)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$struct@1))) (= $abort_flag@5 $abort_flag@4)) (and (= $abort_code@7 $abort_code@5@@0) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 45384) 45536) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 45384) 45532) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon53_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| validator_operator_account)) (and (=> (= (ControlFlow 0 45442) 45434) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 45442) 45384) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 45230) (- 0 50927)) true) (=> (= (ControlFlow 0 45230) 45442) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 45114) 45230)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 45120) 45230) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 45108) 45120) inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 45108) 45114) inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon4_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 45100) 45230)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon0_correct  (=> (and (and (and ((_ is $Vector) human_name) (let ((va@@12 (|v#$Vector| human_name)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (forall ((inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$$0 0) (< inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$$0))
))) (= inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 human_name) 1)))) (and (=> (= (ControlFlow 0 45092) 45108) inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 45092) 45100) inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon3_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon51_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 45126) 45092)) inline$$ValidatorOperatorConfig_ValidatorOperatorConfig_pack$0$anon0_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon32_correct  (=> (= $abort_code@8 $abort_code@6) (=> (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0 $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) (= (ControlFlow 0 44878) 44882)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 44876) 44878)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon32_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 44890) 44878) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon32_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon51_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@6 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 44870) 44890) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 44870) 44876) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 44858) 45126) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 44858) 44870) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon48_Else$1_correct  (=> (and (and (and (= inline$$ValidatorOperatorConfig_publish_$def_verify$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 44852) 45556) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 44852) 44858) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1@@0)))) (= (ControlFlow 0 44840) 44852)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon48_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 44830) (- 0 50689)) true) (=> (= (ControlFlow 0 44830) 44840) inline$$Not$0$anon0_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon48_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 44846) 44830)) inline$$Not$0$Entry_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon48_Then_correct  (=> (and (and $abort_flag@3 (= $abort_code@8 $abort_code@4@@0)) (and (= $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory@0 $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) (= (ControlFlow 0 45576) 44882))) inline$$ValidatorOperatorConfig_publish_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 44758) 45576) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 44758) 44846) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 44768) 45576) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 44768) 44846) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon48_Else_correct))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon2$1_correct@@0  (=> (= inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@1)))) (and (=> (= (ControlFlow 0 44752) 44768) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 44752) 44758) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 44706) 44752)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon2$1_correct@@0)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 44776) 44752) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon2$1_correct@@0)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon0_correct@@0  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 44700) 44776) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 44700) 44706) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$direct_intra$0$anon0_correct@@0  (=> (and ((_ is $Address) call3formal@$ret0@0@@1) (= (ControlFlow 0 44782) 44700)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon0_correct@@0)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon46_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 44790) 44782)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$direct_intra$0$anon0_correct@@0)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon44_Else_correct  (=> (not $abort_flag@2@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3) (=> $abort_flag@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 validator_operator_account)))) ((_ is $Address) call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 44544) 45580) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 44544) 44790) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon46_Else_correct))))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon42_Else_correct  (=> (not $abort_flag@1@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) $abort_flag@2@@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) $abort_flag@2@@0)) (and (=> $abort_flag@2@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))))) (=> $abort_flag@2@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 44538) 45600) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 44538) 44544) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon44_Else_correct))))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon40_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@1@@0)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@1@@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1@@0)) (and (=> $abort_flag@1@@0 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@1@@0 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 44532) 45620) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 44532) 44538) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon42_Else_correct)))))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@0) (=> (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 44526) 45640) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 44526) 44532) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 44422) 44526)) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon6$3_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 45664) 44526) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon6$3_correct)))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon38_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 44414) 45664) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 44414) 44422) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon38_Then_correct  (and (=> (= (ControlFlow 0 45672) 45664) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 45672) 44422) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon39_Else_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon37_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 44406) 45672) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 44406) 44414) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon37_Then_correct  (and (=> (= (ControlFlow 0 45680) 45672) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 45680) 44414) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon38_Else_correct))))
(let ((inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 44400) 45680) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 44400) 44406) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon37_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))
))) (=> (and (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@1))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (= (ControlFlow 0 45684) 44400))) inline$$ValidatorOperatorConfig_publish_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) validator_operator_account) ((_ is $Address) dr_account)) (=> (and (and (and ((_ is $Vector) human_name) (let ((va@@17 (|v#$Vector| human_name)))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@2))
))) (= (ControlFlow 0 43631) 45684)) anon0$1_correct@@1))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 47854) 43631) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
