(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun x@@8 () T@$Value)
(declare-fun y () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort1_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@1 () Int)
(declare-fun inline$$Gt$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 25666) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 17098) (- 0 25948)) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| x@@8) (|i#$Integer| y)))) $abort_flag@0)) (=> (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| x@@8) (|i#$Integer| y)))) $abort_flag@0) (=> (= (ControlFlow 0 17098) (- 0 25965)) (=> $abort_flag@0 (|b#$Boolean| ($Boolean (<= (|i#$Integer| x@@8) (|i#$Integer| y))))))))))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon8_correct  (=> (and (= $abort_flag@0 true) (= (ControlFlow 0 17068) 17098)) anon0$2_correct)))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 17064) 17068)) inline$$TestAbortsIf_abort1_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 17076) 17068) inline$$TestAbortsIf_abort1_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon11_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (= inline$$TestAbortsIf_abort1_$def_verify$0$$t6@1 ($Integer 1)) (= $abort_code@1 (|i#$Integer| inline$$TestAbortsIf_abort1_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 17058) 17076) inline$$TestAbortsIf_abort1_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 17058) 17064) inline$$TestAbortsIf_abort1_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon11_Else_correct  (=> (not (|b#$Boolean| inline$$Not$0$dst@1)) (=> (and (= $abort_flag@0 false) (= (ControlFlow 0 17044) 17098)) anon0$2_correct))))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Gt$0$dst@1)))) (and (=> (= (ControlFlow 0 17028) 17058) inline$$TestAbortsIf_abort1_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 17028) 17044) inline$$TestAbortsIf_abort1_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 17018) (- 0 25878)) true) (=> (= (ControlFlow 0 17018) 17028) inline$$Not$0$anon0_correct))))
(let ((inline$$Gt$0$anon0_correct  (=> (and (= inline$$Gt$0$dst@1 ($Boolean (> (|i#$Integer| x@@8) (|i#$Integer| y)))) (= (ControlFlow 0 16978) 17018)) inline$$Not$0$Entry_correct)))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 16964) (- 0 25853)) true) (=> (= (ControlFlow 0 16964) 16978) inline$$Gt$0$anon0_correct))))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon10_Else_correct  (=> (and (not true) (= (ControlFlow 0 16852) 16964)) inline$$Gt$0$Entry_correct)))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon10_Then_correct  (=> (= (ControlFlow 0 17084) 16964) inline$$Gt$0$Entry_correct)))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 16844) 17084) inline$$TestAbortsIf_abort1_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 16844) 16852) inline$$TestAbortsIf_abort1_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 17092) 17084) inline$$TestAbortsIf_abort1_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 17092) 16852) inline$$TestAbortsIf_abort1_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestAbortsIf_abort1_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16838) 17092) inline$$TestAbortsIf_abort1_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 16838) 16844) inline$$TestAbortsIf_abort1_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct  (=> (and (and ((_ is $Integer) x@@8) (>= (|i#$Integer| x@@8) 0)) (<= (|i#$Integer| x@@8) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y) (>= (|i#$Integer| y) 0)) (<= (|i#$Integer| y) $MAX_U64)) (= (ControlFlow 0 16646) 16838)) inline$$TestAbortsIf_abort1_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 25666) 16646) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun _x () T@$Value)
(declare-fun _y () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 25995) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 17349) (- 0 26104)) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| _x) (|i#$Integer| _y)))) false)) (=> (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| _x) (|i#$Integer| _y)))) false) (=> (= (ControlFlow 0 17349) (- 0 26121)) (=> false (|b#$Boolean| ($Boolean (<= (|i#$Integer| _x) (|i#$Integer| _y))))))))))
(let ((inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 17325) 17349)) anon0$2_correct@@0)))
(let ((inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 17335) 17349) anon0$2_correct@@0)))
(let ((inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon5_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17317) 17335) inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 17317) 17325) inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon5_Then_correct  (and (=> (= (ControlFlow 0 17343) 17335) inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 17343) 17325) inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon6_Else_correct))))
(let ((inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17311) 17343) inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 17311) 17317) inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon5_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and ((_ is $Integer) _x) (>= (|i#$Integer| _x) 0)) (<= (|i#$Integer| _x) $MAX_U64)) (=> (and (and (and ((_ is $Integer) _y) (>= (|i#$Integer| _y) 0)) (<= (|i#$Integer| _y) $MAX_U64)) (= (ControlFlow 0 17215) 17311)) inline$$TestAbortsIf_abort2_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 25995) 17215) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun inline$$TestAbortsIf_abort3_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun _x@@0 () T@$Value)
(declare-fun _y@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26143) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 17629) (- 0 26291)) (=> (|b#$Boolean| ($Boolean true)) true)) (=> (=> (|b#$Boolean| ($Boolean true)) true) (=> (= (ControlFlow 0 17629) (- 0 26300)) (=> true (|b#$Boolean| ($Boolean true))))))))
(let ((inline$$TestAbortsIf_abort3_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 17595) 17629)) anon0$2_correct@@1)))
(let ((inline$$TestAbortsIf_abort3_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 17607) 17629) anon0$2_correct@@1)))
(let ((inline$$TestAbortsIf_abort3_$def_verify$0$anon4_correct  (=> (and (= inline$$TestAbortsIf_abort3_$def_verify$0$$t2@1 ($Integer 1)) (= $abort_code@1@@0 (|i#$Integer| inline$$TestAbortsIf_abort3_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 17589) 17607) inline$$TestAbortsIf_abort3_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 17589) 17595) inline$$TestAbortsIf_abort3_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestAbortsIf_abort3_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 17579) 17589)) inline$$TestAbortsIf_abort3_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIf_abort3_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 17615) 17589) inline$$TestAbortsIf_abort3_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIf_abort3_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17571) 17615) inline$$TestAbortsIf_abort3_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 17571) 17579) inline$$TestAbortsIf_abort3_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestAbortsIf_abort3_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 17623) 17615) inline$$TestAbortsIf_abort3_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 17623) 17579) inline$$TestAbortsIf_abort3_$def_verify$0$anon8_Else_correct))))
(let ((inline$$TestAbortsIf_abort3_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17565) 17623) inline$$TestAbortsIf_abort3_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 17565) 17571) inline$$TestAbortsIf_abort3_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@1  (=> (and (and ((_ is $Integer) _x@@0) (>= (|i#$Integer| _x@@0) 0)) (<= (|i#$Integer| _x@@0) $MAX_U64)) (=> (and (and (and ((_ is $Integer) _y@@0) (>= (|i#$Integer| _y@@0) 0)) (<= (|i#$Integer| _y@@0) $MAX_U64)) (= (ControlFlow 0 17412) 17565)) inline$$TestAbortsIf_abort3_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 26143) 17412) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@9 () T@$Value)
(declare-fun y@@0 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$Gt$0$dst@1@@0 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_code@1@@1 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26314) (let ((anon0$2_correct@@2  (=> (= (ControlFlow 0 18093) (- 0 26547)) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| x@@9) (|i#$Integer| y@@0)))) $abort_flag@0@@0))))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon8_correct  (=> (and (= $abort_flag@0@@0 true) (= (ControlFlow 0 18063) 18093)) anon0$2_correct@@2)))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 18059) 18063)) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 18071) 18063) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon11_Then_correct  (=> (|b#$Boolean| inline$$Gt$0$dst@1@@0) (=> (and (= inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$$t5@1 ($Integer 1)) (= $abort_code@1@@1 (|i#$Integer| inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$$t5@1))) (and (=> (= (ControlFlow 0 18053) 18071) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 18053) 18059) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon11_Else_correct  (=> (not (|b#$Boolean| inline$$Gt$0$dst@1@@0)) (=> (and (= $abort_flag@0@@0 false) (= (ControlFlow 0 18039) 18093)) anon0$2_correct@@2))))
(let ((inline$$Gt$0$anon0_correct@@0  (=> (= inline$$Gt$0$dst@1@@0 ($Boolean (> (|i#$Integer| x@@9) (|i#$Integer| y@@0)))) (and (=> (= (ControlFlow 0 18023) 18053) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 18023) 18039) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Gt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 18009) (- 0 26474)) true) (=> (= (ControlFlow 0 18009) 18023) inline$$Gt$0$anon0_correct@@0))))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon10_Else_correct  (=> (and (not true) (= (ControlFlow 0 17897) 18009)) inline$$Gt$0$Entry_correct@@0)))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon10_Then_correct  (=> (= (ControlFlow 0 18079) 18009) inline$$Gt$0$Entry_correct@@0)))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17889) 18079) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 17889) 17897) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 18087) 18079) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 18087) 17897) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17883) 18087) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 17883) 17889) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and ((_ is $Integer) x@@9) (>= (|i#$Integer| x@@9) 0)) (<= (|i#$Integer| x@@9) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@0) (>= (|i#$Integer| y@@0) 0)) (<= (|i#$Integer| y@@0) $MAX_U64)) (= (ControlFlow 0 17696) 17883)) inline$$TestAbortsIf_abort4_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 26314) 17696) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@10 () T@$Value)
(declare-fun y@@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_code@1@@2 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26569) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 18596) (- 0 26820)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| x@@10) (|i#$Integer| y@@1)))) $abort_flag@0@@1)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| x@@10) (|i#$Integer| y@@1)))) $abort_flag@0@@1) (=> (= (ControlFlow 0 18596) (- 0 26837)) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean (< (|i#$Integer| x@@10) (|i#$Integer| y@@1))))))))))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon8_correct  (=> (and (= $abort_flag@0@@1 true) (= (ControlFlow 0 18566) 18596)) anon0$2_correct@@3)))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 18562) 18566)) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 18574) 18566) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon11_Then_correct  (=> (|b#$Boolean| inline$$Le$0$dst@1) (=> (and (= inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$$t5@1 ($Integer 1)) (= $abort_code@1@@2 (|i#$Integer| inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$$t5@1))) (and (=> (= (ControlFlow 0 18556) 18574) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 18556) 18562) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon11_Else_correct  (=> (not (|b#$Boolean| inline$$Le$0$dst@1)) (=> (and (= $abort_flag@0@@1 false) (= (ControlFlow 0 18542) 18596)) anon0$2_correct@@3))))
(let ((inline$$Le$0$anon0_correct  (=> (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| x@@10) (|i#$Integer| y@@1)))) (and (=> (= (ControlFlow 0 18526) 18556) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 18526) 18542) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 18512) (- 0 26747)) true) (=> (= (ControlFlow 0 18512) 18526) inline$$Le$0$anon0_correct))))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon10_Else_correct  (=> (and (not true) (= (ControlFlow 0 18400) 18512)) inline$$Le$0$Entry_correct)))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon10_Then_correct  (=> (= (ControlFlow 0 18582) 18512) inline$$Le$0$Entry_correct)))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18392) 18582) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 18392) 18400) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 18590) 18582) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 18590) 18400) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18386) 18590) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 18386) 18392) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@3  (=> (and (and ((_ is $Integer) x@@10) (>= (|i#$Integer| x@@10) 0)) (<= (|i#$Integer| x@@10) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@1) (>= (|i#$Integer| y@@1) 0)) (<= (|i#$Integer| y@@1) $MAX_U64)) (= (ControlFlow 0 18199) 18386)) inline$$TestAbortsIf_abort5_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 26569) 18199) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@11 () T@$Value)
(declare-fun y@@2 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_code@1@@3 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26859) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 19099) (- 0 27110)) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| x@@11) (|i#$Integer| y@@2)))) $abort_flag@0@@2)) (=> (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| x@@11) (|i#$Integer| y@@2)))) $abort_flag@0@@2) (=> (= (ControlFlow 0 19099) (- 0 27127)) (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean (<= (|i#$Integer| x@@11) (|i#$Integer| y@@2))))))))))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon8_correct  (=> (and (= $abort_flag@0@@2 true) (= (ControlFlow 0 19069) 19099)) anon0$2_correct@@4)))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 19065) 19069)) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 19077) 19069) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon11_Then_correct  (=> (|b#$Boolean| inline$$Lt$0$dst@1) (=> (and (= inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$$t5@1 ($Integer 1)) (= $abort_code@1@@3 (|i#$Integer| inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$$t5@1))) (and (=> (= (ControlFlow 0 19059) 19077) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 19059) 19065) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon11_Else_correct  (=> (not (|b#$Boolean| inline$$Lt$0$dst@1)) (=> (and (= $abort_flag@0@@2 false) (= (ControlFlow 0 19045) 19099)) anon0$2_correct@@4))))
(let ((inline$$Lt$0$anon0_correct  (=> (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| x@@11) (|i#$Integer| y@@2)))) (and (=> (= (ControlFlow 0 19029) 19059) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 19029) 19045) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 19015) (- 0 27037)) true) (=> (= (ControlFlow 0 19015) 19029) inline$$Lt$0$anon0_correct))))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon10_Else_correct  (=> (and (not true) (= (ControlFlow 0 18903) 19015)) inline$$Lt$0$Entry_correct)))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon10_Then_correct  (=> (= (ControlFlow 0 19085) 19015) inline$$Lt$0$Entry_correct)))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18895) 19085) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 18895) 18903) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 19093) 19085) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 19093) 18903) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18889) 19093) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 18889) 18895) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@4  (=> (and (and ((_ is $Integer) x@@11) (>= (|i#$Integer| x@@11) 0)) (<= (|i#$Integer| x@@11) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@2) (>= (|i#$Integer| y@@2) 0)) (<= (|i#$Integer| y@@2) $MAX_U64)) (= (ControlFlow 0 18702) 18889)) inline$$TestAbortsIf_abort6_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 26859) 18702) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@12 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun |inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$tmp#$1@2| () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t4@1 () T@$Value)
(declare-fun |inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27148) (let ((anon0$2_correct@@5  (=> (= (ControlFlow 0 19673) (- 0 27439)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@12 ($Integer 2)))) $abort_flag@0@@3))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@0@@3 true) (= (ControlFlow 0 19583) 19673)) anon0$2_correct@@5)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 19579) 19583)) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 19591) 19583) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| |inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$tmp#$1@2|) (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t7@1 ($Integer 1)) (= $abort_code@1@@4 (|i#$Integer| inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 19573) 19591) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 19573) 19579) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| |inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$tmp#$1@2|)) (=> (and (= $abort_flag@0@@3 false) (= (ControlFlow 0 19559) 19673)) anon0$2_correct@@5))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon6_correct  (=> (= |inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$tmp#$1@2| inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t5@1) (and (=> (= (ControlFlow 0 19651) 19573) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 19651) 19559) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 19649) 19651)) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 19659) 19651) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon14_Then_correct  (=> (and (|b#$Boolean| inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t4@1) (= inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 19641) 19659) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 19641) 19649) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon8_correct  (=> (= |inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$tmp#$1@2| |inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$tmp#$1@1|) (and (=> (= (ControlFlow 0 19549) 19573) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 19549) 19559) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 19547) 19549)) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 19599) 19549) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon14_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t4@1)) (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t6@1 ($Integer 3)) (= |inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$tmp#$1@1| ($Boolean ($IsEqual_stratified x@@12 inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t6@1)))) (and (=> (= (ControlFlow 0 19541) 19599) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 19541) 19547) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t3@1 ($Integer 2)) (= inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t4@1 ($Boolean ($IsEqual_stratified x@@12 inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$$t3@1)))) (and (=> (= (ControlFlow 0 19521) 19641) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 19521) 19541) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 19473) 19521)) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 19667) 19521) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 19467) 19667) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 19467) 19473) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@5  (=> (and (and (and ((_ is $Integer) x@@12) (>= (|i#$Integer| x@@12) 0)) (<= (|i#$Integer| x@@12) $MAX_U64)) (= (ControlFlow 0 19201) 19467)) inline$$TestAbortsIf_abort_at_2_or_3_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 27148) 19201) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@13 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun |inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$tmp#$1@2| () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t4@1 () T@$Value)
(declare-fun |inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27458) (let ((anon0$2_correct@@6  (=> (= (ControlFlow 0 20249) (- 0 27749)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@13 ($Integer 4)))) $abort_flag@0@@4))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@0@@4 true) (= (ControlFlow 0 20159) 20249)) anon0$2_correct@@6)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 20155) 20159)) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 20167) 20159) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| |inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$tmp#$1@2|) (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t7@1 ($Integer 1)) (= $abort_code@1@@5 (|i#$Integer| inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 20149) 20167) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 20149) 20155) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| |inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$tmp#$1@2|)) (=> (and (= $abort_flag@0@@4 false) (= (ControlFlow 0 20135) 20249)) anon0$2_correct@@6))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon6_correct  (=> (= |inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$tmp#$1@2| inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t5@1) (and (=> (= (ControlFlow 0 20227) 20149) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 20227) 20135) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 20225) 20227)) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 20235) 20227) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon14_Then_correct  (=> (and (|b#$Boolean| inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t4@1) (= inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 20217) 20235) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 20217) 20225) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon8_correct  (=> (= |inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$tmp#$1@2| |inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$tmp#$1@1|) (and (=> (= (ControlFlow 0 20125) 20149) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 20125) 20135) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 20123) 20125)) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 20175) 20125) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon14_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t4@1)) (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t6@1 ($Integer 3)) (= |inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$tmp#$1@1| ($Boolean ($IsEqual_stratified x@@13 inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t6@1)))) (and (=> (= (ControlFlow 0 20117) 20175) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 20117) 20123) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t3@1 ($Integer 2)) (= inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t4@1 ($Boolean ($IsEqual_stratified x@@13 inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$$t3@1)))) (and (=> (= (ControlFlow 0 20097) 20217) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 20097) 20117) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 20049) 20097)) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 20243) 20097) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 20043) 20243) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 20043) 20049) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@6  (=> (and (and (and ((_ is $Integer) x@@13) (>= (|i#$Integer| x@@13) 0)) (<= (|i#$Integer| x@@13) $MAX_U64)) (= (ControlFlow 0 19777) 20043)) inline$$TestAbortsIf_abort_at_2_or_3_spec_incorrect_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 27458) 19777) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun |inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$tmp#$1@2| () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@1@@6 () Int)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t4@1 () T@$Value)
(declare-fun |inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t6@1 () T@$Value)
(declare-fun x@@14 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27768) (let ((anon0$2_correct@@7  (=> (= (ControlFlow 0 20825) (- 0 28047)) (not $abort_flag@0@@5))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@0@@5 true) (= (ControlFlow 0 20735) 20825)) anon0$2_correct@@7)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 20731) 20735)) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 20743) 20735) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| |inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$tmp#$1@2|) (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t7@1 ($Integer 1)) (= $abort_code@1@@6 (|i#$Integer| inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 20725) 20743) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 20725) 20731) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| |inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$tmp#$1@2|)) (=> (and (= $abort_flag@0@@5 false) (= (ControlFlow 0 20711) 20825)) anon0$2_correct@@7))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon6_correct  (=> (= |inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$tmp#$1@2| inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t5@1) (and (=> (= (ControlFlow 0 20803) 20725) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 20803) 20711) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 20801) 20803)) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 20811) 20803) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon14_Then_correct  (=> (and (|b#$Boolean| inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t4@1) (= inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 20793) 20811) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 20793) 20801) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon8_correct  (=> (= |inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$tmp#$1@2| |inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$tmp#$1@1|) (and (=> (= (ControlFlow 0 20701) 20725) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 20701) 20711) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 20699) 20701)) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 20751) 20701) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon14_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t4@1)) (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t6@1 ($Integer 3)) (= |inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$tmp#$1@1| ($Boolean ($IsEqual_stratified x@@14 inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t6@1)))) (and (=> (= (ControlFlow 0 20693) 20751) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 20693) 20699) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t3@1 ($Integer 2)) (= inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t4@1 ($Boolean ($IsEqual_stratified x@@14 inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$$t3@1)))) (and (=> (= (ControlFlow 0 20673) 20793) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 20673) 20693) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 20625) 20673)) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 20819) 20673) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 20619) 20819) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 20619) 20625) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@7  (=> (and (and (and ((_ is $Integer) x@@14) (>= (|i#$Integer| x@@14) 0)) (<= (|i#$Integer| x@@14) $MAX_U64)) (= (ControlFlow 0 20353) 20619)) inline$$TestAbortsIf_abort_at_2_or_3_strict_incorrect_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 27768) 20353) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@7)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@15 () T@$Value)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun |inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$tmp#$1@2| () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@1@@7 () Int)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t4@1 () T@$Value)
(declare-fun |inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28054) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 21401) (- 0 28362)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 ($Integer 2)))) $abort_flag@0@@6)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 ($Integer 2)))) $abort_flag@0@@6) (=> (= (ControlFlow 0 21401) (- 0 28377)) (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 ($Integer 2))))))))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@0@@6 true) (= (ControlFlow 0 21311) 21401)) anon0$2_correct@@8)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 21307) 21311)) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 21319) 21311) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| |inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$tmp#$1@2|) (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t7@1 ($Integer 1)) (= $abort_code@1@@7 (|i#$Integer| inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 21301) 21319) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 21301) 21307) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| |inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$tmp#$1@2|)) (=> (and (= $abort_flag@0@@6 false) (= (ControlFlow 0 21287) 21401)) anon0$2_correct@@8))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon6_correct  (=> (= |inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$tmp#$1@2| inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t5@1) (and (=> (= (ControlFlow 0 21379) 21301) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 21379) 21287) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 21377) 21379)) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 21387) 21379) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon14_Then_correct  (=> (and (|b#$Boolean| inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t4@1) (= inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 21369) 21387) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 21369) 21377) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon8_correct  (=> (= |inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$tmp#$1@2| |inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$tmp#$1@1|) (and (=> (= (ControlFlow 0 21277) 21301) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 21277) 21287) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 21275) 21277)) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 21327) 21277) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon14_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t4@1)) (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t6@1 ($Integer 3)) (= |inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$tmp#$1@1| ($Boolean ($IsEqual_stratified x@@15 inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t6@1)))) (and (=> (= (ControlFlow 0 21269) 21327) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 21269) 21275) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t3@1 ($Integer 2)) (= inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t4@1 ($Boolean ($IsEqual_stratified x@@15 inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$$t3@1)))) (and (=> (= (ControlFlow 0 21249) 21369) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 21249) 21269) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 21201) 21249)) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 21395) 21249) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 21195) 21395) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 21195) 21201) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@8  (=> (and (and (and ((_ is $Integer) x@@15) (>= (|i#$Integer| x@@15) 0)) (<= (|i#$Integer| x@@15) $MAX_U64)) (= (ControlFlow 0 20929) 21195)) inline$$TestAbortsIf_abort_at_2_or_3_total_incorrect_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 28054) 20929) anon0_correct@@8)))
PreconditionGeneratedEntry_correct@@8)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@16 () T@$Value)
(declare-fun y@@3 () T@$Value)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun inline$$Le$0$dst@1@@0 () T@$Value)
(declare-fun inline$$TestAbortsIf_multi_abort1_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_code@1@@8 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28397) (let ((anon0$2_correct@@9  (and (=> (= (ControlFlow 0 21906) (- 0 28673)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| x@@16) (|i#$Integer| y@@3)))) $abort_flag@0@@7)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| x@@16) (|i#$Integer| y@@3)))) $abort_flag@0@@7) (and (=> (= (ControlFlow 0 21906) (- 0 28690)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 y@@3))) $abort_flag@0@@7)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 y@@3))) $abort_flag@0@@7) (=> (= (ControlFlow 0 21906) (- 0 28703)) (=> $abort_flag@0@@7 (or (|b#$Boolean| ($Boolean (< (|i#$Integer| x@@16) (|i#$Integer| y@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 y@@3))))))))))))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon8_correct  (=> (and (= $abort_flag@0@@7 true) (= (ControlFlow 0 21876) 21906)) anon0$2_correct@@9)))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 21872) 21876)) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 21884) 21876) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon11_Then_correct  (=> (|b#$Boolean| inline$$Le$0$dst@1@@0) (=> (and (= inline$$TestAbortsIf_multi_abort1_$def_verify$0$$t5@1 ($Integer 1)) (= $abort_code@1@@8 (|i#$Integer| inline$$TestAbortsIf_multi_abort1_$def_verify$0$$t5@1))) (and (=> (= (ControlFlow 0 21866) 21884) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 21866) 21872) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon11_Else_correct  (=> (not (|b#$Boolean| inline$$Le$0$dst@1@@0)) (=> (and (= $abort_flag@0@@7 false) (= (ControlFlow 0 21852) 21906)) anon0$2_correct@@9))))
(let ((inline$$Le$0$anon0_correct@@0  (=> (= inline$$Le$0$dst@1@@0 ($Boolean (<= (|i#$Integer| x@@16) (|i#$Integer| y@@3)))) (and (=> (= (ControlFlow 0 21836) 21866) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 21836) 21852) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Le$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 21822) (- 0 28600)) true) (=> (= (ControlFlow 0 21822) 21836) inline$$Le$0$anon0_correct@@0))))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon10_Else_correct  (=> (and (not true) (= (ControlFlow 0 21710) 21822)) inline$$Le$0$Entry_correct@@0)))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon10_Then_correct  (=> (= (ControlFlow 0 21892) 21822) inline$$Le$0$Entry_correct@@0)))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 21702) 21892) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 21702) 21710) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 21900) 21892) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 21900) 21710) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 21696) 21900) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 21696) 21702) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@9  (=> (and (and ((_ is $Integer) x@@16) (>= (|i#$Integer| x@@16) 0)) (<= (|i#$Integer| x@@16) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@3) (>= (|i#$Integer| y@@3) 0)) (<= (|i#$Integer| y@@3) $MAX_U64)) (= (ControlFlow 0 21509) 21696)) inline$$TestAbortsIf_multi_abort1_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (= (ControlFlow 0 28397) 21509) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@9))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@17 () T@$Value)
(declare-fun y@@4 () T@$Value)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun inline$$Lt$0$dst@1@@0 () T@$Value)
(declare-fun inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_code@1@@9 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 28737) (let ((anon0$2_correct@@10  (and (=> (= (ControlFlow 0 22409) (- 0 29013)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| x@@17) (|i#$Integer| y@@4)))) $abort_flag@0@@8)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| x@@17) (|i#$Integer| y@@4)))) $abort_flag@0@@8) (and (=> (= (ControlFlow 0 22409) (- 0 29030)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@17 y@@4))) $abort_flag@0@@8)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@17 y@@4))) $abort_flag@0@@8) (=> (= (ControlFlow 0 22409) (- 0 29043)) (=> $abort_flag@0@@8 (or (|b#$Boolean| ($Boolean (< (|i#$Integer| x@@17) (|i#$Integer| y@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@17 y@@4))))))))))))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon8_correct  (=> (and (= $abort_flag@0@@8 true) (= (ControlFlow 0 22379) 22409)) anon0$2_correct@@10)))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 22375) 22379)) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 22387) 22379) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon11_Then_correct  (=> (|b#$Boolean| inline$$Lt$0$dst@1@@0) (=> (and (= inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$$t5@1 ($Integer 1)) (= $abort_code@1@@9 (|i#$Integer| inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$$t5@1))) (and (=> (= (ControlFlow 0 22369) 22387) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 22369) 22375) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon11_Else_correct  (=> (not (|b#$Boolean| inline$$Lt$0$dst@1@@0)) (=> (and (= $abort_flag@0@@8 false) (= (ControlFlow 0 22355) 22409)) anon0$2_correct@@10))))
(let ((inline$$Lt$0$anon0_correct@@0  (=> (= inline$$Lt$0$dst@1@@0 ($Boolean (< (|i#$Integer| x@@17) (|i#$Integer| y@@4)))) (and (=> (= (ControlFlow 0 22339) 22369) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 22339) 22355) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 22325) (- 0 28940)) true) (=> (= (ControlFlow 0 22325) 22339) inline$$Lt$0$anon0_correct@@0))))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon10_Else_correct  (=> (and (not true) (= (ControlFlow 0 22213) 22325)) inline$$Lt$0$Entry_correct@@0)))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon10_Then_correct  (=> (= (ControlFlow 0 22395) 22325) inline$$Lt$0$Entry_correct@@0)))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 22205) 22395) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 22205) 22213) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 22403) 22395) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 22403) 22213) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 22199) 22403) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 22199) 22205) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@10  (=> (and (and ((_ is $Integer) x@@17) (>= (|i#$Integer| x@@17) 0)) (<= (|i#$Integer| x@@17) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@4) (>= (|i#$Integer| y@@4) 0)) (<= (|i#$Integer| y@@4) $MAX_U64)) (= (ControlFlow 0 22012) 22199)) inline$$TestAbortsIf_multi_abort2_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@10  (=> (= (ControlFlow 0 28737) 22012) anon0_correct@@10)))
PreconditionGeneratedEntry_correct@@10))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun _x@@1 () T@$Value)
(declare-fun _y@@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $abort_code@1@@10 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29077) (let ((anon0$2_correct@@11  (and (=> (= (ControlFlow 0 22732) (- 0 29262)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| _x@@1) (|i#$Integer| _y@@1)))) true)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| _x@@1) (|i#$Integer| _y@@1)))) true) (and (=> (= (ControlFlow 0 22732) (- 0 29279)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified _x@@1 _y@@1))) true)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified _x@@1 _y@@1))) true) (=> (= (ControlFlow 0 22732) (- 0 29292)) (=> true (or (|b#$Boolean| ($Boolean (< (|i#$Integer| _x@@1) (|i#$Integer| _y@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified _x@@1 _y@@1))))))))))))
(let ((inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 22698) 22732)) anon0$2_correct@@11)))
(let ((inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 22710) 22732) anon0$2_correct@@11)))
(let ((inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon4_correct  (=> (and (= inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$$t2@1 ($Integer 1)) (= $abort_code@1@@10 (|i#$Integer| inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 22692) 22710) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 22692) 22698) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 22682) 22692)) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 22718) 22692) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 22674) 22718) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 22674) 22682) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 22726) 22718) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 22726) 22682) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon8_Else_correct))))
(let ((inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 22668) 22726) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 22668) 22674) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@11  (=> (and (and ((_ is $Integer) _x@@1) (>= (|i#$Integer| _x@@1) 0)) (<= (|i#$Integer| _x@@1) $MAX_U64)) (=> (and (and (and ((_ is $Integer) _y@@1) (>= (|i#$Integer| _y@@1) 0)) (<= (|i#$Integer| _y@@1) $MAX_U64)) (= (ControlFlow 0 22515) 22668)) inline$$TestAbortsIf_multi_abort3_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@11  (=> (= (ControlFlow 0 29077) 22515) anon0_correct@@11)))
PreconditionGeneratedEntry_correct@@11))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun _x@@2 () T@$Value)
(declare-fun _y@@2 () T@$Value)
(declare-fun inline$$TestAbortsIf_multi_abort4_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $abort_code@1@@11 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29326) (let ((anon0$2_correct@@12  (and (=> (= (ControlFlow 0 23016) (- 0 29544)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| _x@@2) (|i#$Integer| _y@@2)))) true)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| _x@@2) (|i#$Integer| _y@@2)))) true) (and (=> (= (ControlFlow 0 23016) (- 0 29561)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified _x@@2 _y@@2))) true)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified _x@@2 _y@@2))) true) (and (=> (= (ControlFlow 0 23016) (- 0 29574)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| _x@@2) (|i#$Integer| _y@@2)))) true)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| _x@@2) (|i#$Integer| _y@@2)))) true) (=> (= (ControlFlow 0 23016) (- 0 29591)) (=> true (or (or (|b#$Boolean| ($Boolean (< (|i#$Integer| _x@@2) (|i#$Integer| _y@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified _x@@2 _y@@2)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| _x@@2) (|i#$Integer| _y@@2)))))))))))))))
(let ((inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 22982) 23016)) anon0$2_correct@@12)))
(let ((inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 22994) 23016) anon0$2_correct@@12)))
(let ((inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon4_correct  (=> (and (= inline$$TestAbortsIf_multi_abort4_$def_verify$0$$t2@1 ($Integer 1)) (= $abort_code@1@@11 (|i#$Integer| inline$$TestAbortsIf_multi_abort4_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 22976) 22994) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 22976) 22982) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 22966) 22976)) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 23002) 22976) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 22958) 23002) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 22958) 22966) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 23010) 23002) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 23010) 22966) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon8_Else_correct))))
(let ((inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 22952) 23010) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 22952) 22958) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@12  (=> (and (and ((_ is $Integer) _x@@2) (>= (|i#$Integer| _x@@2) 0)) (<= (|i#$Integer| _x@@2) $MAX_U64)) (=> (and (and (and ((_ is $Integer) _y@@2) (>= (|i#$Integer| _y@@2) 0)) (<= (|i#$Integer| _y@@2) $MAX_U64)) (= (ControlFlow 0 22799) 22952)) inline$$TestAbortsIf_multi_abort4_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@12  (=> (= (ControlFlow 0 29326) 22799) anon0_correct@@12)))
PreconditionGeneratedEntry_correct@@12))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun x@@18 () T@$Value)
(declare-fun inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@1@@12 () Int)
(declare-fun inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29640) (let ((anon0$2_correct@@13  (and (=> (= (ControlFlow 0 23350) (- 0 29872)) (=> (|b#$Boolean| ($Boolean true)) $abort_flag@0@@9)) (=> (=> (|b#$Boolean| ($Boolean true)) $abort_flag@0@@9) (and (=> (= (ControlFlow 0 23350) (- 0 29881)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| x@@18) (|i#$Integer| ($Integer 0))))) $abort_flag@0@@9)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| x@@18) (|i#$Integer| ($Integer 0))))) $abort_flag@0@@9) (=> (= (ControlFlow 0 23350) (- 0 29900)) (=> $abort_flag@0@@9 (or (|b#$Boolean| ($Boolean true)) (|b#$Boolean| ($Boolean (> (|i#$Integer| x@@18) (|i#$Integer| ($Integer 0))))))))))))))
(let ((inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@0@@9 true) (= (ControlFlow 0 23328) 23350)) anon0$2_correct@@13)))
(let ((inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 23324) 23328)) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 23336) 23328) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon8_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t3@1) (=> (and (= inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t4@1 ($Integer 1)) (= $abort_code@1@@12 (|i#$Integer| inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 23318) 23336) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 23318) 23324) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon9_Else_correct))))))
(let ((inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon8_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t3@1)) (=> (and (= $abort_flag@0@@9 false) (= (ControlFlow 0 23304) 23350)) anon0$2_correct@@13))))
(let ((inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t2@1 ($Integer 0)) (= inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t3@1 ($Boolean ($IsEqual_stratified x@@18 inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$$t2@1)))) (and (=> (= (ControlFlow 0 23296) 23318) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 23296) 23304) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 23248) 23296)) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 23344) 23296) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 23242) 23344) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 23242) 23248) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@13  (=> (and (and (and ((_ is $Integer) x@@18) (>= (|i#$Integer| x@@18) 0)) (<= (|i#$Integer| x@@18) $MAX_U64)) (= (ControlFlow 0 23079) 23242)) inline$$TestAbortsIf_multi_abort5_incorrect_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@13  (=> (= (ControlFlow 0 29640) 23079) anon0_correct@@13)))
PreconditionGeneratedEntry_correct@@13)))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun inline$$TestAbortsIf_no_aborts_if_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $abort_code@1@@13 () Int)
(declare-fun _x@@3 () T@$Value)
(declare-fun _y@@3 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29932) (let ((inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon9_Else_correct true))
(let ((inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon9_Then_correct true))
(let ((inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon4_correct  (=> (and (= inline$$TestAbortsIf_no_aborts_if_$def_verify$0$$t2@1 ($Integer 1)) (= $abort_code@1@@13 (|i#$Integer| inline$$TestAbortsIf_no_aborts_if_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 23607) 23625) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 23607) 23613) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 23597) 23607)) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 23633) 23607) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 23589) 23633) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 23589) 23597) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 23641) 23633) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 23641) 23597) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon8_Else_correct))))
(let ((inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 23583) 23641) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 23583) 23589) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@14  (=> (and (and ((_ is $Integer) _x@@3) (>= (|i#$Integer| _x@@3) 0)) (<= (|i#$Integer| _x@@3) $MAX_U64)) (=> (and (and (and ((_ is $Integer) _y@@3) (>= (|i#$Integer| _y@@3) 0)) (<= (|i#$Integer| _y@@3) $MAX_U64)) (= (ControlFlow 0 23430) 23583)) inline$$TestAbortsIf_no_aborts_if_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@14  (=> (= (ControlFlow 0 29932) 23430) anon0_correct@@14)))
PreconditionGeneratedEntry_correct@@14)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@19 () T@$Value)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun |inline$$TestAbortsIf_succeed_$def_verify$0$tmp#$1@2| () T@$Value)
(declare-fun inline$$TestAbortsIf_succeed_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@1@@14 () Int)
(declare-fun inline$$TestAbortsIf_succeed_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_succeed_$def_verify$0$$t4@1 () T@$Value)
(declare-fun |inline$$TestAbortsIf_succeed_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$TestAbortsIf_succeed_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_succeed_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 30060) (let ((anon0$2_correct@@14  (=> (= (ControlFlow 0 24182) (- 0 30374)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified x@@19 ($Integer 2))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified x@@19 ($Integer 3)))))))) (not $abort_flag@0@@10)))))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@0@@10 true) (= (ControlFlow 0 24092) 24182)) anon0$2_correct@@14)))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 24088) 24092)) inline$$TestAbortsIf_succeed_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 24100) 24092) inline$$TestAbortsIf_succeed_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| |inline$$TestAbortsIf_succeed_$def_verify$0$tmp#$1@2|) (=> (and (= inline$$TestAbortsIf_succeed_$def_verify$0$$t7@1 ($Integer 1)) (= $abort_code@1@@14 (|i#$Integer| inline$$TestAbortsIf_succeed_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 24082) 24100) inline$$TestAbortsIf_succeed_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 24082) 24088) inline$$TestAbortsIf_succeed_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| |inline$$TestAbortsIf_succeed_$def_verify$0$tmp#$1@2|)) (=> (and (= $abort_flag@0@@10 false) (= (ControlFlow 0 24068) 24182)) anon0$2_correct@@14))))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon6_correct  (=> (= |inline$$TestAbortsIf_succeed_$def_verify$0$tmp#$1@2| inline$$TestAbortsIf_succeed_$def_verify$0$$t5@1) (and (=> (= (ControlFlow 0 24160) 24082) inline$$TestAbortsIf_succeed_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 24160) 24068) inline$$TestAbortsIf_succeed_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 24158) 24160)) inline$$TestAbortsIf_succeed_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 24168) 24160) inline$$TestAbortsIf_succeed_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon14_Then_correct  (=> (and (|b#$Boolean| inline$$TestAbortsIf_succeed_$def_verify$0$$t4@1) (= inline$$TestAbortsIf_succeed_$def_verify$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 24150) 24168) inline$$TestAbortsIf_succeed_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 24150) 24158) inline$$TestAbortsIf_succeed_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon8_correct  (=> (= |inline$$TestAbortsIf_succeed_$def_verify$0$tmp#$1@2| |inline$$TestAbortsIf_succeed_$def_verify$0$tmp#$1@1|) (and (=> (= (ControlFlow 0 24058) 24082) inline$$TestAbortsIf_succeed_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 24058) 24068) inline$$TestAbortsIf_succeed_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 24056) 24058)) inline$$TestAbortsIf_succeed_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 24108) 24058) inline$$TestAbortsIf_succeed_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon14_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIf_succeed_$def_verify$0$$t4@1)) (=> (and (= inline$$TestAbortsIf_succeed_$def_verify$0$$t6@1 ($Integer 3)) (= |inline$$TestAbortsIf_succeed_$def_verify$0$tmp#$1@1| ($Boolean ($IsEqual_stratified x@@19 inline$$TestAbortsIf_succeed_$def_verify$0$$t6@1)))) (and (=> (= (ControlFlow 0 24050) 24108) inline$$TestAbortsIf_succeed_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 24050) 24056) inline$$TestAbortsIf_succeed_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIf_succeed_$def_verify$0$$t3@1 ($Integer 2)) (= inline$$TestAbortsIf_succeed_$def_verify$0$$t4@1 ($Boolean ($IsEqual_stratified x@@19 inline$$TestAbortsIf_succeed_$def_verify$0$$t3@1)))) (and (=> (= (ControlFlow 0 24030) 24150) inline$$TestAbortsIf_succeed_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 24030) 24050) inline$$TestAbortsIf_succeed_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 23982) 24030)) inline$$TestAbortsIf_succeed_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 24176) 24030) inline$$TestAbortsIf_succeed_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_succeed_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 23976) 24176) inline$$TestAbortsIf_succeed_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 23976) 23982) inline$$TestAbortsIf_succeed_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@15  (=> (and (and (and ((_ is $Integer) x@@19) (>= (|i#$Integer| x@@19) 0)) (<= (|i#$Integer| x@@19) $MAX_U64)) (= (ControlFlow 0 23710) 23976)) inline$$TestAbortsIf_succeed_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@15  (=> (= (ControlFlow 0 30060) 23710) anon0_correct@@15)))
PreconditionGeneratedEntry_correct@@15)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@20 () T@$Value)
(declare-fun $abort_flag@0@@11 () Bool)
(declare-fun |inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$tmp#$1@2| () T@$Value)
(declare-fun inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@1@@15 () Int)
(declare-fun inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t4@1 () T@$Value)
(declare-fun |inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 30417) (let ((anon0$2_correct@@15  (and (=> (= (ControlFlow 0 24758) (- 0 30729)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@20 ($Integer 2)))) (not $abort_flag@0@@11))) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@20 ($Integer 2)))) (not $abort_flag@0@@11)) (=> (= (ControlFlow 0 24758) (- 0 30746)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@20 ($Integer 4)))) (not $abort_flag@0@@11)))))))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@0@@11 true) (= (ControlFlow 0 24668) 24758)) anon0$2_correct@@15)))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 24664) 24668)) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 24676) 24668) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| |inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$tmp#$1@2|) (=> (and (= inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t7@1 ($Integer 1)) (= $abort_code@1@@15 (|i#$Integer| inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 24658) 24676) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 24658) 24664) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| |inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$tmp#$1@2|)) (=> (and (= $abort_flag@0@@11 false) (= (ControlFlow 0 24644) 24758)) anon0$2_correct@@15))))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon6_correct  (=> (= |inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$tmp#$1@2| inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t5@1) (and (=> (= (ControlFlow 0 24736) 24658) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 24736) 24644) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 24734) 24736)) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 24744) 24736) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon14_Then_correct  (=> (and (|b#$Boolean| inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t4@1) (= inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 24726) 24744) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 24726) 24734) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon8_correct  (=> (= |inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$tmp#$1@2| |inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$tmp#$1@1|) (and (=> (= (ControlFlow 0 24634) 24658) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 24634) 24644) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 24632) 24634)) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 24684) 24634) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon14_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t4@1)) (=> (and (= inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t6@1 ($Integer 3)) (= |inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$tmp#$1@1| ($Boolean ($IsEqual_stratified x@@20 inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t6@1)))) (and (=> (= (ControlFlow 0 24626) 24684) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 24626) 24632) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t3@1 ($Integer 2)) (= inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t4@1 ($Boolean ($IsEqual_stratified x@@20 inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$$t3@1)))) (and (=> (= (ControlFlow 0 24606) 24726) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 24606) 24626) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 24558) 24606)) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 24752) 24606) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 24552) 24752) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 24552) 24558) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@16  (=> (and (and (and ((_ is $Integer) x@@20) (>= (|i#$Integer| x@@20) 0)) (<= (|i#$Integer| x@@20) $MAX_U64)) (= (ControlFlow 0 24286) 24552)) inline$$TestAbortsIf_succeed_incorrect_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@16  (=> (= (ControlFlow 0 30417) 24286) anon0_correct@@16)))
PreconditionGeneratedEntry_correct@@16)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
