(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun x@@8 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun $abort_code@0 () Int)
(declare-fun inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 18690) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 12783) (- 0 19249)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 0)))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 0)))) $abort_flag@2) (and (=> (= (ControlFlow 0 12783) (- 0 19264)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 0)))))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 0))))) (=> (= (ControlFlow 0 12783) (- 0 19279)) (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 0)))) (= $abort_code@4 (|i#$Integer| ($Integer 43))))))))))))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$ret0@1 $Error) (= $abort_flag@2 true)) (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 12737) 12783))) anon0$2_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon6_correct  (=> (and (= $abort_code@3 $abort_code@1) (= (ControlFlow 0 12759) 12737)) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 12757) 12759)) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 12767) 12759) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon12_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t3@1) (=> (and (= inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t4@1 ($Integer 43)) (= $abort_code@1 (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 12751) 12767) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 12751) 12757) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon14_Then_correct  (=> $abort_flag@1 (=> (and (= $abort_code@3 $abort_code@2) (= (ControlFlow 0 12731) 12737)) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$Abort_correct))))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon10_correct  (=> (= $abort_flag@2 $abort_flag@1) (=> (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 12719) 12783)) anon0$2_correct))))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 12717) 12719)) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 12727) 12719) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon14_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 12711) 12727) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 12711) 12717) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon5_correct  (=> (and (= inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$ret0@1 $Error) (= $abort_flag@1 true)) (and (=> (= (ControlFlow 0 12671) 12731) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 12671) 12711) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 12665) 12671)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon5_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Then_correct  (=> (= (ControlFlow 0 12679) 12671) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon5_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 12659) 12679) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Then_correct) (=> (= (ControlFlow 0 12659) 12665) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon8_correct  (=> (= $abort_flag@1 $abort_flag@0) (and (=> (= (ControlFlow 0 12647) 12731) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 12647) 12711) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 12645) 12647)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon8_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Then_correct  (=> (= (ControlFlow 0 12655) 12647) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon8_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 12639) 12655) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Then_correct) (=> (= (ControlFlow 0 12639) 12645) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= $abort_code@2 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 12623) 12659) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Then_correct) (=> (= (ControlFlow 0 12623) 12639) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| x@@8) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1)) (= (ControlFlow 0 12621) 12623)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1) (|i#$Integer| x@@8)) (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| x@@8) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1))))) (and (= $abort_flag@0 false) (= $abort_code@2 $abort_code@0))) (and (=> (= (ControlFlow 0 12569) 12659) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Then_correct) (=> (= (ControlFlow 0 12569) 12639) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 12543) (- 0 19055)) true) (and (=> (= (ControlFlow 0 12543) 12621) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 12543) 12569) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 12629) 12543)) inline$$Sub$0$Entry_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 12420) 12629)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 12687) 12629) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 12414) 12687) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 12414) 12420) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$anon0_correct  (=> (and (and (and ((_ is $Integer) x@@8) (>= (|i#$Integer| x@@8) 0)) (<= (|i#$Integer| x@@8) $MAX_U64)) (= (ControlFlow 0 12693) 12414)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon0_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$Entry_correct  (and (=> (= (ControlFlow 0 12231) (- 0 18971)) (not (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 0)))))) (=> (not (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 0))))) (=> (= (ControlFlow 0 12231) 12693) inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$anon0_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon12_Else_correct  (=> (and (not (|b#$Boolean| inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t3@1)) (= (ControlFlow 0 12701) 12231)) inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$Entry_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t2@1 ($Integer 0)) (= inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t3@1 ($Boolean ($IsEqual_stratified x@@8 inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$$t2@1)))) (and (=> (= (ControlFlow 0 12156) 12751) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 12156) 12701) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 12108) 12156)) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 12775) 12156) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 12102) 12775) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 12102) 12108) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct  (=> (and (and (and ((_ is $Integer) x@@8) (>= (|i#$Integer| x@@8) 0)) (<= (|i#$Integer| x@@8) $MAX_U64)) (= (ControlFlow 0 11878) 12102)) inline$$TestAbortsIfAssumeAssert_assert_caller_aborts_with_logical_error_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 18690) 11878) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@9 () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19318) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 13392) (- 0 19600)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 0)))) $abort_flag@1@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 0)))) $abort_flag@1@@0) (=> (= (ControlFlow 0 13392) (- 0 19615)) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 0))))))))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon5_correct  (=> (= inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@0 true) (= (ControlFlow 0 13368) 13392)) anon0$2_correct@@0))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 13362) 13368)) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon5_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 13376) 13368) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon5_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 13356) 13376) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 13356) 13362) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon8_correct  (=> (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= (ControlFlow 0 13344) 13392)) anon0$2_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 13342) 13344)) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 13352) 13344) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 13336) 13352) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 13336) 13342) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@0@@0 true) (and (=> (= (ControlFlow 0 13320) 13356) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 13320) 13336) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| x@@9) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$$t2@1)) (= (ControlFlow 0 13318) 13320)) inline$$Sub$0$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$0$anon3_Else_correct@@0  (=> (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$$t2@1) (|i#$Integer| x@@9)) (=> (and (= inline$$Sub$0$dst@1@@0 ($Integer (- (|i#$Integer| x@@9) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$$t2@1)))) (= $abort_flag@0@@0 false)) (and (=> (= (ControlFlow 0 13266) 13356) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 13266) 13336) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon10_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 13240) (- 0 19485)) true) (and (=> (= (ControlFlow 0 13240) 13318) inline$$Sub$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 13240) 13266) inline$$Sub$0$anon3_Else_correct@@0)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 13326) 13240)) inline$$Sub$0$Entry_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 13117) 13326)) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 13384) 13326) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13111) 13384) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 13111) 13117) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and (and ((_ is $Integer) x@@9) (>= (|i#$Integer| x@@9) 0)) (<= (|i#$Integer| x@@9) $MAX_U64)) (= (ControlFlow 0 12932) 13111)) inline$$TestAbortsIfAssumeAssert_asserted_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 19318) 12932) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1 () T@$Value)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19634) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 14176) (- 0 20002)) (not $abort_flag@2@@0))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon4_correct  (=> (and (= $abort_flag@2@@0 $abort_flag@1@@1) (= (ControlFlow 0 14152) 14176)) anon0$2_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 14150) 14152)) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 14160) 14152) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon5_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 14144) 14160) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 14144) 14150) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon5_Then_correct  (=> (and (and $abort_flag@1@@1 (= inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@2@@0 true) (= (ControlFlow 0 14168) 14176))) anon0$2_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon5_correct@@0  (=> (and (= inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$ret0@1@@0 $Error) (= $abort_flag@1@@1 true)) (and (=> (= (ControlFlow 0 14104) 14168) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 14104) 14144) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 14098) 14104)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon5_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Then_correct@@0  (=> (= (ControlFlow 0 14112) 14104) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon5_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Then_correct@@0  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 14092) 14112) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Then_correct@@0) (=> (= (ControlFlow 0 14092) 14098) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Else_correct@@0)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon8_correct@@0  (=> (= $abort_flag@1@@1 $abort_flag@0@@1) (and (=> (= (ControlFlow 0 14080) 14168) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 14080) 14144) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 14078) 14080)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon8_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Then_correct@@0  (=> (= (ControlFlow 0 14088) 14080) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon8_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Else_correct@@0  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 14072) 14088) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Then_correct@@0) (=> (= (ControlFlow 0 14072) 14078) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Else_correct@@0)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@0@@1 true) (and (=> (= (ControlFlow 0 14056) 14092) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Then_correct@@0) (=> (= (ControlFlow 0 14056) 14072) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Else_correct@@0)))))
(let ((inline$$Sub$0$anon3_Then_correct@@1  (=> (and (< (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@0)) (= (ControlFlow 0 14054) 14056)) inline$$Sub$0$anon3_Then$1_correct@@1)))
(let ((inline$$Sub$0$anon3_Else_correct@@1  (=> (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@0) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1)) (=> (and (= inline$$Sub$0$dst@1@@1 ($Integer (- (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@0)))) (= $abort_flag@0@@1 false)) (and (=> (= (ControlFlow 0 14002) 14092) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Then_correct@@0) (=> (= (ControlFlow 0 14002) 14072) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Else_correct@@0))))))
(let ((inline$$Sub$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 13976) (- 0 19845)) true) (and (=> (= (ControlFlow 0 13976) 14054) inline$$Sub$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 13976) 14002) inline$$Sub$0$anon3_Else_correct@@1)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon2$1_correct@@0  (=> (and (= inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@0 ($Integer 1)) (= (ControlFlow 0 14062) 13976)) inline$$Sub$0$Entry_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 13853) 14062)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon2$1_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Then_correct@@0  (=> (= (ControlFlow 0 14120) 14062) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon2$1_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon0_correct@@0  (=> (not false) (and (=> (= (ControlFlow 0 13847) 14120) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 13847) 13853) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Else_correct@@0)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1) (>= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1) 0)) (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1) $MAX_U64)) (= (ControlFlow 0 14126) 13847)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon0_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 13664) (- 0 19761)) (not (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1 ($Integer 0)))))) (=> (not (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1 ($Integer 0))))) (=> (= (ControlFlow 0 13664) 14126) inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$anon0_correct@@0)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$$t0@1 ($Integer 1)) (= (ControlFlow 0 14134) 13664)) inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$Entry_correct@@0))))
(let ((anon0_correct@@1  (=> (= (ControlFlow 0 19634) 14134) inline$$TestAbortsIfAssumeAssert_asserted_caller_$def_verify$0$anon0_correct)))
anon0_correct@@1)))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$ret0@1@@1 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1 () T@$Value)
(declare-fun inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20009) (let ((anon0$2_correct@@2  (=> (= (ControlFlow 0 14984) (- 0 20377)) (not $abort_flag@2@@1))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon4_correct  (=> (and (= $abort_flag@2@@1 $abort_flag@1@@2) (= (ControlFlow 0 14960) 14984)) anon0$2_correct@@2)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 14958) 14960)) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 14968) 14960) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon5_Else_correct  (=> (not $abort_flag@1@@2) (and (=> (= (ControlFlow 0 14952) 14968) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 14952) 14958) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon5_Then_correct  (=> (and (and $abort_flag@1@@2 (= inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@2@@1 true) (= (ControlFlow 0 14976) 14984))) anon0$2_correct@@2)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon5_correct@@1  (=> (and (= inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$ret0@1@@1 $Error) (= $abort_flag@1@@2 true)) (and (=> (= (ControlFlow 0 14912) 14976) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 14912) 14952) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 14906) 14912)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon5_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Then_correct@@1  (=> (= (ControlFlow 0 14920) 14912) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon5_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Then_correct@@1  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 14900) 14920) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Then_correct@@1) (=> (= (ControlFlow 0 14900) 14906) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon11_Else_correct@@1)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon8_correct@@1  (=> (= $abort_flag@1@@2 $abort_flag@0@@2) (and (=> (= (ControlFlow 0 14888) 14976) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 14888) 14952) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 14886) 14888)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon8_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Then_correct@@1  (=> (= (ControlFlow 0 14896) 14888) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon8_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Else_correct@@1  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 14880) 14896) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Then_correct@@1) (=> (= (ControlFlow 0 14880) 14886) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon12_Else_correct@@1)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@0@@2 true) (and (=> (= (ControlFlow 0 14864) 14900) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Then_correct@@1) (=> (= (ControlFlow 0 14864) 14880) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Else_correct@@1)))))
(let ((inline$$Sub$0$anon3_Then_correct@@2  (=> (and (< (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@1)) (= (ControlFlow 0 14862) 14864)) inline$$Sub$0$anon3_Then$1_correct@@2)))
(let ((inline$$Sub$0$anon3_Else_correct@@2  (=> (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@1) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1)) (=> (and (= inline$$Sub$0$dst@1@@2 ($Integer (- (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@1)))) (= $abort_flag@0@@2 false)) (and (=> (= (ControlFlow 0 14810) 14900) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Then_correct@@1) (=> (= (ControlFlow 0 14810) 14880) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon10_Else_correct@@1))))))
(let ((inline$$Sub$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 14784) (- 0 20220)) true) (and (=> (= (ControlFlow 0 14784) 14862) inline$$Sub$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 14784) 14810) inline$$Sub$0$anon3_Else_correct@@2)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon2$1_correct@@1  (=> (and (= inline$$TestAbortsIfAssumeAssert_asserted_$def$0$$t2@1@@1 ($Integer 1)) (= (ControlFlow 0 14870) 14784)) inline$$Sub$0$Entry_correct@@2)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 14661) 14870)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon2$1_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Then_correct@@1  (=> (= (ControlFlow 0 14928) 14870) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon2$1_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon0_correct@@1  (=> (not false) (and (=> (= (ControlFlow 0 14655) 14928) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Then_correct@@1) (=> (= (ControlFlow 0 14655) 14661) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon9_Else_correct@@1)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$anon0_correct@@1  (=> (and (and (and ((_ is $Integer) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1) (>= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1) 0)) (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1) $MAX_U64)) (= (ControlFlow 0 14934) 14655)) inline$$TestAbortsIfAssumeAssert_asserted_$def$0$anon0_correct@@1)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 14472) (- 0 20136)) (not (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1 ($Integer 0)))))) (=> (not (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1 ($Integer 0))))) (=> (= (ControlFlow 0 14472) 14934) inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$anon0_correct@@1)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$$t0@1 ($Integer 0)) (= (ControlFlow 0 14942) 14472)) inline$$TestAbortsIfAssumeAssert_asserted_$direct_intra$0$Entry_correct@@1))))
(let ((anon0_correct@@2  (=> (= (ControlFlow 0 20009) 14942) inline$$TestAbortsIfAssumeAssert_asserted_caller_invalid_$def_verify$0$anon0_correct)))
anon0_correct@@2)))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@10 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20385) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 15297) (- 0 20528)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@10 ($Integer 1)))) false)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@10 ($Integer 1)))) false) (=> (= (ControlFlow 0 15297) (- 0 20543)) (=> false (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@10 ($Integer 1))))))))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 15271) 15297)) anon0$2_correct@@3)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 15281) 15297) anon0$2_correct@@3)))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon5_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15227) 15281) inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 15227) 15271) inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon5_Then_correct  (and (=> (= (ControlFlow 0 15289) 15281) inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 15289) 15271) inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon6_Else_correct))))
(let ((inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15221) 15289) inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 15221) 15227) inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct  (=> (and (|b#$Boolean| ($Boolean (> (|i#$Integer| x@@10) (|i#$Integer| ($Integer 0))))) (= (ControlFlow 0 15295) 15221)) inline$$TestAbortsIfAssumeAssert_asserted_spec_invalid_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and (and ((_ is $Integer) x@@10) (>= (|i#$Integer| x@@10) 0)) (<= (|i#$Integer| x@@10) $MAX_U64)) (= (ControlFlow 0 15103) 15295)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 20385) 15103) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@1))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@11 () T@$Value)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@3 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20563) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 15830) (- 0 20845)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@11 ($Integer 0)))) $abort_flag@1@@3)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@11 ($Integer 0)))) $abort_flag@1@@3) (=> (= (ControlFlow 0 15830) (- 0 20860)) (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@11 ($Integer 0))))))))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon5_correct  (=> (= inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@3 true) (= (ControlFlow 0 15806) 15830)) anon0$2_correct@@4))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 15800) 15806)) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon5_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 15814) 15806) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon5_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 15794) 15814) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 15794) 15800) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon8_correct  (=> (and (= $abort_flag@1@@3 $abort_flag@0@@3) (= (ControlFlow 0 15782) 15830)) anon0$2_correct@@4)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 15780) 15782)) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 15790) 15782) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@3) (and (=> (= (ControlFlow 0 15774) 15790) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 15774) 15780) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@3  (=> (= $abort_flag@0@@3 true) (and (=> (= (ControlFlow 0 15758) 15794) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 15758) 15774) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@3  (=> (and (< (|i#$Integer| x@@11) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$$t2@1)) (= (ControlFlow 0 15756) 15758)) inline$$Sub$0$anon3_Then$1_correct@@3)))
(let ((inline$$Sub$0$anon3_Else_correct@@3  (=> (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$$t2@1) (|i#$Integer| x@@11)) (=> (and (= inline$$Sub$0$dst@1@@3 ($Integer (- (|i#$Integer| x@@11) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$$t2@1)))) (= $abort_flag@0@@3 false)) (and (=> (= (ControlFlow 0 15704) 15794) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 15704) 15774) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon10_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 15678) (- 0 20730)) true) (and (=> (= (ControlFlow 0 15678) 15756) inline$$Sub$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 15678) 15704) inline$$Sub$0$anon3_Else_correct@@3)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 15764) 15678)) inline$$Sub$0$Entry_correct@@3)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 15555) 15764)) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 15822) 15764) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15549) 15822) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 15549) 15555) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@4  (=> (and (and (and ((_ is $Integer) x@@11) (>= (|i#$Integer| x@@11) 0)) (<= (|i#$Integer| x@@11) $MAX_U64)) (= (ControlFlow 0 15370) 15549)) inline$$TestAbortsIfAssumeAssert_assumed_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 20563) 15370) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun x@@12 () T@$Value)
(declare-fun inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@4 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20880) (let ((anon0$2_correct@@5  (=> (= (ControlFlow 0 16693) (- 0 21273)) (not $abort_flag@2@@2))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@2@@2 $abort_flag@1@@4) (= (ControlFlow 0 16661) 16693)) anon0$2_correct@@5)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 16659) 16661)) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 16669) 16661) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@1@@4) (and (=> (= (ControlFlow 0 16653) 16669) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 16653) 16659) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon8_Then_correct  (=> (and (and $abort_flag@1@@4 (= inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@2@@2 true) (= (ControlFlow 0 16677) 16693))) anon0$2_correct@@5)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon5_correct  (=> (and (= inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$ret0@1 $Error) (= $abort_flag@1@@4 true)) (and (=> (= (ControlFlow 0 16613) 16677) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 16613) 16653) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 16607) 16613)) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon5_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon11_Then_correct  (=> (= (ControlFlow 0 16621) 16613) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon5_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 16601) 16621) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon11_Then_correct) (=> (= (ControlFlow 0 16601) 16607) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon11_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon8_correct  (=> (= $abort_flag@1@@4 $abort_flag@0@@4) (and (=> (= (ControlFlow 0 16589) 16677) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 16589) 16653) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 16587) 16589)) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon8_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon12_Then_correct  (=> (= (ControlFlow 0 16597) 16589) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon8_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Else_correct  (=> (not $abort_flag@0@@4) (and (=> (= (ControlFlow 0 16581) 16597) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon12_Then_correct) (=> (= (ControlFlow 0 16581) 16587) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon12_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@4  (=> (= $abort_flag@0@@4 true) (and (=> (= (ControlFlow 0 16565) 16601) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Then_correct) (=> (= (ControlFlow 0 16565) 16581) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@4  (=> (and (< (|i#$Integer| x@@12) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1)) (= (ControlFlow 0 16563) 16565)) inline$$Sub$0$anon3_Then$1_correct@@4)))
(let ((inline$$Sub$0$anon3_Else_correct@@4  (=> (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1) (|i#$Integer| x@@12)) (=> (and (= inline$$Sub$0$dst@1@@4 ($Integer (- (|i#$Integer| x@@12) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1)))) (= $abort_flag@0@@4 false)) (and (=> (= (ControlFlow 0 16511) 16601) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Then_correct) (=> (= (ControlFlow 0 16511) 16581) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 16485) (- 0 21116)) true) (and (=> (= (ControlFlow 0 16485) 16563) inline$$Sub$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 16485) 16511) inline$$Sub$0$anon3_Else_correct@@4)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 16571) 16485)) inline$$Sub$0$Entry_correct@@4)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 16362) 16571)) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 16629) 16571) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16356) 16629) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 16356) 16362) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon9_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$direct_intra$0$anon0_correct  (=> (and (and (and ((_ is $Integer) x@@12) (>= (|i#$Integer| x@@12) 0)) (<= (|i#$Integer| x@@12) $MAX_U64)) (and (not (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@12 ($Integer 0))))) (= (ControlFlow 0 16635) 16356))) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon0_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 16070) 16635)) inline$$TestAbortsIfAssumeAssert_assumed_$direct_intra$0$anon0_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 16685) 16635) inline$$TestAbortsIfAssumeAssert_assumed_$direct_intra$0$anon0_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16064) 16685) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 16064) 16070) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@5  (=> (and (and (and ((_ is $Integer) x@@12) (>= (|i#$Integer| x@@12) 0)) (<= (|i#$Integer| x@@12) $MAX_U64)) (= (ControlFlow 0 15925) 16064)) inline$$TestAbortsIfAssumeAssert_assumed_caller_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 20880) 15925) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$t0@1 () T@$Value)
(declare-fun inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@5 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21280) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 17517) (- 0 21669)) (not $abort_flag@2@@3)) (=> (not $abort_flag@2@@3) (=> (= (ControlFlow 0 17517) (- 0 21672)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean true) ($Boolean false))))))))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon4_correct  (=> (and (= $abort_flag@2@@3 $abort_flag@1@@5) (= (ControlFlow 0 17493) 17517)) anon0$2_correct@@6)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 17491) 17493)) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 17501) 17493) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon4_correct)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon5_Else_correct  (=> (not $abort_flag@1@@5) (and (=> (= (ControlFlow 0 17485) 17501) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 17485) 17491) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon5_Then_correct  (=> (and (and $abort_flag@1@@5 (= inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@2@@3 true) (= (ControlFlow 0 17509) 17517))) anon0$2_correct@@6)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon5_correct@@0  (=> (and (= inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$ret0@1@@0 $Error) (= $abort_flag@1@@5 true)) (and (=> (= (ControlFlow 0 17445) 17509) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 17445) 17485) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon11_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 17439) 17445)) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon5_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon11_Then_correct@@0  (=> (= (ControlFlow 0 17453) 17445) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon5_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Then_correct@@0  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 17433) 17453) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon11_Then_correct@@0) (=> (= (ControlFlow 0 17433) 17439) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon11_Else_correct@@0)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon8_correct@@0  (=> (= $abort_flag@1@@5 $abort_flag@0@@5) (and (=> (= (ControlFlow 0 17421) 17509) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 17421) 17485) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon12_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 17419) 17421)) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon8_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon12_Then_correct@@0  (=> (= (ControlFlow 0 17429) 17421) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon8_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Else_correct@@0  (=> (not $abort_flag@0@@5) (and (=> (= (ControlFlow 0 17413) 17429) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon12_Then_correct@@0) (=> (= (ControlFlow 0 17413) 17419) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon12_Else_correct@@0)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@5  (=> (= $abort_flag@0@@5 true) (and (=> (= (ControlFlow 0 17397) 17433) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Then_correct@@0) (=> (= (ControlFlow 0 17397) 17413) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Else_correct@@0)))))
(let ((inline$$Sub$0$anon3_Then_correct@@5  (=> (and (< (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$t0@1) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1@@0)) (= (ControlFlow 0 17395) 17397)) inline$$Sub$0$anon3_Then$1_correct@@5)))
(let ((inline$$Sub$0$anon3_Else_correct@@5  (=> (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1@@0) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$t0@1)) (=> (and (= inline$$Sub$0$dst@1@@5 ($Integer (- (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$t0@1) (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1@@0)))) (= $abort_flag@0@@5 false)) (and (=> (= (ControlFlow 0 17343) 17433) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Then_correct@@0) (=> (= (ControlFlow 0 17343) 17413) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon10_Else_correct@@0))))))
(let ((inline$$Sub$0$Entry_correct@@5  (and (=> (= (ControlFlow 0 17317) (- 0 21512)) true) (and (=> (= (ControlFlow 0 17317) 17395) inline$$Sub$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 17317) 17343) inline$$Sub$0$anon3_Else_correct@@5)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon2$1_correct@@0  (=> (and (= inline$$TestAbortsIfAssumeAssert_assumed_$def$0$$t2@1@@0 ($Integer 1)) (= (ControlFlow 0 17403) 17317)) inline$$Sub$0$Entry_correct@@5)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon9_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 17194) 17403)) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon2$1_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon9_Then_correct@@0  (=> (= (ControlFlow 0 17461) 17403) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon2$1_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon0_correct@@0  (=> (not false) (and (=> (= (ControlFlow 0 17188) 17461) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 17188) 17194) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon9_Else_correct@@0)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_$direct_intra$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$t0@1) (>= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$t0@1) 0)) (<= (|i#$Integer| inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$t0@1) $MAX_U64)) (and (not (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$t0@1 ($Integer 0))))) (= (ControlFlow 0 17467) 17188))) inline$$TestAbortsIfAssumeAssert_assumed_$def$0$anon0_correct@@0)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$$t0@1 ($Integer 0)) (= (ControlFlow 0 17475) 17467)) inline$$TestAbortsIfAssumeAssert_assumed_$direct_intra$0$anon0_correct@@0))))
(let ((anon0_correct@@6  (=> (= (ControlFlow 0 21280) 17475) inline$$TestAbortsIfAssumeAssert_assumed_caller_unsound_$def_verify$0$anon0_correct)))
anon0_correct@@6))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@13 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21696) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 17814) (- 0 21823)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@13 ($Integer 1)))) false)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@13 ($Integer 1)))) false) (=> (= (ControlFlow 0 17814) (- 0 21838)) (=> false (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@13 ($Integer 1))))))))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 17788) 17814)) anon0$2_correct@@7)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 17798) 17814) anon0$2_correct@@7)))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon5_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17744) 17798) inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 17744) 17788) inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon5_Then_correct  (and (=> (= (ControlFlow 0 17806) 17798) inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 17806) 17788) inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon6_Else_correct))))
(let ((inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17738) 17806) inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 17738) 17744) inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon5_Else_correct)))))
(let ((anon0_correct@@7  (=> (and (and (and ((_ is $Integer) x@@13) (>= (|i#$Integer| x@@13) 0)) (<= (|i#$Integer| x@@13) $MAX_U64)) (= (ControlFlow 0 17636) 17738)) inline$$TestAbortsIfAssumeAssert_assumed_spec_invalid_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 21696) 17636) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@4)))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
