(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun x@@8 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@0 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19837) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 14287) (- 0 20211)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 1)))) $abort_flag@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 1)))) $abort_flag@0) (and (=> (= (ControlFlow 0 14287) (- 0 20226)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 2)))) $abort_flag@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 2)))) $abort_flag@0) (and (=> (= (ControlFlow 0 14287) (- 0 20241)) (=> $abort_flag@0 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 2))))))) (=> (=> $abort_flag@0 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 2)))))) (=> (= (ControlFlow 0 14287) (- 0 20270)) (=> $abort_flag@0 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 1)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 2)))) (= $abort_code@4 (|i#$Integer| ($Integer 2)))))))))))))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$Abort_correct  (=> (= $abort_flag@0 true) (=> (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 14235) 14287)) anon0$2_correct))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon6_correct  (=> (and (= $abort_code@3 $abort_code@1) (= (ControlFlow 0 14265) 14235)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 14263) 14265)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 14273) 14265) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon12_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t3@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t4@1 ($Integer 1)) (= $abort_code@1 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 14257) 14273) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 14257) 14263) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon10_correct  (=> (and (= $abort_code@3 $abort_code@2) (= (ControlFlow 0 14231) 14235)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 14229) 14231)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 14243) 14231) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon14_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t6@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t7@1 ($Integer 2)) (= $abort_code@2 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 14223) 14243) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 14223) 14229) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon14_Else_correct  (=> (and (and (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t6@1)) (= $abort_flag@0 false)) (and (= $abort_code@4 $abort_code@0) (= (ControlFlow 0 14209) 14287))) anon0$2_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon12_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t3@1)) (=> (and (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t5@1 ($Integer 2)) (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified x@@8 inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t5@1)))) (and (=> (= (ControlFlow 0 14201) 14223) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 14201) 14209) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t2@1 ($Integer 1)) (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t3@1 ($Boolean ($IsEqual_stratified x@@8 inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$$t2@1)))) (and (=> (= (ControlFlow 0 14181) 14257) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 14181) 14201) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 14133) 14181)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 14281) 14181) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14127) 14281) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 14127) 14133) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct  (=> (and (and (and ((_ is $Integer) x@@8) (>= (|i#$Integer| x@@8) 0)) (<= (|i#$Integer| x@@8) $MAX_U64)) (= (ControlFlow 0 13882) 14127)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 19837) 13882) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@9 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@0@@0 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20322) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 14782) (- 0 20696)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 1)))) $abort_flag@0@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 1)))) $abort_flag@0@@0) (and (=> (= (ControlFlow 0 14782) (- 0 20711)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 2)))) $abort_flag@0@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 2)))) $abort_flag@0@@0) (and (=> (= (ControlFlow 0 14782) (- 0 20726)) (=> $abort_flag@0@@0 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 2))))))) (=> (=> $abort_flag@0@@0 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 2)))))) (=> (= (ControlFlow 0 14782) (- 0 20755)) (=> $abort_flag@0@@0 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 1)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 2)))) (= $abort_code@4@@0 (|i#$Integer| ($Integer 1)))))))))))))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$Abort_correct  (=> (= $abort_flag@0@@0 true) (=> (and (= $abort_code@4@@0 $abort_code@3@@0) (= (ControlFlow 0 14730) 14782)) anon0$2_correct@@0))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon6_correct  (=> (and (= $abort_code@3@@0 $abort_code@1@@0) (= (ControlFlow 0 14760) 14730)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 14758) 14760)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 14768) 14760) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon12_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t3@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t4@1 ($Integer 1)) (= $abort_code@1@@0 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 14752) 14768) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 14752) 14758) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon10_correct  (=> (and (= $abort_code@3@@0 $abort_code@2@@0) (= (ControlFlow 0 14726) 14730)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 14724) 14726)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 14738) 14726) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon14_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t6@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t7@1 ($Integer 2)) (= $abort_code@2@@0 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 14718) 14738) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 14718) 14724) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon14_Else_correct  (=> (and (and (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t6@1)) (= $abort_flag@0@@0 false)) (and (= $abort_code@4@@0 $abort_code@0@@0) (= (ControlFlow 0 14704) 14782))) anon0$2_correct@@0)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon12_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t3@1)) (=> (and (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t5@1 ($Integer 2)) (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified x@@9 inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t5@1)))) (and (=> (= (ControlFlow 0 14696) 14718) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 14696) 14704) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t2@1 ($Integer 1)) (= inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t3@1 ($Boolean ($IsEqual_stratified x@@9 inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$$t2@1)))) (and (=> (= (ControlFlow 0 14676) 14752) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 14676) 14696) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 14628) 14676)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 14776) 14676) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14622) 14776) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 14622) 14628) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and (and ((_ is $Integer) x@@9) (>= (|i#$Integer| x@@9) 0)) (<= (|i#$Integer| x@@9) $MAX_U64)) (= (ControlFlow 0 14377) 14622)) inline$$TestAbortsIfWithCode_aborts_if_with_code_mixed_invalid_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 20322) 14377) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@0@@1 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t5@1 () T@$Value)
(declare-fun x@@10 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20799) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 15277) (- 0 21092)) (=> $abort_flag@0@@1 (or (= $abort_code@4@@1 (|i#$Integer| ($Integer 1))) (= $abort_code@4@@1 (|i#$Integer| ($Integer 2))))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$Abort_correct  (=> (= $abort_flag@0@@1 true) (=> (and (= $abort_code@4@@1 $abort_code@3@@1) (= (ControlFlow 0 15225) 15277)) anon0$2_correct@@1))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon6_correct  (=> (and (= $abort_code@3@@1 $abort_code@1@@1) (= (ControlFlow 0 15255) 15225)) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 15253) 15255)) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 15263) 15255) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon12_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t3@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t4@1 ($Integer 1)) (= $abort_code@1@@1 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 15247) 15263) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 15247) 15253) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon10_correct  (=> (and (= $abort_code@3@@1 $abort_code@2@@1) (= (ControlFlow 0 15221) 15225)) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 15219) 15221)) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 15233) 15221) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon14_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t6@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t7@1 ($Integer 2)) (= $abort_code@2@@1 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 15213) 15233) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 15213) 15219) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon14_Else_correct  (=> (and (and (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t6@1)) (= $abort_flag@0@@1 false)) (and (= $abort_code@4@@1 $abort_code@0@@1) (= (ControlFlow 0 15199) 15277))) anon0$2_correct@@1)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon12_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t3@1)) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t5@1 ($Integer 2)) (= inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified x@@10 inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t5@1)))) (and (=> (= (ControlFlow 0 15191) 15213) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 15191) 15199) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t2@1 ($Integer 1)) (= inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t3@1 ($Boolean ($IsEqual_stratified x@@10 inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$$t2@1)))) (and (=> (= (ControlFlow 0 15171) 15247) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 15171) 15191) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 15123) 15171)) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 15271) 15171) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15117) 15271) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 15117) 15123) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@1  (=> (and (and (and ((_ is $Integer) x@@10) (>= (|i#$Integer| x@@10) 0)) (<= (|i#$Integer| x@@10) $MAX_U64)) (= (ControlFlow 0 14872) 15117)) inline$$TestAbortsIfWithCode_aborts_with_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 20799) 14872) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@0@@2 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t5@1 () T@$Value)
(declare-fun x@@11 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21119) (let ((anon0$2_correct@@2  (=> (= (ControlFlow 0 15772) (- 0 21412)) (=> $abort_flag@0@@2 (or (= $abort_code@4@@2 (|i#$Integer| ($Integer 1))) (= $abort_code@4@@2 (|i#$Integer| ($Integer 3))))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$Abort_correct  (=> (= $abort_flag@0@@2 true) (=> (and (= $abort_code@4@@2 $abort_code@3@@2) (= (ControlFlow 0 15720) 15772)) anon0$2_correct@@2))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon6_correct  (=> (and (= $abort_code@3@@2 $abort_code@1@@2) (= (ControlFlow 0 15750) 15720)) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 15748) 15750)) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 15758) 15750) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon12_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t3@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t4@1 ($Integer 1)) (= $abort_code@1@@2 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 15742) 15758) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 15742) 15748) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon10_correct  (=> (and (= $abort_code@3@@2 $abort_code@2@@2) (= (ControlFlow 0 15716) 15720)) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 15714) 15716)) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 15728) 15716) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon14_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t6@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t7@1 ($Integer 2)) (= $abort_code@2@@2 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 15708) 15728) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 15708) 15714) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon14_Else_correct  (=> (and (and (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t6@1)) (= $abort_flag@0@@2 false)) (and (= $abort_code@4@@2 $abort_code@0@@2) (= (ControlFlow 0 15694) 15772))) anon0$2_correct@@2)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon12_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t3@1)) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t5@1 ($Integer 2)) (= inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified x@@11 inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t5@1)))) (and (=> (= (ControlFlow 0 15686) 15708) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 15686) 15694) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t2@1 ($Integer 1)) (= inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t3@1 ($Boolean ($IsEqual_stratified x@@11 inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$$t2@1)))) (and (=> (= (ControlFlow 0 15666) 15742) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 15666) 15686) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 15618) 15666)) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 15766) 15666) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15612) 15766) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 15612) 15618) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and (and ((_ is $Integer) x@@11) (>= (|i#$Integer| x@@11) 0)) (<= (|i#$Integer| x@@11) $MAX_U64)) (= (ControlFlow 0 15367) 15612)) inline$$TestAbortsIfWithCode_aborts_with_invalid_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 21119) 15367) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@12 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@0@@3 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21439) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 16267) (- 0 21763)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@12 ($Integer 1)))) $abort_flag@0@@3)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@12 ($Integer 1)))) $abort_flag@0@@3) (=> (= (ControlFlow 0 16267) (- 0 21778)) (=> $abort_flag@0@@3 (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@12 ($Integer 1)))) (= $abort_code@4@@3 (|i#$Integer| ($Integer 1)))) (= $abort_code@4@@3 (|i#$Integer| ($Integer 2))))))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$Abort_correct  (=> (= $abort_flag@0@@3 true) (=> (and (= $abort_code@4@@3 $abort_code@3@@3) (= (ControlFlow 0 16215) 16267)) anon0$2_correct@@3))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon6_correct  (=> (and (= $abort_code@3@@3 $abort_code@1@@3) (= (ControlFlow 0 16245) 16215)) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 16243) 16245)) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 16253) 16245) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon12_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t3@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t4@1 ($Integer 1)) (= $abort_code@1@@3 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 16237) 16253) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 16237) 16243) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon10_correct  (=> (and (= $abort_code@3@@3 $abort_code@2@@3) (= (ControlFlow 0 16211) 16215)) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 16209) 16211)) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 16223) 16211) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon14_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t6@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t7@1 ($Integer 2)) (= $abort_code@2@@3 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 16203) 16223) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 16203) 16209) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon14_Else_correct  (=> (and (and (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t6@1)) (= $abort_flag@0@@3 false)) (and (= $abort_code@4@@3 $abort_code@0@@3) (= (ControlFlow 0 16189) 16267))) anon0$2_correct@@3)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon12_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t3@1)) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t5@1 ($Integer 2)) (= inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified x@@12 inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t5@1)))) (and (=> (= (ControlFlow 0 16181) 16203) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 16181) 16189) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t2@1 ($Integer 1)) (= inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t3@1 ($Boolean ($IsEqual_stratified x@@12 inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$$t2@1)))) (and (=> (= (ControlFlow 0 16161) 16237) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 16161) 16181) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 16113) 16161)) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 16261) 16161) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16107) 16261) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 16107) 16113) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@3  (=> (and (and (and ((_ is $Integer) x@@12) (>= (|i#$Integer| x@@12) 0)) (<= (|i#$Integer| x@@12) $MAX_U64)) (= (ControlFlow 0 15862) 16107)) inline$$TestAbortsIfWithCode_aborts_with_mixed_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 21439) 15862) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@13 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@4 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@0@@4 () Int)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21819) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 16762) (- 0 22143)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@13 ($Integer 1)))) $abort_flag@0@@4)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@13 ($Integer 1)))) $abort_flag@0@@4) (=> (= (ControlFlow 0 16762) (- 0 22158)) (=> $abort_flag@0@@4 (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@13 ($Integer 1)))) (= $abort_code@4@@4 (|i#$Integer| ($Integer 1)))) (= $abort_code@4@@4 (|i#$Integer| ($Integer 2))))))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$Abort_correct  (=> (= $abort_flag@0@@4 true) (=> (and (= $abort_code@4@@4 $abort_code@3@@4) (= (ControlFlow 0 16710) 16762)) anon0$2_correct@@4))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon6_correct  (=> (and (= $abort_code@3@@4 $abort_code@1@@4) (= (ControlFlow 0 16740) 16710)) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 16738) 16740)) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 16748) 16740) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon6_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon12_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t3@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t4@1 ($Integer 1)) (= $abort_code@1@@4 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t4@1))) (and (=> (= (ControlFlow 0 16732) 16748) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 16732) 16738) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon10_correct  (=> (and (= $abort_code@3@@4 $abort_code@2@@4) (= (ControlFlow 0 16706) 16710)) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 16704) 16706)) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 16718) 16706) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon10_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon14_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t6@1) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t7@1 ($Integer 1)) (= $abort_code@2@@4 (|i#$Integer| inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 16698) 16718) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 16698) 16704) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon14_Else_correct  (=> (and (and (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t6@1)) (= $abort_flag@0@@4 false)) (and (= $abort_code@4@@4 $abort_code@0@@4) (= (ControlFlow 0 16684) 16762))) anon0$2_correct@@4)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon12_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t3@1)) (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t5@1 ($Integer 2)) (= inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified x@@13 inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t5@1)))) (and (=> (= (ControlFlow 0 16676) 16698) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 16676) 16684) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t2@1 ($Integer 1)) (= inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t3@1 ($Boolean ($IsEqual_stratified x@@13 inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$$t2@1)))) (and (=> (= (ControlFlow 0 16656) 16732) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 16656) 16676) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 16608) 16656)) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 16756) 16656) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16602) 16756) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 16602) 16608) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@4  (=> (and (and (and ((_ is $Integer) x@@13) (>= (|i#$Integer| x@@13) 0)) (<= (|i#$Integer| x@@13) $MAX_U64)) (= (ControlFlow 0 16357) 16602)) inline$$TestAbortsIfWithCode_aborts_with_mixed_invalid_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 21819) 16357) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@14 () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun y () T@$Value)
(declare-fun $abort_code@5 () Int)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4@@5 () Int)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@2@@5 () Int)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t9@1 () T@$Value)
(declare-fun $abort_code@3@@5 () Int)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun $abort_code@0@@5 () Int)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t4@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 22201) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 17671) (- 0 22927)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@14 ($Integer 1)))) $abort_flag@1)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@14 ($Integer 1)))) $abort_flag@1) (and (=> (= (ControlFlow 0 17671) (- 0 22942)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified y ($Integer 2)))) $abort_flag@1)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified y ($Integer 2)))) $abort_flag@1) (and (=> (= (ControlFlow 0 17671) (- 0 22957)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| y)))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@1)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| y)))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@1) (and (=> (= (ControlFlow 0 17671) (- 0 22986)) (=> $abort_flag@1 (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@14 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified y ($Integer 2))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| y)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (=> (=> $abort_flag@1 (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@14 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified y ($Integer 2))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| y)))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> (= (ControlFlow 0 17671) (- 0 23043)) (=> $abort_flag@1 (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@14 ($Integer 1)))) (= $abort_code@5 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified y ($Integer 2)))) (= $abort_code@5 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| y)))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@5 (|i#$Integer| ($Integer (- 0 1)))))))) (=> (=> $abort_flag@1 (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@14 ($Integer 1)))) (= $abort_code@5 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified y ($Integer 2)))) (= $abort_code@5 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| y)))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@5 (|i#$Integer| ($Integer (- 0 1))))))) (=> (= (ControlFlow 0 17671) (- 0 23135)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| y))))))))))))))))))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$Abort_correct  (=> (= inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_flag@1 true) (= $abort_code@5 $abort_code@4@@5)) (and (= inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$ret0@2 inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$ret0@1) (= (ControlFlow 0 17579) 17671))) anon0$2_correct@@5))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon8_correct  (=> (and (= $abort_code@4@@5 $abort_code@1@@5) (= (ControlFlow 0 17639) 17579)) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 17637) 17639)) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 17647) 17639) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon21_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t5@1) (=> (and (= inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t6@1 ($Integer 2)) (= $abort_code@1@@5 (|i#$Integer| inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 17631) 17647) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17631) 17637) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon12_correct  (=> (and (= $abort_code@4@@5 $abort_code@2@@5) (= (ControlFlow 0 17609) 17579)) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 17607) 17609)) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 17617) 17609) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon23_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t8@1) (=> (and (= inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t9@1 ($Integer 3)) (= $abort_code@2@@5 (|i#$Integer| inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t9@1))) (and (=> (= (ControlFlow 0 17601) 17617) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 17601) 17607) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon15_correct  (=> (and (= $abort_code@4@@5 $abort_code@3@@5) (= (ControlFlow 0 17573) 17579)) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 17571) 17573)) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon15_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 17587) 17573) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon15_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon25_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 17565) 17587) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 17565) 17571) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon18_correct  (=> (and (and (= $abort_flag@1 $abort_flag@0@@5) (= $abort_code@5 $abort_code@3@@5)) (and (= inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$ret0@2 inline$$AddU64$0$dst@2) (= (ControlFlow 0 17553) 17671))) anon0$2_correct@@5)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 17551) 17553)) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon18_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 17561) 17553) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon18_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon25_Else_correct  (=> (not $abort_flag@0@@5) (and (=> (= (ControlFlow 0 17545) 17561) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 17545) 17551) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@5 true) (=> (and (= $abort_code@3@@5 $EXEC_FAILURE_CODE) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 17529) 17565) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 17529) 17545) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| x@@14) (|i#$Integer| y)) $MAX_U64) (= (ControlFlow 0 17527) 17529)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| x@@14) (|i#$Integer| y))) (=> (and (and (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| y)))) (= $abort_flag@0@@5 false)) (and (= $abort_code@3@@5 $abort_code@0@@5) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 17471) 17565) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 17471) 17545) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 17441) (- 0 22737)) true) (and (=> (= (ControlFlow 0 17441) 17527) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 17441) 17471) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t8@1)) (= (ControlFlow 0 17535) 17441)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon21_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t5@1)) (=> (and (= inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t7@1 ($Integer 2)) (= inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t8@1 ($Boolean ($IsEqual_stratified y inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t7@1)))) (and (=> (= (ControlFlow 0 17342) 17601) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 17342) 17535) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon4$2_correct  (=> (and (= inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t4@1 ($Integer 1)) (= inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t5@1 ($Boolean ($IsEqual_stratified x@@14 inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$$t4@1)))) (and (=> (= (ControlFlow 0 17322) 17631) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17322) 17342) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 17240) 17322)) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 17655) 17322) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17232) 17655) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17232) 17240) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 17663) 17655) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17663) 17240) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon20_Else_correct))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17226) 17663) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 17226) 17232) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon19_Else_correct)))))
(let ((anon0_correct@@5  (=> (and (and ((_ is $Integer) x@@14) (>= (|i#$Integer| x@@14) 0)) (<= (|i#$Integer| x@@14) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y) (>= (|i#$Integer| y) 0)) (<= (|i#$Integer| y) $MAX_U64)) (= (ControlFlow 0 16856) 17226)) inline$$TestAbortsIfWithCode_conditional_abort_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 22201) 16856) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5)))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@15 () T@$Value)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun y@@0 () T@$Value)
(declare-fun $abort_code@4@@6 () Int)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@3@@6 () Int)
(declare-fun $abort_code@1@@6 () Int)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@2@@6 () Int)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t9@1 () T@$Value)
(declare-fun $abort_code@0@@6 () Int)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t4@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 23165) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 18367) (- 0 23649)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 ($Integer 1)))) $abort_flag@0@@6)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 ($Integer 1)))) $abort_flag@0@@6) (and (=> (= (ControlFlow 0 18367) (- 0 23664)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 2)))) $abort_flag@0@@6)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 2)))) $abort_flag@0@@6) (and (=> (= (ControlFlow 0 18367) (- 0 23679)) (=> $abort_flag@0@@6 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 2))))))) (=> (=> $abort_flag@0@@6 (or (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 2)))))) (and (=> (= (ControlFlow 0 18367) (- 0 23708)) (=> $abort_flag@0@@6 (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 ($Integer 1)))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 2)))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@0@@6 (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 ($Integer 1)))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 2)))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 3)))))) (=> (= (ControlFlow 0 18367) (- 0 23759)) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$ret0@2 x@@15)))))))))))))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$Abort_correct  (=> (= inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_flag@0@@6 true) (= $abort_code@4@@6 $abort_code@3@@6)) (and (= inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$ret0@2 inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$ret0@1) (= (ControlFlow 0 18305) 18367))) anon0$2_correct@@6))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon8_correct  (=> (and (= $abort_code@3@@6 $abort_code@1@@6) (= (ControlFlow 0 18335) 18305)) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 18333) 18335)) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 18343) 18335) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t5@1) (=> (and (= inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t6@1 ($Integer 2)) (= $abort_code@1@@6 (|i#$Integer| inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 18327) 18343) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 18327) 18333) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon12_correct  (=> (and (= $abort_code@3@@6 $abort_code@2@@6) (= (ControlFlow 0 18299) 18305)) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 18297) 18299)) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 18313) 18299) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon12_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon19_Then_correct  (=> (|b#$Boolean| inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t8@1) (=> (and (= inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t9@1 ($Integer 3)) (= $abort_code@2@@6 (|i#$Integer| inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t9@1))) (and (=> (= (ControlFlow 0 18291) 18313) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 18291) 18297) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon14_correct  (=> (and (and (= $abort_flag@0@@6 false) (= $abort_code@4@@6 $abort_code@0@@6)) (and (= inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$ret0@2 x@@15) (= (ControlFlow 0 18269) 18367))) anon0$2_correct@@6)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 18267) 18269)) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon14_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 18277) 18269) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon14_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon19_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t8@1)) (and (=> (= (ControlFlow 0 18261) 18277) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 18261) 18267) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t5@1)) (=> (and (= inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t7@1 ($Integer 2)) (= inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t8@1 ($Boolean ($IsEqual_stratified y@@0 inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t7@1)))) (and (=> (= (ControlFlow 0 18251) 18291) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 18251) 18261) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon4$2_correct  (=> (and (= inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t4@1 ($Integer 1)) (= inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t5@1 ($Boolean ($IsEqual_stratified x@@15 inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$$t4@1)))) (and (=> (= (ControlFlow 0 18231) 18327) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 18231) 18251) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 18149) 18231)) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 18351) 18231) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18141) 18351) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 18141) 18149) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 18359) 18351) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 18359) 18149) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon16_Else_correct))))
(let ((inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18135) 18359) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 18135) 18141) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon15_Else_correct)))))
(let ((anon0_correct@@6  (=> (and (and ((_ is $Integer) x@@15) (>= (|i#$Integer| x@@15) 0)) (<= (|i#$Integer| x@@15) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@0) (>= (|i#$Integer| y@@0) 0)) (<= (|i#$Integer| y@@0) $MAX_U64)) (= (ControlFlow 0 17814) 18135)) inline$$TestAbortsIfWithCode_conditional_abort_invalid_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 23165) 17814) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@16 () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@1@@7 () Int)
(declare-fun inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun inline$$Div$0$dst@2 () T@$Value)
(declare-fun inline$$Div$0$dst@0 () T@$Value)
(declare-fun inline$$Div$0$dst@1 () T@$Value)
(declare-fun inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $abort_code@0@@7 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 23778) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 18941) (- 0 24138)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 ($Integer 0)))) $abort_flag@1@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 ($Integer 0)))) $abort_flag@1@@0) (and (=> (= (ControlFlow 0 18941) (- 0 24153)) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 ($Integer 0)))))) (=> (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 ($Integer 0))))) (and (=> (= (ControlFlow 0 18941) (- 0 24168)) (=> $abort_flag@1@@0 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 ($Integer 0)))) (= $abort_code@1@@7 (|i#$Integer| ($Integer 1)))))) (=> (=> $abort_flag@1@@0 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 ($Integer 0)))) (= $abort_code@1@@7 (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 18941) (- 0 24194)) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$ret0@2 ($Integer (div (|i#$Integer| ($Integer 10)) (|i#$Integer| x@@16))))))))))))))))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon5_correct  (=> (and (and (= inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$ret0@1 $Error) (= inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$ret0@2 inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$ret0@1)) (and (= $abort_flag@1@@0 true) (= (ControlFlow 0 18917) 18941))) anon0$2_correct@@7)))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 18911) 18917)) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon5_correct)))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 18925) 18917) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon5_correct)))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 18905) 18925) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 18905) 18911) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon8_correct  (=> (= inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$ret0@2 inline$$Div$0$dst@2) (=> (and (= $abort_flag@1@@0 $abort_flag@0@@7) (= (ControlFlow 0 18893) 18941)) anon0$2_correct@@7))))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 18891) 18893)) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 18901) 18893) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon8_correct)))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@7) (and (=> (= (ControlFlow 0 18885) 18901) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 18885) 18891) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Div$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@7 true) (=> (and (= $abort_code@1@@7 $EXEC_FAILURE_CODE) (= inline$$Div$0$dst@2 inline$$Div$0$dst@0)) (and (=> (= (ControlFlow 0 18869) 18905) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 18869) 18885) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon10_Else_correct))))))
(let ((inline$$Div$0$anon3_Then_correct  (=> (and (= (|i#$Integer| x@@16) 0) (= (ControlFlow 0 18867) 18869)) inline$$Div$0$anon3_Then$1_correct)))
(let ((inline$$Div$0$anon3_Else_correct  (=> (not (= (|i#$Integer| x@@16) 0)) (=> (and (and (= inline$$Div$0$dst@1 ($Integer (div (|i#$Integer| inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$t2@1) (|i#$Integer| x@@16)))) (= $abort_flag@0@@7 false)) (and (= $abort_code@1@@7 $abort_code@0@@7) (= inline$$Div$0$dst@2 inline$$Div$0$dst@1))) (and (=> (= (ControlFlow 0 18817) 18905) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 18817) 18885) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon10_Else_correct))))))
(let ((inline$$Div$0$Entry_correct  (and (=> (= (ControlFlow 0 18793) (- 0 24001)) true) (and (=> (= (ControlFlow 0 18793) 18867) inline$$Div$0$anon3_Then_correct) (=> (= (ControlFlow 0 18793) 18817) inline$$Div$0$anon3_Else_correct)))))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$$t2@1 ($Integer 10)) (= (ControlFlow 0 18875) 18793)) inline$$Div$0$Entry_correct)))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 18672) 18875)) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 18933) 18875) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18666) 18933) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 18666) 18672) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@7  (=> (and (and (and ((_ is $Integer) x@@16) (>= (|i#$Integer| x@@16) 0)) (<= (|i#$Integer| x@@16) $MAX_U64)) (= (ControlFlow 0 18487) 18666)) inline$$TestAbortsIfWithCode_exec_failure_invalid_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 23778) 18487) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@7))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
