(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$TestHash_hash_test1_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestHash_hash_test1_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun v1@@7 () T@$Value)
(declare-fun v2@@7 () T@$Value)
(declare-fun call1formal@res@0 () T@$Value)
(declare-fun call1formal@res@0@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 18311) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 14051) (- 0 18906)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0) (and (=> (= (ControlFlow 0 14051) (- 0 18915)) (=> $abort_flag@0 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 14051) (- 0 18924)) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test1_$def_verify$0$$ret0@2 inline$$TestHash_hash_test1_$def_verify$0$$ret1@2))) (|b#$Boolean| ($Boolean ($IsEqual_stratified v1@@7 v2@@7)))))))) (=> (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test1_$def_verify$0$$ret0@2 inline$$TestHash_hash_test1_$def_verify$0$$ret1@2))) (|b#$Boolean| ($Boolean ($IsEqual_stratified v1@@7 v2@@7))))))) (and (=> (= (ControlFlow 0 14051) (- 0 18953)) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified v1@@7 v2@@7))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test1_$def_verify$0$$ret0@2 inline$$TestHash_hash_test1_$def_verify$0$$ret1@2)))))))) (=> (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified v1@@7 v2@@7))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test1_$def_verify$0$$ret0@2 inline$$TestHash_hash_test1_$def_verify$0$$ret1@2))))))) (and (=> (= (ControlFlow 0 14051) (- 0 18982)) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test1_$def_verify$0$$ret0@2))) ($Integer 32)))))) (=> (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test1_$def_verify$0$$ret0@2))) ($Integer 32))))) (=> (= (ControlFlow 0 14051) (- 0 19000)) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test1_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test1_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 0)))) (|i#$Integer| ($Integer $MAX_U8))))))))))))))))))))))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon16_correct  (=> (and (and (= $abort_flag@0 false) (= inline$$TestHash_hash_test1_$def_verify$0$$ret0@2 call1formal@res@0)) (and (= inline$$TestHash_hash_test1_$def_verify$0$$ret1@2 call1formal@res@0@@0) (= (ControlFlow 0 13961) 14051))) anon0$2_correct)))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 13959) 13961)) inline$$TestHash_hash_test1_$def_verify$0$anon16_correct)))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 13969) 13961) inline$$TestHash_hash_test1_$def_verify$0$anon16_correct)))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 13949) 13969) inline$$TestHash_hash_test1_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 13949) 13959) inline$$TestHash_hash_test1_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 13977) 13969) inline$$TestHash_hash_test1_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 13977) 13959) inline$$TestHash_hash_test1_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon21_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 13943) 13977) inline$$TestHash_hash_test1_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 13943) 13949) inline$$TestHash_hash_test1_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon21_Then_correct true))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon19_Else_correct  (=> (and (not false) (= call1formal@res@0@@0 ($Hash_sha2_core v2@@7))) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@0) (let ((va@@8 (|v#$Vector| call1formal@res@0@@0)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall ((i@@10 Int) ) (!  (=> (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) i@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) i@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) i@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) i@@10))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@0)) 32)) (and (=> (= (ControlFlow 0 13935) 13981) inline$$TestHash_hash_test1_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 13935) 13943) inline$$TestHash_hash_test1_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon19_Then_correct true))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon4$2_correct  (=> (= call1formal@res@0 ($Hash_sha2_core v1@@7)) (=> (and (and (and ((_ is $Vector) call1formal@res@0) (let ((va@@9 (|v#$Vector| call1formal@res@0)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall ((i@@11 Int) ) (!  (=> (and (<= 0 i@@11) (< i@@11 (|l#$ValueArray| (|v#$Vector| call1formal@res@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0)) i@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0)) i@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0)) i@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0)) i@@11))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0)) 32)) (and (=> (= (ControlFlow 0 13929) 14009) inline$$TestHash_hash_test1_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 13929) 13935) inline$$TestHash_hash_test1_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 13859) 13929)) inline$$TestHash_hash_test1_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 14033) 13929) inline$$TestHash_hash_test1_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 13851) 14033) inline$$TestHash_hash_test1_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 13851) 13859) inline$$TestHash_hash_test1_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 14041) 14033) inline$$TestHash_hash_test1_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 14041) 13859) inline$$TestHash_hash_test1_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestHash_hash_test1_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13845) 14041) inline$$TestHash_hash_test1_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 13845) 13851) inline$$TestHash_hash_test1_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct  (=> (and (and ((_ is $Vector) v1@@7) (let ((va@@10 (|v#$Vector| v1@@7)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| v1@@7)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@7)) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@7)) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@7)) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@7)) $$0))
))) (=> (and (and (and ((_ is $Vector) v2@@7) (let ((va@@11 (|v#$Vector| v2@@7)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| v2@@7)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@7)) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@7)) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@7)) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@7)) $$0@@0))
))) (= (ControlFlow 0 13557) 13845)) inline$$TestHash_hash_test1_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 18311) 13557) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$TestHash_hash_test1_incorrect_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun call1formal@res@0@@1 () T@$Value)
(declare-fun call1formal@res@0@@2 () T@$Value)
(declare-fun v2@@8 () T@$Value)
(declare-fun v1@@8 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19066) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 14738) (- 0 19575)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0) (and (=> (= (ControlFlow 0 14738) (- 0 19584)) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 14738) (- 0 19593)) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test1_incorrect_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test1_incorrect_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 0)))) (|i#$Integer| ($Integer $MAX_U8))))))))))))))))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon16_correct  (=> (= $abort_flag@0@@0 false) (=> (and (= inline$$TestHash_hash_test1_incorrect_$def_verify$0$$ret0@2 call1formal@res@0@@1) (= (ControlFlow 0 14648) 14738)) anon0$2_correct@@0))))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 14646) 14648)) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon16_correct)))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 14656) 14648) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon16_correct)))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14636) 14656) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 14636) 14646) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 14664) 14656) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 14664) 14646) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon21_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 14630) 14664) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 14630) 14636) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon21_Then_correct true))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon19_Else_correct  (=> (and (not false) (= call1formal@res@0@@2 ($Hash_sha2_core v2@@8))) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@2) (let ((va@@12 (|v#$Vector| call1formal@res@0@@2)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (forall ((i@@12 Int) ) (!  (=> (and (<= 0 i@@12) (< i@@12 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@2)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@2)) i@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@2)) i@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@2)) i@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@2)) i@@12))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@2)) 32)) (and (=> (= (ControlFlow 0 14622) 14668) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 14622) 14630) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon19_Then_correct true))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon4$2_correct  (=> (= call1formal@res@0@@1 ($Hash_sha2_core v1@@8)) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@1) (let ((va@@13 (|v#$Vector| call1formal@res@0@@1)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (forall ((i@@13 Int) ) (!  (=> (and (<= 0 i@@13) (< i@@13 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@1)) i@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@1)) i@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@1)) i@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@1)) i@@13))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@1)) 32)) (and (=> (= (ControlFlow 0 14616) 14696) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 14616) 14622) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 14546) 14616)) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 14720) 14616) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14538) 14720) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 14538) 14546) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 14728) 14720) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 14728) 14546) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14532) 14728) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 14532) 14538) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and ((_ is $Vector) v1@@8) (let ((va@@14 (|v#$Vector| v1@@8)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| v1@@8)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@8)) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@8)) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@8)) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@8)) $$0@@1))
))) (=> (and (and (and ((_ is $Vector) v2@@8) (let ((va@@15 (|v#$Vector| v2@@8)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| v2@@8)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@8)) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@8)) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@8)) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@8)) $$0@@2))
))) (= (ControlFlow 0 14244) 14532)) inline$$TestHash_hash_test1_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 19066) 14244) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$TestHash_hash_test2_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v1@@9 () T@$Value)
(declare-fun v2@@9 () T@$Value)
(declare-fun inline$$TestHash_hash_test2_$def_verify$0$$t6@1 () T@$Value)
(declare-fun call1formal@res@0@@3 () T@$Value)
(declare-fun call1formal@res@0@@4 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19650) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 15384) (- 0 20110)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (and (=> (= (ControlFlow 0 15384) (- 0 20119)) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 15384) (- 0 20128)) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test2_$def_verify$0$$ret0@2 ($Boolean ($IsEqual_stratified v1@@9 v2@@9)))))))))))))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon14_correct  (=> (= $abort_flag@0@@1 false) (=> (and (= inline$$TestHash_hash_test2_$def_verify$0$$ret0@2 inline$$TestHash_hash_test2_$def_verify$0$$t6@1) (= (ControlFlow 0 15306) 15384)) anon0$2_correct@@1))))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 15304) 15306)) inline$$TestHash_hash_test2_$def_verify$0$anon14_correct)))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 15314) 15306) inline$$TestHash_hash_test2_$def_verify$0$anon14_correct)))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon19_Else_correct  (=> (and (not false) (= inline$$TestHash_hash_test2_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified call1formal@res@0@@3 call1formal@res@0@@4)))) (and (=> (= (ControlFlow 0 15298) 15314) inline$$TestHash_hash_test2_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 15298) 15304) inline$$TestHash_hash_test2_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon19_Then_correct true))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon17_Else_correct  (=> (and (not false) (= call1formal@res@0@@4 ($Hash_sha2_core v2@@9))) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@4) (let ((va@@16 (|v#$Vector| call1formal@res@0@@4)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (forall ((i@@14 Int) ) (!  (=> (and (<= 0 i@@14) (< i@@14 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@4)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@4)) i@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@4)) i@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@4)) i@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@4)) i@@14))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@4)) 32)) (and (=> (= (ControlFlow 0 15282) 15318) inline$$TestHash_hash_test2_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 15282) 15298) inline$$TestHash_hash_test2_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon17_Then_correct true))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon4$2_correct  (=> (= call1formal@res@0@@3 ($Hash_sha2_core v1@@9)) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@3) (let ((va@@17 (|v#$Vector| call1formal@res@0@@3)))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (forall ((i@@15 Int) ) (!  (=> (and (<= 0 i@@15) (< i@@15 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@3)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@3)) i@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@3)) i@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@3)) i@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@3)) i@@15))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@3)) 32)) (and (=> (= (ControlFlow 0 15276) 15344) inline$$TestHash_hash_test2_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 15276) 15282) inline$$TestHash_hash_test2_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 15206) 15276)) inline$$TestHash_hash_test2_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 15368) 15276) inline$$TestHash_hash_test2_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15198) 15368) inline$$TestHash_hash_test2_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 15198) 15206) inline$$TestHash_hash_test2_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 15376) 15368) inline$$TestHash_hash_test2_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 15376) 15206) inline$$TestHash_hash_test2_$def_verify$0$anon16_Else_correct))))
(let ((inline$$TestHash_hash_test2_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15192) 15376) inline$$TestHash_hash_test2_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 15192) 15198) inline$$TestHash_hash_test2_$def_verify$0$anon15_Else_correct)))))
(let ((anon0_correct@@1  (=> (and (and ((_ is $Vector) v1@@9) (let ((va@@18 (|v#$Vector| v1@@9)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| v1@@9)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@9)) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@9)) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@9)) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@9)) $$0@@3))
))) (=> (and (and (and ((_ is $Vector) v2@@9) (let ((va@@19 (|v#$Vector| v2@@9)))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| v2@@9)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@9)) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@9)) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@9)) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@9)) $$0@@4))
))) (= (ControlFlow 0 14931) 15192)) inline$$TestHash_hash_test2_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 19650) 14931) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$TestHash_hash_test2_incorrect_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun call1formal@res@0@@5 () T@$Value)
(declare-fun call1formal@res@0@@6 () T@$Value)
(declare-fun v2@@10 () T@$Value)
(declare-fun v1@@10 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20157) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 16065) (- 0 20666)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2) (and (=> (= (ControlFlow 0 16065) (- 0 20675)) (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 16065) (- 0 20684)) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test2_incorrect_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test2_incorrect_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 0)))) (|i#$Integer| ($Integer $MAX_U8))))))))))))))))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon16_correct  (=> (= $abort_flag@0@@2 false) (=> (and (= inline$$TestHash_hash_test2_incorrect_$def_verify$0$$ret0@2 call1formal@res@0@@5) (= (ControlFlow 0 15975) 16065)) anon0$2_correct@@2))))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 15973) 15975)) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon16_correct)))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 15983) 15975) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon16_correct)))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15963) 15983) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 15963) 15973) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 15991) 15983) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 15991) 15973) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon21_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 15957) 15991) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 15957) 15963) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon21_Then_correct true))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon19_Else_correct  (=> (and (not false) (= call1formal@res@0@@6 ($Hash_sha2_core v2@@10))) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@6) (let ((va@@20 (|v#$Vector| call1formal@res@0@@6)))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (forall ((i@@16 Int) ) (!  (=> (and (<= 0 i@@16) (< i@@16 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@6)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@6)) i@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@6)) i@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@6)) i@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@6)) i@@16))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@6)) 32)) (and (=> (= (ControlFlow 0 15949) 15995) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 15949) 15957) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon19_Then_correct true))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon4$2_correct  (=> (= call1formal@res@0@@5 ($Hash_sha2_core v1@@10)) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@5) (let ((va@@21 (|v#$Vector| call1formal@res@0@@5)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (forall ((i@@17 Int) ) (!  (=> (and (<= 0 i@@17) (< i@@17 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@5)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@5)) i@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@5)) i@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@5)) i@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@5)) i@@17))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@5)) 32)) (and (=> (= (ControlFlow 0 15943) 16023) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 15943) 15949) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 15873) 15943)) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 16047) 15943) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15865) 16047) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 15865) 15873) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 16055) 16047) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 16055) 15873) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15859) 16055) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 15859) 15865) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and ((_ is $Vector) v1@@10) (let ((va@@22 (|v#$Vector| v1@@10)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| v1@@10)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@10)) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@10)) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@10)) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@10)) $$0@@5))
))) (=> (and (and (and ((_ is $Vector) v2@@10) (let ((va@@23 (|v#$Vector| v2@@10)))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| v2@@10)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@10)) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@10)) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@10)) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@10)) $$0@@6))
))) (= (ControlFlow 0 15571) 15859)) inline$$TestHash_hash_test2_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 20157) 15571) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun inline$$TestHash_hash_test3_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestHash_hash_test3_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun v1@@11 () T@$Value)
(declare-fun v2@@11 () T@$Value)
(declare-fun call1formal@res@0@@7 () T@$Value)
(declare-fun call1formal@res@0@@8 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20742) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 16752) (- 0 21337)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@3)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@3) (and (=> (= (ControlFlow 0 16752) (- 0 21346)) (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 16752) (- 0 21355)) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test3_$def_verify$0$$ret0@2 inline$$TestHash_hash_test3_$def_verify$0$$ret1@2))) (|b#$Boolean| ($Boolean ($IsEqual_stratified v1@@11 v2@@11)))))))) (=> (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test3_$def_verify$0$$ret0@2 inline$$TestHash_hash_test3_$def_verify$0$$ret1@2))) (|b#$Boolean| ($Boolean ($IsEqual_stratified v1@@11 v2@@11))))))) (and (=> (= (ControlFlow 0 16752) (- 0 21384)) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified v1@@11 v2@@11))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test3_$def_verify$0$$ret0@2 inline$$TestHash_hash_test3_$def_verify$0$$ret1@2)))))))) (=> (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified v1@@11 v2@@11))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test3_$def_verify$0$$ret0@2 inline$$TestHash_hash_test3_$def_verify$0$$ret1@2))))))) (and (=> (= (ControlFlow 0 16752) (- 0 21413)) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test3_$def_verify$0$$ret0@2))) ($Integer 32)))))) (=> (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test3_$def_verify$0$$ret0@2))) ($Integer 32))))) (=> (= (ControlFlow 0 16752) (- 0 21431)) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test3_$def_verify$0$$ret0@2)))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$TestHash_hash_test3_$def_verify$0$$ret0@2)) (|i#$Integer| ($Integer 0)))) (|i#$Integer| ($Integer $MAX_U8))))))))))))))))))))))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon16_correct  (=> (and (and (= $abort_flag@0@@3 false) (= inline$$TestHash_hash_test3_$def_verify$0$$ret0@2 call1formal@res@0@@7)) (and (= inline$$TestHash_hash_test3_$def_verify$0$$ret1@2 call1formal@res@0@@8) (= (ControlFlow 0 16662) 16752))) anon0$2_correct@@3)))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 16660) 16662)) inline$$TestHash_hash_test3_$def_verify$0$anon16_correct)))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 16670) 16662) inline$$TestHash_hash_test3_$def_verify$0$anon16_correct)))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 16650) 16670) inline$$TestHash_hash_test3_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 16650) 16660) inline$$TestHash_hash_test3_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 16678) 16670) inline$$TestHash_hash_test3_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 16678) 16660) inline$$TestHash_hash_test3_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon21_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 16644) 16678) inline$$TestHash_hash_test3_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 16644) 16650) inline$$TestHash_hash_test3_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon21_Then_correct true))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon19_Else_correct  (=> (and (not false) (= call1formal@res@0@@8 ($Hash_sha3_core v2@@11))) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@8) (let ((va@@24 (|v#$Vector| call1formal@res@0@@8)))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (forall ((i@@18 Int) ) (!  (=> (and (<= 0 i@@18) (< i@@18 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@8)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@8)) i@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@8)) i@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@8)) i@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@8)) i@@18))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@8)) 32)) (and (=> (= (ControlFlow 0 16636) 16682) inline$$TestHash_hash_test3_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 16636) 16644) inline$$TestHash_hash_test3_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon19_Then_correct true))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon4$2_correct  (=> (= call1formal@res@0@@7 ($Hash_sha3_core v1@@11)) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@7) (let ((va@@25 (|v#$Vector| call1formal@res@0@@7)))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (forall ((i@@19 Int) ) (!  (=> (and (<= 0 i@@19) (< i@@19 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@7)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@7)) i@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@7)) i@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@7)) i@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@7)) i@@19))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@7)) 32)) (and (=> (= (ControlFlow 0 16630) 16710) inline$$TestHash_hash_test3_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 16630) 16636) inline$$TestHash_hash_test3_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 16560) 16630)) inline$$TestHash_hash_test3_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 16734) 16630) inline$$TestHash_hash_test3_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 16552) 16734) inline$$TestHash_hash_test3_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 16552) 16560) inline$$TestHash_hash_test3_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 16742) 16734) inline$$TestHash_hash_test3_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 16742) 16560) inline$$TestHash_hash_test3_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestHash_hash_test3_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16546) 16742) inline$$TestHash_hash_test3_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 16546) 16552) inline$$TestHash_hash_test3_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@3  (=> (and (and ((_ is $Vector) v1@@11) (let ((va@@26 (|v#$Vector| v1@@11)))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| v1@@11)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@11)) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@11)) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@11)) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@11)) $$0@@7))
))) (=> (and (and (and ((_ is $Vector) v2@@11) (let ((va@@27 (|v#$Vector| v2@@11)))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| v2@@11)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@11)) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@11)) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@11)) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@11)) $$0@@8))
))) (= (ControlFlow 0 16258) 16546)) inline$$TestHash_hash_test3_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 20742) 16258) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun inline$$TestHash_hash_test4_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun v1@@12 () T@$Value)
(declare-fun v2@@12 () T@$Value)
(declare-fun inline$$TestHash_hash_test4_$def_verify$0$$t6@1 () T@$Value)
(declare-fun call1formal@res@0@@9 () T@$Value)
(declare-fun call1formal@res@0@@10 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21488) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 17398) (- 0 21948)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@4)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@4) (and (=> (= (ControlFlow 0 17398) (- 0 21957)) (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 17398) (- 0 21966)) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestHash_hash_test4_$def_verify$0$$ret0@2 ($Boolean ($IsEqual_stratified v1@@12 v2@@12)))))))))))))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon14_correct  (=> (= $abort_flag@0@@4 false) (=> (and (= inline$$TestHash_hash_test4_$def_verify$0$$ret0@2 inline$$TestHash_hash_test4_$def_verify$0$$t6@1) (= (ControlFlow 0 17320) 17398)) anon0$2_correct@@4))))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 17318) 17320)) inline$$TestHash_hash_test4_$def_verify$0$anon14_correct)))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 17328) 17320) inline$$TestHash_hash_test4_$def_verify$0$anon14_correct)))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon19_Else_correct  (=> (and (not false) (= inline$$TestHash_hash_test4_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified call1formal@res@0@@9 call1formal@res@0@@10)))) (and (=> (= (ControlFlow 0 17312) 17328) inline$$TestHash_hash_test4_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17312) 17318) inline$$TestHash_hash_test4_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon19_Then_correct true))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon17_Else_correct  (=> (and (not false) (= call1formal@res@0@@10 ($Hash_sha3_core v2@@12))) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@10) (let ((va@@28 (|v#$Vector| call1formal@res@0@@10)))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (forall ((i@@20 Int) ) (!  (=> (and (<= 0 i@@20) (< i@@20 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@10)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@10)) i@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@10)) i@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@10)) i@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@10)) i@@20))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@10)) 32)) (and (=> (= (ControlFlow 0 17296) 17332) inline$$TestHash_hash_test4_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 17296) 17312) inline$$TestHash_hash_test4_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon17_Then_correct true))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon4$2_correct  (=> (= call1formal@res@0@@9 ($Hash_sha3_core v1@@12)) (=> (and (and (and ((_ is $Vector) call1formal@res@0@@9) (let ((va@@29 (|v#$Vector| call1formal@res@0@@9)))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (forall ((i@@21 Int) ) (!  (=> (and (<= 0 i@@21) (< i@@21 (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@9)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@9)) i@@21)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@9)) i@@21)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@9)) i@@21)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call1formal@res@0@@9)) i@@21))
))) (= (|l#$ValueArray| (|v#$Vector| call1formal@res@0@@9)) 32)) (and (=> (= (ControlFlow 0 17290) 17358) inline$$TestHash_hash_test4_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 17290) 17296) inline$$TestHash_hash_test4_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 17220) 17290)) inline$$TestHash_hash_test4_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 17382) 17290) inline$$TestHash_hash_test4_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17212) 17382) inline$$TestHash_hash_test4_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 17212) 17220) inline$$TestHash_hash_test4_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 17390) 17382) inline$$TestHash_hash_test4_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 17390) 17220) inline$$TestHash_hash_test4_$def_verify$0$anon16_Else_correct))))
(let ((inline$$TestHash_hash_test4_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17206) 17390) inline$$TestHash_hash_test4_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 17206) 17212) inline$$TestHash_hash_test4_$def_verify$0$anon15_Else_correct)))))
(let ((anon0_correct@@4  (=> (and (and ((_ is $Vector) v1@@12) (let ((va@@30 (|v#$Vector| v1@@12)))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| v1@@12)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@12)) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@12)) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@12)) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@12)) $$0@@9))
))) (=> (and (and (and ((_ is $Vector) v2@@12) (let ((va@@31 (|v#$Vector| v2@@12)))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| v2@@12)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@12)) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@12)) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@12)) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@12)) $$0@@10))
))) (= (ControlFlow 0 16945) 17206)) inline$$TestHash_hash_test4_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 21488) 16945) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
