(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $SlidingNonce_SlidingNonce () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun $SlidingNonce_spec_try_record_nonce (T@$Value T@$Value) T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_min_nonce () Int)
(declare-fun $SlidingNonce_SlidingNonce_nonce_mask () Int)
(declare-fun $SlidingNonce_SlidingNonce_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $DiemTransactionPublishingOption_DiemTransactionPublishingOption $SlidingNonce_SlidingNonce)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@0) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@0))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((account T@$Value) (seq_nonce T@$Value) )  (and (and ((_ is $Integer) ($SlidingNonce_spec_try_record_nonce account seq_nonce)) (>= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) 0)) (<= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) $MAX_U64))))
(assert (= $SlidingNonce_SlidingNonce_min_nonce 0))
(assert (= $SlidingNonce_SlidingNonce_nonce_mask 1))
(assert (= $SlidingNonce_SlidingNonce_type_value ($StructType $SlidingNonce_SlidingNonce $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$Vector_contains$0$res@1 () T@$Value)
(declare-fun inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t14@1 () T@$Value)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_Configuration_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory () T@$Memory)
(declare-fun dr_account () T@$Value)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $DiemConfig_DisableReconfiguration_$memory () T@$Memory)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $abort_code@9 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0 () T@$Memory)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun $DiemConfig_Configuration_$memory@0 () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun hash () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$ta@0 () T@$TypeValue)
(declare-fun inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t9@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_code@7 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t8@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1 () T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t7@1 () T@$Value)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_$memory () T@$Memory)
(declare-fun $abort_code@1 () Int)
(declare-fun sliding_nonce () T@$Value)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 70158) (let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon15_Else_correct true))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon15_Then_correct true))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon65_Else_correct  (=> (and (not $abort_flag@7) (= $abort_flag@8 $abort_flag@7)) (and (=> (= (ControlFlow 0 68582) 68816) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 68582) 68812) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct  (=> (= $abort_flag@8 true) (and (=> (= (ControlFlow 0 67717) 68816) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 67717) 68812) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 68768) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 68778) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon47_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 68762) 68778) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 68762) 68768) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon48_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 68748) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon50_Then_correct  (=> (= (ControlFlow 0 68758) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon49_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 68742) 68758) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 68742) 68748) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon50_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 68728) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon52_Then_correct  (=> (= (ControlFlow 0 68738) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon51_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 68722) 68738) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 68722) 68728) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon52_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 68708) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon56_Then_correct  (=> (= (ControlFlow 0 68718) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon55_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 68702) 68718) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 68702) 68708) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon56_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon58_Else_correct  (=> (and (not true) (= (ControlFlow 0 68688) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon58_Then_correct  (=> (= (ControlFlow 0 68698) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon57_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 68682) 68698) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 68682) 68688) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon58_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 68668) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon61_Then_correct  (=> (= (ControlFlow 0 68678) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon60_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 68662) 68678) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 68662) 68668) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon61_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 68648) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon62_Then_correct  (=> (= (ControlFlow 0 68658) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon60_Else_correct  (=> (and (not $abort_flag@6) (= $abort_code@10 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 68642) 68658) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 68642) 68648) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon62_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon59_Then_correct  (=> (|b#$Boolean| inline$$Vector_contains$0$res@1) (=> (and (and (and (= inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t14@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6)) (and (=> $abort_flag@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 68632) 68662) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 68632) 68642) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon60_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 68612) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon64_Then_correct  (=> (= (ControlFlow 0 68622) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon63_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 68606) 68622) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 68606) 68612) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon64_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 68592) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon66_Then_correct  (=> (= (ControlFlow 0 68602) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon65_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 68586) 68602) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 68586) 68592) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon66_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon63_Else$3_correct  (=> (and (= call0formal@$tv0@0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) (= call3formal@$DiemConfig_Configuration_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 68576) (- 0 74141)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))))) $abort_flag@7) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@7)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@7) (=> $abort_flag@7 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@7 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)) |inline$$WritebackToValue$0$vdst'@2|)))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 68576) 68586) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 68576) 68582) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon65_Else_correct)))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| call3formal@$ret0@0@@0) (= (ControlFlow 0 68542) 68576)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon63_Else$3_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 call3formal@$ret0@0@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 68568) 68576))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon63_Else$3_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1)) (and (=> (= (ControlFlow 0 68387) 68568) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 68387) 68542) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 68443) 68568) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 68443) 68542) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 68351) 68443) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 68351) 68387) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) |inline$$Vector_push_back$0$v'@1|)) (= (ControlFlow 0 68208) 68351)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon63_Else_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 68214) 68208)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) len@@0 hash) (+ len@@0 1)))))) (and (=> (= (ControlFlow 0 68143) 68606) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 68143) 68214) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon63_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct  (=> (and (= inline$$Vector_push_back$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 68131) 68143)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 68078) 68131)) inline$$Vector_push_back$0$Entry_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) (= (ControlFlow 0 68040) 68078))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 2) $EmptyPath call3formal@$ret0@0@@0)) (= (ControlFlow 0 67916) 68040)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon59_Else_correct  (=> (and (not (|b#$Boolean| inline$$Vector_contains$0$res@1)) (= (ControlFlow 0 67922) 67916)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon57_Else_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 67860) 68632) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 67860) 67922) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon59_Else_correct)))))
(let ((inline$$Vector_contains$0$anon0_correct  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1) (= inline$$Vector_contains$0$res@1 ($Boolean (exists ((i@@10 Int) )  (and (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)) i@@10) hash)))))) (and (=> (= (ControlFlow 0 67846) 68682) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 67846) 67860) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon57_Else_correct)))))
(let ((inline$$Vector_contains$0$Entry_correct  (=> (and (= inline$$Vector_contains$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 67832) 67846)) inline$$Vector_contains$0$anon0_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)) (= (ControlFlow 0 67777) 67832)) inline$$Vector_contains$0$Entry_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon55_Else_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 67783) 67777)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon53_Then_correct  (=> (and (|b#$Boolean| inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t9@1) (= call0formal@$tv0@0@@0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5) (=> $abort_flag@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 67731) 68702) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 67731) 67783) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon55_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 67711) 67717)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon54_Then_correct  (=> (= (ControlFlow 0 67725) 67717) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon53_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t9@1)) (= $abort_code@7 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 67705) 67725) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 67705) 67711) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon54_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon51_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 67693) 67731) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 67693) 67705) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon53_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon49_Else_correct  (=> (not $abort_flag@3) (=> (and (= inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t8@1 ($Integer 32)) (= inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t9@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1 inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t8@1)))) (=> (and (and (and (= inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$$t10@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 67687) 68722) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 67687) 67693) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon51_Else_correct)))))))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) hash) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| hash))))) (and (=> (= (ControlFlow 0 67657) 68742) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 67657) 67687) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon49_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $IntegerType) (= (ControlFlow 0 67645) 67657)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon47_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 67663) 67645)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon4$2_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@3)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3)) (and (=> $abort_flag@3 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@3 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@4 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@4 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 67602) 68762) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 67602) 67663) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon47_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 67532) 67602)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon4$2_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 68786) 67602) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon4$2_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 67524) 68786) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 67524) 67532) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 68794) 68786) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 68794) 67532) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon46_Else_correct))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon0_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 67518) 68794) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 67518) 67524) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$direct_inter$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and ((_ is $Vector) hash) (let ((va@@8 (|v#$Vector| hash)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$direct_inter$0$$$0 0) (< inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| hash)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$direct_inter$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$direct_inter$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$direct_inter$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$direct_inter$0$$$0))
))) (= (ControlFlow 0 68798) 67518)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def$0$anon0_correct))))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon14_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 68804) 68798)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$direct_inter$0$anon0_correct)))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon14_Then_correct true))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct  (=> (= $abort_flag@2 true) (and (=> (= (ControlFlow 0 66582) 68824) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 66582) 68804) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 66626) 66582)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 66636) 66582) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 66620) 66636) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 66620) 66626) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 66606) 66582)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 66616) 66582) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 66600) 66616) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 66600) 66606) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 66576) 66582)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 66590) 66582) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1)) (= $abort_code@3 (|i#$Integer| call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 66570) 66590) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 66570) 66576) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Then_correct  (=> (and (|b#$Boolean| inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1) (= $abort_flag@2 $abort_flag@1)) (and (=> (= (ControlFlow 0 66596) 68824) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 66596) 68804) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 66558) 66596) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 66558) 66570) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Else_correct  (=> (and (not $abort_flag@0) (= inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t7@1 ($Integer 0))) (=> (and (and (and (= inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1 ($Boolean ($IsEqual_stratified call5formal@$ret0@0 inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t7@1))) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 66552) 66600) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 66552) 66558) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Else_correct))))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon4$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))))) (and (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@1 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call5formal@$ret0@0 ($SlidingNonce_spec_try_record_nonce dr_account sliding_nonce))))))) (and (and ((_ is $Integer) call5formal@$ret0@0) (>= (|i#$Integer| call5formal@$ret0@0) 0)) (<= (|i#$Integer| call5formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 66534) 66620) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 66534) 66552) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 66464) 66534)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon4$2_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 66644) 66534) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon4$2_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 66456) 66644) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 66456) 66464) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 66652) 66644) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 66652) 66464) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Else_correct))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 66450) 66652) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 66450) 66456) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$direct_inter$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and ((_ is $Integer) sliding_nonce) (>= (|i#$Integer| sliding_nonce) 0)) (<= (|i#$Integer| sliding_nonce) $MAX_U64)) (= (ControlFlow 0 66656) 66450)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon0_correct))))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 65988) 66656)) inline$$SlidingNonce_record_nonce_or_abort_$direct_inter$0$anon0_correct)))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 68832) 66656) inline$$SlidingNonce_record_nonce_or_abort_$direct_inter$0$anon0_correct)))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon12_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 65980) 68832) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 65980) 65988) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon12_Then_correct  (and (=> (= (ControlFlow 0 68840) 68832) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 68840) 65988) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon13_Else_correct))))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 65972) 68840) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 65972) 65980) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 68848) 68840) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 68848) 65980) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon12_Else_correct))))
(let ((inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 65966) 68848) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 65966) 65972) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (forall (($inv_addr@@1 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))
))) (=> (and (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))
))) (and (forall (($inv_addr@@4 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))
)) (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@0)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@0))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (forall (($$1 Int) ) (!  (=> (and (>= $$1 0) (< $$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@0))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@0))) $$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@0))) $$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@0))) $$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@0))) $$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@0))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@5))
)))) (=> (and (and (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_min_nonce)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_min_nonce)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_min_nonce)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_nonce_mask)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_nonce_mask)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_nonce_mask)) $MAX_U128))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address T@$Value) )  (=> ((_ is $Address) config_address) (|b#$Boolean| ($Boolean (forall ((config_type T@$Value) )  (=> ((_ is $Type) config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type)) 1) (|a#$Address| config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address ($Address 173345816))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))) (= (ControlFlow 0 68852) 65966)))) inline$$add_to_script_allow_list_add_to_script_allow_list_$def_verify$0$anon0_correct))))))
(let ((anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and ((_ is $Vector) hash) (let ((va@@21 (|v#$Vector| hash)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| hash)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) $$0@@1))
))) (=> (and (and (and ((_ is $Integer) sliding_nonce) (>= (|i#$Integer| sliding_nonce) 0)) (<= (|i#$Integer| sliding_nonce) $MAX_U64)) (= (ControlFlow 0 65323) 68852)) anon0$1_correct)))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 70158) 65323) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
