(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $AddressQuant_R_x () Int)
(declare-fun $AddressQuant_R_type_value () T@$TypeValue)
(declare-fun $AddressQuant_R () T@$TypeName)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $AddressQuant_R_x 0))
(assert (= $AddressQuant_R_type_value ($StructType $AddressQuant_R $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $AddressQuant_R_$memory@0 () T@$Memory)
(declare-fun addr () T@$Value)
(declare-fun $AddressQuant_R_$memory () T@$Memory)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$AddressQuant_f_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$AddressQuant_f_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 15624) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 12388) (- 0 16649)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) $AddressQuant_R_x) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $AddressQuant_R_x)) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) $AddressQuant_R_x) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $AddressQuant_R_x)) (|i#$Integer| ($Integer 1)))))))) (and (=> (= (ControlFlow 0 12388) (- 0 16694)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (forall ((a T@$Value) )  (=> ((_ is $Address) a) (|b#$Boolean| ($Boolean (forall ((b T@$Value) )  (=> ((_ is $Address) b) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@0) $EmptyTypeValueArray (|a#$Address| a)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@0) $EmptyTypeValueArray (|a#$Address| b))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a b)))))))))))))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (forall ((a@@0 T@$Value) )  (=> ((_ is $Address) a@@0) (|b#$Boolean| ($Boolean (forall ((b@@0 T@$Value) )  (=> ((_ is $Address) b@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@0) $EmptyTypeValueArray (|a#$Address| a@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@0) $EmptyTypeValueArray (|a#$Address| b@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@0 b@@0))))))))))))))) (=> (= (ControlFlow 0 12388) (- 0 16704)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (exists ((a@@1 T@$Value) )  (and ((_ is $Address) a@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@0) $EmptyTypeValueArray (|a#$Address| a@@1))))))))))))))))
(let ((inline$$AddressQuant_f_$def_verify$0$Abort_correct  (=> (= $AddressQuant_R_$memory@0 $AddressQuant_R_$memory) (=> (and (= $abort_flag@2 true) (= (ControlFlow 0 12346) 12388)) anon0$2_correct))))
(let ((inline$$AddressQuant_f_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 12364) 12346)) inline$$AddressQuant_f_$def_verify$0$Abort_correct)))
(let ((inline$$AddressQuant_f_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 12374) 12346) inline$$AddressQuant_f_$def_verify$0$Abort_correct)))
(let ((inline$$AddressQuant_f_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 12358) 12374) inline$$AddressQuant_f_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 12358) 12364) inline$$AddressQuant_f_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddressQuant_f_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 12340) 12346)) inline$$AddressQuant_f_$def_verify$0$Abort_correct)))
(let ((inline$$AddressQuant_f_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 12354) 12346) inline$$AddressQuant_f_$def_verify$0$Abort_correct)))
(let ((inline$$AddressQuant_f_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 12334) 12354) inline$$AddressQuant_f_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 12334) 12340) inline$$AddressQuant_f_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$AddressQuant_f_$def_verify$0$anon12$2_correct  (=> (= $AddressQuant_R_$memory@0 |inline$$WritebackToGlobal$0$m'@2|) (=> (and (= $abort_flag@2 $abort_flag@1) (= (ControlFlow 0 12320) 12388)) anon0$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $AddressQuant_R_$memory) (= (ControlFlow 0 12258) 12320)) inline$$AddressQuant_f_$def_verify$0$anon12$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $AddressQuant_R_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 12312) 12320))) inline$$AddressQuant_f_$def_verify$0$anon12$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 12248) 12312) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 12248) 12258) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 12070) 12248)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 12126) 12248))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 12034) 12126) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 12034) 12070) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$AddressQuant_f_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 11897) 12034)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$AddressQuant_f_$def_verify$0$anon18_Then_correct  (=> (and (= inline$$AddressQuant_f_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 12330) 12034)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 11883) 12330) inline$$AddressQuant_f_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 11883) 11897) inline$$AddressQuant_f_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $AddressQuant_R_x) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $AddressQuant_R_x))) (= (ControlFlow 0 11824) 11883))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$AddressQuant_f_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 11830) 11824)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 11694) 12334) inline$$AddressQuant_f_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 11694) 11830) inline$$AddressQuant_f_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$AddressQuant_f_$def_verify$0$$t4@1)) $MAX_U64) (= (ControlFlow 0 11692) 11694)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$AddressQuant_f_$def_verify$0$$t4@1))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$AddressQuant_f_$def_verify$0$$t4@1))))) (and (= $abort_flag@1 $abort_flag@0) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 11636) 12334) inline$$AddressQuant_f_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 11636) 11830) inline$$AddressQuant_f_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 11606) (- 0 16176)) true) (and (=> (= (ControlFlow 0 11606) 11692) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 11606) 11636) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$AddressQuant_f_$def_verify$0$anon14_Else$1_correct  (=> (and (= inline$$AddressQuant_f_$def_verify$0$$t4@1 ($Integer 1)) (= (ControlFlow 0 11700) 11606)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 11495) 11700)) inline$$AddressQuant_f_$def_verify$0$anon14_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $AddressQuant_R_x) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $AddressQuant_R_x))) (= (ControlFlow 0 11457) 11495))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$AddressQuant_f_$def_verify$0$anon14_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 11509) 11457)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 11291) 12358) inline$$AddressQuant_f_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 11291) 11509) inline$$AddressQuant_f_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 11289) 11291)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)))) (and (= $abort_flag@0 false) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 11237) 12358) inline$$AddressQuant_f_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 11237) 11509) inline$$AddressQuant_f_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 11207) 11289) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 11207) 11237) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 11201) (- 0 15974)) true) (=> (= (ControlFlow 0 11201) 11207) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$AddressQuant_f_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 11066) 11201)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$AddressQuant_f_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 12382) 11201) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$AddressQuant_f_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 11060) 12382) inline$$AddressQuant_f_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 11060) 11066) inline$$AddressQuant_f_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct  (=> (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr))) $AddressQuant_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr))) $AddressQuant_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr))) $AddressQuant_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr))
)) (|b#$Boolean| ($Boolean (forall ((a@@2 T@$Value) )  (=> ((_ is $Address) a@@2) (|b#$Boolean| ($Boolean (forall ((b@@1 T@$Value) )  (=> ((_ is $Address) b@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray (|a#$Address| b@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@2 b@@1))))))))))))))) (and (|b#$Boolean| ($Boolean (exists ((a@@3 T@$Value) )  (and ((_ is $Address) a@@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@3)))))))) (= (ControlFlow 0 12386) 11060))) inline$$AddressQuant_f_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 10767) 12386)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 15624) 10767) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $AddressQuant_R_$memory@1 () T@$Memory)
(declare-fun special_addr () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $AddressQuant_R_$memory@0@@0 () T@$Memory)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun inline$$AddressQuant_R_pack$0$$struct@1 () T@$Value)
(declare-fun sndr () T@$Value)
(declare-fun inline$$AddressQuant_initialize_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$AddressQuant_initialize_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$AddressQuant_initialize_$def_verify$0$$t8@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 16727) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 13741) (- 0 17499)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((a@@4 T@$Value) )  (=> ((_ is $Address) a@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@1) $EmptyTypeValueArray (|a#$Address| a@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@4 special_addr)))))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((a@@5 T@$Value) )  (=> ((_ is $Address) a@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@1) $EmptyTypeValueArray (|a#$Address| a@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@5 special_addr))))))))))) (and (=> (= (ControlFlow 0 13741) (- 0 17542)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((a@@6 T@$Value) )  (=> ((_ is $Address) a@@6) (|b#$Boolean| ($Boolean (forall ((b@@2 T@$Value) )  (=> ((_ is $Address) b@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@1) $EmptyTypeValueArray (|a#$Address| a@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@1) $EmptyTypeValueArray (|a#$Address| b@@2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@6 b@@2)))))))))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((a@@7 T@$Value) )  (=> ((_ is $Address) a@@7) (|b#$Boolean| ($Boolean (forall ((b@@3 T@$Value) )  (=> ((_ is $Address) b@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@1) $EmptyTypeValueArray (|a#$Address| a@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@1) $EmptyTypeValueArray (|a#$Address| b@@3))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@7 b@@3))))))))))))))) (=> (= (ControlFlow 0 13741) (- 0 17552)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (exists ((a@@8 T@$Value) )  (and ((_ is $Address) a@@8) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory@1) $EmptyTypeValueArray (|a#$Address| a@@8))))))))))))))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon23_Else_correct  (=> (and (and (not $abort_flag@1@@0) (= $abort_flag@2@@0 $abort_flag@1@@0)) (and (= $AddressQuant_R_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 13679) 13741))) anon0$2_correct@@0)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$Abort_correct  (=> (= $abort_flag@2@@0 true) (=> (and (= $AddressQuant_R_$memory@1 $AddressQuant_R_$memory@0@@0) (= (ControlFlow 0 13173) 13741)) anon0$2_correct@@0))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon7_correct  (=> (and (= $AddressQuant_R_$memory@0@@0 $AddressQuant_R_$memory) (= (ControlFlow 0 13711) 13173)) inline$$AddressQuant_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 13709) 13711)) inline$$AddressQuant_initialize_$def_verify$0$anon7_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 13719) 13711) inline$$AddressQuant_initialize_$def_verify$0$anon7_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 13703) 13719) inline$$AddressQuant_initialize_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 13703) 13709) inline$$AddressQuant_initialize_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon15_correct  (=> (and (= $AddressQuant_R_$memory@0@@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 13691) 13173)) inline$$AddressQuant_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 13689) 13691)) inline$$AddressQuant_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 13699) 13691) inline$$AddressQuant_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon23_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 13683) 13699) inline$$AddressQuant_initialize_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 13683) 13689) inline$$AddressQuant_initialize_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@0 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 13657) 13683) inline$$AddressQuant_initialize_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 13657) 13679) inline$$AddressQuant_initialize_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 13655) 13657)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$AddressQuant_R_pack$0$$struct@1)))) (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 13605) 13683) inline$$AddressQuant_initialize_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 13605) 13679) inline$$AddressQuant_initialize_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| sndr)) (and (=> (= (ControlFlow 0 13663) 13655) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 13663) 13605) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 13451) (- 0 17335)) true) (=> (= (ControlFlow 0 13451) 13663) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$AddressQuant_R_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 13337) 13451)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$AddressQuant_R_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 13343) 13451) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$AddressQuant_R_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 13331) 13343) inline$$AddressQuant_R_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 13331) 13337) inline$$AddressQuant_R_pack$0$anon4_Else_correct)))))
(let ((inline$$AddressQuant_R_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 13323) 13451)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$AddressQuant_R_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$AddressQuant_initialize_$def_verify$0$$t9@1) (>= (|i#$Integer| inline$$AddressQuant_initialize_$def_verify$0$$t9@1) 0)) (<= (|i#$Integer| inline$$AddressQuant_initialize_$def_verify$0$$t9@1) $MAX_U64)) (= inline$$AddressQuant_R_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$AddressQuant_initialize_$def_verify$0$$t9@1) 1)))) (and (=> (= (ControlFlow 0 13315) 13331) inline$$AddressQuant_R_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 13315) 13323) inline$$AddressQuant_R_pack$0$anon3_Else_correct)))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon21_Then_correct  (=> (|b#$Boolean| inline$$AddressQuant_initialize_$def_verify$0$$t7@1) (=> (and (= inline$$AddressQuant_initialize_$def_verify$0$$t9@1 ($Integer 1)) (= (ControlFlow 0 13349) 13315)) inline$$AddressQuant_R_pack$0$anon0_correct))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon12_correct  (=> (and (= $AddressQuant_R_$memory@0@@0 $AddressQuant_R_$memory) (= (ControlFlow 0 13169) 13173)) inline$$AddressQuant_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 13167) 13169)) inline$$AddressQuant_initialize_$def_verify$0$anon12_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 13181) 13169) inline$$AddressQuant_initialize_$def_verify$0$anon12_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon21_Else_correct  (=> (not (|b#$Boolean| inline$$AddressQuant_initialize_$def_verify$0$$t7@1)) (=> (and (= inline$$AddressQuant_initialize_$def_verify$0$$t8@1 ($Integer 0)) (= $abort_code@2 (|i#$Integer| inline$$AddressQuant_initialize_$def_verify$0$$t8@1))) (and (=> (= (ControlFlow 0 13161) 13181) inline$$AddressQuant_initialize_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 13161) 13167) inline$$AddressQuant_initialize_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon19_Else_correct  (=> (and (not $abort_flag@0@@0) (= inline$$AddressQuant_initialize_$def_verify$0$$t7@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0 special_addr)))) (and (=> (= (ControlFlow 0 13145) 13349) inline$$AddressQuant_initialize_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 13145) 13161) inline$$AddressQuant_initialize_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 sndr)))) ((_ is $Address) call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 13131) 13703) inline$$AddressQuant_initialize_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 13131) 13145) inline$$AddressQuant_initialize_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 13061) 13131)) inline$$AddressQuant_initialize_$def_verify$0$anon4$2_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 13727) 13131) inline$$AddressQuant_initialize_$def_verify$0$anon4$2_correct)))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 13053) 13727) inline$$AddressQuant_initialize_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 13053) 13061) inline$$AddressQuant_initialize_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 13735) 13727) inline$$AddressQuant_initialize_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 13735) 13061) inline$$AddressQuant_initialize_$def_verify$0$anon18_Else_correct))))
(let ((inline$$AddressQuant_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13047) 13735) inline$$AddressQuant_initialize_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 13047) 13053) inline$$AddressQuant_initialize_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $AddressQuant_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $AddressQuant_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@0))) $AddressQuant_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((a@@9 T@$Value) )  (=> ((_ is $Address) a@@9) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@9))))))))))) (= (ControlFlow 0 13739) 13047)) inline$$AddressQuant_initialize_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> ((_ is $Address) sndr) (=> (and ((_ is $Address) special_addr) (= (ControlFlow 0 12672) 13739)) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 16727) 12672) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$AddressQuant_R_pack$0$$struct@1@@0 () T@$Value)
(declare-fun sndr@@0 () T@$Value)
(declare-fun inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 17566) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 14683) (- 0 18005)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((a@@10 T@$Value) )  (=> ((_ is $Address) a@@10) (|b#$Boolean| ($Boolean (forall ((b@@4 T@$Value) )  (=> ((_ is $Address) b@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| a@@10)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| b@@4))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@10 b@@4)))))))))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((a@@11 T@$Value) )  (=> ((_ is $Address) a@@11) (|b#$Boolean| ($Boolean (forall ((b@@5 T@$Value) )  (=> ((_ is $Address) b@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| a@@11)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| b@@5))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@11 b@@5))))))))))))))) (=> (= (ControlFlow 0 14683) (- 0 18015)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (exists ((a@@12 T@$Value) )  (and ((_ is $Address) a@@12) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| a@@12))))))))))))))
(let ((inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon5_correct  (=> (and (= $abort_flag@1@@1 true) (= (ControlFlow 0 14661) 14683)) anon0$2_correct@@1)))
(let ((inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 14657) 14661)) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon5_correct)))
(let ((inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 14669) 14661) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon5_correct)))
(let ((inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon8_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 14651) 14669) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 14651) 14657) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@0@@1) (=> (and (= $abort_flag@1@@1 $abort_flag@0@@1) (= (ControlFlow 0 14647) 14683)) anon0$2_correct@@1))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@1 true) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 14625) 14651) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 14625) 14647) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 14623) 14625)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0)) (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 inline$$AddressQuant_R_pack$0$$struct@1@@0)))) (and (= $abort_flag@0@@1 false) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 14573) 14651) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 14573) 14647) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| sndr@@0)) (and (=> (= (ControlFlow 0 14631) 14623) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 14631) 14573) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 14419) (- 0 17875)) true) (=> (= (ControlFlow 0 14419) 14631) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$AddressQuant_R_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 14305) 14419)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$AddressQuant_R_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 14311) 14419) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$AddressQuant_R_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 14299) 14311) inline$$AddressQuant_R_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 14299) 14305) inline$$AddressQuant_R_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$AddressQuant_R_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 14291) 14419)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$AddressQuant_R_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$AddressQuant_R_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 14283) 14299) inline$$AddressQuant_R_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 14283) 14291) inline$$AddressQuant_R_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon2$1_correct  (=> (and (= inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 14317) 14283)) inline$$AddressQuant_R_pack$0$anon0_correct@@0)))
(let ((inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 14119) 14317)) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 14677) 14317) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon2$1_correct)))
(let ((inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14113) 14677) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 14113) 14119) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AddressQuant_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AddressQuant_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AddressQuant_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (|b#$Boolean| ($Boolean (forall ((a@@13 T@$Value) )  (=> ((_ is $Address) a@@13) (|b#$Boolean| ($Boolean (forall ((b@@6 T@$Value) )  (=> ((_ is $Address) b@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@13)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray (|a#$Address| b@@6))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified a@@13 b@@6))))))))))))))) (and (|b#$Boolean| ($Boolean (exists ((a@@14 T@$Value) )  (and ((_ is $Address) a@@14) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AddressQuant_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@14)))))))) (= (ControlFlow 0 14681) 14113))) inline$$AddressQuant_multiple_copy_incorrect_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) sndr@@0) (= (ControlFlow 0 13914) 14681)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 17566) 13914) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
