(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun _v () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 12206) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 10983) (- 0 12666)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 10983) (- 0 12675)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 10983) (- 0 12684)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v _v))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v _v)))) (and (=> (= (ControlFlow 0 10983) (- 0 12699)) (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@8 T@$Value) )  (and (and (and ((_ is $Integer) l@@8) (>= (|i#$Integer| l@@8) 0)) (<= (|i#$Integer| l@@8) $MAX_U64)) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@8 ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@9 T@$Value) )  (and (and (and ((_ is $Integer) l@@9) (>= (|i#$Integer| l@@9) 0)) (<= (|i#$Integer| l@@9) $MAX_U64)) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@9 ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))))))) (and (=> (= (ControlFlow 0 10983) (- 0 12729)) (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@10 T@$Value) )  (and (and (and ((_ is $Integer) l@@10) (>= (|i#$Integer| l@@10) 0)) (<= (|i#$Integer| l@@10) $MAX_U64)) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@10 ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@11 T@$Value) )  (and (and (and ((_ is $Integer) l@@11) (>= (|i#$Integer| l@@11) 0)) (<= (|i#$Integer| l@@11) $MAX_U64)) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@11 ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))))))) (and (=> (= (ControlFlow 0 10983) (- 0 12759)) (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@12 T@$Value) )  (and (and (and ((_ is $Integer) l@@12) (>= (|i#$Integer| l@@12) 0)) (<= (|i#$Integer| l@@12) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@12 ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@12 ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@13 T@$Value) )  (and (and (and ((_ is $Integer) l@@13) (>= (|i#$Integer| l@@13) 0)) (<= (|i#$Integer| l@@13) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@13 ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@13 ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))))))) (and (=> (= (ControlFlow 0 10983) (- 0 12807)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1 _v))
(exists (($i_0 Int) )  (and (and (>= $i_0 0) (< $i_0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 0)))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 _v))
(exists (($i_0@@0 Int) )  (and (and (>= $i_0@@0 0) (< $i_0@@0 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 0))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1 _v))
(exists (($i_0@@1 Int) )  (and (and (>= $i_0@@1 0) (< $i_0@@1 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Integer 0)))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 _v))
(exists (($i_0@@2 Int) )  (and (and (>= $i_0@@2 0) (< $i_0@@2 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Integer 0)))))))))))))) (and (=> (= (ControlFlow 0 10983) (- 0 12838)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))
(exists (($i_2 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3)) $i_2) (< $i_2 (|i#$Integer| (|ub#$Range| $range_3)))) (let ((i@@10 ($Integer $i_2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@10)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean (let (($range_3@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))
(exists (($i_2@@0 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@0)) $i_2@@0) (< $i_2@@0 (|i#$Integer| (|ub#$Range| $range_3@@0)))) (let ((i@@11 ($Integer $i_2@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@11)) ($Integer 0))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))
(exists (($i_2@@1 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3)) $i_2@@1) (< $i_2@@1 (|i#$Integer| (|ub#$Range| $range_3)))) (let ((i@@10 ($Integer $i_2@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@10)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean (let (($range_3@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))
(exists (($i_2@@2 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@0)) $i_2@@2) (< $i_2@@2 (|i#$Integer| (|ub#$Range| $range_3@@0)))) (let ((i@@11 ($Integer $i_2@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@11)) ($Integer 0)))))))))))))) (and (=> (= (ControlFlow 0 10983) (- 0 12869)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (exists ((i@@12 T@$Value) )  (and (and (and ((_ is $Integer) i@@12) (>= (|i#$Integer| i@@12) 0)) (<= (|i#$Integer| i@@12) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@12)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@12) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@12)) ($Integer 0))))))))))) (|b#$Boolean| ($Boolean (exists ((i@@13 T@$Value) )  (and (and (and ((_ is $Integer) i@@13) (>= (|i#$Integer| i@@13) 0)) (<= (|i#$Integer| i@@13) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@13)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@13) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@13)) ($Integer 0)))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (exists ((i@@14 T@$Value) )  (and (and (and ((_ is $Integer) i@@14) (>= (|i#$Integer| i@@14) 0)) (<= (|i#$Integer| i@@14) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@14)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@14) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@14)) ($Integer 0))))))))))) (|b#$Boolean| ($Boolean (exists ((i@@15 T@$Value) )  (and (and (and ((_ is $Integer) i@@15) (>= (|i#$Integer| i@@15) 0)) (<= (|i#$Integer| i@@15) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@15)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@15) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@15)) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 10983) (- 0 12900)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((e T@$Value) )  (=> (and (and ((_ is $Integer) e) (>= (|i#$Integer| e) 0)) (<= (|i#$Integer| e) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@1 _v))
(exists (($i_0@@3 Int) )  (and (and (>= $i_0@@3 0) (< $i_0@@3 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((x@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@10 e))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@2 _v))
(exists (($i_0@@4 Int) )  (and (and (>= $i_0@@4 0) (< $i_0@@4 (|l#$ValueArray| (|v#$Vector| $range_1@@2)))) (let ((x@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@2)) $i_0@@4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@11 e)))))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((e@@0 T@$Value) )  (=> (and (and ((_ is $Integer) e@@0) (>= (|i#$Integer| e@@0) 0)) (<= (|i#$Integer| e@@0) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@1 _v))
(exists (($i_0@@5 Int) )  (and (and (>= $i_0@@5 0) (< $i_0@@5 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((x@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@5)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@10 e@@0))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@2 _v))
(exists (($i_0@@6 Int) )  (and (and (>= $i_0@@6 0) (< $i_0@@6 (|l#$ValueArray| (|v#$Vector| $range_1@@2)))) (let ((x@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@2)) $i_0@@6)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@11 e@@0))))))))))))))))) (and (=> (= (ControlFlow 0 10983) (- 0 12940)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((e@@1 T@$Value) )  (=> (and (and ((_ is $Integer) e@@1) (>= (|i#$Integer| e@@1) 0)) (<= (|i#$Integer| e@@1) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))
(exists (($i_2@@3 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@1)) $i_2@@3) (< $i_2@@3 (|i#$Integer| (|ub#$Range| $range_3@@1)))) (let ((i@@16 ($Integer $i_2@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@16)) e@@1))))))))) (|b#$Boolean| ($Boolean (let (($range_3@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))
(exists (($i_2@@4 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@2)) $i_2@@4) (< $i_2@@4 (|i#$Integer| (|ub#$Range| $range_3@@2)))) (let ((i@@17 ($Integer $i_2@@4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@17)) e@@1)))))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((e@@2 T@$Value) )  (=> (and (and ((_ is $Integer) e@@2) (>= (|i#$Integer| e@@2) 0)) (<= (|i#$Integer| e@@2) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))
(exists (($i_2@@5 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@1)) $i_2@@5) (< $i_2@@5 (|i#$Integer| (|ub#$Range| $range_3@@1)))) (let ((i@@16 ($Integer $i_2@@5)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@16)) e@@2))))))))) (|b#$Boolean| ($Boolean (let (($range_3@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v))))))
(exists (($i_2@@6 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@2)) $i_2@@6) (< $i_2@@6 (|i#$Integer| (|ub#$Range| $range_3@@2)))) (let ((i@@17 ($Integer $i_2@@6)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@17)) e@@2))))))))))))))))) (=> (= (ControlFlow 0 10983) (- 0 12980)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((e@@3 T@$Value) )  (=> (and (and ((_ is $Integer) e@@3) (>= (|i#$Integer| e@@3) 0)) (<= (|i#$Integer| e@@3) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (exists ((i@@18 T@$Value) )  (and (and (and ((_ is $Integer) i@@18) (>= (|i#$Integer| i@@18) 0)) (<= (|i#$Integer| i@@18) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@18)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@18) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@18)) e@@3)))))))))) (|b#$Boolean| ($Boolean (exists ((i@@19 T@$Value) )  (and (and (and ((_ is $Integer) i@@19) (>= (|i#$Integer| i@@19) 0)) (<= (|i#$Integer| i@@19) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@19)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@19) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) (|i#$Integer| i@@19)) e@@3)))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$VectorExists_do_nothing_ref_$def_verify$0$anon3_Else_correct  (=> (and (not true) (= (ControlFlow 0 10967) 10983)) anon0$2_correct)))
(let ((inline$$VectorExists_do_nothing_ref_$def_verify$0$anon3_Then_correct  (=> (= (ControlFlow 0 10977) 10983) anon0$2_correct)))
(let ((inline$$VectorExists_do_nothing_ref_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 10961) 10977) inline$$VectorExists_do_nothing_ref_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 10961) 10967) inline$$VectorExists_do_nothing_ref_$def_verify$0$anon3_Else_correct)))))
(let ((anon0_correct  (=> (and (and (and ((_ is $Vector) _v) (let ((va@@8 (|v#$Vector| _v)))
(let ((l@@14 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@12))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| _v)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) $$0)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v)) $$0))
))) (= (ControlFlow 0 10898) 10961)) inline$$VectorExists_do_nothing_ref_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 12206) 10898) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun _v@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 13033) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 11316) (- 0 13570)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 11316) (- 0 13579)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 11316) (- 0 13588)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v@@0 _v@@0))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified _v@@0 _v@@0)))) (and (=> (= (ControlFlow 0 11316) (- 0 13602)) (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@15 T@$Value) )  (and (and (and ((_ is $Integer) l@@15) (>= (|i#$Integer| l@@15) 0)) (<= (|i#$Integer| l@@15) $MAX_U64)) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@15 ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@16 T@$Value) )  (and (and (and ((_ is $Integer) l@@16) (>= (|i#$Integer| l@@16) 0)) (<= (|i#$Integer| l@@16) $MAX_U64)) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@16 ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))))))) (and (=> (= (ControlFlow 0 11316) (- 0 13632)) (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@17 T@$Value) )  (and (and (and ((_ is $Integer) l@@17) (>= (|i#$Integer| l@@17) 0)) (<= (|i#$Integer| l@@17) $MAX_U64)) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@17 ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@18 T@$Value) )  (and (and (and ((_ is $Integer) l@@18) (>= (|i#$Integer| l@@18) 0)) (<= (|i#$Integer| l@@18) $MAX_U64)) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@18 ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))))))) (and (=> (= (ControlFlow 0 11316) (- 0 13661)) (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@19 T@$Value) )  (and (and (and ((_ is $Integer) l@@19) (>= (|i#$Integer| l@@19) 0)) (<= (|i#$Integer| l@@19) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@19 ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@19 ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (exists ((l@@20 T@$Value) )  (and (and (and ((_ is $Integer) l@@20) (>= (|i#$Integer| l@@20) 0)) (<= (|i#$Integer| l@@20) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@20 ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified l@@20 ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))))))))))) (and (=> (= (ControlFlow 0 11316) (- 0 13708)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@3 _v@@0))
(exists (($i_0@@7 Int) )  (and (and (>= $i_0@@7 0) (< $i_0@@7 (|l#$ValueArray| (|v#$Vector| $range_1@@3)))) (let ((x@@13 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@3)) $i_0@@7)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@13 ($Integer 0)))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@4 _v@@0))
(exists (($i_0@@8 Int) )  (and (and (>= $i_0@@8 0) (< $i_0@@8 (|l#$ValueArray| (|v#$Vector| $range_1@@4)))) (let ((x@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@4)) $i_0@@8)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@14 ($Integer 0))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@3 _v@@0))
(exists (($i_0@@9 Int) )  (and (and (>= $i_0@@9 0) (< $i_0@@9 (|l#$ValueArray| (|v#$Vector| $range_1@@3)))) (let ((x@@13 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@3)) $i_0@@9)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@13 ($Integer 0)))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@4 _v@@0))
(exists (($i_0@@10 Int) )  (and (and (>= $i_0@@10 0) (< $i_0@@10 (|l#$ValueArray| (|v#$Vector| $range_1@@4)))) (let ((x@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@4)) $i_0@@10)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@14 ($Integer 0)))))))))))))) (and (=> (= (ControlFlow 0 11316) (- 0 13738)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))
(exists (($i_2@@7 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@3)) $i_2@@7) (< $i_2@@7 (|i#$Integer| (|ub#$Range| $range_3@@3)))) (let ((i@@20 ($Integer $i_2@@7)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@20)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean (let (($range_3@@4 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))
(exists (($i_2@@8 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@4)) $i_2@@8) (< $i_2@@8 (|i#$Integer| (|ub#$Range| $range_3@@4)))) (let ((i@@21 ($Integer $i_2@@8)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@21)) ($Integer 0))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))
(exists (($i_2@@9 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@3)) $i_2@@9) (< $i_2@@9 (|i#$Integer| (|ub#$Range| $range_3@@3)))) (let ((i@@20 ($Integer $i_2@@9)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@20)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean (let (($range_3@@4 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))
(exists (($i_2@@10 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@4)) $i_2@@10) (< $i_2@@10 (|i#$Integer| (|ub#$Range| $range_3@@4)))) (let ((i@@21 ($Integer $i_2@@10)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@21)) ($Integer 0)))))))))))))) (and (=> (= (ControlFlow 0 11316) (- 0 13768)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (exists ((i@@22 T@$Value) )  (and (and (and ((_ is $Integer) i@@22) (>= (|i#$Integer| i@@22) 0)) (<= (|i#$Integer| i@@22) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@22)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@22) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@22)) ($Integer 0))))))))))) (|b#$Boolean| ($Boolean (exists ((i@@23 T@$Value) )  (and (and (and ((_ is $Integer) i@@23) (>= (|i#$Integer| i@@23) 0)) (<= (|i#$Integer| i@@23) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@23)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@23) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@23)) ($Integer 0)))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (exists ((i@@24 T@$Value) )  (and (and (and ((_ is $Integer) i@@24) (>= (|i#$Integer| i@@24) 0)) (<= (|i#$Integer| i@@24) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@24)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@24) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@24)) ($Integer 0))))))))))) (|b#$Boolean| ($Boolean (exists ((i@@25 T@$Value) )  (and (and (and ((_ is $Integer) i@@25) (>= (|i#$Integer| i@@25) 0)) (<= (|i#$Integer| i@@25) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@25)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@25) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@25)) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 11316) (- 0 13798)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((e@@4 T@$Value) )  (=> (and (and ((_ is $Integer) e@@4) (>= (|i#$Integer| e@@4) 0)) (<= (|i#$Integer| e@@4) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@5 _v@@0))
(exists (($i_0@@11 Int) )  (and (and (>= $i_0@@11 0) (< $i_0@@11 (|l#$ValueArray| (|v#$Vector| $range_1@@5)))) (let ((x@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@5)) $i_0@@11)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 e@@4))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@6 _v@@0))
(exists (($i_0@@12 Int) )  (and (and (>= $i_0@@12 0) (< $i_0@@12 (|l#$ValueArray| (|v#$Vector| $range_1@@6)))) (let ((x@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@6)) $i_0@@12)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 e@@4)))))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((e@@5 T@$Value) )  (=> (and (and ((_ is $Integer) e@@5) (>= (|i#$Integer| e@@5) 0)) (<= (|i#$Integer| e@@5) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@5 _v@@0))
(exists (($i_0@@13 Int) )  (and (and (>= $i_0@@13 0) (< $i_0@@13 (|l#$ValueArray| (|v#$Vector| $range_1@@5)))) (let ((x@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@5)) $i_0@@13)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@15 e@@5))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@6 _v@@0))
(exists (($i_0@@14 Int) )  (and (and (>= $i_0@@14 0) (< $i_0@@14 (|l#$ValueArray| (|v#$Vector| $range_1@@6)))) (let ((x@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@6)) $i_0@@14)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 e@@5))))))))))))))))) (and (=> (= (ControlFlow 0 11316) (- 0 13837)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((e@@6 T@$Value) )  (=> (and (and ((_ is $Integer) e@@6) (>= (|i#$Integer| e@@6) 0)) (<= (|i#$Integer| e@@6) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@5 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))
(exists (($i_2@@11 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@5)) $i_2@@11) (< $i_2@@11 (|i#$Integer| (|ub#$Range| $range_3@@5)))) (let ((i@@26 ($Integer $i_2@@11)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@26)) e@@6))))))))) (|b#$Boolean| ($Boolean (let (($range_3@@6 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))
(exists (($i_2@@12 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@6)) $i_2@@12) (< $i_2@@12 (|i#$Integer| (|ub#$Range| $range_3@@6)))) (let ((i@@27 ($Integer $i_2@@12)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@27)) e@@6)))))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((e@@7 T@$Value) )  (=> (and (and ((_ is $Integer) e@@7) (>= (|i#$Integer| e@@7) 0)) (<= (|i#$Integer| e@@7) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@5 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))
(exists (($i_2@@13 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@5)) $i_2@@13) (< $i_2@@13 (|i#$Integer| (|ub#$Range| $range_3@@5)))) (let ((i@@26 ($Integer $i_2@@13)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@26)) e@@7))))))))) (|b#$Boolean| ($Boolean (let (($range_3@@6 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0))))))
(exists (($i_2@@14 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@6)) $i_2@@14) (< $i_2@@14 (|i#$Integer| (|ub#$Range| $range_3@@6)))) (let ((i@@27 ($Integer $i_2@@14)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@27)) e@@7))))))))))))))))) (=> (= (ControlFlow 0 11316) (- 0 13876)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((e@@8 T@$Value) )  (=> (and (and ((_ is $Integer) e@@8) (>= (|i#$Integer| e@@8) 0)) (<= (|i#$Integer| e@@8) $MAX_U64)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (exists ((i@@28 T@$Value) )  (and (and (and ((_ is $Integer) i@@28) (>= (|i#$Integer| i@@28) 0)) (<= (|i#$Integer| i@@28) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@28)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@28) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@28)) e@@8)))))))))) (|b#$Boolean| ($Boolean (exists ((i@@29 T@$Value) )  (and (and (and ((_ is $Integer) i@@29) (>= (|i#$Integer| i@@29) 0)) (<= (|i#$Integer| i@@29) $MAX_U64)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@29)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@29) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| _v@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) (|i#$Integer| i@@29)) e@@8)))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 11290) 11316)) anon0$2_correct@@0)))
(let ((inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 11300) 11316) anon0$2_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 1) $EmptyPath _v@@0)) (and (=> (= (ControlFlow 0 11274) 11300) inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 11274) 11290) inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 11190) 11274)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 11308) 11274) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 11184) 11308) inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 11184) 11190) inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon5_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and (and ((_ is $Vector) _v@@0) (let ((va@@9 (|v#$Vector| _v@@0)))
(let ((l@@21 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@17))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| _v@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) $$0@@0)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _v@@0)) $$0@@0))
))) (= (ControlFlow 0 11075) 11184)) inline$$VectorExists_do_nothing_ref_mut_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 13033) 11075) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
