(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $GenericBug_PrivilegedCapability () T@$TypeName)
(declare-fun $GenericBug_T () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $GenericBug_PrivilegedCapability_dummy_field () Int)
(declare-fun $GenericBug_PrivilegedCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $GenericBug_T_dummy_field () Int)
(declare-fun $GenericBug_T_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $GenericBug_PrivilegedCapability $GenericBug_T)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $GenericBug_PrivilegedCapability_dummy_field 0))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($GenericBug_PrivilegedCapability_type_value $tv0) ($StructType $GenericBug_PrivilegedCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($GenericBug_PrivilegedCapability_type_value $tv0))
)))
(assert (= $GenericBug_T_dummy_field 0))
(assert (= $GenericBug_T_type_value ($StructType $GenericBug_T $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $GenericBug_PrivilegedCapability_$memory@1 () T@$Memory)
(declare-fun sender () T@$Value)
(declare-fun $GenericBug_PrivilegedCapability_$memory@0 () T@$Memory)
(declare-fun $GenericBug_PrivilegedCapability_$memory () T@$Memory)
(declare-fun $abort_flag@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_flag@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$GenericBug_PrivilegedCapability_pack$0$$struct@1 () T@$Value)
(declare-fun $tv0@@0 () T@$TypeValue)
(declare-fun inline$$GenericBug_apply_for_privilege_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$GenericBug_apply_for_privilege_$def_verify$0$$t3@1 () T@$Value)
(declare-fun call3formal@$ret0@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 16230) (let ((anon0$2_correct  (=> (= (ControlFlow 0 12515) (- 0 16913)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $GenericBug_T_type_value) 1) (|a#$Address| sender))))))))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$Abort_correct  (=> (= $abort_flag@2 true) (=> (and (= $GenericBug_PrivilegedCapability_$memory@1 $GenericBug_PrivilegedCapability_$memory@0) (= (ControlFlow 0 12467) 12515)) anon0$2_correct))))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon5_correct  (=> (and (= $GenericBug_PrivilegedCapability_$memory@0 $GenericBug_PrivilegedCapability_$memory) (= (ControlFlow 0 12493) 12467)) inline$$GenericBug_apply_for_privilege_$def_verify$0$Abort_correct)))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 12491) 12493)) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon5_correct)))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 12501) 12493) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon5_correct)))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 12485) 12501) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 12485) 12491) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon11_correct  (=> (and (= $GenericBug_PrivilegedCapability_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 12463) 12467)) inline$$GenericBug_apply_for_privilege_$def_verify$0$Abort_correct)))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 12461) 12463)) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon11_correct)))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 12475) 12463) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon11_correct)))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon17_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 12455) 12475) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 12455) 12461) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon17_Else_correct  (=> (and (and (not $abort_flag@1) (= $abort_flag@2 $abort_flag@1)) (and (= $GenericBug_PrivilegedCapability_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 12451) 12515))) anon0$2_correct)))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 12429) 12455) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 12429) 12451) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 12427) 12429)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 inline$$GenericBug_PrivilegedCapability_pack$0$$struct@1)))) (and (= $abort_flag@1 $abort_flag@0) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 12377) 12455) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 12377) 12451) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| sender)) (and (=> (= (ControlFlow 0 12435) 12427) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 12435) 12377) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 12223) (- 0 16746)) true) (=> (= (ControlFlow 0 12223) 12435) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1)) (= (ControlFlow 0 12195) 12223)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 12097) 12195)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 12103) 12195) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 12091) 12103) inline$$GenericBug_PrivilegedCapability_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 12091) 12097) inline$$GenericBug_PrivilegedCapability_pack$0$anon4_Else_correct)))))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 12083) 12195)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$GenericBug_apply_for_privilege_$def_verify$0$$t4@1) (= inline$$GenericBug_PrivilegedCapability_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GenericBug_apply_for_privilege_$def_verify$0$$t4@1) 1)))) (and (=> (= (ControlFlow 0 12075) 12091) inline$$GenericBug_PrivilegedCapability_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 12075) 12083) inline$$GenericBug_PrivilegedCapability_pack$0$anon3_Else_correct)))))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon16_Else_correct  (=> (not (|b#$Boolean| inline$$GenericBug_apply_for_privilege_$def_verify$0$$t3@1)) (=> (and (= inline$$GenericBug_apply_for_privilege_$def_verify$0$$t4@1 ($Boolean false)) (= (ControlFlow 0 12109) 12075)) inline$$GenericBug_PrivilegedCapability_pack$0$anon0_correct))))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon16_Then_correct  (=> (and (and (|b#$Boolean| inline$$GenericBug_apply_for_privilege_$def_verify$0$$t3@1) (= $abort_flag@2 $abort_flag@0)) (and (= $GenericBug_PrivilegedCapability_$memory@1 $GenericBug_PrivilegedCapability_$memory) (= (ControlFlow 0 12481) 12515))) anon0$2_correct)))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon14_Else_correct  (=> (and (not $abort_flag@0) (= inline$$GenericBug_apply_for_privilege_$def_verify$0$$t3@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1) (|a#$Address| call3formal@$ret0@0))))) (and (=> (= (ControlFlow 0 11932) 12481) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 11932) 12109) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 sender)))) ((_ is $Address) call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 11906) 12485) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 11906) 11932) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 11870) 11906)) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon2$1_correct)))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 12509) 11906) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon2$1_correct)))
(let ((inline$$GenericBug_apply_for_privilege_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 11864) 12509) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 11864) 11870) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $GenericBug_PrivilegedCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))
)) (=> (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $GenericBug_T_type_value) 1) (|a#$Address| sender)))) (= (ControlFlow 0 12513) 11864)) inline$$GenericBug_apply_for_privilege_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and ((_ is $Address) sender) (= (ControlFlow 0 11533) 12513)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 16230) 11533) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $GenericBug_PrivilegedCapability_$memory@1@@0 () T@$Memory)
(declare-fun sender@@0 () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $GenericBug_PrivilegedCapability_$memory@0@@0 () T@$Memory)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$GenericBug_PrivilegedCapability_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$GenericBug_initialize_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$GenericBug_PrivilegedCapability_pack$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$GenericBug_initialize_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$GenericBug_initialize_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$GenericBug_root_address_$def$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 16939) (let ((anon0$2_correct@@0  (=> (= (ControlFlow 0 13851) (- 0 17719)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $GenericBug_T_type_value) 1) (|a#$Address| sender@@0))))))))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon23_Else_correct  (=> (and (and (not $abort_flag@1@@0) (= $abort_flag@2@@0 $abort_flag@1@@0)) (and (= $GenericBug_PrivilegedCapability_$memory@1@@0 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 13793) 13851))) anon0$2_correct@@0)))
(let ((inline$$GenericBug_initialize_$def_verify$0$Abort_correct  (=> (= $abort_flag@2@@0 true) (=> (and (= $GenericBug_PrivilegedCapability_$memory@1@@0 $GenericBug_PrivilegedCapability_$memory@0@@0) (= (ControlFlow 0 13268) 13851)) anon0$2_correct@@0))))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon5_correct  (=> (and (= $GenericBug_PrivilegedCapability_$memory@0@@0 $GenericBug_PrivilegedCapability_$memory) (= (ControlFlow 0 13829) 13268)) inline$$GenericBug_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 13827) 13829)) inline$$GenericBug_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 13837) 13829) inline$$GenericBug_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 13821) 13837) inline$$GenericBug_initialize_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 13821) 13827) inline$$GenericBug_initialize_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon15_correct  (=> (and (= $GenericBug_PrivilegedCapability_$memory@0@@0 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 13805) 13268)) inline$$GenericBug_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 13803) 13805)) inline$$GenericBug_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 13813) 13805) inline$$GenericBug_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon23_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 13797) 13813) inline$$GenericBug_initialize_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 13797) 13803) inline$$GenericBug_initialize_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@1@@0 true) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 13771) 13797) inline$$GenericBug_initialize_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 13771) 13793) inline$$GenericBug_initialize_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 13769) 13771)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0)) (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0 inline$$GenericBug_PrivilegedCapability_pack$0$$struct@1@@0)))) (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 13719) 13797) inline$$GenericBug_initialize_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 13719) 13793) inline$$GenericBug_initialize_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| sender@@0)) (and (=> (= (ControlFlow 0 13777) 13769) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 13777) 13719) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 13565) (- 0 17551)) true) (=> (= (ControlFlow 0 13565) 13777) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$MoveTo$0$Entry_correct@@0  (=> (and (= inline$$MoveTo$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $GenericBug_T_type_value) 1)) (= (ControlFlow 0 13537) 13565)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 13439) 13537)) inline$$MoveTo$0$Entry_correct@@0)))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 13445) 13537) inline$$MoveTo$0$Entry_correct@@0)))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 13433) 13445) inline$$GenericBug_PrivilegedCapability_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 13433) 13439) inline$$GenericBug_PrivilegedCapability_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 13425) 13537)) inline$$MoveTo$0$Entry_correct@@0)))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$anon0_correct@@0  (=> (and ((_ is $Boolean) inline$$GenericBug_initialize_$def_verify$0$$t8@1) (= inline$$GenericBug_PrivilegedCapability_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GenericBug_initialize_$def_verify$0$$t8@1) 1)))) (and (=> (= (ControlFlow 0 13417) 13433) inline$$GenericBug_PrivilegedCapability_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 13417) 13425) inline$$GenericBug_PrivilegedCapability_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$GenericBug_PrivilegedCapability_pack$0$Entry_correct  (=> (and (= inline$$GenericBug_PrivilegedCapability_pack$0$$tv0@0 $GenericBug_T_type_value) (= (ControlFlow 0 13395) 13417)) inline$$GenericBug_PrivilegedCapability_pack$0$anon0_correct@@0)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon21_Then_correct  (=> (|b#$Boolean| inline$$GenericBug_initialize_$def_verify$0$$t6@1) (=> (and (= inline$$GenericBug_initialize_$def_verify$0$$t8@1 ($Boolean false)) (= (ControlFlow 0 13451) 13395)) inline$$GenericBug_PrivilegedCapability_pack$0$Entry_correct))))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon12_correct  (=> (and (= $GenericBug_PrivilegedCapability_$memory@0@@0 $GenericBug_PrivilegedCapability_$memory) (= (ControlFlow 0 13264) 13268)) inline$$GenericBug_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 13262) 13264)) inline$$GenericBug_initialize_$def_verify$0$anon12_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 13276) 13264) inline$$GenericBug_initialize_$def_verify$0$anon12_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon21_Else_correct  (=> (not (|b#$Boolean| inline$$GenericBug_initialize_$def_verify$0$$t6@1)) (=> (and (= inline$$GenericBug_initialize_$def_verify$0$$t7@1 ($Integer 1000)) (= $abort_code@2 (|i#$Integer| inline$$GenericBug_initialize_$def_verify$0$$t7@1))) (and (=> (= (ControlFlow 0 13256) 13276) inline$$GenericBug_initialize_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 13256) 13262) inline$$GenericBug_initialize_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@0) (= inline$$GenericBug_initialize_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 inline$$GenericBug_root_address_$def$0$$t0@1)))) (and (=> (= (ControlFlow 0 13240) 13451) inline$$GenericBug_initialize_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 13240) 13256) inline$$GenericBug_initialize_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@0 (=> (and (= $GenericBug_PrivilegedCapability_$memory@0@@0 $GenericBug_PrivilegedCapability_$memory) (= (ControlFlow 0 13817) 13268)) inline$$GenericBug_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$GenericBug_root_address_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 13200) 13817) inline$$GenericBug_initialize_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 13200) 13240) inline$$GenericBug_initialize_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$GenericBug_root_address_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 13210) 13817) inline$$GenericBug_initialize_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 13210) 13240) inline$$GenericBug_initialize_$def_verify$0$anon20_Else_correct))))
(let ((inline$$GenericBug_root_address_$def$0$anon0_correct  (=> (and (not $abort_flag@0@@0) (= inline$$GenericBug_root_address_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 13194) 13210) inline$$GenericBug_root_address_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 13194) 13200) inline$$GenericBug_root_address_$def$0$anon3_Else_correct)))))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 13224) 13194)) inline$$GenericBug_root_address_$def$0$anon0_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 sender@@0)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 13089) 13821) inline$$GenericBug_initialize_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 13089) 13224) inline$$GenericBug_initialize_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 13053) 13089)) inline$$GenericBug_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 13845) 13089) inline$$GenericBug_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$GenericBug_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13047) 13845) inline$$GenericBug_initialize_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 13047) 13053) inline$$GenericBug_initialize_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@0 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))) $GenericBug_PrivilegedCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@0))
)) (=> (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $GenericBug_T_type_value) 1) (|a#$Address| sender@@0)))) (= (ControlFlow 0 13849) 13047)) inline$$GenericBug_initialize_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) sender@@0) (= (ControlFlow 0 12671) 13849)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 16939) 12671) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $GenericBug_PrivilegedCapability_$memory@1@@1 () T@$Memory)
(declare-fun sender@@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@2| () T@$Memory)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun inline$$MoveFrom$0$dst@2 () T@$Value)
(declare-fun inline$$GenericBug_PrivilegedCapability_unpack$0$dummy_field@1 () T@$Value)
(declare-fun $GenericBug_PrivilegedCapability_$memory@0@@1 () T@$Memory)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveFrom$0$a@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1| () T@$Memory)
(declare-fun addr () T@$Value)
(declare-fun $tv0@@1 () T@$TypeValue)
(declare-fun inline$$GenericBug_remove_privilege_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$GenericBug_remove_privilege_$def_verify$0$$t9@1 () T@$Value)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$GenericBug_root_address_$def$0$$t0@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 17739) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 15094) (- 0 18483)) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $GenericBug_T_type_value) 1) (|a#$Address| sender@@1))))))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon26_Else$1_correct  (=> (= $GenericBug_PrivilegedCapability_$memory@1@@1 |inline$$MoveFrom$0$m'@2|) (=> (and (= $abort_flag@2@@1 $abort_flag@1@@1) (= (ControlFlow 0 15028) 15094)) anon0$2_correct@@1))))
(let ((inline$$GenericBug_PrivilegedCapability_unpack$0$anon0_correct  (=> (and (and ((_ is $Vector) inline$$MoveFrom$0$dst@2) (= inline$$GenericBug_PrivilegedCapability_unpack$0$dummy_field@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$MoveFrom$0$dst@2)) $GenericBug_PrivilegedCapability_dummy_field))) (and ((_ is $Boolean) inline$$GenericBug_PrivilegedCapability_unpack$0$dummy_field@1) (= (ControlFlow 0 15020) 15028))) inline$$GenericBug_remove_privilege_$def_verify$0$anon26_Else$1_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 15026) 15020)) inline$$GenericBug_PrivilegedCapability_unpack$0$anon0_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$Abort_correct  (=> (= $GenericBug_PrivilegedCapability_$memory@1@@1 $GenericBug_PrivilegedCapability_$memory@0@@1) (=> (and (= $abort_flag@2@@1 true) (= (ControlFlow 0 14697) 15094)) anon0$2_correct@@1))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon7_correct  (=> (and (= $GenericBug_PrivilegedCapability_$memory@0@@1 $GenericBug_PrivilegedCapability_$memory) (= (ControlFlow 0 15064) 14697)) inline$$GenericBug_remove_privilege_$def_verify$0$Abort_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 15062) 15064)) inline$$GenericBug_remove_privilege_$def_verify$0$anon7_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 15072) 15064) inline$$GenericBug_remove_privilege_$def_verify$0$anon7_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon21_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 15056) 15072) inline$$GenericBug_remove_privilege_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 15056) 15062) inline$$GenericBug_remove_privilege_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon17_correct  (=> (and (= $GenericBug_PrivilegedCapability_$memory@0@@1 |inline$$MoveFrom$0$m'@2|) (= (ControlFlow 0 15040) 14697)) inline$$GenericBug_remove_privilege_$def_verify$0$Abort_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 15038) 15040)) inline$$GenericBug_remove_privilege_$def_verify$0$anon17_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 15048) 15040) inline$$GenericBug_remove_privilege_$def_verify$0$anon17_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon26_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 15032) 15048) inline$$GenericBug_remove_privilege_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 15032) 15038) inline$$GenericBug_remove_privilege_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct  (=> (= $abort_flag@1@@1 true) (=> (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@0|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@0)) (and (=> (= (ControlFlow 0 14947) 15032) inline$$GenericBug_remove_privilege_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 14947) 15026) inline$$GenericBug_remove_privilege_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1)) (= (ControlFlow 0 14945) 14947)) inline$$MoveFrom$0$anon3_Then$1_correct)))
(let ((inline$$MoveFrom$0$anon3_Else_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1) (= inline$$MoveFrom$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1))) (=> (and (and (= |inline$$MoveFrom$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 $Error))) (= $abort_flag@1@@1 $abort_flag@0@@1)) (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@1|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@1))) (and (=> (= (ControlFlow 0 14893) 15032) inline$$GenericBug_remove_privilege_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 14893) 15026) inline$$GenericBug_remove_privilege_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct  (=> (= inline$$MoveFrom$0$a@1 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 14847) 14945) inline$$MoveFrom$0$anon3_Then_correct) (=> (= (ControlFlow 0 14847) 14893) inline$$MoveFrom$0$anon3_Else_correct)))))
(let ((inline$$MoveFrom$0$Entry_correct  (=> (= inline$$MoveFrom$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1)) (and (=> (= (ControlFlow 0 14841) (- 0 18275)) true) (=> (= (ControlFlow 0 14841) 14847) inline$$MoveFrom$0$anon0_correct)))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon24_Then_correct  (=> (and (|b#$Boolean| inline$$GenericBug_remove_privilege_$def_verify$0$$t8@1) (= (ControlFlow 0 14955) 14841)) inline$$MoveFrom$0$Entry_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon14_correct  (=> (and (= $GenericBug_PrivilegedCapability_$memory@0@@1 $GenericBug_PrivilegedCapability_$memory) (= (ControlFlow 0 14693) 14697)) inline$$GenericBug_remove_privilege_$def_verify$0$Abort_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 14691) 14693)) inline$$GenericBug_remove_privilege_$def_verify$0$anon14_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 14705) 14693) inline$$GenericBug_remove_privilege_$def_verify$0$anon14_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon24_Else_correct  (=> (not (|b#$Boolean| inline$$GenericBug_remove_privilege_$def_verify$0$$t8@1)) (=> (and (= inline$$GenericBug_remove_privilege_$def_verify$0$$t9@1 ($Integer 1001)) (= $abort_code@2@@0 (|i#$Integer| inline$$GenericBug_remove_privilege_$def_verify$0$$t9@1))) (and (=> (= (ControlFlow 0 14685) 14705) inline$$GenericBug_remove_privilege_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 14685) 14691) inline$$GenericBug_remove_privilege_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@0@@1) (= inline$$GenericBug_remove_privilege_$def_verify$0$$t8@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 inline$$GenericBug_root_address_$def$0$$t0@1@@0)))) (and (=> (= (ControlFlow 0 14669) 14955) inline$$GenericBug_remove_privilege_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 14669) 14685) inline$$GenericBug_remove_privilege_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0@@1 (=> (and (= $GenericBug_PrivilegedCapability_$memory@0@@1 $GenericBug_PrivilegedCapability_$memory) (= (ControlFlow 0 15052) 14697)) inline$$GenericBug_remove_privilege_$def_verify$0$Abort_correct))))
(let ((inline$$GenericBug_root_address_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 14629) 15052) inline$$GenericBug_remove_privilege_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 14629) 14669) inline$$GenericBug_remove_privilege_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$GenericBug_root_address_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 14639) 15052) inline$$GenericBug_remove_privilege_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 14639) 14669) inline$$GenericBug_remove_privilege_$def_verify$0$anon23_Else_correct))))
(let ((inline$$GenericBug_root_address_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@0@@1) (= inline$$GenericBug_root_address_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 14623) 14639) inline$$GenericBug_root_address_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 14623) 14629) inline$$GenericBug_root_address_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon21_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 14653) 14623)) inline$$GenericBug_root_address_$def$0$anon0_correct@@0)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 sender@@1)))) ((_ is $Address) call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 14518) 15056) inline$$GenericBug_remove_privilege_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 14518) 14653) inline$$GenericBug_remove_privilege_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 14448) 14518)) inline$$GenericBug_remove_privilege_$def_verify$0$anon4$2_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 15080) 14518) inline$$GenericBug_remove_privilege_$def_verify$0$anon4$2_correct)))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14440) 15080) inline$$GenericBug_remove_privilege_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 14440) 14448) inline$$GenericBug_remove_privilege_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 15088) 15080) inline$$GenericBug_remove_privilege_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 15088) 14448) inline$$GenericBug_remove_privilege_$def_verify$0$anon20_Else_correct))))
(let ((inline$$GenericBug_remove_privilege_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14434) 15088) inline$$GenericBug_remove_privilege_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 14434) 14440) inline$$GenericBug_remove_privilege_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@1 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))) $GenericBug_PrivilegedCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@1))
)) (=> (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $GenericBug_PrivilegedCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $GenericBug_T_type_value) 1) (|a#$Address| sender@@1)))) (= (ControlFlow 0 15092) 14434)) inline$$GenericBug_remove_privilege_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> ((_ is $Address) sender@@1) (=> (and ((_ is $Address) addr) (= (ControlFlow 0 14028) 15092)) anon0$1_correct@@1))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 17739) 14028) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun inline$$GenericBug_root_address_$def_verify$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 18501) (let ((inline$$GenericBug_root_address_$def_verify$0$anon3_Else_correct true))
(let ((inline$$GenericBug_root_address_$def_verify$0$anon3_Then_correct true))
(let ((inline$$GenericBug_root_address_$def_verify$0$anon0_correct  (=> (and (not false) (= inline$$GenericBug_root_address_$def_verify$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 15346) 15362) inline$$GenericBug_root_address_$def_verify$0$anon3_Then_correct) (=> (= (ControlFlow 0 15346) 15352) inline$$GenericBug_root_address_$def_verify$0$anon3_Else_correct)))))
(let ((anon0_correct@@2  (=> (= (ControlFlow 0 18501) 15346) inline$$GenericBug_root_address_$def_verify$0$anon0_correct)))
anon0_correct@@2)))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
