(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $TestGlobalInvariants_R () T@$TypeName)
(declare-fun $TestGlobalInvariants_S () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestGlobalInvariants_R_x () Int)
(declare-fun $TestGlobalInvariants_R_type_value () T@$TypeValue)
(declare-fun $TestGlobalInvariants_S_x () Int)
(declare-fun $TestGlobalInvariants_S_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $TestGlobalInvariants_R $TestGlobalInvariants_S)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestGlobalInvariants_R_x 0))
(assert (= $TestGlobalInvariants_R_type_value ($StructType $TestGlobalInvariants_R $EmptyTypeValueArray)))
(assert (= $TestGlobalInvariants_S_x 0))
(assert (= $TestGlobalInvariants_S_type_value ($StructType $TestGlobalInvariants_S $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun |inline$$MoveToRaw$1$m'@2| () T@$Memory)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $TestGlobalInvariants_R_$memory () T@$Memory)
(declare-fun |inline$$MoveToRaw$1$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$1$a@1 () Int)
(declare-fun |inline$$MoveToRaw$1$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$TestGlobalInvariants_R_pack$0$$struct@1 () T@$Value)
(declare-fun account () T@$Value)
(declare-fun inline$$TestGlobalInvariants_create_R_$def_verify$0$$t4@1 () T@$Value)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun $TestGlobalInvariants_S_$memory () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$TestGlobalInvariants_S_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_create_R_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19970) (let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon13_Else_correct true))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon13_Then_correct true))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon12_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 14448) 14464) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 14448) 14454) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon15_Else_correct true))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon15_Then_correct true))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon14_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 14424) 14444) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 14424) 14430) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon14_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 14420) (- 0 20736)) (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_create_R_$def_verify$0$a T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_create_R_$def_verify$0$a) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@0 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@0))))))))))) (=> (= (ControlFlow 0 14420) (- 0 20773)) (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@1 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@1)))))))))))))))))
(let ((inline$$MoveToRaw$1$anon3_Then$1_correct  (=> (and (= $abort_flag@1 true) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@0|)) (and (=> (= (ControlFlow 0 14322) 14424) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 14322) 14420) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$MoveToRaw$1$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveTo$1$a@1) (= (ControlFlow 0 14320) 14322)) inline$$MoveToRaw$1$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$1$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveTo$1$a@1)) (= |inline$$MoveToRaw$1$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveTo$1$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveTo$1$a@1 inline$$TestGlobalInvariants_R_pack$0$$struct@1)))) (and (= $abort_flag@1 $abort_flag@0) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@1|))) (and (=> (= (ControlFlow 0 14270) 14424) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 14270) 14420) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$MoveTo$1$anon0$1_correct  (=> (= inline$$MoveTo$1$a@1 (|a#$Address| account)) (and (=> (= (ControlFlow 0 14328) 14320) inline$$MoveToRaw$1$anon3_Then_correct) (=> (= (ControlFlow 0 14328) 14270) inline$$MoveToRaw$1$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$1$Entry_correct  (and (=> (= (ControlFlow 0 14116) (- 0 20628)) true) (=> (= (ControlFlow 0 14116) 14328) inline$$MoveTo$1$anon0$1_correct))))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 14000) 14116)) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 14006) 14116) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 13994) 14006) inline$$TestGlobalInvariants_R_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 13994) 14000) inline$$TestGlobalInvariants_R_pack$0$anon4_Else_correct)))))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 13986) 14116)) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestGlobalInvariants_create_R_$def_verify$0$$t4@1) (>= (|i#$Integer| inline$$TestGlobalInvariants_create_R_$def_verify$0$$t4@1) 0)) (<= (|i#$Integer| inline$$TestGlobalInvariants_create_R_$def_verify$0$$t4@1) $MAX_U64)) (= inline$$TestGlobalInvariants_R_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestGlobalInvariants_create_R_$def_verify$0$$t4@1) 1)))) (and (=> (= (ControlFlow 0 13978) 13994) inline$$TestGlobalInvariants_R_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 13978) 13986) inline$$TestGlobalInvariants_R_pack$0$anon3_Else_correct)))))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon12_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 14012) (- 0 20492)) (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@2 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@2)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@3 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_$def_verify$0$a@@3))))))))))) (=> (and (= inline$$TestGlobalInvariants_create_R_$def_verify$0$$t4@1 ($Integer 0)) (= (ControlFlow 0 14012) 13978)) inline$$TestGlobalInvariants_R_pack$0$anon0_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 13789) 14448) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 13789) 14012) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 13787) 13789)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$TestGlobalInvariants_S_pack$0$$struct@1)))) (and (= $abort_flag@0 false) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 13737) 14448) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 13737) 14012) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account)) (and (=> (= (ControlFlow 0 13795) 13787) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 13795) 13737) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 13583) (- 0 20386)) true) (=> (= (ControlFlow 0 13583) 13795) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$TestGlobalInvariants_S_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 13469) 13583)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$TestGlobalInvariants_S_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 13475) 13583) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$TestGlobalInvariants_S_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 13463) 13475) inline$$TestGlobalInvariants_S_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 13463) 13469) inline$$TestGlobalInvariants_S_pack$0$anon4_Else_correct)))))
(let ((inline$$TestGlobalInvariants_S_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 13455) 13583)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$TestGlobalInvariants_S_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestGlobalInvariants_create_R_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestGlobalInvariants_create_R_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestGlobalInvariants_create_R_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestGlobalInvariants_S_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestGlobalInvariants_create_R_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 13447) 13463) inline$$TestGlobalInvariants_S_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 13447) 13455) inline$$TestGlobalInvariants_S_pack$0$anon3_Else_correct)))))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestGlobalInvariants_create_R_$def_verify$0$$t2@1 ($Integer 0)) (= (ControlFlow 0 13481) 13447)) inline$$TestGlobalInvariants_S_pack$0$anon0_correct)))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 13283) 13481)) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 14472) 13481) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_create_R_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13277) 14472) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 13277) 13283) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct  (=> (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr))) $TestGlobalInvariants_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr))) $TestGlobalInvariants_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr))) $TestGlobalInvariants_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestGlobalInvariants_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestGlobalInvariants_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestGlobalInvariants_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (and (|b#$Boolean| ($Boolean (forall ((a T@$Value) )  (=> ((_ is $Address) a) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| a)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| a))))))))))) (= (ControlFlow 0 14476) 13277))) inline$$TestGlobalInvariants_create_R_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and ((_ is $Address) account) (= (ControlFlow 0 12815) 14476)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 19970) 12815) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$TestGlobalInvariants_R_pack$0$$struct@1@@0 () T@$Value)
(declare-fun account@@0 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20847) (let ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon9_Else_correct true))
(let ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon9_Then_correct true))
(let ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon8_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 15656) 15674) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 15656) 15662) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 15652) (- 0 21273)) (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a@@0 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a@@0))))))))))) (=> (= (ControlFlow 0 15652) (- 0 21311)) (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a@@1 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$a@@1)))))))))))))))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@0 true) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 15554) 15656) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 15554) 15652) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 15552) 15554)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0)) (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 inline$$TestGlobalInvariants_R_pack$0$$struct@1@@0)))) (and (= $abort_flag@0@@0 false) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 15502) 15656) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 15502) 15652) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| account@@0)) (and (=> (= (ControlFlow 0 15560) 15552) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 15560) 15502) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 15348) (- 0 21167)) true) (=> (= (ControlFlow 0 15348) 15560) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 15232) 15348)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 15238) 15348) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 15226) 15238) inline$$TestGlobalInvariants_R_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 15226) 15232) inline$$TestGlobalInvariants_R_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 15218) 15348)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$TestGlobalInvariants_R_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$$t2@1) $MAX_U64)) (= inline$$TestGlobalInvariants_R_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 15210) 15226) inline$$TestGlobalInvariants_R_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 15210) 15218) inline$$TestGlobalInvariants_R_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$$t2@1 ($Integer 0)) (= (ControlFlow 0 15244) 15210)) inline$$TestGlobalInvariants_R_pack$0$anon0_correct@@0)))
(let ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 15046) 15244)) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 15682) 15244) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15040) 15682) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 15040) 15046) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestGlobalInvariants_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestGlobalInvariants_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@1))) $TestGlobalInvariants_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((a@@0 T@$Value) )  (=> ((_ is $Address) a@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| a@@0))))))))))) (= (ControlFlow 0 15686) 15040)) inline$$TestGlobalInvariants_create_R_invalid_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 14724) 15686)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 20847) 14724) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun account@@1 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21366) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 16722) (- 0 22174)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 16722) (- 0 22195)) (=> $abort_flag@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))))) (=> (=> $abort_flag@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))))))) (=> (= (ControlFlow 0 16722) (- 0 22216)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $TestGlobalInvariants_S_x))))))))))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon20_correct  (=> (= inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1) (=> (and (= $abort_flag@3 $abort_flag@2) (= (ControlFlow 0 16638) 16722)) anon0$2_correct))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 16636) 16638)) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon20_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 16646) 16638) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon20_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $TestGlobalInvariants_S_x)) (and (=> (= (ControlFlow 0 16620) 16646) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 16620) 16636) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 16626) 16620)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$ret0@1 $Error) (= inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$ret0@2 inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$ret0@1)) (and (= $abort_flag@3 true) (= (ControlFlow 0 16379) 16722))) anon0$2_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 16696) 16379)) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 16706) 16379) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon22_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 16690) 16706) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 16690) 16696) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 16676) 16379)) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 16686) 16379) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon26_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 16670) 16686) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 16670) 16676) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 16656) 16379)) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 16666) 16379) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon28_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 16650) 16666) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 16650) 16656) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@2 true) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 16566) 16650) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 16566) 16626) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 16564) 16566)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0)))) (and (= $abort_flag@2 $abort_flag@1@@0) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 16512) 16650) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 16512) 16626) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0)) (and (=> (= (ControlFlow 0 16494) 16564) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 16494) 16512) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 16488) (- 0 21998)) true) (=> (= (ControlFlow 0 16488) 16494) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 16572) 16488)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon24_Then_correct  (=> (|b#$Boolean| inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$t5@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 account@@1)))) ((_ is $Address) call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 16393) 16670) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 16393) 16572) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 16371) 16379)) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 16387) 16379) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon24_Else_correct  (=> (not (|b#$Boolean| inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$t5@1)) (=> (and (= inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$t6@1 ($Integer 0)) (= $abort_code@3 (|i#$Integer| inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 16365) 16387) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 16365) 16371) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@0@@1) (= inline$$TestGlobalInvariants_get_S_x_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@0))))) (and (=> (= (ControlFlow 0 16349) 16393) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 16349) 16365) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 account@@1)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 16335) 16690) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 16335) 16349) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 16299) 16335)) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 16714) 16335) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16293) 16714) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 16293) 16299) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestGlobalInvariants_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestGlobalInvariants_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@2))) $TestGlobalInvariants_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestGlobalInvariants_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestGlobalInvariants_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@3))) $TestGlobalInvariants_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@3))
))) (and (|b#$Boolean| ($Boolean (forall ((a@@1 T@$Value) )  (=> ((_ is $Address) a@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| a@@1))))))))))) (= (ControlFlow 0 16720) 16293))) inline$$TestGlobalInvariants_get_S_x_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) account@@1) (= (ControlFlow 0 15852) 16720)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 21366) 15852) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@2| () T@$Memory)
(declare-fun |inline$$MoveFrom$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@2 () T@$Value)
(declare-fun inline$$MoveFrom$0$dst@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$a@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1| () T@$Memory)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$$t5@1 () T@$Value)
(declare-fun account@@2 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 22246) (let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon21_Else_correct true))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon21_Then_correct true))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 17863) 17879) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 17863) 17869) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon25_Else_correct true))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon25_Then_correct true))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon24_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 17843) 17859) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 17843) 17849) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon27_Else_correct true))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon27_Then_correct true))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon26_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 17823) 17839) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 17823) 17829) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$TestGlobalInvariants_R_unpack$0$anon0_correct true))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon26_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 17817) (- 0 22905)) (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@0 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@0))))))))))) (and (=> (= (ControlFlow 0 17817) (- 0 22943)) (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@1 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@1)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@2 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$a@@2))))))))))) (=> (= (ControlFlow 0 17817) 17811) inline$$TestGlobalInvariants_R_unpack$0$anon0_correct))))))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@0 true) (=> (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@0|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@0)) (and (=> (= (ControlFlow 0 17669) 17823) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 17669) 17817) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1)) (= (ControlFlow 0 17667) 17669)) inline$$MoveFrom$0$anon3_Then$1_correct)))
(let ((inline$$MoveFrom$0$anon3_Else_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1) (= inline$$MoveFrom$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1))) (=> (and (and (= |inline$$MoveFrom$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1 $Error))) (= $abort_flag@2@@0 $abort_flag@1@@1)) (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@1|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@1))) (and (=> (= (ControlFlow 0 17615) 17823) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 17615) 17817) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct  (=> (= inline$$MoveFrom$0$a@1 (|a#$Address| call3formal@$ret0@0@@1)) (and (=> (= (ControlFlow 0 17569) 17667) inline$$MoveFrom$0$anon3_Then_correct) (=> (= (ControlFlow 0 17569) 17615) inline$$MoveFrom$0$anon3_Else_correct)))))
(let ((inline$$MoveFrom$0$Entry_correct  (and (=> (= (ControlFlow 0 17563) (- 0 22785)) true) (=> (= (ControlFlow 0 17563) 17569) inline$$MoveFrom$0$anon0_correct))))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon24_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 17677) 17563)) inline$$MoveFrom$0$Entry_correct)))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon22_Then_correct  (=> (|b#$Boolean| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$$t5@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1) (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 account@@2)))) ((_ is $Address) call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 17437) 17843) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 17437) 17677) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon23_Else_correct true))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon23_Then_correct true))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon22_Else_correct  (=> (not (|b#$Boolean| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$$t5@1)) (=> (and (= inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$$t6@1 ($Integer 0)) (= $abort_code@3@@0 (|i#$Integer| inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 17411) 17431) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 17411) 17417) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@2) (= inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@2))))) (and (=> (= (ControlFlow 0 17395) 17437) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 17395) 17411) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2) (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 account@@2)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 17381) 17863) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 17381) 17395) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 17345) 17381)) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 17887) 17381) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17339) 17887) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 17339) 17345) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestGlobalInvariants_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestGlobalInvariants_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@4))) $TestGlobalInvariants_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((a@@2 T@$Value) )  (=> ((_ is $Address) a@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| a@@2))))))))))) (= (ControlFlow 0 17891) 17339)) inline$$TestGlobalInvariants_remove_R_invalid_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (and ((_ is $Address) account@@2) (= (ControlFlow 0 16866) 17891)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 22246) 16866) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun account@@3 () T@$Value)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun inline$$MoveFrom$0$dst@2@@0 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_S_unpack$0$x@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0@@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$a@1@@0 () Int)
(declare-fun inline$$MoveFrom$0$dst@1@@0 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1@@0| () T@$Memory)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 23043) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 19016) (- 0 23872)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@3@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@3@@0) (=> (= (ControlFlow 0 19016) (- 0 23893)) (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))))))))))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon26_Else$1_correct  (=> (and (= $abort_flag@3@@0 $abort_flag@2@@1) (= (ControlFlow 0 18942) 19016)) anon0$2_correct@@0)))
(let ((inline$$TestGlobalInvariants_S_unpack$0$anon0_correct  (=> (and ((_ is $Vector) inline$$MoveFrom$0$dst@2@@0) (= inline$$TestGlobalInvariants_S_unpack$0$x@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$MoveFrom$0$dst@2@@0)) $TestGlobalInvariants_S_x))) (=> (and (and (and ((_ is $Integer) inline$$TestGlobalInvariants_S_unpack$0$x@1) (>= (|i#$Integer| inline$$TestGlobalInvariants_S_unpack$0$x@1) 0)) (<= (|i#$Integer| inline$$TestGlobalInvariants_S_unpack$0$x@1) $MAX_U64)) (= (ControlFlow 0 18934) 18942)) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon26_Else$1_correct))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon26_Else_correct  (=> (not $abort_flag@2@@1) (and (=> (= (ControlFlow 0 18940) (- 0 23764)) (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$a T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$a) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$a)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$a)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$a@@0 T@$Value) )  (=> ((_ is $Address) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$a@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$a@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$a@@0))))))))))) (=> (= (ControlFlow 0 18940) 18934) inline$$TestGlobalInvariants_S_unpack$0$anon0_correct))))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$Abort_correct  (=> (and (= $abort_flag@3@@0 true) (= (ControlFlow 0 18585) 19016)) anon0$2_correct@@0)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 18992) 18585)) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 19002) 18585) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 18986) 19002) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 18986) 18992) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 18972) 18585)) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 18982) 18585) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon24_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 18966) 18982) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 18966) 18972) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 18952) 18585)) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 18962) 18585) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon26_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 18946) 18962) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 18946) 18952) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@2@@1 true) (=> (and (= |inline$$MoveFrom$0$m'@2@@0| |inline$$MoveFrom$0$m'@0@@0|) (= inline$$MoveFrom$0$dst@2@@0 inline$$MoveFrom$0$dst@0@@0)) (and (=> (= (ControlFlow 0 18829) 18946) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 18829) 18940) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0)) (= (ControlFlow 0 18827) 18829)) inline$$MoveFrom$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveFrom$0$anon3_Else_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0) (= inline$$MoveFrom$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0))) (=> (and (and (= |inline$$MoveFrom$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1@@0 $Error))) (= $abort_flag@2@@1 $abort_flag@1@@2)) (and (= |inline$$MoveFrom$0$m'@2@@0| |inline$$MoveFrom$0$m'@1@@0|) (= inline$$MoveFrom$0$dst@2@@0 inline$$MoveFrom$0$dst@1@@0))) (and (=> (= (ControlFlow 0 18775) 18946) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 18775) 18940) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct@@0  (=> (= inline$$MoveFrom$0$a@1@@0 (|a#$Address| call3formal@$ret0@0@@3)) (and (=> (= (ControlFlow 0 18729) 18827) inline$$MoveFrom$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 18729) 18775) inline$$MoveFrom$0$anon3_Else_correct@@0)))))
(let ((inline$$MoveFrom$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 18723) (- 0 23644)) true) (=> (= (ControlFlow 0 18723) 18729) inline$$MoveFrom$0$anon0_correct@@0))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon24_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 18837) 18723)) inline$$MoveFrom$0$Entry_correct@@0)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon22_Then_correct  (=> (|b#$Boolean| inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$$t5@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@2) (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 account@@3)))) ((_ is $Address) call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 18599) 18966) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 18599) 18837) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 18579) 18585)) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 18593) 18585) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$Abort_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon22_Else_correct  (=> (not (|b#$Boolean| inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$$t5@1)) (=> (and (= inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$$t6@1 ($Integer 0)) (= $abort_code@3@@1 (|i#$Integer| inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 18573) 18593) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 18573) 18579) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@3) (= inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4))))) (and (=> (= (ControlFlow 0 18557) 18599) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 18557) 18573) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@3) (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 account@@3)))) ((_ is $Address) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 18543) 18986) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 18543) 18557) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 18507) 18543)) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 19010) 18543) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18501) 19010) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 18501) 18507) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (and (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestGlobalInvariants_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestGlobalInvariants_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@5))) $TestGlobalInvariants_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestGlobalInvariants_S_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestGlobalInvariants_S_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@6))) $TestGlobalInvariants_S_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray $inv_addr@@6))
))) (and (|b#$Boolean| ($Boolean (forall ((a@@3 T@$Value) )  (=> ((_ is $Address) a@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_R_$memory) $EmptyTypeValueArray (|a#$Address| a@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestGlobalInvariants_S_$memory) $EmptyTypeValueArray (|a#$Address| a@@3))))))))))) (= (ControlFlow 0 19014) 18501))) inline$$TestGlobalInvariants_remove_S_invalid_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and ((_ is $Address) account@@3) (= (ControlFlow 0 18052) 19014)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 23043) 18052) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
