(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestLet_R_x () Int)
(declare-fun $TestLet_R_type_value () T@$TypeValue)
(declare-fun $TestLet_R () T@$TypeName)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestLet_R_x 0))
(assert (= $TestLet_R_type_value ($StructType $TestLet_R $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun |inline$$TestLet_local_let_with_memory_access_$def_verify$0$tmp#$2@2| () T@$Value)
(declare-fun $TestLet_R_$memory () T@$Memory)
(declare-fun a1 () T@$Value)
(declare-fun a2 () T@$Value)
(declare-fun inline$$TestLet_local_let_with_memory_access_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestLet_local_let_with_memory_access_$def_verify$0$$t5@1 () T@$Value)
(declare-fun |inline$$TestLet_local_let_with_memory_access_$def_verify$0$tmp#$2@1| () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19081) (let ((anon0$2_correct  (=> (= (ControlFlow 0 12947) (- 0 19369)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified |inline$$TestLet_local_let_with_memory_access_$def_verify$0$tmp#$2@2| (let ((e ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray (|a#$Address| a1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray (|a#$Address| a2))))))))
($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| e) (|b#$Boolean| e)))) (|b#$Boolean| e)))))))))))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 12845) 12947)) anon0$2_correct)))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 12855) 12947) anon0$2_correct)))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon8_correct  (=> (= |inline$$TestLet_local_let_with_memory_access_$def_verify$0$tmp#$2@2| inline$$TestLet_local_let_with_memory_access_$def_verify$0$$t6@1) (and (=> (= (ControlFlow 0 12915) 12855) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 12915) 12845) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 12913) 12915)) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon8_correct)))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 12923) 12915) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon8_correct)))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon15_Then_correct  (=> (and (|b#$Boolean| inline$$TestLet_local_let_with_memory_access_$def_verify$0$$t5@1) (= inline$$TestLet_local_let_with_memory_access_$def_verify$0$$t6@1 ($Boolean true))) (and (=> (= (ControlFlow 0 12905) 12923) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 12905) 12913) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon10_correct  (=> (= |inline$$TestLet_local_let_with_memory_access_$def_verify$0$tmp#$2@2| |inline$$TestLet_local_let_with_memory_access_$def_verify$0$tmp#$2@1|) (and (=> (= (ControlFlow 0 12835) 12855) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 12835) 12845) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 12833) 12835)) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon10_correct)))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 12863) 12835) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon10_correct)))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon15_Else_correct  (=> (and (not (|b#$Boolean| inline$$TestLet_local_let_with_memory_access_$def_verify$0$$t5@1)) (= |inline$$TestLet_local_let_with_memory_access_$def_verify$0$tmp#$2@1| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray (|a#$Address| a2))))) (and (=> (= (ControlFlow 0 12827) 12863) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 12827) 12833) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon4$2_correct  (=> (= inline$$TestLet_local_let_with_memory_access_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray (|a#$Address| a1)))) (and (=> (= (ControlFlow 0 12811) 12905) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 12811) 12827) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 12733) 12811)) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 12931) 12811) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 12725) 12931) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 12725) 12733) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 12939) 12931) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 12939) 12733) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon14_Else_correct))))
(let ((inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 12719) 12939) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 12719) 12725) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray $inv_addr))) $TestLet_R_x)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray $inv_addr))) $TestLet_R_x)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray $inv_addr))) $TestLet_R_x)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestLet_R_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 12945) 12719)) inline$$TestLet_local_let_with_memory_access_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> ((_ is $Address) a1) (=> (and ((_ is $Address) a2) (= (ControlFlow 0 12446) 12945)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 19081) 12446) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$TestLet_spec_let_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun a () T@$Value)
(declare-fun b () T@$Value)
(declare-fun inline$$TestLet_spec_let_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestLet_spec_let_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestLet_spec_let_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$AddU64$1$dst@2 () T@$Value)
(declare-fun inline$$AddU64$2$dst@2 () T@$Value)
(declare-fun inline$$AddU64$2$dst@0 () T@$Value)
(declare-fun inline$$AddU64$2$dst@1 () T@$Value)
(declare-fun inline$$AddU64$1$dst@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$TestLet_spec_let_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19404) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 14230) (- 0 20056)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| ($Integer (+ (|i#$Integer| a) (|i#$Integer| ($Integer 1))))) (|i#$Integer| b)))))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| ($Integer (+ (|i#$Integer| a) (|i#$Integer| ($Integer 1))))) (|i#$Integer| b))))))) (=> (= (ControlFlow 0 14230) (- 0 20074)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_$def_verify$0$$ret1@2 ($Integer (- (|i#$Integer| inline$$TestLet_spec_let_$def_verify$0$$ret0@2) (|i#$Integer| ($Integer 1)))))))))))))
(let ((inline$$TestLet_spec_let_$def_verify$0$Abort_correct  (=> (and (= inline$$TestLet_spec_let_$def_verify$0$$ret0@1 $Error) (= inline$$TestLet_spec_let_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@3 true) (= inline$$TestLet_spec_let_$def_verify$0$$ret0@2 inline$$TestLet_spec_let_$def_verify$0$$ret0@1)) (and (= inline$$TestLet_spec_let_$def_verify$0$$ret1@2 inline$$TestLet_spec_let_$def_verify$0$$ret1@1) (= (ControlFlow 0 14156) 14230))) anon0$2_correct@@0))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 14194) 14156)) inline$$TestLet_spec_let_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 14204) 14156) inline$$TestLet_spec_let_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 14188) 14204) inline$$TestLet_spec_let_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 14188) 14194) inline$$TestLet_spec_let_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 14174) 14156)) inline$$TestLet_spec_let_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 14184) 14156) inline$$TestLet_spec_let_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 14168) 14184) inline$$TestLet_spec_let_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 14168) 14174) inline$$TestLet_spec_let_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 14146) 14156)) inline$$TestLet_spec_let_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 14164) 14156) inline$$TestLet_spec_let_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon27_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 14140) 14164) inline$$TestLet_spec_let_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 14140) 14146) inline$$TestLet_spec_let_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon20_correct  (=> (and (and (= $abort_flag@3 $abort_flag@2) (= inline$$TestLet_spec_let_$def_verify$0$$ret0@2 inline$$AddU64$1$dst@2)) (and (= inline$$TestLet_spec_let_$def_verify$0$$ret1@2 inline$$AddU64$2$dst@2) (= (ControlFlow 0 14120) 14230))) anon0$2_correct@@0)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 14118) 14120)) inline$$TestLet_spec_let_$def_verify$0$anon20_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 14128) 14120) inline$$TestLet_spec_let_$def_verify$0$anon20_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14108) 14128) inline$$TestLet_spec_let_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 14108) 14118) inline$$TestLet_spec_let_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 14136) 14128) inline$$TestLet_spec_let_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 14136) 14118) inline$$TestLet_spec_let_$def_verify$0$anon30_Else_correct))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon27_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 14102) 14136) inline$$TestLet_spec_let_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 14102) 14108) inline$$TestLet_spec_let_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$AddU64$2$anon3_Then$1_correct  (=> (and (= $abort_flag@2 true) (= inline$$AddU64$2$dst@2 inline$$AddU64$2$dst@0)) (and (=> (= (ControlFlow 0 14086) 14140) inline$$TestLet_spec_let_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 14086) 14102) inline$$TestLet_spec_let_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AddU64$2$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| a) (|i#$Integer| b)) $MAX_U64) (= (ControlFlow 0 14084) 14086)) inline$$AddU64$2$anon3_Then$1_correct)))
(let ((inline$$AddU64$2$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| a) (|i#$Integer| b))) (= inline$$AddU64$2$dst@1 ($Integer (+ (|i#$Integer| a) (|i#$Integer| b))))) (and (= $abort_flag@2 $abort_flag@1) (= inline$$AddU64$2$dst@2 inline$$AddU64$2$dst@1))) (and (=> (= (ControlFlow 0 14028) 14140) inline$$TestLet_spec_let_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 14028) 14102) inline$$TestLet_spec_let_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AddU64$2$Entry_correct  (and (=> (= (ControlFlow 0 13998) (- 0 19859)) true) (and (=> (= (ControlFlow 0 13998) 14084) inline$$AddU64$2$anon3_Then_correct) (=> (= (ControlFlow 0 13998) 14028) inline$$AddU64$2$anon3_Else_correct)))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 14092) 13998)) inline$$AddU64$2$Entry_correct)))
(let ((inline$$AddU64$1$anon3_Then$1_correct  (=> (and (= $abort_flag@1 true) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@0)) (and (=> (= (ControlFlow 0 13893) 14168) inline$$TestLet_spec_let_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 13893) 14092) inline$$TestLet_spec_let_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$AddU64$1$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$AddU64$0$dst@2) (|i#$Integer| b)) $MAX_U64) (= (ControlFlow 0 13891) 13893)) inline$$AddU64$1$anon3_Then$1_correct)))
(let ((inline$$AddU64$1$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$AddU64$0$dst@2) (|i#$Integer| b))) (= inline$$AddU64$1$dst@1 ($Integer (+ (|i#$Integer| inline$$AddU64$0$dst@2) (|i#$Integer| b))))) (and (= $abort_flag@1 $abort_flag@0) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@1))) (and (=> (= (ControlFlow 0 13835) 14168) inline$$TestLet_spec_let_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 13835) 14092) inline$$TestLet_spec_let_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$AddU64$1$Entry_correct  (and (=> (= (ControlFlow 0 13805) (- 0 19770)) true) (and (=> (= (ControlFlow 0 13805) 13891) inline$$AddU64$1$anon3_Then_correct) (=> (= (ControlFlow 0 13805) 13835) inline$$AddU64$1$anon3_Else_correct)))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 13899) 13805)) inline$$AddU64$1$Entry_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 13700) 14188) inline$$TestLet_spec_let_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 13700) 13899) inline$$TestLet_spec_let_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| a) (|i#$Integer| inline$$TestLet_spec_let_$def_verify$0$$t4@1)) $MAX_U64) (= (ControlFlow 0 13698) 13700)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| a) (|i#$Integer| inline$$TestLet_spec_let_$def_verify$0$$t4@1))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| a) (|i#$Integer| inline$$TestLet_spec_let_$def_verify$0$$t4@1))))) (and (= $abort_flag@0 false) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 13642) 14188) inline$$TestLet_spec_let_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 13642) 13899) inline$$TestLet_spec_let_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 13612) (- 0 19683)) true) (and (=> (= (ControlFlow 0 13612) 13698) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 13612) 13642) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon4$2_correct  (=> (and (= inline$$TestLet_spec_let_$def_verify$0$$t4@1 ($Integer 1)) (= (ControlFlow 0 13706) 13612)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 13447) 13706)) inline$$TestLet_spec_let_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 14212) 13706) inline$$TestLet_spec_let_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 13439) 14212) inline$$TestLet_spec_let_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 13439) 13447) inline$$TestLet_spec_let_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 14220) 14212) inline$$TestLet_spec_let_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 14220) 13447) inline$$TestLet_spec_let_$def_verify$0$anon22_Else_correct))))
(let ((inline$$TestLet_spec_let_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13433) 14220) inline$$TestLet_spec_let_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 13433) 13439) inline$$TestLet_spec_let_$def_verify$0$anon21_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and ((_ is $Integer) a) (>= (|i#$Integer| a) 0)) (<= (|i#$Integer| a) $MAX_U64)) (=> (and (and (and ((_ is $Integer) b) (>= (|i#$Integer| b) 0)) (<= (|i#$Integer| b) $MAX_U64)) (= (ControlFlow 0 13078) 13433)) inline$$TestLet_spec_let_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 19404) 13078) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TestLet_spec_let_with_generic_$def_verify$0$$t4@1 () T@$Value)
(declare-fun x@@9 () T@$Value)
(declare-fun y () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20106) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 14681) (- 0 20272)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_with_generic_$def_verify$0$$t4@1 ($Boolean ($IsEqual_stratified x@@9 y)))))))))
(let ((inline$$TestLet_spec_let_with_generic_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 14647) 14681)) anon0$2_correct@@1)))
(let ((inline$$TestLet_spec_let_with_generic_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 14657) 14681) anon0$2_correct@@1)))
(let ((inline$$TestLet_spec_let_with_generic_$def_verify$0$anon4$2_correct  (=> (= inline$$TestLet_spec_let_with_generic_$def_verify$0$$t4@1 ($Boolean ($IsEqual_stratified x@@9 y))) (and (=> (= (ControlFlow 0 14641) 14657) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 14641) 14647) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_generic_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 14561) 14641)) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestLet_spec_let_with_generic_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 14665) 14641) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestLet_spec_let_with_generic_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14553) 14665) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 14553) 14561) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_generic_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 14673) 14665) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 14673) 14561) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon8_Else_correct))))
(let ((inline$$TestLet_spec_let_with_generic_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14547) 14673) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 14547) 14553) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon7_Else_correct)))))
(let ((anon0_correct@@1  (=> (= (ControlFlow 0 20106) 14547) inline$$TestLet_spec_let_with_generic_$def_verify$0$anon0_correct)))
anon0_correct@@1)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun b@@0 () T@$Value)
(declare-fun a@@0 () T@$Value)
(declare-fun inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun inline$$AddU64$1$dst@2@@0 () T@$Value)
(declare-fun inline$$AddU64$2$dst@2@@0 () T@$Value)
(declare-fun inline$$AddU64$2$dst@0@@0 () T@$Value)
(declare-fun inline$$AddU64$2$dst@1@@0 () T@$Value)
(declare-fun inline$$AddU64$1$dst@0@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$TestLet_spec_let_with_lambda_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20299) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 15935) (- 0 20957)) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| b@@0) (|i#$Integer| ($Integer (+ (|i#$Integer| a@@0) (|i#$Integer| ($Integer 1)))))))))))) (=> (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| b@@0) (|i#$Integer| ($Integer (+ (|i#$Integer| a@@0) (|i#$Integer| ($Integer 1))))))))))) (=> (= (ControlFlow 0 15935) (- 0 20981)) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret1@2 ($Integer (- (|i#$Integer| inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret0@2) (|i#$Integer| ($Integer 1)))))))))))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$Abort_correct  (=> (and (= inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret0@1 $Error) (= inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@3@@0 true) (= inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret0@2 inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret0@1)) (and (= inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret1@2 inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret1@1) (= (ControlFlow 0 15861) 15935))) anon0$2_correct@@2))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 15899) 15861)) inline$$TestLet_spec_let_with_lambda_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 15909) 15861) inline$$TestLet_spec_let_with_lambda_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 15893) 15909) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 15893) 15899) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 15879) 15861)) inline$$TestLet_spec_let_with_lambda_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 15889) 15861) inline$$TestLet_spec_let_with_lambda_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 15873) 15889) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 15873) 15879) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 15851) 15861)) inline$$TestLet_spec_let_with_lambda_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 15869) 15861) inline$$TestLet_spec_let_with_lambda_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon27_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 15845) 15869) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 15845) 15851) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon20_correct  (=> (and (and (= $abort_flag@3@@0 $abort_flag@2@@0) (= inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret0@2 inline$$AddU64$1$dst@2@@0)) (and (= inline$$TestLet_spec_let_with_lambda_$def_verify$0$$ret1@2 inline$$AddU64$2$dst@2@@0) (= (ControlFlow 0 15825) 15935))) anon0$2_correct@@2)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 15823) 15825)) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon20_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 15833) 15825) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon20_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15813) 15833) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 15813) 15823) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 15841) 15833) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 15841) 15823) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon30_Else_correct))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon27_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 15807) 15841) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 15807) 15813) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$AddU64$2$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@2@@0 true) (= inline$$AddU64$2$dst@2@@0 inline$$AddU64$2$dst@0@@0)) (and (=> (= (ControlFlow 0 15791) 15845) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 15791) 15807) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AddU64$2$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| a@@0) (|i#$Integer| b@@0)) $MAX_U64) (= (ControlFlow 0 15789) 15791)) inline$$AddU64$2$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$2$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| a@@0) (|i#$Integer| b@@0))) (= inline$$AddU64$2$dst@1@@0 ($Integer (+ (|i#$Integer| a@@0) (|i#$Integer| b@@0))))) (and (= $abort_flag@2@@0 $abort_flag@1@@0) (= inline$$AddU64$2$dst@2@@0 inline$$AddU64$2$dst@1@@0))) (and (=> (= (ControlFlow 0 15733) 15845) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 15733) 15807) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AddU64$2$Entry_correct@@0  (and (=> (= (ControlFlow 0 15703) (- 0 20760)) true) (and (=> (= (ControlFlow 0 15703) 15789) inline$$AddU64$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 15703) 15733) inline$$AddU64$2$anon3_Else_correct@@0)))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 15797) 15703)) inline$$AddU64$2$Entry_correct@@0)))
(let ((inline$$AddU64$1$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@1@@0 true) (= inline$$AddU64$1$dst@2@@0 inline$$AddU64$1$dst@0@@0)) (and (=> (= (ControlFlow 0 15598) 15873) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 15598) 15797) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$AddU64$1$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$AddU64$0$dst@2@@0) (|i#$Integer| b@@0)) $MAX_U64) (= (ControlFlow 0 15596) 15598)) inline$$AddU64$1$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$1$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$AddU64$0$dst@2@@0) (|i#$Integer| b@@0))) (= inline$$AddU64$1$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$AddU64$0$dst@2@@0) (|i#$Integer| b@@0))))) (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= inline$$AddU64$1$dst@2@@0 inline$$AddU64$1$dst@1@@0))) (and (=> (= (ControlFlow 0 15540) 15873) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 15540) 15797) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$AddU64$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 15510) (- 0 20671)) true) (and (=> (= (ControlFlow 0 15510) 15596) inline$$AddU64$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 15510) 15540) inline$$AddU64$1$anon3_Else_correct@@0)))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 15604) 15510)) inline$$AddU64$1$Entry_correct@@0)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@0 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 15405) 15893) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 15405) 15604) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| a@@0) (|i#$Integer| inline$$TestLet_spec_let_with_lambda_$def_verify$0$$t4@1)) $MAX_U64) (= (ControlFlow 0 15403) 15405)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| a@@0) (|i#$Integer| inline$$TestLet_spec_let_with_lambda_$def_verify$0$$t4@1))) (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| a@@0) (|i#$Integer| inline$$TestLet_spec_let_with_lambda_$def_verify$0$$t4@1))))) (and (= $abort_flag@0@@0 false) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 15347) 15893) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 15347) 15604) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 15317) (- 0 20584)) true) (and (=> (= (ControlFlow 0 15317) 15403) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 15317) 15347) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon4$2_correct  (=> (and (= inline$$TestLet_spec_let_with_lambda_$def_verify$0$$t4@1 ($Integer 1)) (= (ControlFlow 0 15411) 15317)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 15152) 15411)) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 15917) 15411) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon4$2_correct)))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15144) 15917) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 15144) 15152) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 15925) 15917) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 15925) 15152) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon22_Else_correct))))
(let ((inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15138) 15925) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 15138) 15144) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon21_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and ((_ is $Integer) a@@0) (>= (|i#$Integer| a@@0) 0)) (<= (|i#$Integer| a@@0) $MAX_U64)) (=> (and (and (and ((_ is $Integer) b@@0) (>= (|i#$Integer| b@@0) 0)) (<= (|i#$Integer| b@@0) $MAX_U64)) (= (ControlFlow 0 14783) 15138)) inline$$TestLet_spec_let_with_lambda_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 20299) 14783) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun inline$$TestLet_spec_let_with_old_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun a@@1 () T@$Value)
(declare-fun b@@1 () T@$Value)
(declare-fun inline$$TestLet_spec_let_with_old_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestLet_spec_let_with_old_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestLet_spec_let_with_old_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$2$dst@2@@1 () T@$Value)
(declare-fun inline$$AddU64$2$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$AddU64$2$dst@1@@1 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$1$dst@2@@1 () T@$Value)
(declare-fun inline$$AddU64$1$dst@0@@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1@@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$TestLet_spec_let_with_old_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21013) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 17978) (- 0 22039)) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_with_old_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| ($Integer (+ (|i#$Integer| a@@1) (|i#$Integer| ($Integer 1))))) (|i#$Integer| b@@1)))))))) (=> (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_with_old_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| ($Integer (+ (|i#$Integer| a@@1) (|i#$Integer| ($Integer 1))))) (|i#$Integer| b@@1))))))) (=> (= (ControlFlow 0 17978) (- 0 22057)) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestLet_spec_let_with_old_$def_verify$0$$ret1@2 ($Integer (- (|i#$Integer| inline$$TestLet_spec_let_with_old_$def_verify$0$$ret0@2) (|i#$Integer| ($Integer 1)))))))))))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$Abort_correct  (=> (and (= inline$$TestLet_spec_let_with_old_$def_verify$0$$ret0@1 $Error) (= inline$$TestLet_spec_let_with_old_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@3@@1 true) (= inline$$TestLet_spec_let_with_old_$def_verify$0$$ret0@2 inline$$TestLet_spec_let_with_old_$def_verify$0$$ret0@1)) (and (= inline$$TestLet_spec_let_with_old_$def_verify$0$$ret1@2 inline$$TestLet_spec_let_with_old_$def_verify$0$$ret1@1) (= (ControlFlow 0 17896) 17978))) anon0$2_correct@@3))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 17934) 17896)) inline$$TestLet_spec_let_with_old_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 17944) 17896) inline$$TestLet_spec_let_with_old_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon26_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 17928) 17944) inline$$TestLet_spec_let_with_old_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 17928) 17934) inline$$TestLet_spec_let_with_old_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 17914) 17896)) inline$$TestLet_spec_let_with_old_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 17924) 17896) inline$$TestLet_spec_let_with_old_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon28_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 17908) 17924) inline$$TestLet_spec_let_with_old_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 17908) 17914) inline$$TestLet_spec_let_with_old_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 17886) 17896)) inline$$TestLet_spec_let_with_old_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 17904) 17896) inline$$TestLet_spec_let_with_old_$def_verify$0$Abort_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon30_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 17880) 17904) inline$$TestLet_spec_let_with_old_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 17880) 17886) inline$$TestLet_spec_let_with_old_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon22_correct  (=> (and (and (= $abort_flag@3@@1 $abort_flag@2@@1) (= inline$$TestLet_spec_let_with_old_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2|)) (and (= inline$$TestLet_spec_let_with_old_$def_verify$0$$ret1@2 |inline$$WritebackToValue$1$vdst'@2|) (= (ControlFlow 0 17860) 17978))) anon0$2_correct@@3)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 17858) 17860)) inline$$TestLet_spec_let_with_old_$def_verify$0$anon22_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 17868) 17860) inline$$TestLet_spec_let_with_old_$def_verify$0$anon22_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon32_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17848) 17868) inline$$TestLet_spec_let_with_old_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 17848) 17858) inline$$TestLet_spec_let_with_old_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon32_Then_correct  (and (=> (= (ControlFlow 0 17876) 17868) inline$$TestLet_spec_let_with_old_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 17876) 17858) inline$$TestLet_spec_let_with_old_$def_verify$0$anon33_Else_correct))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 4))) (= |inline$$WritebackToValue$1$vdst'@2| b@@1)) (and (=> (= (ControlFlow 0 17806) 17876) inline$$TestLet_spec_let_with_old_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 17806) 17848) inline$$TestLet_spec_let_with_old_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 4)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1|) 0 b@@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1|))) (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|)) (and (=> (= (ControlFlow 0 17832) 17876) inline$$TestLet_spec_let_with_old_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 17832) 17848) inline$$TestLet_spec_let_with_old_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$AddU64$2$dst@2@@1)) (and (=> (= (ControlFlow 0 17707) 17832) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 17707) 17806) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon30_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 17713) 17707)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$AddU64$2$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@2@@1 true) (= inline$$AddU64$2$dst@2@@1 inline$$AddU64$2$dst@0@@1)) (and (=> (= (ControlFlow 0 17642) 17880) inline$$TestLet_spec_let_with_old_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 17642) 17713) inline$$TestLet_spec_let_with_old_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$AddU64$2$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$ReadRef$3$v@1)) $MAX_U64) (= (ControlFlow 0 17640) 17642)) inline$$AddU64$2$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$2$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$ReadRef$3$v@1))) (= inline$$AddU64$2$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$ReadRef$3$v@1))))) (and (= $abort_flag@2@@1 $abort_flag@1@@1) (= inline$$AddU64$2$dst@2@@1 inline$$AddU64$2$dst@1@@1))) (and (=> (= (ControlFlow 0 17584) 17880) inline$$TestLet_spec_let_with_old_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 17584) 17713) inline$$TestLet_spec_let_with_old_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$AddU64$2$Entry_correct@@1  (and (=> (= (ControlFlow 0 17554) (- 0 21762)) true) (and (=> (= (ControlFlow 0 17554) 17640) inline$$AddU64$2$anon3_Then_correct@@1) (=> (= (ControlFlow 0 17554) 17584) inline$$AddU64$2$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowLoc$1$dst@1)) (= (ControlFlow 0 17455) 17554)) inline$$AddU64$2$Entry_correct@@1)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| a@@1) (= (ControlFlow 0 17391) 17455)) inline$$ReadRef$3$anon0_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 3)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 a@@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 17417) 17455))) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$AddU64$1$dst@2@@1)) (and (=> (= (ControlFlow 0 17292) 17417) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 17292) 17391) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 17298) 17292)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$AddU64$1$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@1@@1 true) (= inline$$AddU64$1$dst@2@@1 inline$$AddU64$1$dst@0@@1)) (and (=> (= (ControlFlow 0 17227) 17908) inline$$TestLet_spec_let_with_old_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 17227) 17298) inline$$TestLet_spec_let_with_old_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$AddU64$1$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$AddU64$0$dst@2@@1) (|i#$Integer| inline$$ReadRef$2$v@1)) $MAX_U64) (= (ControlFlow 0 17225) 17227)) inline$$AddU64$1$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$1$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$AddU64$0$dst@2@@1) (|i#$Integer| inline$$ReadRef$2$v@1))) (= inline$$AddU64$1$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$AddU64$0$dst@2@@1) (|i#$Integer| inline$$ReadRef$2$v@1))))) (and (= $abort_flag@1@@1 $abort_flag@0@@1) (= inline$$AddU64$1$dst@2@@1 inline$$AddU64$1$dst@1@@1))) (and (=> (= (ControlFlow 0 17169) 17908) inline$$TestLet_spec_let_with_old_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 17169) 17298) inline$$TestLet_spec_let_with_old_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$AddU64$1$Entry_correct@@1  (and (=> (= (ControlFlow 0 17139) (- 0 21577)) true) (and (=> (= (ControlFlow 0 17139) 17225) inline$$AddU64$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 17139) 17169) inline$$AddU64$1$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowLoc$1$dst@1)) (= (ControlFlow 0 17040) 17139)) inline$$AddU64$1$Entry_correct@@1)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 17046) 17040)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@1 true) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 16996) 17928) inline$$TestLet_spec_let_with_old_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 16996) 17046) inline$$TestLet_spec_let_with_old_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestLet_spec_let_with_old_$def_verify$0$$t8@1)) $MAX_U64) (= (ControlFlow 0 16994) 16996)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestLet_spec_let_with_old_$def_verify$0$$t8@1))) (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestLet_spec_let_with_old_$def_verify$0$$t8@1))))) (and (= $abort_flag@0@@1 false) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 16938) 17928) inline$$TestLet_spec_let_with_old_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 16938) 17046) inline$$TestLet_spec_let_with_old_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 16908) (- 0 21474)) true) (and (=> (= (ControlFlow 0 16908) 16994) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 16908) 16938) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon6$1_correct  (=> (and (= inline$$TestLet_spec_let_with_old_$def_verify$0$$t8@1 ($Integer 1)) (= (ControlFlow 0 17002) 16908)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 16805) 17002)) inline$$TestLet_spec_let_with_old_$def_verify$0$anon6$1_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 16773) 16805)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 17952) 16805) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (and (=> (= (ControlFlow 0 16759) 17952) inline$$TestLet_spec_let_with_old_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 16759) 16773) inline$$TestLet_spec_let_with_old_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 4) $EmptyPath b@@1)) (= (ControlFlow 0 16721) 16759)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 3) $EmptyPath a@@1)) (= (ControlFlow 0 16665) 16721)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 16547) 16665)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 17960) 16665) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 16539) 17960) inline$$TestLet_spec_let_with_old_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 16539) 16547) inline$$TestLet_spec_let_with_old_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 17968) 17960) inline$$TestLet_spec_let_with_old_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 17968) 16547) inline$$TestLet_spec_let_with_old_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestLet_spec_let_with_old_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16533) 17968) inline$$TestLet_spec_let_with_old_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 16533) 16539) inline$$TestLet_spec_let_with_old_$def_verify$0$anon23_Else_correct)))))
(let ((anon0_correct@@3  (=> (and (and ((_ is $Integer) a@@1) (>= (|i#$Integer| a@@1) 0)) (<= (|i#$Integer| a@@1) $MAX_U64)) (=> (and (and (and ((_ is $Integer) b@@1) (>= (|i#$Integer| b@@1) 0)) (<= (|i#$Integer| b@@1) $MAX_U64)) (= (ControlFlow 0 16102) 16533)) inline$$TestLet_spec_let_with_old_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 21013) 16102) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
