(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $Test_Event1 () T@$TypeName)
(declare-fun $Test_Event2 () T@$TypeName)
(declare-fun $Test_EventHandle () T@$TypeName)
(declare-fun $Test_T () T@$TypeName)
(declare-fun $Test_EventHandleGenerator () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $Test_Event1_dummy_field () Int)
(declare-fun $Test_Event1_type_value () T@$TypeValue)
(declare-fun $Test_Event2_dummy_field () Int)
(declare-fun $Test_Event2_type_value () T@$TypeValue)
(declare-fun $Test_EventHandle_counter () Int)
(declare-fun $Test_EventHandle_guid () Int)
(declare-fun $Test_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Test_T_received_events () Int)
(declare-fun $Test_T_sent_events () Int)
(declare-fun $Test_T_type_value () T@$TypeValue)
(declare-fun $Test_EventHandleGenerator_counter () Int)
(declare-fun $Test_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $Test_Event1 $Test_Event2 $Test_EventHandle $Test_T $Test_EventHandleGenerator)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $Test_Event1_dummy_field 0))
(assert (= $Test_Event1_type_value ($StructType $Test_Event1 $EmptyTypeValueArray)))
(assert (= $Test_Event2_dummy_field 0))
(assert (= $Test_Event2_type_value ($StructType $Test_Event2 $EmptyTypeValueArray)))
(assert (= $Test_EventHandle_counter 0))
(assert (= $Test_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Test_EventHandle_type_value $tv0) ($StructType $Test_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Test_EventHandle_type_value $tv0))
)))
(assert (= $Test_T_received_events 0))
(assert (= $Test_T_sent_events 1))
(assert (= $Test_T_type_value ($StructType $Test_T $EmptyTypeValueArray)))
(assert (= $Test_EventHandleGenerator_counter 0))
(assert (= $Test_EventHandleGenerator_type_value ($StructType $Test_EventHandleGenerator $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun counter () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$Test_fresh_guid_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun sender () T@$Value)
(declare-fun inline$$Test_fresh_guid_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Test_fresh_guid_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun call2formal@res@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_append$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun call2formal@res@0@@0 () T@$Value)
(declare-fun inline$$Vector_append$0$ta@0 () T@$TypeValue)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$Test_fresh_guid_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun call0formal@ta@0 () T@$TypeValue)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun call0formal@ta@0@@0 () T@$TypeValue)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $Test_EventHandleGenerator_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20880) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 15744) (- 0 22345)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1) (and (=> (= (ControlFlow 0 15744) (- 0 22380)) (=> $abort_flag@1 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@1 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64)))))) (=> (= (ControlFlow 0 15744) (- 0 22415)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core sender)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter))))))))) (|v#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter))))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)))))))))))) ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2))))))) (|v#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2)) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2)))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2)))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def_verify$0$$ret0@2)))))))))) ($BCS_serialize_core sender)))))))))))))))
(let ((inline$$Test_fresh_guid_$def_verify$0$Abort_correct  (=> (= inline$$Test_fresh_guid_$def_verify$0$$ret0@1 $Error) (=> (and (and (= inline$$Test_fresh_guid_$def_verify$0$$ret1@1 $Error) (= $abort_flag@1 true)) (and (= inline$$Test_fresh_guid_$def_verify$0$$ret0@2 inline$$Test_fresh_guid_$def_verify$0$$ret0@1) (= (ControlFlow 0 15650) 15744))) anon0$2_correct))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 15668) 15650)) inline$$Test_fresh_guid_$def_verify$0$Abort_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 15678) 15650) inline$$Test_fresh_guid_$def_verify$0$Abort_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon31_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 15662) 15678) inline$$Test_fresh_guid_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 15662) 15668) inline$$Test_fresh_guid_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 15640) 15650)) inline$$Test_fresh_guid_$def_verify$0$Abort_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 15658) 15650) inline$$Test_fresh_guid_$def_verify$0$Abort_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon33_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 15634) 15658) inline$$Test_fresh_guid_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 15634) 15640) inline$$Test_fresh_guid_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon24_correct  (=> (= $abort_flag@1 $abort_flag@0) (=> (and (= inline$$Test_fresh_guid_$def_verify$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2|) (= (ControlFlow 0 15614) 15744)) anon0$2_correct))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 15612) 15614)) inline$$Test_fresh_guid_$def_verify$0$anon24_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 15622) 15614) inline$$Test_fresh_guid_$def_verify$0$anon24_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon35_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15602) 15622) inline$$Test_fresh_guid_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 15602) 15612) inline$$Test_fresh_guid_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon35_Then_correct  (and (=> (= (ControlFlow 0 15630) 15622) inline$$Test_fresh_guid_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 15630) 15612) inline$$Test_fresh_guid_$def_verify$0$anon36_Else_correct))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 2))) (= |inline$$WritebackToValue$1$vdst'@2| call2formal@res@0)) (and (=> (= (ControlFlow 0 15560) 15630) inline$$Test_fresh_guid_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 15560) 15602) inline$$Test_fresh_guid_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1|) 0 call2formal@res@0 (|v#$Mutation| |inline$$WriteRef$1$to'@1|))) (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|)) (and (=> (= (ControlFlow 0 15586) 15630) inline$$Test_fresh_guid_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 15586) 15602) inline$$Test_fresh_guid_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1) |inline$$Vector_append$0$v'@1|)) (and (=> (= (ControlFlow 0 15461) 15586) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 15461) 15560) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon33_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 15467) 15461)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$Vector_append$0$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$2$v@1) (=> (and ((_ is $Vector) call2formal@res@0@@0) (= |inline$$Vector_append$0$v'@1| ($Vector (let ((m2 (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0))))
(let ((l2 (|l#$ValueArray| (|v#$Vector| call2formal@res@0@@0))))
(let ((m1 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1))))
(let ((l1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1))))
($ValueArray (|lambda#2| 0 (+ l1 l2) l1 m1 m2 l1 $Error) (+ l1 l2))))))))) (and (=> (= (ControlFlow 0 15396) 15634) inline$$Test_fresh_guid_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 15396) 15467) inline$$Test_fresh_guid_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$Vector_append$0$Entry_correct  (=> (and (= inline$$Vector_append$0$ta@0 $IntegerType) (= (ControlFlow 0 15380) 15396)) inline$$Vector_append$0$anon0_correct)))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowLoc$1$dst@1)) (= (ControlFlow 0 15325) 15380)) inline$$Vector_append$0$Entry_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 2) $EmptyPath call2formal@res@0)) (= (ControlFlow 0 15287) 15325)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 4))) (= (ControlFlow 0 15205) 15287)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 4)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 counter (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= (ControlFlow 0 15231) 15287)) inline$$BorrowLoc$1$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1)) (and (=> (= (ControlFlow 0 15050) 15231) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 15050) 15205) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 15106) 15231) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 15106) 15205) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 15014) 15106) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 15014) 15050) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1) (|p#$Mutation| inline$$BorrowField$2$dst@1) inline$$AddU64$0$dst@2)) (= (ControlFlow 0 14871) 15014)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $Test_EventHandleGenerator_counter) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $Test_EventHandleGenerator_counter))) (= (ControlFlow 0 14812) 14871))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon31_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 14818) 14812)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 14682) 15662) inline$$Test_fresh_guid_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 14682) 14818) inline$$Test_fresh_guid_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$Test_fresh_guid_$def_verify$0$$t9@1)) $MAX_U64) (= (ControlFlow 0 14680) 14682)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$Test_fresh_guid_$def_verify$0$$t9@1))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$Test_fresh_guid_$def_verify$0$$t9@1))))) (and (= $abort_flag@0 false) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 14624) 15662) inline$$Test_fresh_guid_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 14624) 14818) inline$$Test_fresh_guid_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 14594) (- 0 21729)) true) (and (=> (= (ControlFlow 0 14594) 14680) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 14594) 14624) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon29_Else$1_correct  (=> (and (= inline$$Test_fresh_guid_$def_verify$0$$t9@1 ($Integer 1)) (= (ControlFlow 0 14688) 14594)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 14483) 14688)) inline$$Test_fresh_guid_$def_verify$0$anon29_Else$1_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $Test_EventHandleGenerator_counter) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $Test_EventHandleGenerator_counter))) (= (ControlFlow 0 14445) 14483))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon29_Else_correct  (=> (and (not false) (= (ControlFlow 0 14497) 14445)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon29_Then_correct true))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon27_Else$1_correct  (=> (and (= call0formal@ta@0 $IntegerType) (= call2formal@res@0 ($BCS_serialize_core inline$$ReadRef$0$v@1))) (=> (and (and ((_ is $Vector) call2formal@res@0) (let ((va@@8 (|v#$Vector| call2formal@res@0)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall ((i@@10 Int) ) (!  (=> (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| call2formal@res@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@10))
))) (and (=> (= (ControlFlow 0 14287) 15682) inline$$Test_fresh_guid_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 14287) 14497) inline$$Test_fresh_guid_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 14271) 14287)) inline$$Test_fresh_guid_$def_verify$0$anon27_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $Test_EventHandleGenerator_counter) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $Test_EventHandleGenerator_counter))) (= (ControlFlow 0 14233) 14271))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon27_Else_correct  (=> (and (not false) (= (ControlFlow 0 14285) 14233)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon27_Then_correct true))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon4$3_correct  (=> (and (= call0formal@ta@0@@0 $AddressType) (= call2formal@res@0@@0 ($BCS_serialize_core sender))) (=> (and (and ((_ is $Vector) call2formal@res@0@@0) (let ((va@@9 (|v#$Vector| call2formal@res@0@@0)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall ((i@@11 Int) ) (!  (=> (and (<= 0 i@@11) (< i@@11 (|l#$ValueArray| (|v#$Vector| call2formal@res@0@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0)) i@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0)) i@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0)) i@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0)) i@@11))
))) (and (=> (= (ControlFlow 0 14075) 15702) inline$$Test_fresh_guid_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 14075) 14285) inline$$Test_fresh_guid_$def_verify$0$anon27_Else_correct))))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 4) $EmptyPath counter)) (= (ControlFlow 0 14067) 14075)) inline$$Test_fresh_guid_$def_verify$0$anon4$3_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 13949) 14067)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 15726) 14067) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 13941) 15726) inline$$Test_fresh_guid_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 13941) 13949) inline$$Test_fresh_guid_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 15734) 15726) inline$$Test_fresh_guid_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 15734) 13949) inline$$Test_fresh_guid_$def_verify$0$anon26_Else_correct))))
(let ((inline$$Test_fresh_guid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13935) 15734) inline$$Test_fresh_guid_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 13935) 13941) inline$$Test_fresh_guid_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr))) $Test_EventHandleGenerator_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr))) $Test_EventHandleGenerator_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr))) $Test_EventHandleGenerator_counter)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 15742) 13935)) inline$$Test_fresh_guid_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and (and (and (and ((_ is $Vector) counter) (let ((va@@11 (|v#$Vector| counter)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| counter)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter)) $Test_EventHandleGenerator_counter)) $MAX_U64))) (and ((_ is $Address) sender) (= (ControlFlow 0 13445) 15742))) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 20880) 13445) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun counter@@0 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun sender@@0 () T@$Value)
(declare-fun inline$$Test_EventHandle_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$Test_new_event_handle_impl_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Test_fresh_guid_$def$0$$ret0@2 () T@$Value)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$Test_fresh_guid_$def$0$$ret1@2 () T@$Value)
(declare-fun inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Test_new_event_handle_impl_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun inline$$Test_fresh_guid_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Test_fresh_guid_$def$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun call2formal@res@0@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_append$0$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun call2formal@res@0@@2 () T@$Value)
(declare-fun inline$$Vector_append$0$ta@0@@0 () T@$TypeValue)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$2$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@0 () Int)
(declare-fun inline$$BorrowField$2$p@2@@0 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@0 () T@$Value)
(declare-fun inline$$Test_fresh_guid_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun call0formal@ta@0@@1 () T@$TypeValue)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun call0formal@ta@0@@2 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 22461) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 19508) (- 0 24487)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@2) (and (=> (= (ControlFlow 0 19508) (- 0 24522)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64)))))) (and (=> (= (ControlFlow 0 19508) (- 0 24557)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid)))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core sender@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))))))) (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))))))) ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid)))))))) (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))))))) ($BCS_serialize_core sender@@0))))))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid)))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core sender@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))))))) (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))))))) ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid)))))))) (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer (|l#$ValueArray| (|v#$Vector| ($BCS_serialize_core (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter))))) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_guid))))))))))) ($BCS_serialize_core sender@@0)))))))) (=> (= (ControlFlow 0 19508) (- 0 24589)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2)) $Test_EventHandle_counter) ($Integer 0))))))))))))))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon10_correct  (=> (= inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2 inline$$Test_EventHandle_pack$0$$struct@1) (=> (and (= $abort_flag@2 $abort_flag@1@@0) (= (ControlFlow 0 19456) 19508)) anon0$2_correct@@0))))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 19454) 19456)) inline$$Test_new_event_handle_impl_$def_verify$0$anon10_correct)))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 19464) 19456) inline$$Test_new_event_handle_impl_$def_verify$0$anon10_correct)))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon14_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 19444) 19464) inline$$Test_new_event_handle_impl_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 19444) 19454) inline$$Test_new_event_handle_impl_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon14_Then_correct  (and (=> (= (ControlFlow 0 19472) 19464) inline$$Test_new_event_handle_impl_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 19472) 19454) inline$$Test_new_event_handle_impl_$def_verify$0$anon15_Else_correct))))
(let ((inline$$Test_EventHandle_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 19422) 19472) inline$$Test_new_event_handle_impl_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 19422) 19444) inline$$Test_new_event_handle_impl_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Test_EventHandle_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 19428) 19472) inline$$Test_new_event_handle_impl_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 19428) 19444) inline$$Test_new_event_handle_impl_$def_verify$0$anon14_Else_correct))))
(let ((inline$$Test_EventHandle_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 19416) 19428) inline$$Test_EventHandle_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 19416) 19422) inline$$Test_EventHandle_pack$0$anon4_Else_correct)))))
(let ((inline$$Test_EventHandle_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 19408) 19472) inline$$Test_new_event_handle_impl_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 19408) 19444) inline$$Test_new_event_handle_impl_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Test_EventHandle_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$Test_new_event_handle_impl_$def_verify$0$$t5@1) (>= (|i#$Integer| inline$$Test_new_event_handle_impl_$def_verify$0$$t5@1) 0)) (<= (|i#$Integer| inline$$Test_new_event_handle_impl_$def_verify$0$$t5@1) $MAX_U64)) (=> (and (and (and ((_ is $Vector) inline$$Test_fresh_guid_$def$0$$ret0@2) (let ((va@@12 (|v#$Vector| inline$$Test_fresh_guid_$def$0$$ret0@2)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (forall ((inline$$Test_EventHandle_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Test_EventHandle_pack$0$$$0 0) (< inline$$Test_EventHandle_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def$0$$ret0@2)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def$0$$ret0@2)) inline$$Test_EventHandle_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def$0$$ret0@2)) inline$$Test_EventHandle_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def$0$$ret0@2)) inline$$Test_EventHandle_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Test_fresh_guid_$def$0$$ret0@2)) inline$$Test_EventHandle_pack$0$$$0))
))) (= inline$$Test_EventHandle_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Test_new_event_handle_impl_$def_verify$0$$t5@1) 1 inline$$Test_fresh_guid_$def$0$$ret0@2) 2)))) (and (=> (= (ControlFlow 0 19400) 19416) inline$$Test_EventHandle_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 19400) 19408) inline$$Test_EventHandle_pack$0$anon3_Else_correct))))))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1|) ($Local 2))) (= (ControlFlow 0 19137) 19400)) inline$$Test_EventHandle_pack$0$anon0_correct)))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$2$to'@1|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$2$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1|) 0 counter@@0 (|v#$Mutation| |inline$$WriteRef$2$to'@1|))) (= (ControlFlow 0 19163) 19400)) inline$$Test_EventHandle_pack$0$anon0_correct))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$Test_fresh_guid_$def$0$$ret1@2)) (and (=> (= (ControlFlow 0 19038) 19163) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 19038) 19137) inline$$WritebackToValue$2$anon3_Else_correct)))))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 19044) 19038)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon13_Then_correct  (=> (and $abort_flag@1@@0 (= inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@1 $Error)) (=> (and (and (= inline$$Test_new_event_handle_impl_$def_verify$0$$ret1@1 $Error) (= inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@2 inline$$Test_new_event_handle_impl_$def_verify$0$$ret0@1)) (and (= $abort_flag@2 true) (= (ControlFlow 0 19482) 19508))) anon0$2_correct@@0))))
(let ((inline$$Test_fresh_guid_$def$0$Abort_correct  (=> (= inline$$Test_fresh_guid_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$Test_fresh_guid_$def$0$$ret1@1 $Error) (= $abort_flag@1@@0 true)) (and (= inline$$Test_fresh_guid_$def$0$$ret0@2 inline$$Test_fresh_guid_$def$0$$ret0@1) (= inline$$Test_fresh_guid_$def$0$$ret1@2 inline$$Test_fresh_guid_$def$0$$ret1@1))) (and (=> (= (ControlFlow 0 18877) 19482) inline$$Test_new_event_handle_impl_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 18877) 19044) inline$$Test_new_event_handle_impl_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$Test_fresh_guid_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 18895) 18877)) inline$$Test_fresh_guid_$def$0$Abort_correct)))
(let ((inline$$Test_fresh_guid_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 18905) 18877) inline$$Test_fresh_guid_$def$0$Abort_correct)))
(let ((inline$$Test_fresh_guid_$def$0$anon31_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 18889) 18905) inline$$Test_fresh_guid_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 18889) 18895) inline$$Test_fresh_guid_$def$0$anon32_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 18867) 18877)) inline$$Test_fresh_guid_$def$0$Abort_correct)))
(let ((inline$$Test_fresh_guid_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 18885) 18877) inline$$Test_fresh_guid_$def$0$Abort_correct)))
(let ((inline$$Test_fresh_guid_$def$0$anon33_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 18861) 18885) inline$$Test_fresh_guid_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 18861) 18867) inline$$Test_fresh_guid_$def$0$anon34_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def$0$anon24_correct  (=> (= $abort_flag@1@@0 $abort_flag@0@@0) (=> (and (= inline$$Test_fresh_guid_$def$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2@@0|) (= inline$$Test_fresh_guid_$def$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2|)) (and (=> (= (ControlFlow 0 18841) 19482) inline$$Test_new_event_handle_impl_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 18841) 19044) inline$$Test_new_event_handle_impl_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$Test_fresh_guid_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 18839) 18841)) inline$$Test_fresh_guid_$def$0$anon24_correct)))
(let ((inline$$Test_fresh_guid_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 18849) 18841) inline$$Test_fresh_guid_$def$0$anon24_correct)))
(let ((inline$$Test_fresh_guid_$def$0$anon35_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18829) 18849) inline$$Test_fresh_guid_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 18829) 18839) inline$$Test_fresh_guid_$def$0$anon36_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def$0$anon35_Then_correct  (and (=> (= (ControlFlow 0 18857) 18849) inline$$Test_fresh_guid_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 18857) 18839) inline$$Test_fresh_guid_$def$0$anon36_Else_correct))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|) ($Local 2))) (= |inline$$WritebackToValue$1$vdst'@2@@0| call2formal@res@0@@1)) (and (=> (= (ControlFlow 0 18787) 18857) inline$$Test_fresh_guid_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 18787) 18829) inline$$Test_fresh_guid_$def$0$anon35_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|) 0 call2formal@res@0@@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))) (= |inline$$WritebackToValue$1$vdst'@2@@0| |inline$$WritebackToValue$1$vdst'@1@@0|)) (and (=> (= (ControlFlow 0 18813) 18857) inline$$Test_fresh_guid_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 18813) 18829) inline$$Test_fresh_guid_$def$0$anon35_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|p#$Mutation| inline$$BorrowLoc$2$dst@1) |inline$$Vector_append$0$v'@1@@0|)) (and (=> (= (ControlFlow 0 18688) 18813) inline$$WritebackToValue$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 18688) 18787) inline$$WritebackToValue$1$anon3_Else_correct@@0)))))
(let ((inline$$Test_fresh_guid_$def$0$anon33_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 18694) 18688)) inline$$WriteRef$1$anon0_correct@@0)))
(let ((inline$$Vector_append$0$anon0_correct@@0  (=> ((_ is $Vector) inline$$ReadRef$3$v@1) (=> (and ((_ is $Vector) call2formal@res@0@@2) (= |inline$$Vector_append$0$v'@1@@0| ($Vector (let ((m2@@0 (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@2))))
(let ((l2@@0 (|l#$ValueArray| (|v#$Vector| call2formal@res@0@@2))))
(let ((m1@@0 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1))))
(let ((l1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1))))
($ValueArray (|lambda#2| 0 (+ l1@@0 l2@@0) l1@@0 m1@@0 m2@@0 l1@@0 $Error) (+ l1@@0 l2@@0))))))))) (and (=> (= (ControlFlow 0 18623) 18861) inline$$Test_fresh_guid_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 18623) 18694) inline$$Test_fresh_guid_$def$0$anon33_Else_correct))))))
(let ((inline$$Vector_append$0$Entry_correct@@0  (=> (and (= inline$$Vector_append$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 18607) 18623)) inline$$Vector_append$0$anon0_correct@@0)))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowLoc$2$dst@1)) (= (ControlFlow 0 18552) 18607)) inline$$Vector_append$0$Entry_correct@@0)))
(let ((inline$$BorrowLoc$2$anon0_correct  (=> (and (= inline$$BorrowLoc$2$dst@1 ($Mutation ($Local 2) $EmptyPath call2formal@res@0@@1)) (= (ControlFlow 0 18514) 18552)) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 4))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$0$v@1@@0) (= (ControlFlow 0 18432) 18514)) inline$$BorrowLoc$2$anon0_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 4)) (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 inline$$ReadRef$0$v@1@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1@@0|) (= (ControlFlow 0 18458) 18514))) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowLoc$1$dst@1@@0)) (and (=> (= (ControlFlow 0 18277) 18458) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 18277) 18432) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (and (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)))) (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|))) (and (=> (= (ControlFlow 0 18333) 18458) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 18333) 18432) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) (and (=> (= (ControlFlow 0 18241) 18333) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 18241) 18277) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (and (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@0) (|p#$Mutation| inline$$BorrowField$2$dst@1@@0) inline$$AddU64$0$dst@2@@0)) (= (ControlFlow 0 18098) 18241)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$BorrowField$2$anon0_correct@@0  (=> (= inline$$BorrowField$2$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0)) (=> (and (and (= inline$$BorrowField$2$size@1@@0 (|size#$Path| inline$$BorrowField$2$p@1@@0)) (= inline$$BorrowField$2$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@0) inline$$BorrowField$2$size@1@@0 $Test_EventHandleGenerator_counter) (+ inline$$BorrowField$2$size@1@@0 1)))) (and (= inline$$BorrowField$2$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$BorrowField$2$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) $Test_EventHandleGenerator_counter))) (= (ControlFlow 0 18039) 18098))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$Test_fresh_guid_$def$0$anon31_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 18045) 18039)) inline$$BorrowField$2$anon0_correct@@0)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@0 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 17909) 18889) inline$$Test_fresh_guid_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 17909) 18045) inline$$Test_fresh_guid_$def$0$anon31_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$Test_fresh_guid_$def$0$$t9@1)) $MAX_U64) (= (ControlFlow 0 17907) 17909)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$Test_fresh_guid_$def$0$$t9@1))) (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$Test_fresh_guid_$def$0$$t9@1))))) (and (= $abort_flag@0@@0 false) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 17851) 18889) inline$$Test_fresh_guid_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 17851) 18045) inline$$Test_fresh_guid_$def$0$anon31_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 17821) (- 0 23601)) true) (and (=> (= (ControlFlow 0 17821) 17907) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 17821) 17851) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$Test_fresh_guid_$def$0$anon29_Else$1_correct  (=> (and (= inline$$Test_fresh_guid_$def$0$$t9@1 ($Integer 1)) (= (ControlFlow 0 17915) 17821)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$ReadRef$2$anon0_correct@@0  (=> (and (= inline$$ReadRef$2$v@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1@@0)) (= (ControlFlow 0 17710) 17915)) inline$$Test_fresh_guid_$def$0$anon29_Else$1_correct)))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $Test_EventHandleGenerator_counter) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) $Test_EventHandleGenerator_counter))) (= (ControlFlow 0 17672) 17710))) inline$$ReadRef$2$anon0_correct@@0))))
(let ((inline$$Test_fresh_guid_$def$0$anon29_Else_correct  (=> (and (not false) (= (ControlFlow 0 17724) 17672)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$Test_fresh_guid_$def$0$anon29_Then_correct true))
(let ((inline$$Test_fresh_guid_$def$0$anon27_Else$1_correct  (=> (and (= call0formal@ta@0@@1 $IntegerType) (= call2formal@res@0@@1 ($BCS_serialize_core inline$$ReadRef$1$v@1@@0))) (=> (and (and ((_ is $Vector) call2formal@res@0@@1) (let ((va@@13 (|v#$Vector| call2formal@res@0@@1)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (forall ((i@@12 Int) ) (!  (=> (and (<= 0 i@@12) (< i@@12 (|l#$ValueArray| (|v#$Vector| call2formal@res@0@@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@1)) i@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@1)) i@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@1)) i@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@1)) i@@12))
))) (and (=> (= (ControlFlow 0 17514) 18909) inline$$Test_fresh_guid_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 17514) 17724) inline$$Test_fresh_guid_$def$0$anon29_Else_correct))))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 17498) 17514)) inline$$Test_fresh_guid_$def$0$anon27_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $Test_EventHandleGenerator_counter) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) $Test_EventHandleGenerator_counter))) (= (ControlFlow 0 17460) 17498))) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$Test_fresh_guid_$def$0$anon27_Else_correct  (=> (and (not false) (= (ControlFlow 0 17512) 17460)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$Test_fresh_guid_$def$0$anon27_Then_correct true))
(let ((inline$$Test_fresh_guid_$def$0$anon4$3_correct  (=> (and (= call0formal@ta@0@@2 $AddressType) (= call2formal@res@0@@2 ($BCS_serialize_core sender@@0))) (=> (and (and ((_ is $Vector) call2formal@res@0@@2) (let ((va@@14 (|v#$Vector| call2formal@res@0@@2)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (forall ((i@@13 Int) ) (!  (=> (and (<= 0 i@@13) (< i@@13 (|l#$ValueArray| (|v#$Vector| call2formal@res@0@@2)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@2)) i@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@2)) i@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@2)) i@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@2)) i@@13))
))) (and (=> (= (ControlFlow 0 17302) 18929) inline$$Test_fresh_guid_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 17302) 17512) inline$$Test_fresh_guid_$def$0$anon27_Else_correct))))))
(let ((inline$$BorrowLoc$1$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$1$dst@1@@0 ($Mutation ($Local 4) $EmptyPath inline$$ReadRef$0$v@1@@0)) (= (ControlFlow 0 17294) 17302)) inline$$Test_fresh_guid_$def$0$anon4$3_correct)))
(let ((inline$$Test_fresh_guid_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 17176) 17294)) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$Test_fresh_guid_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 18953) 17294) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$Test_fresh_guid_$def$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17168) 18953) inline$$Test_fresh_guid_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 17168) 17176) inline$$Test_fresh_guid_$def$0$anon26_Else_correct)))))
(let ((inline$$Test_fresh_guid_$def$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 18961) 18953) inline$$Test_fresh_guid_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 18961) 17176) inline$$Test_fresh_guid_$def$0$anon26_Else_correct))))
(let ((inline$$Test_fresh_guid_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17162) 18961) inline$$Test_fresh_guid_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 17162) 17168) inline$$Test_fresh_guid_$def$0$anon25_Else_correct)))))
(let ((inline$$Test_fresh_guid_$direct_intra$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@0) (let ((va@@15 (|v#$Vector| inline$$ReadRef$0$v@1@@0)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Test_EventHandleGenerator_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Test_EventHandleGenerator_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Test_EventHandleGenerator_counter)) $MAX_U64))) (and ((_ is $Address) sender@@0) (= (ControlFlow 0 18969) 17162))) inline$$Test_fresh_guid_$def$0$anon0_correct)))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon4$4_correct  (and (=> (= (ControlFlow 0 18979) (- 0 23183)) true) (=> (= (ControlFlow 0 18979) 18969) inline$$Test_fresh_guid_$direct_intra$0$anon0_correct))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 16622) 18979)) inline$$Test_new_event_handle_impl_$def_verify$0$anon4$4_correct)))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon4$3_correct  (=> (and (= inline$$Test_new_event_handle_impl_$def_verify$0$$t5@1 ($Integer 0)) (= (ControlFlow 0 16628) 16622)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 2) $EmptyPath counter@@0)) (= (ControlFlow 0 16580) 16628)) inline$$Test_new_event_handle_impl_$def_verify$0$anon4$3_correct)))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 16462) 16580)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 19490) 16580) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 16454) 19490) inline$$Test_new_event_handle_impl_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 16454) 16462) inline$$Test_new_event_handle_impl_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 19498) 19490) inline$$Test_new_event_handle_impl_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 19498) 16462) inline$$Test_new_event_handle_impl_$def_verify$0$anon12_Else_correct))))
(let ((inline$$Test_new_event_handle_impl_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16448) 19498) inline$$Test_new_event_handle_impl_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 16448) 16454) inline$$Test_new_event_handle_impl_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Test_EventHandleGenerator_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Test_EventHandleGenerator_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Test_EventHandleGenerator_counter)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Test_EventHandleGenerator_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (= (ControlFlow 0 19506) 16448)) inline$$Test_new_event_handle_impl_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> (and (and (and (and ((_ is $Vector) counter@@0) (let ((va@@17 (|v#$Vector| counter@@0)))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| counter@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| counter@@0)) $Test_EventHandleGenerator_counter)) $MAX_U64))) (and ((_ is $Address) sender@@0) (= (ControlFlow 0 16153) 19506))) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 22461) 16153) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
