(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $TestReferences_T () T@$TypeName)
(declare-fun $TestReferences_WithdrawalCapability () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $TestReferences_T_a () Int)
(declare-fun $TestReferences_T_type_value () T@$TypeValue)
(declare-fun $TestReferences_WithdrawalCapability_account_address () Int)
(declare-fun $TestReferences_WithdrawalCapability_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $TestReferences_T $TestReferences_WithdrawalCapability)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $TestReferences_T_a 0))
(assert (= $TestReferences_T_type_value ($StructType $TestReferences_T $EmptyTypeValueArray)))
(assert (= $TestReferences_WithdrawalCapability_account_address 0))
(assert (= $TestReferences_WithdrawalCapability_type_value ($StructType $TestReferences_WithdrawalCapability $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun b () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun inline$$TestReferences_mut_b_$def_verify$0$$t3@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 18637) (let ((inline$$TestReferences_mut_b_$def_verify$0$anon6_Else_correct true))
(let ((inline$$TestReferences_mut_b_$def_verify$0$anon6_Then_correct true))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 1))) (and (=> (= (ControlFlow 0 12847) 12899) inline$$TestReferences_mut_b_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 12847) 12889) inline$$TestReferences_mut_b_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 1)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 b (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (and (=> (= (ControlFlow 0 12873) 12899) inline$$TestReferences_mut_b_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 12873) 12889) inline$$TestReferences_mut_b_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$TestReferences_mut_b_$def_verify$0$$t3@1)) (and (=> (= (ControlFlow 0 12748) 12873) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 12748) 12847) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$TestReferences_mut_b_$def_verify$0$anon2$2_correct  (=> (and (= inline$$TestReferences_mut_b_$def_verify$0$$t3@1 ($Integer 10)) (= (ControlFlow 0 12754) 12748)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 1) $EmptyPath b)) (= (ControlFlow 0 12685) 12754)) inline$$TestReferences_mut_b_$def_verify$0$anon2$2_correct)))
(let ((inline$$TestReferences_mut_b_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 12601) 12685)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestReferences_mut_b_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 12907) 12685) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestReferences_mut_b_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 12595) 12907) inline$$TestReferences_mut_b_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 12595) 12601) inline$$TestReferences_mut_b_$def_verify$0$anon5_Else_correct)))))
(let ((anon0_correct  (=> (and (and (and ((_ is $Integer) b) (>= (|i#$Integer| b) 0)) (<= (|i#$Integer| b) $MAX_U64)) (= (ControlFlow 0 12469) 12595)) inline$$TestReferences_mut_b_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 18637) 12469) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$TestReferences_mut_ref_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestReferences_mut_ref_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@1 () Int)
(declare-fun inline$$TestReferences_mut_ref_$def_verify$0$$t4@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$TestReferences_mut_ref_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun inline$$TestReferences_mut_b_$def$0$$t3@1 () T@$Value)
(declare-fun inline$$TestReferences_mut_ref_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 18883) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 14259) (- 0 19540)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0) (=> (= (ControlFlow 0 14259) (- 0 19549)) (=> $abort_flag@0 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$Abort_correct  (=> (and (= $abort_flag@0 true) (= (ControlFlow 0 14215) 14259)) anon0$2_correct)))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 14209) 14215)) inline$$TestReferences_mut_ref_$def_verify$0$Abort_correct)))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 14223) 14215) inline$$TestReferences_mut_ref_$def_verify$0$Abort_correct)))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| inline$$TestReferences_mut_ref_$def_verify$0$$t5@1) (=> (and (= inline$$TestReferences_mut_ref_$def_verify$0$$t6@1 ($Integer 1)) (= $abort_code@1 (|i#$Integer| inline$$TestReferences_mut_ref_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 14203) 14223) inline$$TestReferences_mut_ref_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 14203) 14209) inline$$TestReferences_mut_ref_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| inline$$TestReferences_mut_ref_$def_verify$0$$t5@1)) (=> (and (= $abort_flag@0 false) (= (ControlFlow 0 14189) 14259)) anon0$2_correct))))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon8$1_correct  (=> (and (= inline$$TestReferences_mut_ref_$def_verify$0$$t4@1 ($Integer 10)) (= inline$$TestReferences_mut_ref_$def_verify$0$$t5@1 ($Boolean  (not ($IsEqual_stratified |inline$$WritebackToValue$1$vdst'@2| inline$$TestReferences_mut_ref_$def_verify$0$$t4@1))))) (and (=> (= (ControlFlow 0 14181) 14203) inline$$TestReferences_mut_ref_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 14181) 14189) inline$$TestReferences_mut_ref_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| inline$$ReadRef$1$v@1) (= (ControlFlow 0 14133) 14181)) inline$$TestReferences_mut_ref_$def_verify$0$anon8$1_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1|) 0 inline$$ReadRef$1$v@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 14159) 14181))) inline$$TestReferences_mut_ref_$def_verify$0$anon8$1_correct)))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon16_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14040) 14159) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 14040) 14133) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon16_Then_correct  (and (=> (= (ControlFlow 0 14231) 14159) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 14231) 14133) inline$$WritebackToValue$1$anon3_Else_correct))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (= inline$$ReadRef$1$v@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1|)) (and (=> (= (ControlFlow 0 14026) 14231) inline$$TestReferences_mut_ref_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 14026) 14040) inline$$TestReferences_mut_ref_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 13994) 14026)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon15_Then_correct  (=> (and (= inline$$TestReferences_mut_ref_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1|)) (= (ControlFlow 0 14241) 14026)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0) |inline$$WritebackToValue$0$vdst'@2|)) (and (=> (= (ControlFlow 0 13980) 14241) inline$$TestReferences_mut_ref_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 13980) 13994) inline$$TestReferences_mut_ref_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon14_Else_correct  (=> (and (not false) (= (ControlFlow 0 13986) 13980)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon14_Then_correct true))
(let ((inline$$TestReferences_mut_b_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 13889) 14245) inline$$TestReferences_mut_ref_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 13889) 13986) inline$$TestReferences_mut_ref_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestReferences_mut_b_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 13899) 14245) inline$$TestReferences_mut_ref_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 13899) 13986) inline$$TestReferences_mut_ref_$def_verify$0$anon14_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$0$v@1)) (and (=> (= (ControlFlow 0 13847) 13899) inline$$TestReferences_mut_b_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 13847) 13889) inline$$TestReferences_mut_b_$def$0$anon6_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|) 0 inline$$ReadRef$0$v@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))) (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1@@0|)) (and (=> (= (ControlFlow 0 13873) 13899) inline$$TestReferences_mut_b_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 13873) 13889) inline$$TestReferences_mut_b_$def$0$anon6_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$TestReferences_mut_b_$def$0$$t3@1)) (and (=> (= (ControlFlow 0 13748) 13873) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 13748) 13847) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$TestReferences_mut_b_$def$0$anon2$2_correct  (=> (and (= inline$$TestReferences_mut_b_$def$0$$t3@1 ($Integer 10)) (= (ControlFlow 0 13754) 13748)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 1) $EmptyPath inline$$ReadRef$0$v@1)) (= (ControlFlow 0 13685) 13754)) inline$$TestReferences_mut_b_$def$0$anon2$2_correct)))
(let ((inline$$TestReferences_mut_b_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 13601) 13685)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestReferences_mut_b_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 13907) 13685) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestReferences_mut_b_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 13595) 13907) inline$$TestReferences_mut_b_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 13595) 13601) inline$$TestReferences_mut_b_$def$0$anon5_Else_correct)))))
(let ((inline$$TestReferences_mut_b_$direct_intra$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$ReadRef$0$v@1) (>= (|i#$Integer| inline$$ReadRef$0$v@1) 0)) (<= (|i#$Integer| inline$$ReadRef$0$v@1) $MAX_U64)) (= (ControlFlow 0 13913) 13595)) inline$$TestReferences_mut_b_$def$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 13425) 13913)) inline$$TestReferences_mut_b_$direct_intra$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 0) $EmptyPath inline$$TestReferences_mut_ref_$def_verify$0$$t2@1)) (= (ControlFlow 0 13387) 13425)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 13337) 13387)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 14253) 13387) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestReferences_mut_ref_$def_verify$0$anon0_correct  (=> (and (not false) (= inline$$TestReferences_mut_ref_$def_verify$0$$t2@1 ($Integer 20))) (and (=> (= (ControlFlow 0 13329) 14253) inline$$TestReferences_mut_ref_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 13329) 13337) inline$$TestReferences_mut_ref_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@0  (=> (= (ControlFlow 0 18883) 13329) inline$$TestReferences_mut_ref_$def_verify$0$anon0_correct)))
anon0_correct@@0)))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t4@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@0| () T@$Value)
(declare-fun inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$TestReferences_mut_b_$def$0$$t3@1@@0 () T@$Value)
(declare-fun inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 19562) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 15711) (- 0 20219)) (=> (|b#$Boolean| ($Boolean true)) $abort_flag@0@@0)) (=> (=> (|b#$Boolean| ($Boolean true)) $abort_flag@0@@0) (=> (= (ControlFlow 0 15711) (- 0 20228)) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean true))))))))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$Abort_correct  (=> (and (= $abort_flag@0@@0 true) (= (ControlFlow 0 15667) 15711)) anon0$2_correct@@0)))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 15661) 15667)) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 15675) 15667) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$Abort_correct)))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t5@1) (=> (and (= inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t6@1 ($Integer 1)) (= $abort_code@1@@0 (|i#$Integer| inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 15655) 15675) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 15655) 15661) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t5@1)) (=> (and (= $abort_flag@0@@0 false) (= (ControlFlow 0 15641) 15711)) anon0$2_correct@@0))))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon8$1_correct  (=> (and (= inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t4@1 ($Integer 10)) (= inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t5@1 ($Boolean  (not ($IsEqual_stratified |inline$$WritebackToValue$1$vdst'@2@@0| inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t4@1))))) (and (=> (= (ControlFlow 0 15633) 15655) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 15633) 15641) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|) ($Local 0))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2@@0| inline$$ReadRef$1$v@1@@0) (= (ControlFlow 0 15585) 15633)) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon8$1_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|) ($Local 0)) (= |inline$$WritebackToValue$1$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|) 0 inline$$ReadRef$1$v@1@@0 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|)))) (and (= |inline$$WritebackToValue$1$vdst'@2@@0| |inline$$WritebackToValue$1$vdst'@1@@0|) (= (ControlFlow 0 15611) 15633))) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon8$1_correct)))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon16_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15492) 15611) inline$$WritebackToValue$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 15492) 15585) inline$$WritebackToValue$1$anon3_Else_correct@@0)))))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon16_Then_correct  (and (=> (= (ControlFlow 0 15683) 15611) inline$$WritebackToValue$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 15683) 15585) inline$$WritebackToValue$1$anon3_Else_correct@@0))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (and (=> (= (ControlFlow 0 15478) 15683) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 15478) 15492) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 15446) 15478)) inline$$ReadRef$1$anon0_correct@@0)))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon15_Then_correct  (=> (and (= inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= (ControlFlow 0 15693) 15478)) inline$$ReadRef$1$anon0_correct@@0)))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1) |inline$$WritebackToValue$0$vdst'@2@@0|)) (and (=> (= (ControlFlow 0 15432) 15693) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 15432) 15446) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not false) (= (ControlFlow 0 15438) 15432)) inline$$WriteRef$1$anon0_correct@@0)))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon14_Then_correct true))
(let ((inline$$TestReferences_mut_b_$def$0$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 15341) 15697) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 15341) 15438) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestReferences_mut_b_$def$0$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 15351) 15697) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 15351) 15438) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon14_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2@@0| inline$$ReadRef$0$v@1@@0)) (and (=> (= (ControlFlow 0 15299) 15351) inline$$TestReferences_mut_b_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 15299) 15341) inline$$TestReferences_mut_b_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|) 0 inline$$ReadRef$0$v@1@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))) (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 15325) 15351) inline$$TestReferences_mut_b_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 15325) 15341) inline$$TestReferences_mut_b_$def$0$anon6_Else_correct@@0))))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$TestReferences_mut_b_$def$0$$t3@1@@0)) (and (=> (= (ControlFlow 0 15200) 15325) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 15200) 15299) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$TestReferences_mut_b_$def$0$anon2$2_correct@@0  (=> (and (= inline$$TestReferences_mut_b_$def$0$$t3@1@@0 ($Integer 10)) (= (ControlFlow 0 15206) 15200)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$1$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$1$dst@1@@0 ($Mutation ($Local 1) $EmptyPath inline$$ReadRef$0$v@1@@0)) (= (ControlFlow 0 15137) 15206)) inline$$TestReferences_mut_b_$def$0$anon2$2_correct@@0)))
(let ((inline$$TestReferences_mut_b_$def$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 15053) 15137)) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$TestReferences_mut_b_$def$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 15359) 15137) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$TestReferences_mut_b_$def$0$anon0_correct@@0  (=> (not false) (and (=> (= (ControlFlow 0 15047) 15359) inline$$TestReferences_mut_b_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 15047) 15053) inline$$TestReferences_mut_b_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$TestReferences_mut_b_$direct_intra$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$ReadRef$0$v@1@@0) (>= (|i#$Integer| inline$$ReadRef$0$v@1@@0) 0)) (<= (|i#$Integer| inline$$ReadRef$0$v@1@@0) $MAX_U64)) (= (ControlFlow 0 15365) 15047)) inline$$TestReferences_mut_b_$def$0$anon0_correct@@0)))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 14877) 15365)) inline$$TestReferences_mut_b_$direct_intra$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 0) $EmptyPath inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t2@1)) (= (ControlFlow 0 14839) 14877)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 14789) 14839)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 15705) 14839) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon0_correct  (=> (and (not false) (= inline$$TestReferences_mut_ref_incorrect_$def_verify$0$$t2@1 ($Integer 20))) (and (=> (= (ControlFlow 0 14781) 15705) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 14781) 14789) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@1  (=> (= (ControlFlow 0 19562) 14781) inline$$TestReferences_mut_ref_incorrect_$def_verify$0$anon0_correct)))
anon0_correct@@1)))))))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun r@@1 () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $TestReferences_T_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20243) (let ((anon0$2_correct@@1  (=> (= (ControlFlow 0 16197) (- 0 20412)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestReferences_T_a))))))))
(let ((inline$$TestReferences_ref_param_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 16171) 16197)) anon0$2_correct@@1)))
(let ((inline$$TestReferences_ref_param_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 16181) 16197) anon0$2_correct@@1)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestReferences_T_a)) (and (=> (= (ControlFlow 0 16155) 16181) inline$$TestReferences_ref_param_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 16155) 16171) inline$$TestReferences_ref_param_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestReferences_ref_param_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 16079) 16155)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$TestReferences_ref_param_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 16189) 16155) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$TestReferences_ref_param_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16073) 16189) inline$$TestReferences_ref_param_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 16073) 16079) inline$$TestReferences_ref_param_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_T_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_T_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_T_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_T_$memory) $EmptyTypeValueArray $inv_addr))) $TestReferences_T_a)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_T_$memory) $EmptyTypeValueArray $inv_addr))) $TestReferences_T_a)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_T_$memory) $EmptyTypeValueArray $inv_addr))) $TestReferences_T_a)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_T_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 16195) 16073)) inline$$TestReferences_ref_param_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> (and (and (and (and (and ((_ is $Vector) r@@1) (let ((va@@9 (|v#$Vector| r@@1)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| r@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestReferences_T_a)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestReferences_T_a)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@1)) $TestReferences_T_a)) $MAX_U64))) true) (= (ControlFlow 0 15938) 16195)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 20243) 15938) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@0)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$TestReferences_ref_param_vec_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun r@@2 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20435) (let ((anon0$2_correct@@2  (=> (= (ControlFlow 0 16653) (- 0 20676)) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestReferences_ref_param_vec_$def_verify$0$$ret0@2 ($Integer (|l#$ValueArray| (|v#$Vector| r@@2))))))))))
(let ((inline$$TestReferences_ref_param_vec_$def_verify$0$anon8_correct  (=> (= $abort_flag@0@@1 false) (=> (and (= inline$$TestReferences_ref_param_vec_$def_verify$0$$ret0@2 inline$$Vector_length$0$l@1) (= (ControlFlow 0 16605) 16653)) anon0$2_correct@@2))))
(let ((inline$$TestReferences_ref_param_vec_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 16603) 16605)) inline$$TestReferences_ref_param_vec_$def_verify$0$anon8_correct)))
(let ((inline$$TestReferences_ref_param_vec_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 16613) 16605) inline$$TestReferences_ref_param_vec_$def_verify$0$anon8_correct)))
(let ((inline$$TestReferences_ref_param_vec_$def_verify$0$anon10_Else_correct  (=> (not false) (and (=> (= (ControlFlow 0 16597) 16613) inline$$TestReferences_ref_param_vec_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 16597) 16603) inline$$TestReferences_ref_param_vec_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestReferences_ref_param_vec_$def_verify$0$anon10_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) r@@2) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| r@@2))))) (and (=> (= (ControlFlow 0 16581) 16617) inline$$TestReferences_ref_param_vec_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 16581) 16597) inline$$TestReferences_ref_param_vec_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $TestReferences_T_type_value) (= (ControlFlow 0 16569) 16581)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$TestReferences_ref_param_vec_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 16496) 16569)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$TestReferences_ref_param_vec_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 16645) 16569) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$TestReferences_ref_param_vec_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16490) 16645) inline$$TestReferences_ref_param_vec_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 16490) 16496) inline$$TestReferences_ref_param_vec_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@3  (=> (and (and (and ((_ is $Vector) r@@2) (let ((va@@10 (|v#$Vector| r@@2)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| r@@2)))) (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $$0)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $$0))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $$0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $$0))) $TestReferences_T_a)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $$0))) $TestReferences_T_a)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $$0))) $TestReferences_T_a)) $MAX_U64))) true)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@2)) $$0))
))) (= (ControlFlow 0 16326) 16490)) inline$$TestReferences_ref_param_vec_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 20435) 16326) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@1))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$TestReferences_ref_return_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun r@@3 () T@$Value)
(declare-fun i@@10 () T@$Value)
(declare-fun inline$$TestReferences_ref_return_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$Vector_borrow$0$dst@2 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1 () Int)
(declare-fun inline$$Vector_borrow$0$dst@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 20699) (let ((anon0$2_correct@@3  (=> (= (ControlFlow 0 17367) (- 0 21078)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestReferences_ref_return_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) (|i#$Integer| i@@10)))))))))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon7_correct  (=> (and (and (= inline$$TestReferences_ref_return_$def_verify$0$$ret0@1 $Error) (= inline$$TestReferences_ref_return_$def_verify$0$$ret0@2 inline$$TestReferences_ref_return_$def_verify$0$$ret0@1)) (and (= $abort_flag@1 true) (= (ControlFlow 0 17335) 17367))) anon0$2_correct@@3)))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 17329) 17335)) inline$$TestReferences_ref_return_$def_verify$0$anon7_correct)))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 17343) 17335) inline$$TestReferences_ref_return_$def_verify$0$anon7_correct)))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 17323) 17343) inline$$TestReferences_ref_return_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 17323) 17329) inline$$TestReferences_ref_return_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon10_correct  (=> (= inline$$TestReferences_ref_return_$def_verify$0$$ret0@2 inline$$Vector_borrow$0$dst@2) (=> (and (= $abort_flag@1 $abort_flag@0@@2) (= (ControlFlow 0 17311) 17367)) anon0$2_correct@@3))))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 17309) 17311)) inline$$TestReferences_ref_return_$def_verify$0$anon10_correct)))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 17319) 17311) inline$$TestReferences_ref_return_$def_verify$0$anon10_correct)))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 17303) 17319) inline$$TestReferences_ref_return_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 17303) 17309) inline$$TestReferences_ref_return_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@2 true) (= inline$$Vector_borrow$0$dst@2 inline$$Vector_borrow$0$dst@0)) (and (=> (= (ControlFlow 0 17287) 17323) inline$$TestReferences_ref_return_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 17287) 17303) inline$$TestReferences_ref_return_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| r@@3)))) (= (ControlFlow 0 17285) 17287)) inline$$Vector_borrow$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| r@@3))))) (= inline$$Vector_borrow$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) inline$$Vector_borrow$0$i_ind@1))) (and (= $abort_flag@0@@2 false) (= inline$$Vector_borrow$0$dst@2 inline$$Vector_borrow$0$dst@1))) (and (=> (= (ControlFlow 0 17227) 17323) inline$$TestReferences_ref_return_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 17227) 17303) inline$$TestReferences_ref_return_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct  (=> ((_ is $Vector) r@@3) (=> (and ((_ is $Integer) i@@10) (= inline$$Vector_borrow$0$i_ind@1 (|i#$Integer| i@@10))) (and (=> (= (ControlFlow 0 17201) 17285) inline$$Vector_borrow$0$anon3_Then_correct) (=> (= (ControlFlow 0 17201) 17227) inline$$Vector_borrow$0$anon3_Else_correct))))))
(let ((inline$$Vector_borrow$0$Entry_correct  (=> (and (= inline$$Vector_borrow$0$ta@0 $TestReferences_T_type_value) (= (ControlFlow 0 17187) 17201)) inline$$Vector_borrow$0$anon0_correct)))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 17009) 17187)) inline$$Vector_borrow$0$Entry_correct)))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 17351) 17187) inline$$Vector_borrow$0$Entry_correct)))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17001) 17351) inline$$TestReferences_ref_return_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 17001) 17009) inline$$TestReferences_ref_return_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 17359) 17351) inline$$TestReferences_ref_return_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 17359) 17009) inline$$TestReferences_ref_return_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestReferences_ref_return_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16995) 17359) inline$$TestReferences_ref_return_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 16995) 17001) inline$$TestReferences_ref_return_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@4  (=> (and (and ((_ is $Vector) r@@3) (let ((va@@12 (|v#$Vector| r@@3)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| r@@3)))) (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $$0@@0)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $$0@@0))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $$0@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $$0@@0))) $TestReferences_T_a)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $$0@@0))) $TestReferences_T_a)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $$0@@0))) $TestReferences_T_a)) $MAX_U64))) true)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r@@3)) $$0@@0))
))) (=> (and (and (and ((_ is $Integer) i@@10) (>= (|i#$Integer| i@@10) 0)) (<= (|i#$Integer| i@@10) $MAX_U64)) (= (ControlFlow 0 16785) 16995)) inline$$TestReferences_ref_return_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 20699) 16785) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun cap () T@$Value)
(declare-fun $TestReferences_WithdrawalCapability_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 21101) (let ((anon0$2_correct@@4  (=> (= (ControlFlow 0 17742) (- 0 21270)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $TestReferences_WithdrawalCapability_account_address))))))))
(let ((inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 17716) 17742)) anon0$2_correct@@4)))
(let ((inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 17726) 17742) anon0$2_correct@@4)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $TestReferences_WithdrawalCapability_account_address)) (and (=> (= (ControlFlow 0 17700) 17726) inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 17700) 17716) inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 17624) 17700)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 17734) 17700) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 17618) 17734) inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 17618) 17624) inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_WithdrawalCapability_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_WithdrawalCapability_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_WithdrawalCapability_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_WithdrawalCapability_$memory) $EmptyTypeValueArray $inv_addr@@0))) $TestReferences_WithdrawalCapability_account_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TestReferences_WithdrawalCapability_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (= (ControlFlow 0 17740) 17618)) inline$$TestReferences_withdrawal_capability_address_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@5  (=> (and (and (and (and (and ((_ is $Vector) cap) (let ((va@@15 (|v#$Vector| cap)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| cap)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $TestReferences_WithdrawalCapability_account_address))) true) (= (ControlFlow 0 17483) 17740)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 21101) 17483) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@3)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
