(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun x@@8 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun y () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26057) (let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon14_Else_correct true))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon14_Then_correct true))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 14675) 14693) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 14675) 14681) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon10_correct  (and (=> (= (ControlFlow 0 14663) (- 0 26354)) (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 x@@8)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 x@@8))) (and (=> (= (ControlFlow 0 14663) (- 0 26362)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AddU64$0$dst@2 ($Integer (* (|i#$Integer| ($Integer 2)) (|i#$Integer| x@@8))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AddU64$0$dst@2 ($Integer (* (|i#$Integer| ($Integer 2)) (|i#$Integer| x@@8)))))) (=> (= (ControlFlow 0 14663) (- 0 26382)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AddU64$0$dst@2 ($Integer (* (|i#$Integer| ($Integer 2)) (|i#$Integer| x@@8)))))))))))))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 14607) 14663)) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon10_correct)))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 14671) 14663) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon10_correct)))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 14601) 14671) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 14601) 14607) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 14587) 14675) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 14587) 14601) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| x@@8) (|i#$Integer| x@@8)) $MAX_U64) (= (ControlFlow 0 14585) 14587)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| x@@8) (|i#$Integer| x@@8))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| x@@8) (|i#$Integer| x@@8))))) (and (= $abort_flag@0 false) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 14529) 14675) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 14529) 14601) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 14499) (- 0 26260)) true) (and (=> (= (ControlFlow 0 14499) 14585) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 14499) 14529) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 14236) 14499)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 14701) 14499) inline$$AddU64$0$Entry_correct)))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 14228) 14701) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 14228) 14236) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 14709) 14701) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 14709) 14236) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestAssertWithReferences_simple1_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 14222) 14709) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 14222) 14228) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct  (=> (and (and ((_ is $Integer) x@@8) (>= (|i#$Integer| x@@8) 0)) (<= (|i#$Integer| x@@8) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y) (>= (|i#$Integer| y) 0)) (<= (|i#$Integer| y) $MAX_U64)) (= (ControlFlow 0 13960) 14222)) inline$$TestAssertWithReferences_simple1_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 26057) 13960) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun y@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun x@@9 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26432) (let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon12_Else_correct true))
(let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon12_Then_correct true))
(let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15831) 15851) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 15831) 15841) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 15859) 15851) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 15859) 15841) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon4$10_correct  (and (=> (= (ControlFlow 0 15825) (- 0 26914)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (=> (= (ControlFlow 0 15825) 15859) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 15825) 15831) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon11_Else_correct))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 7))) (= (ControlFlow 0 15775) 15825)) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon4$10_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 7)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 y@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= (ControlFlow 0 15801) 15825)) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon4$10_correct))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$1$dst@1)) (and (=> (= (ControlFlow 0 15620) 15801) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 15620) 15775) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 15676) 15801) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 15676) 15775) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 15584) 15676) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 15584) 15620) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$ReadRef$0$v@1)) (= (ControlFlow 0 15441) 15584)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 15348) 15441)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 7) $EmptyPath y@@0)) (= (ControlFlow 0 15276) 15348)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 5) $EmptyPath x@@9)) (= (ControlFlow 0 15220) 15276)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon10_Else_correct  (=> (and (not true) (= (ControlFlow 0 15102) 15220)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon10_Then_correct  (=> (= (ControlFlow 0 15867) 15220) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon9_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 15094) 15867) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 15094) 15102) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon9_Then_correct  (and (=> (= (ControlFlow 0 15875) 15867) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 15875) 15102) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon10_Else_correct))))
(let ((inline$$TestAssertWithReferences_simple2_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 15088) 15875) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 15088) 15094) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and ((_ is $Integer) x@@9) (>= (|i#$Integer| x@@9) 0)) (<= (|i#$Integer| x@@9) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@0) (>= (|i#$Integer| y@@0) 0)) (<= (|i#$Integer| y@@0) $MAX_U64)) (= (ControlFlow 0 14861) 15088)) inline$$TestAssertWithReferences_simple2_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 26432) 14861) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun y@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple3_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun x@@10 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 26963) (let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon7_correct true))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 17878) 17886)) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon7_correct)))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 17894) 17886) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon7_correct)))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 17872) 17894) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 17872) 17878) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon18_Else_correct true))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon18_Then_correct true))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 17840) 17860) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 17840) 17850) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 17868) 17860) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 17868) 17850) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon15_Else$4_correct  (and (=> (= (ControlFlow 0 17834) (- 0 27822)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (|i#$Integer| ($Integer 1)))) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (|i#$Integer| ($Integer 1)))) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (=> (= (ControlFlow 0 17834) 17868) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 17834) 17840) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 12))) (= (ControlFlow 0 17772) 17834)) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon15_Else$4_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 12)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 y@@1 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (= (ControlFlow 0 17798) 17834)) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon15_Else$4_correct))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 17617) 17798) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 17617) 17772) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (and (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|))) (and (=> (= (ControlFlow 0 17673) 17798) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 17673) 17772) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (and (=> (= (ControlFlow 0 17581) 17673) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 17581) 17617) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (and (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$AddU64$0$dst@2@@0)) (= (ControlFlow 0 17438) 17581)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 17385) 17438)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@0 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 17339) 17872) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 17339) 17385) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestAssertWithReferences_simple3_$def_verify$0$$t7@1)) $MAX_U64) (= (ControlFlow 0 17337) 17339)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestAssertWithReferences_simple3_$def_verify$0$$t7@1))) (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$TestAssertWithReferences_simple3_$def_verify$0$$t7@1))))) (and (= $abort_flag@0@@0 false) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 17281) 17872) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 17281) 17385) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 17251) (- 0 27540)) true) (and (=> (= (ControlFlow 0 17251) 17337) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 17251) 17281) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon4$11_correct  (=> (and (= inline$$TestAssertWithReferences_simple3_$def_verify$0$$t7@1 ($Integer 1)) (= (ControlFlow 0 17345) 17251)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 17148) 17345)) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon4$11_correct)))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon4$9_correct  (and (=> (= (ControlFlow 0 17116) (- 0 27489)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)))) (=> (= (ControlFlow 0 17116) 17148) inline$$ReadRef$1$anon0_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowLoc$1$dst@1@@0) (= (ControlFlow 0 17006) 17116)) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon4$9_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 17062) 17116))) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon4$9_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0))) (and (=> (= (ControlFlow 0 16970) 17062) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 16970) 17006) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (and (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@0) inline$$ReadRef$0$v@1@@0)) (= (ControlFlow 0 16827) 16970)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 16734) 16827)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$1$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$1$dst@1@@0 ($Mutation ($Local 12) $EmptyPath y@@1)) (= (ControlFlow 0 16662) 16734)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 10) $EmptyPath x@@10)) (= (ControlFlow 0 16606) 16662)) inline$$BorrowLoc$1$anon0_correct@@0)))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 16488) 16606)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 17902) 16606) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 16480) 17902) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 16480) 16488) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 17910) 17902) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 17910) 16488) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon14_Else_correct))))
(let ((inline$$TestAssertWithReferences_simple3_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 16474) 17910) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 16474) 16480) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@1  (=> (and (and ((_ is $Integer) x@@10) (>= (|i#$Integer| x@@10) 0)) (<= (|i#$Integer| x@@10) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@1) (>= (|i#$Integer| y@@1) 0)) (<= (|i#$Integer| y@@1) $MAX_U64)) (= (ControlFlow 0 16120) 16474)) inline$$TestAssertWithReferences_simple3_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 26963) 16120) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun y@@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$AddU64$1$dst@2 () T@$Value)
(declare-fun inline$$AddU64$1$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$7$v@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple4_$def_verify$0$$t26@1 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1 () T@$Value)
(declare-fun inline$$ReadRef$6$v@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun x@@11 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 27916) (let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$Abort_correct true))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 21166) 21108)) inline$$TestAssertWithReferences_simple4_$def_verify$0$Abort_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 21176) 21108) inline$$TestAssertWithReferences_simple4_$def_verify$0$Abort_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon29_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 21160) 21176) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 21160) 21166) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 21098) 21108)) inline$$TestAssertWithReferences_simple4_$def_verify$0$Abort_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 21116) 21108) inline$$TestAssertWithReferences_simple4_$def_verify$0$Abort_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon36_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 21092) 21116) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 21092) 21098) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon39_Else_correct true))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon39_Then_correct true))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon38_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 21060) 21080) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 21060) 21070) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon38_Then_correct  (and (=> (= (ControlFlow 0 21088) 21080) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 21088) 21070) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon39_Else_correct))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon36_Else$4_correct  (and (=> (= (ControlFlow 0 21054) (- 0 29256)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (|i#$Integer| ($Integer 1)))) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (|i#$Integer| ($Integer 1)))) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)))) (and (=> (= (ControlFlow 0 21054) (- 0 29280)) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$AddU64$0$dst@2@@1) (|i#$Integer| ($Integer 1)))) ($Integer (+ (|i#$Integer| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (|i#$Integer| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (+ (|i#$Integer| inline$$AddU64$0$dst@2@@1) (|i#$Integer| ($Integer 1)))) ($Integer (+ (|i#$Integer| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (|i#$Integer| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))))))) (and (=> (= (ControlFlow 0 21054) 21088) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 21054) 21060) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon38_Else_correct))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) ($Local 31))) (= (ControlFlow 0 20956) 21054)) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon36_Else$4_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) ($Local 31)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 y@@2 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (= (ControlFlow 0 20982) 21054)) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon36_Else$4_correct))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (and (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 20801) 20982) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 20801) 20956) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (and (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|)))) (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|))) (and (=> (= (ControlFlow 0 20857) 20982) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 20857) 20956) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (and (=> (= (ControlFlow 0 20765) 20857) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 20765) 20801) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (and (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) inline$$AddU64$1$dst@2)) (= (ControlFlow 0 20622) 20765)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 20569) 20622)) inline$$WriteRef$1$anon0_correct@@0)))
(let ((inline$$AddU64$1$anon3_Then$1_correct  (=> (and (= $abort_flag@1 true) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@0)) (and (=> (= (ControlFlow 0 20523) 21092) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 20523) 20569) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$AddU64$1$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$7$v@1) (|i#$Integer| inline$$TestAssertWithReferences_simple4_$def_verify$0$$t26@1)) $MAX_U64) (= (ControlFlow 0 20521) 20523)) inline$$AddU64$1$anon3_Then$1_correct)))
(let ((inline$$AddU64$1$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$7$v@1) (|i#$Integer| inline$$TestAssertWithReferences_simple4_$def_verify$0$$t26@1))) (= inline$$AddU64$1$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$7$v@1) (|i#$Integer| inline$$TestAssertWithReferences_simple4_$def_verify$0$$t26@1))))) (and (= $abort_flag@1 $abort_flag@0@@1) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@1))) (and (=> (= (ControlFlow 0 20465) 21092) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 20465) 20569) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$AddU64$1$Entry_correct  (and (=> (= (ControlFlow 0 20435) (- 0 28972)) true) (and (=> (= (ControlFlow 0 20435) 20521) inline$$AddU64$1$anon3_Then_correct) (=> (= (ControlFlow 0 20435) 20465) inline$$AddU64$1$anon3_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon18$3_correct  (=> (and (= inline$$TestAssertWithReferences_simple4_$def_verify$0$$t26@1 ($Integer 1)) (= (ControlFlow 0 20529) 20435)) inline$$AddU64$1$Entry_correct)))
(let ((inline$$ReadRef$7$anon0_correct  (=> (and (= inline$$ReadRef$7$v@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= (ControlFlow 0 20332) 20529)) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon18$3_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon18_correct  (and (=> (= (ControlFlow 0 20266) (- 0 28886)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ReadRef$5$v@1 inline$$ReadRef$6$v@1)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ReadRef$5$v@1 inline$$ReadRef$6$v@1))) (and (=> (= (ControlFlow 0 20266) (- 0 28894)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ReadRef$3$v@1 inline$$ReadRef$4$v@1)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ReadRef$3$v@1 inline$$ReadRef$4$v@1))) (and (=> (= (ControlFlow 0 20266) (- 0 28902)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AddU64$0$dst@2@@1 ($Integer (* (|i#$Integer| ($Integer 2)) (|i#$Integer| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)))))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AddU64$0$dst@2@@1 ($Integer (* (|i#$Integer| ($Integer 2)) (|i#$Integer| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))))))) (=> (= (ControlFlow 0 20266) 20332) inline$$ReadRef$7$anon0_correct)))))))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 20188) 20266)) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon18_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 21124) 20266) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon18_correct)))
(let ((inline$$ReadRef$6$anon0_correct  (=> (= inline$$ReadRef$6$v@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 20174) 21124) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 20174) 20188) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 20108) 20174)) inline$$ReadRef$6$anon0_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 21132) 20174) inline$$ReadRef$6$anon0_correct)))
(let ((inline$$ReadRef$5$anon0_correct  (=> (= inline$$ReadRef$5$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (and (=> (= (ControlFlow 0 20094) 21132) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 20094) 20108) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 20028) 20094)) inline$$ReadRef$5$anon0_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 21140) 20094) inline$$ReadRef$5$anon0_correct)))
(let ((inline$$ReadRef$4$anon0_correct  (=> (= inline$$ReadRef$4$v@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 20014) 21140) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 20014) 20028) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 19948) 20014)) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 21148) 20014) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$ReadRef$3$anon0_correct  (=> (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (and (=> (= (ControlFlow 0 19934) 21148) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 19934) 19948) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 19868) 19934)) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 21156) 19934) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon29_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 19862) 21156) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 19862) 19868) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@1 true) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 19848) 21160) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 19848) 19862) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| inline$$ReadRef$2$v@1)) $MAX_U64) (= (ControlFlow 0 19846) 19848)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| inline$$ReadRef$2$v@1))) (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| inline$$ReadRef$2$v@1))))) (and (= $abort_flag@0@@1 false) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 19790) 21160) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 19790) 19862) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 19760) (- 0 28648)) true) (and (=> (= (ControlFlow 0 19760) 19846) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 19760) 19790) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= (ControlFlow 0 19661) 19760)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 19589) 19661)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowLoc$1$dst@1@@1) (= (ControlFlow 0 19461) 19589)) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 19517) 19589))) inline$$ReadRef$1$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1))) (and (=> (= (ControlFlow 0 19425) 19517) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 19425) 19461) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (and (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1@@1) inline$$ReadRef$0$v@1@@1)) (= (ControlFlow 0 19282) 19425)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 19189) 19282)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$1$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$1$dst@1@@1 ($Mutation ($Local 31) $EmptyPath y@@2)) (= (ControlFlow 0 19117) 19189)) inline$$ReadRef$0$anon0_correct@@1)))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 29) $EmptyPath x@@11)) (= (ControlFlow 0 19061) 19117)) inline$$BorrowLoc$1$anon0_correct@@1)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 18943) 19061)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 21184) 19061) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon27_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 18935) 21184) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 18935) 18943) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon27_Then_correct  (and (=> (= (ControlFlow 0 21192) 21184) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 21192) 18943) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon28_Else_correct))))
(let ((inline$$TestAssertWithReferences_simple4_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 18929) 21192) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 18929) 18935) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon27_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and ((_ is $Integer) x@@11) (>= (|i#$Integer| x@@11) 0)) (<= (|i#$Integer| x@@11) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@2) (>= (|i#$Integer| y@@2) 0)) (<= (|i#$Integer| y@@2) $MAX_U64)) (= (ControlFlow 0 18267) 18929)) inline$$TestAssertWithReferences_simple4_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 27916) 18267) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $ret0@0 () T@$Value)
(declare-fun n () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1 () T@$Value)
(declare-fun inline$$Not$0$dst@2 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$AddU64$0$dst@3 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@2 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$t8@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@2 () T@$Value)
(declare-fun inline$$Lt$0$dst@2 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple5_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 29437) (let ((GeneratedUnifiedExit_correct  (=> (= (ControlFlow 0 29431) (- 0 30102)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified $ret0@0 n)))))))
(let ((anon0$2_correct  (=> (= $ret0@0 inline$$TestAssertWithReferences_simple5_$def_verify$0$$ret0@2) (=> (and (= $abort_flag@3 $abort_flag@2) (= (ControlFlow 0 22766) 29431)) GeneratedUnifiedExit_correct))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon14_correct  (=> (= $abort_flag@2 $abort_flag@0@@2) (=> (and (= inline$$TestAssertWithReferences_simple5_$def_verify$0$$ret0@2 inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1) (= (ControlFlow 0 22734) 22766)) anon0$2_correct))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 22732) 22734)) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon14_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 22742) 22734) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon14_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon17_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@2) (and (=> (= (ControlFlow 0 22722) (- 0 29874)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1 n)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1 n))) (and (=> (= (ControlFlow 0 22722) 22742) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 22722) 22732) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon21_Else_correct)))))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon9_correct  (=> (and (and (= inline$$TestAssertWithReferences_simple5_$def_verify$0$$ret0@1 $Error) (= $abort_flag@2 true)) (and (= inline$$TestAssertWithReferences_simple5_$def_verify$0$$ret0@2 inline$$TestAssertWithReferences_simple5_$def_verify$0$$ret0@1) (= (ControlFlow 0 22666) 22766))) anon0$2_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 22660) 22666)) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon9_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 22674) 22666) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon9_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon18_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 22654) 22674) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 22654) 22660) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon12_correct  (=> (= (ControlFlow 0 22642) (- 0 30004)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$AddU64$0$dst@3) (|i#$Integer| n)))))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 22640) 22642)) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon12_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 22650) 22642) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon12_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 22634) 22650) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 22634) 22640) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@1@@0 true) (= inline$$AddU64$0$dst@3 inline$$AddU64$0$dst@1@@2)) (and (=> (= (ControlFlow 0 22620) 22654) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 22620) 22634) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1) (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t8@2)) $MAX_U64) (= (ControlFlow 0 22618) 22620)) inline$$AddU64$0$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$0$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1) (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t8@2))) (= inline$$AddU64$0$dst@2@@2 ($Integer (+ (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1) (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t8@2))))) (and (= $abort_flag@1@@0 $abort_flag@0@@2) (= inline$$AddU64$0$dst@3 inline$$AddU64$0$dst@2@@2))) (and (=> (= (ControlFlow 0 22562) 22654) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 22562) 22634) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 22532) (- 0 29910)) true) (and (=> (= (ControlFlow 0 22532) 22618) inline$$AddU64$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 22532) 22562) inline$$AddU64$0$anon3_Else_correct@@2)))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon17_Else$1_correct  (=> (and (= inline$$TestAssertWithReferences_simple5_$def_verify$0$$t8@2 ($Integer 1)) (= (ControlFlow 0 22626) 22532)) inline$$AddU64$0$Entry_correct@@2)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon17_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@2)) (= (ControlFlow 0 22435) 22626)) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon17_Else$1_correct)))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@2 ($Boolean  (not (|b#$Boolean| inline$$Lt$0$dst@2)))) (and (=> (= (ControlFlow 0 22387) 22722) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 22387) 22435) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 22377) (- 0 29851)) true) (=> (= (ControlFlow 0 22377) 22387) inline$$Not$0$anon0_correct))))
(let ((inline$$Lt$0$anon0_correct  (=> (and (= inline$$Lt$0$dst@2 ($Boolean (< (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1) (|i#$Integer| n)))) (= (ControlFlow 0 22337) 22377)) inline$$Not$0$Entry_correct)))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 22323) (- 0 29826)) true) (=> (= (ControlFlow 0 22323) 22337) inline$$Lt$0$anon0_correct))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$L2_correct  (=> (not $abort_flag@0@@2) (=> (and (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple5_$def_verify$0$$t3@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t3@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t3@1) $MAX_U64))) (=> (and (and (and (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple5_$def_verify$0$$t4@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t4@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t4@1) $MAX_U64)) (and ((_ is $Boolean) inline$$TestAssertWithReferences_simple5_$def_verify$0$$t5@1) ((_ is $Boolean) inline$$TestAssertWithReferences_simple5_$def_verify$0$$t6@1))) (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple5_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t7@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple5_$def_verify$0$$t8@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t8@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t8@1) $MAX_U64)) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$x@1) (|i#$Integer| n)))) (= (ControlFlow 0 22245) 22323)))) inline$$Lt$0$Entry_correct)))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon4_correct  (and (=> (= (ControlFlow 0 22165) (- 0 29672)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t2@1) (|i#$Integer| n))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$TestAssertWithReferences_simple5_$def_verify$0$$t2@1) (|i#$Integer| n)))) (=> (= (ControlFlow 0 22165) 22245) inline$$TestAssertWithReferences_simple5_$def_verify$0$L2_correct)))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 22163) 22165)) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon4_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 22750) 22165) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon4_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon2$1_correct  (=> (= inline$$TestAssertWithReferences_simple5_$def_verify$0$$t2@1 ($Integer 0)) (and (=> (= (ControlFlow 0 22155) 22750) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 22155) 22163) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 22083) 22155)) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 22758) 22155) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAssertWithReferences_simple5_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 22077) 22758) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 22077) 22083) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon15_Else_correct)))))
(let ((anon0_correct@@3  (=> (and (and (and ((_ is $Integer) n) (>= (|i#$Integer| n) 0)) (<= (|i#$Integer| n) $MAX_U64)) (= (ControlFlow 0 21729) 22077)) inline$$TestAssertWithReferences_simple5_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 29437) 21729) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$AddU64$0$dst@3@@0 () T@$Value)
(declare-fun n@@0 () T@$Value)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $ret0@0@@0 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@3 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$$t7@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@3 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun inline$$Lt$0$dst@2@@0 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple6_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 30162) (let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon12_correct  (=> (= (ControlFlow 0 23880) (- 0 30708)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$AddU64$0$dst@3@@0) (|i#$Integer| n@@0)))))))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 23878) 23880)) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon12_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 23888) 23880) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon12_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 23872) 23888) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 23872) 23878) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon20_Else_correct)))))
(let ((GeneratedUnifiedExit_correct@@0  (=> (= (ControlFlow 0 30156) (- 0 30784)) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified $ret0@0@@0 n@@0)))))))
(let ((anon0$2_correct@@0  (=> (= $ret0@0@@0 inline$$TestAssertWithReferences_simple6_$def_verify$0$$ret0@2) (=> (and (= $abort_flag@3@@0 $abort_flag@2@@0) (= (ControlFlow 0 23936) 30156)) GeneratedUnifiedExit_correct@@0))))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon9_correct  (=> (and (and (= inline$$TestAssertWithReferences_simple6_$def_verify$0$$ret0@1 $Error) (= inline$$TestAssertWithReferences_simple6_$def_verify$0$$ret0@2 inline$$TestAssertWithReferences_simple6_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@0 true) (= (ControlFlow 0 23904) 23936))) anon0$2_correct@@0)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 23898) 23904)) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon9_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 23912) 23904) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon9_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon18_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 23892) 23912) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 23892) 23898) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@3  (=> (and (= $abort_flag@1@@1 true) (= inline$$AddU64$0$dst@3@@0 inline$$AddU64$0$dst@1@@3)) (and (=> (= (ControlFlow 0 23858) 23892) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 23858) 23872) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@3  (=> (and (> (+ (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1) (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t7@2)) $MAX_U64) (= (ControlFlow 0 23856) 23858)) inline$$AddU64$0$anon3_Then$1_correct@@3)))
(let ((inline$$AddU64$0$anon3_Else_correct@@3  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1) (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t7@2))) (= inline$$AddU64$0$dst@2@@3 ($Integer (+ (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1) (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t7@2))))) (and (= $abort_flag@1@@1 $abort_flag@0@@3) (= inline$$AddU64$0$dst@3@@0 inline$$AddU64$0$dst@2@@3))) (and (=> (= (ControlFlow 0 23800) 23892) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 23800) 23872) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 23770) (- 0 30614)) true) (and (=> (= (ControlFlow 0 23770) 23856) inline$$AddU64$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 23770) 23800) inline$$AddU64$0$anon3_Else_correct@@3)))))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon17_Then$1_correct  (=> (and (= inline$$TestAssertWithReferences_simple6_$def_verify$0$$t7@2 ($Integer 1)) (= (ControlFlow 0 23864) 23770)) inline$$AddU64$0$Entry_correct@@3)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon17_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@2@@0) (= (ControlFlow 0 23673) 23864)) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon17_Then$1_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon14_correct  (=> (= inline$$TestAssertWithReferences_simple6_$def_verify$0$$ret0@2 inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1) (=> (and (= $abort_flag@2@@0 $abort_flag@0@@3) (= (ControlFlow 0 23627) 23936)) anon0$2_correct@@0))))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 23625) 23627)) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon14_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 23635) 23627) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon14_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| inline$$Lt$0$dst@2@@0)) (and (=> (= (ControlFlow 0 23615) (- 0 30561)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1 n@@0)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1 n@@0))) (and (=> (= (ControlFlow 0 23615) 23635) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 23615) 23625) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon21_Else_correct)))))))
(let ((inline$$Lt$0$anon0_correct@@0  (=> (= inline$$Lt$0$dst@2@@0 ($Boolean (< (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1) (|i#$Integer| n@@0)))) (and (=> (= (ControlFlow 0 23557) 23673) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 23557) 23615) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 23543) (- 0 30530)) true) (=> (= (ControlFlow 0 23543) 23557) inline$$Lt$0$anon0_correct@@0))))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$L3_correct  (=> (not $abort_flag@0@@3) (=> (and (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple6_$def_verify$0$$t3@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t3@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t3@1) $MAX_U64))) (=> (and (and (and (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple6_$def_verify$0$$t4@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t4@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t4@1) $MAX_U64)) ((_ is $Boolean) inline$$TestAssertWithReferences_simple6_$def_verify$0$$t5@1)) (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple6_$def_verify$0$$t6@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t6@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t6@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple6_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t7@1) $MAX_U64)) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$x@1) (|i#$Integer| n@@0)))) (= (ControlFlow 0 23465) 23543)))) inline$$Lt$0$Entry_correct@@0)))))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon4_correct  (and (=> (= (ControlFlow 0 23389) (- 0 30388)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t2@1) (|i#$Integer| n@@0))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$TestAssertWithReferences_simple6_$def_verify$0$$t2@1) (|i#$Integer| n@@0)))) (=> (= (ControlFlow 0 23389) 23465) inline$$TestAssertWithReferences_simple6_$def_verify$0$L3_correct)))))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 23387) 23389)) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon4_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 23920) 23389) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon4_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon2$1_correct  (=> (= inline$$TestAssertWithReferences_simple6_$def_verify$0$$t2@1 ($Integer 0)) (and (=> (= (ControlFlow 0 23379) 23920) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 23379) 23387) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 23307) 23379)) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 23928) 23379) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAssertWithReferences_simple6_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 23301) 23928) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 23301) 23307) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon15_Else_correct)))))
(let ((anon0_correct@@4  (=> (and (and (and ((_ is $Integer) n@@0) (>= (|i#$Integer| n@@0) 0)) (<= (|i#$Integer| n@@0) $MAX_U64)) (= (ControlFlow 0 22962) 23301)) inline$$TestAssertWithReferences_simple6_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 30162) 22962) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$AddU64$0$dst@3@@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@4 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple7_$def_verify$0$x@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple7_$def_verify$0$$t7@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@4 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun inline$$Lt$0$dst@2@@1 () T@$Value)
(declare-fun n@@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple7_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple7_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple7_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple7_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple7_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$TestAssertWithReferences_simple7_$def_verify$0$$t2@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 30844) (let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon9_correct true))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 25034) 25040)) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon9_correct)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 25048) 25040) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon9_correct)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon18_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 25028) 25048) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 25028) 25034) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon12_correct  (=> (= (ControlFlow 0 25016) (- 0 31365)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AddU64$0$dst@3@@1 ($Integer 0)))))))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 25014) 25016)) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon12_correct)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 25024) 25016) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon12_correct)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@1@@2) (and (=> (= (ControlFlow 0 25008) 25024) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 25008) 25014) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@4  (=> (and (= $abort_flag@1@@2 true) (= inline$$AddU64$0$dst@3@@1 inline$$AddU64$0$dst@1@@4)) (and (=> (= (ControlFlow 0 24994) 25028) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 24994) 25008) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@4  (=> (and (> (+ (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$x@1) (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t7@2)) $MAX_U64) (= (ControlFlow 0 24992) 24994)) inline$$AddU64$0$anon3_Then$1_correct@@4)))
(let ((inline$$AddU64$0$anon3_Else_correct@@4  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$x@1) (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t7@2))) (= inline$$AddU64$0$dst@2@@4 ($Integer (+ (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$x@1) (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t7@2))))) (and (= $abort_flag@1@@2 $abort_flag@0@@4) (= inline$$AddU64$0$dst@3@@1 inline$$AddU64$0$dst@2@@4))) (and (=> (= (ControlFlow 0 24936) 25028) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 24936) 25008) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 24906) (- 0 31271)) true) (and (=> (= (ControlFlow 0 24906) 24992) inline$$AddU64$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 24906) 24936) inline$$AddU64$0$anon3_Else_correct@@4)))))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon17_Then$1_correct  (=> (and (= inline$$TestAssertWithReferences_simple7_$def_verify$0$$t7@2 ($Integer 1)) (= (ControlFlow 0 25000) 24906)) inline$$AddU64$0$Entry_correct@@4)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon17_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@2@@1) (= (ControlFlow 0 24809) 25000)) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon17_Then$1_correct)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon21_Else_correct true))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon21_Then_correct true))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon17_Else_correct  (=> (not (|b#$Boolean| inline$$Lt$0$dst@2@@1)) (and (=> (= (ControlFlow 0 24751) 24771) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 24751) 24761) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct@@1  (=> (= inline$$Lt$0$dst@2@@1 ($Boolean (< (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$x@1) (|i#$Integer| n@@1)))) (and (=> (= (ControlFlow 0 24703) 24809) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 24703) 24751) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 24689) (- 0 31195)) true) (=> (= (ControlFlow 0 24689) 24703) inline$$Lt$0$anon0_correct@@1))))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$L3_correct  (=> (not $abort_flag@0@@4) (=> (and (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple7_$def_verify$0$x@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$x@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$x@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple7_$def_verify$0$$t3@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t3@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t3@1) $MAX_U64))) (=> (and (and (and (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple7_$def_verify$0$$t4@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t4@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t4@1) $MAX_U64)) ((_ is $Boolean) inline$$TestAssertWithReferences_simple7_$def_verify$0$$t5@1)) (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple7_$def_verify$0$$t6@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t6@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t6@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$TestAssertWithReferences_simple7_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$TestAssertWithReferences_simple7_$def_verify$0$$t7@1) $MAX_U64)) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAssertWithReferences_simple7_$def_verify$0$x@1 ($Integer 0)))) (= (ControlFlow 0 24611) 24689)))) inline$$Lt$0$Entry_correct@@1)))))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon4_correct  (and (=> (= (ControlFlow 0 24537) (- 0 31055)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAssertWithReferences_simple7_$def_verify$0$$t2@1 ($Integer 0))))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestAssertWithReferences_simple7_$def_verify$0$$t2@1 ($Integer 0)))) (=> (= (ControlFlow 0 24537) 24611) inline$$TestAssertWithReferences_simple7_$def_verify$0$L3_correct)))))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 24535) 24537)) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon4_correct)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 25056) 24537) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon4_correct)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon2$1_correct  (=> (= inline$$TestAssertWithReferences_simple7_$def_verify$0$$t2@1 ($Integer 0)) (and (=> (= (ControlFlow 0 24527) 25056) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 24527) 24535) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 24455) 24527)) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 25064) 24527) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestAssertWithReferences_simple7_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 24449) 25064) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 24449) 24455) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon15_Else_correct)))))
(let ((anon0_correct@@5  (=> (and (and (and ((_ is $Integer) n@@1) (>= (|i#$Integer| n@@1) 0)) (<= (|i#$Integer| n@@1) $MAX_U64)) (= (ControlFlow 0 24120) 24449)) inline$$TestAssertWithReferences_simple7_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 30844) 24120) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5))))))))))))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
