(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $FixedPoint32_FixedPoint32 $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@0) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@0))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@2) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@2))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@3) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@3))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@4) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@4))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@5) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@5))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@6) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@6))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_update_minting_ability_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun allow_minting () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun $tv0@@7 () T@$TypeValue)
(declare-fun $abort_code@2 () Int)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun tc_account () T@$Value)
(declare-fun $abort_code@1 () Int)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 101466) (let ((inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon9_Else_correct true))
(let ((inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon9_Then_correct true))
(let ((inline$$Diem_update_minting_ability_$def$0$Abort_correct  (=> (= $abort_flag@3 true) (and (=> (= (ControlFlow 0 100180) 100272) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 100180) 100266) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 100222) 100180)) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 100232) 100180) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon23_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 100216) 100232) inline$$Diem_update_minting_ability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 100216) 100222) inline$$Diem_update_minting_ability_$def$0$anon24_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 100202) 100180)) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 100212) 100180) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon25_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 100196) 100212) inline$$Diem_update_minting_ability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 100196) 100202) inline$$Diem_update_minting_ability_$def$0$anon26_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 100174) 100180)) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 100188) 100180) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon28_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 100168) 100188) inline$$Diem_update_minting_ability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 100168) 100174) inline$$Diem_update_minting_ability_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon27_Then_correct  (=> (and $abort_flag@1 (= (ControlFlow 0 100192) 100180)) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon20$3_correct  (=> (= $abort_flag@3 $abort_flag@2) (and (=> (= (ControlFlow 0 100154) 100272) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 100154) 100266) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (= (ControlFlow 0 100092) 100154)) inline$$Diem_update_minting_ability_$def$0$anon20$3_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1))) (= (ControlFlow 0 100146) 100154))) inline$$Diem_update_minting_ability_$def$0$anon20$3_correct))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 100082) 100146) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 100082) 100092) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 99962) (- 0 103230)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 99962) 100082) inline$$WritebackToGlobal$0$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 99914) 99962)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 99783) 99914)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 99839) 99914))) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 99747) 99839) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 99747) 99783) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 99610) 99747)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon30_Then_correct  (=> (and (= inline$$Diem_update_minting_ability_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 100164) 99747)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) allow_minting)) (and (=> (= (ControlFlow 0 99596) 100164) inline$$Diem_update_minting_ability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 99596) 99610) inline$$Diem_update_minting_ability_$def$0$anon30_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $Diem_CurrencyInfo_can_mint) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $Diem_CurrencyInfo_can_mint))) (= (ControlFlow 0 99537) 99596))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 99415) 99537)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 99409) 99415)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon28_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 99419) 99409)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@2 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 99369) 100168) inline$$Diem_update_minting_ability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 99369) 99419) inline$$Diem_update_minting_ability_$def$0$anon28_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 99367) 99369)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)))) (and (= $abort_flag@2 $abort_flag@1) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 99315) 100168) inline$$Diem_update_minting_ability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 99315) 99419) inline$$Diem_update_minting_ability_$def$0$anon28_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 99285) 99367) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 99285) 99315) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (=> (= inline$$BorrowGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1)) (and (=> (= (ControlFlow 0 99279) (- 0 102885)) true) (=> (= (ControlFlow 0 99279) 99285) inline$$BorrowGlobal$0$anon0_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon27_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 99375) 99279)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 99136) 100192) inline$$Diem_update_minting_ability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 99136) 99375) inline$$Diem_update_minting_ability_$def$0$anon27_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 99146) 100192) inline$$Diem_update_minting_ability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 99146) 99375) inline$$Diem_update_minting_ability_$def$0$anon27_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@1) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 99130) 99146) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 99130) 99136) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon25_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 99160) 99130)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon23_Else_correct  (=> (and (and (not $abort_flag@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 99025) 100196) inline$$Diem_update_minting_ability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 99025) 99160) inline$$Diem_update_minting_ability_$def$0$anon25_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@0) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@0)) (and (=> $abort_flag@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@1 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 99019) 100216) inline$$Diem_update_minting_ability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 99019) 99025) inline$$Diem_update_minting_ability_$def$0$anon23_Else_correct))))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 98949) 99019)) inline$$Diem_update_minting_ability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 100240) 99019) inline$$Diem_update_minting_ability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 98941) 100240) inline$$Diem_update_minting_ability_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 98941) 98949) inline$$Diem_update_minting_ability_$def$0$anon22_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 100248) 100240) inline$$Diem_update_minting_ability_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 100248) 98949) inline$$Diem_update_minting_ability_$def$0$anon22_Else_correct))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 98935) 100248) inline$$Diem_update_minting_ability_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 98935) 98941) inline$$Diem_update_minting_ability_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$direct_inter$0$anon0_correct  (=> ((_ is $Address) tc_account) (=> (and ((_ is $Boolean) allow_minting) (= (ControlFlow 0 100252) 98935)) inline$$Diem_update_minting_ability_$def$0$anon0_correct))))
(let ((inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 98431) 100252)) inline$$Diem_update_minting_ability_$direct_inter$0$anon0_correct)))
(let ((inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 100280) 100252) inline$$Diem_update_minting_ability_$direct_inter$0$anon0_correct)))
(let ((inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon7_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 98423) 100280) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 98423) 98431) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon7_Then_correct  (and (=> (= (ControlFlow 0 100288) 100280) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 100288) 98431) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon8_Else_correct))))
(let ((inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 98417) 100288) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 98417) 98423) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (forall (($inv_addr@@0 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@10 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))) $$0))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events)) (let ((va@@12 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))
)) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 100292) 98417))) inline$$update_minting_ability_update_minting_ability_$def_verify$0$anon0_correct)))))
(let ((anon0_correct  (=> ((_ is $Address) tc_account) (=> (and ((_ is $Boolean) allow_minting) (= (ControlFlow 0 97943) 100292)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 101466) 97943) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
