(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $AccountFreezing_FreezeAccountEvent () T@$TypeName)
(declare-fun $AccountFreezing_FreezeEventsHolder () T@$TypeName)
(declare-fun $AccountFreezing_FreezingBit () T@$TypeName)
(declare-fun $AccountFreezing_UnfreezeAccountEvent () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_frozen_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeEventsHolder_freeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezingBit_is_frozen () Int)
(declare-fun $AccountFreezing_FreezingBit_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_unfrozen_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $AccountFreezing_FreezeAccountEvent $AccountFreezing_FreezeEventsHolder $AccountFreezing_FreezingBit $AccountFreezing_UnfreezeAccountEvent)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_FreezeAccountEvent_frozen_address 1))
(assert (= $AccountFreezing_FreezeAccountEvent_type_value ($StructType $AccountFreezing_FreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeEventsHolder_freeze_event_handle 0))
(assert (= $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle 1))
(assert (= $AccountFreezing_FreezeEventsHolder_type_value ($StructType $AccountFreezing_FreezeEventsHolder $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezingBit_is_frozen 0))
(assert (= $AccountFreezing_FreezingBit_type_value ($StructType $AccountFreezing_FreezingBit $EmptyTypeValueArray)))
(assert (= $AccountFreezing_UnfreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_UnfreezeAccountEvent_unfrozen_address 1))
(assert (= $AccountFreezing_UnfreezeAccountEvent_type_value ($StructType $AccountFreezing_UnfreezeAccountEvent $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$AccountFreezing_account_is_frozen_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $AccountFreezing_FreezingBit_$memory () T@$Memory)
(declare-fun addr () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun inline$$AccountFreezing_account_is_frozen_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun |inline$$AccountFreezing_account_is_frozen_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$AccountFreezing_account_is_frozen_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$AccountFreezing_account_is_frozen_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 64237) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 50456) (- 0 64823)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2) (and (=> (= (ControlFlow 0 50456) (- 0 64832)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 50456) (- 0 64841)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountFreezing_account_is_frozen_$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $AccountFreezing_FreezingBit_is_frozen))))))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountFreezing_account_is_frozen_$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $AccountFreezing_FreezingBit_is_frozen)))))))) (=> (= (ControlFlow 0 50456) (- 0 64859)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $AccountFreezing_FreezingBit_is_frozen) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))))))))))))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon7_correct  (=> (and (and (= inline$$AccountFreezing_account_is_frozen_$def_verify$0$$ret0@1 $Error) (= inline$$AccountFreezing_account_is_frozen_$def_verify$0$$ret0@2 inline$$AccountFreezing_account_is_frozen_$def_verify$0$$ret0@1)) (and (= $abort_flag@2 true) (= (ControlFlow 0 50432) 50456))) anon0$2_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 50426) 50432)) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon7_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 50440) 50432) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon7_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon17_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 50420) 50440) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 50420) 50426) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon14_correct  (=> (= inline$$AccountFreezing_account_is_frozen_$def_verify$0$$ret0@2 |inline$$AccountFreezing_account_is_frozen_$def_verify$0$tmp#$1@1|) (=> (and (= $abort_flag@2 $abort_flag@1) (= (ControlFlow 0 50115) 50456)) anon0$2_correct))))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 50113) 50115)) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon14_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 50123) 50115) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon14_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon10_correct  (=> (and (= |inline$$AccountFreezing_account_is_frozen_$def_verify$0$tmp#$1@1| inline$$GetFieldFromValue$0$dst@1) (= $abort_flag@1 $abort_flag@0)) (and (=> (= (ControlFlow 0 50408) 50123) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 50408) 50113) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 50406) 50408)) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon10_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 50416) 50408) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon10_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountFreezing_FreezingBit_is_frozen)) (and (=> (= (ControlFlow 0 50358) 50416) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 50358) 50406) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon17_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 50364) 50358)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 50304) 50420) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 50304) 50364) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 50302) 50304)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (and (= $abort_flag@0 false) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 50250) 50420) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 50250) 50364) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 50232) 50302) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 50232) 50250) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 50226) (- 0 64631)) true) (=> (= (ControlFlow 0 50226) 50232) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon16_Then_correct  (=> (and (|b#$Boolean| inline$$AccountFreezing_account_is_frozen_$def_verify$0$$t3@1) (= (ControlFlow 0 50310) 50226)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon12_correct  (=> (and (= |inline$$AccountFreezing_account_is_frozen_$def_verify$0$tmp#$1@1| inline$$AccountFreezing_account_is_frozen_$def_verify$0$$t6@1) (= $abort_flag@1 false)) (and (=> (= (ControlFlow 0 50103) 50123) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 50103) 50113) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 50101) 50103)) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon12_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 50131) 50103) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon12_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon16_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountFreezing_account_is_frozen_$def_verify$0$$t3@1)) (= inline$$AccountFreezing_account_is_frozen_$def_verify$0$$t6@1 ($Boolean false))) (and (=> (= (ControlFlow 0 50093) 50131) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 50093) 50101) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon2$1_correct  (=> (= inline$$AccountFreezing_account_is_frozen_$def_verify$0$$t3@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (and (=> (= (ControlFlow 0 50049) 50310) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 50049) 50093) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 50005) 50049)) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 50448) 50049) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 49999) 50448) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 49999) 50005) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct  (=> (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (= (ControlFlow 0 50454) 49999))) inline$$AccountFreezing_account_is_frozen_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 49653) 50454)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 64237) 49653) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$AccountFreezing_assert_not_frozen_$def_verify$0$$t6@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 64935) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 51125) (- 0 65724)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@2@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@2@@0) (and (=> (= (ControlFlow 0 51125) (- 0 65735)) (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $AccountFreezing_FreezingBit_is_frozen))))))) (=> (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $AccountFreezing_FreezingBit_is_frozen)))))) (and (=> (= (ControlFlow 0 51125) (- 0 65746)) (=> $abort_flag@2@@0 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@5 (|i#$Integer| ($Integer 1)))))) (=> (=> $abort_flag@2@@0 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 51125) (- 0 65768)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $AccountFreezing_FreezingBit_is_frozen) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))))))))))))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$Abort_correct  (=> (= $abort_flag@2@@0 true) (=> (and (= $abort_code@5 $abort_code@4) (= (ControlFlow 0 51057) 51125)) anon0$2_correct@@0))))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 51103) 51057)) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$Abort_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 51101) 51103)) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon5_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 51111) 51103) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon5_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon16_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 51095) 51111) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 51095) 51101) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon9_correct  (=> (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 51083) 51057)) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$Abort_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 51081) 51083)) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon9_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 51091) 51083) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon9_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon18_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 51075) 51091) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 51075) 51081) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon14_correct  (=> (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 51053) 51057)) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$Abort_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 51051) 51053)) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon14_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 51065) 51053) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon14_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@3 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 51045) 51065) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 51045) 51051) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon20_Then_correct  (=> (and (and (|b#$Boolean| inline$$Not$0$dst@1) (= $abort_flag@2@@0 $abort_flag@1@@0)) (and (= $abort_code@5 $abort_code@2) (= (ControlFlow 0 51071) 51125))) anon0$2_correct@@0)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 51033) 51071) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 51033) 51045) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon16_Else$1_correct  (=> (and (and (and (= inline$$AccountFreezing_assert_not_frozen_$def_verify$0$$t6@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0)) (and (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 51027) 51075) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 51027) 51033) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| call3formal@$ret0@0@@0)))) (= (ControlFlow 0 51015) 51027)) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon16_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 51005) (- 0 65553)) true) (=> (= (ControlFlow 0 51005) 51015) inline$$Not$0$anon0_correct))))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 51021) 51005)) inline$$Not$0$Entry_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0) (=> (and (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $AccountFreezing_FreezingBit_is_frozen))))))))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) account) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $AccountFreezing_FreezingBit_is_frozen) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 50967) 51095) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 50967) 51021) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 50931) 50967)) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 51119) 50967) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 50925) 51119) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 50925) 50931) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@0))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (= (ControlFlow 0 51123) 50925))) inline$$AccountFreezing_assert_not_frozen_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) account) (= (ControlFlow 0 50613) 51123)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 64935) 50613) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun $AccountFreezing_FreezingBit_$memory@1 () T@$Memory)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $AccountFreezing_FreezingBit_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$AccountFreezing_FreezingBit_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$AccountFreezing_create_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$AccountFreezing_create_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$AccountFreezing_create_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$AccountFreezing_create_$def_verify$0$$t5@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun $AccountFreezing_FreezingBit_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 65837) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 52579) (- 0 67018)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@3) (and (=> (= (ControlFlow 0 52579) (- 0 67032)) (=> $abort_flag@3 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))) (=> (=> $abort_flag@3 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))) (and (=> (= (ControlFlow 0 52579) (- 0 67046)) (=> $abort_flag@3 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (= $abort_code@6 (|i#$Integer| ($Integer 6)))))) (=> (=> $abort_flag@3 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (=> (= (ControlFlow 0 52579) (- 0 67071)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0)))) $AccountFreezing_FreezingBit_is_frozen)))))))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0)))) $AccountFreezing_FreezingBit_is_frozen))))))))) (=> (= (ControlFlow 0 52579) (- 0 67085)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (forall ((addr@@3 T@$Value) )  (=> ((_ is $Address) addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@1) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $AccountFreezing_FreezingBit_is_frozen) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))))))))))))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon26_Else_correct  (=> (not $abort_flag@2@@1) (and (=> (= (ControlFlow 0 52505) (- 0 66847)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (and (=> (= (ControlFlow 0 52505) (- 0 66866)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (and (=> (= (ControlFlow 0 52505) (- 0 66885)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountFreezing_create_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$AccountFreezing_create_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_create_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_create_$def_verify$0$addr)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountFreezing_create_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountFreezing_create_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_create_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_create_$def_verify$0$addr@@0))))))))))) (=> (and (and (= $abort_code@6 $abort_code@4@@0) (= $abort_flag@3 $abort_flag@2@@1)) (and (= $AccountFreezing_FreezingBit_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 52505) 52579))) anon0$2_correct@@1))))))))))
(let ((inline$$AccountFreezing_create_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@6 $abort_code@5@@0) (= $abort_flag@3 true)) (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory@0) (= (ControlFlow 0 51906) 52579))) anon0$2_correct@@1)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon5_correct  (=> (= $abort_code@5@@0 $abort_code@1@@0) (=> (and (= $AccountFreezing_FreezingBit_$memory@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 52557) 51906)) inline$$AccountFreezing_create_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 52555) 52557)) inline$$AccountFreezing_create_$def_verify$0$anon5_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 52565) 52557) inline$$AccountFreezing_create_$def_verify$0$anon5_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 52549) 52565) inline$$AccountFreezing_create_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 52549) 52555) inline$$AccountFreezing_create_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon9_correct  (=> (= $abort_code@5@@0 $abort_code@2@@0) (=> (and (= $AccountFreezing_FreezingBit_$memory@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 52537) 51906)) inline$$AccountFreezing_create_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 52535) 52537)) inline$$AccountFreezing_create_$def_verify$0$anon9_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 52545) 52537) inline$$AccountFreezing_create_$def_verify$0$anon9_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 52529) 52545) inline$$AccountFreezing_create_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 52529) 52535) inline$$AccountFreezing_create_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon17_correct  (=> (= $abort_code@5@@0 $abort_code@4@@0) (=> (and (= $AccountFreezing_FreezingBit_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 52517) 51906)) inline$$AccountFreezing_create_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 52515) 52517)) inline$$AccountFreezing_create_$def_verify$0$anon17_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 52525) 52517) inline$$AccountFreezing_create_$def_verify$0$anon17_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon26_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 52509) 52525) inline$$AccountFreezing_create_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 52509) 52515) inline$$AccountFreezing_create_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@1 true) (=> (and (= $abort_code@4@@0 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 52404) 52509) inline$$AccountFreezing_create_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 52404) 52505) inline$$AccountFreezing_create_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 52402) 52404)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$AccountFreezing_FreezingBit_pack$0$$struct@1))) (= $abort_flag@2@@1 $abort_flag@1@@1)) (and (= $abort_code@4@@0 $abort_code@2@@0) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 52352) 52509) inline$$AccountFreezing_create_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 52352) 52505) inline$$AccountFreezing_create_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account@@0)) (and (=> (= (ControlFlow 0 52410) 52402) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 52410) 52352) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 52198) (- 0 66732)) true) (=> (= (ControlFlow 0 52198) 52410) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon24_Then$1_correct  (and (=> (= (ControlFlow 0 52418) (- 0 66697)) (|Select_[$TypeValueArray,$int]$bool| inline$$AccountFreezing_create_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| account@@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$AccountFreezing_create_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| account@@0)) (=> (= (ControlFlow 0 52418) 52198) inline$$Signer_borrow_address$0$Entry_correct)))))
(let ((inline$$AccountFreezing_FreezingBit_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 52070) 52418)) inline$$AccountFreezing_create_$def_verify$0$anon24_Then$1_correct)))
(let ((inline$$AccountFreezing_FreezingBit_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 52076) 52418) inline$$AccountFreezing_create_$def_verify$0$anon24_Then$1_correct)))
(let ((inline$$AccountFreezing_FreezingBit_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 52064) 52076) inline$$AccountFreezing_FreezingBit_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 52064) 52070) inline$$AccountFreezing_FreezingBit_pack$0$anon4_Else_correct)))))
(let ((inline$$AccountFreezing_FreezingBit_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 52056) 52418)) inline$$AccountFreezing_create_$def_verify$0$anon24_Then$1_correct)))
(let ((inline$$AccountFreezing_FreezingBit_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$AccountFreezing_create_$def_verify$0$$t9@1) (= inline$$AccountFreezing_FreezingBit_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$AccountFreezing_create_$def_verify$0$$t9@1) 1)))) (and (=> (= (ControlFlow 0 52048) 52064) inline$$AccountFreezing_FreezingBit_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 52048) 52056) inline$$AccountFreezing_FreezingBit_pack$0$anon3_Else_correct)))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon24_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1@@0) (=> (and (= inline$$AccountFreezing_create_$def_verify$0$$t9@1 ($Boolean false)) (= (ControlFlow 0 52082) 52048)) inline$$AccountFreezing_FreezingBit_pack$0$anon0_correct))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon14_correct  (=> (= $abort_code@5@@0 $abort_code@3@@0) (=> (and (= $AccountFreezing_FreezingBit_$memory@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 51902) 51906)) inline$$AccountFreezing_create_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 51900) 51902)) inline$$AccountFreezing_create_$def_verify$0$anon14_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 51914) 51902) inline$$AccountFreezing_create_$def_verify$0$anon14_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon24_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (= $abort_code@3@@0 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 51894) 51914) inline$$AccountFreezing_create_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 51894) 51900) inline$$AccountFreezing_create_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon22_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 51882) 52082) inline$$AccountFreezing_create_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 51882) 51894) inline$$AccountFreezing_create_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon20_Else$1_correct  (=> (and (and (and (= inline$$AccountFreezing_create_$def_verify$0$$t7@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 51876) 52529) inline$$AccountFreezing_create_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 51876) 51882) inline$$AccountFreezing_create_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@0  (=> (and (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$AccountFreezing_create_$def_verify$0$$t5@1)))) (= (ControlFlow 0 51864) 51876)) inline$$AccountFreezing_create_$def_verify$0$anon20_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 51854) (- 0 66509)) true) (=> (= (ControlFlow 0 51854) 51864) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon20_Else_correct  (=> (not $abort_flag@0@@1) (=> (and (= inline$$AccountFreezing_create_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@2)))) (= (ControlFlow 0 51870) 51854)) inline$$Not$0$Entry_correct@@0))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 51808) 52549) inline$$AccountFreezing_create_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 51808) 51870) inline$$AccountFreezing_create_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon2_correct  (=> (and (= inline$$AccountFreezing_create_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| account@@0) true)) (= (ControlFlow 0 51806) 51808)) inline$$AccountFreezing_create_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 51756) 51806)) inline$$AccountFreezing_create_$def_verify$0$anon2_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 52573) 51806) inline$$AccountFreezing_create_$def_verify$0$anon2_correct)))
(let ((inline$$AccountFreezing_create_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 51750) 52573) inline$$AccountFreezing_create_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 51750) 51756) inline$$AccountFreezing_create_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (= (ControlFlow 0 52577) 51750))) inline$$AccountFreezing_create_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 51216) 52577)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (and (|Select_[$TypeValueArray,$int]$bool| $AccountFreezing_FreezingBit_$CallerDomain $EmptyTypeValueArray (|a#$Address| account@@0)) (= (ControlFlow 0 65837) 51216)) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun account@@1 () T@$Value)
(declare-fun frozen_address () T@$Value)
(declare-fun $abort_code@13 () Int)
(declare-fun $AccountFreezing_FreezingBit_$memory@1@@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun $abort_flag@7 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun $abort_code@11 () Int)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun $AccountFreezing_FreezeEventsHolder_$memory () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun $AccountFreezing_FreezingBit_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0 () T@$TypeValue)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$AccountFreezing_FreezeAccountEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$AccountFreezing_freeze_account_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$AccountFreezing_freeze_account_$def_verify$0$$t19@1 () T@$Value)
(declare-fun $abort_code@8 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$AccountFreezing_freeze_account_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$AccountFreezing_freeze_account_$def_verify$0$$t20@1 () T@$Value)
(declare-fun $abort_code@7 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$AccountFreezing_freeze_account_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$AccountFreezing_freeze_account_$def_verify$0$$t12@1 () T@$Value)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$AccountFreezing_freeze_account_$def_verify$0$$t13@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 67151) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 56973) (- 0 71345)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71360)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71381)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71410)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71427)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 173345816)))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 173345816)))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71440)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 186537453)))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 186537453)))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71453)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| frozen_address))))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| frozen_address))))))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71471)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71492)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71521)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) $abort_flag@8) (and (=> (= (ControlFlow 0 56973) (- 0 71538)) (=> $abort_flag@8 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| frozen_address)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453)))))))) (=> (=> $abort_flag@8 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| frozen_address)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))))) (and (=> (= (ControlFlow 0 56973) (- 0 71722)) (=> $abort_flag@8 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@13 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (= $abort_code@13 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@13 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) (= $abort_code@13 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 173345816)))) (= $abort_code@13 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 186537453)))) (= $abort_code@13 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| frozen_address))))))) (= $abort_code@13 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (= $abort_code@13 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@13 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) (= $abort_code@13 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@8 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@13 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (= $abort_code@13 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@13 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) (= $abort_code@13 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 173345816)))) (= $abort_code@13 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified frozen_address ($Address 186537453)))) (= $abort_code@13 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| frozen_address))))))) (= $abort_code@13 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (= $abort_code@13 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@13 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) (= $abort_code@13 (|i#$Integer| ($Integer 2)))))) (=> (= (ControlFlow 0 56973) (- 0 72016)) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| frozen_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| frozen_address)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))))))))))))))))))))))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon86_Else$3_correct  (and (=> (= (ControlFlow 0 56759) (- 0 71067)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 56759) (- 0 71088)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (and (and (= $abort_flag@8 $abort_flag@7) (= $AccountFreezing_FreezingBit_$memory@1@@0 |inline$$WritebackToGlobal$0$m'@2|)) (and (= $abort_code@13 $abort_code@11) (= (ControlFlow 0 56759) 56973))) anon0$2_correct@@2)))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $AccountFreezing_FreezeEventsHolder_$memory) (= (ControlFlow 0 56653) 56759)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon86_Else$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 56707) 56759))) inline$$AccountFreezing_freeze_account_$def_verify$0$anon86_Else$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (and (=> (= (ControlFlow 0 56643) 56707) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 56643) 56653) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 56461) 56643)) inline$$WritebackToGlobal$1$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 56517) 56643))) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 56425) 56517) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 56425) 56461) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (and (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$ReadRef$0$v@1)) (= (ControlFlow 0 56282) 56425)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon86_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 56288) 56282)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@8 true) (= $AccountFreezing_FreezingBit_$memory@1@@0 $AccountFreezing_FreezingBit_$memory@0@@0)) (and (= $abort_code@13 $abort_code@12) (= (ControlFlow 0 54330) 56973))) anon0$2_correct@@2)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon7_correct  (=> (= $abort_code@12 $abort_code@1@@1) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 56943) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 56941) 56943)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon7_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 56951) 56943) inline$$AccountFreezing_freeze_account_$def_verify$0$anon7_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon61_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 56935) 56951) inline$$AccountFreezing_freeze_account_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 56935) 56941) inline$$AccountFreezing_freeze_account_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon11_correct  (=> (= $abort_code@12 $abort_code@2@@1) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 56923) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 56921) 56923)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon11_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 56931) 56923) inline$$AccountFreezing_freeze_account_$def_verify$0$anon11_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon63_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 56915) 56931) inline$$AccountFreezing_freeze_account_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 56915) 56921) inline$$AccountFreezing_freeze_account_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon17_correct  (=> (= $abort_code@12 $abort_code@3@@1) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 56899) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 56897) 56899)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon17_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon67_Then_correct  (=> (= (ControlFlow 0 56907) 56899) inline$$AccountFreezing_freeze_account_$def_verify$0$anon17_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon66_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 56891) 56907) inline$$AccountFreezing_freeze_account_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 56891) 56897) inline$$AccountFreezing_freeze_account_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon27_correct  (=> (= $abort_code@12 $abort_code@5@@1) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 56875) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 56873) 56875)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon27_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 56883) 56875) inline$$AccountFreezing_freeze_account_$def_verify$0$anon27_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon71_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 56867) 56883) inline$$AccountFreezing_freeze_account_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 56867) 56873) inline$$AccountFreezing_freeze_account_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon35_correct  (=> (= $abort_code@12 $abort_code@6@@0) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 56855) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 56853) 56855)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon35_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 56863) 56855) inline$$AccountFreezing_freeze_account_$def_verify$0$anon35_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon75_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 56847) 56863) inline$$AccountFreezing_freeze_account_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 56847) 56853) inline$$AccountFreezing_freeze_account_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon43_correct  (=> (= $abort_code@12 $abort_code@9) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 56835) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 56833) 56835)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon43_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon80_Then_correct  (=> (= (ControlFlow 0 56843) 56835) inline$$AccountFreezing_freeze_account_$def_verify$0$anon43_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon79_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 56827) 56843) inline$$AccountFreezing_freeze_account_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 56827) 56833) inline$$AccountFreezing_freeze_account_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon47_correct  (=> (= $abort_code@12 $abort_code@10) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 56815) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 56813) 56815)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon47_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon82_Then_correct  (=> (= (ControlFlow 0 56823) 56815) inline$$AccountFreezing_freeze_account_$def_verify$0$anon47_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon81_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 56807) 56823) inline$$AccountFreezing_freeze_account_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 56807) 56813) inline$$AccountFreezing_freeze_account_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon53_correct  (=> (= $abort_code@12 $abort_code@11) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 56791) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 56789) 56791)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon53_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon85_Then_correct  (=> (= (ControlFlow 0 56799) 56791) inline$$AccountFreezing_freeze_account_$def_verify$0$anon53_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon84_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 56783) 56799) inline$$AccountFreezing_freeze_account_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 56783) 56789) inline$$AccountFreezing_freeze_account_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon57_correct  (=> (= $abort_code@12 $abort_code@11) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 56771) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 56769) 56771)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon57_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon87_Then_correct  (=> (= (ControlFlow 0 56779) 56771) inline$$AccountFreezing_freeze_account_$def_verify$0$anon57_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon86_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 56763) 56779) inline$$AccountFreezing_freeze_account_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 56763) 56769) inline$$AccountFreezing_freeze_account_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct  (=> (= inline$$Event_emit_event$0$t@0 $AccountFreezing_FreezeAccountEvent_type_value) (and (=> (= (ControlFlow 0 56213) 56763) inline$$AccountFreezing_freeze_account_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 56213) 56288) inline$$AccountFreezing_freeze_account_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon84_Else$3_correct  (and (=> (= (ControlFlow 0 56223) (- 0 70783)) true) (=> (= (ControlFlow 0 56223) 56213) inline$$Event_emit_event$0$Entry_correct))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 56165) 56223)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon84_Else$3_correct)))
(let ((inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 56121) 56165)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 56127) 56165) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 56115) 56127) inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 56115) 56121) inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 56107) 56165)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon0_correct  (=> ((_ is $Address) call3formal@$ret0@0@@3) (=> (and ((_ is $Address) frozen_address) (= inline$$AccountFreezing_FreezeAccountEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 call3formal@$ret0@0@@3) 1 frozen_address) 2)))) (and (=> (= (ControlFlow 0 56099) 56115) inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 56099) 56107) inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $AccountFreezing_FreezeEventsHolder_freeze_event_handle) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) (= (ControlFlow 0 55941) 56099))) inline$$AccountFreezing_FreezeAccountEvent_pack$0$anon0_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon84_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 55947) 55941)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (= $abort_code@11 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 55811) 56783) inline$$AccountFreezing_freeze_account_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 55811) 55947) inline$$AccountFreezing_freeze_account_$def_verify$0$anon84_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 55809) 55811)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1))) (= $abort_code@11 $abort_code@10)) (and (= $abort_flag@7 $abort_flag@6) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 55757) 56783) inline$$AccountFreezing_freeze_account_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 55757) 55947) inline$$AccountFreezing_freeze_account_$def_verify$0$anon84_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 55727) 55809) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 55727) 55757) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 55721) (- 0 70529)) true) (=> (= (ControlFlow 0 55721) 55727) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon83_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 55817) 55721)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon83_Then_correct  (=> (and (and $abort_flag@6 (= $abort_code@12 $abort_code@10)) (and (= $AccountFreezing_FreezingBit_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 56803) 54330))) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 55590) 56803) inline$$AccountFreezing_freeze_account_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 55590) 55817) inline$$AccountFreezing_freeze_account_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 55600) 56803) inline$$AccountFreezing_freeze_account_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 55600) 55817) inline$$AccountFreezing_freeze_account_$def_verify$0$anon83_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@6) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 55584) 55600) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 55584) 55590) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon81_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 55614) 55584)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon79_Else$4_correct  (and (=> (= (ControlFlow 0 55479) (- 0 70339)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (and (=> (= (ControlFlow 0 55479) (- 0 70358)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (and (=> (= (ControlFlow 0 55479) (- 0 70377)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountFreezing_freeze_account_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$AccountFreezing_freeze_account_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_freeze_account_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_freeze_account_$def_verify$0$addr)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountFreezing_freeze_account_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountFreezing_freeze_account_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_freeze_account_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_freeze_account_$def_verify$0$addr@@0))))))))))) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6) (=> $abort_flag@6 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 account@@1)))) ((_ is $Address) call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 55479) 56807) inline$$AccountFreezing_freeze_account_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 55479) 55614) inline$$AccountFreezing_freeze_account_$def_verify$0$anon81_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 55338) 55479)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon79_Else$4_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 55392) 55479))) inline$$AccountFreezing_freeze_account_$def_verify$0$anon79_Else$4_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 55328) 55392) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 55328) 55338) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 55148) 55328)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 55204) 55328))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 55112) 55204) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 55112) 55148) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) inline$$AccountFreezing_freeze_account_$def_verify$0$$t22@1)) (= (ControlFlow 0 54969) 55112)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $AccountFreezing_FreezingBit_is_frozen) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $AccountFreezing_FreezingBit_is_frozen))) (= (ControlFlow 0 54910) 54969))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon79_Else_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 54916) 54910)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@5 true) (=> (and (= $abort_code@9 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 54780) 56827) inline$$AccountFreezing_freeze_account_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 54780) 54916) inline$$AccountFreezing_freeze_account_$def_verify$0$anon79_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 54778) 54780)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_flag@5 $abort_flag@4)) (and (= $abort_code@9 $abort_code@6@@0) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 54726) 56827) inline$$AccountFreezing_freeze_account_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 54726) 54916) inline$$AccountFreezing_freeze_account_$def_verify$0$anon79_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| frozen_address)) (and (=> (= (ControlFlow 0 54696) 54778) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 54696) 54726) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 54690) (- 0 69915)) true) (=> (= (ControlFlow 0 54690) 54696) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon77_Then_correct  (=> (|b#$Boolean| inline$$AccountFreezing_freeze_account_$def_verify$0$$t19@1) (=> (and (= inline$$AccountFreezing_freeze_account_$def_verify$0$$t22@1 ($Boolean true)) (= (ControlFlow 0 54786) 54690)) inline$$BorrowGlobal$0$Entry_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon40_correct  (=> (= $abort_code@12 $abort_code@8) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 54573) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 54571) 54573)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon40_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon78_Then_correct  (=> (= (ControlFlow 0 54581) 54573) inline$$AccountFreezing_freeze_account_$def_verify$0$anon40_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon77_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountFreezing_freeze_account_$def_verify$0$$t19@1)) (= $abort_code@8 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 54565) 54581) inline$$AccountFreezing_freeze_account_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 54565) 54571) inline$$AccountFreezing_freeze_account_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon75_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 54553) 54786) inline$$AccountFreezing_freeze_account_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 54553) 54565) inline$$AccountFreezing_freeze_account_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon73_Then_correct  (=> (and (|b#$Boolean| inline$$AccountFreezing_freeze_account_$def_verify$0$$t16@1) (= inline$$AccountFreezing_freeze_account_$def_verify$0$$t19@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| frozen_address))))) (=> (and (and (and (= inline$$AccountFreezing_freeze_account_$def_verify$0$$t20@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 54547) 56847) inline$$AccountFreezing_freeze_account_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 54547) 54553) inline$$AccountFreezing_freeze_account_$def_verify$0$anon75_Else_correct))))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon32_correct  (=> (= $abort_code@12 $abort_code@7) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 54521) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 54519) 54521)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon32_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 54529) 54521) inline$$AccountFreezing_freeze_account_$def_verify$0$anon32_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon73_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountFreezing_freeze_account_$def_verify$0$$t16@1)) (= $abort_code@7 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 54513) 54529) inline$$AccountFreezing_freeze_account_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 54513) 54519) inline$$AccountFreezing_freeze_account_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon71_Else_correct  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 54501) 54547) inline$$AccountFreezing_freeze_account_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 54501) 54513) inline$$AccountFreezing_freeze_account_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon70_Else_correct  (=> (and (not $abort_flag@2@@2) (= inline$$AccountFreezing_freeze_account_$def_verify$0$$t16@1 ($Boolean  (not ($IsEqual_stratified frozen_address inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1))))) (=> (and (and (and (= inline$$AccountFreezing_freeze_account_$def_verify$0$$t17@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0)) (and (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 54495) 56867) inline$$AccountFreezing_freeze_account_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 54495) 54501) inline$$AccountFreezing_freeze_account_$def_verify$0$anon71_Else_correct))))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon70_Then_correct  (=> (and (and $abort_flag@2@@2 (= $abort_code@12 $abort_code@3@@1)) (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 56887) 54330))) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 54449) 56887) inline$$AccountFreezing_freeze_account_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 54449) 54495) inline$$AccountFreezing_freeze_account_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 54459) 56887) inline$$AccountFreezing_freeze_account_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 54459) 54495) inline$$AccountFreezing_freeze_account_$def_verify$0$anon70_Else_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@2@@2) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 ($Address 186537453))) (and (=> (= (ControlFlow 0 54443) 54459) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 54443) 54449) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon68_Then_correct  (=> (and (|b#$Boolean| inline$$AccountFreezing_freeze_account_$def_verify$0$$t12@1) (= (ControlFlow 0 54473) 54443)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon22_correct  (=> (= $abort_code@12 $abort_code@4@@1) (=> (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 54326) 54330)) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 54324) 54326)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon22_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 54338) 54326) inline$$AccountFreezing_freeze_account_$def_verify$0$anon22_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon68_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountFreezing_freeze_account_$def_verify$0$$t12@1)) (= $abort_code@4@@1 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 54318) 54338) inline$$AccountFreezing_freeze_account_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 54318) 54324) inline$$AccountFreezing_freeze_account_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon66_Else_correct  (=> (not $abort_flag@2@@2) (and (=> (= (ControlFlow 0 54306) 54473) inline$$AccountFreezing_freeze_account_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 54306) 54318) inline$$AccountFreezing_freeze_account_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon65_Else_correct  (=> (and (not $abort_flag@1@@2) (= inline$$AccountFreezing_freeze_account_$def_verify$0$$t12@1 ($Boolean  (not ($IsEqual_stratified frozen_address inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1))))) (=> (and (and (and (= inline$$AccountFreezing_freeze_account_$def_verify$0$$t13@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@2)) (and (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 54300) 56891) inline$$AccountFreezing_freeze_account_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 54300) 54306) inline$$AccountFreezing_freeze_account_$def_verify$0$anon66_Else_correct))))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon65_Then_correct  (=> (and (and $abort_flag@1@@2 (= $abort_code@12 $abort_code@2@@1)) (and (= $AccountFreezing_FreezingBit_$memory@0@@0 $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 56911) 54330))) inline$$AccountFreezing_freeze_account_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 54254) 56911) inline$$AccountFreezing_freeze_account_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 54254) 54300) inline$$AccountFreezing_freeze_account_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 54264) 56911) inline$$AccountFreezing_freeze_account_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 54264) 54300) inline$$AccountFreezing_freeze_account_$def_verify$0$anon65_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@1@@2) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 54248) 54264) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 54248) 54254) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon63_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 54278) 54248)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon61_Else_correct  (=> (and (not $abort_flag@0@@2) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@1@@2)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@1@@2) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) $abort_flag@1@@2)) (and (=> $abort_flag@1@@2 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))))) (=> $abort_flag@1@@2 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@1 ($Address 186537453))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 54143) 56915) inline$$AccountFreezing_freeze_account_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 54143) 54278) inline$$AccountFreezing_freeze_account_$def_verify$0$anon63_Else_correct))))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@2) (=> (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 54137) 56935) inline$$AccountFreezing_freeze_account_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 54137) 54143) inline$$AccountFreezing_freeze_account_$def_verify$0$anon61_Else_correct))))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 54067) 54137)) inline$$AccountFreezing_freeze_account_$def_verify$0$anon4$2_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 56959) 54137) inline$$AccountFreezing_freeze_account_$def_verify$0$anon4$2_correct)))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon59_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 54059) 56959) inline$$AccountFreezing_freeze_account_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 54059) 54067) inline$$AccountFreezing_freeze_account_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon59_Then_correct  (and (=> (= (ControlFlow 0 56967) 56959) inline$$AccountFreezing_freeze_account_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 56967) 54067) inline$$AccountFreezing_freeze_account_$def_verify$0$anon60_Else_correct))))
(let ((inline$$AccountFreezing_freeze_account_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 54053) 56967) inline$$AccountFreezing_freeze_account_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 54053) 54059) inline$$AccountFreezing_freeze_account_$def_verify$0$anon59_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (=> (and (and (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) 2)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@0))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@4))
))) (and (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@18 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@5))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (= (ControlFlow 0 56971) 54053)))) inline$$AccountFreezing_freeze_account_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> ((_ is $Address) account@@1) (=> (and ((_ is $Address) frozen_address) (= (ControlFlow 0 52787) 56971)) anon0$1_correct@@2))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 67151) 52787) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun dr_account () T@$Value)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_$memory@1 () T@$Memory)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$AccountFreezing_FreezeEventsHolder_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun inline$$Not$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$AccountFreezing_initialize_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$AccountFreezing_initialize_$def_verify$0$$t5@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 72032) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 59233) (- 0 73763)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 59233) (- 0 73778)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 59233) (- 0 73795)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 59233) (- 0 73809)) (=> $abort_flag@5@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (=> (=> $abort_flag@5@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))) (and (=> (= (ControlFlow 0 59233) (- 0 73853)) (=> $abort_flag@5@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@8@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@8@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) (= $abort_code@8@@0 (|i#$Integer| ($Integer 6))))))) (=> (=> $abort_flag@5@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@8@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@8@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) (= $abort_code@8@@0 (|i#$Integer| ($Integer 6)))))) (and (=> (= (ControlFlow 0 59233) (- 0 73930)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory@1) $EmptyTypeValueArray (|a#$Address| dr_account)))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory@1) $EmptyTypeValueArray (|a#$Address| dr_account))))) (=> (= (ControlFlow 0 59233) (- 0 73946)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@4 T@$Value) )  (=> ((_ is $Address) addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $AccountFreezing_FreezingBit_is_frozen) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))))))))))))))))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon50_Else_correct  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 59079) (- 0 73553)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 59079) (- 0 73574)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (and (and (= $abort_code@8@@0 $abort_code@6@@1) (= $abort_flag@5@@0 $abort_flag@4@@0)) (and (= $AccountFreezing_FreezeEventsHolder_$memory@1 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 59079) 59233))) anon0$2_correct@@3))))))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@8@@0 $abort_code@7@@0) (= $abort_flag@5@@0 true)) (and (= $AccountFreezing_FreezeEventsHolder_$memory@1 $AccountFreezing_FreezeEventsHolder_$memory@0) (= (ControlFlow 0 58419) 59233))) anon0$2_correct@@3)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon5_correct  (=> (= $abort_code@7@@0 $abort_code@1@@2) (=> (and (= $AccountFreezing_FreezeEventsHolder_$memory@0 $AccountFreezing_FreezeEventsHolder_$memory) (= (ControlFlow 0 59211) 58419)) inline$$AccountFreezing_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 59209) 59211)) inline$$AccountFreezing_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 59219) 59211) inline$$AccountFreezing_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon36_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 59203) 59219) inline$$AccountFreezing_initialize_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 59203) 59209) inline$$AccountFreezing_initialize_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon9_correct  (=> (= $abort_code@7@@0 $abort_code@2@@2) (=> (and (= $AccountFreezing_FreezeEventsHolder_$memory@0 $AccountFreezing_FreezeEventsHolder_$memory) (= (ControlFlow 0 59191) 58419)) inline$$AccountFreezing_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 59189) 59191)) inline$$AccountFreezing_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 59199) 59191) inline$$AccountFreezing_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon38_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 59183) 59199) inline$$AccountFreezing_initialize_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 59183) 59189) inline$$AccountFreezing_initialize_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon13_correct  (=> (= $abort_code@7@@0 $abort_code@3@@2) (=> (and (= $AccountFreezing_FreezeEventsHolder_$memory@0 $AccountFreezing_FreezeEventsHolder_$memory) (= (ControlFlow 0 59171) 58419)) inline$$AccountFreezing_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 59169) 59171)) inline$$AccountFreezing_initialize_$def_verify$0$anon13_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 59179) 59171) inline$$AccountFreezing_initialize_$def_verify$0$anon13_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon40_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 59163) 59179) inline$$AccountFreezing_initialize_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 59163) 59169) inline$$AccountFreezing_initialize_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon17_correct  (=> (= $abort_code@7@@0 $abort_code@4@@2) (=> (and (= $AccountFreezing_FreezeEventsHolder_$memory@0 $AccountFreezing_FreezeEventsHolder_$memory) (= (ControlFlow 0 59151) 58419)) inline$$AccountFreezing_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 59149) 59151)) inline$$AccountFreezing_initialize_$def_verify$0$anon17_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 59159) 59151) inline$$AccountFreezing_initialize_$def_verify$0$anon17_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon42_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 59143) 59159) inline$$AccountFreezing_initialize_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 59143) 59149) inline$$AccountFreezing_initialize_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon25_correct  (=> (= $abort_code@7@@0 $abort_code@4@@2) (=> (and (= $AccountFreezing_FreezeEventsHolder_$memory@0 $AccountFreezing_FreezeEventsHolder_$memory) (= (ControlFlow 0 59131) 58419)) inline$$AccountFreezing_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 59129) 59131)) inline$$AccountFreezing_initialize_$def_verify$0$anon25_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 59139) 59131) inline$$AccountFreezing_initialize_$def_verify$0$anon25_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon46_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 59123) 59139) inline$$AccountFreezing_initialize_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 59123) 59129) inline$$AccountFreezing_initialize_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon29_correct  (=> (= $abort_code@7@@0 $abort_code@4@@2) (=> (and (= $AccountFreezing_FreezeEventsHolder_$memory@0 $AccountFreezing_FreezeEventsHolder_$memory) (= (ControlFlow 0 59111) 58419)) inline$$AccountFreezing_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 59109) 59111)) inline$$AccountFreezing_initialize_$def_verify$0$anon29_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 59119) 59111) inline$$AccountFreezing_initialize_$def_verify$0$anon29_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon48_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 59103) 59119) inline$$AccountFreezing_initialize_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 59103) 59109) inline$$AccountFreezing_initialize_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon33_correct  (=> (= $abort_code@7@@0 $abort_code@6@@1) (=> (and (= $AccountFreezing_FreezeEventsHolder_$memory@0 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 59091) 58419)) inline$$AccountFreezing_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 59089) 59091)) inline$$AccountFreezing_initialize_$def_verify$0$anon33_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 59099) 59091) inline$$AccountFreezing_initialize_$def_verify$0$anon33_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon50_Then_correct  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 59083) 59099) inline$$AccountFreezing_initialize_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 59083) 59089) inline$$AccountFreezing_initialize_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@4@@0 true) (=> (and (= $abort_code@6@@1 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 59013) 59083) inline$$AccountFreezing_initialize_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 59013) 59079) inline$$AccountFreezing_initialize_$def_verify$0$anon50_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 59011) 59013)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 inline$$AccountFreezing_FreezeEventsHolder_pack$0$$struct@1))) (= $abort_flag@4@@0 $abort_flag@3@@1)) (and (= $abort_code@6@@1 $abort_code@4@@2) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 58961) 59083) inline$$AccountFreezing_initialize_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 58961) 59079) inline$$AccountFreezing_initialize_$def_verify$0$anon50_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 59019) 59011) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 59019) 58961) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 58807) (- 0 73438)) true) (=> (= (ControlFlow 0 58807) 59019) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 58689) 58807)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 58695) 58807) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 58683) 58695) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 58683) 58689) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon4_Else_correct)))))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 58675) 58807)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon0_correct  (=> (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@19 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1))
))) true) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$1$res@0) (let ((va@@21 (|v#$Vector| inline$$Event_new_event_handle$1$res@0)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2))
))) true) (= inline$$AccountFreezing_FreezeEventsHolder_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Event_new_event_handle$0$res@0) 1 inline$$Event_new_event_handle$1$res@0) 2)))) (and (=> (= (ControlFlow 0 58667) 58683) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 58667) 58675) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon3_Else_correct))))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon48_Else_correct  (=> (and (not $abort_flag@3@@1) (= (ControlFlow 0 58701) 58667)) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$1$Entry_correct  (=> (= inline$$Event_new_event_handle$1$t@0 $AccountFreezing_UnfreezeAccountEvent_type_value) (and (=> (= (ControlFlow 0 58501) 59103) inline$$AccountFreezing_initialize_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 58501) 58701) inline$$AccountFreezing_initialize_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon46_Else_correct  (=> (and (not $abort_flag@3@@1) (= (ControlFlow 0 58509) 58501)) inline$$Event_new_event_handle$1$Entry_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $AccountFreezing_FreezeAccountEvent_type_value) (and (=> (= (ControlFlow 0 58459) 59123) inline$$AccountFreezing_initialize_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 58459) 58509) inline$$AccountFreezing_initialize_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon44_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@1) (= (ControlFlow 0 58467) 58459)) inline$$Event_new_event_handle$0$Entry_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon22_correct  (=> (= $abort_code@7@@0 $abort_code@5@@2) (=> (and (= $AccountFreezing_FreezeEventsHolder_$memory@0 $AccountFreezing_FreezeEventsHolder_$memory) (= (ControlFlow 0 58415) 58419)) inline$$AccountFreezing_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 58413) 58415)) inline$$AccountFreezing_initialize_$def_verify$0$anon22_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 58427) 58415) inline$$AccountFreezing_initialize_$def_verify$0$anon22_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon44_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@1)) (= $abort_code@5@@2 (|i#$Integer| call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 58407) 58427) inline$$AccountFreezing_initialize_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 58407) 58413) inline$$AccountFreezing_initialize_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon42_Else_correct  (=> (not $abort_flag@3@@1) (and (=> (= (ControlFlow 0 58395) 58467) inline$$AccountFreezing_initialize_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 58395) 58407) inline$$AccountFreezing_initialize_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon40_Else$1_correct  (=> (and (and (and (= inline$$AccountFreezing_initialize_$def_verify$0$$t7@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@1)) (and (=> $abort_flag@3@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 58389) 59143) inline$$AccountFreezing_initialize_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 58389) 58395) inline$$AccountFreezing_initialize_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@1  (=> (and (= inline$$Not$0$dst@1@@1 ($Boolean  (not (|b#$Boolean| inline$$AccountFreezing_initialize_$def_verify$0$$t5@1)))) (= (ControlFlow 0 58377) 58389)) inline$$AccountFreezing_initialize_$def_verify$0$anon40_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 58367) (- 0 73184)) true) (=> (= (ControlFlow 0 58367) 58377) inline$$Not$0$anon0_correct@@1))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon40_Else_correct  (=> (not $abort_flag@2@@3) (=> (and (= inline$$AccountFreezing_initialize_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@8)))) (= (ControlFlow 0 58383) 58367)) inline$$Not$0$Entry_correct@@1))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon38_Else_correct  (=> (not $abort_flag@1@@3) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@3) (=> $abort_flag@2@@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 58321) 59163) inline$$AccountFreezing_initialize_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 58321) 58383) inline$$AccountFreezing_initialize_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon36_Else_correct  (=> (and (and (not $abort_flag@0@@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1@@3)) (and (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@1@@3 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 58315) 59183) inline$$AccountFreezing_initialize_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 58315) 58321) inline$$AccountFreezing_initialize_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0@@3) (=> (and (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 58309) 59203) inline$$AccountFreezing_initialize_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 58309) 58315) inline$$AccountFreezing_initialize_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 58273) 58309)) inline$$AccountFreezing_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 59227) 58309) inline$$AccountFreezing_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountFreezing_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 58267) 59227) inline$$AccountFreezing_initialize_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 58267) 58273) inline$$AccountFreezing_initialize_$def_verify$0$anon35_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (=> (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) 2)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@4))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (= (ControlFlow 0 59231) 58267))) inline$$AccountFreezing_initialize_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@3  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 57544) 59231)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 72032) 57544) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun account@@2 () T@$Value)
(declare-fun unfrozen_address () T@$Value)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $AccountFreezing_FreezingBit_$memory@1@@1 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@0| () T@$Memory)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$1$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun $AccountFreezing_FreezingBit_$memory@0@@1 () T@$Memory)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@0 () T@$TypeValue)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AccountFreezing_unfreeze_account_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AccountFreezing_unfreeze_account_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$AccountFreezing_unfreeze_account_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 74015) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 62928) (- 0 77513)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 62928) (- 0 77528)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 62928) (- 0 77549)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 62928) (- 0 77578)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 62928) (- 0 77595)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| unfrozen_address))))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| unfrozen_address))))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 62928) (- 0 77613)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 62928) (- 0 77634)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 62928) (- 0 77663)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 62928) (- 0 77680)) (=> $abort_flag@6@@0 (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| unfrozen_address)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453)))))))) (=> (=> $abort_flag@6@@0 (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| unfrozen_address)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))))) (and (=> (= (ControlFlow 0 62928) (- 0 77840)) (=> $abort_flag@6@@0 (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| unfrozen_address))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@6@@0 (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| unfrozen_address))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 2)))))) (=> (= (ControlFlow 0 62928) (- 0 78088)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@1@@1) $EmptyTypeValueArray (|a#$Address| unfrozen_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@1@@1) $EmptyTypeValueArray (|a#$Address| unfrozen_address)))) $AccountFreezing_FreezingBit_is_frozen))))))))))))))))))))))))))))))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon56_Else$3_correct  (and (=> (= (ControlFlow 0 62762) (- 0 77299)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 62762) (- 0 77320)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (and (and (= $abort_flag@6@@0 $abort_flag@5@@1) (= $AccountFreezing_FreezingBit_$memory@1@@1 |inline$$WritebackToGlobal$0$m'@2@@0|)) (and (= $abort_code@9@@0 $abort_code@7@@1) (= (ControlFlow 0 62762) 62928))) anon0$2_correct@@4)))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@0| $AccountFreezing_FreezeEventsHolder_$memory) (= (ControlFlow 0 62656) 62762)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon56_Else$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@0)) (= inline$$WritebackToGlobal$1$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (= |inline$$WritebackToGlobal$1$m'@1@@0| ($Memory (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0 inline$$WritebackToGlobal$1$v@1@@0)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@0| |inline$$WritebackToGlobal$1$m'@1@@0|) (= (ControlFlow 0 62710) 62762))) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon56_Else$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$1$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (and (=> (= (ControlFlow 0 62646) 62710) inline$$WritebackToGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 62646) 62656) inline$$WritebackToGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@0| inline$$BorrowGlobal$1$dst@2@@0) (= (ControlFlow 0 62464) 62646)) inline$$WritebackToGlobal$1$anon0_correct@@0))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|) (= (ControlFlow 0 62520) 62646))) inline$$WritebackToGlobal$1$anon0_correct@@0)))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) (and (=> (= (ControlFlow 0 62428) 62520) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 62428) 62464) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (and (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@0) (|p#$Mutation| inline$$BorrowField$1$dst@1@@0) inline$$ReadRef$0$v@1@@0)) (= (ControlFlow 0 62285) 62428)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon56_Else_correct  (=> (and (not $abort_flag@5@@1) (= (ControlFlow 0 62291) 62285)) inline$$WriteRef$1$anon0_correct@@0)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@6@@0 true) (= $AccountFreezing_FreezingBit_$memory@1@@1 $AccountFreezing_FreezingBit_$memory@0@@1)) (and (= $abort_code@9@@0 $abort_code@8@@1) (= (ControlFlow 0 60576) 62928))) anon0$2_correct@@4)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon7_correct  (=> (= $AccountFreezing_FreezingBit_$memory@0@@1 $AccountFreezing_FreezingBit_$memory) (=> (and (= $abort_code@8@@1 $abort_code@1@@3) (= (ControlFlow 0 62898) 60576)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 62896) 62898)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon7_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 62906) 62898) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon7_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon41_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 62890) 62906) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 62890) 62896) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon11_correct  (=> (= $AccountFreezing_FreezingBit_$memory@0@@1 $AccountFreezing_FreezingBit_$memory) (=> (and (= $abort_code@8@@1 $abort_code@2@@3) (= (ControlFlow 0 62878) 60576)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 62876) 62878)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon11_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 62886) 62878) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon11_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon43_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 62870) 62886) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 62870) 62876) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon15_correct  (=> (= $AccountFreezing_FreezingBit_$memory@0@@1 $AccountFreezing_FreezingBit_$memory) (=> (and (= $abort_code@8@@1 $abort_code@3@@3) (= (ControlFlow 0 62858) 60576)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 62856) 62858)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon15_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 62866) 62858) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon15_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon45_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 62850) 62866) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 62850) 62856) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon23_correct  (=> (= $AccountFreezing_FreezingBit_$memory@0@@1 $AccountFreezing_FreezingBit_$memory) (=> (and (= $abort_code@8@@1 $abort_code@5@@3) (= (ControlFlow 0 62838) 60576)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 62836) 62838)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon23_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 62846) 62838) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon23_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon49_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 62830) 62846) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 62830) 62836) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon27_correct  (=> (= $AccountFreezing_FreezingBit_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@0|) (=> (and (= $abort_code@8@@1 $abort_code@6@@2) (= (ControlFlow 0 62818) 60576)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 62816) 62818)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon27_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 62826) 62818) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon27_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon51_Then_correct  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 62810) 62826) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 62810) 62816) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon33_correct  (=> (= $AccountFreezing_FreezingBit_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@0|) (=> (and (= $abort_code@8@@1 $abort_code@7@@1) (= (ControlFlow 0 62794) 60576)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 62792) 62794)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon33_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 62802) 62794) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon33_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon54_Then_correct  (=> $abort_flag@5@@1 (and (=> (= (ControlFlow 0 62786) 62802) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 62786) 62792) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon37_correct  (=> (= $AccountFreezing_FreezingBit_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@0|) (=> (and (= $abort_code@8@@1 $abort_code@7@@1) (= (ControlFlow 0 62774) 60576)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 62772) 62774)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon37_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 62782) 62774) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon37_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon56_Then_correct  (=> $abort_flag@5@@1 (and (=> (= (ControlFlow 0 62766) 62782) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 62766) 62772) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@0  (=> (= inline$$Event_emit_event$0$t@0@@0 $AccountFreezing_UnfreezeAccountEvent_type_value) (and (=> (= (ControlFlow 0 62216) 62766) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 62216) 62291) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon54_Else$3_correct  (and (=> (= (ControlFlow 0 62226) (- 0 77015)) true) (=> (= (ControlFlow 0 62226) 62216) inline$$Event_emit_event$0$Entry_correct@@0))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1@@0)) (= (ControlFlow 0 62168) 62226)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon54_Else$3_correct)))
(let ((inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 62124) 62168)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 62130) 62168) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 62118) 62130) inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 62118) 62124) inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 62110) 62168)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon0_correct  (=> ((_ is $Address) call3formal@$ret0@0@@9) (=> (and ((_ is $Address) unfrozen_address) (= inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 call3formal@$ret0@0@@9) 1 unfrozen_address) 2)))) (and (=> (= (ControlFlow 0 62102) 62118) inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 62102) 62110) inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) (= (ControlFlow 0 61944) 62102))) inline$$AccountFreezing_UnfreezeAccountEvent_pack$0$anon0_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon54_Else_correct  (=> (and (not $abort_flag@5@@1) (= (ControlFlow 0 61950) 61944)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@0  (=> (= $abort_code@7@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@5@@1 true) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@0@@0)) (and (=> (= (ControlFlow 0 61814) 62786) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 61814) 61950) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon54_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0)) (= (ControlFlow 0 61812) 61814)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$1$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0))) (= $abort_code@7@@1 $abort_code@6@@2)) (and (= $abort_flag@5@@1 $abort_flag@4@@1) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@1@@0))) (and (=> (= (ControlFlow 0 61760) 62786) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 61760) 61950) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon54_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@0  (=> (= inline$$BorrowGlobal$1$a@1@@0 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0)) (and (=> (= (ControlFlow 0 61730) 61812) inline$$BorrowGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 61730) 61760) inline$$BorrowGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 61724) (- 0 76761)) true) (=> (= (ControlFlow 0 61724) 61730) inline$$BorrowGlobal$1$anon0_correct@@0))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon53_Else_correct  (=> (and (not $abort_flag@4@@1) (= (ControlFlow 0 61820) 61724)) inline$$BorrowGlobal$1$Entry_correct@@0)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon53_Then_correct  (=> (and (and $abort_flag@4@@1 (= $AccountFreezing_FreezingBit_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@0|)) (and (= $abort_code@8@@1 $abort_code@6@@2) (= (ControlFlow 0 62806) 60576))) inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 61593) 62806) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 61593) 61820) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 61603) 62806) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 61603) 61820) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon53_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@4@@1) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 61587) 61603) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 61587) 61593) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon51_Else_correct  (=> (and (not $abort_flag@4@@1) (= (ControlFlow 0 61617) 61587)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon49_Else$4_correct  (and (=> (= (ControlFlow 0 61482) (- 0 76571)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (and (=> (= (ControlFlow 0 61482) (- 0 76590)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (and (=> (= (ControlFlow 0 61482) (- 0 76609)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$AccountFreezing_unfreeze_account_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_unfreeze_account_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_unfreeze_account_$def_verify$0$addr)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountFreezing_unfreeze_account_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_unfreeze_account_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$AccountFreezing_unfreeze_account_$def_verify$0$addr@@0))))))))))) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@1) (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 account@@2)))) ((_ is $Address) call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 61482) 62810) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 61482) 61617) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon51_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $AccountFreezing_FreezingBit_$memory) (= (ControlFlow 0 61341) 61482)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon49_Else$4_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 61395) 61482))) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon49_Else$4_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 61331) 61395) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 61331) 61341) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 61151) 61331)) inline$$WritebackToGlobal$0$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 61207) 61331))) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 61115) 61207) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 61115) 61151) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (and (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) inline$$AccountFreezing_unfreeze_account_$def_verify$0$$t10@1)) (= (ControlFlow 0 60972) 61115)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $AccountFreezing_FreezingBit_is_frozen) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $AccountFreezing_FreezingBit_is_frozen))) (= (ControlFlow 0 60913) 60972))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon49_Else_correct  (=> (and (not $abort_flag@3@@2) (= (ControlFlow 0 60919) 60913)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@3@@2 true) (=> (and (= $abort_code@5@@3 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 60783) 62830) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 60783) 60919) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon49_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 60781) 60783)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0))) (= $abort_flag@3@@2 $abort_flag@2@@4)) (and (= $abort_code@5@@3 $abort_code@3@@3) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 60729) 62830) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 60729) 60919) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon49_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| unfrozen_address)) (and (=> (= (ControlFlow 0 60699) 60781) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 60699) 60729) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 60693) (- 0 76147)) true) (=> (= (ControlFlow 0 60693) 60699) inline$$BorrowGlobal$0$anon0_correct@@0))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon47_Then_correct  (=> (|b#$Boolean| inline$$AccountFreezing_unfreeze_account_$def_verify$0$$t7@1) (=> (and (= inline$$AccountFreezing_unfreeze_account_$def_verify$0$$t10@1 ($Boolean false)) (= (ControlFlow 0 60789) 60693)) inline$$BorrowGlobal$0$Entry_correct@@0))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon20_correct  (=> (= $AccountFreezing_FreezingBit_$memory@0@@1 $AccountFreezing_FreezingBit_$memory) (=> (and (= $abort_code@8@@1 $abort_code@4@@3) (= (ControlFlow 0 60572) 60576)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$Abort_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 60570) 60572)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon20_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 60584) 60572) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon20_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon47_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountFreezing_unfreeze_account_$def_verify$0$$t7@1)) (= $abort_code@4@@3 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 60564) 60584) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 60564) 60570) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon45_Else_correct  (=> (not $abort_flag@2@@4) (and (=> (= (ControlFlow 0 60552) 60789) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 60552) 60564) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon43_Else_correct  (=> (and (not $abort_flag@1@@4) (= inline$$AccountFreezing_unfreeze_account_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| unfrozen_address))))) (=> (and (and (and (= inline$$AccountFreezing_unfreeze_account_$def_verify$0$$t8@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@4)) (and (=> $abort_flag@2@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 60546) 62850) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 60546) 60552) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon45_Else_correct))))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon41_Else_correct  (=> (and (not $abort_flag@0@@4) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@1@@4)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@1@@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) $abort_flag@1@@4)) (and (=> $abort_flag@1@@4 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))))) (=> $abort_flag@1@@4 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@2@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@2@@3 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@2 ($Address 186537453))))) (= $abort_code@2@@3 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 60528) 62870) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 60528) 60546) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@4) (=> (and (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@4 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 60522) 62890) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 60522) 60528) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 60452) 60522)) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon4$2_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 62914) 60522) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon4$2_correct)))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon39_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 60444) 62914) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 60444) 60452) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon39_Then_correct  (and (=> (= (ControlFlow 0 62922) 62914) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 62922) 60452) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon40_Else_correct))))
(let ((inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 60438) 62922) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 60438) 60444) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon39_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@29 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (=> (and (and (and (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))
)) (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) 2)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@5))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@6))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@10))
))) (and (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@36 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@11))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@11))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@11))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (= (ControlFlow 0 62926) 60438)))) inline$$AccountFreezing_unfreeze_account_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@4  (=> ((_ is $Address) account@@2) (=> (and ((_ is $Address) unfrozen_address) (= (ControlFlow 0 59454) 62926)) anon0$1_correct@@4))))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 74015) 59454) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
