(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@0) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@0))
)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(declare-fun $tv0@@1 () T@$TypeValue)
(declare-fun receiving () T@$Value)
(declare-fun $abort_flag@13 () Bool)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun amount () T@$Value)
(declare-fun $abort_code@18 () Int)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t20@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@12 () Bool)
(declare-fun inline$$And$1$dst@1 () T@$Value)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t12@1 () T@$Value)
(declare-fun $abort_code@16 () Int)
(declare-fun inline$$Le$1$dst@1 () T@$Value)
(declare-fun inline$$Le$3$dst@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$3$vdst'@2| () T@$Value)
(declare-fun $abort_code@15 () Int)
(declare-fun $abort_flag@11 () Bool)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$3$vdst'@1| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$9$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$3$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$9$p@1 () T@$Path)
(declare-fun inline$$BorrowField$9$size@1 () Int)
(declare-fun inline$$BorrowField$9$p@2 () T@$Path)
(declare-fun |inline$$WritebackToValue$2$vdst'@2| () T@$Value)
(declare-fun $abort_code@13 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@1| () T@$Value)
(declare-fun inline$$And$0$dst@1 () T@$Value)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_code@17 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun inline$$AddU64$3$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$8$v@1 () T@$Value)
(declare-fun inline$$AddU64$3$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$8$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$8$p@1 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1 () Int)
(declare-fun inline$$BorrowField$8$p@2 () T@$Path)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$7$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$2$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$7$p@1 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1 () Int)
(declare-fun inline$$BorrowField$7$p@2 () T@$Path)
(declare-fun inline$$AddU64$2$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$7$v@1 () T@$Value)
(declare-fun inline$$AddU64$2$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$6$p@1 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1 () Int)
(declare-fun inline$$BorrowField$6$p@2 () T@$Path)
(declare-fun inline$$AddU64$1$dst@2 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$AddU64$1$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$6$v@1 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1 () Int)
(declare-fun inline$$BorrowField$5$p@2 () T@$Path)
(declare-fun inline$$Le$2$dst@1 () T@$Value)
(declare-fun $abort_code@12 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t35@1 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@2 () T@$Value)
(declare-fun inline$$Sub$1$dst@0 () T@$Value)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t32@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun $abort_code@8 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t26@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t23@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t15@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun $AccountLimits_Window_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 123716) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 85427) (- 0 129685)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)))))))) $abort_flag@13)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)))))))) $abort_flag@13) (and (=> (= (ControlFlow 0 85427) (- 0 129720)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@1 1)))) len@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@0 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@13)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@1 1)))) len@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@0 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@13) (and (=> (= (ControlFlow 0 85427) (- 0 129783)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@6 1)))) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@5 1)))) receiving))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@13)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@6 1)))) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@5 1)))) receiving))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@13) (and (=> (= (ControlFlow 0 85427) (- 0 129846)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@13)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@13) (and (=> (= (ControlFlow 0 85427) (- 0 129911)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@13)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@13) (and (=> (= (ControlFlow 0 85427) (- 0 129948)) (=> $abort_flag@13 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@11 1)))) len@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@10 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@15 (|l#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@16 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@16 1)))) len@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@15 1)))) receiving))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (=> (=> $abort_flag@13 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@11 1)))) len@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@10 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@15 (|l#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@16 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@16 1)))) len@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@15 1)))) receiving))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (=> (= (ControlFlow 0 85427) (- 0 130207)) (=> $abort_flag@13 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)))))))) (= $abort_code@18 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@20 (|l#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@21 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@21 1)))) len@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@20 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@18 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@25 (|l#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@26 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@26 1)))) len@@25 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@25 1)))) receiving))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@18 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@18 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@18 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@13 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)))))))) (= $abort_code@18 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@20 (|l#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@21 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@21 1)))) len@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@20 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@18 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@25 (|l#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@26 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@26 1)))) len@@25 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@25 1)))) receiving))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@18 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@18 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@18 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 85427) (- 0 130521)) (=> (not $abort_flag@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@30 (|l#$ValueArray| (let ((len@@31 (|l#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1)))) len@@31 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@31 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@31 (|l#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1)))) len@@31 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@31 1)))) len@@30 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@30 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@35 (|l#$ValueArray| (let ((len@@36 (|l#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1)))) len@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@36 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@36 (|l#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1)))) len@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@36 1)))) len@@35 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@35 1)))) receiving))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))) (=> (=> (not $abort_flag@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@30 (|l#$ValueArray| (let ((len@@31 (|l#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1)))) len@@31 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@31 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@31 (|l#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1)))) len@@31 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@31 1)))) len@@30 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@30 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@35 (|l#$ValueArray| (let ((len@@36 (|l#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1)))) len@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@36 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@36 (|l#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1)))) len@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@36 1)))) len@@35 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@35 1)))) receiving))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding)))))))))))))) (=> (= (ControlFlow 0 85427) (- 0 130545)) (=> (not $abort_flag@13) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))))))))) ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@40 (|l#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1)))) len@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@40 1)))) receiving))) $AccountLimits_Window_window_inflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@40 (|l#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1)))) len@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@40 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@40 (|l#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1)))) len@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@40 1)))) receiving))))))) $AccountLimits_Window_tracked_balance ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@40 (|l#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1)))) len@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@40 1)))) receiving))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount)))) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@40 (|l#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1)))) len@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@40 1)))) receiving))) $AccountLimits_Window_window_inflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@40 (|l#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1)))) len@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@40 1)))) receiving))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@40 (|l#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@41 1)))) len@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@40 1)))) receiving))))))))))) ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@2 (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@45 (|l#$ValueArray| (let ((len@@46 (|l#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1)))) len@@46 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@46 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@46 (|l#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1)))) len@@46 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (+ len@@46 1)))) len@@45 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address)) (+ len@@45 1)))) receiving)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@2 receiving)))))))))))))))))))))))))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon28_correct  (=> (= $abort_flag@13 $abort_flag@2) (=> (and (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@2 inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t20@1) (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@2 receiving)) (and (= $abort_code@18 $abort_code@4) (= (ControlFlow 0 85317) 85427))) anon0$2_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon96_Else_correct  (=> (and (not true) (= (ControlFlow 0 85315) 85317)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon28_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon96_Then_correct  (=> (= (ControlFlow 0 85325) 85317) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon28_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon95_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 85305) 85325) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 85305) 85315) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon95_Then_correct  (and (=> (= (ControlFlow 0 85333) 85325) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 85333) 85315) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon96_Else_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon94_Then_correct  (=> (and (|b#$Boolean| call4formal@$ret0@0) (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t20@1 ($Boolean true))) (and (=> (= (ControlFlow 0 85299) 85333) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 85299) 85305) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon82_correct  (=> (= $abort_flag@13 $abort_flag@12) (=> (and (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@2 inline$$And$1$dst@1) (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@2 inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t12@1)) (and (= $abort_code@18 $abort_code@16) (= (ControlFlow 0 83310) 85427))) anon0$2_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon123_Else_correct  (=> (and (not true) (= (ControlFlow 0 83308) 83310)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon82_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon123_Then_correct  (=> (= (ControlFlow 0 83318) 83310) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon82_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon122_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 83298) 83318) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon123_Then_correct) (=> (= (ControlFlow 0 83298) 83308) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon123_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon122_Then_correct  (and (=> (= (ControlFlow 0 83326) 83318) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon123_Then_correct) (=> (= (ControlFlow 0 83326) 83308) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon123_Else_correct))))
(let ((inline$$And$1$anon0_correct  (=> (= inline$$And$1$dst@1 ($Boolean  (and (|b#$Boolean| inline$$Le$1$dst@1) (|b#$Boolean| inline$$Le$3$dst@1)))) (and (=> (= (ControlFlow 0 83282) 83326) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon122_Then_correct) (=> (= (ControlFlow 0 83282) 83298) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon122_Else_correct)))))
(let ((inline$$And$1$Entry_correct  (and (=> (= (ControlFlow 0 83268) (- 0 129361)) true) (=> (= (ControlFlow 0 83268) 83282) inline$$And$1$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon120_Else$4_correct  (=> (and (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t12@1 |inline$$WritebackToValue$3$vdst'@2|) (= $abort_code@16 $abort_code@15)) (and (= $abort_flag@12 $abort_flag@11) (= (ControlFlow 0 85091) 83268))) inline$$And$1$Entry_correct)))
(let ((inline$$WritebackToValue$3$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 12))) (=> (and (= |inline$$WritebackToValue$3$vdst'@2| receiving) (= (ControlFlow 0 85057) 85091)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon120_Else$4_correct))))
(let ((inline$$WritebackToValue$3$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 12)) (= |inline$$WritebackToValue$3$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 receiving (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (= |inline$$WritebackToValue$3$vdst'@2| |inline$$WritebackToValue$3$vdst'@1|) (= (ControlFlow 0 85083) 85091))) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon120_Else$4_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 84902) 85083) inline$$WritebackToValue$3$anon3_Then_correct) (=> (= (ControlFlow 0 84902) 85057) inline$$WritebackToValue$3$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (and (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|v#$Mutation| |inline$$WriteRef$2$to'@1|)))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|))) (and (=> (= (ControlFlow 0 84958) 85083) inline$$WritebackToValue$3$anon3_Then_correct) (=> (= (ControlFlow 0 84958) 85057) inline$$WritebackToValue$3$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (and (=> (= (ControlFlow 0 84866) 84958) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 84866) 84902) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (and (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$9$dst@1) (|p#$Mutation| inline$$BorrowField$9$dst@1) inline$$AddU64$3$dst@2)) (= (ControlFlow 0 84723) 84866)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$BorrowField$9$anon0_correct  (=> (= inline$$BorrowField$9$p@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (=> (and (and (= inline$$BorrowField$9$size@1 (|size#$Path| inline$$BorrowField$9$p@1)) (= inline$$BorrowField$9$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$9$p@1) inline$$BorrowField$9$size@1 $AccountLimits_Window_tracked_balance) (+ inline$$BorrowField$9$size@1 1)))) (and (= inline$$BorrowField$9$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$BorrowField$9$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) $AccountLimits_Window_tracked_balance))) (= (ControlFlow 0 84664) 84723))) inline$$WriteRef$2$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon120_Else_correct  (=> (and (not $abort_flag@11) (= (ControlFlow 0 84670) 84664)) inline$$BorrowField$9$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon117_Else$1_correct  (=> (and (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t12@1 |inline$$WritebackToValue$2$vdst'@2|) (= $abort_code@16 $abort_code@13)) (and (= $abort_flag@12 $abort_flag@9) (= (ControlFlow 0 83224) 83268))) inline$$And$1$Entry_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 12))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2| receiving) (= (ControlFlow 0 83190) 83224)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon117_Else$1_correct))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 12)) (= |inline$$WritebackToValue$2$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 receiving (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (and (= |inline$$WritebackToValue$2$vdst'@2| |inline$$WritebackToValue$2$vdst'@1|) (= (ControlFlow 0 83216) 83224))) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon117_Else$1_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon117_Else_correct  (=> (not (|b#$Boolean| inline$$And$0$dst@1)) (and (=> (= (ControlFlow 0 83222) 83216) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 83222) 83190) inline$$WritebackToValue$2$anon3_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct  (=> (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@1 $Error) (=> (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@1 $Error) (= $abort_flag@13 true)) (=> (and (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@2 inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret0@1) (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@2 inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$ret1@1)) (and (= $abort_code@18 $abort_code@17) (= (ControlFlow 0 80207) 85427))) anon0$2_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon7_correct  (=> (and (= $abort_code@17 $abort_code@1) (= (ControlFlow 0 85393) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 85391) 85393)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon7_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon86_Then_correct  (=> (= (ControlFlow 0 85401) 85393) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon7_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon85_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 85385) 85401) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 85385) 85391) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon15_correct  (=> (and (= $abort_code@17 $abort_code@3) (= (ControlFlow 0 85373) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon90_Else_correct  (=> (and (not true) (= (ControlFlow 0 85371) 85373)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon15_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon90_Then_correct  (=> (= (ControlFlow 0 85381) 85373) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon15_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon89_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 85365) 85381) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 85365) 85371) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon21_correct  (=> (and (= $abort_code@17 $abort_code@4) (= (ControlFlow 0 85345) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 85343) 85345)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon93_Then_correct  (=> (= (ControlFlow 0 85353) 85345) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon92_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 85337) 85353) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 85337) 85343) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon31_correct  (=> (and (= $abort_code@17 $abort_code@5) (= (ControlFlow 0 85279) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon98_Else_correct  (=> (and (not true) (= (ControlFlow 0 85277) 85279)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon31_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon98_Then_correct  (=> (= (ControlFlow 0 85287) 85279) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon31_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon97_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 85271) 85287) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 85271) 85277) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon98_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon35_correct  (=> (and (= $abort_code@17 $abort_code@6) (= (ControlFlow 0 85259) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon100_Else_correct  (=> (and (not true) (= (ControlFlow 0 85257) 85259)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon35_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon100_Then_correct  (=> (= (ControlFlow 0 85267) 85259) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon35_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon99_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 85251) 85267) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 85251) 85257) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon100_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon39_correct  (=> (and (= $abort_code@17 $abort_code@7) (= (ControlFlow 0 85239) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon102_Else_correct  (=> (and (not true) (= (ControlFlow 0 85237) 85239)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon39_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon102_Then_correct  (=> (= (ControlFlow 0 85247) 85239) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon39_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon101_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 85231) 85247) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 85231) 85237) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon102_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon47_correct  (=> (and (= $abort_code@17 $abort_code@9) (= (ControlFlow 0 85219) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon106_Else_correct  (=> (and (not true) (= (ControlFlow 0 85217) 85219)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon47_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon106_Then_correct  (=> (= (ControlFlow 0 85227) 85219) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon47_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon105_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 85211) 85227) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon106_Then_correct) (=> (= (ControlFlow 0 85211) 85217) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon106_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon53_correct  (=> (and (= $abort_code@17 $abort_code@10) (= (ControlFlow 0 85191) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon109_Else_correct  (=> (and (not true) (= (ControlFlow 0 85189) 85191)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon53_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon109_Then_correct  (=> (= (ControlFlow 0 85199) 85191) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon53_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon108_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 85183) 85199) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 85183) 85189) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon109_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon57_correct  (=> (and (= $abort_code@17 $abort_code@11) (= (ControlFlow 0 85171) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 85169) 85171)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon57_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon111_Then_correct  (=> (= (ControlFlow 0 85179) 85171) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon57_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon110_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 85163) 85179) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon111_Then_correct) (=> (= (ControlFlow 0 85163) 85169) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon111_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon65_correct  (=> (and (= $abort_code@17 $abort_code@13) (= (ControlFlow 0 85151) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon115_Else_correct  (=> (and (not true) (= (ControlFlow 0 85149) 85151)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon65_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon115_Then_correct  (=> (= (ControlFlow 0 85159) 85151) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon65_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon114_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 85143) 85159) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon115_Then_correct) (=> (= (ControlFlow 0 85143) 85149) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon115_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon73_correct  (=> (and (= $abort_code@17 $abort_code@14) (= (ControlFlow 0 85123) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon119_Else_correct  (=> (and (not true) (= (ControlFlow 0 85121) 85123)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon73_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon119_Then_correct  (=> (= (ControlFlow 0 85131) 85123) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon73_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon118_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 85115) 85131) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon119_Then_correct) (=> (= (ControlFlow 0 85115) 85121) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon119_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon77_correct  (=> (and (= $abort_code@17 $abort_code@15) (= (ControlFlow 0 85103) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon121_Else_correct  (=> (and (not true) (= (ControlFlow 0 85101) 85103)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon77_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon121_Then_correct  (=> (= (ControlFlow 0 85111) 85103) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon77_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon120_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 85095) 85111) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon121_Then_correct) (=> (= (ControlFlow 0 85095) 85101) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon121_Else_correct)))))
(let ((inline$$AddU64$3$anon3_Then$1_correct  (=> (= $abort_flag@11 true) (=> (and (= $abort_code@15 $EXEC_FAILURE_CODE) (= inline$$AddU64$3$dst@2 inline$$AddU64$3$dst@0)) (and (=> (= (ControlFlow 0 84534) 85095) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon120_Then_correct) (=> (= (ControlFlow 0 84534) 84670) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon120_Else_correct))))))
(let ((inline$$AddU64$3$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$8$v@1) (|i#$Integer| amount)) $MAX_U64) (= (ControlFlow 0 84532) 84534)) inline$$AddU64$3$anon3_Then$1_correct)))
(let ((inline$$AddU64$3$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$8$v@1) (|i#$Integer| amount))) (=> (and (and (= inline$$AddU64$3$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$8$v@1) (|i#$Integer| amount)))) (= $abort_flag@11 $abort_flag@10)) (and (= $abort_code@15 $abort_code@14) (= inline$$AddU64$3$dst@2 inline$$AddU64$3$dst@1))) (and (=> (= (ControlFlow 0 84476) 85095) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon120_Then_correct) (=> (= (ControlFlow 0 84476) 84670) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon120_Else_correct))))))
(let ((inline$$AddU64$3$Entry_correct  (and (=> (= (ControlFlow 0 84446) (- 0 128968)) true) (and (=> (= (ControlFlow 0 84446) 84532) inline$$AddU64$3$anon3_Then_correct) (=> (= (ControlFlow 0 84446) 84476) inline$$AddU64$3$anon3_Else_correct)))))
(let ((inline$$ReadRef$8$anon0_correct  (=> (and (= inline$$ReadRef$8$v@1 (|v#$Mutation| inline$$BorrowField$8$dst@1)) (= (ControlFlow 0 84339) 84446)) inline$$AddU64$3$Entry_correct)))
(let ((inline$$BorrowField$8$anon0_correct  (=> (= inline$$BorrowField$8$p@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (=> (and (and (= inline$$BorrowField$8$size@1 (|size#$Path| inline$$BorrowField$8$p@1)) (= inline$$BorrowField$8$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1) inline$$BorrowField$8$size@1 $AccountLimits_Window_tracked_balance) (+ inline$$BorrowField$8$size@1 1)))) (and (= inline$$BorrowField$8$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$BorrowField$8$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) $AccountLimits_Window_tracked_balance))) (= (ControlFlow 0 84301) 84339))) inline$$ReadRef$8$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WriteRef$0$to'@1|) (= (ControlFlow 0 84085) 84301)) inline$$BorrowField$8$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1|) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 84141) 84301))) inline$$BorrowField$8$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|))) (and (=> (= (ControlFlow 0 84049) 84141) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 84049) 84085) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (and (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$7$dst@1) (|p#$Mutation| inline$$BorrowField$7$dst@1) inline$$AddU64$2$dst@2)) (= (ControlFlow 0 83906) 84049)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$BorrowField$7$anon0_correct  (=> (= inline$$BorrowField$7$p@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (=> (and (and (= inline$$BorrowField$7$size@1 (|size#$Path| inline$$BorrowField$7$p@1)) (= inline$$BorrowField$7$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1) inline$$BorrowField$7$size@1 $AccountLimits_Window_window_inflow) (+ inline$$BorrowField$7$size@1 1)))) (and (= inline$$BorrowField$7$dst@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1|) inline$$BorrowField$7$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1|))) $AccountLimits_Window_window_inflow))) (= (ControlFlow 0 83847) 83906))) inline$$WriteRef$1$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon118_Else_correct  (=> (and (not $abort_flag@10) (= (ControlFlow 0 83853) 83847)) inline$$BorrowField$7$anon0_correct)))
(let ((inline$$AddU64$2$anon3_Then$1_correct  (=> (= $abort_code@14 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@10 true) (= inline$$AddU64$2$dst@2 inline$$AddU64$2$dst@0)) (and (=> (= (ControlFlow 0 83717) 85115) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon118_Then_correct) (=> (= (ControlFlow 0 83717) 83853) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon118_Else_correct))))))
(let ((inline$$AddU64$2$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$7$v@1) (|i#$Integer| amount)) $MAX_U64) (= (ControlFlow 0 83715) 83717)) inline$$AddU64$2$anon3_Then$1_correct)))
(let ((inline$$AddU64$2$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$7$v@1) (|i#$Integer| amount))) (=> (and (and (= inline$$AddU64$2$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$7$v@1) (|i#$Integer| amount)))) (= $abort_code@14 $abort_code@13)) (and (= $abort_flag@10 $abort_flag@9) (= inline$$AddU64$2$dst@2 inline$$AddU64$2$dst@1))) (and (=> (= (ControlFlow 0 83659) 85115) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon118_Then_correct) (=> (= (ControlFlow 0 83659) 83853) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon118_Else_correct))))))
(let ((inline$$AddU64$2$Entry_correct  (and (=> (= (ControlFlow 0 83629) (- 0 128558)) true) (and (=> (= (ControlFlow 0 83629) 83715) inline$$AddU64$2$anon3_Then_correct) (=> (= (ControlFlow 0 83629) 83659) inline$$AddU64$2$anon3_Else_correct)))))
(let ((inline$$ReadRef$7$anon0_correct  (=> (and (= inline$$ReadRef$7$v@1 (|v#$Mutation| inline$$BorrowField$6$dst@1)) (= (ControlFlow 0 83522) 83629)) inline$$AddU64$2$Entry_correct)))
(let ((inline$$BorrowField$6$anon0_correct  (=> (= inline$$BorrowField$6$p@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (=> (and (and (= inline$$BorrowField$6$size@1 (|size#$Path| inline$$BorrowField$6$p@1)) (= inline$$BorrowField$6$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1) inline$$BorrowField$6$size@1 $AccountLimits_Window_window_inflow) (+ inline$$BorrowField$6$size@1 1)))) (and (= inline$$BorrowField$6$dst@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1|) inline$$BorrowField$6$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1|))) $AccountLimits_Window_window_inflow))) (= (ControlFlow 0 83484) 83522))) inline$$ReadRef$7$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon117_Then_correct  (=> (and (|b#$Boolean| inline$$And$0$dst@1) (= (ControlFlow 0 83536) 83484)) inline$$BorrowField$6$anon0_correct)))
(let ((inline$$And$0$anon0_correct  (=> (= inline$$And$0$dst@1 ($Boolean  (and (|b#$Boolean| inline$$Le$1$dst@1) (|b#$Boolean| inline$$Le$3$dst@1)))) (and (=> (= (ControlFlow 0 83083) 83536) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon117_Then_correct) (=> (= (ControlFlow 0 83083) 83222) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon117_Else_correct)))))
(let ((inline$$And$0$Entry_correct  (and (=> (= (ControlFlow 0 83069) (- 0 128367)) true) (=> (= (ControlFlow 0 83069) 83083) inline$$And$0$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon116_Else_correct  (=> (and (not true) (= (ControlFlow 0 83025) 83069)) inline$$And$0$Entry_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon116_Then_correct  (=> (= (ControlFlow 0 85139) 83069) inline$$And$0$Entry_correct)))
(let ((inline$$Le$3$anon0_correct  (=> (= inline$$Le$3$dst@1 ($Boolean (<= (|i#$Integer| inline$$AddU64$1$dst@2) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)))) (and (=> (= (ControlFlow 0 83011) 85139) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon116_Then_correct) (=> (= (ControlFlow 0 83011) 83025) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon116_Else_correct)))))
(let ((inline$$Le$3$Entry_correct  (and (=> (= (ControlFlow 0 82997) (- 0 128329)) true) (=> (= (ControlFlow 0 82997) 83011) inline$$Le$3$anon0_correct))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_max_holding)) (= (ControlFlow 0 82947) 82997)) inline$$Le$3$Entry_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon114_Else_correct  (=> (and (not $abort_flag@9) (= (ControlFlow 0 82953) 82947)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$AddU64$1$anon3_Then$1_correct  (=> (= $abort_flag@9 true) (=> (and (= $abort_code@13 $EXEC_FAILURE_CODE) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@0)) (and (=> (= (ControlFlow 0 82893) 85143) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon114_Then_correct) (=> (= (ControlFlow 0 82893) 82953) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon114_Else_correct))))))
(let ((inline$$AddU64$1$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| amount)) $MAX_U64) (= (ControlFlow 0 82891) 82893)) inline$$AddU64$1$anon3_Then$1_correct)))
(let ((inline$$AddU64$1$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| amount))) (=> (and (and (= inline$$AddU64$1$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| amount)))) (= $abort_flag@9 $abort_flag@8)) (and (= $abort_code@13 $abort_code@11) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@1))) (and (=> (= (ControlFlow 0 82835) 85143) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon114_Then_correct) (=> (= (ControlFlow 0 82835) 82953) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon114_Else_correct))))))
(let ((inline$$AddU64$1$Entry_correct  (and (=> (= (ControlFlow 0 82805) (- 0 128213)) true) (and (=> (= (ControlFlow 0 82805) 82891) inline$$AddU64$1$anon3_Then_correct) (=> (= (ControlFlow 0 82805) 82835) inline$$AddU64$1$anon3_Else_correct)))))
(let ((inline$$ReadRef$6$anon0_correct  (=> (and (= inline$$ReadRef$6$v@1 (|v#$Mutation| inline$$BorrowField$5$dst@1)) (= (ControlFlow 0 82698) 82805)) inline$$AddU64$1$Entry_correct)))
(let ((inline$$BorrowField$5$anon0_correct  (=> (= inline$$BorrowField$5$p@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (=> (and (and (= inline$$BorrowField$5$size@1 (|size#$Path| inline$$BorrowField$5$p@1)) (= inline$$BorrowField$5$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1) inline$$BorrowField$5$size@1 $AccountLimits_Window_tracked_balance) (+ inline$$BorrowField$5$size@1 1)))) (and (= inline$$BorrowField$5$dst@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1|) inline$$BorrowField$5$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1|))) $AccountLimits_Window_tracked_balance))) (= (ControlFlow 0 82660) 82698))) inline$$ReadRef$6$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon112_Then_correct  (=> (and (|b#$Boolean| inline$$Le$2$dst@1) (= (ControlFlow 0 82712) 82660)) inline$$BorrowField$5$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon62_correct  (=> (and (= $abort_code@17 $abort_code@12) (= (ControlFlow 0 82494) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon113_Else_correct  (=> (and (not true) (= (ControlFlow 0 82492) 82494)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon62_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon113_Then_correct  (=> (= (ControlFlow 0 82502) 82494) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon62_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon112_Else$1_correct  (=> (= $abort_code@12 (|i#$Integer| call3formal@$ret0@0)) (and (=> (= (ControlFlow 0 82486) 82502) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 82486) 82492) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon113_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 12))) (= (ControlFlow 0 82448) 82486)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon112_Else$1_correct)))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 12)) (=> (and (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 receiving (|v#$Mutation| |inline$$WriteRef$0$to'@1|))) (= (ControlFlow 0 82474) 82486)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon112_Else$1_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon112_Else_correct  (=> (not (|b#$Boolean| inline$$Le$2$dst@1)) (and (=> (= (ControlFlow 0 82480) 82474) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 82480) 82448) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon110_Else_correct  (=> (not $abort_flag@8) (and (=> (= (ControlFlow 0 82349) 82712) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon112_Then_correct) (=> (= (ControlFlow 0 82349) 82480) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon112_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon108_Else$1_correct  (=> (and (and (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t35@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@8)) (and (=> $abort_flag@8 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 82343) 85163) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon110_Then_correct) (=> (= (ControlFlow 0 82343) 82349) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon110_Else_correct)))))
(let ((inline$$Le$2$anon0_correct  (=> (and (= inline$$Le$2$dst@1 ($Boolean (<= (|i#$Integer| inline$$ReadRef$5$v@1) (|i#$Integer| inline$$Sub$1$dst@2)))) (= (ControlFlow 0 82331) 82343)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon108_Else$1_correct)))
(let ((inline$$Le$2$Entry_correct  (and (=> (= (ControlFlow 0 82317) (- 0 127942)) true) (=> (= (ControlFlow 0 82317) 82331) inline$$Le$2$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon108_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 82337) 82317)) inline$$Le$2$Entry_correct)))
(let ((inline$$Sub$1$anon3_Then$1_correct  (=> (= $abort_code@10 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7 true) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@0)) (and (=> (= (ControlFlow 0 82261) 85183) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon108_Then_correct) (=> (= (ControlFlow 0 82261) 82337) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon108_Else_correct))))))
(let ((inline$$Sub$1$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t32@1) (|i#$Integer| amount)) (= (ControlFlow 0 82259) 82261)) inline$$Sub$1$anon3_Then$1_correct)))
(let ((inline$$Sub$1$anon3_Else_correct  (=> (<= (|i#$Integer| amount) (|i#$Integer| inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t32@1)) (=> (and (and (= inline$$Sub$1$dst@1 ($Integer (- (|i#$Integer| inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t32@1) (|i#$Integer| amount)))) (= $abort_code@10 $abort_code@9)) (and (= $abort_flag@7 $abort_flag@6) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@1))) (and (=> (= (ControlFlow 0 82207) 85183) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon108_Then_correct) (=> (= (ControlFlow 0 82207) 82337) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon108_Else_correct))))))
(let ((inline$$Sub$1$Entry_correct  (and (=> (= (ControlFlow 0 82181) (- 0 127854)) true) (and (=> (= (ControlFlow 0 82181) 82259) inline$$Sub$1$anon3_Then_correct) (=> (= (ControlFlow 0 82181) 82207) inline$$Sub$1$anon3_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon50$1_correct  (=> (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t32@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 82267) 82181)) inline$$Sub$1$Entry_correct)))
(let ((inline$$ReadRef$5$anon0_correct  (=> (and (= inline$$ReadRef$5$v@1 (|v#$Mutation| inline$$BorrowField$4$dst@1)) (= (ControlFlow 0 82078) 82267)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon50$1_correct)))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $AccountLimits_Window_tracked_balance) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1|) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1|))) $AccountLimits_Window_tracked_balance))) (= (ControlFlow 0 82040) 82078))) inline$$ReadRef$5$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon107_Else_correct  (=> (and (not true) (= (ControlFlow 0 81886) 82040)) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon107_Then_correct  (=> (= (ControlFlow 0 85207) 82040) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$Le$1$anon0_correct  (=> (= inline$$Le$1$dst@1 ($Boolean (<= (|i#$Integer| inline$$AddU64$0$dst@2) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1)))) (and (=> (= (ControlFlow 0 81872) 85207) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon107_Then_correct) (=> (= (ControlFlow 0 81872) 81886) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon107_Else_correct)))))
(let ((inline$$Le$1$Entry_correct  (and (=> (= (ControlFlow 0 81858) (- 0 127706)) true) (=> (= (ControlFlow 0 81858) 81872) inline$$Le$1$anon0_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_max_inflow)) (= (ControlFlow 0 81808) 81858)) inline$$Le$1$Entry_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon105_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 81814) 81808)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_flag@6 true) (=> (and (= $abort_code@9 $EXEC_FAILURE_CODE) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 81754) 85211) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 81754) 81814) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon105_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$4$v@1) (|i#$Integer| amount)) $MAX_U64) (= (ControlFlow 0 81752) 81754)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$4$v@1) (|i#$Integer| amount))) (=> (and (and (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$4$v@1) (|i#$Integer| amount)))) (= $abort_flag@6 $abort_flag@5)) (and (= $abort_code@9 $abort_code@7) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 81696) 85211) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 81696) 81814) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon105_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 81666) (- 0 127590)) true) (and (=> (= (ControlFlow 0 81666) 81752) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 81666) 81696) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowField$3$dst@1)) (= (ControlFlow 0 81559) 81666)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $AccountLimits_Window_window_inflow) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1|) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1|))) $AccountLimits_Window_window_inflow))) (= (ControlFlow 0 81521) 81559))) inline$$ReadRef$4$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon103_Then_correct  (=> (and (|b#$Boolean| inline$$Le$0$dst@1) (= (ControlFlow 0 81573) 81521)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon44_correct  (=> (and (= $abort_code@17 $abort_code@8) (= (ControlFlow 0 81355) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon104_Else_correct  (=> (and (not true) (= (ControlFlow 0 81353) 81355)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon44_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon104_Then_correct  (=> (= (ControlFlow 0 81363) 81355) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon44_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon103_Else$1_correct  (=> (= $abort_code@8 (|i#$Integer| call3formal@$ret0@0@@0)) (and (=> (= (ControlFlow 0 81347) 81363) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 81347) 81353) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon104_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 12))) (= (ControlFlow 0 81309) 81347)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon103_Else$1_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 12)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 receiving (|v#$Mutation| |inline$$WriteRef$0$to'@1|))) (= (ControlFlow 0 81335) 81347)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon103_Else$1_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon103_Else_correct  (=> (not (|b#$Boolean| inline$$Le$0$dst@1)) (and (=> (= (ControlFlow 0 81341) 81335) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 81341) 81309) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon101_Else_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 81210) 81573) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon103_Then_correct) (=> (= (ControlFlow 0 81210) 81341) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon103_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon99_Else$1_correct  (=> (and (and (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t26@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5)) (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 81204) 85231) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 81204) 81210) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon101_Else_correct)))))
(let ((inline$$Le$0$anon0_correct  (=> (and (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| inline$$ReadRef$3$v@1) (|i#$Integer| inline$$Sub$0$dst@2)))) (= (ControlFlow 0 81192) 81204)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon99_Else$1_correct)))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 81178) (- 0 127319)) true) (=> (= (ControlFlow 0 81178) 81192) inline$$Le$0$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon99_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 81198) 81178)) inline$$Le$0$Entry_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (= $abort_code@6 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4 true) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 81122) 85251) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 81122) 81198) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon99_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t23@1) (|i#$Integer| amount)) (= (ControlFlow 0 81120) 81122)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (<= (|i#$Integer| amount) (|i#$Integer| inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t23@1)) (=> (and (and (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t23@1) (|i#$Integer| amount)))) (= $abort_code@6 $abort_code@5)) (and (= $abort_flag@4 $abort_flag@3) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 81068) 85251) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 81068) 81198) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon99_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 81042) (- 0 127231)) true) (and (=> (= (ControlFlow 0 81042) 81120) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 81042) 81068) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon97_Else$2_correct  (=> (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t23@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 81128) 81042)) inline$$Sub$0$Entry_correct)))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 80939) 81128)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon97_Else$2_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $AccountLimits_Window_window_inflow) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1|) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1|))) $AccountLimits_Window_window_inflow))) (= (ControlFlow 0 80901) 80939))) inline$$ReadRef$3$anon0_correct))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) call5formal@$ret0@0)) (= (ControlFlow 0 80741) 80901)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon97_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 80747) 80741)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon94_Else$1_correct  (and (=> (= (ControlFlow 0 80684) (- 0 126873)) true) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@3) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3) (=> $abort_flag@3 (or (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (=> $abort_flag@3 (or (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@5 (|i#$Integer| ($Integer 8)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call5formal@$ret0@0 (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) inline$$ReadRef$2$v@1))))))) (=> (and (and (and (and (and (and (and ((_ is $Vector) call5formal@$ret0@0) (let ((va@@8 (|v#$Vector| call5formal@$ret0@0)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $AccountLimits_Window_limit_address))) (and (=> (= (ControlFlow 0 80684) 85271) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 80684) 80747) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon97_Else_correct))))))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 80672) 80684)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon94_Else$1_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon94_Else_correct  (=> (and (not (|b#$Boolean| call4formal@$ret0@0)) (= (ControlFlow 0 80678) 80672)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon92_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 80634) 85299) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 80634) 80678) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon18_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2) (=> $abort_flag@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) ((_ is $Boolean) call4formal@$ret0@0))) (and (=> (= (ControlFlow 0 80628) 85337) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 80628) 80634) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 80626) 80628)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon18_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon91_Then_correct  (=> (= (ControlFlow 0 85361) 80628) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon18_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon89_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 80620) 85361) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 80620) 80626) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@1 true) (=> (and (= $abort_code@3 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 80606) 85365) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 80606) 80620) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon89_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 80604) 80606)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$GetGlobal$0$ta@0 (|a#$Address| inline$$ReadRef$1$v@1))) (= $abort_flag@1 $abort_flag@0)) (and (= $abort_code@3 $abort_code@1) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 80552) 85365) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 80552) 80620) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon89_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$ReadRef$1$v@1)) (and (=> (= (ControlFlow 0 80534) 80604) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 80534) 80552) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (=> (= inline$$GetGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1)) (and (=> (= (ControlFlow 0 80528) (- 0 126679)) true) (=> (= (ControlFlow 0 80528) 80534) inline$$GetGlobal$0$anon0_correct)))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 80411) 80528)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $AccountLimits_Window_limit_address) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $AccountLimits_Window_limit_address))) (= (ControlFlow 0 80373) 80411))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon87_Then_correct  (=> (and (|b#$Boolean| inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t15@1) (= (ControlFlow 0 80425) 80373)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon12_correct  (=> (and (= $abort_code@17 $abort_code@2) (= (ControlFlow 0 80199) 80207)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 80197) 80199)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon12_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon88_Then_correct  (=> (= (ControlFlow 0 80215) 80199) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon12_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon87_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t15@1)) (= $abort_code@2 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 80191) 80215) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 80191) 80197) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon85_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 80179) 80425) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 80179) 80191) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon4$4_correct  (=> (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t15@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| inline$$ReadRef$0$v@1)))) (=> (and (and (and (= inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$$t16@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0)) (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 80173) 85385) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 80173) 80179) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon85_Else_correct))))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 80133) 80173)) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon4$4_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $AccountLimits_Window_limit_address) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $AccountLimits_Window_limit_address))) (= (ControlFlow 0 80095) 80133))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 12) $EmptyPath receiving)) (= (ControlFlow 0 79935) 80095)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 79817) 79935)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon84_Then_correct  (=> (= (ControlFlow 0 85409) 79935) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon83_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 79809) 85409) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 79809) 79817) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon83_Then_correct  (and (=> (= (ControlFlow 0 85417) 85409) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 85417) 79817) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon84_Else_correct))))
(let ((inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 79803) 85417) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 79803) 79809) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon83_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))
))) (=> (and (and (forall (($inv_addr@@1 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((window_addr T@$Value) )  (=> ((_ is $Address) window_addr) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 85425) 79803))) inline$$AccountLimits_can_receive_and_update_window_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) (=> (and (and (and (and (and (and (and (and ((_ is $Vector) receiving) (let ((va@@12 (|v#$Vector| receiving)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| receiving)) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| receiving)) $AccountLimits_Window_limit_address))) (= (ControlFlow 0 78173) 85425)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 123716) 78173) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@2 () T@$TypeValue)
(declare-fun sending () T@$Value)
(declare-fun $abort_flag@11@@0 () Bool)
(declare-fun amount@@0 () T@$Value)
(declare-fun $abort_code@15@@0 () Int)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t18@1 () T@$Value)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_code@13@@0 () Int)
(declare-fun $abort_flag@10@@0 () Bool)
(declare-fun inline$$Le$1$dst@1@@0 () T@$Value)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t10@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@2@@0| () T@$Value)
(declare-fun $abort_code@12@@0 () Int)
(declare-fun $abort_flag@9@@0 () Bool)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@1@@0| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$8$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$tmp#$8@1| () T@$Value)
(declare-fun inline$$BorrowField$8$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1@@0 () Int)
(declare-fun inline$$BorrowField$8$p@2@@0 () T@$Path)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t34@1 () T@$Value)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun inline$$Ge$0$dst@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@2@@0 () T@$Value)
(declare-fun $abort_flag@8@@0 () Bool)
(declare-fun $abort_code@11@@0 () Int)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$1$vdst'@1@@0| () T@$Value)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_code@14@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun inline$$Sub$1$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$7$v@1@@0 () T@$Value)
(declare-fun inline$$Sub$1$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$7$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1@@0 () Int)
(declare-fun inline$$BorrowField$7$p@2@@0 () T@$Path)
(declare-fun inline$$ReadRef$6$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$6$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1@@0 () Int)
(declare-fun inline$$BorrowField$6$p@2@@0 () T@$Path)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$5$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$1$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$5$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@0 () Int)
(declare-fun inline$$BorrowField$5$p@2@@0 () T@$Path)
(declare-fun inline$$AddU64$1$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1@@0 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@0 () Int)
(declare-fun inline$$BorrowField$4$p@2@@0 () T@$Path)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@0 () Int)
(declare-fun inline$$BorrowField$3$p@2@@0 () T@$Path)
(declare-fun inline$$Le$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@0 () T@$Value)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@0 () Int)
(declare-fun inline$$BorrowField$2$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun call5formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 130646) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 92588) (- 0 135686)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)))))))) $abort_flag@11@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)))))))) $abort_flag@11@@0) (and (=> (= (ControlFlow 0 92588) (- 0 135721)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@55 (|l#$ValueArray| (let ((len@@56 (|l#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1)))) len@@56 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@56 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@56 (|l#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1)))) len@@56 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@56 1)))) len@@55 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@55 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@11@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@55 (|l#$ValueArray| (let ((len@@56 (|l#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1)))) len@@56 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@56 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@56 (|l#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1)))) len@@56 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@56 1)))) len@@55 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@55 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@11@@0) (and (=> (= (ControlFlow 0 92588) (- 0 135784)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@11@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@11@@0) (and (=> (= (ControlFlow 0 92588) (- 0 135849)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@11@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@11@@0) (and (=> (= (ControlFlow 0 92588) (- 0 135886)) (=> $abort_flag@11@@0 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@60 (|l#$ValueArray| (let ((len@@61 (|l#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1)))) len@@61 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@61 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@61 (|l#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1)))) len@@61 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@61 1)))) len@@60 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@60 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (=> (=> $abort_flag@11@@0 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@60 (|l#$ValueArray| (let ((len@@61 (|l#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1)))) len@@61 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@61 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@61 (|l#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1)))) len@@61 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@61 1)))) len@@60 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@60 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (=> (= (ControlFlow 0 92588) (- 0 136083)) (=> $abort_flag@11@@0 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@65 (|l#$ValueArray| (let ((len@@66 (|l#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1)))) len@@66 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@66 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@66 (|l#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1)))) len@@66 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@66 1)))) len@@65 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@65 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@11@@0 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@65 (|l#$ValueArray| (let ((len@@66 (|l#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1)))) len@@66 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@66 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@66 (|l#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1)))) len@@66 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@66 1)))) len@@65 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@65 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 92588) (- 0 136324)) (=> (not $abort_flag@11@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@70 (|l#$ValueArray| (let ((len@@71 (|l#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1)))) len@@71 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@71 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@71 (|l#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1)))) len@@71 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@71 1)))) len@@70 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@70 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow)))))))))))) (=> (=> (not $abort_flag@11@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@70 (|l#$ValueArray| (let ((len@@71 (|l#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1)))) len@@71 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@71 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@71 (|l#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1)))) len@@71 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@71 1)))) len@@70 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@70 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))) (=> (= (ControlFlow 0 92588) (- 0 136348)) (=> (not $abort_flag@11@@0) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))))))))) ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) sending))) $AccountLimits_Window_window_outflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) sending))))))) $AccountLimits_Window_tracked_balance (ite (|b#$Boolean| ($Boolean (>= (|i#$Integer| amount@@0) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) sending))) $AccountLimits_Window_tracked_balance))))) ($Integer 0) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) sending))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@0))))) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) sending))) $AccountLimits_Window_window_outflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) sending))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@0)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) sending))))))))))) ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@2 (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@80 (|l#$ValueArray| (let ((len@@81 (|l#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1)))) len@@81 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@81 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@81 (|l#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1)))) len@@81 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (+ len@@81 1)))) len@@80 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address)) (+ len@@80 1)))) sending)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@2 sending)))))))))))))))))))))))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon28_correct  (=> (= $abort_code@15@@0 $abort_code@4@@0) (=> (and (and (= $abort_flag@11@@0 $abort_flag@2@@0) (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@2 inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t18@1)) (and (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@2 sending) (= (ControlFlow 0 92478) 92588))) anon0$2_correct@@0))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 92476) 92478)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon28_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon84_Then_correct  (=> (= (ControlFlow 0 92486) 92478) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon28_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon83_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 92466) 92486) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 92466) 92476) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon83_Then_correct  (and (=> (= (ControlFlow 0 92494) 92486) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 92494) 92476) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon84_Else_correct))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon82_Then_correct  (=> (and (|b#$Boolean| call4formal@$ret0@0@@0) (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t18@1 ($Boolean true))) (and (=> (= (ControlFlow 0 92460) 92494) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 92460) 92466) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon70_correct  (=> (= $abort_code@15@@0 $abort_code@13@@0) (=> (and (and (= $abort_flag@11@@0 $abort_flag@10@@0) (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@2 inline$$Le$1$dst@1@@0)) (and (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@2 inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t10@1) (= (ControlFlow 0 90199) 92588))) anon0$2_correct@@0))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon105_Else_correct  (=> (and (not true) (= (ControlFlow 0 90197) 90199)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon70_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon105_Then_correct  (=> (= (ControlFlow 0 90207) 90199) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon70_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon104_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 90187) 90207) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 90187) 90197) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon105_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon104_Then_correct  (and (=> (= (ControlFlow 0 90215) 90207) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 90215) 90197) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon105_Else_correct))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$L13$4_correct  (=> (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t10@1 |inline$$WritebackToValue$2$vdst'@2@@0|) (=> (and (= $abort_code@13@@0 $abort_code@12@@0) (= $abort_flag@10@@0 $abort_flag@9@@0)) (and (=> (= (ControlFlow 0 92252) 90215) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 92252) 90187) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon104_Else_correct))))))
(let ((inline$$WritebackToValue$2$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) ($Local 10))) (=> (and (= |inline$$WritebackToValue$2$vdst'@2@@0| sending) (= (ControlFlow 0 92218) 92252)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$L13$4_correct))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) ($Local 10)) (= |inline$$WritebackToValue$2$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 sending (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)))) (and (= |inline$$WritebackToValue$2$vdst'@2@@0| |inline$$WritebackToValue$2$vdst'@1@@0|) (= (ControlFlow 0 92244) 92252))) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$L13$4_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (and (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 92063) 92244) inline$$WritebackToValue$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 92063) 92218) inline$$WritebackToValue$2$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (and (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@0|)))) (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|))) (and (=> (= (ControlFlow 0 92119) 92244) inline$$WritebackToValue$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 92119) 92218) inline$$WritebackToValue$2$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (and (=> (= (ControlFlow 0 92027) 92119) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 92027) 92063) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$2$anon0_correct@@0  (=> (and (= |inline$$WriteRef$2$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$8$dst@1@@0) (|p#$Mutation| inline$$BorrowField$8$dst@1@@0) |inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$tmp#$8@1|)) (= (ControlFlow 0 91884) 92027)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$BorrowField$8$anon0_correct@@0  (=> (= inline$$BorrowField$8$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$8$size@1@@0 (|size#$Path| inline$$BorrowField$8$p@1@@0)) (= inline$$BorrowField$8$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1@@0) inline$$BorrowField$8$size@1@@0 $AccountLimits_Window_tracked_balance) (+ inline$$BorrowField$8$size@1@@0 1)))) (and (= inline$$BorrowField$8$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$BorrowField$8$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) $AccountLimits_Window_tracked_balance))) (= (ControlFlow 0 91825) 91884))) inline$$WriteRef$2$anon0_correct@@0))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon60_correct  (=> (and (and (= |inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$tmp#$8@1| inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t34@1) (= $abort_flag@9@@0 $abort_flag@7@@0)) (and (= $abort_code@12@@0 $abort_code@10@@0) (= (ControlFlow 0 92332) 91825))) inline$$BorrowField$8$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon100_Else_correct  (=> (and (not true) (= (ControlFlow 0 92330) 92332)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon60_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon100_Then_correct  (=> (= (ControlFlow 0 92340) 92332) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon60_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon99_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1) (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t34@1 ($Integer 0))) (and (=> (= (ControlFlow 0 92322) 92340) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 92322) 92330) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon100_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon66_correct  (=> (and (and (= |inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$tmp#$8@1| inline$$Sub$1$dst@2@@0) (= $abort_flag@9@@0 $abort_flag@8@@0)) (and (= $abort_code@12@@0 $abort_code@11@@0) (= (ControlFlow 0 91707) 91825))) inline$$BorrowField$8$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon103_Else_correct  (=> (and (not true) (= (ControlFlow 0 91705) 91707)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon66_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon103_Then_correct  (=> (= (ControlFlow 0 92260) 91707) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon66_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon101_Else_correct  (=> (not $abort_flag@8@@0) (and (=> (= (ControlFlow 0 91699) 92260) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon103_Then_correct) (=> (= (ControlFlow 0 91699) 91705) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon103_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon96_Else$1_correct  (=> (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t10@1 |inline$$WritebackToValue$1$vdst'@2|) (=> (and (= $abort_code@13@@0 $abort_code@9@@0) (= $abort_flag@10@@0 $abort_flag@6@@0)) (and (=> (= (ControlFlow 0 90177) 90215) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 90177) 90187) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon104_Else_correct))))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 10))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| sending) (= (ControlFlow 0 90143) 90177)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon96_Else$1_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 10)) (= |inline$$WritebackToValue$1$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|) 0 sending (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1@@0|) (= (ControlFlow 0 90169) 90177))) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon96_Else$1_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon96_Else_correct  (=> (not (|b#$Boolean| inline$$Le$1$dst@1@@0)) (and (=> (= (ControlFlow 0 90175) 90169) inline$$WritebackToValue$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 90175) 90143) inline$$WritebackToValue$1$anon3_Else_correct@@0)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct  (=> (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@1 $Error) (=> (and (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@1 $Error) (= $abort_code@15@@0 $abort_code@14@@0)) (=> (and (and (= $abort_flag@11@@0 true) (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@2 inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret0@1)) (and (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@2 inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$ret1@1) (= (ControlFlow 0 88363) 92588))) anon0$2_correct@@0)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon7_correct  (=> (and (= $abort_code@14@@0 $abort_code@1@@0) (= (ControlFlow 0 92554) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 92552) 92554)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon7_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 92562) 92554) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon7_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon73_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 92546) 92562) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 92546) 92552) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon15_correct  (=> (and (= $abort_code@14@@0 $abort_code@3@@0) (= (ControlFlow 0 92534) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 92532) 92534)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon15_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon78_Then_correct  (=> (= (ControlFlow 0 92542) 92534) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon15_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon77_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 92526) 92542) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 92526) 92532) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon21_correct  (=> (and (= $abort_code@14@@0 $abort_code@4@@0) (= (ControlFlow 0 92506) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 92504) 92506)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon81_Then_correct  (=> (= (ControlFlow 0 92514) 92506) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon80_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 92498) 92514) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 92498) 92504) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon31_correct  (=> (and (= $abort_code@14@@0 $abort_code@5@@0) (= (ControlFlow 0 92440) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 92438) 92440)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon31_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon86_Then_correct  (=> (= (ControlFlow 0 92448) 92440) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon31_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon85_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 92432) 92448) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 92432) 92438) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon35_correct  (=> (and (= $abort_code@14@@0 $abort_code@6@@0) (= (ControlFlow 0 92420) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 92418) 92420)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon35_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon88_Then_correct  (=> (= (ControlFlow 0 92428) 92420) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon35_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon87_Then_correct  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 92412) 92428) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 92412) 92418) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon39_correct  (=> (and (= $abort_code@14@@0 $abort_code@7@@0) (= (ControlFlow 0 92400) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon90_Else_correct  (=> (and (not true) (= (ControlFlow 0 92398) 92400)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon39_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon90_Then_correct  (=> (= (ControlFlow 0 92408) 92400) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon39_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon89_Then_correct  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 92392) 92408) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 92392) 92398) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon47_correct  (=> (and (= $abort_code@14@@0 $abort_code@9@@0) (= (ControlFlow 0 92380) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 92378) 92380)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon47_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon94_Then_correct  (=> (= (ControlFlow 0 92388) 92380) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon47_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon93_Then_correct  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 92372) 92388) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 92372) 92378) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon55_correct  (=> (and (= $abort_code@14@@0 $abort_code@10@@0) (= (ControlFlow 0 92352) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon98_Else_correct  (=> (and (not true) (= (ControlFlow 0 92350) 92352)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon55_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon98_Then_correct  (=> (= (ControlFlow 0 92360) 92352) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon55_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon97_Then_correct  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 92344) 92360) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 92344) 92350) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon98_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon63_correct  (=> (and (= $abort_code@14@@0 $abort_code@11@@0) (= (ControlFlow 0 92272) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon102_Else_correct  (=> (and (not true) (= (ControlFlow 0 92270) 92272)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon63_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon102_Then_correct  (=> (= (ControlFlow 0 92280) 92272) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon63_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon101_Then_correct  (=> $abort_flag@8@@0 (and (=> (= (ControlFlow 0 92264) 92280) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 92264) 92270) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon102_Else_correct)))))
(let ((inline$$Sub$1$anon3_Then$1_correct@@0  (=> (= $abort_flag@8@@0 true) (=> (and (= $abort_code@11@@0 $EXEC_FAILURE_CODE) (= inline$$Sub$1$dst@2@@0 inline$$Sub$1$dst@0@@0)) (and (=> (= (ControlFlow 0 91685) 92264) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 91685) 91699) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon101_Else_correct))))))
(let ((inline$$Sub$1$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$ReadRef$7$v@1@@0) (|i#$Integer| amount@@0)) (= (ControlFlow 0 91683) 91685)) inline$$Sub$1$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$1$anon3_Else_correct@@0  (=> (<= (|i#$Integer| amount@@0) (|i#$Integer| inline$$ReadRef$7$v@1@@0)) (=> (and (and (= inline$$Sub$1$dst@1@@0 ($Integer (- (|i#$Integer| inline$$ReadRef$7$v@1@@0) (|i#$Integer| amount@@0)))) (= $abort_flag@8@@0 $abort_flag@7@@0)) (and (= $abort_code@11@@0 $abort_code@10@@0) (= inline$$Sub$1$dst@2@@0 inline$$Sub$1$dst@1@@0))) (and (=> (= (ControlFlow 0 91631) 92264) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 91631) 91699) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon101_Else_correct))))))
(let ((inline$$Sub$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 91605) (- 0 134991)) true) (and (=> (= (ControlFlow 0 91605) 91683) inline$$Sub$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 91605) 91631) inline$$Sub$1$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$7$anon0_correct@@0  (=> (and (= inline$$ReadRef$7$v@1@@0 (|v#$Mutation| inline$$BorrowField$7$dst@1@@0)) (= (ControlFlow 0 91506) 91605)) inline$$Sub$1$Entry_correct@@0)))
(let ((inline$$BorrowField$7$anon0_correct@@0  (=> (= inline$$BorrowField$7$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$7$size@1@@0 (|size#$Path| inline$$BorrowField$7$p@1@@0)) (= inline$$BorrowField$7$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1@@0) inline$$BorrowField$7$size@1@@0 $AccountLimits_Window_tracked_balance) (+ inline$$BorrowField$7$size@1@@0 1)))) (and (= inline$$BorrowField$7$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$BorrowField$7$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) $AccountLimits_Window_tracked_balance))) (= (ControlFlow 0 91468) 91506))) inline$$ReadRef$7$anon0_correct@@0))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon99_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1)) (= (ControlFlow 0 91520) 91468)) inline$$BorrowField$7$anon0_correct@@0)))
(let ((inline$$Ge$0$anon0_correct  (=> (= inline$$Ge$0$dst@1 ($Boolean (>= (|i#$Integer| amount@@0) (|i#$Integer| inline$$ReadRef$6$v@1@@0)))) (and (=> (= (ControlFlow 0 91300) 92322) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 91300) 91520) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon99_Else_correct)))))
(let ((inline$$Ge$0$Entry_correct  (and (=> (= (ControlFlow 0 91286) (- 0 134846)) true) (=> (= (ControlFlow 0 91286) 91300) inline$$Ge$0$anon0_correct))))
(let ((inline$$ReadRef$6$anon0_correct@@0  (=> (and (= inline$$ReadRef$6$v@1@@0 (|v#$Mutation| inline$$BorrowField$6$dst@1@@0)) (= (ControlFlow 0 91228) 91286)) inline$$Ge$0$Entry_correct)))
(let ((inline$$BorrowField$6$anon0_correct@@0  (=> (= inline$$BorrowField$6$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$6$size@1@@0 (|size#$Path| inline$$BorrowField$6$p@1@@0)) (= inline$$BorrowField$6$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1@@0) inline$$BorrowField$6$size@1@@0 $AccountLimits_Window_tracked_balance) (+ inline$$BorrowField$6$size@1@@0 1)))) (and (= inline$$BorrowField$6$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$BorrowField$6$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) $AccountLimits_Window_tracked_balance))) (= (ControlFlow 0 91190) 91228))) inline$$ReadRef$6$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WriteRef$0$to'@1@@0|) (= (ControlFlow 0 90974) 91190)) inline$$BorrowField$6$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 91030) 91190))) inline$$BorrowField$6$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|))) (and (=> (= (ControlFlow 0 90938) 91030) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 90938) 90974) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (and (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1@@0) (|p#$Mutation| inline$$BorrowField$5$dst@1@@0) inline$$AddU64$1$dst@2@@0)) (= (ControlFlow 0 90795) 90938)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$BorrowField$5$anon0_correct@@0  (=> (= inline$$BorrowField$5$p@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (=> (and (and (= inline$$BorrowField$5$size@1@@0 (|size#$Path| inline$$BorrowField$5$p@1@@0)) (= inline$$BorrowField$5$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@0) inline$$BorrowField$5$size@1@@0 $AccountLimits_Window_window_outflow) (+ inline$$BorrowField$5$size@1@@0 1)))) (and (= inline$$BorrowField$5$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) inline$$BorrowField$5$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))) $AccountLimits_Window_window_outflow))) (= (ControlFlow 0 90736) 90795))) inline$$WriteRef$1$anon0_correct@@0))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon97_Else_correct  (=> (and (not $abort_flag@7@@0) (= (ControlFlow 0 90742) 90736)) inline$$BorrowField$5$anon0_correct@@0)))
(let ((inline$$AddU64$1$anon3_Then$1_correct@@0  (=> (= $abort_code@10@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7@@0 true) (= inline$$AddU64$1$dst@2@@0 inline$$AddU64$1$dst@0@@0)) (and (=> (= (ControlFlow 0 90606) 92344) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 90606) 90742) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon97_Else_correct))))))
(let ((inline$$AddU64$1$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$5$v@1@@0) (|i#$Integer| amount@@0)) $MAX_U64) (= (ControlFlow 0 90604) 90606)) inline$$AddU64$1$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$1$anon3_Else_correct@@0  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$5$v@1@@0) (|i#$Integer| amount@@0))) (=> (and (and (= inline$$AddU64$1$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$5$v@1@@0) (|i#$Integer| amount@@0)))) (= $abort_code@10@@0 $abort_code@9@@0)) (and (= $abort_flag@7@@0 $abort_flag@6@@0) (= inline$$AddU64$1$dst@2@@0 inline$$AddU64$1$dst@1@@0))) (and (=> (= (ControlFlow 0 90548) 92344) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 90548) 90742) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon97_Else_correct))))))
(let ((inline$$AddU64$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 90518) (- 0 134436)) true) (and (=> (= (ControlFlow 0 90518) 90604) inline$$AddU64$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 90518) 90548) inline$$AddU64$1$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$5$anon0_correct@@0  (=> (and (= inline$$ReadRef$5$v@1@@0 (|v#$Mutation| inline$$BorrowField$4$dst@1@@0)) (= (ControlFlow 0 90411) 90518)) inline$$AddU64$1$Entry_correct@@0)))
(let ((inline$$BorrowField$4$anon0_correct@@0  (=> (= inline$$BorrowField$4$p@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (=> (and (and (= inline$$BorrowField$4$size@1@@0 (|size#$Path| inline$$BorrowField$4$p@1@@0)) (= inline$$BorrowField$4$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@0) inline$$BorrowField$4$size@1@@0 $AccountLimits_Window_window_outflow) (+ inline$$BorrowField$4$size@1@@0 1)))) (and (= inline$$BorrowField$4$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) inline$$BorrowField$4$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))) $AccountLimits_Window_window_outflow))) (= (ControlFlow 0 90373) 90411))) inline$$ReadRef$5$anon0_correct@@0))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon96_Then_correct  (=> (and (|b#$Boolean| inline$$Le$1$dst@1@@0) (= (ControlFlow 0 90425) 90373)) inline$$BorrowField$4$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon95_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 90042) 90425) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 90042) 90175) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon95_Then_correct  (and (=> (= (ControlFlow 0 92368) 90425) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 92368) 90175) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon96_Else_correct))))
(let ((inline$$Le$1$anon0_correct@@0  (=> (= inline$$Le$1$dst@1@@0 ($Boolean (<= (|i#$Integer| inline$$AddU64$0$dst@2@@0) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0)))) (and (=> (= (ControlFlow 0 90028) 92368) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 90028) 90042) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$Le$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 90014) (- 0 134234)) true) (=> (= (ControlFlow 0 90014) 90028) inline$$Le$1$anon0_correct@@0))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $AccountLimits_LimitsDefinition_max_outflow)) (= (ControlFlow 0 89964) 90014)) inline$$Le$1$Entry_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon93_Else_correct  (=> (and (not $abort_flag@6@@0) (= (ControlFlow 0 89970) 89964)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@6@@0 true) (=> (and (= $abort_code@9@@0 $EXEC_FAILURE_CODE) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 89910) 92372) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 89910) 89970) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon93_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$4$v@1@@0) (|i#$Integer| amount@@0)) $MAX_U64) (= (ControlFlow 0 89908) 89910)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$4$v@1@@0) (|i#$Integer| amount@@0))) (=> (and (and (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$4$v@1@@0) (|i#$Integer| amount@@0)))) (= $abort_flag@6@@0 $abort_flag@5@@0)) (and (= $abort_code@9@@0 $abort_code@7@@0) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 89852) 92372) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 89852) 89970) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon93_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 89822) (- 0 134118)) true) (and (=> (= (ControlFlow 0 89822) 89908) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 89822) 89852) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$4$anon0_correct@@0  (=> (and (= inline$$ReadRef$4$v@1@@0 (|v#$Mutation| inline$$BorrowField$3$dst@1@@0)) (= (ControlFlow 0 89715) 89822)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$BorrowField$3$anon0_correct@@0  (=> (= inline$$BorrowField$3$p@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (=> (and (and (= inline$$BorrowField$3$size@1@@0 (|size#$Path| inline$$BorrowField$3$p@1@@0)) (= inline$$BorrowField$3$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@0) inline$$BorrowField$3$size@1@@0 $AccountLimits_Window_window_outflow) (+ inline$$BorrowField$3$size@1@@0 1)))) (and (= inline$$BorrowField$3$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) inline$$BorrowField$3$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))) $AccountLimits_Window_window_outflow))) (= (ControlFlow 0 89677) 89715))) inline$$ReadRef$4$anon0_correct@@0))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon91_Then_correct  (=> (and (|b#$Boolean| inline$$Le$0$dst@1@@0) (= (ControlFlow 0 89729) 89677)) inline$$BorrowField$3$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon44_correct  (=> (and (= $abort_code@14@@0 $abort_code@8@@0) (= (ControlFlow 0 89511) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 89509) 89511)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon44_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon92_Then_correct  (=> (= (ControlFlow 0 89519) 89511) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon44_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon91_Else$1_correct  (=> (= $abort_code@8@@0 (|i#$Integer| call3formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 89503) 89519) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 89503) 89509) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 10))) (= (ControlFlow 0 89465) 89503)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon91_Else$1_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) ($Local 10)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|) 0 sending (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))) (= (ControlFlow 0 89491) 89503)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon91_Else$1_correct))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon91_Else_correct  (=> (not (|b#$Boolean| inline$$Le$0$dst@1@@0)) (and (=> (= (ControlFlow 0 89497) 89491) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 89497) 89465) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon89_Else_correct  (=> (not $abort_flag@5@@0) (and (=> (= (ControlFlow 0 89366) 89729) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 89366) 89497) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon87_Else$1_correct  (=> (and (and (and (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t24@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@0)) (and (=> $abort_flag@5@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 89360) 92392) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 89360) 89366) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$Le$0$anon0_correct@@0  (=> (and (= inline$$Le$0$dst@1@@0 ($Boolean (<= (|i#$Integer| inline$$ReadRef$3$v@1@@0) (|i#$Integer| inline$$Sub$0$dst@2@@0)))) (= (ControlFlow 0 89348) 89360)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon87_Else$1_correct)))
(let ((inline$$Le$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 89334) (- 0 133847)) true) (=> (= (ControlFlow 0 89334) 89348) inline$$Le$0$anon0_correct@@0))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon87_Else_correct  (=> (and (not $abort_flag@4@@0) (= (ControlFlow 0 89354) 89334)) inline$$Le$0$Entry_correct@@0)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@0  (=> (= $abort_code@6@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4@@0 true) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@0@@0)) (and (=> (= (ControlFlow 0 89278) 92412) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 89278) 89354) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon87_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t21@1) (|i#$Integer| amount@@0)) (= (ControlFlow 0 89276) 89278)) inline$$Sub$0$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$0$anon3_Else_correct@@0  (=> (<= (|i#$Integer| amount@@0) (|i#$Integer| inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t21@1)) (=> (and (and (= inline$$Sub$0$dst@1@@0 ($Integer (- (|i#$Integer| inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t21@1) (|i#$Integer| amount@@0)))) (= $abort_code@6@@0 $abort_code@5@@0)) (and (= $abort_flag@4@@0 $abort_flag@3@@0) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@1@@0))) (and (=> (= (ControlFlow 0 89224) 92412) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 89224) 89354) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon87_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 89198) (- 0 133759)) true) (and (=> (= (ControlFlow 0 89198) 89276) inline$$Sub$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 89198) 89224) inline$$Sub$0$anon3_Else_correct@@0)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon85_Else$2_correct  (=> (and (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t21@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 89284) 89198)) inline$$Sub$0$Entry_correct@@0)))
(let ((inline$$ReadRef$3$anon0_correct@@0  (=> (and (= inline$$ReadRef$3$v@1@@0 (|v#$Mutation| inline$$BorrowField$2$dst@1@@0)) (= (ControlFlow 0 89095) 89284)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon85_Else$2_correct)))
(let ((inline$$BorrowField$2$anon0_correct@@0  (=> (= inline$$BorrowField$2$p@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (=> (and (and (= inline$$BorrowField$2$size@1@@0 (|size#$Path| inline$$BorrowField$2$p@1@@0)) (= inline$$BorrowField$2$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@0) inline$$BorrowField$2$size@1@@0 $AccountLimits_Window_window_outflow) (+ inline$$BorrowField$2$size@1@@0 1)))) (and (= inline$$BorrowField$2$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|) inline$$BorrowField$2$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))) $AccountLimits_Window_window_outflow))) (= (ControlFlow 0 89057) 89095))) inline$$ReadRef$3$anon0_correct@@0))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (and (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0) call5formal@$ret0@0@@0)) (= (ControlFlow 0 88897) 89057)) inline$$BorrowField$2$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon85_Else_correct  (=> (and (not $abort_flag@3@@0) (= (ControlFlow 0 88903) 88897)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon82_Else$1_correct  (and (=> (= (ControlFlow 0 88840) (- 0 133401)) true) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@3@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@0) (=> $abort_flag@3@@0 (or (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (=> $abort_flag@3@@0 (or (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@5@@0 (|i#$Integer| ($Integer 8)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@0 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call5formal@$ret0@0@@0 (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@85 (|l#$ValueArray| (let ((len@@86 (|l#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1)))) len@@86 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $AccountLimits_Window_tracked_balance)) (+ len@@86 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@86 (|l#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1)))) len@@86 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $AccountLimits_Window_tracked_balance)) (+ len@@86 1)))) len@@85 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $AccountLimits_Window_limit_address)) (+ len@@85 1)))) inline$$ReadRef$2$v@1@@0))))))) (=> (and (and (and (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@0) (let ((va@@13 (|v#$Vector| call5formal@$ret0@0@@0)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $AccountLimits_Window_limit_address))) (and (=> (= (ControlFlow 0 88840) 92432) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 88840) 88903) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon85_Else_correct))))))))
(let ((inline$$ReadRef$2$anon0_correct@@0  (=> (and (= inline$$ReadRef$2$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 88828) 88840)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon82_Else$1_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon82_Else_correct  (=> (and (not (|b#$Boolean| call4formal@$ret0@0@@0)) (= (ControlFlow 0 88834) 88828)) inline$$ReadRef$2$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon80_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 88790) 92460) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 88790) 88834) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon18_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@0) (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) ((_ is $Boolean) call4formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 88784) 92498) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 88784) 88790) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 88782) 88784)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon18_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon79_Then_correct  (=> (= (ControlFlow 0 92522) 88784) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon18_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon77_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 88776) 92522) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 88776) 88782) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@1@@0 true) (=> (and (= $abort_code@3@@0 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 88762) 92526) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 88762) 88776) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon77_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$GetGlobal$0$ta@0@@0 inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 88760) 88762)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$GetGlobal$0$ta@0@@0 inline$$GetGlobal$0$a@1@@0) (=> (and (and (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$GetGlobal$0$ta@0@@0 (|a#$Address| inline$$ReadRef$1$v@1@@0))) (= $abort_flag@1@@0 $abort_flag@0@@0)) (and (= $abort_code@3@@0 $abort_code@1@@0) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 88708) 92526) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 88708) 88776) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon77_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| inline$$ReadRef$1$v@1@@0)) (and (=> (= (ControlFlow 0 88690) 88760) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 88690) 88708) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (=> (= inline$$GetGlobal$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1)) (and (=> (= (ControlFlow 0 88684) (- 0 133207)) true) (=> (= (ControlFlow 0 88684) 88690) inline$$GetGlobal$0$anon0_correct@@0)))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1@@0)) (= (ControlFlow 0 88567) 88684)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $AccountLimits_Window_limit_address) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $AccountLimits_Window_limit_address))) (= (ControlFlow 0 88529) 88567))) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon75_Then_correct  (=> (and (|b#$Boolean| inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t13@1) (= (ControlFlow 0 88581) 88529)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon12_correct  (=> (and (= $abort_code@14@@0 $abort_code@2@@0) (= (ControlFlow 0 88355) 88363)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 88353) 88355)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon12_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 88371) 88355) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon12_correct)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon75_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t13@1)) (= $abort_code@2@@0 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 88347) 88371) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 88347) 88353) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon73_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 88335) 88581) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 88335) 88347) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon4$4_correct  (=> (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t13@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| inline$$ReadRef$0$v@1@@0)))) (=> (and (and (and (= inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$$t14@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0)) (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 88329) 92546) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 88329) 88335) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon73_Else_correct))))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 88289) 88329)) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon4$4_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $AccountLimits_Window_limit_address) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $AccountLimits_Window_limit_address))) (= (ControlFlow 0 88251) 88289))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 10) $EmptyPath sending)) (= (ControlFlow 0 88091) 88251)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 87973) 88091)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 92570) 88091) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon71_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 87965) 92570) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 87965) 87973) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon71_Then_correct  (and (=> (= (ControlFlow 0 92578) 92570) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 92578) 87973) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon72_Else_correct))))
(let ((inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 87959) 92578) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 87959) 87965) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon71_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))
))) (=> (and (and (forall (($inv_addr@@4 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((window_addr@@0 T@$Value) )  (=> ((_ is $Address) window_addr@@0) (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| window_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| window_addr@@0)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 92586) 87959))) inline$$AccountLimits_can_withdraw_and_update_window_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (and (and ((_ is $Integer) amount@@0) (>= (|i#$Integer| amount@@0) 0)) (<= (|i#$Integer| amount@@0) $MAX_U64)) (=> (and (and (and (and (and (and (and (and ((_ is $Vector) sending) (let ((va@@17 (|v#$Vector| sending)))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| sending)) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| sending)) $AccountLimits_Window_limit_address))) (= (ControlFlow 0 86524) 92586)) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 130646) 86524) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$AccountLimits_current_time_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun call2formal@$ret0@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun inline$$DiemTimestamp_is_genesis_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 136437) (let ((inline$$AccountLimits_current_time_$def_verify$0$Abort_correct true))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 94195) 94203)) inline$$AccountLimits_current_time_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 94211) 94203) inline$$AccountLimits_current_time_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 94189) 94211) inline$$AccountLimits_current_time_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 94189) 94195) inline$$AccountLimits_current_time_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon13_Then_correct  (=> (and $abort_flag@0@@1 (= (ControlFlow 0 94275) 94203)) inline$$AccountLimits_current_time_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon18_Else_correct true))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon18_Then_correct true))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 94261) 94185) inline$$AccountLimits_current_time_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 94261) 94175) inline$$AccountLimits_current_time_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 94271) 94185) inline$$AccountLimits_current_time_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 94271) 94175) inline$$AccountLimits_current_time_$def_verify$0$anon18_Else_correct))))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon14_Then_correct  (=> (and (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2) (= inline$$AccountLimits_current_time_$def_verify$0$$t2@1 ($Integer 0))) (and (=> (= (ControlFlow 0 94253) 94271) inline$$AccountLimits_current_time_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 94253) 94261) inline$$AccountLimits_current_time_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon16_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 94165) 94185) inline$$AccountLimits_current_time_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 94165) 94175) inline$$AccountLimits_current_time_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon14_Else_correct  (=> (not (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@1) (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@1@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (and (and ((_ is $Integer) call2formal@$ret0@0) (>= (|i#$Integer| call2formal@$ret0@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 94159) 94189) inline$$AccountLimits_current_time_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 94159) 94165) inline$$AccountLimits_current_time_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 94151) 94253) inline$$AccountLimits_current_time_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 94151) 94159) inline$$AccountLimits_current_time_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct  (=> (and (= $abort_flag@0@@1 false) (= inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2 inline$$Not$0$dst@1)) (and (=> (= (ControlFlow 0 94113) 94275) inline$$AccountLimits_current_time_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 94113) 94151) inline$$AccountLimits_current_time_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 94111) 94113)) inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct)))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 94121) 94113) inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct)))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$t1@1)))) (and (=> (= (ControlFlow 0 94095) 94121) inline$$DiemTimestamp_is_genesis_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 94095) 94111) inline$$DiemTimestamp_is_genesis_$def$0$anon6_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 94085) (- 0 136798)) true) (=> (= (ControlFlow 0 94085) 94095) inline$$Not$0$anon0_correct))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct  (=> (not false) (=> (and (= inline$$DiemTimestamp_is_genesis_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)))) (= (ControlFlow 0 94101) 94085)) inline$$Not$0$Entry_correct))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 94013) 94129) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 94013) 94101) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 94023) 94129) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 94023) 94101) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 94007) 94023) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 94007) 94013) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 94037) 94007)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$AccountLimits_current_time_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 94143) 94037)) inline$$DiemTimestamp_is_genesis_$def$0$anon0_correct)))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@18 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 94281) 94143)) inline$$AccountLimits_current_time_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (= (ControlFlow 0 136437) 94281) anon0$1_correct@@1)))
anon0_correct@@1))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun dr_account () T@$Value)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun inline$$AccountLimits_grant_mutation_capability_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$AccountLimits_grant_mutation_capability_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$AccountLimits_AccountLimitMutationCapability_pack$0$$struct@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 137034) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 95022) (- 0 138421)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2@@1) (and (=> (= (ControlFlow 0 95022) (- 0 138436)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@2@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@2@@1) (and (=> (= (ControlFlow 0 95022) (- 0 138457)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@1) (and (=> (= (ControlFlow 0 95022) (- 0 138486)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@2@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@2@@1) (and (=> (= (ControlFlow 0 95022) (- 0 138503)) (=> $abort_flag@2@@1 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))))) (=> (=> $abort_flag@2@@1 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> (= (ControlFlow 0 95022) (- 0 138582)) (=> $abort_flag@2@@1 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@4@@1 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@4@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@4@@1 (|i#$Integer| ($Integer 2)))))))))))))))))))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$Abort_correct  (=> (and (and (= inline$$AccountLimits_grant_mutation_capability_$def_verify$0$$ret0@1 $Error) (= $abort_flag@2@@1 true)) (and (= $abort_code@4@@1 $abort_code@3@@1) (= (ControlFlow 0 94978) 95022))) anon0$2_correct@@1)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon5_correct  (=> (and (= $abort_code@3@@1 $abort_code@1@@2) (= (ControlFlow 0 94998) 94978)) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 94996) 94998)) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon5_correct)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 95006) 94998) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon5_correct)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 94990) 95006) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 94990) 94996) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon9_correct  (=> (and (= $abort_code@3@@1 $abort_code@2@@1) (= (ControlFlow 0 94972) 94978)) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 94970) 94972)) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 94986) 94972) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 94964) 94986) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 94964) 94970) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon12_correct  (=> (= $abort_flag@2@@1 $abort_flag@1@@2) (=> (and (= $abort_code@4@@1 $abort_code@2@@1) (= (ControlFlow 0 94952) 95022)) anon0$2_correct@@1))))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 94950) 94952)) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon12_correct)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 94960) 94952) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon12_correct)))
(let ((inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 94928) 94960) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 94928) 94950) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 94934) 94960) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 94934) 94950) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon18_Else_correct))))
(let ((inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 94922) 94934) inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 94922) 94928) inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon4_Else_correct)))))
(let ((inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 94914) 94960) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 94914) 94950) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$$t2@1) (= inline$$AccountLimits_AccountLimitMutationCapability_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$AccountLimits_grant_mutation_capability_$def_verify$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 94906) 94922) inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 94906) 94914) inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon3_Else_correct)))))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon16_Else_correct  (=> (not $abort_flag@1@@2) (=> (and (= inline$$AccountLimits_grant_mutation_capability_$def_verify$0$$t2@1 ($Boolean false)) (= (ControlFlow 0 94940) 94906)) inline$$AccountLimits_AccountLimitMutationCapability_pack$0$anon0_correct))))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon14_Else_correct  (=> (not $abort_flag@0@@2) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1@@2) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@1@@2)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@1@@2) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1@@2)) (and (=> $abort_flag@1@@2 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@1@@2 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 94772) 94964) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 94772) 94940) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon16_Else_correct)))))))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0@@2) (=> (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 94766) 94990) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 94766) 94772) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 94730) 94766)) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 95014) 94766) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 94724) 95014) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 94724) 94730) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@19 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 95020) 94724))) inline$$AccountLimits_grant_mutation_capability_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 94418) 95020)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 137034) 94418) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$AccountLimits_has_limits_published_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $tv0@@3 () T@$TypeValue)
(declare-fun addr () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 138711) (let ((inline$$AccountLimits_has_limits_published_$def_verify$0$anon6_Else_correct true))
(let ((inline$$AccountLimits_has_limits_published_$def_verify$0$anon6_Then_correct true))
(let ((inline$$AccountLimits_has_limits_published_$def_verify$0$anon2$1_correct  (=> (= inline$$AccountLimits_has_limits_published_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| addr)))) (and (=> (= (ControlFlow 0 95472) 95488) inline$$AccountLimits_has_limits_published_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 95472) 95478) inline$$AccountLimits_has_limits_published_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$AccountLimits_has_limits_published_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 95414) 95472)) inline$$AccountLimits_has_limits_published_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountLimits_has_limits_published_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 95496) 95472) inline$$AccountLimits_has_limits_published_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountLimits_has_limits_published_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 95408) 95496) inline$$AccountLimits_has_limits_published_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 95408) 95414) inline$$AccountLimits_has_limits_published_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@8 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8)) (let ((va@@21 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((window_addr@@1 T@$Value) )  (=> ((_ is $Address) window_addr@@1) (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| window_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| window_addr@@1)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 95502) 95408)) inline$$AccountLimits_has_limits_published_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@3  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 95122) 95502)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 138711) 95122) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@2))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$AccountLimits_has_window_published_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $tv0@@4 () T@$TypeValue)
(declare-fun addr@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 138998) (let ((anon0$2_correct@@2  (=> (= (ControlFlow 0 95986) (- 0 139299)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_has_window_published_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| addr@@0))))))))))
(let ((inline$$AccountLimits_has_window_published_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 95960) 95986)) anon0$2_correct@@2)))
(let ((inline$$AccountLimits_has_window_published_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 95970) 95986) anon0$2_correct@@2)))
(let ((inline$$AccountLimits_has_window_published_$def_verify$0$anon2$1_correct  (=> (= inline$$AccountLimits_has_window_published_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| addr@@0)))) (and (=> (= (ControlFlow 0 95954) 95970) inline$$AccountLimits_has_window_published_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 95954) 95960) inline$$AccountLimits_has_window_published_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$AccountLimits_has_window_published_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 95896) 95954)) inline$$AccountLimits_has_window_published_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountLimits_has_window_published_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 95978) 95954) inline$$AccountLimits_has_window_published_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountLimits_has_window_published_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 95890) 95978) inline$$AccountLimits_has_window_published_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 95890) 95896) inline$$AccountLimits_has_window_published_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (forall (($inv_addr@@9 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9)) (let ((va@@22 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((window_addr@@2 T@$Value) )  (=> ((_ is $Address) window_addr@@2) (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| window_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| window_addr@@2)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 95984) 95890)) inline$$AccountLimits_has_window_published_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) addr@@0) (= (ControlFlow 0 95604) 95984)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 138998) 95604) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@3)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$3@2| () T@$Value)
(declare-fun limits_def () T@$Value)
(declare-fun |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$3@1| () T@$Value)
(declare-fun inline$$AccountLimits_is_unrestricted_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@0 () T@$Value)
(declare-fun |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$2@2| () T@$Value)
(declare-fun inline$$AccountLimits_is_unrestricted_$def_verify$0$$t16@1 () T@$Value)
(declare-fun |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$2@1| () T@$Value)
(declare-fun inline$$AccountLimits_is_unrestricted_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$1@2| () T@$Value)
(declare-fun inline$$AccountLimits_is_unrestricted_$def_verify$0$$t13@1 () T@$Value)
(declare-fun |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$AccountLimits_is_unrestricted_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$3$dst@1 () T@$Value)
(declare-fun inline$$AccountLimits_is_unrestricted_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$AccountLimits_is_unrestricted_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$AccountLimits_is_unrestricted_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 139325) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 97280) (- 0 140090)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 97280) (- 0 140099)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 97280) (- 0 140108)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$3@2| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))))))))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 96984) 97280)) anon0$2_correct@@3)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 96994) 97280) anon0$2_correct@@3)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon18_correct  (=> (= |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$3@2| |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$3@1|) (and (=> (= (ControlFlow 0 97076) 96994) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 97076) 96984) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 97074) 97076)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon18_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 97084) 97076) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon18_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon30_Then$1_correct  (=> (and (= inline$$AccountLimits_is_unrestricted_$def_verify$0$$t15@1 ($Integer 86400000000)) (= |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$1$dst@1@@0 inline$$AccountLimits_is_unrestricted_$def_verify$0$$t15@1)))) (and (=> (= (ControlFlow 0 97068) 97084) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 97068) 97074) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$1$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_time_period)) (= (ControlFlow 0 97048) 97068)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon30_Then$1_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon30_Then_correct  (=> (and (|b#$Boolean| |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$2@2|) (= (ControlFlow 0 97054) 97048)) inline$$GetFieldFromValue$1$anon0_correct@@0)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon20_correct  (=> (= |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$3@2| inline$$AccountLimits_is_unrestricted_$def_verify$0$$t16@1) (and (=> (= (ControlFlow 0 96974) 96994) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 96974) 96984) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 96972) 96974)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon20_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 97002) 96974) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon20_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon30_Else_correct  (=> (and (not (|b#$Boolean| |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$2@2|)) (= inline$$AccountLimits_is_unrestricted_$def_verify$0$$t16@1 ($Boolean false))) (and (=> (= (ControlFlow 0 96964) 97002) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 96964) 96972) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon12_correct  (=> (= |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$2@2| |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$2@1|) (and (=> (= (ControlFlow 0 97166) 97054) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 97166) 96964) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 97164) 97166)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon12_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 97174) 97166) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon12_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon27_Then$1_correct  (=> (and (= inline$$AccountLimits_is_unrestricted_$def_verify$0$$t12@1 ($Integer 18446744073709551615)) (= |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$2@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$2$dst@1 inline$$AccountLimits_is_unrestricted_$def_verify$0$$t12@1)))) (and (=> (= (ControlFlow 0 97158) 97174) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 97158) 97164) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (and (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_holding)) (= (ControlFlow 0 97138) 97158)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon27_Then$1_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon27_Then_correct  (=> (and (|b#$Boolean| |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$1@2|) (= (ControlFlow 0 97144) 97138)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon14_correct  (=> (= |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$2@2| inline$$AccountLimits_is_unrestricted_$def_verify$0$$t13@1) (and (=> (= (ControlFlow 0 96918) 97054) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 96918) 96964) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 96916) 96918)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon14_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 97092) 96918) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon14_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon27_Else_correct  (=> (and (not (|b#$Boolean| |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$1@2|)) (= inline$$AccountLimits_is_unrestricted_$def_verify$0$$t13@1 ($Boolean false))) (and (=> (= (ControlFlow 0 96908) 97092) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 96908) 96916) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon6_correct  (=> (= |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$1@2| |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$1@1|) (and (=> (= (ControlFlow 0 97256) 97144) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 97256) 96908) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 97254) 97256)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon6_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 97264) 97256) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon6_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon24_Then$1_correct  (=> (and (= inline$$AccountLimits_is_unrestricted_$def_verify$0$$t9@1 ($Integer 18446744073709551615)) (= |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$1@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$3$dst@1 inline$$AccountLimits_is_unrestricted_$def_verify$0$$t9@1)))) (and (=> (= (ControlFlow 0 97248) 97264) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 97248) 97254) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$GetFieldFromValue$3$anon0_correct  (=> (and (= inline$$GetFieldFromValue$3$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_outflow)) (= (ControlFlow 0 97228) 97248)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon24_Then$1_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon24_Then_correct  (=> (and (|b#$Boolean| inline$$AccountLimits_is_unrestricted_$def_verify$0$$t7@1) (= (ControlFlow 0 97234) 97228)) inline$$GetFieldFromValue$3$anon0_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon8_correct  (=> (= |inline$$AccountLimits_is_unrestricted_$def_verify$0$tmp#$1@2| inline$$AccountLimits_is_unrestricted_$def_verify$0$$t10@1) (and (=> (= (ControlFlow 0 96862) 97144) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 96862) 96908) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 96860) 96862)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon8_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 97182) 96862) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon8_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon24_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountLimits_is_unrestricted_$def_verify$0$$t7@1)) (= inline$$AccountLimits_is_unrestricted_$def_verify$0$$t10@1 ($Boolean false))) (and (=> (= (ControlFlow 0 96852) 97182) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 96852) 96860) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon2$2_correct  (=> (and (= inline$$AccountLimits_is_unrestricted_$def_verify$0$$t6@1 ($Integer 18446744073709551615)) (= inline$$AccountLimits_is_unrestricted_$def_verify$0$$t7@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@1 inline$$AccountLimits_is_unrestricted_$def_verify$0$$t6@1)))) (and (=> (= (ControlFlow 0 96808) 97234) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 96808) 96852) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_inflow)) (= (ControlFlow 0 96788) 96808)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon2$2_correct)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 96712) 96788)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 97272) 96788) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$AccountLimits_is_unrestricted_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 96706) 97272) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 96706) 96712) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon23_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (forall (($inv_addr@@10 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((window_addr@@3 T@$Value) )  (=> ((_ is $Address) window_addr@@3) (|b#$Boolean| ($Boolean (forall ((coin_type@@3 T@$Value) )  (=> ((_ is $Type) coin_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| window_addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| window_addr@@3)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 97278) 96706)) inline$$AccountLimits_is_unrestricted_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@5  (=> (and (and (and (and (and (and (and (and ((_ is $Vector) limits_def) (let ((va@@24 (|v#$Vector| limits_def)))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| limits_def)) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_def)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) (= (ControlFlow 0 96086) 97278)) anon0$1_correct@@5)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 139325) 96086) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@4))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@1 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@1 () T@$Value)
(declare-fun addr@@1 () T@$Value)
(declare-fun $tv0@@5 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 140132) (let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon5_correct true))
(let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 98189) 98195)) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon5_correct)))
(let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 98203) 98195) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon5_correct)))
(let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 98183) 98203) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 98183) 98189) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon12_Else_correct true))
(let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon12_Then_correct true))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@2  (=> (= inline$$GetFieldFromValue$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst)) $AccountLimits_Window_limit_address)) (and (=> (= (ControlFlow 0 98153) 98179) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 98153) 98169) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon10_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 98159) 98153)) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@0@@3 true) (and (=> (= (ControlFlow 0 98099) 98183) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 98099) 98159) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$GetGlobal$0$ta@0@@1 inline$$GetGlobal$0$a@1@@1)) (= (ControlFlow 0 98097) 98099)) inline$$GetGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$GetGlobal$0$ta@0@@1 inline$$GetGlobal$0$a@1@@1) (=> (and (= inline$$GetGlobal$0$dst@1@@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$GetGlobal$0$ta@0@@1 (|a#$Address| addr@@1))) (= $abort_flag@0@@3 false)) (and (=> (= (ControlFlow 0 98045) 98183) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 98045) 98159) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon10_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@1  (=> (= inline$$GetGlobal$0$a@1@@1 (|a#$Address| addr@@1)) (and (=> (= (ControlFlow 0 98027) 98097) inline$$GetGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 98027) 98045) inline$$GetGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$GetGlobal$0$Entry_correct@@1  (=> (= inline$$GetGlobal$0$ta@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1)) (and (=> (= (ControlFlow 0 98021) (- 0 140444)) true) (=> (= (ControlFlow 0 98021) 98027) inline$$GetGlobal$0$anon0_correct@@1)))))
(let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 97884) 98021)) inline$$GetGlobal$0$Entry_correct@@1)))
(let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 98211) 98021) inline$$GetGlobal$0$Entry_correct@@1)))
(let ((inline$$AccountLimits_limits_definition_address_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 97878) 98211) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 97878) 97884) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon9_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (forall (($inv_addr@@11 Int) ($inv_tv0@@6 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((window_addr@@4 T@$Value) )  (=> ((_ is $Address) window_addr@@4) (|b#$Boolean| ($Boolean (forall ((coin_type@@4 T@$Value) )  (=> ((_ is $Type) coin_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| window_addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| window_addr@@4)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 98217) 97878)) inline$$AccountLimits_limits_definition_address_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@6  (=> (and ((_ is $Address) addr@@1) (= (ControlFlow 0 97526) 98217)) anon0$1_correct@@6)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 140132) 97526) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@5))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@6 () T@$TypeValue)
(declare-fun publish_account () T@$Value)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $AccountLimits_LimitsDefinition_$memory@1 () T@$Memory)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $AccountLimits_LimitsDefinition_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 140578) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 100291) (- 0 142032)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| publish_account)))) $abort_flag@3@@1)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| publish_account)))) $abort_flag@3@@1) (and (=> (= (ControlFlow 0 100291) (- 0 142058)) (=> $abort_flag@3@@1 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| publish_account)))))) (=> (=> $abort_flag@3@@1 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| publish_account))))) (=> (= (ControlFlow 0 100291) (- 0 142084)) (=> $abort_flag@3@@1 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| publish_account)))) (= $abort_code@6@@1 (|i#$Integer| ($Integer 6))))))))))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon26_Else_correct  (=> (not $abort_flag@2@@2) (and (=> (= (ControlFlow 0 100217) (- 0 141755)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$addr) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$addr@@0))))))))))))))) (and (=> (= (ControlFlow 0 100217) (- 0 141833)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$window_addr T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$window_addr) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@1)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$window_addr)))) $AccountLimits_Window_limit_address))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$window_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$window_addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$window_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@2)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$window_addr@@0)))) $AccountLimits_Window_limit_address)))))))))))))))) (=> (and (and (= $abort_code@6@@1 $abort_code@4@@2) (= $abort_flag@3@@1 $abort_flag@2@@2)) (and (= $AccountLimits_LimitsDefinition_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 100217) 100291))) anon0$2_correct@@4))))))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@6@@1 $abort_code@5@@1) (= $abort_flag@3@@1 true)) (and (= $AccountLimits_LimitsDefinition_$memory@1 $AccountLimits_LimitsDefinition_$memory@0) (= (ControlFlow 0 99252) 100291))) anon0$2_correct@@4)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon5_correct  (=> (= $abort_code@5@@1 $abort_code@1@@3) (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 100269) 99252)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 100267) 100269)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon5_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 100277) 100269) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon5_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 100261) 100277) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 100261) 100267) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon9_correct  (=> (= $abort_code@5@@1 $abort_code@2@@2) (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 100249) 99252)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 100247) 100249)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 100257) 100249) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 100241) 100257) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 100241) 100247) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon17_correct  (=> (= $abort_code@5@@1 $abort_code@4@@2) (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 100229) 99252)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 100227) 100229)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon17_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 100237) 100229) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon17_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon26_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 100221) 100237) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 100221) 100227) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@2 true) (=> (and (= $abort_code@4@@2 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 100011) 100221) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 100011) 100217) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 100009) 100011)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1))) (= $abort_flag@2@@2 $abort_flag@1@@3)) (and (= $abort_code@4@@2 $abort_code@2@@2) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 99959) 100221) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 99959) 100217) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| publish_account)) (and (=> (= (ControlFlow 0 100017) 100009) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 100017) 99959) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 99805) (- 0 141640)) true) (=> (= (ControlFlow 0 99805) 100017) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1)) (= (ControlFlow 0 99777) 99805)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 99663) (- 0 141518)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 99663) (- 0 141537)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 99663) (- 0 141556)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 99663) (- 0 141575)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 99663) 99777) inline$$MoveTo$0$Entry_correct)))))))))))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 99677) 99663)) inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 99683) 99663) inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 99671) 99683) inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 99671) 99677) inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Else_correct)))))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 99581) 99663)) inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t14@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t14@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t14@1) $MAX_U64)) (=> (and (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t15@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t15@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t15@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t16@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t16@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t16@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t17@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t17@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t17@1) $MAX_U64)) (= inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t14@1) 1 inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t15@1) 2 inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t16@1) 3 inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t17@1) 4))))) (and (=> (= (ControlFlow 0 99573) 99671) inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 99573) 99581) inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Else_correct))))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon24_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@0) (= inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t14@1 ($Integer 18446744073709551615))) (=> (and (and (= inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t15@1 ($Integer 18446744073709551615)) (= inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t16@1 ($Integer 86400000000))) (and (= inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t17@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 99689) 99573))) inline$$AccountLimits_LimitsDefinition_pack$0$anon0_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon14_correct  (=> (= $abort_code@5@@1 $abort_code@3@@2) (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 99248) 99252)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 99246) 99248)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon14_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 99260) 99248) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon14_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon24_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (= $abort_code@3@@2 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 99240) 99260) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 99240) 99246) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon22_Else_correct  (=> (not $abort_flag@1@@3) (and (=> (= (ControlFlow 0 99228) 99689) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 99228) 99240) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon20_Else$1_correct  (=> (and (and (and (= inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3)) (and (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 99222) 100241) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 99222) 99228) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@0  (=> (and (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t10@1)))) (= (ControlFlow 0 99210) 99222)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon20_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 99200) (- 0 141273)) true) (=> (= (ControlFlow 0 99200) 99210) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon20_Else_correct  (=> (not $abort_flag@0@@4) (=> (and (= inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| call3formal@$ret0@0@@5)))) (= (ControlFlow 0 99216) 99200)) inline$$Not$0$Entry_correct@@0))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@4) (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 publish_account)))) ((_ is $Address) call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 99142) 100261) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 99142) 99216) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 99106) 99142)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 100285) 99142) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon2$1_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 99100) 100285) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 99100) 99106) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@7  (=> (forall (($inv_addr@@12 Int) ($inv_tv0@@7 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((window_addr@@5 T@$Value) )  (=> ((_ is $Address) window_addr@@5) (|b#$Boolean| ($Boolean (forall ((coin_type@@5 T@$Value) )  (=> ((_ is $Type) coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| window_addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| window_addr@@5)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 100289) 99100)) inline$$AccountLimits_publish_unrestricted_limits_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@7  (=> (and ((_ is $Address) publish_account) (= (ControlFlow 0 98353) 100289)) anon0$1_correct@@7)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 140578) 98353) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@7 () T@$TypeValue)
(declare-fun limit_address () T@$Value)
(declare-fun $abort_flag@10@@1 () Bool)
(declare-fun to_limit () T@$Value)
(declare-fun dr_account@@0 () T@$Value)
(declare-fun $abort_code@14@@1 () Int)
(declare-fun $abort_flag@9@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@12@@1 () Int)
(declare-fun $AccountLimits_Window_$memory@1 () T@$Memory)
(declare-fun $abort_code@13@@1 () Int)
(declare-fun $AccountLimits_Window_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$AccountLimits_Window_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_code@11@@1 () Int)
(declare-fun $abort_flag@8@@1 () Bool)
(declare-fun inline$$AccountLimits_current_time_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$AccountLimits_publish_window_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_window_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_window_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$AccountLimits_current_time_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@9@@1 () Int)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_flag@7@@1 () Bool)
(declare-fun |inline$$AccountLimits_current_time_$def$0$tmp#$0@1| () T@$Value)
(declare-fun $abort_code@10@@1 () Int)
(declare-fun inline$$AccountLimits_current_time_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun call2formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun inline$$DiemTimestamp_is_genesis_$def$0$$t1@1@@0 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(declare-fun inline$$DiemTimestamp_is_genesis_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$AccountLimits_publish_window_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_window_$def_verify$0$$t14@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$AccountLimits_publish_window_$def_verify$0$$t10@1 () T@$Value)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$AccountLimits_publish_window_$def_verify$0$$t11@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 142128) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 103767) (- 0 146224)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| limit_address))))))) $abort_flag@10@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| limit_address))))))) $abort_flag@10@@1) (and (=> (= (ControlFlow 0 103767) (- 0 146255)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| to_limit)))) $abort_flag@10@@1)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| to_limit)))) $abort_flag@10@@1) (and (=> (= (ControlFlow 0 103767) (- 0 146281)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit))))))) $abort_flag@10@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit))))))) $abort_flag@10@@1) (and (=> (= (ControlFlow 0 103767) (- 0 146302)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 6)))))))) $abort_flag@10@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 6)))))))) $abort_flag@10@@1) (and (=> (= (ControlFlow 0 103767) (- 0 146347)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@10@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@10@@1) (and (=> (= (ControlFlow 0 103767) (- 0 146368)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@10@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@10@@1) (and (=> (= (ControlFlow 0 103767) (- 0 146397)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@10@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@10@@1) (and (=> (= (ControlFlow 0 103767) (- 0 146414)) (=> $abort_flag@10@@1 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| limit_address))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| to_limit))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 6))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))))) (=> (=> $abort_flag@10@@1 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| limit_address))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| to_limit))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 6))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))))) (=> (= (ControlFlow 0 103767) (- 0 146598)) (=> $abort_flag@10@@1 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| limit_address))))))) (= $abort_code@14@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| to_limit)))) (= $abort_code@14@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit))))))) (= $abort_code@14@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 6)))))))) (= $abort_code@14@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@14@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@14@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@14@@1 (|i#$Integer| ($Integer 2)))))))))))))))))))))))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon59_Else_correct  (=> (not $abort_flag@9@@1) (and (=> (= (ControlFlow 0 103613) (- 0 145880)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_window_$def_verify$0$window_addr T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_publish_window_$def_verify$0$window_addr) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_window_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_publish_window_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_publish_window_$def_verify$0$window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_publish_window_$def_verify$0$window_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@0))))))))))))))) (and (=> (= (ControlFlow 0 103613) (- 0 145958)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@1) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@1)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@1)))) $AccountLimits_Window_limit_address))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@2) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@2)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_publish_window_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_publish_window_$def_verify$0$window_addr@@2)))) $AccountLimits_Window_limit_address)))))))))))))))) (=> (and (and (= $abort_flag@10@@1 $abort_flag@9@@1) (= $abort_code@14@@1 $abort_code@12@@1)) (and (= $AccountLimits_Window_$memory@1 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 103613) 103767))) anon0$2_correct@@5))))))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@10@@1 true) (= $abort_code@14@@1 $abort_code@13@@1)) (and (= $AccountLimits_Window_$memory@1 $AccountLimits_Window_$memory@0) (= (ControlFlow 0 101909) 103767))) anon0$2_correct@@5)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon9_correct  (=> (= $abort_code@13@@1 $abort_code@1@@4) (=> (and (= $AccountLimits_Window_$memory@0 $AccountLimits_Window_$memory) (= (ControlFlow 0 103729) 101909)) inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 103727) 103729)) inline$$AccountLimits_publish_window_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 103737) 103729) inline$$AccountLimits_publish_window_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon44_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 103721) 103737) inline$$AccountLimits_publish_window_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 103721) 103727) inline$$AccountLimits_publish_window_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon13_correct  (=> (= $abort_code@13@@1 $abort_code@2@@3) (=> (and (= $AccountLimits_Window_$memory@0 $AccountLimits_Window_$memory) (= (ControlFlow 0 103709) 101909)) inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 103707) 103709)) inline$$AccountLimits_publish_window_$def_verify$0$anon13_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 103717) 103709) inline$$AccountLimits_publish_window_$def_verify$0$anon13_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon46_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 103701) 103717) inline$$AccountLimits_publish_window_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 103701) 103707) inline$$AccountLimits_publish_window_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon21_correct  (=> (= $abort_code@13@@1 $abort_code@3@@3) (=> (and (= $AccountLimits_Window_$memory@0 $AccountLimits_Window_$memory) (= (ControlFlow 0 103689) 101909)) inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 103687) 103689)) inline$$AccountLimits_publish_window_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 103697) 103689) inline$$AccountLimits_publish_window_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon50_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 103681) 103697) inline$$AccountLimits_publish_window_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 103681) 103687) inline$$AccountLimits_publish_window_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon25_correct  (=> (= $abort_code@13@@1 $abort_code@5@@2) (=> (and (= $AccountLimits_Window_$memory@0 $AccountLimits_Window_$memory) (= (ControlFlow 0 103669) 101909)) inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 103667) 103669)) inline$$AccountLimits_publish_window_$def_verify$0$anon25_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 103677) 103669) inline$$AccountLimits_publish_window_$def_verify$0$anon25_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon52_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 103661) 103677) inline$$AccountLimits_publish_window_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 103661) 103667) inline$$AccountLimits_publish_window_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon29_correct  (=> (= $abort_code@13@@1 $abort_code@6@@2) (=> (and (= $AccountLimits_Window_$memory@0 $AccountLimits_Window_$memory) (= (ControlFlow 0 103649) 101909)) inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 103647) 103649)) inline$$AccountLimits_publish_window_$def_verify$0$anon29_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 103657) 103649) inline$$AccountLimits_publish_window_$def_verify$0$anon29_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon54_Then_correct  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 103641) 103657) inline$$AccountLimits_publish_window_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 103641) 103647) inline$$AccountLimits_publish_window_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon39_correct  (=> (= $abort_code@13@@1 $abort_code@12@@1) (=> (and (= $AccountLimits_Window_$memory@0 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 103625) 101909)) inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 103623) 103625)) inline$$AccountLimits_publish_window_$def_verify$0$anon39_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 103633) 103625) inline$$AccountLimits_publish_window_$def_verify$0$anon39_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon59_Then_correct  (=> $abort_flag@9@@1 (and (=> (= (ControlFlow 0 103617) 103633) inline$$AccountLimits_publish_window_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 103617) 103623) inline$$AccountLimits_publish_window_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (= $abort_code@12@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@9@@1 true) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 103407) 103617) inline$$AccountLimits_publish_window_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 103407) 103613) inline$$AccountLimits_publish_window_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 103405) 103407)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0 inline$$AccountLimits_Window_pack$0$$struct@1))) (= $abort_code@12@@1 $abort_code@11@@1)) (and (= $abort_flag@9@@1 $abort_flag@8@@1) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 103355) 103617) inline$$AccountLimits_publish_window_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 103355) 103613) inline$$AccountLimits_publish_window_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| to_limit)) (and (=> (= (ControlFlow 0 103413) 103405) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 103413) 103355) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 103201) (- 0 145765)) true) (=> (= (ControlFlow 0 103201) 103413) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$MoveTo$0$Entry_correct@@0  (=> (and (= inline$$MoveTo$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1)) (= (ControlFlow 0 103173) 103201)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$AccountLimits_Window_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 103073) 103173)) inline$$MoveTo$0$Entry_correct@@0)))
(let ((inline$$AccountLimits_Window_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 103079) 103173) inline$$MoveTo$0$Entry_correct@@0)))
(let ((inline$$AccountLimits_Window_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 103067) 103079) inline$$AccountLimits_Window_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 103067) 103073) inline$$AccountLimits_Window_pack$0$anon4_Else_correct)))))
(let ((inline$$AccountLimits_Window_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 103059) 103173)) inline$$MoveTo$0$Entry_correct@@0)))
(let ((inline$$AccountLimits_Window_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$AccountLimits_current_time_$def$0$$ret0@2) (>= (|i#$Integer| inline$$AccountLimits_current_time_$def$0$$ret0@2) 0)) (<= (|i#$Integer| inline$$AccountLimits_current_time_$def$0$$ret0@2) $MAX_U64)) (=> (and (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_window_$def_verify$0$$t19@1) (>= (|i#$Integer| inline$$AccountLimits_publish_window_$def_verify$0$$t19@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_window_$def_verify$0$$t19@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$AccountLimits_publish_window_$def_verify$0$$t20@1) (>= (|i#$Integer| inline$$AccountLimits_publish_window_$def_verify$0$$t20@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_window_$def_verify$0$$t20@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_window_$def_verify$0$$t21@1) (>= (|i#$Integer| inline$$AccountLimits_publish_window_$def_verify$0$$t21@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_window_$def_verify$0$$t21@1) $MAX_U64)) (and ((_ is $Address) limit_address) (= inline$$AccountLimits_Window_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$AccountLimits_current_time_$def$0$$ret0@2) 1 inline$$AccountLimits_publish_window_$def_verify$0$$t19@1) 2 inline$$AccountLimits_publish_window_$def_verify$0$$t20@1) 3 inline$$AccountLimits_publish_window_$def_verify$0$$t21@1) 4 limit_address) 5)))))) (and (=> (= (ControlFlow 0 103051) 103067) inline$$AccountLimits_Window_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 103051) 103059) inline$$AccountLimits_Window_pack$0$anon3_Else_correct))))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon58_Else_correct  (=> (not $abort_flag@8@@1) (=> (and (and (= inline$$AccountLimits_publish_window_$def_verify$0$$t19@1 ($Integer 0)) (= inline$$AccountLimits_publish_window_$def_verify$0$$t20@1 ($Integer 0))) (and (= inline$$AccountLimits_publish_window_$def_verify$0$$t21@1 ($Integer 0)) (= (ControlFlow 0 103085) 103051))) inline$$AccountLimits_Window_pack$0$anon0_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon58_Then_correct  (=> (and (and $abort_flag@8@@1 (= $abort_code@13@@1 $abort_code@11@@1)) (and (= $AccountLimits_Window_$memory@0 $AccountLimits_Window_$memory) (= (ControlFlow 0 103637) 101909))) inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_current_time_$def$0$Abort_correct  (=> (and (and (= inline$$AccountLimits_current_time_$def$0$$ret0@1 $Error) (= $abort_flag@8@@1 true)) (and (= inline$$AccountLimits_current_time_$def$0$$ret0@2 inline$$AccountLimits_current_time_$def$0$$ret0@1) (= $abort_code@11@@1 $abort_code@9@@1))) (and (=> (= (ControlFlow 0 102710) 103637) inline$$AccountLimits_publish_window_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 102710) 103085) inline$$AccountLimits_publish_window_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$AccountLimits_current_time_$def$0$anon9_correct  (=> (and (= $abort_code@9@@1 $abort_code@8@@1) (= (ControlFlow 0 102704) 102710)) inline$$AccountLimits_current_time_$def$0$Abort_correct)))
(let ((inline$$AccountLimits_current_time_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 102702) 102704)) inline$$AccountLimits_current_time_$def$0$anon9_correct)))
(let ((inline$$AccountLimits_current_time_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 102718) 102704) inline$$AccountLimits_current_time_$def$0$anon9_correct)))
(let ((inline$$AccountLimits_current_time_$def$0$anon16_Then_correct  (=> $abort_flag@6@@1 (and (=> (= (ControlFlow 0 102696) 102718) inline$$AccountLimits_current_time_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 102696) 102702) inline$$AccountLimits_current_time_$def$0$anon17_Else_correct)))))
(let ((inline$$AccountLimits_current_time_$def$0$anon13_Then_correct  (=> $abort_flag@5@@1 (=> (and (= $abort_code@9@@1 $abort_code@6@@2) (= (ControlFlow 0 102782) 102710)) inline$$AccountLimits_current_time_$def$0$Abort_correct))))
(let ((inline$$AccountLimits_current_time_$def$0$anon12_correct  (=> (= $abort_flag@8@@1 $abort_flag@7@@1) (=> (and (= inline$$AccountLimits_current_time_$def$0$$ret0@2 |inline$$AccountLimits_current_time_$def$0$tmp#$0@1|) (= $abort_code@11@@1 $abort_code@10@@1)) (and (=> (= (ControlFlow 0 102684) 103637) inline$$AccountLimits_publish_window_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 102684) 103085) inline$$AccountLimits_publish_window_$def_verify$0$anon58_Else_correct))))))
(let ((inline$$AccountLimits_current_time_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 102682) 102684)) inline$$AccountLimits_current_time_$def$0$anon12_correct)))
(let ((inline$$AccountLimits_current_time_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 102692) 102684) inline$$AccountLimits_current_time_$def$0$anon12_correct)))
(let ((inline$$AccountLimits_current_time_$def$0$anon6_correct  (=> (= $abort_code@10@@1 $abort_code@6@@2) (=> (and (= |inline$$AccountLimits_current_time_$def$0$tmp#$0@1| inline$$AccountLimits_current_time_$def$0$$t2@1) (= $abort_flag@7@@1 $abort_flag@5@@1)) (and (=> (= (ControlFlow 0 102770) 102692) inline$$AccountLimits_current_time_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 102770) 102682) inline$$AccountLimits_current_time_$def$0$anon18_Else_correct))))))
(let ((inline$$AccountLimits_current_time_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 102768) 102770)) inline$$AccountLimits_current_time_$def$0$anon6_correct)))
(let ((inline$$AccountLimits_current_time_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 102778) 102770) inline$$AccountLimits_current_time_$def$0$anon6_correct)))
(let ((inline$$AccountLimits_current_time_$def$0$anon14_Then_correct  (=> (and (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2@@0) (= inline$$AccountLimits_current_time_$def$0$$t2@1 ($Integer 0))) (and (=> (= (ControlFlow 0 102760) 102778) inline$$AccountLimits_current_time_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 102760) 102768) inline$$AccountLimits_current_time_$def$0$anon15_Else_correct)))))
(let ((inline$$AccountLimits_current_time_$def$0$anon16_Else_correct  (=> (and (and (not $abort_flag@6@@1) (= $abort_code@10@@1 $abort_code@8@@1)) (and (= |inline$$AccountLimits_current_time_$def$0$tmp#$0@1| call2formal@$ret0@0@@0) (= $abort_flag@7@@1 $abort_flag@6@@1))) (and (=> (= (ControlFlow 0 102672) 102692) inline$$AccountLimits_current_time_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 102672) 102682) inline$$AccountLimits_current_time_$def$0$anon18_Else_correct)))))
(let ((inline$$AccountLimits_current_time_$def$0$anon14_Else_correct  (=> (not (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2@@0)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@1) (=> $abort_flag@6@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@6@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (and (and ((_ is $Integer) call2formal@$ret0@0@@0) (>= (|i#$Integer| call2formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 102666) 102696) inline$$AccountLimits_current_time_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 102666) 102672) inline$$AccountLimits_current_time_$def$0$anon16_Else_correct))))))
(let ((inline$$AccountLimits_current_time_$def$0$anon13_Else_correct  (=> (not $abort_flag@5@@1) (and (=> (= (ControlFlow 0 102658) 102760) inline$$AccountLimits_current_time_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 102658) 102666) inline$$AccountLimits_current_time_$def$0$anon14_Else_correct)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct@@0  (=> (and (= $abort_flag@5@@1 $abort_flag@4@@1) (= inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2@@0 inline$$Not$1$dst@1)) (and (=> (= (ControlFlow 0 102620) 102782) inline$$AccountLimits_current_time_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 102620) 102658) inline$$AccountLimits_current_time_$def$0$anon13_Else_correct)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon6_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 102618) 102620)) inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct@@0)))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon6_Then_correct@@0  (=> (= (ControlFlow 0 102628) 102620) inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct@@0)))
(let ((inline$$Not$1$anon0_correct  (=> (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$t1@1@@0)))) (and (=> (= (ControlFlow 0 102602) 102628) inline$$DiemTimestamp_is_genesis_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 102602) 102618) inline$$DiemTimestamp_is_genesis_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 102592) (- 0 145293)) true) (=> (= (ControlFlow 0 102592) 102602) inline$$Not$1$anon0_correct))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct@@0  (=> (not $abort_flag@4@@1) (=> (and (= inline$$DiemTimestamp_is_genesis_$def$0$$t1@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0)))) (= (ControlFlow 0 102608) 102592)) inline$$Not$1$Entry_correct))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct@@0  (=> (and (and $abort_flag@4@@1 (= inline$$DiemTimestamp_is_genesis_$def$0$$ret0@1 $Error)) (and (= $abort_flag@5@@1 true) (= inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2@@0 inline$$DiemTimestamp_is_genesis_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 102636) 102782) inline$$AccountLimits_current_time_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 102636) 102658) inline$$AccountLimits_current_time_$def$0$anon13_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 102520) 102636) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 102520) 102608) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 102530) 102636) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 102530) 102608) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct@@0))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@4@@1) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 102514) 102530) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 102514) 102520) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@4@@1) (= (ControlFlow 0 102544) 102514)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0)))
(let ((inline$$AccountLimits_current_time_$def$0$anon0_correct  (=> (and (not $abort_flag@4@@1) (= (ControlFlow 0 102650) 102544)) inline$$DiemTimestamp_is_genesis_$def$0$anon0_correct@@0)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon56_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@1) (= (ControlFlow 0 102796) 102650)) inline$$AccountLimits_current_time_$def$0$anon0_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon34_correct  (=> (= $abort_code@13@@1 $abort_code@7@@1) (=> (and (= $AccountLimits_Window_$memory@0 $AccountLimits_Window_$memory) (= (ControlFlow 0 102035) 101909)) inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 102033) 102035)) inline$$AccountLimits_publish_window_$def_verify$0$anon34_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 102043) 102035) inline$$AccountLimits_publish_window_$def_verify$0$anon34_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon56_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@1)) (= $abort_code@7@@1 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 102027) 102043) inline$$AccountLimits_publish_window_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 102027) 102033) inline$$AccountLimits_publish_window_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon54_Else_correct  (=> (not $abort_flag@4@@1) (and (=> (= (ControlFlow 0 102015) 102796) inline$$AccountLimits_publish_window_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 102015) 102027) inline$$AccountLimits_publish_window_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon52_Else$1_correct  (=> (and (and (and (= inline$$AccountLimits_publish_window_$def_verify$0$$t16@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@1)) (and (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 102009) 103641) inline$$AccountLimits_publish_window_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 102009) 102015) inline$$AccountLimits_publish_window_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@1  (=> (and (= inline$$Not$0$dst@1@@1 ($Boolean  (not (|b#$Boolean| inline$$AccountLimits_publish_window_$def_verify$0$$t14@1)))) (= (ControlFlow 0 101997) 102009)) inline$$AccountLimits_publish_window_$def_verify$0$anon52_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 101987) (- 0 145044)) true) (=> (= (ControlFlow 0 101987) 101997) inline$$Not$0$anon0_correct@@1))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@3@@2) (=> (and (= inline$$AccountLimits_publish_window_$def_verify$0$$t14@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| call3formal@$ret0@0@@7)))) (= (ControlFlow 0 102003) 101987)) inline$$Not$0$Entry_correct@@1))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon50_Else_correct  (=> (not $abort_flag@2@@3) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2) (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 to_limit)))) ((_ is $Address) call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 101929) 103661) inline$$AccountLimits_publish_window_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 101929) 102003) inline$$AccountLimits_publish_window_$def_verify$0$anon52_Else_correct))))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon48_Then_correct  (=> (|b#$Boolean| inline$$AccountLimits_publish_window_$def_verify$0$$t10@1) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit))))))) $abort_flag@2@@3) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 6)))))))) $abort_flag@2@@3)) (and (=> $abort_flag@2@@3 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (=> $abort_flag@2@@3 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit))))))) (= $abort_code@3@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| to_limit)))) $Roles_RoleId_role_id) ($Integer 6)))))))) (= $abort_code@3@@3 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 101923) 103681) inline$$AccountLimits_publish_window_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 101923) 101929) inline$$AccountLimits_publish_window_$def_verify$0$anon50_Else_correct))))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon18_correct  (=> (= $abort_code@13@@1 $abort_code@4@@3) (=> (and (= $AccountLimits_Window_$memory@0 $AccountLimits_Window_$memory) (= (ControlFlow 0 101905) 101909)) inline$$AccountLimits_publish_window_$def_verify$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 101903) 101905)) inline$$AccountLimits_publish_window_$def_verify$0$anon18_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 101917) 101905) inline$$AccountLimits_publish_window_$def_verify$0$anon18_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon48_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountLimits_publish_window_$def_verify$0$$t10@1)) (= $abort_code@4@@3 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 101897) 101917) inline$$AccountLimits_publish_window_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 101897) 101903) inline$$AccountLimits_publish_window_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon46_Else_correct  (=> (not $abort_flag@1@@4) (and (=> (= (ControlFlow 0 101885) 101923) inline$$AccountLimits_publish_window_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 101885) 101897) inline$$AccountLimits_publish_window_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon44_Else_correct  (=> (and (not $abort_flag@0@@5) (= inline$$AccountLimits_publish_window_$def_verify$0$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| limit_address))))) (=> (and (and (and (= inline$$AccountLimits_publish_window_$def_verify$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@4)) (and (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 101879) 103701) inline$$AccountLimits_publish_window_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 101879) 101885) inline$$AccountLimits_publish_window_$def_verify$0$anon46_Else_correct))))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon6$3_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@0@@5) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@0@@5)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@0@@5) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@0@@5)) (and (=> $abort_flag@0@@5 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))))) (=> $abort_flag@0@@5 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 101849) 103721) inline$$AccountLimits_publish_window_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 101849) 101879) inline$$AccountLimits_publish_window_$def_verify$0$anon44_Else_correct))))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 101745) 101849)) inline$$AccountLimits_publish_window_$def_verify$0$anon6$3_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 103745) 101849) inline$$AccountLimits_publish_window_$def_verify$0$anon6$3_correct)))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon42_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 101737) 103745) inline$$AccountLimits_publish_window_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 101737) 101745) inline$$AccountLimits_publish_window_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon42_Then_correct  (and (=> (= (ControlFlow 0 103753) 103745) inline$$AccountLimits_publish_window_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 103753) 101745) inline$$AccountLimits_publish_window_$def_verify$0$anon43_Else_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 101729) 103753) inline$$AccountLimits_publish_window_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 101729) 101737) inline$$AccountLimits_publish_window_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 103761) 103753) inline$$AccountLimits_publish_window_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 103761) 101737) inline$$AccountLimits_publish_window_$def_verify$0$anon42_Else_correct))))
(let ((inline$$AccountLimits_publish_window_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 101723) 103761) inline$$AccountLimits_publish_window_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 101723) 101729) inline$$AccountLimits_publish_window_$def_verify$0$anon41_Else_correct)))))
(let ((anon0$1_correct@@8  (=> (forall (($inv_addr@@13 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13)) (let ((va@@27 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))
)) (=> (and (forall (($inv_addr@@14 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14)) (let ((va@@28 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))
)) (forall (($inv_addr@@15 Int) ($inv_tv0@@8 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15)) (let ((va@@29 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@15))
))) (=> (and (and (forall (($inv_addr@@16 Int) ($inv_tv0@@9 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@16))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((window_addr@@6 T@$Value) )  (=> ((_ is $Address) window_addr@@6) (|b#$Boolean| ($Boolean (forall ((coin_type@@6 T@$Value) )  (=> ((_ is $Type) coin_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| window_addr@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| window_addr@@6)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 103765) 101723))) inline$$AccountLimits_publish_window_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@8  (=> (and (and ((_ is $Address) dr_account@@0) ((_ is $Address) to_limit)) (and ((_ is $Address) limit_address) (= (ControlFlow 0 100543) 103765))) anon0$1_correct@@8)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 142128) 100543) anon0_correct@@8)))
PreconditionGeneratedEntry_correct@@7))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun window () T@$Value)
(declare-fun limits_definition () T@$Value)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun inline$$AccountLimits_reset_window_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$AccountLimits_reset_window_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$4$dst@1@@1 () T@$Mutation)
(declare-fun inline$$AccountLimits_reset_window_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@1 () Int)
(declare-fun inline$$BorrowField$4$p@2@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1@@1 () T@$Mutation)
(declare-fun inline$$AccountLimits_reset_window_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@1 () Int)
(declare-fun inline$$BorrowField$3$p@2@@1 () T@$Path)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$2$dst@1@@1 () T@$Mutation)
(declare-fun call2formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@1 () Int)
(declare-fun inline$$BorrowField$2$p@2@@1 () T@$Path)
(declare-fun inline$$Gt$0$dst@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun inline$$AccountLimits_reset_window_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@6@@3 () Int)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun $abort_code@2@@4 () Int)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$Le$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$AccountLimits_reset_window_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@1 () T@$Value)
(declare-fun inline$$AccountLimits_reset_window_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@3 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 146866) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 107711) (- 0 149514)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 107711) (- 0 149551)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 107711) (- 0 149566)) (=> $abort_flag@4@@2 (or (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@4@@2 (or (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 107711) (- 0 149617)) (=> $abort_flag@4@@2 (or (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 8)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@4@@2 (or (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 8)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 1)))))) (=> (= (ControlFlow 0 107711) (- 0 149690)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_reset_window_$def_verify$0$$ret0@2 (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@90 (|l#$ValueArray| (let ((len@@91 (|l#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1)))) len@@91 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_tracked_balance)) (+ len@@91 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@91 (|l#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1)))) len@@91 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_tracked_balance)) (+ len@@91 1)))) len@@90 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_limit_address)) (+ len@@90 1)))) window))))))))))))))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon28_correct  (=> (and (and (= inline$$AccountLimits_reset_window_$def_verify$0$$ret0@2 inline$$AccountLimits_reset_window_$def_verify$0$$t5@1) (= $abort_flag@4@@2 $abort_flag@3@@3)) (and (= $abort_code@7@@2 $abort_code@5@@3) (= (ControlFlow 0 106206) 107711))) anon0$2_correct@@6)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 106204) 106206)) inline$$AccountLimits_reset_window_$def_verify$0$anon28_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 106214) 106206) inline$$AccountLimits_reset_window_$def_verify$0$anon28_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then$10_correct  (=> (= inline$$AccountLimits_reset_window_$def_verify$0$$t5@1 |inline$$WritebackToValue$0$vdst'@2|) (and (=> (= (ControlFlow 0 107607) 106214) inline$$AccountLimits_reset_window_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 107607) 106204) inline$$AccountLimits_reset_window_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 5))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| window) (= (ControlFlow 0 107573) 107607)) inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then$10_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 5)) (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 window (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1@@1|) (= (ControlFlow 0 107599) 107607))) inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then$10_correct)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$1$dst'@2@@1|)) (and (=> (= (ControlFlow 0 107418) 107599) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 107418) 107573) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (and (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@1|)))) (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|))) (and (=> (= (ControlFlow 0 107474) 107599) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 107474) 107573) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) (and (=> (= (ControlFlow 0 107382) 107474) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 107382) 107418) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct@@1  (=> (and (= |inline$$WriteRef$2$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1@@1) (|p#$Mutation| inline$$BorrowField$4$dst@1@@1) inline$$AccountLimits_reset_window_$def_verify$0$$t22@1)) (= (ControlFlow 0 107239) 107382)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$BorrowField$4$anon0_correct@@1  (=> (= inline$$BorrowField$4$p@1@@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (=> (and (and (= inline$$BorrowField$4$size@1@@1 (|size#$Path| inline$$BorrowField$4$p@1@@1)) (= inline$$BorrowField$4$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@1) inline$$BorrowField$4$size@1@@1 $AccountLimits_Window_window_outflow) (+ inline$$BorrowField$4$size@1@@1 1)))) (and (= inline$$BorrowField$4$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) inline$$BorrowField$4$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) $AccountLimits_Window_window_outflow))) (= (ControlFlow 0 107180) 107239))) inline$$WriteRef$2$anon0_correct@@1))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then$6_correct  (=> (and (= inline$$AccountLimits_reset_window_$def_verify$0$$t22@1 ($Integer 0)) (= (ControlFlow 0 107186) 107180)) inline$$BorrowField$4$anon0_correct@@1)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@1| |inline$$WritebackToReference$0$dst'@2@@1|) (= (ControlFlow 0 106996) 107186)) inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then$6_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1)) (= |inline$$WritebackToReference$1$dst'@1@@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) inline$$WritebackToReference$1$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@1| |inline$$WritebackToReference$1$dst'@1@@1|) (= (ControlFlow 0 107052) 107186))) inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then$6_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= inline$$WritebackToReference$1$dstPath@1@@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (and (=> (= (ControlFlow 0 106960) 107052) inline$$WritebackToReference$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 106960) 106996) inline$$WritebackToReference$1$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (and (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@1) (|p#$Mutation| inline$$BorrowField$3$dst@1@@1) inline$$AccountLimits_reset_window_$def_verify$0$$t20@1)) (= (ControlFlow 0 106817) 106960)) inline$$WritebackToReference$1$anon0_correct@@1)))
(let ((inline$$BorrowField$3$anon0_correct@@1  (=> (= inline$$BorrowField$3$p@1@@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (=> (and (and (= inline$$BorrowField$3$size@1@@1 (|size#$Path| inline$$BorrowField$3$p@1@@1)) (= inline$$BorrowField$3$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@1) inline$$BorrowField$3$size@1@@1 $AccountLimits_Window_window_inflow) (+ inline$$BorrowField$3$size@1@@1 1)))) (and (= inline$$BorrowField$3$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) inline$$BorrowField$3$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) $AccountLimits_Window_window_inflow))) (= (ControlFlow 0 106758) 106817))) inline$$WriteRef$1$anon0_correct@@1))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then$3_correct  (=> (and (= inline$$AccountLimits_reset_window_$def_verify$0$$t20@1 ($Integer 0)) (= (ControlFlow 0 106764) 106758)) inline$$BorrowField$3$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowLoc$0$dst@1@@1) (= (ControlFlow 0 106574) 106764)) inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then$3_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 106630) 106764))) inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then$3_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) (and (=> (= (ControlFlow 0 106538) 106630) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 106538) 106574) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (and (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@1) (|p#$Mutation| inline$$BorrowField$2$dst@1@@1) call2formal@$ret0@0@@1)) (= (ControlFlow 0 106395) 106538)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$BorrowField$2$anon0_correct@@1  (=> (= inline$$BorrowField$2$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$2$size@1@@1 (|size#$Path| inline$$BorrowField$2$p@1@@1)) (= inline$$BorrowField$2$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@1) inline$$BorrowField$2$size@1@@1 $AccountLimits_Window_window_start) (+ inline$$BorrowField$2$size@1@@1 1)))) (and (= inline$$BorrowField$2$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$2$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $AccountLimits_Window_window_start))) (= (ControlFlow 0 106336) 106395))) inline$$WriteRef$0$anon0_correct@@1))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1) (= (ControlFlow 0 106342) 106336)) inline$$BorrowField$2$anon0_correct@@1)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1)) (= inline$$AccountLimits_reset_window_$def_verify$0$$t5@1 window)) (and (=> (= (ControlFlow 0 106194) 106214) inline$$AccountLimits_reset_window_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 106194) 106204) inline$$AccountLimits_reset_window_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct  (=> (= inline$$Gt$0$dst@1 ($Boolean (> (|i#$Integer| call2formal@$ret0@0@@1) (|i#$Integer| inline$$AddU64$0$dst@2@@1)))) (and (=> (= (ControlFlow 0 106178) 106342) inline$$AccountLimits_reset_window_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 106178) 106194) inline$$AccountLimits_reset_window_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 106164) (- 0 148641)) true) (=> (= (ControlFlow 0 106164) 106178) inline$$Gt$0$anon0_correct))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@3@@3) (= (ControlFlow 0 106184) 106164)) inline$$Gt$0$Entry_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$Abort_correct  (=> (= inline$$AccountLimits_reset_window_$def_verify$0$$ret0@1 $Error) (=> (and (and (= inline$$AccountLimits_reset_window_$def_verify$0$$ret0@2 inline$$AccountLimits_reset_window_$def_verify$0$$ret0@1) (= $abort_flag@4@@2 true)) (and (= $abort_code@7@@2 $abort_code@6@@3) (= (ControlFlow 0 105661) 107711))) anon0$2_correct@@6))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon7_correct  (=> (and (= $abort_code@6@@3 $abort_code@1@@5) (= (ControlFlow 0 107679) 105661)) inline$$AccountLimits_reset_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 107677) 107679)) inline$$AccountLimits_reset_window_$def_verify$0$anon7_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 107687) 107679) inline$$AccountLimits_reset_window_$def_verify$0$anon7_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon31_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 107671) 107687) inline$$AccountLimits_reset_window_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 107671) 107677) inline$$AccountLimits_reset_window_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon11_correct  (=> (and (= $abort_code@6@@3 $abort_code@2@@4) (= (ControlFlow 0 107659) 105661)) inline$$AccountLimits_reset_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 107657) 107659)) inline$$AccountLimits_reset_window_$def_verify$0$anon11_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 107667) 107659) inline$$AccountLimits_reset_window_$def_verify$0$anon11_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon33_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 107651) 107667) inline$$AccountLimits_reset_window_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 107651) 107657) inline$$AccountLimits_reset_window_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon15_correct  (=> (and (= $abort_code@6@@3 $abort_code@3@@4) (= (ControlFlow 0 107639) 105661)) inline$$AccountLimits_reset_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 107637) 107639)) inline$$AccountLimits_reset_window_$def_verify$0$anon15_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 107647) 107639) inline$$AccountLimits_reset_window_$def_verify$0$anon15_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon35_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 107631) 107647) inline$$AccountLimits_reset_window_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 107631) 107637) inline$$AccountLimits_reset_window_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon23_correct  (=> (and (= $abort_code@6@@3 $abort_code@5@@3) (= (ControlFlow 0 107619) 105661)) inline$$AccountLimits_reset_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 107617) 107619)) inline$$AccountLimits_reset_window_$def_verify$0$anon23_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 107627) 107619) inline$$AccountLimits_reset_window_$def_verify$0$anon23_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon39_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 107611) 107627) inline$$AccountLimits_reset_window_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 107611) 107617) inline$$AccountLimits_reset_window_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (= $abort_code@5@@3 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@3@@3 true) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 106108) 107611) inline$$AccountLimits_reset_window_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 106108) 106184) inline$$AccountLimits_reset_window_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1@@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1@@1)) $MAX_U64) (= (ControlFlow 0 106106) 106108)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1@@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1@@1))) (=> (and (and (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1@@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1@@1)))) (= $abort_code@5@@3 $abort_code@3@@4)) (and (= $abort_flag@3@@3 $abort_flag@2@@4) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 106050) 107611) inline$$AccountLimits_reset_window_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 106050) 106184) inline$$AccountLimits_reset_window_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 106020) (- 0 148545)) true) (and (=> (= (ControlFlow 0 106020) 106106) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 106020) 106050) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@1  (=> (and (= inline$$GetFieldFromValue$1$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period)) (= (ControlFlow 0 105921) 106020)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$ReadRef$1$anon0_correct@@1  (=> (and (= inline$$ReadRef$1$v@1@@1 (|v#$Mutation| inline$$BorrowField$1$dst@1@@1)) (= (ControlFlow 0 105865) 105921)) inline$$GetFieldFromValue$1$anon0_correct@@1)))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1)) (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $AccountLimits_Window_window_start) (+ inline$$BorrowField$1$size@1@@1 1)))) (and (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $AccountLimits_Window_window_start))) (= (ControlFlow 0 105827) 105865))) inline$$ReadRef$1$anon0_correct@@1))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon37_Then_correct  (=> (and (|b#$Boolean| inline$$Le$0$dst@1@@1) (= (ControlFlow 0 105879) 105827)) inline$$BorrowField$1$anon0_correct@@1)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon20_correct  (=> (and (= $abort_code@6@@3 $abort_code@4@@4) (= (ControlFlow 0 105655) 105661)) inline$$AccountLimits_reset_window_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 105653) 105655)) inline$$AccountLimits_reset_window_$def_verify$0$anon20_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 105669) 105655) inline$$AccountLimits_reset_window_$def_verify$0$anon20_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$0$dst@1@@1)) (= $abort_code@4@@4 (|i#$Integer| call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 105647) 105669) inline$$AccountLimits_reset_window_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 105647) 105653) inline$$AccountLimits_reset_window_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@2@@4) (and (=> (= (ControlFlow 0 105635) 105879) inline$$AccountLimits_reset_window_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 105635) 105647) inline$$AccountLimits_reset_window_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon33_Else$1_correct  (=> (and (and (and (= inline$$AccountLimits_reset_window_$def_verify$0$$t13@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@4)) (and (=> $abort_flag@2@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 105629) 107631) inline$$AccountLimits_reset_window_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 105629) 105635) inline$$AccountLimits_reset_window_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Le$0$anon0_correct@@1  (=> (and (= inline$$Le$0$dst@1@@1 ($Boolean (<= (|i#$Integer| inline$$ReadRef$0$v@1@@1) (|i#$Integer| inline$$Sub$0$dst@2@@1)))) (= (ControlFlow 0 105617) 105629)) inline$$AccountLimits_reset_window_$def_verify$0$anon33_Else$1_correct)))
(let ((inline$$Le$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 105603) (- 0 148302)) true) (=> (= (ControlFlow 0 105603) 105617) inline$$Le$0$anon0_correct@@1))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon33_Else_correct  (=> (and (not $abort_flag@1@@5) (= (ControlFlow 0 105623) 105603)) inline$$Le$0$Entry_correct@@1)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@1@@5 true) (=> (and (= $abort_code@2@@4 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@0@@1)) (and (=> (= (ControlFlow 0 105547) 107651) inline$$AccountLimits_reset_window_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 105547) 105623) inline$$AccountLimits_reset_window_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@1  (=> (and (< (|i#$Integer| inline$$AccountLimits_reset_window_$def_verify$0$$t9@1) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@3)) (= (ControlFlow 0 105545) 105547)) inline$$Sub$0$anon3_Then$1_correct@@1)))
(let ((inline$$Sub$0$anon3_Else_correct@@1  (=> (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@3) (|i#$Integer| inline$$AccountLimits_reset_window_$def_verify$0$$t9@1)) (=> (and (and (= inline$$Sub$0$dst@1@@1 ($Integer (- (|i#$Integer| inline$$AccountLimits_reset_window_$def_verify$0$$t9@1) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@3)))) (= $abort_flag@1@@5 $abort_flag@0@@6)) (and (= $abort_code@2@@4 $abort_code@1@@5) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@1@@1))) (and (=> (= (ControlFlow 0 105493) 107651) inline$$AccountLimits_reset_window_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 105493) 105623) inline$$AccountLimits_reset_window_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 105467) (- 0 148214)) true) (and (=> (= (ControlFlow 0 105467) 105545) inline$$Sub$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 105467) 105493) inline$$Sub$0$anon3_Else_correct@@1)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@3  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period)) (= (ControlFlow 0 105376) 105467)) inline$$Sub$0$Entry_correct@@1)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon31_Else$1_correct  (=> (and (= inline$$AccountLimits_reset_window_$def_verify$0$$t9@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 105382) 105376)) inline$$GetFieldFromValue$0$anon0_correct@@3)))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (= (ControlFlow 0 105316) 105382)) inline$$AccountLimits_reset_window_$def_verify$0$anon31_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $AccountLimits_Window_window_start) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $AccountLimits_Window_window_start))) (= (ControlFlow 0 105278) 105316))) inline$$ReadRef$0$anon0_correct@@1))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon31_Else_correct  (=> (and (not $abort_flag@0@@6) (= (ControlFlow 0 105330) 105278)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon4$3_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@6) (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@0@@6 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@5 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (and (and ((_ is $Integer) call2formal@$ret0@0@@1) (>= (|i#$Integer| call2formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 105120) 107671) inline$$AccountLimits_reset_window_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 105120) 105330) inline$$AccountLimits_reset_window_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 5) $EmptyPath window)) (= (ControlFlow 0 105112) 105120)) inline$$AccountLimits_reset_window_$def_verify$0$anon4$3_correct)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 104994) 105112)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 107695) 105112) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 104986) 107695) inline$$AccountLimits_reset_window_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 104986) 104994) inline$$AccountLimits_reset_window_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 107703) 107695) inline$$AccountLimits_reset_window_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 107703) 104994) inline$$AccountLimits_reset_window_$def_verify$0$anon30_Else_correct))))
(let ((inline$$AccountLimits_reset_window_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 104980) 107703) inline$$AccountLimits_reset_window_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 104980) 104986) inline$$AccountLimits_reset_window_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@9  (=> (and (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@17))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@17))
)) (forall (($inv_addr@@18 Int) ($inv_tv0@@10 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@18))
))) (=> (and (and (forall (($inv_addr@@19 Int) ($inv_tv0@@11 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19)) (let ((va@@33 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@19))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((window_addr@@7 T@$Value) )  (=> ((_ is $Address) window_addr@@7) (|b#$Boolean| ($Boolean (forall ((coin_type@@7 T@$Value) )  (=> ((_ is $Type) coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| window_addr@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| window_addr@@7)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 107709) 104980))) inline$$AccountLimits_reset_window_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@9  (=> (and (and (and (and (and (and (and ((_ is $Vector) window) (let ((va@@34 (|v#$Vector| window)))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| window)) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| window)) $AccountLimits_Window_limit_address))) (=> (and (and (and (and (and (and (and (and ((_ is $Vector) limits_definition) (let ((va@@35 (|v#$Vector| limits_definition)))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| limits_definition)) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| limits_definition)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) (= (ControlFlow 0 104169) 107709)) anon0$1_correct@@9))))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 146866) 104169) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@8)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@8 () T@$TypeValue)
(declare-fun addr@@2 () T@$Value)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun amount@@1 () T@$Value)
(declare-fun $abort_code@6@@4 () Int)
(declare-fun inline$$AccountLimits_update_deposit_limits_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $AccountLimits_Window_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@4@@5 () Int)
(declare-fun call5formal@$ret0@0@@1 () T@$Value)
(declare-fun $abort_flag@2@@5 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun call6formal@$ret1@0 () T@$Value)
(declare-fun inline$$AccountLimits_update_deposit_limits_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@5@@4 () Int)
(declare-fun $abort_code@1@@6 () Int)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun $abort_code@3@@5 () Int)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun inline$$ReadRef$0$v@1@@2 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$AccountLimits_update_deposit_limits_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$AccountLimits_update_deposit_limits_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@2@@5 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$AccountLimits_update_deposit_limits_$def_verify$0$$t8@1 () T@$Value)
(declare-fun _cap () T@$Value)
(declare-fun $AccountLimits_Window_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 149721) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 110308) (- 0 154569)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 110308) (- 0 154599)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 110308) (- 0 154651)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@95 (|l#$ValueArray| (let ((len@@96 (|l#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1)))) len@@96 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@96 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@96 (|l#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1)))) len@@96 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@96 1)))) len@@95 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@95 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@95 (|l#$ValueArray| (let ((len@@96 (|l#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1)))) len@@96 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@96 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@96 (|l#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1)))) len@@96 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@96 1)))) len@@95 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@95 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 110308) (- 0 154748)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@100 (|l#$ValueArray| (let ((len@@101 (|l#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1)))) len@@101 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@101 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@101 (|l#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1)))) len@@101 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@101 1)))) len@@100 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@100 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@100 (|l#$ValueArray| (let ((len@@101 (|l#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1)))) len@@101 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@101 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@101 (|l#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1)))) len@@101 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@101 1)))) len@@100 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@100 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 110308) (- 0 154845)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 110308) (- 0 154961)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 110308) (- 0 155015)) (=> $abort_flag@3@@4 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@105 (|l#$ValueArray| (let ((len@@106 (|l#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1)))) len@@106 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@106 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@106 (|l#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1)))) len@@106 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@106 1)))) len@@105 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@105 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@110 (|l#$ValueArray| (let ((len@@111 (|l#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1)))) len@@111 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@111 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@111 (|l#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1)))) len@@111 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@111 1)))) len@@110 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@110 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (=> (=> $abort_flag@3@@4 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@105 (|l#$ValueArray| (let ((len@@106 (|l#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1)))) len@@106 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@106 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@106 (|l#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1)))) len@@106 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@106 1)))) len@@105 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@105 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@110 (|l#$ValueArray| (let ((len@@111 (|l#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1)))) len@@111 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@111 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@111 (|l#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1)))) len@@111 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@111 1)))) len@@110 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@110 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (=> (= (ControlFlow 0 110308) (- 0 155456)) (=> $abort_flag@3@@4 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@115 (|l#$ValueArray| (let ((len@@116 (|l#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1)))) len@@116 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@116 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@116 (|l#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1)))) len@@116 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@116 1)))) len@@115 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@115 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@120 (|l#$ValueArray| (let ((len@@121 (|l#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1)))) len@@121 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@121 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@121 (|l#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1)))) len@@121 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@121 1)))) len@@120 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@120 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@3@@4 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@115 (|l#$ValueArray| (let ((len@@116 (|l#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1)))) len@@116 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@116 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@116 (|l#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1)))) len@@116 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@116 1)))) len@@115 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@115 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@120 (|l#$ValueArray| (let ((len@@121 (|l#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1)))) len@@121 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@121 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@121 (|l#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1)))) len@@121 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@121 1)))) len@@120 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@120 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@4 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 110308) (- 0 155963)) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_update_deposit_limits_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@125 (|l#$ValueArray| (let ((len@@126 (|l#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1)))) len@@126 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@126 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@126 (|l#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1)))) len@@126 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@126 1)))) len@@125 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@125 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@130 (|l#$ValueArray| (let ((len@@131 (|l#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1)))) len@@131 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@131 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@131 (|l#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1)))) len@@131 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@131 1)))) len@@130 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@130 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))) (=> (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_update_deposit_limits_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@125 (|l#$ValueArray| (let ((len@@126 (|l#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1)))) len@@126 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@126 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@126 (|l#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1)))) len@@126 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@126 1)))) len@@125 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@125 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@130 (|l#$ValueArray| (let ((len@@131 (|l#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1)))) len@@131 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@131 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@131 (|l#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1)))) len@@131 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@131 1)))) len@@130 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@130 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding)))))))))))))) (=> (= (ControlFlow 0 110308) (- 0 156004)) (=> (not $abort_flag@3@@4) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| inline$$AccountLimits_update_deposit_limits_$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))))))))) ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@135 (|l#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1)))) len@@135 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@135 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@135 (|l#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1)))) len@@135 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@135 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@135 (|l#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1)))) len@@135 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@135 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))))))) $AccountLimits_Window_tracked_balance ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@135 (|l#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1)))) len@@135 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@135 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@135 (|l#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1)))) len@@135 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@135 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@135 (|l#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1)))) len@@135 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@135 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@135 (|l#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1)))) len@@135 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@135 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))))))))))))) ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)) (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@140 (|l#$ValueArray| (let ((len@@141 (|l#$ValueArray| (let ((len@@142 (|l#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1)))) len@@142 ($Integer 0)) (+ len@@142 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@142 (|l#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1)))) len@@142 ($Integer 0)) (+ len@@142 1)))) len@@141 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@141 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@141 (|l#$ValueArray| (let ((len@@142 (|l#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1)))) len@@142 ($Integer 0)) (+ len@@142 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@142 (|l#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1)))) len@@142 ($Integer 0)) (+ len@@142 1)))) len@@141 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_tracked_balance)) (+ len@@141 1)))) len@@140 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) $AccountLimits_Window_limit_address)) (+ len@@140 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))))))))))))))))))))))))))))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon24_correct  (=> (= $abort_code@6@@4 $abort_code@4@@5) (=> (and (and (= inline$$AccountLimits_update_deposit_limits_$def_verify$0$$ret0@2 call5formal@$ret0@0@@1) (= $abort_flag@3@@4 $abort_flag@2@@5)) (and (= $AccountLimits_Window_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 110208) 110308))) anon0$2_correct@@7))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 110206) 110208)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon24_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 110216) 110208) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon24_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon34_Else$2_correct  (and (=> (= (ControlFlow 0 110200) (- 0 154278)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@0))))))))))))))) (and (=> (= (ControlFlow 0 110200) (- 0 154356)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@1) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@1)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@1)))) $AccountLimits_Window_limit_address))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@2) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@2)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_deposit_limits_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_update_deposit_limits_$def_verify$0$window_addr@@2)))) $AccountLimits_Window_limit_address)))))))))))))))) (and (=> (= (ControlFlow 0 110200) 110216) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 110200) 110206) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon36_Else_correct))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $AccountLimits_Window_$memory) (= (ControlFlow 0 109952) 110200)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon34_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $AccountLimits_Window_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 110006) 110200))) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon34_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (and (=> (= (ControlFlow 0 109942) 110006) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 109942) 109952) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (and (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|p#$Mutation| inline$$BorrowGlobal$0$dst@2) call6formal@$ret1@0)) (= (ControlFlow 0 109818) 109942)) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@5) (= (ControlFlow 0 109824) 109818)) inline$$WriteRef$0$anon0_correct@@2)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$Abort_correct  (=> (and (= inline$$AccountLimits_update_deposit_limits_$def_verify$0$$ret0@1 $Error) (= $abort_code@6@@4 $abort_code@5@@4)) (=> (and (and (= inline$$AccountLimits_update_deposit_limits_$def_verify$0$$ret0@2 inline$$AccountLimits_update_deposit_limits_$def_verify$0$$ret0@1) (= $abort_flag@3@@4 true)) (and (= $AccountLimits_Window_$memory@0@@0 $AccountLimits_Window_$memory) (= (ControlFlow 0 109468) 110308))) anon0$2_correct@@7))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon9_correct  (=> (and (= $abort_code@5@@4 $abort_code@1@@6) (= (ControlFlow 0 110268) 109468)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 110266) 110268)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 110276) 110268) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 110260) 110276) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 110260) 110266) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon17_correct  (=> (and (= $abort_code@5@@4 $abort_code@3@@5) (= (ControlFlow 0 110248) 109468)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 110246) 110248)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon17_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 110256) 110248) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon17_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon32_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 110240) 110256) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 110240) 110246) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon21_correct  (=> (and (= $abort_code@5@@4 $abort_code@4@@5) (= (ControlFlow 0 110228) 109468)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 110226) 110228)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 110236) 110228) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon34_Then_correct  (=> $abort_flag@2@@5 (and (=> (= (ControlFlow 0 110220) 110236) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 110220) 110226) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon32_Else$1_correct  (and (=> (= (ControlFlow 0 109761) (- 0 153226)) true) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)))))))) $abort_flag@2@@5) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@145 (|l#$ValueArray| (let ((len@@146 (|l#$ValueArray| (let ((len@@147 (|l#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1)))) len@@147 ($Integer 0)) (+ len@@147 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@147 (|l#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1)))) len@@147 ($Integer 0)) (+ len@@147 1)))) len@@146 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@146 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@146 (|l#$ValueArray| (let ((len@@147 (|l#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1)))) len@@147 ($Integer 0)) (+ len@@147 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@147 (|l#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1)))) len@@147 ($Integer 0)) (+ len@@147 1)))) len@@146 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@146 1)))) len@@145 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@145 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@2@@5)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@150 (|l#$ValueArray| (let ((len@@151 (|l#$ValueArray| (let ((len@@152 (|l#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1)))) len@@152 ($Integer 0)) (+ len@@152 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@152 (|l#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1)))) len@@152 ($Integer 0)) (+ len@@152 1)))) len@@151 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@151 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@151 (|l#$ValueArray| (let ((len@@152 (|l#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1)))) len@@152 ($Integer 0)) (+ len@@152 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@152 (|l#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1)))) len@@152 ($Integer 0)) (+ len@@152 1)))) len@@151 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@151 1)))) len@@150 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@150 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@2@@5) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@2@@5)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2@@5) (=> $abort_flag@2@@5 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@155 (|l#$ValueArray| (let ((len@@156 (|l#$ValueArray| (let ((len@@157 (|l#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1)))) len@@157 ($Integer 0)) (+ len@@157 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@157 (|l#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1)))) len@@157 ($Integer 0)) (+ len@@157 1)))) len@@156 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@156 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@156 (|l#$ValueArray| (let ((len@@157 (|l#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1)))) len@@157 ($Integer 0)) (+ len@@157 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@157 (|l#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1)))) len@@157 ($Integer 0)) (+ len@@157 1)))) len@@156 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@156 1)))) len@@155 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@155 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@160 (|l#$ValueArray| (let ((len@@161 (|l#$ValueArray| (let ((len@@162 (|l#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1)))) len@@162 ($Integer 0)) (+ len@@162 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@162 (|l#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1)))) len@@162 ($Integer 0)) (+ len@@162 1)))) len@@161 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@161 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@161 (|l#$ValueArray| (let ((len@@162 (|l#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1)))) len@@162 ($Integer 0)) (+ len@@162 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@162 (|l#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1)))) len@@162 ($Integer 0)) (+ len@@162 1)))) len@@161 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@161 1)))) len@@160 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@160 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (and (and (=> $abort_flag@2@@5 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)))))))) (= $abort_code@4@@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@165 (|l#$ValueArray| (let ((len@@166 (|l#$ValueArray| (let ((len@@167 (|l#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1)))) len@@167 ($Integer 0)) (+ len@@167 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@167 (|l#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1)))) len@@167 ($Integer 0)) (+ len@@167 1)))) len@@166 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@166 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@166 (|l#$ValueArray| (let ((len@@167 (|l#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1)))) len@@167 ($Integer 0)) (+ len@@167 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@167 (|l#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1)))) len@@167 ($Integer 0)) (+ len@@167 1)))) len@@166 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@166 1)))) len@@165 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@165 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@4@@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@170 (|l#$ValueArray| (let ((len@@171 (|l#$ValueArray| (let ((len@@172 (|l#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1)))) len@@172 ($Integer 0)) (+ len@@172 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@172 (|l#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1)))) len@@172 ($Integer 0)) (+ len@@172 1)))) len@@171 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@171 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@171 (|l#$ValueArray| (let ((len@@172 (|l#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1)))) len@@172 ($Integer 0)) (+ len@@172 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@172 (|l#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1)))) len@@172 ($Integer 0)) (+ len@@172 1)))) len@@171 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@171 1)))) len@@170 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@170 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@4@@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@4@@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@4@@5 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@2@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call5formal@$ret0@0@@1 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@175 (|l#$ValueArray| (let ((len@@176 (|l#$ValueArray| (let ((len@@177 (|l#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1)))) len@@177 ($Integer 0)) (+ len@@177 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@177 (|l#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1)))) len@@177 ($Integer 0)) (+ len@@177 1)))) len@@176 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@176 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@176 (|l#$ValueArray| (let ((len@@177 (|l#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1)))) len@@177 ($Integer 0)) (+ len@@177 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@177 (|l#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1)))) len@@177 ($Integer 0)) (+ len@@177 1)))) len@@176 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@176 1)))) len@@175 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@175 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@180 (|l#$ValueArray| (let ((len@@181 (|l#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1)))) len@@181 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@181 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@181 (|l#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1)))) len@@181 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@181 1)))) len@@180 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@180 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))) (and (=> (not $abort_flag@2@@5) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| call5formal@$ret0@0@@1) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))))))))) ($Boolean ($IsEqual_stratified call6formal@$ret1@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@185 (|l#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1)))) len@@185 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@185 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_window_inflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@185 (|l#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1)))) len@@185 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@185 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@185 (|l#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1)))) len@@185 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@185 1)))) inline$$ReadRef$0$v@1@@2))))))) $AccountLimits_Window_tracked_balance ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@185 (|l#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1)))) len@@185 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@185 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@1)))) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@185 (|l#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1)))) len@@185 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@185 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_window_inflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@185 (|l#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1)))) len@@185 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@185 1)))) inline$$ReadRef$0$v@1@@2))) $AccountLimits_Window_window_inflow)) (|i#$Integer| amount@@1)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@185 (|l#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@186 1)))) len@@185 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@185 1)))) inline$$ReadRef$0$v@1@@2))))))))))) ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified call6formal@$ret1@0 (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@190 (|l#$ValueArray| (let ((len@@191 (|l#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1)))) len@@191 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@191 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@191 (|l#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1)))) len@@191 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_tracked_balance)) (+ len@@191 1)))) len@@190 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $AccountLimits_Window_limit_address)) (+ len@@190 1)))) inline$$ReadRef$0$v@1@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified call6formal@$ret1@0 inline$$ReadRef$0$v@1@@2)))))))) ((_ is $Boolean) call5formal@$ret0@0@@1)))) (=> (and (and (and (and (and (and (and ((_ is $Vector) call6formal@$ret1@0) (let ((va@@36 (|v#$Vector| call6formal@$ret1@0)))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $AccountLimits_Window_limit_address))) (and (=> (= (ControlFlow 0 109761) 110220) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 109761) 109824) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon34_Else_correct))))))))
(let ((inline$$ReadRef$0$anon0_correct@@2  (=> (and (= inline$$ReadRef$0$v@1@@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 109749) 109761)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon32_Else$1_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon32_Else_correct  (=> (and (not $abort_flag@1@@6) (= (ControlFlow 0 109755) 109749)) inline$$ReadRef$0$anon0_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@1@@6 true) (=> (and (= $abort_code@3@@5 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 109705) 110240) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 109705) 109755) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 109703) 109705)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1))) (= $abort_flag@1@@6 $abort_flag@0@@7)) (and (= $abort_code@3@@5 $abort_code@1@@6) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 109651) 110240) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 109651) 109755) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| addr@@2)) (and (=> (= (ControlFlow 0 109621) 109703) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 109621) 109651) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (=> (= inline$$BorrowGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1)) (and (=> (= (ControlFlow 0 109615) (- 0 153113)) true) (=> (= (ControlFlow 0 109615) 109621) inline$$BorrowGlobal$0$anon0_correct)))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon30_Then_correct  (=> (|b#$Boolean| inline$$AccountLimits_update_deposit_limits_$def_verify$0$$t7@1) (and (=> (= (ControlFlow 0 109711) (- 0 153045)) (|Select_[$TypeValueArray,$int]$bool| inline$$AccountLimits_update_deposit_limits_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$AccountLimits_update_deposit_limits_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)) (=> (= (ControlFlow 0 109711) 109615) inline$$BorrowGlobal$0$Entry_correct))))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon14_correct  (=> (and (= $abort_code@5@@4 $abort_code@2@@5) (= (ControlFlow 0 109462) 109468)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 109460) 109462)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon14_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 109476) 109462) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon14_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon30_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountLimits_update_deposit_limits_$def_verify$0$$t7@1)) (= $abort_code@2@@5 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 109454) 109476) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 109454) 109460) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon28_Else_correct  (=> (not $abort_flag@0@@7) (and (=> (= (ControlFlow 0 109442) 109711) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 109442) 109454) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon6$2_correct  (=> (= inline$$AccountLimits_update_deposit_limits_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)))) (=> (and (and (and (= inline$$AccountLimits_update_deposit_limits_$def_verify$0$$t8@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@7)) (and (=> $abort_flag@0@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 109436) 110260) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 109436) 109442) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon6_correct  (=> (and (= inline$$AccountLimits_update_deposit_limits_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2) true)) (= (ControlFlow 0 109376) 109436)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon6$2_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 109316) 109376)) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon6_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 110284) 109376) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon6_correct)))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon26_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 109308) 110284) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 109308) 109316) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon26_Then_correct  (and (=> (= (ControlFlow 0 110292) 110284) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 110292) 109316) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon27_Else_correct))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 109300) 110292) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 109300) 109308) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 110300) 110292) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 110300) 109308) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon26_Else_correct))))
(let ((inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 109294) 110300) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 109294) 109300) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@10  (=> (and (forall (($inv_addr@@20 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20)) (let ((va@@37 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))
)) (forall (($inv_addr@@21 Int) ($inv_tv0@@12 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21)) (let ((va@@38 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@21))
))) (=> (and (and (forall (($inv_addr@@22 Int) ($inv_tv0@@13 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22)) (let ((va@@39 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@22))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((window_addr@@8 T@$Value) )  (=> ((_ is $Address) window_addr@@8) (|b#$Boolean| ($Boolean (forall ((coin_type@@8 T@$Value) )  (=> ((_ is $Type) coin_type@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| window_addr@@8)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| window_addr@@8)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 110306) 109294))) inline$$AccountLimits_update_deposit_limits_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@10  (=> (and (and (and ((_ is $Integer) amount@@1) (>= (|i#$Integer| amount@@1) 0)) (<= (|i#$Integer| amount@@1) $MAX_U64)) ((_ is $Address) addr@@2)) (=> (and (and (and (and (and ((_ is $Vector) _cap) (let ((va@@40 (|v#$Vector| _cap)))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| _cap)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _cap)) $AccountLimits_AccountLimitMutationCapability_dummy_field))) true) (= (ControlFlow 0 108320) 110306)) anon0$1_correct@@10))))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (and (|Select_[$TypeValueArray,$int]$bool| $AccountLimits_Window_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@2)) (= (ControlFlow 0 149721) 108320)) anon0_correct@@10)))
PreconditionGeneratedEntry_correct@@9))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun $abort_flag@2@@6 () Bool)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@2 () T@$Mutation)
(declare-fun new_time_period () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@2 () Int)
(declare-fun inline$$BorrowField$0$p@2@@2 () T@$Path)
(declare-fun inline$$Gt$3$dst@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$t27@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@2| () T@$Mutation)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@2 () T@$Mutation)
(declare-fun new_max_holding_balance () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@2 () Int)
(declare-fun inline$$BorrowField$1$p@2@@2 () T@$Path)
(declare-fun inline$$Gt$2$dst@1 () T@$Value)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$t24@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@2 () T@$Mutation)
(declare-fun new_max_outflow () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@2 () Int)
(declare-fun inline$$BorrowField$2$p@2@@2 () T@$Path)
(declare-fun inline$$Gt$1$dst@1 () T@$Value)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$t21@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2| () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1| () T@$Mutation)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@2 () T@$Mutation)
(declare-fun new_max_inflow () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@2 () Int)
(declare-fun inline$$BorrowField$3$p@2@@2 () T@$Path)
(declare-fun inline$$Gt$0$dst@1@@0 () T@$Value)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun limit_address@@0 () T@$Value)
(declare-fun $tv0@@9 () T@$TypeValue)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$t15@1 () T@$Value)
(declare-fun $abort_code@3@@6 () Int)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$AccountLimits_update_limits_definition_$def_verify$0$$t16@1 () T@$Value)
(declare-fun tc_account () T@$Value)
(declare-fun $abort_code@1@@7 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 156221) (let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon52_Else_correct true))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon52_Then_correct true))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon51_Then_correct  (=> $abort_flag@0@@8 (and (=> (= (ControlFlow 0 115866) 115882) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 115866) 115872) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon54_Else_correct true))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon54_Then_correct true))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon53_Then_correct  (=> $abort_flag@1@@7 (and (=> (= (ControlFlow 0 115846) 115862) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 115846) 115852) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon58_Else_correct true))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon58_Then_correct true))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon57_Then_correct  (=> $abort_flag@2@@6 (and (=> (= (ControlFlow 0 115826) 115842) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 115826) 115832) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon44$3_correct  (and (=> (= (ControlFlow 0 114486) (- 0 159548)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_limits_definition_$def_verify$0$addr) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@0))))))))))))))) (=> (= (ControlFlow 0 114486) (- 0 159626)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$window_addr T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_limits_definition_$def_verify$0$window_addr) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@1)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$window_addr)))) $AccountLimits_Window_limit_address)))))))))))))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 114240) 114486)) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon44$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 114294) 114486))) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon44$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (and (=> (= (ControlFlow 0 114230) 114294) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 114230) 114240) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$AccountLimits_LimitsDefinition_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 114108) (- 0 159359)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 114108) (- 0 159378)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 114108) (- 0 159397)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 114108) (- 0 159416)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 114108) 114230) inline$$WritebackToGlobal$1$anon0_correct)))))))))))
(let ((inline$$AccountLimits_LimitsDefinition_$pack_ref$1$Entry_correct  (=> (and (= inline$$AccountLimits_LimitsDefinition_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (= (ControlFlow 0 114026) 114108)) inline$$AccountLimits_LimitsDefinition_$pack_ref$1$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@2| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3) (= (ControlFlow 0 113860) 114026)) inline$$AccountLimits_LimitsDefinition_$pack_ref$1$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2)) (= |inline$$WritebackToReference$0$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3) inline$$WritebackToReference$0$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@2| |inline$$WritebackToReference$0$dst'@1@@2|) (= (ControlFlow 0 113916) 114026))) inline$$AccountLimits_LimitsDefinition_$pack_ref$1$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= inline$$WritebackToReference$0$dstPath@1@@2 (|p#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3))) (and (=> (= (ControlFlow 0 113824) 113916) inline$$WritebackToReference$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 113824) 113860) inline$$WritebackToReference$0$anon3_Else_correct@@2)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 113687) 113824)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon66_Then_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$trace_temp@4 (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3)) (= (ControlFlow 0 114496) 113824)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@2) (|p#$Mutation| inline$$BorrowField$0$dst@1@@2) new_time_period)) (and (=> (= (ControlFlow 0 113673) 114496) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 113673) 113687) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@2  (=> (= inline$$BorrowField$0$p@1@@2 (|p#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3)) (=> (and (and (= inline$$BorrowField$0$size@1@@2 (|size#$Path| inline$$BorrowField$0$p@1@@2)) (= inline$$BorrowField$0$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@2) inline$$BorrowField$0$size@1@@2 $AccountLimits_LimitsDefinition_time_period) (+ inline$$BorrowField$0$size@1@@2 1)))) (and (= inline$$BorrowField$0$dst@1@@2 ($Mutation (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3) inline$$BorrowField$0$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3))) $AccountLimits_LimitsDefinition_time_period))) (= (ControlFlow 0 113614) 113673))) inline$$WriteRef$0$anon0_correct@@3))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon65_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$3$dst@1) (= (ControlFlow 0 113620) 113614)) inline$$BorrowField$0$anon0_correct@@2)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon65_Else$2_correct  (and (=> (= (ControlFlow 0 113490) (- 0 158935)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$addr@@2))))))))))))))) (=> (= (ControlFlow 0 113490) (- 0 159013)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$window_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_limits_definition_$def_verify$0$window_addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$window_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@4)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_limits_definition_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$AccountLimits_update_limits_definition_$def_verify$0$window_addr@@0)))) $AccountLimits_Window_limit_address)))))))))))))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 113244) 113490)) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon65_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 113298) 113490))) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon65_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3)) (and (=> (= (ControlFlow 0 113234) 113298) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 113234) 113244) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$AccountLimits_LimitsDefinition_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 113112) (- 0 158746)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 113112) (- 0 158765)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 113112) (- 0 158784)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 113112) (- 0 158803)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 113112) 113234) inline$$WritebackToGlobal$0$anon0_correct@@0)))))))))))
(let ((inline$$AccountLimits_LimitsDefinition_$pack_ref$0$Entry_correct  (=> (and (= inline$$AccountLimits_LimitsDefinition_$pack_ref$0$$after@0 (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3)) (= (ControlFlow 0 113030) 113112)) inline$$AccountLimits_LimitsDefinition_$pack_ref$0$anon0_correct)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon65_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$3$dst@1)) (= (ControlFlow 0 113116) 113030)) inline$$AccountLimits_LimitsDefinition_$pack_ref$0$Entry_correct)))
(let ((inline$$Gt$3$anon0_correct  (=> (= inline$$Gt$3$dst@1 ($Boolean (> (|i#$Integer| new_time_period) (|i#$Integer| inline$$AccountLimits_update_limits_definition_$def_verify$0$$t27@1)))) (and (=> (= (ControlFlow 0 112912) 113620) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 112912) 113116) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$Gt$3$Entry_correct  (and (=> (= (ControlFlow 0 112898) (- 0 158704)) true) (=> (= (ControlFlow 0 112898) 112912) inline$$Gt$3$anon0_correct))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$L10_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$t27@1 ($Integer 0)) (= (ControlFlow 0 112918) 112898)) inline$$Gt$3$Entry_correct)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon40$1_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3 |inline$$WritebackToReference$1$dst'@2@@2|) (= (ControlFlow 0 114928) 112918)) inline$$AccountLimits_update_limits_definition_$def_verify$0$L10_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@2 inline$$WritebackToReference$1$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@2| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2) (= (ControlFlow 0 114864) 114928)) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon40$1_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@2 inline$$WritebackToReference$1$srcPath@1@@2)) (= |inline$$WritebackToReference$1$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2) inline$$WritebackToReference$1$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@2|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@2| |inline$$WritebackToReference$1$dst'@1@@2|) (= (ControlFlow 0 114920) 114928))) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon40$1_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (= inline$$WritebackToReference$1$dstPath@1@@2 (|p#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2))) (and (=> (= (ControlFlow 0 114828) 114920) inline$$WritebackToReference$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 114828) 114864) inline$$WritebackToReference$1$anon3_Else_correct@@2)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 114691) 114828)) inline$$WritebackToReference$1$anon0_correct@@2)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon64_Then_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$trace_temp@3 (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2)) (= (ControlFlow 0 114938) 114828)) inline$$WritebackToReference$1$anon0_correct@@2)))
(let ((inline$$WriteRef$1$anon0_correct@@2  (=> (= |inline$$WriteRef$1$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@2) (|p#$Mutation| inline$$BorrowField$1$dst@1@@2) new_max_holding_balance)) (and (=> (= (ControlFlow 0 114677) 114938) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 114677) 114691) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@2  (=> (= inline$$BorrowField$1$p@1@@2 (|p#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2)) (=> (and (and (= inline$$BorrowField$1$size@1@@2 (|size#$Path| inline$$BorrowField$1$p@1@@2)) (= inline$$BorrowField$1$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@2) inline$$BorrowField$1$size@1@@2 $AccountLimits_LimitsDefinition_max_holding) (+ inline$$BorrowField$1$size@1@@2 1)))) (and (= inline$$BorrowField$1$dst@1@@2 ($Mutation (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2) inline$$BorrowField$1$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2))) $AccountLimits_LimitsDefinition_max_holding))) (= (ControlFlow 0 114618) 114677))) inline$$WriteRef$1$anon0_correct@@2))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon63_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$2$dst@1) (= (ControlFlow 0 114624) 114618)) inline$$BorrowField$1$anon0_correct@@2)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon63_Else_correct  (=> (not (|b#$Boolean| inline$$Gt$2$dst@1)) (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@3 inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2) (= (ControlFlow 0 112850) 112918)) inline$$AccountLimits_update_limits_definition_$def_verify$0$L10_correct))))
(let ((inline$$Gt$2$anon0_correct  (=> (= inline$$Gt$2$dst@1 ($Boolean (> (|i#$Integer| new_max_holding_balance) (|i#$Integer| inline$$AccountLimits_update_limits_definition_$def_verify$0$$t24@1)))) (and (=> (= (ControlFlow 0 112834) 114624) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 112834) 112850) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$Gt$2$Entry_correct  (and (=> (= (ControlFlow 0 112820) (- 0 158418)) true) (=> (= (ControlFlow 0 112820) 112834) inline$$Gt$2$anon0_correct))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$L7_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$t24@1 ($Integer 0)) (= (ControlFlow 0 112840) 112820)) inline$$Gt$2$Entry_correct)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon36$1_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2 |inline$$WritebackToReference$2$dst'@2@@0|) (= (ControlFlow 0 115370) 112840)) inline$$AccountLimits_update_limits_definition_$def_verify$0$L7_correct)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@0| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1) (= (ControlFlow 0 115306) 115370)) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon36$1_correct))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0)) (= |inline$$WritebackToReference$2$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1) inline$$WritebackToReference$2$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@2|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@0| |inline$$WritebackToReference$2$dst'@1@@0|) (= (ControlFlow 0 115362) 115370))) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon36$1_correct)))
(let ((inline$$WritebackToReference$2$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@2|)) (= inline$$WritebackToReference$2$dstPath@1@@0 (|p#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1))) (and (=> (= (ControlFlow 0 115270) 115362) inline$$WritebackToReference$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 115270) 115306) inline$$WritebackToReference$2$anon3_Else_correct@@0)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 115133) 115270)) inline$$WritebackToReference$2$anon0_correct@@0)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon62_Then_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1)) (= (ControlFlow 0 115380) 115270)) inline$$WritebackToReference$2$anon0_correct@@0)))
(let ((inline$$WriteRef$2$anon0_correct@@2  (=> (= |inline$$WriteRef$2$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@2) (|p#$Mutation| inline$$BorrowField$2$dst@1@@2) new_max_outflow)) (and (=> (= (ControlFlow 0 115119) 115380) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 115119) 115133) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct@@2  (=> (= inline$$BorrowField$2$p@1@@2 (|p#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1)) (=> (and (and (= inline$$BorrowField$2$size@1@@2 (|size#$Path| inline$$BorrowField$2$p@1@@2)) (= inline$$BorrowField$2$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@2) inline$$BorrowField$2$size@1@@2 $AccountLimits_LimitsDefinition_max_outflow) (+ inline$$BorrowField$2$size@1@@2 1)))) (and (= inline$$BorrowField$2$dst@1@@2 ($Mutation (|l#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1) inline$$BorrowField$2$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1))) $AccountLimits_LimitsDefinition_max_outflow))) (= (ControlFlow 0 115060) 115119))) inline$$WriteRef$2$anon0_correct@@2))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon61_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$1$dst@1) (= (ControlFlow 0 115066) 115060)) inline$$BorrowField$2$anon0_correct@@2)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon61_Else_correct  (=> (not (|b#$Boolean| inline$$Gt$1$dst@1)) (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@2 inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1) (= (ControlFlow 0 112772) 112840)) inline$$AccountLimits_update_limits_definition_$def_verify$0$L7_correct))))
(let ((inline$$Gt$1$anon0_correct  (=> (= inline$$Gt$1$dst@1 ($Boolean (> (|i#$Integer| new_max_outflow) (|i#$Integer| inline$$AccountLimits_update_limits_definition_$def_verify$0$$t21@1)))) (and (=> (= (ControlFlow 0 112756) 115066) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 112756) 112772) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$Gt$1$Entry_correct  (and (=> (= (ControlFlow 0 112742) (- 0 158132)) true) (=> (= (ControlFlow 0 112742) 112756) inline$$Gt$1$anon0_correct))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$L4_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$t21@1 ($Integer 0)) (= (ControlFlow 0 112762) 112742)) inline$$Gt$1$Entry_correct)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon32$1_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1 |inline$$WritebackToReference$3$dst'@2|) (= (ControlFlow 0 115812) 112762)) inline$$AccountLimits_update_limits_definition_$def_verify$0$L4_correct)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 115748) 115812)) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon32$1_correct))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1)) (= |inline$$WritebackToReference$3$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$3$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$3$to'@1|))))) (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$3$dst'@1|) (= (ControlFlow 0 115804) 115812))) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon32$1_correct)))
(let ((inline$$WritebackToReference$3$anon0_correct  (=> (and (= inline$$WritebackToReference$3$srcPath@1 (|p#$Mutation| |inline$$WriteRef$3$to'@1|)) (= inline$$WritebackToReference$3$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 115712) 115804) inline$$WritebackToReference$3$anon3_Then_correct) (=> (= (ControlFlow 0 115712) 115748) inline$$WritebackToReference$3$anon3_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 115575) 115712)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon60_Then_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 115822) 115712)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@2) (|p#$Mutation| inline$$BorrowField$3$dst@1@@2) new_max_inflow)) (and (=> (= (ControlFlow 0 115561) 115822) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 115561) 115575) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct@@2  (=> (= inline$$BorrowField$3$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$3$size@1@@2 (|size#$Path| inline$$BorrowField$3$p@1@@2)) (= inline$$BorrowField$3$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@2) inline$$BorrowField$3$size@1@@2 $AccountLimits_LimitsDefinition_max_inflow) (+ inline$$BorrowField$3$size@1@@2 1)))) (and (= inline$$BorrowField$3$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$3$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $AccountLimits_LimitsDefinition_max_inflow))) (= (ControlFlow 0 115502) 115561))) inline$$WriteRef$3$anon0_correct))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon59_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1@@0) (= (ControlFlow 0 115508) 115502)) inline$$BorrowField$3$anon0_correct@@2)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon59_Else_correct  (=> (not (|b#$Boolean| inline$$Gt$0$dst@1@@0)) (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$limits_def@1 inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 112694) 112762)) inline$$AccountLimits_update_limits_definition_$def_verify$0$L4_correct))))
(let ((inline$$Gt$0$anon0_correct@@0  (=> (= inline$$Gt$0$dst@1@@0 ($Boolean (> (|i#$Integer| new_max_inflow) (|i#$Integer| inline$$AccountLimits_update_limits_definition_$def_verify$0$$t18@1)))) (and (=> (= (ControlFlow 0 112678) 115508) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 112678) 112694) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Gt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 112664) (- 0 157846)) true) (=> (= (ControlFlow 0 112664) 112678) inline$$Gt$0$anon0_correct@@0))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon57_Else$1_correct  (=> (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$t18@1 ($Integer 0)) (= (ControlFlow 0 112684) 112664)) inline$$Gt$0$Entry_correct@@0)))
(let ((inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$$before@0)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$$before@0)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$$before@0)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$$before@0)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0)))))) (= (ControlFlow 0 112612) 112684)) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon57_Else$1_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$Entry_correct  (=> (and (= inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 112606) 112612)) inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$anon0_correct)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon57_Else_correct  (=> (and (not $abort_flag@2@@6) (= (ControlFlow 0 112616) 112606)) inline$$AccountLimits_LimitsDefinition_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@2@@6 true) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 112566) 115826) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 112566) 112616) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 112564) 112566)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0)))) (and (= $abort_flag@2@@6 $abort_flag@1@@7) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 112512) 115826) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 112512) 112616) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| limit_address@@0)) (and (=> (= (ControlFlow 0 112482) 112564) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 112482) 112512) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (=> (= inline$$BorrowGlobal$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1)) (and (=> (= (ControlFlow 0 112476) (- 0 157730)) true) (=> (= (ControlFlow 0 112476) 112482) inline$$BorrowGlobal$0$anon0_correct@@0)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon55_Then_correct  (=> (and (|b#$Boolean| inline$$AccountLimits_update_limits_definition_$def_verify$0$$t15@1) (= (ControlFlow 0 112572) 112476)) inline$$BorrowGlobal$0$Entry_correct@@0)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon56_Else_correct true))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon56_Then_correct true))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon55_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountLimits_update_limits_definition_$def_verify$0$$t15@1)) (= $abort_code@3@@6 (|i#$Integer| call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 112339) 112359) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 112339) 112345) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon53_Else_correct  (=> (not $abort_flag@1@@7) (and (=> (= (ControlFlow 0 112327) 112572) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 112327) 112339) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon51_Else_correct  (=> (and (not $abort_flag@0@@8) (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$t15@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| limit_address@@0))))) (=> (and (and (and (= inline$$AccountLimits_update_limits_definition_$def_verify$0$$t16@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@7)) (and (=> $abort_flag@1@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@11) (>= (|i#$Integer| call3formal@$ret0@0@@11) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@11) $MAX_U64))) (and (=> (= (ControlFlow 0 112321) 115846) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 112321) 112327) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon53_Else_correct))))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon12$6_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@0@@8) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@8) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@0@@8)) (and (=> $abort_flag@0@@8 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@0@@8 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@1@@7 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@7 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@1@@7 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 112291) 115866) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 112291) 112321) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon51_Else_correct))))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 112085) 112291)) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon12$6_correct)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 115890) 112291) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon12$6_correct)))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon49_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 112077) 115890) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 112077) 112085) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon49_Then_correct  (and (=> (= (ControlFlow 0 115898) 115890) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 115898) 112085) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon50_Else_correct))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon48_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 112069) 115898) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 112069) 112077) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon48_Then_correct  (and (=> (= (ControlFlow 0 115906) 115898) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 115906) 112077) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon49_Else_correct))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon47_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 112061) 115906) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 112061) 112069) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon47_Then_correct  (and (=> (= (ControlFlow 0 115914) 115906) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 115914) 112069) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon48_Else_correct))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon46_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 112053) 115914) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 112053) 112061) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon46_Then_correct  (and (=> (= (ControlFlow 0 115922) 115914) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 115922) 112061) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon47_Else_correct))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 112045) 115922) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 112045) 112053) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 115930) 115922) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 115930) 112053) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon46_Else_correct))))
(let ((inline$$AccountLimits_update_limits_definition_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 112039) 115930) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 112039) 112045) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon45_Else_correct)))))
(let ((anon0$1_correct@@11  (=> (and (and (forall (($inv_addr@@23 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23)) (let ((va@@41 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))
)) (forall (($inv_addr@@24 Int) ($inv_tv0@@14 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24)) (let ((va@@42 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@24))
))) (and (|b#$Boolean| ($Boolean (forall ((window_addr@@9 T@$Value) )  (=> ((_ is $Address) window_addr@@9) (|b#$Boolean| ($Boolean (forall ((coin_type@@9 T@$Value) )  (=> ((_ is $Type) coin_type@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@9)) 1) (|a#$Address| window_addr@@9)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@9)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@9)) 1) (|a#$Address| window_addr@@9)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 115934) 112039))) inline$$AccountLimits_update_limits_definition_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@11  (=> (and ((_ is $Address) tc_account) ((_ is $Address) limit_address@@0)) (=> (and (and ((_ is $Integer) new_max_inflow) (>= (|i#$Integer| new_max_inflow) 0)) (<= (|i#$Integer| new_max_inflow) $MAX_U64)) (=> (and (and (and (and ((_ is $Integer) new_max_outflow) (>= (|i#$Integer| new_max_outflow) 0)) (<= (|i#$Integer| new_max_outflow) $MAX_U64)) (and (and ((_ is $Integer) new_max_holding_balance) (>= (|i#$Integer| new_max_holding_balance) 0)) (<= (|i#$Integer| new_max_holding_balance) $MAX_U64))) (and (and (and ((_ is $Integer) new_time_period) (>= (|i#$Integer| new_time_period) 0)) (<= (|i#$Integer| new_time_period) $MAX_U64)) (= (ControlFlow 0 110615) 115934))) anon0$1_correct@@11)))))
(let ((PreconditionGeneratedEntry_correct@@10  (=> (= (ControlFlow 0 156221) 110615) anon0_correct@@11)))
PreconditionGeneratedEntry_correct@@10))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun $abort_flag@2@@7 () Bool)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@0| () T@$Memory)
(declare-fun inline$$AccountLimits_update_window_info_$def_verify$0$window@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@4| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$AccountLimits_update_window_info_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@3 () T@$Mutation)
(declare-fun new_limit_address () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@3 () Int)
(declare-fun inline$$BorrowField$0$p@2@@3 () T@$Path)
(declare-fun inline$$AccountLimits_update_window_info_$def_verify$0$$t14@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun $abort_code@3@@7 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun $tv0@@10 () T@$TypeValue)
(declare-fun inline$$AccountLimits_update_window_info_$def_verify$0$$t15@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@3| () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$AccountLimits_update_window_info_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@3 () T@$Mutation)
(declare-fun aggregate_balance () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@3 () Int)
(declare-fun inline$$BorrowField$1$p@2@@3 () T@$Path)
(declare-fun inline$$AccountLimits_update_window_info_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$AccountLimits_update_window_info_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@1 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun window_address () T@$Value)
(declare-fun tc_account@@0 () T@$Value)
(declare-fun $abort_code@1@@8 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 159774) (let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon36_Else_correct true))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon36_Then_correct true))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon35_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 120085) 120101) inline$$AccountLimits_update_window_info_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 120085) 120091) inline$$AccountLimits_update_window_info_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon38_Else_correct true))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon38_Then_correct true))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon37_Then_correct  (=> $abort_flag@1@@8 (and (=> (= (ControlFlow 0 120065) 120081) inline$$AccountLimits_update_window_info_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 120065) 120071) inline$$AccountLimits_update_window_info_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon42_Else_correct true))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon42_Then_correct true))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon41_Then_correct  (=> $abort_flag@2@@7 (and (=> (= (ControlFlow 0 119603) 119619) inline$$AccountLimits_update_window_info_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 119603) 119609) inline$$AccountLimits_update_window_info_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon30$2_correct  (and (=> (= (ControlFlow 0 119589) (- 0 162105)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$window_addr T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_window_info_$def_verify$0$window_addr) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_window_info_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@0))))))))))))))) (=> (= (ControlFlow 0 119589) (- 0 162183)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@1) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@1)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@1)))) $AccountLimits_Window_limit_address)))))))))))))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@0| $AccountLimits_Window_$memory) (= (ControlFlow 0 119343) 119589)) inline$$AccountLimits_update_window_info_$def_verify$0$anon30$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@0)) (= inline$$WritebackToGlobal$1$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|))) (= |inline$$WritebackToGlobal$1$m'@1@@0| ($Memory (|domain#$Memory| $AccountLimits_Window_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0 inline$$WritebackToGlobal$1$v@1@@0)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@0| |inline$$WritebackToGlobal$1$m'@1@@0|) (= (ControlFlow 0 119397) 119589))) inline$$AccountLimits_update_window_info_$def_verify$0$anon30$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$1$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (and (=> (= (ControlFlow 0 119333) 119397) inline$$WritebackToGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 119333) 119343) inline$$WritebackToGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@3| inline$$AccountLimits_update_window_info_$def_verify$0$window@1) (= (ControlFlow 0 119153) 119333)) inline$$WritebackToGlobal$1$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3)) (= |inline$$WritebackToReference$0$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1) inline$$WritebackToReference$0$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|v#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@4|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@3| |inline$$WritebackToReference$0$dst'@1@@3|) (= (ControlFlow 0 119209) 119333))) inline$$WritebackToGlobal$1$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (= inline$$WritebackToReference$0$dstPath@1@@3 (|p#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1))) (and (=> (= (ControlFlow 0 119117) 119209) inline$$WritebackToReference$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 119117) 119153) inline$$WritebackToReference$0$anon3_Else_correct@@3)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 118980) 119117)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon45_Then_correct  (=> (and (= inline$$AccountLimits_update_window_info_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1)) (= (ControlFlow 0 119599) 119117)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$WriteRef$0$anon0_correct@@4  (=> (= |inline$$WriteRef$0$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@3) (|p#$Mutation| inline$$BorrowField$0$dst@1@@3) new_limit_address)) (and (=> (= (ControlFlow 0 118966) 119599) inline$$AccountLimits_update_window_info_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 118966) 118980) inline$$AccountLimits_update_window_info_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@3  (=> (= inline$$BorrowField$0$p@1@@3 (|p#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@3 (|size#$Path| inline$$BorrowField$0$p@1@@3)) (= inline$$BorrowField$0$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@3) inline$$BorrowField$0$size@1@@3 $AccountLimits_Window_limit_address) (+ inline$$BorrowField$0$size@1@@3 1)))) (and (= inline$$BorrowField$0$dst@1@@3 ($Mutation (|l#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1) inline$$BorrowField$0$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1))) $AccountLimits_Window_limit_address))) (= (ControlFlow 0 118907) 118966))) inline$$WriteRef$0$anon0_correct@@4))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon43_Then_correct  (=> (and (|b#$Boolean| inline$$AccountLimits_update_window_info_$def_verify$0$$t14@1) (= (ControlFlow 0 118913) 118907)) inline$$BorrowField$0$anon0_correct@@3)))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon44_Else_correct true))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon44_Then_correct true))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon43_Else$1_correct  (and (=> (= (ControlFlow 0 118765) (- 0 161560)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@2) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@2)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@3) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@3))))))))))))))) (and (=> (= (ControlFlow 0 118765) (- 0 161638)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@4) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@4)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@4)))) $AccountLimits_Window_limit_address))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@5 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@5) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@5)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_window_info_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$AccountLimits_update_window_info_$def_verify$0$window_addr@@5)))) $AccountLimits_Window_limit_address)))))))))))))))) (=> (= $abort_code@3@@7 (|i#$Integer| call3formal@$ret0@0@@12)) (and (=> (= (ControlFlow 0 118765) 118785) inline$$AccountLimits_update_window_info_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 118765) 118771) inline$$AccountLimits_update_window_info_$def_verify$0$anon44_Else_correct)))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@1| $AccountLimits_Window_$memory) (= (ControlFlow 0 118515) 118765)) inline$$AccountLimits_update_window_info_$def_verify$0$anon43_Else$1_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1))) (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $AccountLimits_Window_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@1|) (= (ControlFlow 0 118569) 118765))) inline$$AccountLimits_update_window_info_$def_verify$0$anon43_Else$1_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| inline$$AccountLimits_update_window_info_$def_verify$0$window@1)) (and (=> (= (ControlFlow 0 118505) 118569) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 118505) 118515) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon43_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountLimits_update_window_info_$def_verify$0$$t14@1)) (= (ControlFlow 0 118575) 118505)) inline$$WritebackToGlobal$0$anon0_correct@@1)))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon41_Else_correct  (=> (not $abort_flag@2@@7) (and (=> (= (ControlFlow 0 118381) 118913) inline$$AccountLimits_update_window_info_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 118381) 118575) inline$$AccountLimits_update_window_info_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$L2_correct  (=> (= inline$$AccountLimits_update_window_info_$def_verify$0$$t14@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| new_limit_address)))) (=> (and (and (and (= inline$$AccountLimits_update_window_info_$def_verify$0$$t15@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@7)) (and (=> $abort_flag@2@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 118375) 119603) inline$$AccountLimits_update_window_info_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 118375) 118381) inline$$AccountLimits_update_window_info_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon20$1_correct  (=> (and (= inline$$AccountLimits_update_window_info_$def_verify$0$window@1 |inline$$WritebackToReference$1$dst'@2@@3|) (= (ControlFlow 0 120051) 118375)) inline$$AccountLimits_update_window_info_$def_verify$0$L2_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@3 inline$$WritebackToReference$1$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@3| inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 119987) 120051)) inline$$AccountLimits_update_window_info_$def_verify$0$anon20$1_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@3 inline$$WritebackToReference$1$srcPath@1@@3)) (= |inline$$WritebackToReference$1$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$WritebackToReference$1$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@3|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@3| |inline$$WritebackToReference$1$dst'@1@@3|) (= (ControlFlow 0 120043) 120051))) inline$$AccountLimits_update_window_info_$def_verify$0$anon20$1_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (= inline$$WritebackToReference$1$dstPath@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) (and (=> (= (ControlFlow 0 119951) 120043) inline$$WritebackToReference$1$anon3_Then_correct@@3) (=> (= (ControlFlow 0 119951) 119987) inline$$WritebackToReference$1$anon3_Else_correct@@3)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 119814) 119951)) inline$$WritebackToReference$1$anon0_correct@@3)))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon40_Then_correct  (=> (and (= inline$$AccountLimits_update_window_info_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 120061) 119951)) inline$$WritebackToReference$1$anon0_correct@@3)))
(let ((inline$$WriteRef$1$anon0_correct@@3  (=> (= |inline$$WriteRef$1$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@3) (|p#$Mutation| inline$$BorrowField$1$dst@1@@3) aggregate_balance)) (and (=> (= (ControlFlow 0 119800) 120061) inline$$AccountLimits_update_window_info_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 119800) 119814) inline$$AccountLimits_update_window_info_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@3  (=> (= inline$$BorrowField$1$p@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@3 (|size#$Path| inline$$BorrowField$1$p@1@@3)) (= inline$$BorrowField$1$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@3) inline$$BorrowField$1$size@1@@3 $AccountLimits_Window_tracked_balance) (+ inline$$BorrowField$1$size@1@@3 1)))) (and (= inline$$BorrowField$1$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$1$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $AccountLimits_Window_tracked_balance))) (= (ControlFlow 0 119741) 119800))) inline$$WriteRef$1$anon0_correct@@3))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$AccountLimits_update_window_info_$def_verify$0$$t12@1) (= (ControlFlow 0 119747) 119741)) inline$$BorrowField$1$anon0_correct@@3)))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon39_Else_correct  (=> (not (|b#$Boolean| inline$$AccountLimits_update_window_info_$def_verify$0$$t12@1)) (=> (and (= inline$$AccountLimits_update_window_info_$def_verify$0$window@1 inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 118349) 118375)) inline$$AccountLimits_update_window_info_$def_verify$0$L2_correct))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon37_Else_correct  (=> (not $abort_flag@1@@8) (=> (and (= inline$$AccountLimits_update_window_info_$def_verify$0$$t11@1 ($Integer 0)) (= inline$$AccountLimits_update_window_info_$def_verify$0$$t12@1 ($Boolean  (not ($IsEqual_stratified aggregate_balance inline$$AccountLimits_update_window_info_$def_verify$0$$t11@1))))) (and (=> (= (ControlFlow 0 118341) 119747) inline$$AccountLimits_update_window_info_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 118341) 118349) inline$$AccountLimits_update_window_info_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@1@@8 true) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 118313) 120065) inline$$AccountLimits_update_window_info_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 118313) 118341) inline$$AccountLimits_update_window_info_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 118311) 118313)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1) (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1)))) (and (= $abort_flag@1@@8 $abort_flag@0@@9) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 118259) 120065) inline$$AccountLimits_update_window_info_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 118259) 118341) inline$$AccountLimits_update_window_info_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| window_address)) (and (=> (= (ControlFlow 0 118229) 118311) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 118229) 118259) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (=> (= inline$$BorrowGlobal$0$ta@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (and (=> (= (ControlFlow 0 118223) (- 0 160985)) true) (=> (= (ControlFlow 0 118223) 118229) inline$$BorrowGlobal$0$anon0_correct@@1)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon35_Else_correct  (=> (and (not $abort_flag@0@@9) (= (ControlFlow 0 118319) 118223)) inline$$BorrowGlobal$0$Entry_correct@@1)))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon8$4_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) $abort_flag@0@@9) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@9) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) $abort_flag@0@@9)) (and (=> $abort_flag@0@@9 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))))) (=> $abort_flag@0@@9 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (= $abort_code@1@@8 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@8 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) (= $abort_code@1@@8 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 118106) 120085) inline$$AccountLimits_update_window_info_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 118106) 118319) inline$$AccountLimits_update_window_info_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 117968) 118106)) inline$$AccountLimits_update_window_info_$def_verify$0$anon8$4_correct)))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 120109) 118106) inline$$AccountLimits_update_window_info_$def_verify$0$anon8$4_correct)))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 117960) 120109) inline$$AccountLimits_update_window_info_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 117960) 117968) inline$$AccountLimits_update_window_info_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 120117) 120109) inline$$AccountLimits_update_window_info_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 120117) 117968) inline$$AccountLimits_update_window_info_$def_verify$0$anon34_Else_correct))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon32_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 117952) 120117) inline$$AccountLimits_update_window_info_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 117952) 117960) inline$$AccountLimits_update_window_info_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon32_Then_correct  (and (=> (= (ControlFlow 0 120125) 120117) inline$$AccountLimits_update_window_info_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 120125) 117960) inline$$AccountLimits_update_window_info_$def_verify$0$anon33_Else_correct))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon31_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 117944) 120125) inline$$AccountLimits_update_window_info_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 117944) 117952) inline$$AccountLimits_update_window_info_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon31_Then_correct  (and (=> (= (ControlFlow 0 120133) 120125) inline$$AccountLimits_update_window_info_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 120133) 117952) inline$$AccountLimits_update_window_info_$def_verify$0$anon32_Else_correct))))
(let ((inline$$AccountLimits_update_window_info_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 117938) 120133) inline$$AccountLimits_update_window_info_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 117938) 117944) inline$$AccountLimits_update_window_info_$def_verify$0$anon31_Else_correct)))))
(let ((anon0$1_correct@@12  (=> (forall (($inv_addr@@25 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25)) (let ((va@@43 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))
)) (=> (and (and (forall (($inv_addr@@26 Int) ($inv_tv0@@15 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26)) (let ((va@@44 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@26))
)) (forall (($inv_addr@@27 Int) ($inv_tv0@@16 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27)) (let ((va@@45 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@27))
))) (and (|b#$Boolean| ($Boolean (forall ((window_addr@@10 T@$Value) )  (=> ((_ is $Address) window_addr@@10) (|b#$Boolean| ($Boolean (forall ((coin_type@@10 T@$Value) )  (=> ((_ is $Type) coin_type@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@10)) 1) (|a#$Address| window_addr@@10)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@10)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@10)) 1) (|a#$Address| window_addr@@10)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 120137) 117938))) inline$$AccountLimits_update_window_info_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@12  (=> (and ((_ is $Address) tc_account@@0) ((_ is $Address) window_address)) (=> (and (and (and ((_ is $Integer) aggregate_balance) (>= (|i#$Integer| aggregate_balance) 0)) (<= (|i#$Integer| aggregate_balance) $MAX_U64)) (and ((_ is $Address) new_limit_address) (= (ControlFlow 0 116735) 120137))) anon0$1_correct@@12))))
(let ((PreconditionGeneratedEntry_correct@@11  (=> (= (ControlFlow 0 159774) 116735) anon0_correct@@12)))
PreconditionGeneratedEntry_correct@@11)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@11 () T@$TypeValue)
(declare-fun addr@@3 () T@$Value)
(declare-fun $abort_flag@3@@5 () Bool)
(declare-fun amount@@2 () T@$Value)
(declare-fun $abort_code@6@@5 () Int)
(declare-fun inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $AccountLimits_Window_$memory@0@@1 () T@$Memory)
(declare-fun $abort_code@4@@6 () Int)
(declare-fun call5formal@$ret0@0@@2 () T@$Value)
(declare-fun $abort_flag@2@@8 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@2 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@2 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@2 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@2 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@5| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@2| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@2 () T@$Mutation)
(declare-fun call6formal@$ret1@0@@0 () T@$Value)
(declare-fun inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@5@@5 () Int)
(declare-fun $abort_code@1@@9 () Int)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun $abort_code@3@@8 () Int)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun inline$$ReadRef$0$v@1@@3 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@2 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@2 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@2 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@2@@6 () Int)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$t8@1 () T@$Value)
(declare-fun _cap@@0 () T@$Value)
(declare-fun $AccountLimits_Window_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 162331) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 122622) (- 0 166520)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))))) $abort_flag@3@@5)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))))) $abort_flag@3@@5) (and (=> (= (ControlFlow 0 122622) (- 0 166550)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)))))))) $abort_flag@3@@5)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)))))))) $abort_flag@3@@5) (and (=> (= (ControlFlow 0 122622) (- 0 166602)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@195 (|l#$ValueArray| (let ((len@@196 (|l#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1)))) len@@196 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@196 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@196 (|l#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1)))) len@@196 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@196 1)))) len@@195 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@195 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@3@@5)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@195 (|l#$ValueArray| (let ((len@@196 (|l#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1)))) len@@196 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@196 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@196 (|l#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1)))) len@@196 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@196 1)))) len@@195 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@195 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@3@@5) (and (=> (= (ControlFlow 0 122622) (- 0 166699)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@3@@5)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@3@@5) (and (=> (= (ControlFlow 0 122622) (- 0 166815)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3@@5)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3@@5) (and (=> (= (ControlFlow 0 122622) (- 0 166869)) (=> $abort_flag@3@@5 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@200 (|l#$ValueArray| (let ((len@@201 (|l#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1)))) len@@201 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@201 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@201 (|l#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1)))) len@@201 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@201 1)))) len@@200 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@200 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (=> (=> $abort_flag@3@@5 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@200 (|l#$ValueArray| (let ((len@@201 (|l#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1)))) len@@201 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@201 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@201 (|l#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1)))) len@@201 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@201 1)))) len@@200 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@200 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (=> (= (ControlFlow 0 122622) (- 0 167214)) (=> $abort_flag@3@@5 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@205 (|l#$ValueArray| (let ((len@@206 (|l#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1)))) len@@206 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@206 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@206 (|l#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1)))) len@@206 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@206 1)))) len@@205 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@205 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@3@@5 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@205 (|l#$ValueArray| (let ((len@@206 (|l#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1)))) len@@206 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@206 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@206 (|l#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1)))) len@@206 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@206 1)))) len@@205 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@205 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 122622) (- 0 167614)) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@210 (|l#$ValueArray| (let ((len@@211 (|l#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1)))) len@@211 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@211 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@211 (|l#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1)))) len@@211 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@211 1)))) len@@210 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@210 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow)))))))))))) (=> (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@210 (|l#$ValueArray| (let ((len@@211 (|l#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1)))) len@@211 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@211 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@211 (|l#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1)))) len@@211 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@211 1)))) len@@210 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@210 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))) (=> (= (ControlFlow 0 122622) (- 0 167655)) (=> (not $abort_flag@3@@5) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))))))))) ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))))))) $AccountLimits_Window_tracked_balance (ite (|b#$Boolean| ($Boolean (>= (|i#$Integer| amount@@2) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_tracked_balance))))) ($Integer 0) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@2))))) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))))))))))))) ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)) (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@220 (|l#$ValueArray| (let ((len@@221 (|l#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1)))) len@@221 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@221 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@221 (|l#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1)))) len@@221 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_tracked_balance)) (+ len@@221 1)))) len@@220 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) $AccountLimits_Window_limit_address)) (+ len@@220 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))))))))))))))))))))))))))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon24_correct  (=> (= $abort_code@6@@5 $abort_code@4@@6) (=> (and (and (= inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$ret0@2 call5formal@$ret0@0@@2) (= $abort_flag@3@@5 $abort_flag@2@@8)) (and (= $AccountLimits_Window_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@2|) (= (ControlFlow 0 122522) 122622))) anon0$2_correct@@8))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 122520) 122522)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon24_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 122530) 122522) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon24_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon34_Else$2_correct  (and (=> (= (ControlFlow 0 122514) (- 0 166229)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@0))))))))))))))) (and (=> (= (ControlFlow 0 122514) (- 0 166307)) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@1) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@1)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@1)))) $AccountLimits_Window_limit_address))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@2) (|b#$Boolean| ($Boolean (forall ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@2)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$window_addr@@2)))) $AccountLimits_Window_limit_address)))))))))))))))) (and (=> (= (ControlFlow 0 122514) 122530) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 122514) 122520) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon36_Else_correct))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@2  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@2| $AccountLimits_Window_$memory) (= (ControlFlow 0 122266) 122514)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon34_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@2  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@2 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@2)) (= inline$$WritebackToGlobal$0$a@1@@2 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@2))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@2 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@5|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@5|))) (= |inline$$WritebackToGlobal$0$m'@1@@2| ($Memory (|domain#$Memory| $AccountLimits_Window_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2 inline$$WritebackToGlobal$0$v@1@@2)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@2| |inline$$WritebackToGlobal$0$m'@1@@2|) (= (ControlFlow 0 122320) 122514))) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon34_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@2  (=> (= inline$$WritebackToGlobal$0$l@1@@2 (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (and (=> (= (ControlFlow 0 122256) 122320) inline$$WritebackToGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 122256) 122266) inline$$WritebackToGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$WriteRef$0$anon0_correct@@5  (=> (and (= |inline$$WriteRef$0$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) call6formal@$ret1@0@@0)) (= (ControlFlow 0 122132) 122256)) inline$$WritebackToGlobal$0$anon0_correct@@2)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@8) (= (ControlFlow 0 122138) 122132)) inline$$WriteRef$0$anon0_correct@@5)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$Abort_correct  (=> (and (= inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$ret0@1 $Error) (= $abort_code@6@@5 $abort_code@5@@5)) (=> (and (and (= inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$ret0@2 inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$ret0@1) (= $abort_flag@3@@5 true)) (and (= $AccountLimits_Window_$memory@0@@1 $AccountLimits_Window_$memory) (= (ControlFlow 0 121782) 122622))) anon0$2_correct@@8))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon9_correct  (=> (and (= $abort_code@5@@5 $abort_code@1@@9) (= (ControlFlow 0 122582) 121782)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 122580) 122582)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 122590) 122582) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon9_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@10 (and (=> (= (ControlFlow 0 122574) 122590) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 122574) 122580) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon17_correct  (=> (and (= $abort_code@5@@5 $abort_code@3@@8) (= (ControlFlow 0 122562) 121782)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 122560) 122562)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon17_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 122570) 122562) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon17_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon32_Then_correct  (=> $abort_flag@1@@9 (and (=> (= (ControlFlow 0 122554) 122570) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 122554) 122560) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon21_correct  (=> (and (= $abort_code@5@@5 $abort_code@4@@6) (= (ControlFlow 0 122542) 121782)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 122540) 122542)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 122550) 122542) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon21_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon34_Then_correct  (=> $abort_flag@2@@8 (and (=> (= (ControlFlow 0 122534) 122550) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 122534) 122540) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon32_Else$1_correct  (and (=> (= (ControlFlow 0 122075) (- 0 165360)) true) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)))))))) $abort_flag@2@@8) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@225 (|l#$ValueArray| (let ((len@@226 (|l#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1)))) len@@226 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@226 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@226 (|l#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1)))) len@@226 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@226 1)))) len@@225 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@225 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@2@@8) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@2@@8)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2@@8) (=> $abort_flag@2@@8 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@230 (|l#$ValueArray| (let ((len@@231 (|l#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1)))) len@@231 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@231 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@231 (|l#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1)))) len@@231 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@231 1)))) len@@230 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@230 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (and (and (=> $abort_flag@2@@8 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)))))))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@235 (|l#$ValueArray| (let ((len@@236 (|l#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1)))) len@@236 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@236 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@236 (|l#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1)))) len@@236 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@236 1)))) len@@235 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@235 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call5formal@$ret0@0@@2 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@240 (|l#$ValueArray| (let ((len@@241 (|l#$ValueArray| (let ((len@@242 (|l#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1)))) len@@242 ($Integer 0)) (+ len@@242 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@242 (|l#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1)))) len@@242 ($Integer 0)) (+ len@@242 1)))) len@@241 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@241 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@241 (|l#$ValueArray| (let ((len@@242 (|l#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1)))) len@@242 ($Integer 0)) (+ len@@242 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@242 (|l#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1)))) len@@242 ($Integer 0)) (+ len@@242 1)))) len@@241 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@241 1)))) len@@240 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@240 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow)))))))))))) (and (=> (not $abort_flag@2@@8) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| call5formal@$ret0@0@@2) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))))))))) ($Boolean ($IsEqual_stratified call6formal@$ret1@0@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@245 (|l#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1)))) len@@245 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@245 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_window_outflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@245 (|l#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1)))) len@@245 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@245 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@245 (|l#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1)))) len@@245 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@245 1)))) inline$$ReadRef$0$v@1@@3))))))) $AccountLimits_Window_tracked_balance (ite (|b#$Boolean| ($Boolean (>= (|i#$Integer| amount@@2) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@245 (|l#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1)))) len@@245 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@245 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_tracked_balance))))) ($Integer 0) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@245 (|l#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1)))) len@@245 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@245 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount@@2))))) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@245 (|l#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1)))) len@@245 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@245 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_window_outflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@245 (|l#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1)))) len@@245 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@245 1)))) inline$$ReadRef$0$v@1@@3))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount@@2)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@245 (|l#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@246 1)))) len@@245 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@245 1)))) inline$$ReadRef$0$v@1@@3))))))))))) ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified call6formal@$ret1@0@@0 (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@250 (|l#$ValueArray| (let ((len@@251 (|l#$ValueArray| (let ((len@@252 (|l#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1)))) len@@252 ($Integer 0)) (+ len@@252 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@252 (|l#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1)))) len@@252 ($Integer 0)) (+ len@@252 1)))) len@@251 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@251 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@251 (|l#$ValueArray| (let ((len@@252 (|l#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1)))) len@@252 ($Integer 0)) (+ len@@252 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@252 (|l#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1)))) len@@252 ($Integer 0)) (+ len@@252 1)))) len@@251 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_tracked_balance)) (+ len@@251 1)))) len@@250 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $AccountLimits_Window_limit_address)) (+ len@@250 1)))) inline$$ReadRef$0$v@1@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified call6formal@$ret1@0@@0 inline$$ReadRef$0$v@1@@3)))))))) ((_ is $Boolean) call5formal@$ret0@0@@2)))) (=> (and (and (and (and (and (and (and ((_ is $Vector) call6formal@$ret1@0@@0) (let ((va@@46 (|v#$Vector| call6formal@$ret1@0@@0)))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $AccountLimits_Window_limit_address))) (and (=> (= (ControlFlow 0 122075) 122534) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 122075) 122138) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon34_Else_correct))))))))
(let ((inline$$ReadRef$0$anon0_correct@@3  (=> (and (= inline$$ReadRef$0$v@1@@3 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (= (ControlFlow 0 122063) 122075)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon32_Else$1_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon32_Else_correct  (=> (and (not $abort_flag@1@@9) (= (ControlFlow 0 122069) 122063)) inline$$ReadRef$0$anon0_correct@@3)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@1@@9 true) (=> (and (= $abort_code@3@@8 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 122019) 122554) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 122019) 122069) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2)) (= (ControlFlow 0 122017) 122019)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@2  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@2 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2))) (= $abort_flag@1@@9 $abort_flag@0@@10)) (and (= $abort_code@3@@8 $abort_code@1@@9) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 121965) 122554) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 121965) 122069) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@2  (=> (= inline$$BorrowGlobal$0$a@1@@2 (|a#$Address| addr@@3)) (and (=> (= (ControlFlow 0 121935) 122017) inline$$BorrowGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 121935) 121965) inline$$BorrowGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@2  (=> (= inline$$BorrowGlobal$0$ta@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1)) (and (=> (= (ControlFlow 0 121929) (- 0 165247)) true) (=> (= (ControlFlow 0 121929) 121935) inline$$BorrowGlobal$0$anon0_correct@@2)))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon30_Then_correct  (=> (|b#$Boolean| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$t7@1) (and (=> (= (ControlFlow 0 122025) (- 0 165179)) (|Select_[$TypeValueArray,$int]$bool| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)) (=> (= (ControlFlow 0 122025) 121929) inline$$BorrowGlobal$0$Entry_correct@@2))))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon14_correct  (=> (and (= $abort_code@5@@5 $abort_code@2@@6) (= (ControlFlow 0 121776) 121782)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$Abort_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 121774) 121776)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon14_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 121790) 121776) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon14_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon30_Else_correct  (=> (and (not (|b#$Boolean| inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$t7@1)) (= $abort_code@2@@6 (|i#$Integer| call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 121768) 121790) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 121768) 121774) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon28_Else_correct  (=> (not $abort_flag@0@@10) (and (=> (= (ControlFlow 0 121756) 122025) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 121756) 121768) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon6$2_correct  (=> (= inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)))) (=> (and (and (and (= inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$t8@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@10)) (and (=> $abort_flag@0@@10 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@13) (>= (|i#$Integer| call3formal@$ret0@0@@13) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@13) $MAX_U64))) (and (=> (= (ControlFlow 0 121750) 122574) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 121750) 121756) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon6_correct  (=> (and (= inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3) true)) (= (ControlFlow 0 121690) 121750)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon6$2_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 121630) 121690)) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon6_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 122598) 121690) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon6_correct)))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon26_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 121622) 122598) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 121622) 121630) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon26_Then_correct  (and (=> (= (ControlFlow 0 122606) 122598) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 122606) 121630) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon27_Else_correct))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 121614) 122606) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 121614) 121622) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 122614) 122606) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 122614) 121622) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon26_Else_correct))))
(let ((inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 121608) 122614) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 121608) 121614) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@13  (=> (and (forall (($inv_addr@@28 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28)) (let ((va@@47 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))
)) (forall (($inv_addr@@29 Int) ($inv_tv0@@17 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29)) (let ((va@@48 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@29))
))) (=> (and (and (forall (($inv_addr@@30 Int) ($inv_tv0@@18 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30)) (let ((va@@49 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@30))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((window_addr@@11 T@$Value) )  (=> ((_ is $Address) window_addr@@11) (|b#$Boolean| ($Boolean (forall ((coin_type@@11 T@$Value) )  (=> ((_ is $Type) coin_type@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| window_addr@@11)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| window_addr@@11)))) $AccountLimits_Window_limit_address)))))))))))))))) (= (ControlFlow 0 122620) 121608))) inline$$AccountLimits_update_withdrawal_limits_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@13  (=> (and (and (and ((_ is $Integer) amount@@2) (>= (|i#$Integer| amount@@2) 0)) (<= (|i#$Integer| amount@@2) $MAX_U64)) ((_ is $Address) addr@@3)) (=> (and (and (and (and (and ((_ is $Vector) _cap@@0) (let ((va@@50 (|v#$Vector| _cap@@0)))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| _cap@@0)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _cap@@0)) $AccountLimits_AccountLimitMutationCapability_dummy_field))) true) (= (ControlFlow 0 120634) 122620)) anon0$1_correct@@13))))
(let ((PreconditionGeneratedEntry_correct@@12  (=> (and (|Select_[$TypeValueArray,$int]$bool| $AccountLimits_Window_$CallerDomain@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@3)) (= (ControlFlow 0 162331) 120634)) anon0_correct@@13)))
PreconditionGeneratedEntry_correct@@12))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
