(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DesignatedDealer_Dealer () T@$TypeName)
(declare-fun $DesignatedDealer_ReceivedMintEvent () T@$TypeName)
(declare-fun $DesignatedDealer_TierInfo () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_Dealer_mint_event_handle () Int)
(declare-fun $DesignatedDealer_Dealer_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_ReceivedMintEvent_currency_code () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_destination_address () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_amount () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_TierInfo_window_start () Int)
(declare-fun $DesignatedDealer_TierInfo_window_inflow () Int)
(declare-fun $DesignatedDealer_TierInfo_tiers () Int)
(declare-fun $DesignatedDealer_TierInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $FixedPoint32_FixedPoint32 $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $DesignatedDealer_Dealer $DesignatedDealer_ReceivedMintEvent $DesignatedDealer_TierInfo)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@0) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@0))
)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0@@1) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($Event_EventHandle_type_value $tv0@@1))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_Dealer_mint_event_handle 0))
(assert (= $DesignatedDealer_Dealer_type_value ($StructType $DesignatedDealer_Dealer $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_ReceivedMintEvent_currency_code 0))
(assert (= $DesignatedDealer_ReceivedMintEvent_destination_address 1))
(assert (= $DesignatedDealer_ReceivedMintEvent_amount 2))
(assert (= $DesignatedDealer_ReceivedMintEvent_type_value ($StructType $DesignatedDealer_ReceivedMintEvent $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_TierInfo_window_start 0))
(assert (= $DesignatedDealer_TierInfo_window_inflow 1))
(assert (= $DesignatedDealer_TierInfo_tiers 2))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($DesignatedDealer_TierInfo_type_value $tv0@@9) ($StructType $DesignatedDealer_TierInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($DesignatedDealer_TierInfo_type_value $tv0@@9))
)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun tier_info () T@$Value)
(declare-fun inline$$DesignatedDealer_reset_window_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$DesignatedDealer_reset_window_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun inline$$DesignatedDealer_reset_window_$def_verify$0$$t3@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$DesignatedDealer_reset_window_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun call2formal@$ret0@0 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun |inline$$DesignatedDealer_reset_window_$def_verify$0$tmp#$2@1| () T@$Value)
(declare-fun inline$$Gt$1$dst@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_reset_window_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$Gt$0$dst@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_reset_window_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_reset_window_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $DesignatedDealer_TierInfo_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 214275) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 164855) (- 0 216092)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 164855) (- 0 216107)) (=> $abort_flag@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 164855) (- 0 216122)) (=> $abort_flag@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1)))))) (=> (=> $abort_flag@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 164855) (- 0 216148)) (=> (not $abort_flag@3) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 86400000000))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 86400000000))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_window_start)))))))) ($Boolean ($IsEqual_stratified inline$$DesignatedDealer_reset_window_$def_verify$0$$ret0@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_window_start (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| tier_info)))))) $DesignatedDealer_TierInfo_window_inflow ($Integer 0)) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_window_start (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| tier_info)))))))))) ($Boolean ($IsEqual_stratified inline$$DesignatedDealer_reset_window_$def_verify$0$$ret0@2 tier_info))))))))))))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$Abort_correct  (=> (= inline$$DesignatedDealer_reset_window_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_flag@3 true) (= $abort_code@5 $abort_code@4)) (and (= inline$$DesignatedDealer_reset_window_$def_verify$0$$ret0@2 inline$$DesignatedDealer_reset_window_$def_verify$0$$ret0@1) (= (ControlFlow 0 164811) 164855))) anon0$2_correct))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 164831) 164811)) inline$$DesignatedDealer_reset_window_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 164829) 164831)) inline$$DesignatedDealer_reset_window_$def_verify$0$anon5_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 164839) 164831) inline$$DesignatedDealer_reset_window_$def_verify$0$anon5_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon22_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 164823) 164839) inline$$DesignatedDealer_reset_window_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 164823) 164829) inline$$DesignatedDealer_reset_window_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon11_correct  (=> (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 164805) 164811)) inline$$DesignatedDealer_reset_window_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 164803) 164805)) inline$$DesignatedDealer_reset_window_$def_verify$0$anon11_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 164819) 164805) inline$$DesignatedDealer_reset_window_$def_verify$0$anon11_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 164797) 164819) inline$$DesignatedDealer_reset_window_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 164797) 164803) inline$$DesignatedDealer_reset_window_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon20_correct  (=> (and (and (= $abort_flag@3 $abort_flag@2) (= $abort_code@5 $abort_code@3)) (and (= inline$$DesignatedDealer_reset_window_$def_verify$0$$ret0@2 inline$$DesignatedDealer_reset_window_$def_verify$0$$t3@1) (= (ControlFlow 0 163333) 164855))) anon0$2_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 163331) 163333)) inline$$DesignatedDealer_reset_window_$def_verify$0$anon20_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 163341) 163333) inline$$DesignatedDealer_reset_window_$def_verify$0$anon20_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Then$7_correct  (=> (= inline$$DesignatedDealer_reset_window_$def_verify$0$$t3@1 |inline$$WritebackToValue$0$vdst'@2|) (and (=> (= (ControlFlow 0 164312) 163341) inline$$DesignatedDealer_reset_window_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 164312) 163331) inline$$DesignatedDealer_reset_window_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| tier_info) (= (ControlFlow 0 164278) 164312)) inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Then$7_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 3)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 tier_info (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 164304) 164312))) inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Then$7_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 164123) 164304) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 164123) 164278) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (and (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|))) (and (=> (= (ControlFlow 0 164179) 164304) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 164179) 164278) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (and (=> (= (ControlFlow 0 164087) 164179) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 164087) 164123) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (and (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$DesignatedDealer_reset_window_$def_verify$0$$t12@1)) (= (ControlFlow 0 163944) 164087)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $DesignatedDealer_TierInfo_window_inflow) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) $DesignatedDealer_TierInfo_window_inflow))) (= (ControlFlow 0 163885) 163944))) inline$$WriteRef$1$anon0_correct))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Then$3_correct  (=> (and (= inline$$DesignatedDealer_reset_window_$def_verify$0$$t12@1 ($Integer 0)) (= (ControlFlow 0 163891) 163885)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1) (= (ControlFlow 0 163701) 163891)) inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Then$3_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 163757) 163891))) inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Then$3_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 163665) 163757) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 163665) 163701) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) call2formal@$ret0@0)) (= (ControlFlow 0 163522) 163665)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DesignatedDealer_TierInfo_window_start) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $DesignatedDealer_TierInfo_window_start))) (= (ControlFlow 0 163463) 163522))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Then_correct  (=> (and (|b#$Boolean| |inline$$DesignatedDealer_reset_window_$def_verify$0$tmp#$2@1|) (= (ControlFlow 0 163469) 163463)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Else_correct  (=> (and (not (|b#$Boolean| |inline$$DesignatedDealer_reset_window_$def_verify$0$tmp#$2@1|)) (= inline$$DesignatedDealer_reset_window_$def_verify$0$$t3@1 tier_info)) (and (=> (= (ControlFlow 0 163321) 163341) inline$$DesignatedDealer_reset_window_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 163321) 163331) inline$$DesignatedDealer_reset_window_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon14_correct  (=> (= $abort_code@3 $abort_code@2) (=> (and (= |inline$$DesignatedDealer_reset_window_$def_verify$0$tmp#$2@1| inline$$Gt$1$dst@1) (= $abort_flag@2 $abort_flag@1)) (and (=> (= (ControlFlow 0 164785) 163469) inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 164785) 163321) inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 164783) 164785)) inline$$DesignatedDealer_reset_window_$def_verify$0$anon14_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 164793) 164785) inline$$DesignatedDealer_reset_window_$def_verify$0$anon14_correct)))
(let ((inline$$Gt$1$anon0_correct  (=> (= inline$$Gt$1$dst@1 ($Boolean (> (|i#$Integer| inline$$Sub$0$dst@2) (|i#$Integer| inline$$ReadRef$0$v@1)))) (and (=> (= (ControlFlow 0 164769) 164793) inline$$DesignatedDealer_reset_window_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 164769) 164783) inline$$DesignatedDealer_reset_window_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Gt$1$Entry_correct  (and (=> (= (ControlFlow 0 164755) (- 0 215436)) true) (=> (= (ControlFlow 0 164755) 164769) inline$$Gt$1$anon0_correct))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 164697) 164755)) inline$$Gt$1$Entry_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $DesignatedDealer_TierInfo_window_start) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $DesignatedDealer_TierInfo_window_start))) (= (ControlFlow 0 164659) 164697))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 164711) 164659)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (= $abort_flag@1 true) (=> (and (= $abort_code@2 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 164493) 164797) inline$$DesignatedDealer_reset_window_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 164493) 164711) inline$$DesignatedDealer_reset_window_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| call2formal@$ret0@0) (|i#$Integer| inline$$DesignatedDealer_reset_window_$def_verify$0$$t7@1)) (= (ControlFlow 0 164491) 164493)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (<= (|i#$Integer| inline$$DesignatedDealer_reset_window_$def_verify$0$$t7@1) (|i#$Integer| call2formal@$ret0@0)) (=> (and (and (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| call2formal@$ret0@0) (|i#$Integer| inline$$DesignatedDealer_reset_window_$def_verify$0$$t7@1)))) (= $abort_flag@1 $abort_flag@0)) (and (= $abort_code@2 $abort_code@1) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 164439) 164797) inline$$DesignatedDealer_reset_window_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 164439) 164711) inline$$DesignatedDealer_reset_window_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 164413) (- 0 215248)) true) (and (=> (= (ControlFlow 0 164413) 164491) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 164413) 164439) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon24_Then_correct  (=> (|b#$Boolean| inline$$Gt$0$dst@1) (=> (and (= inline$$DesignatedDealer_reset_window_$def_verify$0$$t7@1 ($Integer 86400000000)) (= (ControlFlow 0 164499) 164413)) inline$$Sub$0$Entry_correct))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon16_correct  (=> (= $abort_code@3 $abort_code@1) (=> (and (= |inline$$DesignatedDealer_reset_window_$def_verify$0$tmp#$2@1| inline$$DesignatedDealer_reset_window_$def_verify$0$$t10@1) (= $abort_flag@2 $abort_flag@0)) (and (=> (= (ControlFlow 0 163311) 163469) inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 163311) 163321) inline$$DesignatedDealer_reset_window_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 163309) 163311)) inline$$DesignatedDealer_reset_window_$def_verify$0$anon16_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 164320) 163311) inline$$DesignatedDealer_reset_window_$def_verify$0$anon16_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon24_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1)) (= inline$$DesignatedDealer_reset_window_$def_verify$0$$t10@1 ($Boolean false))) (and (=> (= (ControlFlow 0 163301) 164320) inline$$DesignatedDealer_reset_window_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 163301) 163309) inline$$DesignatedDealer_reset_window_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct  (=> (= inline$$Gt$0$dst@1 ($Boolean (> (|i#$Integer| call2formal@$ret0@0) (|i#$Integer| inline$$DesignatedDealer_reset_window_$def_verify$0$$t5@1)))) (and (=> (= (ControlFlow 0 163249) 164499) inline$$DesignatedDealer_reset_window_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 163249) 163301) inline$$DesignatedDealer_reset_window_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 163235) (- 0 215173)) true) (=> (= (ControlFlow 0 163235) 163249) inline$$Gt$0$anon0_correct))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon22_Else_correct  (=> (not $abort_flag@0) (=> (and (= inline$$DesignatedDealer_reset_window_$def_verify$0$$t5@1 ($Integer 86400000000)) (= (ControlFlow 0 163255) 163235)) inline$$Gt$0$Entry_correct))))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon2$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (and (and ((_ is $Integer) call2formal@$ret0@0) (>= (|i#$Integer| call2formal@$ret0@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 163183) 164823) inline$$DesignatedDealer_reset_window_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 163183) 163255) inline$$DesignatedDealer_reset_window_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 3) $EmptyPath tier_info)) (= (ControlFlow 0 163175) 163183)) inline$$DesignatedDealer_reset_window_$def_verify$0$anon2$2_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 163091) 163175)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 164847) 163175) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$DesignatedDealer_reset_window_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 163085) 164847) inline$$DesignatedDealer_reset_window_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 163085) 163091) inline$$DesignatedDealer_reset_window_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct  (=> (and (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers)) (let ((va@@10 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers))) $$0)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers))) $$0))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1)) $i_0) (< $i_0 (|i#$Integer| (|ub#$Range| $range_1)))) (let ((i@@10 ($Integer $i_0)))
(|b#$Boolean| ($Boolean (let (($range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3)) $i_2) (< $i_2 (|i#$Integer| (|ub#$Range| $range_3)))) (let ((j@@1 ($Integer $i_2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@10) (|i#$Integer| j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@10))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@1))))))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 164853) 163085)))) inline$$DesignatedDealer_reset_window_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and (and (and (and (and (and (and ((_ is $Vector) tier_info) (let ((va@@11 (|v#$Vector| tier_info)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| tier_info)) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_tiers)) (let ((va@@12 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_tiers))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_tiers))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_tiers))) $$0@@0)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tier_info)) $DesignatedDealer_TierInfo_tiers))) $$0@@0))
))) (= (ControlFlow 0 162482) 164853)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 214275) 162482) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun tc_account () T@$Value)
(declare-fun $abort_flag@33 () Bool)
(declare-fun dd () T@$Value)
(declare-fun $DesignatedDealer_Dealer_$memory () T@$Memory)
(declare-fun $tv0@@10 () T@$TypeValue)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(declare-fun $abort_code@42 () Int)
(declare-fun $DesignatedDealer_TierInfo_$memory@5 () T@$Memory)
(declare-fun $abort_flag@32 () Bool)
(declare-fun $Diem_Preburn_$memory@3 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@1 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@3 () T@$Memory)
(declare-fun $abort_code@40 () Int)
(declare-fun $Diem_Preburn_$memory@2 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@4 () T@$Memory)
(declare-fun $abort_code@41 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_code@25 () Int)
(declare-fun $abort_flag@19 () Bool)
(declare-fun $abort_code@26 () Int)
(declare-fun $abort_flag@20 () Bool)
(declare-fun $abort_code@28 () Int)
(declare-fun |inline$$MoveToRaw$1$m'@2| () T@$Memory)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $abort_code@33 () Int)
(declare-fun $abort_flag@25 () Bool)
(declare-fun $abort_code@34 () Int)
(declare-fun $DesignatedDealer_TierInfo_$memory@0 () T@$Memory)
(declare-fun $abort_flag@26 () Bool)
(declare-fun $abort_code@35 () Int)
(declare-fun $abort_flag@27 () Bool)
(declare-fun $abort_code@36 () Int)
(declare-fun $DesignatedDealer_TierInfo_$memory@1 () T@$Memory)
(declare-fun $abort_flag@28 () Bool)
(declare-fun $abort_code@37 () Int)
(declare-fun $abort_flag@29 () Bool)
(declare-fun $abort_code@38 () Int)
(declare-fun $DesignatedDealer_TierInfo_$memory@2 () T@$Memory)
(declare-fun $abort_flag@30 () Bool)
(declare-fun $abort_code@39 () Int)
(declare-fun $abort_flag@31 () Bool)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$MulU64$3$dst@2 () T@$Value)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun inline$$MulU64$3$dst@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$t27@1 () T@$Value)
(declare-fun inline$$Diem_scaling_factor_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$MulU64$3$dst@1 () T@$Value)
(declare-fun inline$$MulU64$2$dst@2 () T@$Value)
(declare-fun inline$$MulU64$2$dst@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$t25@1 () T@$Value)
(declare-fun inline$$MulU64$2$dst@1 () T@$Value)
(declare-fun inline$$MulU64$1$dst@2 () T@$Value)
(declare-fun inline$$MulU64$1$dst@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$t23@1 () T@$Value)
(declare-fun inline$$MulU64$1$dst@1 () T@$Value)
(declare-fun inline$$MulU64$0$dst@2 () T@$Value)
(declare-fun inline$$MulU64$0$dst@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$MulU64$0$dst@1 () T@$Value)
(declare-fun $abort_code@32 () Int)
(declare-fun $abort_flag@24 () Bool)
(declare-fun inline$$Diem_scaling_factor_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@31 () Int)
(declare-fun $abort_code@29 () Int)
(declare-fun $abort_flag@22 () Bool)
(declare-fun $abort_code@30 () Int)
(declare-fun $abort_flag@23 () Bool)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$1$a@1 () Int)
(declare-fun inline$$GetGlobal$1$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun |inline$$MoveToRaw$1$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$1$a@1 () Int)
(declare-fun |inline$$MoveToRaw$1$m'@1| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_pack$0$$struct@1 () T@$Value)
(declare-fun call2formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Not$2$dst@1 () T@$Value)
(declare-fun $abort_code@27 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_flag@18 () Bool)
(declare-fun $abort_code@24 () Int)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $abort_code@22 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@23 () Int)
(declare-fun $Diem_Preburn_$memory@0 () T@$Memory)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@13 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_code@15 () Int)
(declare-fun $abort_flag@11 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_code@21 () Int)
(declare-fun inline$$Diem_publish_preburn_to_account_$def$0$$Diem_Preburn_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@20 () Int)
(declare-fun $abort_code@17 () Int)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $abort_code@18 () Int)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $abort_code@19 () Int)
(declare-fun inline$$Diem_Preburn_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@14 () Bool)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun $abort_code@16 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$Diem_publish_preburn_to_account_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$Diem_publish_preburn_to_account_$def$0$$t13@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@14 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$Diem_publish_preburn_to_account_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$Diem_is_synthetic_currency_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun inline$$Diem_is_synthetic_currency_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun |inline$$Diem_is_synthetic_currency_$def$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$Diem_is_synthetic_currency_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$Diem_is_synthetic_currency_$def$0$$t5@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$Diem_Preburn_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_currency_$def_verify$0$$t11@1 () T@$Value)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DesignatedDealer_TierInfo_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 216265) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 174192) (- 0 232678)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232699)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232728)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232745)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232766)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232795)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232818)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232846)) (=> (|b#$Boolean| (let ((addr ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr)))) $Diem_CurrencyInfo_is_synthetic)))))) $abort_flag@33)) (=> (=> (|b#$Boolean| (let ((addr ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr)))) $Diem_CurrencyInfo_is_synthetic)))))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232857)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232885)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232902)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 174192) (- 0 232917)) (=> $abort_flag@33 (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd))))) (|b#$Boolean| (let ((addr@@0 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@0)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@0)))) $Diem_CurrencyInfo_is_synthetic))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@33 (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd))))) (|b#$Boolean| (let ((addr@@0 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@0)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@0)))) $Diem_CurrencyInfo_is_synthetic))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 174192) (- 0 233146)) (=> $abort_flag@33 (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@42 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@42 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@42 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (= $abort_code@42 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@42 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (= $abort_code@42 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) (= $abort_code@42 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| (let ((addr@@1 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@1)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@1)))) $Diem_CurrencyInfo_is_synthetic)))))) (= $abort_code@42 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) (= $abort_code@42 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@42 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@42 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@33 (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@42 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@42 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@42 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (= $abort_code@42 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@42 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (= $abort_code@42 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) (= $abort_code@42 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| (let ((addr@@1 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@1)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@1)))) $Diem_CurrencyInfo_is_synthetic)))))) (= $abort_code@42 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) (= $abort_code@42 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@42 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@42 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 174192) (- 0 233496)) (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))))) (=> (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd))))) (and (=> (= (ControlFlow 0 174192) (- 0 233526)) (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@2 1)))) len@@1 ($Integer 0)) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@2 1)))) len@@1 ($Integer 0)) (+ len@@1 1)))) len@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) $DesignatedDealer_TierInfo_tiers)) (+ len@@0 1))))))))) (=> (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@2 1)))) len@@1 ($Integer 0)) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@2 1)))) len@@1 ($Integer 0)) (+ len@@1 1)))) len@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) $DesignatedDealer_TierInfo_tiers)) (+ len@@0 1)))))))) (=> (= (ControlFlow 0 174192) (- 0 233605)) (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4))))))))))))))))))))))))))))))))))))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon119_Else_correct  (=> (and (not $abort_flag@32) (= $Diem_Preburn_$memory@3 $Diem_Preburn_$memory@1)) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@5 $DesignatedDealer_TierInfo_$memory@3) (= $abort_code@42 $abort_code@40)) (and (= $abort_flag@33 $abort_flag@32) (= (ControlFlow 0 173842) 174192))) anon0$2_correct@@0))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct  (=> (= $Diem_Preburn_$memory@3 $Diem_Preburn_$memory@2) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@5 $DesignatedDealer_TierInfo_$memory@4) (= $abort_code@42 $abort_code@41)) (and (= $abort_flag@33 true) (= (ControlFlow 0 167427) 174192))) anon0$2_correct@@0))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon7_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory) (= $abort_code@41 $abort_code@1@@0)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 174162) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 174160) 174162)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon7_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon84_Then_correct  (=> (= (ControlFlow 0 174170) 174162) inline$$DesignatedDealer_add_currency_$def_verify$0$anon7_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon83_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 174154) 174170) inline$$DesignatedDealer_add_currency_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 174154) 174160) inline$$DesignatedDealer_add_currency_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon11_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory) (= $abort_code@41 $abort_code@2@@0)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 174142) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 174140) 174142)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon11_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon86_Then_correct  (=> (= (ControlFlow 0 174150) 174142) inline$$DesignatedDealer_add_currency_$def_verify$0$anon11_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon85_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 174134) 174150) inline$$DesignatedDealer_add_currency_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 174134) 174140) inline$$DesignatedDealer_add_currency_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon15_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory) (= $abort_code@41 $abort_code@3@@0)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 174122) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 174120) 174122)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon15_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon88_Then_correct  (=> (= (ControlFlow 0 174130) 174122) inline$$DesignatedDealer_add_currency_$def_verify$0$anon15_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon87_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 174114) 174130) inline$$DesignatedDealer_add_currency_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 174114) 174120) inline$$DesignatedDealer_add_currency_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon19_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory) (= $abort_code@41 $abort_code@4@@0)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 174102) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon90_Else_correct  (=> (and (not true) (= (ControlFlow 0 174100) 174102)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon19_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon90_Then_correct  (=> (= (ControlFlow 0 174110) 174102) inline$$DesignatedDealer_add_currency_$def_verify$0$anon19_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon89_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 174094) 174110) inline$$DesignatedDealer_add_currency_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 174094) 174100) inline$$DesignatedDealer_add_currency_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon29_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@25)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 174078) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 174076) 174078)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon29_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon95_Then_correct  (=> (= (ControlFlow 0 174086) 174078) inline$$DesignatedDealer_add_currency_$def_verify$0$anon29_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon94_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 174070) 174086) inline$$DesignatedDealer_add_currency_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 174070) 174076) inline$$DesignatedDealer_add_currency_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon37_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@26)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 174058) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 174056) 174058)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon37_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon99_Then_correct  (=> (= (ControlFlow 0 174066) 174058) inline$$DesignatedDealer_add_currency_$def_verify$0$anon37_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon98_Then_correct  (=> $abort_flag@20 (and (=> (= (ControlFlow 0 174050) 174066) inline$$DesignatedDealer_add_currency_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 174050) 174056) inline$$DesignatedDealer_add_currency_$def_verify$0$anon99_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon41_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@26)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 174038) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon101_Else_correct  (=> (and (not true) (= (ControlFlow 0 174036) 174038)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon41_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon101_Then_correct  (=> (= (ControlFlow 0 174046) 174038) inline$$DesignatedDealer_add_currency_$def_verify$0$anon41_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon100_Then_correct  (=> $abort_flag@20 (and (=> (= (ControlFlow 0 174030) 174046) inline$$DesignatedDealer_add_currency_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 174030) 174036) inline$$DesignatedDealer_add_currency_$def_verify$0$anon101_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon45_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@28)) (and (= $DesignatedDealer_TierInfo_$memory@4 |inline$$MoveToRaw$1$m'@2|) (= (ControlFlow 0 174018) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon103_Else_correct  (=> (and (not true) (= (ControlFlow 0 174016) 174018)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon45_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon103_Then_correct  (=> (= (ControlFlow 0 174026) 174018) inline$$DesignatedDealer_add_currency_$def_verify$0$anon45_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon102_Then_correct  (=> $abort_flag@21 (and (=> (= (ControlFlow 0 174010) 174026) inline$$DesignatedDealer_add_currency_$def_verify$0$anon103_Then_correct) (=> (= (ControlFlow 0 174010) 174016) inline$$DesignatedDealer_add_currency_$def_verify$0$anon103_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon51_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@33)) (and (= $DesignatedDealer_TierInfo_$memory@4 |inline$$MoveToRaw$1$m'@2|) (= (ControlFlow 0 173994) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon106_Else_correct  (=> (and (not true) (= (ControlFlow 0 173992) 173994)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon51_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon106_Then_correct  (=> (= (ControlFlow 0 174002) 173994) inline$$DesignatedDealer_add_currency_$def_verify$0$anon51_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon105_Then_correct  (=> $abort_flag@25 (and (=> (= (ControlFlow 0 173986) 174002) inline$$DesignatedDealer_add_currency_$def_verify$0$anon106_Then_correct) (=> (= (ControlFlow 0 173986) 173992) inline$$DesignatedDealer_add_currency_$def_verify$0$anon106_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon55_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@34)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory@0) (= (ControlFlow 0 173974) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon108_Else_correct  (=> (and (not true) (= (ControlFlow 0 173972) 173974)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon55_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon108_Then_correct  (=> (= (ControlFlow 0 173982) 173974) inline$$DesignatedDealer_add_currency_$def_verify$0$anon55_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon107_Then_correct  (=> $abort_flag@26 (and (=> (= (ControlFlow 0 173966) 173982) inline$$DesignatedDealer_add_currency_$def_verify$0$anon108_Then_correct) (=> (= (ControlFlow 0 173966) 173972) inline$$DesignatedDealer_add_currency_$def_verify$0$anon108_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon59_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@35)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory@0) (= (ControlFlow 0 173954) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon110_Else_correct  (=> (and (not true) (= (ControlFlow 0 173952) 173954)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon59_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon110_Then_correct  (=> (= (ControlFlow 0 173962) 173954) inline$$DesignatedDealer_add_currency_$def_verify$0$anon59_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon109_Then_correct  (=> $abort_flag@27 (and (=> (= (ControlFlow 0 173946) 173962) inline$$DesignatedDealer_add_currency_$def_verify$0$anon110_Then_correct) (=> (= (ControlFlow 0 173946) 173952) inline$$DesignatedDealer_add_currency_$def_verify$0$anon110_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon63_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@36)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory@1) (= (ControlFlow 0 173934) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon112_Else_correct  (=> (and (not true) (= (ControlFlow 0 173932) 173934)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon63_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon112_Then_correct  (=> (= (ControlFlow 0 173942) 173934) inline$$DesignatedDealer_add_currency_$def_verify$0$anon63_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon111_Then_correct  (=> $abort_flag@28 (and (=> (= (ControlFlow 0 173926) 173942) inline$$DesignatedDealer_add_currency_$def_verify$0$anon112_Then_correct) (=> (= (ControlFlow 0 173926) 173932) inline$$DesignatedDealer_add_currency_$def_verify$0$anon112_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon67_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@37)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory@1) (= (ControlFlow 0 173914) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon114_Else_correct  (=> (and (not true) (= (ControlFlow 0 173912) 173914)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon67_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon114_Then_correct  (=> (= (ControlFlow 0 173922) 173914) inline$$DesignatedDealer_add_currency_$def_verify$0$anon67_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon113_Then_correct  (=> $abort_flag@29 (and (=> (= (ControlFlow 0 173906) 173922) inline$$DesignatedDealer_add_currency_$def_verify$0$anon114_Then_correct) (=> (= (ControlFlow 0 173906) 173912) inline$$DesignatedDealer_add_currency_$def_verify$0$anon114_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon71_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@38)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory@2) (= (ControlFlow 0 173894) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon116_Else_correct  (=> (and (not true) (= (ControlFlow 0 173892) 173894)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon71_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon116_Then_correct  (=> (= (ControlFlow 0 173902) 173894) inline$$DesignatedDealer_add_currency_$def_verify$0$anon71_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon115_Then_correct  (=> $abort_flag@30 (and (=> (= (ControlFlow 0 173886) 173902) inline$$DesignatedDealer_add_currency_$def_verify$0$anon116_Then_correct) (=> (= (ControlFlow 0 173886) 173892) inline$$DesignatedDealer_add_currency_$def_verify$0$anon116_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon75_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@39)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory@2) (= (ControlFlow 0 173874) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon118_Else_correct  (=> (and (not true) (= (ControlFlow 0 173872) 173874)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon75_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon118_Then_correct  (=> (= (ControlFlow 0 173882) 173874) inline$$DesignatedDealer_add_currency_$def_verify$0$anon75_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon117_Then_correct  (=> $abort_flag@31 (and (=> (= (ControlFlow 0 173866) 173882) inline$$DesignatedDealer_add_currency_$def_verify$0$anon118_Then_correct) (=> (= (ControlFlow 0 173866) 173872) inline$$DesignatedDealer_add_currency_$def_verify$0$anon118_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon79_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@40)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory@3) (= (ControlFlow 0 173854) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon120_Else_correct  (=> (and (not true) (= (ControlFlow 0 173852) 173854)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon79_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon120_Then_correct  (=> (= (ControlFlow 0 173862) 173854) inline$$DesignatedDealer_add_currency_$def_verify$0$anon79_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon119_Then_correct  (=> $abort_flag@32 (and (=> (= (ControlFlow 0 173846) 173862) inline$$DesignatedDealer_add_currency_$def_verify$0$anon120_Then_correct) (=> (= (ControlFlow 0 173846) 173852) inline$$DesignatedDealer_add_currency_$def_verify$0$anon120_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon117_Else_correct  (=> (not $abort_flag@31) (and (=> (= (ControlFlow 0 173836) (- 0 231410)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@32) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@32)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@32) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) $abort_flag@32))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) $abort_flag@32) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$3$dst@2))))))) $abort_flag@32)) (and (=> $abort_flag@32 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$3$dst@2))))))))) (=> $abort_flag@32 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@40 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@40 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@40 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) (= $abort_code@40 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) (= $abort_code@40 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$3$dst@2))))))) (= $abort_code@40 (|i#$Integer| ($Integer 7)))))))) (and (and (=> (not $abort_flag@32) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))) (=> (not $abort_flag@32) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)) ($Vector (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@5 1)))) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@5 1)))) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@4 1)))) len@@3 ($Vector (let ((m2 (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$MulU64$3$dst@2) 1))))))
(let ((l2 (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$MulU64$3$dst@2) 1))))))
(let ((m1 (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))))
(let ((l1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))))
($ValueArray (|lambda#2| 0 (+ l1 l2) l1 m1 m2 l1 $Error) (+ l1 l2)))))))) (+ len@@3 1))))))))) (and (= (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) (= (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@3) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) (and (=> (= (ControlFlow 0 173836) 173846) inline$$DesignatedDealer_add_currency_$def_verify$0$anon119_Then_correct) (=> (= (ControlFlow 0 173836) 173842) inline$$DesignatedDealer_add_currency_$def_verify$0$anon119_Else_correct)))))))))
(let ((inline$$MulU64$3$anon3_Then$1_correct  (=> (= $abort_flag@31 true) (=> (and (= $abort_code@39 $EXEC_FAILURE_CODE) (= inline$$MulU64$3$dst@2 inline$$MulU64$3$dst@0)) (and (=> (= (ControlFlow 0 173822) 173866) inline$$DesignatedDealer_add_currency_$def_verify$0$anon117_Then_correct) (=> (= (ControlFlow 0 173822) 173836) inline$$DesignatedDealer_add_currency_$def_verify$0$anon117_Else_correct))))))
(let ((inline$$MulU64$3$anon3_Then_correct  (=> (and (> (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t27@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)) $MAX_U64) (= (ControlFlow 0 173820) 173822)) inline$$MulU64$3$anon3_Then$1_correct)))
(let ((inline$$MulU64$3$anon3_Else_correct  (=> (>= $MAX_U64 (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t27@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2))) (=> (and (and (= inline$$MulU64$3$dst@1 ($Integer (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t27@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)))) (= $abort_flag@31 $abort_flag@30)) (and (= $abort_code@39 $abort_code@38) (= inline$$MulU64$3$dst@2 inline$$MulU64$3$dst@1))) (and (=> (= (ControlFlow 0 173764) 173866) inline$$DesignatedDealer_add_currency_$def_verify$0$anon117_Then_correct) (=> (= (ControlFlow 0 173764) 173836) inline$$DesignatedDealer_add_currency_$def_verify$0$anon117_Else_correct))))))
(let ((inline$$MulU64$3$Entry_correct  (and (=> (= (ControlFlow 0 173734) (- 0 231308)) true) (and (=> (= (ControlFlow 0 173734) 173820) inline$$MulU64$3$anon3_Then_correct) (=> (= (ControlFlow 0 173734) 173764) inline$$MulU64$3$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon115_Else_correct  (=> (not $abort_flag@30) (=> (and (= inline$$DesignatedDealer_add_currency_$def_verify$0$$t27@1 ($Integer 500000000)) (= (ControlFlow 0 173828) 173734)) inline$$MulU64$3$Entry_correct))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon113_Else_correct  (=> (not $abort_flag@29) (and (=> (= (ControlFlow 0 173633) (- 0 230445)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@30) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@30)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@30) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) $abort_flag@30))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) $abort_flag@30) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$2$dst@2))))))) $abort_flag@30)) (and (=> $abort_flag@30 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$2$dst@2))))))))) (=> $abort_flag@30 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@38 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@38 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@38 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) (= $abort_code@38 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) (= $abort_code@38 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$2$dst@2))))))) (= $abort_code@38 (|i#$Integer| ($Integer 7)))))))) (and (and (=> (not $abort_flag@30) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))) (=> (not $abort_flag@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)) ($Vector (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@8 1)))) len@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@8 1)))) len@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@7 1)))) len@@6 ($Vector (let ((m2@@0 (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$MulU64$2$dst@2) 1))))))
(let ((l2@@0 (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$MulU64$2$dst@2) 1))))))
(let ((m1@@0 (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))))
(let ((l1@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))))
($ValueArray (|lambda#2| 0 (+ l1@@0 l2@@0) l1@@0 m1@@0 m2@@0 l1@@0 $Error) (+ l1@@0 l2@@0)))))))) (+ len@@6 1))))))))) (and (= (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) (= (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@2) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) (and (=> (= (ControlFlow 0 173633) 173886) inline$$DesignatedDealer_add_currency_$def_verify$0$anon115_Then_correct) (=> (= (ControlFlow 0 173633) 173828) inline$$DesignatedDealer_add_currency_$def_verify$0$anon115_Else_correct)))))))))
(let ((inline$$MulU64$2$anon3_Then$1_correct  (=> (= $abort_code@37 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@29 true) (= inline$$MulU64$2$dst@2 inline$$MulU64$2$dst@0)) (and (=> (= (ControlFlow 0 173619) 173906) inline$$DesignatedDealer_add_currency_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 173619) 173633) inline$$DesignatedDealer_add_currency_$def_verify$0$anon113_Else_correct))))))
(let ((inline$$MulU64$2$anon3_Then_correct  (=> (and (> (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t25@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)) $MAX_U64) (= (ControlFlow 0 173617) 173619)) inline$$MulU64$2$anon3_Then$1_correct)))
(let ((inline$$MulU64$2$anon3_Else_correct  (=> (>= $MAX_U64 (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t25@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2))) (=> (and (and (= inline$$MulU64$2$dst@1 ($Integer (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t25@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)))) (= $abort_code@37 $abort_code@36)) (and (= $abort_flag@29 $abort_flag@28) (= inline$$MulU64$2$dst@2 inline$$MulU64$2$dst@1))) (and (=> (= (ControlFlow 0 173561) 173906) inline$$DesignatedDealer_add_currency_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 173561) 173633) inline$$DesignatedDealer_add_currency_$def_verify$0$anon113_Else_correct))))))
(let ((inline$$MulU64$2$Entry_correct  (and (=> (= (ControlFlow 0 173531) (- 0 230343)) true) (and (=> (= (ControlFlow 0 173531) 173617) inline$$MulU64$2$anon3_Then_correct) (=> (= (ControlFlow 0 173531) 173561) inline$$MulU64$2$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon111_Else_correct  (=> (not $abort_flag@28) (=> (and (= inline$$DesignatedDealer_add_currency_$def_verify$0$$t25@1 ($Integer 50000000)) (= (ControlFlow 0 173625) 173531)) inline$$MulU64$2$Entry_correct))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon109_Else_correct  (=> (not $abort_flag@27) (and (=> (= (ControlFlow 0 173430) (- 0 229480)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@28) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@28)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@28) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) $abort_flag@28))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) $abort_flag@28) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$1$dst@2))))))) $abort_flag@28)) (and (=> $abort_flag@28 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$1$dst@2))))))))) (=> $abort_flag@28 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@36 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@36 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@36 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) (= $abort_code@36 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) (= $abort_code@36 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$1$dst@2))))))) (= $abort_code@36 (|i#$Integer| ($Integer 7)))))))) (and (and (=> (not $abort_flag@28) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))) (=> (not $abort_flag@28) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)) ($Vector (let ((len@@9 (|l#$ValueArray| (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@11 1)))) len@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@10 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@11 1)))) len@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@10 1)))) len@@9 ($Vector (let ((m2@@1 (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$MulU64$1$dst@2) 1))))))
(let ((l2@@1 (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$MulU64$1$dst@2) 1))))))
(let ((m1@@1 (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))))
(let ((l1@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))))
($ValueArray (|lambda#2| 0 (+ l1@@1 l2@@1) l1@@1 m1@@1 m2@@1 l1@@1 $Error) (+ l1@@1 l2@@1)))))))) (+ len@@9 1))))))))) (and (= (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) (= (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) (and (=> (= (ControlFlow 0 173430) 173926) inline$$DesignatedDealer_add_currency_$def_verify$0$anon111_Then_correct) (=> (= (ControlFlow 0 173430) 173625) inline$$DesignatedDealer_add_currency_$def_verify$0$anon111_Else_correct)))))))))
(let ((inline$$MulU64$1$anon3_Then$1_correct  (=> (= $abort_flag@27 true) (=> (and (= $abort_code@35 $EXEC_FAILURE_CODE) (= inline$$MulU64$1$dst@2 inline$$MulU64$1$dst@0)) (and (=> (= (ControlFlow 0 173416) 173946) inline$$DesignatedDealer_add_currency_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 173416) 173430) inline$$DesignatedDealer_add_currency_$def_verify$0$anon109_Else_correct))))))
(let ((inline$$MulU64$1$anon3_Then_correct  (=> (and (> (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t23@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)) $MAX_U64) (= (ControlFlow 0 173414) 173416)) inline$$MulU64$1$anon3_Then$1_correct)))
(let ((inline$$MulU64$1$anon3_Else_correct  (=> (>= $MAX_U64 (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t23@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2))) (=> (and (and (= inline$$MulU64$1$dst@1 ($Integer (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t23@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)))) (= $abort_flag@27 $abort_flag@26)) (and (= $abort_code@35 $abort_code@34) (= inline$$MulU64$1$dst@2 inline$$MulU64$1$dst@1))) (and (=> (= (ControlFlow 0 173358) 173946) inline$$DesignatedDealer_add_currency_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 173358) 173430) inline$$DesignatedDealer_add_currency_$def_verify$0$anon109_Else_correct))))))
(let ((inline$$MulU64$1$Entry_correct  (and (=> (= (ControlFlow 0 173328) (- 0 229378)) true) (and (=> (= (ControlFlow 0 173328) 173414) inline$$MulU64$1$anon3_Then_correct) (=> (= (ControlFlow 0 173328) 173358) inline$$MulU64$1$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon107_Else_correct  (=> (not $abort_flag@26) (=> (and (= inline$$DesignatedDealer_add_currency_$def_verify$0$$t23@1 ($Integer 5000000)) (= (ControlFlow 0 173422) 173328)) inline$$MulU64$1$Entry_correct))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon105_Else_correct  (=> (not $abort_flag@25) (and (=> (= (ControlFlow 0 173227) (- 0 228515)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@26) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@26)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@26) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) $abort_flag@26))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) $abort_flag@26) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$0$dst@2))))))) $abort_flag@26)) (and (=> $abort_flag@26 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$0$dst@2))))))))) (=> $abort_flag@26 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@34 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@34 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@34 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) (= $abort_code@34 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) (= $abort_code@34 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| inline$$MulU64$0$dst@2))))))) (= $abort_code@34 (|i#$Integer| ($Integer 7)))))))) (and (and (=> (not $abort_flag@26) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))) (=> (not $abort_flag@26) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)) ($Vector (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@14 1)))) len@@13 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@14 1)))) len@@13 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@13 1)))) len@@12 ($Vector (let ((m2@@2 (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$MulU64$0$dst@2) 1))))))
(let ((l2@@2 (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$MulU64$0$dst@2) 1))))))
(let ((m1@@2 (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))))
(let ((l1@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) $DesignatedDealer_TierInfo_tiers)))))
($ValueArray (|lambda#2| 0 (+ l1@@2 l2@@2) l1@@2 m1@@2 m2@@2 l1@@2 $Error) (+ l1@@2 l2@@2)))))))) (+ len@@12 1))))))))) (and (= (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) (= (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0))))))) (and (=> (= (ControlFlow 0 173227) 173966) inline$$DesignatedDealer_add_currency_$def_verify$0$anon107_Then_correct) (=> (= (ControlFlow 0 173227) 173422) inline$$DesignatedDealer_add_currency_$def_verify$0$anon107_Else_correct)))))))))
(let ((inline$$MulU64$0$anon3_Then$1_correct  (=> (= $abort_code@33 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@25 true) (= inline$$MulU64$0$dst@2 inline$$MulU64$0$dst@0)) (and (=> (= (ControlFlow 0 173213) 173986) inline$$DesignatedDealer_add_currency_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 173213) 173227) inline$$DesignatedDealer_add_currency_$def_verify$0$anon105_Else_correct))))))
(let ((inline$$MulU64$0$anon3_Then_correct  (=> (and (> (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t21@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)) $MAX_U64) (= (ControlFlow 0 173211) 173213)) inline$$MulU64$0$anon3_Then$1_correct)))
(let ((inline$$MulU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t21@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2))) (=> (and (and (= inline$$MulU64$0$dst@1 ($Integer (* (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t21@1) (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)))) (= $abort_code@33 $abort_code@32)) (and (= $abort_flag@25 $abort_flag@24) (= inline$$MulU64$0$dst@2 inline$$MulU64$0$dst@1))) (and (=> (= (ControlFlow 0 173155) 173986) inline$$DesignatedDealer_add_currency_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 173155) 173227) inline$$DesignatedDealer_add_currency_$def_verify$0$anon105_Else_correct))))))
(let ((inline$$MulU64$0$Entry_correct  (and (=> (= (ControlFlow 0 173125) (- 0 228413)) true) (and (=> (= (ControlFlow 0 173125) 173211) inline$$MulU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 173125) 173155) inline$$MulU64$0$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon104_Else_correct  (=> (not $abort_flag@24) (=> (and (= inline$$DesignatedDealer_add_currency_$def_verify$0$$t21@1 ($Integer 500000)) (= (ControlFlow 0 173219) 173125)) inline$$MulU64$0$Entry_correct))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon104_Then_correct  (=> $abort_flag@24 (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@32)) (and (= $DesignatedDealer_TierInfo_$memory@4 |inline$$MoveToRaw$1$m'@2|) (= (ControlFlow 0 174006) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_scaling_factor_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_scaling_factor_$def$0$$ret0@1 $Error) (= $abort_code@32 $abort_code@31)) (and (= inline$$Diem_scaling_factor_$def$0$$ret0@2 inline$$Diem_scaling_factor_$def$0$$ret0@1) (= $abort_flag@24 true))) (and (=> (= (ControlFlow 0 172976) 174006) inline$$DesignatedDealer_add_currency_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 172976) 173219) inline$$DesignatedDealer_add_currency_$def_verify$0$anon104_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon3_correct  (=> (and (= $abort_code@31 $abort_code@29) (= (ControlFlow 0 173000) 172976)) inline$$Diem_scaling_factor_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 172998) 173000)) inline$$Diem_scaling_factor_$def$0$anon3_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon14_Then_correct  (=> (= (ControlFlow 0 173008) 173000) inline$$Diem_scaling_factor_$def$0$anon3_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon13_Then_correct  (=> $abort_flag@22 (and (=> (= (ControlFlow 0 172992) 173008) inline$$Diem_scaling_factor_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 172992) 172998) inline$$Diem_scaling_factor_$def$0$anon14_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon9_correct  (=> (and (= $abort_code@31 $abort_code@30) (= (ControlFlow 0 172970) 172976)) inline$$Diem_scaling_factor_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 172968) 172970)) inline$$Diem_scaling_factor_$def$0$anon9_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 172984) 172970) inline$$Diem_scaling_factor_$def$0$anon9_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon16_Then_correct  (=> $abort_flag@23 (and (=> (= (ControlFlow 0 172962) 172984) inline$$Diem_scaling_factor_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 172962) 172968) inline$$Diem_scaling_factor_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon15_Then_correct  (=> $abort_flag@22 (=> (and (= $abort_code@31 $abort_code@29) (= (ControlFlow 0 172988) 172976)) inline$$Diem_scaling_factor_$def$0$Abort_correct))))
(let ((inline$$Diem_scaling_factor_$def$0$anon12_correct  (=> (= $abort_code@32 $abort_code@30) (=> (and (= inline$$Diem_scaling_factor_$def$0$$ret0@2 inline$$GetFieldFromValue$1$dst@1) (= $abort_flag@24 $abort_flag@23)) (and (=> (= (ControlFlow 0 172950) 174006) inline$$DesignatedDealer_add_currency_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 172950) 173219) inline$$DesignatedDealer_add_currency_$def_verify$0$anon104_Else_correct))))))
(let ((inline$$Diem_scaling_factor_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 172948) 172950)) inline$$Diem_scaling_factor_$def$0$anon12_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 172958) 172950) inline$$Diem_scaling_factor_$def$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$1$dst@2)) $Diem_CurrencyInfo_scaling_factor)) (and (=> (= (ControlFlow 0 172932) 172958) inline$$Diem_scaling_factor_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 172932) 172948) inline$$Diem_scaling_factor_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@23) (= (ControlFlow 0 172938) 172932)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$GetGlobal$1$anon3_Then$1_correct  (=> (= $abort_code@30 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@23 true) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 172878) 172962) inline$$Diem_scaling_factor_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 172878) 172938) inline$$Diem_scaling_factor_$def$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$1$ta@0 inline$$GetGlobal$1$a@1)) (= (ControlFlow 0 172876) 172878)) inline$$GetGlobal$1$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$1$ta@0 inline$$GetGlobal$1$a@1) (=> (and (and (= inline$$GetGlobal$1$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$1$ta@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1))) (= $abort_code@30 $abort_code@29)) (and (= $abort_flag@23 $abort_flag@22) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 172824) 172962) inline$$Diem_scaling_factor_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 172824) 172938) inline$$Diem_scaling_factor_$def$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$1$anon0_correct  (=> (= inline$$GetGlobal$1$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 172806) 172876) inline$$GetGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 172806) 172824) inline$$GetGlobal$1$anon3_Else_correct)))))
(let ((inline$$GetGlobal$1$Entry_correct  (=> (= inline$$GetGlobal$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (and (=> (= (ControlFlow 0 172800) (- 0 228199)) true) (=> (= (ControlFlow 0 172800) 172806) inline$$GetGlobal$1$anon0_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon15_Else_correct  (=> (and (not $abort_flag@22) (= (ControlFlow 0 172884) 172800)) inline$$GetGlobal$1$Entry_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 172667) 172988) inline$$Diem_scaling_factor_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 172667) 172884) inline$$Diem_scaling_factor_$def$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 172677) 172988) inline$$Diem_scaling_factor_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 172677) 172884) inline$$Diem_scaling_factor_$def$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@22) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 172661) 172677) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 172661) 172667) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon13_Else_correct  (=> (and (not $abort_flag@22) (= (ControlFlow 0 172691) 172661)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon0_correct  (=> (and (and (not $abort_flag@21) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@22)) (and (=> $abort_flag@22 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@22 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@29 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 172556) 172992) inline$$Diem_scaling_factor_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 172556) 172691) inline$$Diem_scaling_factor_$def$0$anon13_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon102_Else_correct  (=> (not $abort_flag@21) (and (=> (= (ControlFlow 0 173022) (- 0 227936)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_add_currency_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_add_currency_$def_verify$0$addr) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_add_currency_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_add_currency_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_add_currency_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_add_currency_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_add_currency_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_add_currency_$def_verify$0$addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_add_currency_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_add_currency_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_add_currency_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_add_currency_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_add_currency_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_add_currency_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_add_currency_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_add_currency_$def_verify$0$addr@@0))))))))))))))) (=> (= (ControlFlow 0 173022) 172556) inline$$Diem_scaling_factor_$def$0$anon0_correct))))))
(let ((inline$$MoveToRaw$1$anon3_Then$1_correct  (=> (= $abort_flag@21 true) (=> (and (= $abort_code@28 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@0|)) (and (=> (= (ControlFlow 0 172192) 174010) inline$$DesignatedDealer_add_currency_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 172192) 173022) inline$$DesignatedDealer_add_currency_$def_verify$0$anon102_Else_correct))))))
(let ((inline$$MoveToRaw$1$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1) (= (ControlFlow 0 172190) 172192)) inline$$MoveToRaw$1$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$1$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1)) (=> (and (and (= |inline$$MoveToRaw$1$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 inline$$DesignatedDealer_TierInfo_pack$0$$struct@1))) (= $abort_flag@21 $abort_flag@20)) (and (= $abort_code@28 $abort_code@26) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@1|))) (and (=> (= (ControlFlow 0 172140) 174010) inline$$DesignatedDealer_add_currency_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 172140) 173022) inline$$DesignatedDealer_add_currency_$def_verify$0$anon102_Else_correct))))))
(let ((inline$$MoveTo$1$anon0$1_correct  (=> (= inline$$MoveTo$1$a@1 (|a#$Address| dd)) (and (=> (= (ControlFlow 0 172198) 172190) inline$$MoveToRaw$1$anon3_Then_correct) (=> (= (ControlFlow 0 172198) 172140) inline$$MoveToRaw$1$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$1$Entry_correct  (and (=> (= (ControlFlow 0 171986) (- 0 227821)) true) (=> (= (ControlFlow 0 171986) 172198) inline$$MoveTo$1$anon0$1_correct))))
(let ((inline$$MoveTo$1$Entry_correct  (=> (and (= inline$$MoveTo$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (= (ControlFlow 0 171958) 171986)) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon100_Else$1_correct  (and (=> (= (ControlFlow 0 172206) (- 0 227759)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)) (=> (= (ControlFlow 0 172206) 171958) inline$$MoveTo$1$Entry_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 171820) (- 0 227613)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 171820) (- 0 227634)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_pack$0$$range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_pack$0$$i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_pack$0$$range_1)) inline$$DesignatedDealer_TierInfo_pack$0$$i_0) (< inline$$DesignatedDealer_TierInfo_pack$0$$i_0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_pack$0$$range_1)))) (let ((inline$$DesignatedDealer_TierInfo_pack$0$i ($Integer inline$$DesignatedDealer_TierInfo_pack$0$$i_0)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_pack$0$$range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_pack$0$$i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_pack$0$$range_3)) inline$$DesignatedDealer_TierInfo_pack$0$$i_2) (< inline$$DesignatedDealer_TierInfo_pack$0$$i_2 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_pack$0$$range_3)))) (let ((inline$$DesignatedDealer_TierInfo_pack$0$j ($Integer inline$$DesignatedDealer_TierInfo_pack$0$$i_2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_pack$0$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_pack$0$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_pack$0$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_pack$0$j)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_pack$0$$range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_pack$0$$i_0@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_pack$0$$range_1)) inline$$DesignatedDealer_TierInfo_pack$0$$i_0@@0) (< inline$$DesignatedDealer_TierInfo_pack$0$$i_0@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_pack$0$$range_1)))) (let ((inline$$DesignatedDealer_TierInfo_pack$0$i ($Integer inline$$DesignatedDealer_TierInfo_pack$0$$i_0@@0)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_pack$0$$range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_pack$0$$i_2@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_pack$0$$range_3)) inline$$DesignatedDealer_TierInfo_pack$0$$i_2@@0) (< inline$$DesignatedDealer_TierInfo_pack$0$$i_2@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_pack$0$$range_3)))) (let ((inline$$DesignatedDealer_TierInfo_pack$0$j ($Integer inline$$DesignatedDealer_TierInfo_pack$0$$i_2@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_pack$0$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_pack$0$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_pack$0$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_pack$0$$struct@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_pack$0$j))))))))))))))))))))) (=> (= (ControlFlow 0 171820) 172206) inline$$DesignatedDealer_add_currency_$def_verify$0$anon100_Else$1_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 171834) 171820)) inline$$DesignatedDealer_TierInfo_pack$0$anon3_correct)))
(let ((inline$$DesignatedDealer_TierInfo_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 171840) 171820) inline$$DesignatedDealer_TierInfo_pack$0$anon3_correct)))
(let ((inline$$DesignatedDealer_TierInfo_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 171828) 171840) inline$$DesignatedDealer_TierInfo_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 171828) 171834) inline$$DesignatedDealer_TierInfo_pack$0$anon5_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 171672) 171820)) inline$$DesignatedDealer_TierInfo_pack$0$anon3_correct)))
(let ((inline$$DesignatedDealer_TierInfo_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Integer) call2formal@$ret0@0@@0) (>= (|i#$Integer| call2formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@0) $MAX_U64)) (and (and ((_ is $Integer) inline$$DesignatedDealer_add_currency_$def_verify$0$$t18@1) (>= (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t18@1) 0)) (<= (|i#$Integer| inline$$DesignatedDealer_add_currency_$def_verify$0$$t18@1) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$Vector_empty$0$v@1) (let ((va@@13 (|v#$Vector| inline$$Vector_empty$0$v@1)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (forall ((inline$$DesignatedDealer_TierInfo_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DesignatedDealer_TierInfo_pack$0$$$0 0) (< inline$$DesignatedDealer_TierInfo_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DesignatedDealer_TierInfo_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DesignatedDealer_TierInfo_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DesignatedDealer_TierInfo_pack$0$$$0)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DesignatedDealer_TierInfo_pack$0$$$0))
))) (= inline$$DesignatedDealer_TierInfo_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 call2formal@$ret0@0@@0) 1 inline$$DesignatedDealer_add_currency_$def_verify$0$$t18@1) 2 inline$$Vector_empty$0$v@1) 3))))) (and (=> (= (ControlFlow 0 171664) 171828) inline$$DesignatedDealer_TierInfo_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 171664) 171672) inline$$DesignatedDealer_TierInfo_pack$0$anon4_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon100_Else_correct  (=> (and (not $abort_flag@20) (= (ControlFlow 0 171846) 171664)) inline$$DesignatedDealer_TierInfo_pack$0$anon0_correct)))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 171242) 174030) inline$$DesignatedDealer_add_currency_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 171242) 171846) inline$$DesignatedDealer_add_currency_$def_verify$0$anon100_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 $IntegerType) (= (ControlFlow 0 171238) 171242)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon98_Else_correct  (=> (not $abort_flag@20) (=> (and (= inline$$DesignatedDealer_add_currency_$def_verify$0$$t18@1 ($Integer 0)) (= (ControlFlow 0 171248) 171238)) inline$$Vector_empty$0$Entry_correct))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon96_Then_correct  (=> (|b#$Boolean| inline$$Not$2$dst@1) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@20) (=> $abort_flag@20 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@20 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@26 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (and (and ((_ is $Integer) call2formal@$ret0@0@@0) (>= (|i#$Integer| call2formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 171205) 174050) inline$$DesignatedDealer_add_currency_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 171205) 171248) inline$$DesignatedDealer_add_currency_$def_verify$0$anon98_Else_correct))))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon34_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@27)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 171191) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 171189) 171191)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon34_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon97_Then_correct  (=> (= (ControlFlow 0 171199) 171191) inline$$DesignatedDealer_add_currency_$def_verify$0$anon34_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon96_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$2$dst@1)) (= $abort_code@27 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 171183) 171199) inline$$DesignatedDealer_add_currency_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 171183) 171189) inline$$DesignatedDealer_add_currency_$def_verify$0$anon97_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon94_Else_correct  (=> (not $abort_flag@19) (and (=> (= (ControlFlow 0 171171) 171205) inline$$DesignatedDealer_add_currency_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 171171) 171183) inline$$DesignatedDealer_add_currency_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon93_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_add_currency_$def_verify$0$$t15@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@19)) (and (=> $abort_flag@19 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@19) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 171165) 174070) inline$$DesignatedDealer_add_currency_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 171165) 171171) inline$$DesignatedDealer_add_currency_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$Not$2$anon0_correct  (=> (and (= inline$$Not$2$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DesignatedDealer_add_currency_$def_verify$0$$t13@1)))) (= (ControlFlow 0 171153) 171165)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon93_Else$1_correct)))
(let ((inline$$Not$2$Entry_correct  (and (=> (= (ControlFlow 0 171143) (- 0 227254)) true) (=> (= (ControlFlow 0 171143) 171153) inline$$Not$2$anon0_correct))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon93_Else_correct  (=> (not $abort_flag@18) (=> (and (= inline$$DesignatedDealer_add_currency_$def_verify$0$$t13@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0)))) (= (ControlFlow 0 171159) 171143)) inline$$Not$2$Entry_correct))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon93_Then_correct  (=> $abort_flag@18 (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_code@41 $abort_code@24)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 174090) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon59_Else_correct  (=> (and (and (not $abort_flag@17) (= $abort_code@24 $abort_code@22)) (and (= $abort_flag@18 $abort_flag@17) (= $Diem_Preburn_$memory@1 |inline$$MoveToRaw$0$m'@2|))) (and (=> (= (ControlFlow 0 170929) 174090) inline$$DesignatedDealer_add_currency_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 170929) 171159) inline$$DesignatedDealer_add_currency_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct  (=> (= $abort_code@24 $abort_code@23) (=> (and (= $abort_flag@18 true) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory@0)) (and (=> (= (ControlFlow 0 169376) 174090) inline$$DesignatedDealer_add_currency_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 169376) 171159) inline$$DesignatedDealer_add_currency_$def_verify$0$anon93_Else_correct))))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon7_correct  (=> (= $abort_code@23 $abort_code@6) (=> (and (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory) (= (ControlFlow 0 171049) 169376)) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 171047) 171049)) inline$$Diem_publish_preburn_to_account_$def$0$anon7_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 171057) 171049) inline$$Diem_publish_preburn_to_account_$def$0$anon7_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon43_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 171041) 171057) inline$$Diem_publish_preburn_to_account_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 171041) 171047) inline$$Diem_publish_preburn_to_account_$def$0$anon44_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon11_correct  (=> (= $abort_code@23 $abort_code@7) (=> (and (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory) (= (ControlFlow 0 171029) 169376)) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 171027) 171029)) inline$$Diem_publish_preburn_to_account_$def$0$anon11_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 171037) 171029) inline$$Diem_publish_preburn_to_account_$def$0$anon11_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon45_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 171021) 171037) inline$$Diem_publish_preburn_to_account_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 171021) 171027) inline$$Diem_publish_preburn_to_account_$def$0$anon46_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon17_correct  (=> (= $abort_code@23 $abort_code@12) (=> (and (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory) (= (ControlFlow 0 171005) 169376)) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 171003) 171005)) inline$$Diem_publish_preburn_to_account_$def$0$anon17_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon49_Then_correct  (=> (= (ControlFlow 0 171013) 171005) inline$$Diem_publish_preburn_to_account_$def$0$anon17_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon48_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 170997) 171013) inline$$Diem_publish_preburn_to_account_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 170997) 171003) inline$$Diem_publish_preburn_to_account_$def$0$anon49_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon25_correct  (=> (= $abort_code@23 $abort_code@13) (=> (and (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory) (= (ControlFlow 0 170985) 169376)) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 170983) 170985)) inline$$Diem_publish_preburn_to_account_$def$0$anon25_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 170993) 170985) inline$$Diem_publish_preburn_to_account_$def$0$anon25_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon52_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 170977) 170993) inline$$Diem_publish_preburn_to_account_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 170977) 170983) inline$$Diem_publish_preburn_to_account_$def$0$anon53_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon29_correct  (=> (= $abort_code@23 $abort_code@15) (=> (and (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory) (= (ControlFlow 0 170965) 169376)) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 170963) 170965)) inline$$Diem_publish_preburn_to_account_$def$0$anon29_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 170973) 170965) inline$$Diem_publish_preburn_to_account_$def$0$anon29_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon54_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 170957) 170973) inline$$Diem_publish_preburn_to_account_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 170957) 170963) inline$$Diem_publish_preburn_to_account_$def$0$anon55_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon39_correct  (=> (= $abort_code@23 $abort_code@22) (=> (and (= $Diem_Preburn_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 170941) 169376)) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 170939) 170941)) inline$$Diem_publish_preburn_to_account_$def$0$anon39_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon60_Then_correct  (=> (= (ControlFlow 0 170949) 170941) inline$$Diem_publish_preburn_to_account_$def$0$anon39_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon59_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 170933) 170949) inline$$Diem_publish_preburn_to_account_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 170933) 170939) inline$$Diem_publish_preburn_to_account_$def$0$anon60_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@17 true) (=> (and (= $abort_code@22 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 170907) 170933) inline$$Diem_publish_preburn_to_account_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 170907) 170929) inline$$Diem_publish_preburn_to_account_$def$0$anon59_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 170905) 170907)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 inline$$Diem_create_preburn_$def$0$$ret0@2))) (= $abort_flag@17 $abort_flag@16)) (and (= $abort_code@22 $abort_code@21) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 170855) 170933) inline$$Diem_publish_preburn_to_account_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 170855) 170929) inline$$Diem_publish_preburn_to_account_$def$0$anon59_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| dd)) (and (=> (= (ControlFlow 0 170913) 170905) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 170913) 170855) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 170701) (- 0 226938)) true) (=> (= (ControlFlow 0 170701) 170913) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (= (ControlFlow 0 170673) 170701)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon58_Else_correct  (=> (not $abort_flag@16) (and (=> (= (ControlFlow 0 170921) (- 0 226876)) (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_publish_preburn_to_account_$def$0$$Diem_Preburn_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_publish_preburn_to_account_$def$0$$Diem_Preburn_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)) (=> (= (ControlFlow 0 170921) 170673) inline$$MoveTo$0$Entry_correct))))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon58_Then_correct  (=> (and (and $abort_flag@16 (= $abort_code@23 $abort_code@21)) (and (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory) (= (ControlFlow 0 170953) 169376))) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_create_preburn_$def$0$$ret0@1 $Error) (= $abort_code@21 $abort_code@20)) (and (= inline$$Diem_create_preburn_$def$0$$ret0@2 inline$$Diem_create_preburn_$def$0$$ret0@1) (= $abort_flag@16 true))) (and (=> (= (ControlFlow 0 170495) 170953) inline$$Diem_publish_preburn_to_account_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 170495) 170921) inline$$Diem_publish_preburn_to_account_$def$0$anon58_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon5_correct  (=> (and (= $abort_code@20 $abort_code@17) (= (ControlFlow 0 170527) 170495)) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 170525) 170527)) inline$$Diem_create_preburn_$def$0$anon5_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 170535) 170527) inline$$Diem_create_preburn_$def$0$anon5_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 170519) 170535) inline$$Diem_create_preburn_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 170519) 170525) inline$$Diem_create_preburn_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon9_correct  (=> (and (= $abort_code@20 $abort_code@18) (= (ControlFlow 0 170507) 170495)) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 170505) 170507)) inline$$Diem_create_preburn_$def$0$anon9_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 170515) 170507) inline$$Diem_create_preburn_$def$0$anon9_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 170499) 170515) inline$$Diem_create_preburn_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 170499) 170505) inline$$Diem_create_preburn_$def$0$anon19_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Then_correct  (=> $abort_flag@15 (=> (and (= $abort_code@20 $abort_code@19) (= (ControlFlow 0 170489) 170495)) inline$$Diem_create_preburn_$def$0$Abort_correct))))
(let ((inline$$Diem_create_preburn_$def$0$anon14_correct  (=> (= $abort_code@21 $abort_code@19) (=> (and (= inline$$Diem_create_preburn_$def$0$$ret0@2 inline$$Diem_Preburn_pack$0$$struct@1) (= $abort_flag@16 $abort_flag@15)) (and (=> (= (ControlFlow 0 170477) 170953) inline$$Diem_publish_preburn_to_account_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 170477) 170921) inline$$Diem_publish_preburn_to_account_$def$0$anon58_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 170475) 170477)) inline$$Diem_create_preburn_$def$0$anon14_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 170485) 170477) inline$$Diem_create_preburn_$def$0$anon14_correct)))
(let ((inline$$Diem_Preburn_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 170453) 170485) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 170453) 170475) inline$$Diem_create_preburn_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 170459) 170485) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 170459) 170475) inline$$Diem_create_preburn_$def$0$anon21_Else_correct))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 170447) 170459) inline$$Diem_Preburn_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 170447) 170453) inline$$Diem_Preburn_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 170439) 170485) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 170439) 170475) inline$$Diem_create_preburn_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$0$$ret0@2) (let ((va@@14 (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$Diem_Preburn_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 170431) 170447) inline$$Diem_Preburn_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 170431) 170439) inline$$Diem_Preburn_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 170465) 170431)) inline$$Diem_Preburn_pack$0$anon0_correct)))
(let ((inline$$Diem_zero_$def$0$anon3_correct  (=> (= inline$$Diem_zero_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@15 true) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_zero_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 170270) 170489) inline$$Diem_create_preburn_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 170270) 170465) inline$$Diem_create_preburn_$def$0$anon20_Else_correct))))))
(let ((inline$$Diem_zero_$def$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 170264) 170270)) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon8_Then_correct  (=> (= (ControlFlow 0 170278) 170270) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon7_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 170258) 170278) inline$$Diem_zero_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 170258) 170264) inline$$Diem_zero_$def$0$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon6_correct  (=> (and (= $abort_flag@15 $abort_flag@14) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_Diem_pack$0$$struct@1)) (and (=> (= (ControlFlow 0 170246) 170489) inline$$Diem_create_preburn_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 170246) 170465) inline$$Diem_create_preburn_$def$0$anon20_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 170244) 170246)) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_zero_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 170254) 170246) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 170222) 170254) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 170222) 170244) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 170228) 170254) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 170228) 170244) inline$$Diem_zero_$def$0$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 170216) 170228) inline$$Diem_Diem_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 170216) 170222) inline$$Diem_Diem_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 170208) 170254) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 170208) 170244) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$0$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 170200) 170216) inline$$Diem_Diem_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 170200) 170208) inline$$Diem_Diem_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon7_Else_correct  (=> (not $abort_flag@14) (=> (and (= inline$$Diem_zero_$def$0$$t0@1 ($Integer 0)) (= (ControlFlow 0 170234) 170200)) inline$$Diem_Diem_pack$0$anon0_correct))))
(let ((inline$$Diem_zero_$def$0$anon0_correct  (=> (and (and (not $abort_flag@13) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@14)) (and (=> $abort_flag@14 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@14 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@19 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 170059) 170258) inline$$Diem_zero_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 170059) 170234) inline$$Diem_zero_$def$0$anon7_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Else_correct  (=> (and (not $abort_flag@13) (= (ControlFlow 0 170292) 170059)) inline$$Diem_zero_$def$0$anon0_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Else_correct  (=> (and (and (not $abort_flag@12) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@13)) (and (=> $abort_flag@13 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@13 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@18 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 169862) 170499) inline$$Diem_create_preburn_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 169862) 170292) inline$$Diem_create_preburn_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@12) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@12) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@12)) (and (=> $abort_flag@12 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@12 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@17 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@17 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@17 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 169856) 170519) inline$$Diem_create_preburn_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 169856) 169862) inline$$Diem_create_preburn_$def$0$anon16_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 169820) 169856)) inline$$Diem_create_preburn_$def$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 170543) 169856) inline$$Diem_create_preburn_$def$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon0_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 169814) 170543) inline$$Diem_create_preburn_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 169814) 169820) inline$$Diem_create_preburn_$def$0$anon15_Else_correct)))))
(let ((inline$$Diem_create_preburn$0$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 170549) 169814)) inline$$Diem_create_preburn_$def$0$anon0_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon56_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 170557) 170549)) inline$$Diem_create_preburn$0$anon0_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon34_correct  (=> (= $abort_code@23 $abort_code@16) (=> (and (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory) (= (ControlFlow 0 169496) 169376)) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 169494) 169496)) inline$$Diem_publish_preburn_to_account_$def$0$anon34_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 169504) 169496) inline$$Diem_publish_preburn_to_account_$def$0$anon34_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon56_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= $abort_code@16 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 169488) 169504) inline$$Diem_publish_preburn_to_account_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 169488) 169494) inline$$Diem_publish_preburn_to_account_$def$0$anon57_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon54_Else_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 169476) 170557) inline$$Diem_publish_preburn_to_account_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 169476) 169488) inline$$Diem_publish_preburn_to_account_$def$0$anon56_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon52_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_preburn_to_account_$def$0$$t15@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11)) (and (=> $abort_flag@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 169470) 170957) inline$$Diem_publish_preburn_to_account_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 169470) 169476) inline$$Diem_publish_preburn_to_account_$def$0$anon54_Else_correct)))))
(let ((inline$$Not$1$anon0_correct  (=> (and (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_publish_preburn_to_account_$def$0$$t13@1)))) (= (ControlFlow 0 169458) 169470)) inline$$Diem_publish_preburn_to_account_$def$0$anon52_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 169448) (- 0 225991)) true) (=> (= (ControlFlow 0 169448) 169458) inline$$Not$1$anon0_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon52_Else_correct  (=> (not $abort_flag@10) (=> (and (= inline$$Diem_publish_preburn_to_account_$def$0$$t13@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0@@2)))) (= (ControlFlow 0 169464) 169448)) inline$$Not$1$Entry_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon50_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@10) (=> $abort_flag@10 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 dd)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 169390) 170977) inline$$Diem_publish_preburn_to_account_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 169390) 169464) inline$$Diem_publish_preburn_to_account_$def$0$anon52_Else_correct))))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon22_correct  (=> (= $abort_code@23 $abort_code@14) (=> (and (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory) (= (ControlFlow 0 169372) 169376)) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 169370) 169372)) inline$$Diem_publish_preburn_to_account_$def$0$anon22_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 169384) 169372) inline$$Diem_publish_preburn_to_account_$def$0$anon22_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon50_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@14 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 169364) 169384) inline$$Diem_publish_preburn_to_account_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 169364) 169370) inline$$Diem_publish_preburn_to_account_$def$0$anon51_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon48_Else_correct  (=> (not $abort_flag@9) (and (=> (= (ControlFlow 0 169352) 169390) inline$$Diem_publish_preburn_to_account_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 169352) 169364) inline$$Diem_publish_preburn_to_account_$def$0$anon50_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon47_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_preburn_to_account_$def$0$$t10@1 ($Integer 6)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9)) (and (=> $abort_flag@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 169346) 170997) inline$$Diem_publish_preburn_to_account_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 169346) 169352) inline$$Diem_publish_preburn_to_account_$def$0$anon48_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_is_synthetic_currency_$def$0$$ret0@2)))) (= (ControlFlow 0 169334) 169346)) inline$$Diem_publish_preburn_to_account_$def$0$anon47_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 169324) (- 0 225792)) true) (=> (= (ControlFlow 0 169324) 169334) inline$$Not$0$anon0_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon47_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 169340) 169324)) inline$$Not$0$Entry_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon47_Then_correct  (=> (and (and $abort_flag@8 (= $abort_code@23 $abort_code@11)) (and (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory) (= (ControlFlow 0 171017) 169376))) inline$$Diem_publish_preburn_to_account_$def$0$Abort_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_is_synthetic_currency_$def$0$$ret0@1 $Error) (= $abort_flag@8 true)) (and (= $abort_code@11 $abort_code@10) (= inline$$Diem_is_synthetic_currency_$def$0$$ret0@2 inline$$Diem_is_synthetic_currency_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 169258) 171017) inline$$Diem_publish_preburn_to_account_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 169258) 169340) inline$$Diem_publish_preburn_to_account_$def$0$anon47_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon7_correct  (=> (and (= $abort_code@10 $abort_code@8) (= (ControlFlow 0 169252) 169258)) inline$$Diem_is_synthetic_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 169250) 169252)) inline$$Diem_is_synthetic_currency_$def$0$anon7_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 169266) 169252) inline$$Diem_is_synthetic_currency_$def$0$anon7_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon17_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 169244) 169266) inline$$Diem_is_synthetic_currency_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 169244) 169250) inline$$Diem_is_synthetic_currency_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon15_Then_correct  (=> $abort_flag@5 (=> (and (= $abort_code@10 $abort_code@7) (= (ControlFlow 0 169270) 169258)) inline$$Diem_is_synthetic_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon14_correct  (=> (= $abort_flag@8 $abort_flag@7) (=> (and (= $abort_code@11 $abort_code@9) (= inline$$Diem_is_synthetic_currency_$def$0$$ret0@2 |inline$$Diem_is_synthetic_currency_$def$0$tmp#$1@1|)) (and (=> (= (ControlFlow 0 168927) 171017) inline$$Diem_publish_preburn_to_account_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 168927) 169340) inline$$Diem_publish_preburn_to_account_$def$0$anon47_Else_correct))))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 168925) 168927)) inline$$Diem_is_synthetic_currency_$def$0$anon14_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 168935) 168927) inline$$Diem_is_synthetic_currency_$def$0$anon14_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon10_correct  (=> (= $abort_code@9 $abort_code@8) (=> (and (= |inline$$Diem_is_synthetic_currency_$def$0$tmp#$1@1| inline$$GetFieldFromValue$0$dst@1) (= $abort_flag@7 $abort_flag@6)) (and (=> (= (ControlFlow 0 169232) 168935) inline$$Diem_is_synthetic_currency_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 169232) 168925) inline$$Diem_is_synthetic_currency_$def$0$anon21_Else_correct))))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 169230) 169232)) inline$$Diem_is_synthetic_currency_$def$0$anon10_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 169240) 169232) inline$$Diem_is_synthetic_currency_$def$0$anon10_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $Diem_CurrencyInfo_is_synthetic)) (and (=> (= (ControlFlow 0 169182) 169240) inline$$Diem_is_synthetic_currency_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 169182) 169230) inline$$Diem_is_synthetic_currency_$def$0$anon19_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon17_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 169188) 169182)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@6 true) (=> (and (= $abort_code@8 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 169128) 169244) inline$$Diem_is_synthetic_currency_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 169128) 169188) inline$$Diem_is_synthetic_currency_$def$0$anon17_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 169126) 169128)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1))) (= $abort_flag@6 $abort_flag@5)) (and (= $abort_code@8 $abort_code@7) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 169074) 169244) inline$$Diem_is_synthetic_currency_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 169074) 169188) inline$$Diem_is_synthetic_currency_$def$0$anon17_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 169056) 169126) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 169056) 169074) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (=> (= inline$$GetGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (and (=> (= (ControlFlow 0 169050) (- 0 225557)) true) (=> (= (ControlFlow 0 169050) 169056) inline$$GetGlobal$0$anon0_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon16_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_is_synthetic_currency_$def$0$$t2@1) (= (ControlFlow 0 169134) 169050)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon12_correct  (=> (= $abort_code@9 $abort_code@7) (=> (and (= |inline$$Diem_is_synthetic_currency_$def$0$tmp#$1@1| inline$$Diem_is_synthetic_currency_$def$0$$t5@1) (= $abort_flag@7 $abort_flag@5)) (and (=> (= (ControlFlow 0 168915) 168935) inline$$Diem_is_synthetic_currency_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 168915) 168925) inline$$Diem_is_synthetic_currency_$def$0$anon21_Else_correct))))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 168913) 168915)) inline$$Diem_is_synthetic_currency_$def$0$anon12_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 168943) 168915) inline$$Diem_is_synthetic_currency_$def$0$anon12_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon16_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_is_synthetic_currency_$def$0$$t2@1)) (= inline$$Diem_is_synthetic_currency_$def$0$$t5@1 ($Boolean false))) (and (=> (= (ControlFlow 0 168905) 168943) inline$$Diem_is_synthetic_currency_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 168905) 168913) inline$$Diem_is_synthetic_currency_$def$0$anon20_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon15_Else_correct  (=> (and (not $abort_flag@5) (= inline$$Diem_is_synthetic_currency_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1))))) (and (=> (= (ControlFlow 0 168861) 169134) inline$$Diem_is_synthetic_currency_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 168861) 168905) inline$$Diem_is_synthetic_currency_$def$0$anon16_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 168809) 169270) inline$$Diem_is_synthetic_currency_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 168809) 168861) inline$$Diem_is_synthetic_currency_$def$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 168819) 169270) inline$$Diem_is_synthetic_currency_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 168819) 168861) inline$$Diem_is_synthetic_currency_$def$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@5) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 168803) 168819) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 168803) 168809) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon0_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 168833) 168803)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon45_Else_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 169284) 168833)) inline$$Diem_is_synthetic_currency_$def$0$anon0_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon43_Else_correct  (=> (and (not $abort_flag@4) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@5)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@5) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@5)) (and (=> $abort_flag@5 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@5 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@7 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@7 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@7 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 168370) 171021) inline$$Diem_publish_preburn_to_account_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 168370) 169284) inline$$Diem_publish_preburn_to_account_$def$0$anon45_Else_correct))))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) $abort_flag@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@4)) (and (=> $abort_flag@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))))) (=> $abort_flag@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (= $abort_code@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@6 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 168364) 171041) inline$$Diem_publish_preburn_to_account_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 168364) 168370) inline$$Diem_publish_preburn_to_account_$def$0$anon43_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon4_correct  (=> (and (= inline$$Diem_publish_preburn_to_account_$def$0$$Diem_Preburn_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd) true)) (= (ControlFlow 0 168328) 168364)) inline$$Diem_publish_preburn_to_account_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 168266) 168328)) inline$$Diem_publish_preburn_to_account_$def$0$anon4_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 171065) 168328) inline$$Diem_publish_preburn_to_account_$def$0$anon4_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 168258) 171065) inline$$Diem_publish_preburn_to_account_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 168258) 168266) inline$$Diem_publish_preburn_to_account_$def$0$anon42_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 171073) 171065) inline$$Diem_publish_preburn_to_account_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 171073) 168266) inline$$Diem_publish_preburn_to_account_$def$0$anon42_Else_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def$0$anon0_correct  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 168252) 171073) inline$$Diem_publish_preburn_to_account_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 168252) 168258) inline$$Diem_publish_preburn_to_account_$def$0$anon41_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$direct_inter$0$anon0_correct  (=> ((_ is $Address) dd) (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 171077) 168252)) inline$$Diem_publish_preburn_to_account_$def$0$anon0_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$direct_inter$0$Entry_correct  (and (=> (= (ControlFlow 0 167555) (- 0 224790)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$Diem_Preburn_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_currency_$def_verify$0$$Diem_Preburn_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)) (=> (= (ControlFlow 0 167555) 171077) inline$$Diem_publish_preburn_to_account_$direct_inter$0$anon0_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon91_Then_correct  (=> (and (|b#$Boolean| call3formal@$ret0@0@@4) (= (ControlFlow 0 171083) 167555)) inline$$Diem_publish_preburn_to_account_$direct_inter$0$Entry_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon24_correct  (=> (and (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory) (= $abort_code@41 $abort_code@5@@0)) (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 167423) 167427))) inline$$DesignatedDealer_add_currency_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 167421) 167423)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon24_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon92_Then_correct  (=> (= (ControlFlow 0 167435) 167423) inline$$DesignatedDealer_add_currency_$def_verify$0$anon24_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon91_Else_correct  (=> (and (not (|b#$Boolean| call3formal@$ret0@0@@4)) (= $abort_code@5@@0 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 167415) 167435) inline$$DesignatedDealer_add_currency_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 167415) 167421) inline$$DesignatedDealer_add_currency_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon89_Else_correct  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 167403) 171083) inline$$DesignatedDealer_add_currency_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 167403) 167415) inline$$DesignatedDealer_add_currency_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon87_Else_correct  (=> (not $abort_flag@2@@0) (=> (and (and (and (= inline$$DesignatedDealer_add_currency_$def_verify$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0)) (and (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 167397) 174094) inline$$DesignatedDealer_add_currency_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 167397) 167403) inline$$DesignatedDealer_add_currency_$def_verify$0$anon89_Else_correct))))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon85_Else_correct  (=> (not $abort_flag@1@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@0) (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0))))))) ((_ is $Boolean) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 167387) 174114) inline$$DesignatedDealer_add_currency_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 167387) 167397) inline$$DesignatedDealer_add_currency_$def_verify$0$anon87_Else_correct))))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon83_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 dd)))) ((_ is $Address) call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 167381) 174134) inline$$DesignatedDealer_add_currency_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 167381) 167387) inline$$DesignatedDealer_add_currency_$def_verify$0$anon85_Else_correct))))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@0@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@0@@0)) (and (=> $abort_flag@0@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@0@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 167375) 174154) inline$$DesignatedDealer_add_currency_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 167375) 167381) inline$$DesignatedDealer_add_currency_$def_verify$0$anon83_Else_correct))))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon4_correct  (=> (= inline$$DesignatedDealer_add_currency_$def_verify$0$$Diem_Preburn_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd) true)) (=> (and (= inline$$DesignatedDealer_add_currency_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd) true)) (= (ControlFlow 0 167339) 167375)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon4$2_correct))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 167245) 167339)) inline$$DesignatedDealer_add_currency_$def_verify$0$anon4_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon82_Then_correct  (=> (= (ControlFlow 0 174178) 167339) inline$$DesignatedDealer_add_currency_$def_verify$0$anon4_correct)))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon81_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 167237) 174178) inline$$DesignatedDealer_add_currency_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 167237) 167245) inline$$DesignatedDealer_add_currency_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon81_Then_correct  (and (=> (= (ControlFlow 0 174186) 174178) inline$$DesignatedDealer_add_currency_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 174186) 167245) inline$$DesignatedDealer_add_currency_$def_verify$0$anon82_Else_correct))))
(let ((inline$$DesignatedDealer_add_currency_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 167231) 174186) inline$$DesignatedDealer_add_currency_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 167231) 167237) inline$$DesignatedDealer_add_currency_$def_verify$0$anon81_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (and (and (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))
))) (and (forall (($inv_addr@@3 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@1))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@23 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@24 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))
)) (forall (($inv_addr@@4 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_Preburn_to_burn)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))
)))) (and (and (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@7))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (forall (($inv_addr@@6 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers))) $$0@@8)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers))) $$0@@8))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@0)) $i_0@@0) (< $i_0@@0 (|i#$Integer| (|ub#$Range| $range_1@@0)))) (let ((i@@11 ($Integer $i_0@@0)))
(|b#$Boolean| ($Boolean (let (($range_3@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@0)) $i_2@@0) (< $i_2@@0 (|i#$Integer| (|ub#$Range| $range_3@@0)))) (let ((j@@2 ($Integer $i_2@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@11) (|i#$Integer| j@@2)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@11))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@2))))))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@6))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 174190) 167231))))) inline$$DesignatedDealer_add_currency_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> ((_ is $Address) dd) (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 165270) 174190)) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| $Diem_Preburn_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)) (=> (and (|Select_[$TypeValueArray,$int]$bool| $DesignatedDealer_TierInfo_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| dd)) (= (ControlFlow 0 216265) 165270)) anon0_correct@@0))))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun tc_account@@0 () T@$Value)
(declare-fun $abort_flag@9@@0 () Bool)
(declare-fun $tv0@@11 () T@$TypeValue)
(declare-fun dd_addr () T@$Value)
(declare-fun tier_upperbound () T@$Value)
(declare-fun $abort_code@14@@0 () Int)
(declare-fun $DesignatedDealer_TierInfo_$memory@0@@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun $abort_code@11@@0 () Int)
(declare-fun $abort_flag@8@@0 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun $abort_code@13@@0 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun $abort_code@12@@0 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0 () T@$Value)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0 () T@$TypeValue)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$t35@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@2 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1 () Int)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Sub$0$dst@0@@0 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$t30@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Gt$0$dst@1@@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$t28@1 () T@$Value)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$t26@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$DesignatedDealer_add_tier_$def_verify$0$$t18@1 () T@$Value)
(declare-fun $DesignatedDealer_TierInfo_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 233657) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 180241) (- 0 238131)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 180241) (- 0 238152)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 180241) (- 0 238181)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 180241) (- 0 238198)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 180241) (- 0 238228)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 180241) (- 0 238248)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| tier_upperbound))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| tier_upperbound))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 180241) (- 0 238322)) (=> $abort_flag@9@@0 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| tier_upperbound)))))))))) (=> (=> $abort_flag@9@@0 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| tier_upperbound))))))))) (and (=> (= (ControlFlow 0 180241) (- 0 238508)) (=> $abort_flag@9@@0 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr))))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| tier_upperbound))))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@9@@0 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr))))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4)))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| tier_upperbound))))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 7)))))) (and (=> (= (ControlFlow 0 180241) (- 0 238760)) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))))) (=> (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr))))) (=> (= (ControlFlow 0 180241) (- 0 238786)) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)) ($Vector (let ((len@@15 (|l#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@16 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@16 1)))) len@@15 ($Vector (let ((m2@@3 (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 tier_upperbound) 1))))))
(let ((l2@@3 (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 tier_upperbound) 1))))))
(let ((m1@@3 (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers)))))
(let ((l1@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)))) $DesignatedDealer_TierInfo_tiers)))))
($ValueArray (|lambda#2| 0 (+ l1@@3 l2@@3) l1@@3 m1@@3 m2@@3 l1@@3 $Error) (+ l1@@3 l2@@3)))))))) (+ len@@15 1)))))))))))))))))))))))))))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon64$3_correct  (and (=> (= (ControlFlow 0 179069) (- 0 237693)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_add_tier_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_add_tier_$def_verify$0$addr) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_add_tier_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_add_tier_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_add_tier_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_add_tier_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_add_tier_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_add_tier_$def_verify$0$addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_add_tier_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_add_tier_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_add_tier_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_add_tier_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_add_tier_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_add_tier_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_add_tier_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_add_tier_$def_verify$0$addr@@0))))))))))))))) (=> (and (and (= $abort_code@14@@0 $abort_code@11@@0) (= $abort_flag@9@@0 $abort_flag@8@@0)) (and (= $DesignatedDealer_TierInfo_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 179069) 180241))) anon0$2_correct@@1)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 178927) 179069)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon64$3_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 178981) 179069))) inline$$DesignatedDealer_add_tier_$def_verify$0$anon64$3_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 178917) 178981) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 178917) 178927) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 178795) (- 0 237439)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 178795) (- 0 237460)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@0)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j))))))))))))))))))))) (=> (= (ControlFlow 0 178795) 178917) inline$$WritebackToGlobal$0$anon0_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 178647) 178795)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 178410) 178647)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 178466) 178647))) inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 178374) 178466) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 178374) 178410) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon96_Else_correct  (=> (and (not true) (= (ControlFlow 0 178237) 178374)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon96_Then_correct  (=> (and (= inline$$DesignatedDealer_add_tier_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= (ControlFlow 0 179079) 178374)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) |inline$$Vector_push_back$0$v'@1|)) (and (=> (= (ControlFlow 0 178223) 179079) inline$$DesignatedDealer_add_tier_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 178223) 178237) inline$$DesignatedDealer_add_tier_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon94_Else_correct  (=> (and (not $abort_flag@8@@0) (= (ControlFlow 0 178229) 178223)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@14@@0 $abort_code@13@@0) (= $abort_flag@9@@0 true)) (and (= $DesignatedDealer_TierInfo_$memory@0@@0 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 176837) 180241))) anon0$2_correct@@1)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon9_correct  (=> (and (= $abort_code@13@@0 $abort_code@1@@1) (= (ControlFlow 0 180203) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 180201) 180203)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon9_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 180211) 180203) inline$$DesignatedDealer_add_tier_$def_verify$0$anon9_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon68_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 180195) 180211) inline$$DesignatedDealer_add_tier_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 180195) 180201) inline$$DesignatedDealer_add_tier_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon13_correct  (=> (and (= $abort_code@13@@0 $abort_code@2@@1) (= (ControlFlow 0 180183) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 180181) 180183)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon13_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon71_Then_correct  (=> (= (ControlFlow 0 180191) 180183) inline$$DesignatedDealer_add_tier_$def_verify$0$anon13_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon70_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 180175) 180191) inline$$DesignatedDealer_add_tier_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 180175) 180181) inline$$DesignatedDealer_add_tier_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon21_correct  (=> (and (= $abort_code@13@@0 $abort_code@4@@1) (= (ControlFlow 0 180163) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 180161) 180163)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon21_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon75_Then_correct  (=> (= (ControlFlow 0 180171) 180163) inline$$DesignatedDealer_add_tier_$def_verify$0$anon21_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon74_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 180155) 180171) inline$$DesignatedDealer_add_tier_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 180155) 180161) inline$$DesignatedDealer_add_tier_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon25_correct  (=> (and (= $abort_code@13@@0 $abort_code@4@@1) (= (ControlFlow 0 180143) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon77_Else_correct  (=> (and (not true) (= (ControlFlow 0 180141) 180143)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon25_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon77_Then_correct  (=> (= (ControlFlow 0 180151) 180143) inline$$DesignatedDealer_add_tier_$def_verify$0$anon25_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon76_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 180135) 180151) inline$$DesignatedDealer_add_tier_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 180135) 180141) inline$$DesignatedDealer_add_tier_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon29_correct  (=> (and (= $abort_code@13@@0 $abort_code@5@@1) (= (ControlFlow 0 180123) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 180121) 180123)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon29_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon79_Then_correct  (=> (= (ControlFlow 0 180131) 180123) inline$$DesignatedDealer_add_tier_$def_verify$0$anon29_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon78_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 180115) 180131) inline$$DesignatedDealer_add_tier_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 180115) 180121) inline$$DesignatedDealer_add_tier_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon33_correct  (=> (and (= $abort_code@13@@0 $abort_code@6@@0) (= (ControlFlow 0 180103) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 180101) 180103)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon33_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon81_Then_correct  (=> (= (ControlFlow 0 180111) 180103) inline$$DesignatedDealer_add_tier_$def_verify$0$anon33_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon80_Then_correct  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 180095) 180111) inline$$DesignatedDealer_add_tier_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 180095) 180101) inline$$DesignatedDealer_add_tier_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon43_correct  (=> (and (= $abort_code@13@@0 $abort_code@8@@0) (= (ControlFlow 0 180083) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 180081) 180083)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon43_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon86_Then_correct  (=> (= (ControlFlow 0 180091) 180083) inline$$DesignatedDealer_add_tier_$def_verify$0$anon43_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon85_Then_correct  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 180075) 180091) inline$$DesignatedDealer_add_tier_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 180075) 180081) inline$$DesignatedDealer_add_tier_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon47_correct  (=> (and (= $abort_code@13@@0 $abort_code@9@@0) (= (ControlFlow 0 180063) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 180061) 180063)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon47_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon88_Then_correct  (=> (= (ControlFlow 0 180071) 180063) inline$$DesignatedDealer_add_tier_$def_verify$0$anon47_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon87_Then_correct  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 180055) 180071) inline$$DesignatedDealer_add_tier_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 180055) 180061) inline$$DesignatedDealer_add_tier_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon53_correct  (=> (and (= $abort_code@13@@0 $abort_code@10@@0) (= (ControlFlow 0 180035) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 180033) 180035)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon53_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon91_Then_correct  (=> (= (ControlFlow 0 180043) 180035) inline$$DesignatedDealer_add_tier_$def_verify$0$anon53_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon90_Then_correct  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 180027) 180043) inline$$DesignatedDealer_add_tier_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 180027) 180033) inline$$DesignatedDealer_add_tier_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon58_correct  (=> (and (= $abort_code@13@@0 $abort_code@12@@0) (= (ControlFlow 0 180009) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 180007) 180009)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon58_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon93_Then_correct  (=> (= (ControlFlow 0 180017) 180009) inline$$DesignatedDealer_add_tier_$def_verify$0$anon58_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon92_Else$1_correct  (=> (= $abort_code@12@@0 (|i#$Integer| call3formal@$ret0@0@@6)) (and (=> (= (ControlFlow 0 180001) 180017) inline$$DesignatedDealer_add_tier_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 180001) 180007) inline$$DesignatedDealer_add_tier_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$anon0_correct  (and (=> (= (ControlFlow 0 179991) (- 0 237798)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 179991) (- 0 237819)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@0)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j))))))))))))))))))))) (=> (= (ControlFlow 0 179991) 180001) inline$$DesignatedDealer_add_tier_$def_verify$0$anon92_Else$1_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$Entry_correct  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 179843) 179991)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$anon0_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon92_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= (ControlFlow 0 179995) 179843)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$Entry_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon61_correct  (=> (and (= $abort_code@13@@0 $abort_code@11@@0) (= (ControlFlow 0 179091) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 179089) 179091)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon61_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon95_Then_correct  (=> (= (ControlFlow 0 179099) 179091) inline$$DesignatedDealer_add_tier_$def_verify$0$anon61_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon94_Then_correct  (=> $abort_flag@8@@0 (and (=> (= (ControlFlow 0 179083) 179099) inline$$DesignatedDealer_add_tier_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 179083) 179089) inline$$DesignatedDealer_add_tier_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@18 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) len@@18 tier_upperbound) (+ len@@18 1)))))) (and (=> (= (ControlFlow 0 178158) 179083) inline$$DesignatedDealer_add_tier_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 178158) 178229) inline$$DesignatedDealer_add_tier_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct  (=> (and (= inline$$Vector_push_back$0$ta@0 $IntegerType) (= (ControlFlow 0 178146) 178158)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 178095) 178146)) inline$$Vector_push_back$0$Entry_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon92_Then_correct  (=> (and (and (|b#$Boolean| inline$$Lt$0$dst@1) (= $abort_flag@8@@0 $abort_flag@7@@0)) (and (= $abort_code@11@@0 $abort_code@10@@0) (= (ControlFlow 0 180023) 178095))) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon90_Else_correct  (=> (not $abort_flag@7@@0) (and (=> (= (ControlFlow 0 179662) 180023) inline$$DesignatedDealer_add_tier_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 179662) 179995) inline$$DesignatedDealer_add_tier_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon50$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_add_tier_$def_verify$0$$t35@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7@@0)) (and (=> $abort_flag@7@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 179656) 180027) inline$$DesignatedDealer_add_tier_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 179656) 179662) inline$$DesignatedDealer_add_tier_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct  (=> (and (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| inline$$Vector_borrow$0$dst@2) (|i#$Integer| tier_upperbound)))) (= (ControlFlow 0 179644) 179656)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon50$1_correct)))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 179630) (- 0 237106)) true) (=> (= (ControlFlow 0 179630) 179644) inline$$Lt$0$anon0_correct))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 179586) 179630)) inline$$Lt$0$Entry_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon89_Then_correct  (=> (= (ControlFlow 0 180051) 179630) inline$$Lt$0$Entry_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon87_Else_correct  (=> (not $abort_flag@6@@0) (and (=> (= (ControlFlow 0 179578) 180051) inline$$DesignatedDealer_add_tier_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 179578) 179586) inline$$DesignatedDealer_add_tier_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct  (=> (= $abort_code@9@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@6@@0 true) (= inline$$Vector_borrow$0$dst@2 inline$$Vector_borrow$0$dst@0)) (and (=> (= (ControlFlow 0 179532) 180055) inline$$DesignatedDealer_add_tier_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 179532) 179578) inline$$DesignatedDealer_add_tier_$def_verify$0$anon87_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)))) (= (ControlFlow 0 179530) 179532)) inline$$Vector_borrow$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct  (=> (not (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1))))) (=> (and (and (= inline$$Vector_borrow$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) inline$$Vector_borrow$0$i_ind@1)) (= $abort_code@9@@0 $abort_code@8@@0)) (and (= $abort_flag@6@@0 $abort_flag@5@@0) (= inline$$Vector_borrow$0$dst@2 inline$$Vector_borrow$0$dst@1))) (and (=> (= (ControlFlow 0 179472) 180055) inline$$DesignatedDealer_add_tier_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 179472) 179578) inline$$DesignatedDealer_add_tier_$def_verify$0$anon87_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$2$v@1) (=> (and ((_ is $Integer) inline$$Sub$0$dst@2@@0) (= inline$$Vector_borrow$0$i_ind@1 (|i#$Integer| inline$$Sub$0$dst@2@@0))) (and (=> (= (ControlFlow 0 179446) 179530) inline$$Vector_borrow$0$anon3_Then_correct) (=> (= (ControlFlow 0 179446) 179472) inline$$Vector_borrow$0$anon3_Else_correct))))))
(let ((inline$$Vector_borrow$0$Entry_correct  (=> (and (= inline$$Vector_borrow$0$ta@0 $IntegerType) (= (ControlFlow 0 179432) 179446)) inline$$Vector_borrow$0$anon0_correct)))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 179316) 179432)) inline$$Vector_borrow$0$Entry_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon85_Else_correct  (=> (and (not $abort_flag@5@@0) (= (ControlFlow 0 179322) 179316)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@5@@0 true) (=> (and (= $abort_code@8@@0 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@0@@0)) (and (=> (= (ControlFlow 0 179272) 180075) inline$$DesignatedDealer_add_tier_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 179272) 179322) inline$$DesignatedDealer_add_tier_$def_verify$0$anon85_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$DesignatedDealer_add_tier_$def_verify$0$$t30@1)) (= (ControlFlow 0 179270) 179272)) inline$$Sub$0$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$0$anon3_Else_correct@@0  (=> (<= (|i#$Integer| inline$$DesignatedDealer_add_tier_$def_verify$0$$t30@1) (|i#$Integer| inline$$Vector_length$0$l@1)) (=> (and (and (= inline$$Sub$0$dst@1@@0 ($Integer (- (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$DesignatedDealer_add_tier_$def_verify$0$$t30@1)))) (= $abort_flag@5@@0 $abort_flag@4@@0)) (and (= $abort_code@8@@0 $abort_code@6@@0) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@1@@0))) (and (=> (= (ControlFlow 0 179218) 180075) inline$$DesignatedDealer_add_tier_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 179218) 179322) inline$$DesignatedDealer_add_tier_$def_verify$0$anon85_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 179192) (- 0 236864)) true) (and (=> (= (ControlFlow 0 179192) 179270) inline$$Sub$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 179192) 179218) inline$$Sub$0$anon3_Else_correct@@0)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon84_Then_correct  (=> (|b#$Boolean| inline$$Gt$0$dst@1@@0) (=> (and (= inline$$DesignatedDealer_add_tier_$def_verify$0$$t30@1 ($Integer 1)) (= (ControlFlow 0 179278) 179192)) inline$$Sub$0$Entry_correct@@0))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon84_Else_correct  (=> (and (and (not (|b#$Boolean| inline$$Gt$0$dst@1@@0)) (= $abort_flag@8@@0 $abort_flag@4@@0)) (and (= $abort_code@11@@0 $abort_code@6@@0) (= (ControlFlow 0 178063) 178095))) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$Gt$0$anon0_correct@@0  (=> (= inline$$Gt$0$dst@1@@0 ($Boolean (> (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$DesignatedDealer_add_tier_$def_verify$0$$t28@1)))) (and (=> (= (ControlFlow 0 178047) 179278) inline$$DesignatedDealer_add_tier_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 178047) 178063) inline$$DesignatedDealer_add_tier_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$Gt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 178033) (- 0 236819)) true) (=> (= (ControlFlow 0 178033) 178047) inline$$Gt$0$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon82_Then_correct  (=> (|b#$Boolean| inline$$Le$0$dst@1) (=> (and (= inline$$DesignatedDealer_add_tier_$def_verify$0$$t28@1 ($Integer 0)) (= (ControlFlow 0 178053) 178033)) inline$$Gt$0$Entry_correct@@0))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon38_correct  (=> (and (= $abort_code@13@@0 $abort_code@7@@0) (= (ControlFlow 0 177973) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 177971) 177973)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon38_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon83_Then_correct  (=> (= (ControlFlow 0 177981) 177973) inline$$DesignatedDealer_add_tier_$def_verify$0$anon38_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon82_Else$1_correct  (=> (= $abort_code@7@@0 (|i#$Integer| call3formal@$ret0@0@@7)) (and (=> (= (ControlFlow 0 177965) 177981) inline$$DesignatedDealer_add_tier_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 177965) 177971) inline$$DesignatedDealer_add_tier_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 177955) (- 0 236654)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 177955) (- 0 236675)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@0)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j))))))))))))))))))))) (=> (= (ControlFlow 0 177955) 177965) inline$$DesignatedDealer_add_tier_$def_verify$0$anon82_Else$1_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$Entry_correct  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 177807) 177955)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$anon0_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon82_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$0$dst@1)) (= (ControlFlow 0 177959) 177807)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$Entry_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon80_Else_correct  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 177626) 178053) inline$$DesignatedDealer_add_tier_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 177626) 177959) inline$$DesignatedDealer_add_tier_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon78_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_add_tier_$def_verify$0$$t26@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@0)) (and (=> $abort_flag@4@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 177620) 180095) inline$$DesignatedDealer_add_tier_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 177620) 177626) inline$$DesignatedDealer_add_tier_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$Le$0$anon0_correct  (=> (and (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| inline$$AddU64$0$dst@2) (|i#$Integer| inline$$DesignatedDealer_add_tier_$def_verify$0$$t24@1)))) (= (ControlFlow 0 177608) 177620)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon78_Else$1_correct)))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 177594) (- 0 236534)) true) (=> (= (ControlFlow 0 177594) 177608) inline$$Le$0$anon0_correct))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon78_Else_correct  (=> (not $abort_flag@3@@1) (=> (and (= inline$$DesignatedDealer_add_tier_$def_verify$0$$t24@1 ($Integer 4)) (= (ControlFlow 0 177614) 177594)) inline$$Le$0$Entry_correct))))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_code@5@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@3@@1 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 177534) 180115) inline$$DesignatedDealer_add_tier_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 177534) 177614) inline$$DesignatedDealer_add_tier_$def_verify$0$anon78_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$DesignatedDealer_add_tier_$def_verify$0$$t22@1)) $MAX_U64) (= (ControlFlow 0 177532) 177534)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$DesignatedDealer_add_tier_$def_verify$0$$t22@1))) (=> (and (and (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$Vector_length$0$l@1) (|i#$Integer| inline$$DesignatedDealer_add_tier_$def_verify$0$$t22@1)))) (= $abort_code@5@@1 $abort_code@4@@1)) (and (= $abort_flag@3@@1 $abort_flag@2@@1) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 177476) 180115) inline$$DesignatedDealer_add_tier_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 177476) 177614) inline$$DesignatedDealer_add_tier_$def_verify$0$anon78_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 177446) (- 0 236428)) true) (and (=> (= (ControlFlow 0 177446) 177532) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 177446) 177476) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon76_Else_correct  (=> (not $abort_flag@2@@1) (=> (and (= inline$$DesignatedDealer_add_tier_$def_verify$0$$t22@1 ($Integer 1)) (= (ControlFlow 0 177540) 177446)) inline$$AddU64$0$Entry_correct))))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@0) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0))))) (and (=> (= (ControlFlow 0 177337) 180135) inline$$DesignatedDealer_add_tier_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 177337) 177540) inline$$DesignatedDealer_add_tier_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $IntegerType) (= (ControlFlow 0 177325) 177337)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 177280) 177325)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $DesignatedDealer_TierInfo_tiers) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DesignatedDealer_TierInfo_tiers))) (= (ControlFlow 0 177242) 177280))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_TierInfo_$unpack_ref$0$anon0_correct  (=> (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@1)) $i_0@@1) (< $i_0@@1 (|i#$Integer| (|ub#$Range| $range_1@@1)))) (let ((i@@12 ($Integer $i_0@@1)))
(|b#$Boolean| ($Boolean (let (($range_3@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@1)) $i_2@@1) (< $i_2@@1 (|i#$Integer| (|ub#$Range| $range_3@@1)))) (let ((j@@3 ($Integer $i_2@@1)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@12) (|i#$Integer| j@@3)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@12))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@3)))))))))))))))))))))) (= (ControlFlow 0 177120) 177242)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_TierInfo_$unpack_ref$0$Entry_correct  (=> (and (= inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 177114) 177120)) inline$$DesignatedDealer_TierInfo_$unpack_ref$0$anon0_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon74_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 177124) 177114)) inline$$DesignatedDealer_TierInfo_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@1 true) (=> (and (= $abort_code@4@@1 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 177074) 180155) inline$$DesignatedDealer_add_tier_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 177074) 177124) inline$$DesignatedDealer_add_tier_$def_verify$0$anon74_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 177072) 177074)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1))) (= $abort_flag@2@@1 $abort_flag@1@@1)) (and (= $abort_code@4@@1 $abort_code@2@@1) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 177020) 180155) inline$$DesignatedDealer_add_tier_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 177020) 177124) inline$$DesignatedDealer_add_tier_$def_verify$0$anon74_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| dd_addr)) (and (=> (= (ControlFlow 0 176990) 177072) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 176990) 177020) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (=> (= inline$$BorrowGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1)) (and (=> (= (ControlFlow 0 176984) (- 0 236182)) true) (=> (= (ControlFlow 0 176984) 176990) inline$$BorrowGlobal$0$anon0_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon72_Then_correct  (=> (|b#$Boolean| inline$$DesignatedDealer_add_tier_$def_verify$0$$t17@1) (and (=> (= (ControlFlow 0 177080) (- 0 236114)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_tier_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_add_tier_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)) (=> (= (ControlFlow 0 177080) 176984) inline$$BorrowGlobal$0$Entry_correct))))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon18_correct  (=> (and (= $abort_code@13@@0 $abort_code@3@@1) (= (ControlFlow 0 176833) 176837)) inline$$DesignatedDealer_add_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 176831) 176833)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon18_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon73_Then_correct  (=> (= (ControlFlow 0 176845) 176833) inline$$DesignatedDealer_add_tier_$def_verify$0$anon18_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon72_Else_correct  (=> (and (not (|b#$Boolean| inline$$DesignatedDealer_add_tier_$def_verify$0$$t17@1)) (= $abort_code@3@@1 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 176825) 176845) inline$$DesignatedDealer_add_tier_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 176825) 176831) inline$$DesignatedDealer_add_tier_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon70_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 176813) 177080) inline$$DesignatedDealer_add_tier_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 176813) 176825) inline$$DesignatedDealer_add_tier_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon68_Else_correct  (=> (and (not $abort_flag@0@@1) (= inline$$DesignatedDealer_add_tier_$def_verify$0$$t17@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr))))) (=> (and (and (and (= inline$$DesignatedDealer_add_tier_$def_verify$0$$t18@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 176807) 180175) inline$$DesignatedDealer_add_tier_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 176807) 176813) inline$$DesignatedDealer_add_tier_$def_verify$0$anon70_Else_correct))))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) $abort_flag@0@@1) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) $abort_flag@0@@1)) (and (=> $abort_flag@0@@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))))) (=> $abort_flag@0@@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 176777) 180195) inline$$DesignatedDealer_add_tier_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 176777) 176807) inline$$DesignatedDealer_add_tier_$def_verify$0$anon68_Else_correct))))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon6_correct  (=> (and (= inline$$DesignatedDealer_add_tier_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr) true)) (= (ControlFlow 0 176707) 176777)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon6$3_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 176647) 176707)) inline$$DesignatedDealer_add_tier_$def_verify$0$anon6_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon67_Then_correct  (=> (= (ControlFlow 0 180219) 176707) inline$$DesignatedDealer_add_tier_$def_verify$0$anon6_correct)))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon66_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 176639) 180219) inline$$DesignatedDealer_add_tier_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 176639) 176647) inline$$DesignatedDealer_add_tier_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon66_Then_correct  (and (=> (= (ControlFlow 0 180227) 180219) inline$$DesignatedDealer_add_tier_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 180227) 176647) inline$$DesignatedDealer_add_tier_$def_verify$0$anon67_Else_correct))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon65_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 176631) 180227) inline$$DesignatedDealer_add_tier_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 176631) 176639) inline$$DesignatedDealer_add_tier_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon65_Then_correct  (and (=> (= (ControlFlow 0 180235) 180227) inline$$DesignatedDealer_add_tier_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 180235) 176639) inline$$DesignatedDealer_add_tier_$def_verify$0$anon66_Else_correct))))
(let ((inline$$DesignatedDealer_add_tier_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 176625) 180235) inline$$DesignatedDealer_add_tier_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 176625) 176631) inline$$DesignatedDealer_add_tier_$def_verify$0$anon65_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@37 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (forall (($inv_addr@@8 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8)) (let ((va@@38 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers))) $$0@@9)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers))) $$0@@9))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@2)) $i_0@@2) (< $i_0@@2 (|i#$Integer| (|ub#$Range| $range_1@@2)))) (let ((i@@13 ($Integer $i_0@@2)))
(|b#$Boolean| ($Boolean (let (($range_3@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@2)) $i_2@@2) (< $i_2@@2 (|i#$Integer| (|ub#$Range| $range_3@@2)))) (let ((j@@4 ($Integer $i_2@@2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@13) (|i#$Integer| j@@4)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@13))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@4))))))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))
))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@3 T@$Value) )  (=> ((_ is $Type) coin_type@@3) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@0 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@4 T@$Value) )  (=> ((_ is $Type) coin_type@@4) (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@5 T@$Value) )  (=> ((_ is $Type) coin_type@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@2 T@$Value) )  (=> ((_ is $Address) addr1@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| addr1@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 180239) 176625))) inline$$DesignatedDealer_add_tier_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) tc_account@@0) ((_ is $Address) dd_addr)) (=> (and (and (and ((_ is $Integer) tier_upperbound) (>= (|i#$Integer| tier_upperbound) 0)) (<= (|i#$Integer| tier_upperbound) $MAX_U64)) (= (ControlFlow 0 175145) 180239)) anon0$1_correct@@1))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DesignatedDealer_TierInfo_$CallerDomain@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| dd_addr)) (= (ControlFlow 0 233657) 175145)) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$DesignatedDealer_exists_at_$def_verify$0$$t2@1 () T@$Value)
(declare-fun dd_addr@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 238906) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 181094) (- 0 239088)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 181094) (- 0 239097)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (=> (= (ControlFlow 0 181094) (- 0 239106)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DesignatedDealer_exists_at_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd_addr@@0))))))))))))))
(let ((inline$$DesignatedDealer_exists_at_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 181068) 181094)) anon0$2_correct@@2)))
(let ((inline$$DesignatedDealer_exists_at_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 181078) 181094) anon0$2_correct@@2)))
(let ((inline$$DesignatedDealer_exists_at_$def_verify$0$anon2$1_correct  (=> (= inline$$DesignatedDealer_exists_at_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd_addr@@0)))) (and (=> (= (ControlFlow 0 181062) 181078) inline$$DesignatedDealer_exists_at_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 181062) 181068) inline$$DesignatedDealer_exists_at_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$DesignatedDealer_exists_at_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 181016) 181062)) inline$$DesignatedDealer_exists_at_$def_verify$0$anon2$1_correct)))
(let ((inline$$DesignatedDealer_exists_at_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 181086) 181062) inline$$DesignatedDealer_exists_at_$def_verify$0$anon2$1_correct)))
(let ((inline$$DesignatedDealer_exists_at_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 181010) 181086) inline$$DesignatedDealer_exists_at_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 181010) 181016) inline$$DesignatedDealer_exists_at_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@40 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@10))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@9))
)) (= (ControlFlow 0 181092) 181010)) inline$$DesignatedDealer_exists_at_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> (and ((_ is $Address) dd_addr@@0) (= (ControlFlow 0 180870) 181092)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 238906) 180870) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun tc_account@@1 () T@$Value)
(declare-fun $abort_flag@8@@1 () Bool)
(declare-fun dd@@0 () T@$Value)
(declare-fun add_all_currencies () T@$Value)
(declare-fun $tv0@@12 () T@$TypeValue)
(declare-fun $abort_code@11@@1 () Int)
(declare-fun $DesignatedDealer_Dealer_$memory@1 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@4@@0 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@2@@0 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@4 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@2@@0 () T@$Memory)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_flag@7@@1 () Bool)
(declare-fun $abort_code@9@@1 () Int)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun $Diem_Preburn_$memory@0@@0 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@0@@1 () T@$Memory)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $Diem_Preburn_$memory@1@@0 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@1@@0 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@3@@0 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@3@@0 () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory@0 () T@$Memory)
(declare-fun $abort_code@10@@1 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun call3formal@$Diem_Preburn_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call3formal@$Diem_Preburn_$CallerDomain@0@@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$DesignatedDealer_Dealer_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_Dealer_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$t9@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun $DesignatedDealer_Dealer_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DesignatedDealer_TierInfo_$CallerDomain@@1 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 239135) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 183740) (- 0 248650)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248671)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248700)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248717)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248738)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248767)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248783)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248821)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@2 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@2)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@2)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@2 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@2)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@2)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248842)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248880)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248907)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248932)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 248976)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@3 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@3)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@3)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@3 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@3)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@3)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 249003)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 249047)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 249080)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 183740) (- 0 249111)) (=> $abort_flag@8@@1 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@4 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@4)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@4)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@5 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@5)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@5)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (=> (=> $abort_flag@8@@1 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@4 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@4)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@4)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@5 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@5)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@5)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (=> (= (ControlFlow 0 183740) (- 0 249557)) (=> $abort_flag@8@@1 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@6 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@6)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@6)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@7 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@7)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@7)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@8@@1 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@6 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@6)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@6)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@7 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@7)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@7)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 183740) (- 0 250179)) (=> (not $abort_flag@8@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory@1) $EmptyTypeValueArray (|a#$Address| dd@@0)))))) (=> (=> (not $abort_flag@8@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory@1) $EmptyTypeValueArray (|a#$Address| dd@@0))))) (=> (= (ControlFlow 0 183740) (- 0 250197)) (=> (not $abort_flag@8@@1) (|b#$Boolean| (ite (|b#$Boolean| add_all_currencies) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@4@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@4@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$L5_correct  (=> (and (= $DesignatedDealer_TierInfo_$memory@4@@0 $DesignatedDealer_TierInfo_$memory@2@@0) (= $Diem_Preburn_$memory@4 $Diem_Preburn_$memory@2@@0)) (=> (and (and (= $DesignatedDealer_Dealer_$memory@1 |inline$$MoveToRaw$0$m'@2@@0|) (= $abort_flag@8@@1 $abort_flag@7@@1)) (and (= $abort_code@11@@1 $abort_code@9@@1) (= (ControlFlow 0 183538) 183740))) anon0$2_correct@@3))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon63_Else_correct  (=> (and (not $abort_flag@5@@1) (= $abort_code@9@@1 $abort_code@7@@1)) (=> (and (and (= $abort_flag@7@@1 $abort_flag@5@@1) (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory@0@@0)) (and (= $DesignatedDealer_TierInfo_$memory@2@@0 $DesignatedDealer_TierInfo_$memory@0@@1) (= (ControlFlow 0 183570) 183538))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$L5_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon65_Else_correct  (=> (and (not $abort_flag@6@@1) (= $abort_code@9@@1 $abort_code@8@@1)) (=> (and (and (= $abort_flag@7@@1 $abort_flag@6@@1) (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory@1@@0)) (and (= $DesignatedDealer_TierInfo_$memory@2@@0 $DesignatedDealer_TierInfo_$memory@1@@0) (= (ControlFlow 0 183536) 183538))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$L5_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct  (=> (and (= $DesignatedDealer_TierInfo_$memory@4@@0 $DesignatedDealer_TierInfo_$memory@3@@0) (= $Diem_Preburn_$memory@4 $Diem_Preburn_$memory@3@@0)) (=> (and (and (= $DesignatedDealer_Dealer_$memory@1 $DesignatedDealer_Dealer_$memory@0) (= $abort_flag@8@@1 true)) (and (= $abort_code@11@@1 $abort_code@10@@1) (= (ControlFlow 0 182925) 183740))) anon0$2_correct@@3))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon9_correct  (=> (= $abort_code@10@@1 $abort_code@1@@2) (=> (and (and (= $DesignatedDealer_Dealer_$memory@0 $DesignatedDealer_Dealer_$memory) (= $Diem_Preburn_$memory@3@@0 $Diem_Preburn_$memory)) (and (= $DesignatedDealer_TierInfo_$memory@3@@0 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 183702) 182925))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 183700) 183702)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon9_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 183710) 183702) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon9_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon48_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 183694) 183710) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 183694) 183700) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon13_correct  (=> (= $abort_code@10@@1 $abort_code@2@@2) (=> (and (and (= $DesignatedDealer_Dealer_$memory@0 $DesignatedDealer_Dealer_$memory) (= $Diem_Preburn_$memory@3@@0 $Diem_Preburn_$memory)) (and (= $DesignatedDealer_TierInfo_$memory@3@@0 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 183682) 182925))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 183680) 183682)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon13_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 183690) 183682) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon13_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon50_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 183674) 183690) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 183674) 183680) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon17_correct  (=> (= $abort_code@10@@1 $abort_code@3@@2) (=> (and (and (= $DesignatedDealer_Dealer_$memory@0 $DesignatedDealer_Dealer_$memory) (= $Diem_Preburn_$memory@3@@0 $Diem_Preburn_$memory)) (and (= $DesignatedDealer_TierInfo_$memory@3@@0 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 183662) 182925))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 183660) 183662)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon17_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 183670) 183662) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon17_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon52_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 183654) 183670) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 183654) 183660) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon21_correct  (=> (= $abort_code@10@@1 $abort_code@4@@2) (=> (and (and (= $DesignatedDealer_Dealer_$memory@0 $DesignatedDealer_Dealer_$memory) (= $Diem_Preburn_$memory@3@@0 $Diem_Preburn_$memory)) (and (= $DesignatedDealer_TierInfo_$memory@3@@0 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 183642) 182925))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 183640) 183642)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon21_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 183650) 183642) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon21_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon54_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 183634) 183650) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 183634) 183640) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon29_correct  (=> (= $abort_code@10@@1 $abort_code@4@@2) (=> (and (and (= $DesignatedDealer_Dealer_$memory@0 $DesignatedDealer_Dealer_$memory) (= $Diem_Preburn_$memory@3@@0 $Diem_Preburn_$memory)) (and (= $DesignatedDealer_TierInfo_$memory@3@@0 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 183622) 182925))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 183620) 183622)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon29_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 183630) 183622) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon29_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon58_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 183614) 183630) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 183614) 183620) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon33_correct  (=> (= $abort_code@10@@1 $abort_code@6@@1) (=> (and (and (= $DesignatedDealer_Dealer_$memory@0 |inline$$MoveToRaw$0$m'@2@@0|) (= $Diem_Preburn_$memory@3@@0 $Diem_Preburn_$memory)) (and (= $DesignatedDealer_TierInfo_$memory@3@@0 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 183602) 182925))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 183600) 183602)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon33_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon61_Then_correct  (=> (= (ControlFlow 0 183610) 183602) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon33_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon60_Then_correct  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 183594) 183610) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 183594) 183600) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon39_correct  (=> (= $abort_code@10@@1 $abort_code@7@@1) (=> (and (and (= $DesignatedDealer_Dealer_$memory@0 |inline$$MoveToRaw$0$m'@2@@0|) (= $Diem_Preburn_$memory@3@@0 $Diem_Preburn_$memory@0@@0)) (and (= $DesignatedDealer_TierInfo_$memory@3@@0 $DesignatedDealer_TierInfo_$memory@0@@1) (= (ControlFlow 0 183582) 182925))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 183580) 183582)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon39_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 183590) 183582) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon39_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon63_Then_correct  (=> $abort_flag@5@@1 (and (=> (= (ControlFlow 0 183574) 183590) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 183574) 183580) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon62_Then_correct  (=> (|b#$Boolean| add_all_currencies) (=> (and (= call0formal@$tv0@0 $XUS_XUS_type_value) (= call3formal@$Diem_Preburn_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 183564) (- 0 245929)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$Diem_Preburn_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$Diem_Preburn_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)) (and (=> (= (ControlFlow 0 183564) (- 0 245951)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@5@@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@5@@1)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@5@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) $abort_flag@5@@1))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@5@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) $abort_flag@5@@1)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))) $abort_flag@5@@1) (=> (|b#$Boolean| (let ((addr@@8 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@8)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@8)))) $Diem_CurrencyInfo_is_synthetic)))))) $abort_flag@5@@1))) (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))) $abort_flag@5@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@1)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@1) (=> $abort_flag@5@@1 (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0))))) (|b#$Boolean| (let ((addr@@9 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@9)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@9)))) $Diem_CurrencyInfo_is_synthetic))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (and (and (=> $abort_flag@5@@1 (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| (let ((addr@@10 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@10)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@10)))) $Diem_CurrencyInfo_is_synthetic)))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))))) (and (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)) ($Vector (let ((len@@19 (|l#$ValueArray| (let ((len@@20 (|l#$ValueArray| (let ((len@@21 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@21 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@21 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@21 1)))) len@@20 ($Integer 0)) (+ len@@20 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@20 (|l#$ValueArray| (let ((len@@21 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@21 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@21 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@21 1)))) len@@20 ($Integer 0)) (+ len@@20 1)))) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))) $DesignatedDealer_TierInfo_tiers)) (+ len@@19 1)))))))) (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4))))))) (and (and (= (|contents#$Memory| $Diem_Preburn_$memory@0@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))) (= (|domain#$Memory| $Diem_Preburn_$memory@0@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0))))) (and (= (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0@@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))) (= (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0@@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dd@@0)))))))) (and (=> (= (ControlFlow 0 183564) 183574) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 183564) 183570) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon63_Else_correct))))))))))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon43_correct  (=> (= $abort_code@10@@1 $abort_code@8@@1) (=> (and (and (= $DesignatedDealer_Dealer_$memory@0 |inline$$MoveToRaw$0$m'@2@@0|) (= $Diem_Preburn_$memory@3@@0 $Diem_Preburn_$memory@1@@0)) (and (= $DesignatedDealer_TierInfo_$memory@3@@0 $DesignatedDealer_TierInfo_$memory@1@@0) (= (ControlFlow 0 183550) 182925))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 183548) 183550)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon43_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 183558) 183550) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon43_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon65_Then_correct  (=> $abort_flag@6@@1 (and (=> (= (ControlFlow 0 183542) 183558) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 183542) 183548) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon62_Else_correct  (=> (and (not (|b#$Boolean| add_all_currencies)) (= call3formal@$Diem_Preburn_$CallerDomain@0@@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 183530) (- 0 247141)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$Diem_Preburn_$CallerDomain@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$Diem_Preburn_$CallerDomain@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)) (and (=> (= (ControlFlow 0 183530) (- 0 247163)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@6@@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@6@@1)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@6@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) $abort_flag@6@@1))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@6@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) $abort_flag@6@@1)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))) $abort_flag@6@@1) (=> (|b#$Boolean| (let ((addr@@11 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@11)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@11)))) $Diem_CurrencyInfo_is_synthetic)))))) $abort_flag@6@@1))) (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))) $abort_flag@6@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@1)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@1) (=> $abort_flag@6@@1 (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| dd@@0)))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))) (|b#$Boolean| (let ((addr@@12 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@12)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@12)))) $Diem_CurrencyInfo_is_synthetic))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (and (and (=> $abort_flag@6@@1 (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| (let ((addr@@13 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@13)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@13)))) $Diem_CurrencyInfo_is_synthetic)))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))))) (and (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)) ($Vector (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))) $DesignatedDealer_TierInfo_tiers)) (+ len@@22 1)))))))) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))) $DesignatedDealer_TierInfo_tiers)))) ($Integer 4))))))) (and (and (= (|contents#$Memory| $Diem_Preburn_$memory@1@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))) (= (|domain#$Memory| $Diem_Preburn_$memory@1@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))))) (and (= (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))) (= (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0)))))))) (and (=> (= (ControlFlow 0 183530) 183542) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 183530) 183536) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon65_Else_correct)))))))))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon60_Else_correct  (=> (not $abort_flag@4@@1) (and (=> (= (ControlFlow 0 183522) (- 0 245865)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$addr)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$addr@@0))))))))))) (and (=> (= (ControlFlow 0 183522) 183564) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 183522) 183530) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon62_Else_correct)))))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@4@@1 true) (=> (and (= $abort_code@6@@1 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 183461) 183594) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 183461) 183522) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon60_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 183459) 183461)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 inline$$DesignatedDealer_Dealer_pack$0$$struct@1))) (= $abort_flag@4@@1 $abort_flag@3@@2)) (and (= $abort_code@6@@1 $abort_code@4@@2) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 183409) 183594) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 183409) 183522) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon60_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| dd@@0)) (and (=> (= (ControlFlow 0 183467) 183459) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 183467) 183409) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 183255) (- 0 245750)) true) (=> (= (ControlFlow 0 183255) 183467) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon58_Else$1_correct  (and (=> (= (ControlFlow 0 183475) (- 0 245715)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_Dealer_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| dd@@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_Dealer_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| dd@@0)) (=> (= (ControlFlow 0 183475) 183255) inline$$Signer_borrow_address$0$Entry_correct@@0)))))
(let ((inline$$DesignatedDealer_Dealer_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 183127) 183475)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon58_Else$1_correct)))
(let ((inline$$DesignatedDealer_Dealer_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 183133) 183475) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon58_Else$1_correct)))
(let ((inline$$DesignatedDealer_Dealer_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 183121) 183133) inline$$DesignatedDealer_Dealer_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 183121) 183127) inline$$DesignatedDealer_Dealer_pack$0$anon4_Else_correct)))))
(let ((inline$$DesignatedDealer_Dealer_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 183113) 183475)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon58_Else$1_correct)))
(let ((inline$$DesignatedDealer_Dealer_pack$0$anon0_correct  (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@43 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@11))
))) true) (= inline$$DesignatedDealer_Dealer_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Event_new_event_handle$0$res@0) 1)))) (and (=> (= (ControlFlow 0 183105) 183121) inline$$DesignatedDealer_Dealer_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 183105) 183113) inline$$DesignatedDealer_Dealer_pack$0$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon58_Else_correct  (=> (and (not $abort_flag@3@@2) (= (ControlFlow 0 183139) 183105)) inline$$DesignatedDealer_Dealer_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $DesignatedDealer_ReceivedMintEvent_type_value) (and (=> (= (ControlFlow 0 182965) 183614) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 182965) 183139) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon56_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@0) (= (ControlFlow 0 182973) 182965)) inline$$Event_new_event_handle$0$Entry_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon26_correct  (=> (= $abort_code@10@@1 $abort_code@5@@2) (=> (and (and (= $DesignatedDealer_Dealer_$memory@0 $DesignatedDealer_Dealer_$memory) (= $Diem_Preburn_$memory@3@@0 $Diem_Preburn_$memory)) (and (= $DesignatedDealer_TierInfo_$memory@3@@0 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 182921) 182925))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 182919) 182921)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon26_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 182933) 182921) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon26_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon56_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (= $abort_code@5@@2 (|i#$Integer| call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 182913) 182933) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 182913) 182919) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon54_Else_correct  (=> (not $abort_flag@3@@2) (and (=> (= (ControlFlow 0 182901) 182973) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 182901) 182913) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon52_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2)) (and (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 182895) 183634) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 182895) 182901) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@0  (=> (and (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$t9@1)))) (= (ControlFlow 0 182883) 182895)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon52_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 182873) (- 0 245518)) true) (=> (= (ControlFlow 0 182873) 182883) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@2@@2) (=> (and (= inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@10)))) (= (ControlFlow 0 182889) 182873)) inline$$Not$0$Entry_correct@@0))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon50_Else_correct  (=> (not $abort_flag@1@@2) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@2) (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 dd@@0)))) ((_ is $Address) call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 182827) 183654) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 182827) 182889) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon52_Else_correct))))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon48_Else_correct  (=> (not $abort_flag@0@@2) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) $abort_flag@1@@2) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@1@@2)) (and (=> $abort_flag@1@@2 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))))) (=> $abort_flag@1@@2 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0))))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 182821) 183674) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 182821) 182827) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon50_Else_correct))))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@0@@2) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@2) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@0@@2)) (and (=> $abort_flag@0@@2 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))))) (=> $abort_flag@0@@2 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 182815) 183694) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 182815) 182821) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon48_Else_correct))))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon6_correct  (=> (= inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_Dealer_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| dd@@0) true)) (=> (and (= inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0) true) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0) true)) (= (ControlFlow 0 182745) 182815)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon6$3_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 182637) 182745)) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon6_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 183718) 182745) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon6_correct)))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon46_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 182629) 183718) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 182629) 182637) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon46_Then_correct  (and (=> (= (ControlFlow 0 183726) 183718) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 183726) 182637) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon47_Else_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 182621) 183726) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 182621) 182629) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 183734) 183726) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 183734) 182629) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon46_Else_correct))))
(let ((inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 182615) 183734) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 182615) 182621) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon45_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (and (and (and (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@45 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))
)) (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@46 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))
))) (and (forall (($inv_addr@@12 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12)) (let ((va@@47 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code)) (let ((va@@49 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))) $$0@@12))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events)) (let ((va@@50 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@13))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@53 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@14))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@54 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@55 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@15))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@56 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@57 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@16))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
))))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@17))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))
)) (forall (($inv_addr@@13 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13)) (let ((va@@60 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13))))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13))) $Diem_Preburn_to_burn)) (let ((va@@61 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@13))
)))) (and (and (forall (($inv_addr@@14 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14)) (let ((va@@62 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) 1)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle)) (let ((va@@63 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid)) (let ((va@@64 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
))))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@18))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@14))
)) (forall (($inv_addr@@15 Int) ($inv_tv0@@6 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15)) (let ((va@@65 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers)) (let ((va@@66 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
))))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers))) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers))) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers))) $$0@@19)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers))) $$0@@19))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@3)) $i_0@@3) (< $i_0@@3 (|i#$Integer| (|ub#$Range| $range_1@@3)))) (let ((i@@14 ($Integer $i_0@@3)))
(|b#$Boolean| ($Boolean (let (($range_3@@3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@3)) $i_2@@3) (< $i_2@@3 (|i#$Integer| (|ub#$Range| $range_3@@3)))) (let ((j@@5 ($Integer $i_2@@3)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@14) (|i#$Integer| j@@5)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@14))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@5))))))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@6 T@$Value) )  (=> ((_ is $Type) coin_type@@6) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@1 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| mint_cap_owner@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@7 T@$Value) )  (=> ((_ is $Type) coin_type@@7) (|b#$Boolean| ($Boolean (forall ((addr3@@0 T@$Value) )  (=> ((_ is $Address) addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@8 T@$Value) )  (=> ((_ is $Type) coin_type@@8) (|b#$Boolean| ($Boolean (forall ((addr1@@3 T@$Value) )  (=> ((_ is $Address) addr1@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@9 T@$Value) )  (=> ((_ is $Type) coin_type@@9) (|b#$Boolean| ($Boolean (forall ((addr1@@4 T@$Value) )  (=> ((_ is $Address) addr1@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@9)) 1) (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 183738) 182615))))) inline$$DesignatedDealer_publish_designated_dealer_credential_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and ((_ is $Address) dd@@0) ((_ is $Address) tc_account@@1)) (and ((_ is $Boolean) add_all_currencies) (= (ControlFlow 0 181184) 183738))) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| $DesignatedDealer_Dealer_$CallerDomain $EmptyTypeValueArray (|a#$Address| dd@@0)) (|Select_[$TypeValueArray,$int]$bool| $DesignatedDealer_TierInfo_$CallerDomain@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| dd@@0))) (and (|Select_[$TypeValueArray,$int]$bool| $DesignatedDealer_TierInfo_$CallerDomain@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dd@@0)) (= (ControlFlow 0 239135) 181184))) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun amount () T@$Value)
(declare-fun $abort_flag@21@@0 () Bool)
(declare-fun tier_index () T@$Value)
(declare-fun $tv0@@13 () T@$TypeValue)
(declare-fun dd_addr@@1 () T@$Value)
(declare-fun tc_account@@2 () T@$Value)
(declare-fun $abort_code@32@@0 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@4 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@3@@1 () T@$Memory)
(declare-fun inline$$DesignatedDealer_tiered_mint_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_mint_$def$0$$ret0@2 () T@$Value)
(declare-fun $DesignatedDealer_TierInfo_$memory@1@@1 () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory@1@@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$4$m'@2| () T@$Memory)
(declare-fun $abort_code@30@@0 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@2 () T@$Memory)
(declare-fun $abort_flag@20@@0 () Bool)
(declare-fun inline$$DesignatedDealer_tiered_mint_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $DesignatedDealer_TierInfo_$memory@2@@1 () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@31@@0 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@3 () T@$Memory)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun $abort_code@22@@0 () Int)
(declare-fun $abort_flag@14@@0 () Bool)
(declare-fun $abort_code@23@@0 () Int)
(declare-fun $abort_flag@15@@0 () Bool)
(declare-fun $abort_code@28@@0 () Int)
(declare-fun call7formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@19@@0 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0 () T@$Memory)
(declare-fun inline$$Diem_mint_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@29@@0 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1 () T@$Memory)
(declare-fun $abort_code@24@@0 () Int)
(declare-fun $abort_flag@16@@0 () Bool)
(declare-fun $abort_code@25@@0 () Int)
(declare-fun $abort_flag@17@@0 () Bool)
(declare-fun $abort_code@27@@0 () Int)
(declare-fun $abort_flag@18@@0 () Bool)
(declare-fun inline$$Diem_mint_$def$0$$Diem_CurrencyInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$GetGlobal$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$Diem_mint_$def$0$$t7@1 () T@$Value)
(declare-fun $abort_code@26@@0 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$Diem_mint_$def$0$$t8@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_tiered_mint_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$WritebackToGlobal$4$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$4$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$4$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$4$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$4$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$Event_emit_event$0$t@0 () T@$TypeValue)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$DesignatedDealer_ReceivedMintEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun $abort_code@21@@0 () Int)
(declare-fun $abort_flag@13@@0 () Bool)
(declare-fun |inline$$WritebackToGlobal$3$m'@2| () T@$Memory)
(declare-fun $abort_flag@12@@0 () Bool)
(declare-fun $abort_code@19@@0 () Int)
(declare-fun inline$$WritebackToGlobal$3$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$3$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$3$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$3$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$3$m'@1| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@0 () Int)
(declare-fun inline$$BorrowField$2$p@2@@0 () T@$Path)
(declare-fun $abort_code@20@@0 () Int)
(declare-fun $DesignatedDealer_TierInfo_$memory@0@@2 () T@$Memory)
(declare-fun $abort_code@9@@2 () Int)
(declare-fun $abort_flag@5@@2 () Bool)
(declare-fun $abort_code@10@@2 () Int)
(declare-fun $abort_flag@6@@2 () Bool)
(declare-fun $abort_code@11@@2 () Int)
(declare-fun $abort_flag@7@@2 () Bool)
(declare-fun $abort_code@13@@1 () Int)
(declare-fun $abort_flag@8@@2 () Bool)
(declare-fun $abort_code@14@@1 () Int)
(declare-fun $abort_flag@9@@1 () Bool)
(declare-fun $abort_code@16@@0 () Int)
(declare-fun $abort_flag@10@@0 () Bool)
(declare-fun $abort_code@17@@0 () Int)
(declare-fun $abort_flag@11@@0 () Bool)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Le$1$dst@1 () T@$Value)
(declare-fun $abort_code@18@@0 () Int)
(declare-fun |inline$$WritebackToGlobal$2$m'@2| () T@$Memory)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$WritebackToGlobal$2$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@1| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def$0$$t28@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@2@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Le$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@15@@0 () Int)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def$0$$t24@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@0@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1@@0 () Int)
(declare-fun inline$$ReadRef$2$v@1@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0@@0 () T@$TypeValue)
(declare-fun inline$$Lt$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@12@@1 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def$0$$t20@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@0 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0@@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def$0$$DesignatedDealer_TierInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DesignatedDealer_tiered_mint_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t21@1 () T@$Value)
(declare-fun $abort_code@8@@2 () Int)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t22@1 () T@$Value)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(declare-fun inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$Gt$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun call3formal@$ret0@0@@20 () T@$Value)
(declare-fun inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t14@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DesignatedDealer_TierInfo_$CallerDomain@@2 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 250267) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 195541) (- 0 261616)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified amount ($Integer 0)))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified amount ($Integer 0)))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261631)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers)))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers)))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261659)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)) (|i#$Integer| ($Integer 86400000000)))))))) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| amount))) amount)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| tier_index)))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)) (|i#$Integer| ($Integer 86400000000)))))))) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| amount))) amount)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| tier_index)))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261698)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261731)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261752)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261781)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261798)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd_addr@@1))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd_addr@@1))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261816)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261846)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261861)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261881)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261917)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 195541) (- 0 261933)) (=> $abort_flag@21@@0 (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified amount ($Integer 0)))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)) (|i#$Integer| ($Integer 86400000000)))))))) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| amount))) amount)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| tier_index))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd_addr@@1)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U128)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@21@@0 (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified amount ($Integer 0)))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)) (|i#$Integer| ($Integer 86400000000)))))))) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| amount))) amount)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| tier_index))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd_addr@@1)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U128)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 195541) (- 0 262238)) (=> $abort_flag@21@@0 (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified amount ($Integer 0)))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers)))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)) (|i#$Integer| ($Integer 86400000000)))))))) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| amount))) amount)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| tier_index)))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| tc_account@@2))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd_addr@@1))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U128))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@21@@0 (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified amount ($Integer 0)))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers)))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)) (|i#$Integer| ($Integer 86400000000)))))))) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| amount))) amount)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| tier_index)))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| tc_account@@2))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd_addr@@1))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U128))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@32@@0 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 195541) (- 0 262686)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 195541) (- 0 262712)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1))))) (and (=> (= (ControlFlow 0 195541) (- 0 262738)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers)))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))))) (and (=> (= (ControlFlow 0 195541) (- 0 262795)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)))))) (and (=> (= (ControlFlow 0 195541) (- 0 262832)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow) amount)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| amount)))))))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow) amount)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_start)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| amount))))))))))))) (and (=> (= (ControlFlow 0 195541) (- 0 262963)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (< (|i#$Integer| tier_index) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers)))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (< (|i#$Integer| tier_index) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))))))))) (and (=> (= (ControlFlow 0 195541) (- 0 262993)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| tier_index)))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@3@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| tier_index))))))) (and (=> (= (ControlFlow 0 195541) (- 0 263034)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_tiered_mint_$def_verify$0$$ret0@2)) $Diem_Diem_value) amount))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_tiered_mint_$def_verify$0$$ret0@2)) $Diem_Diem_value) amount)))) (=> (= (ControlFlow 0 195541) (- 0 263052)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon58_correct  (=> (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$ret0@2 inline$$Diem_mint_$def$0$$ret0@2) (=> (and (= $DesignatedDealer_TierInfo_$memory@3@@1 $DesignatedDealer_TierInfo_$memory@1@@1) (= $DesignatedDealer_Dealer_$memory@1@@0 |inline$$WritebackToGlobal$4$m'@2|)) (=> (and (and (= $abort_code@32@@0 $abort_code@30@@0) (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@2)) (and (= $abort_flag@21@@0 $abort_flag@20@@0) (= (ControlFlow 0 195325) 195541))) anon0$2_correct@@4)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 195323) 195325)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon58_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon87_Then_correct  (=> (= (ControlFlow 0 195333) 195325) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon58_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon86_Else_correct  (=> (not $abort_flag@20@@0) (and (=> (= (ControlFlow 0 195317) 195333) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 195317) 195323) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct  (=> (and (and (and (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$ret0@1 $Error) (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$ret0@2 inline$$DesignatedDealer_tiered_mint_$def_verify$0$$ret0@1)) (and (= $DesignatedDealer_TierInfo_$memory@3@@1 $DesignatedDealer_TierInfo_$memory@2@@1) (= $DesignatedDealer_Dealer_$memory@1@@0 $DesignatedDealer_Dealer_$memory@0@@0))) (and (and (= $abort_code@32@@0 $abort_code@31@@0) (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@3)) (and (= $abort_flag@21@@0 true) (= (ControlFlow 0 186100) 195541)))) anon0$2_correct@@4)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon11_correct  (=> (= $abort_code@31@@0 $abort_code@1@@3) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195493) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 195491) 195493)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon11_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 195501) 195493) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon11_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon63_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 195485) 195501) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 195485) 195491) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon15_correct  (=> (= $abort_code@31@@0 $abort_code@2@@3) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195473) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 195471) 195473)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon15_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 195481) 195473) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon15_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon65_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 195465) 195481) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 195465) 195471) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon23_correct  (=> (= $abort_code@31@@0 $abort_code@3@@3) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195453) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 195451) 195453)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon23_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 195461) 195453) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon23_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon69_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 195445) 195461) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 195445) 195451) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon27_correct  (=> (= $abort_code@31@@0 $abort_code@5@@3) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195433) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 195431) 195433)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon27_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 195441) 195433) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon27_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon71_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 195425) 195441) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 195425) 195431) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon35_correct  (=> (= $abort_code@31@@0 $abort_code@6@@2) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195413) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 195411) 195413)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon35_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 195421) 195413) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon35_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon75_Then_correct  (=> $abort_flag@4@@2 (and (=> (= (ControlFlow 0 195405) 195421) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 195405) 195411) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon45_correct  (=> (= $abort_code@31@@0 $abort_code@22@@0) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory@1@@1) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195389) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 195387) 195389)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon45_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon81_Then_correct  (=> (= (ControlFlow 0 195397) 195389) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon45_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon80_Then_correct  (=> $abort_flag@14@@0 (and (=> (= (ControlFlow 0 195381) 195397) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 195381) 195387) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon49_correct  (=> (= $abort_code@31@@0 $abort_code@23@@0) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory@1@@1) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195369) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 195367) 195369)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon49_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon83_Then_correct  (=> (= (ControlFlow 0 195377) 195369) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon49_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon82_Then_correct  (=> $abort_flag@15@@0 (and (=> (= (ControlFlow 0 195361) 195377) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 195361) 195367) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon53_correct  (=> (= $abort_code@31@@0 $abort_code@23@@0) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory@1@@1) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195349) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 195347) 195349)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon53_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon85_Then_correct  (=> (= (ControlFlow 0 195357) 195349) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon53_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon84_Then_correct  (=> $abort_flag@15@@0 (and (=> (= (ControlFlow 0 195341) 195357) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 195341) 195347) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon86_Then_correct  (=> (and $abort_flag@20@@0 (= $abort_code@31@@0 $abort_code@30@@0)) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory@1@@1) (= $DesignatedDealer_Dealer_$memory@0@@0 |inline$$WritebackToGlobal$4$m'@2|)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@2) (= (ControlFlow 0 195337) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_mint_$def$0$anon26_correct  (=> (and (and (= $abort_code@30@@0 $abort_code@28@@0) (= inline$$Diem_mint_$def$0$$ret0@2 call7formal@$ret0@0)) (and (= $abort_flag@20@@0 $abort_flag@19@@0) (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@0))) (and (=> (= (ControlFlow 0 195189) 195337) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 195189) 195317) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 195187) 195189)) inline$$Diem_mint_$def$0$anon26_correct)))
(let ((inline$$Diem_mint_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 195197) 195189) inline$$Diem_mint_$def$0$anon26_correct)))
(let ((inline$$Diem_mint_$def$0$anon37_Else_correct  (=> (not $abort_flag@19@@0) (and (=> (= (ControlFlow 0 195181) 195197) inline$$Diem_mint_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 195181) 195187) inline$$Diem_mint_$def$0$anon39_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$Abort_correct  (=> (= inline$$Diem_mint_$def$0$$ret0@1 $Error) (=> (and (and (= $abort_code@30@@0 $abort_code@29@@0) (= inline$$Diem_mint_$def$0$$ret0@2 inline$$Diem_mint_$def$0$$ret0@1)) (and (= $abort_flag@20@@0 true) (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1))) (and (=> (= (ControlFlow 0 194966) 195337) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 194966) 195317) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon86_Else_correct))))))
(let ((inline$$Diem_mint_$def$0$anon7_correct  (=> (= $abort_code@29@@0 $abort_code@24@@0) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195269) 194966)) inline$$Diem_mint_$def$0$Abort_correct))))
(let ((inline$$Diem_mint_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 195267) 195269)) inline$$Diem_mint_$def$0$anon7_correct)))
(let ((inline$$Diem_mint_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 195277) 195269) inline$$Diem_mint_$def$0$anon7_correct)))
(let ((inline$$Diem_mint_$def$0$anon29_Then_correct  (=> $abort_flag@16@@0 (and (=> (= (ControlFlow 0 195261) 195277) inline$$Diem_mint_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 195261) 195267) inline$$Diem_mint_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$anon11_correct  (=> (= $abort_code@29@@0 $abort_code@25@@0) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195249) 194966)) inline$$Diem_mint_$def$0$Abort_correct))))
(let ((inline$$Diem_mint_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 195247) 195249)) inline$$Diem_mint_$def$0$anon11_correct)))
(let ((inline$$Diem_mint_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 195257) 195249) inline$$Diem_mint_$def$0$anon11_correct)))
(let ((inline$$Diem_mint_$def$0$anon31_Then_correct  (=> $abort_flag@17@@0 (and (=> (= (ControlFlow 0 195241) 195257) inline$$Diem_mint_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 195241) 195247) inline$$Diem_mint_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$anon19_correct  (=> (= $abort_code@29@@0 $abort_code@27@@0) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195229) 194966)) inline$$Diem_mint_$def$0$Abort_correct))))
(let ((inline$$Diem_mint_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 195227) 195229)) inline$$Diem_mint_$def$0$anon19_correct)))
(let ((inline$$Diem_mint_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 195237) 195229) inline$$Diem_mint_$def$0$anon19_correct)))
(let ((inline$$Diem_mint_$def$0$anon35_Then_correct  (=> $abort_flag@18@@0 (and (=> (= (ControlFlow 0 195221) 195237) inline$$Diem_mint_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 195221) 195227) inline$$Diem_mint_$def$0$anon36_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$anon23_correct  (=> (= $abort_code@29@@0 $abort_code@28@@0) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory@0) (= (ControlFlow 0 195209) 194966)) inline$$Diem_mint_$def$0$Abort_correct))))
(let ((inline$$Diem_mint_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 195207) 195209)) inline$$Diem_mint_$def$0$anon23_correct)))
(let ((inline$$Diem_mint_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 195217) 195209) inline$$Diem_mint_$def$0$anon23_correct)))
(let ((inline$$Diem_mint_$def$0$anon37_Then_correct  (=> $abort_flag@19@@0 (and (=> (= (ControlFlow 0 195201) 195217) inline$$Diem_mint_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 195201) 195207) inline$$Diem_mint_$def$0$anon38_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$anon35_Else_correct  (=> (not $abort_flag@18@@0) (and (=> (= (ControlFlow 0 195173) (- 0 260610)) (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_mint_$def$0$$Diem_CurrencyInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_mint_$def$0$$Diem_CurrencyInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) $abort_flag@19@@0) (=> (and (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@19@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@19@@0)) (and (=> $abort_flag@19@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U128)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))) (=> $abort_flag@19@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (= $abort_code@28@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer $MAX_U128))))) (= $abort_code@28@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@28@@0 (|i#$Integer| ($Integer 5)))))))) (and (and (=> (not $abort_flag@19@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))) (=> (not $abort_flag@19@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@19@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| amount)))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (not $abort_flag@19@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $Diem_Diem_value) amount))))))) (=> (and (and (and (and (and ((_ is $Vector) call7formal@$ret0@0) (let ((va@@67 (|v#$Vector| call7formal@$ret0@0)))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
)))))) (= (|l#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (= (|contents#$Memory| $Diem_CurrencyInfo_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $Diem_CurrencyInfo_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (= (ControlFlow 0 195173) 195201) inline$$Diem_mint_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 195173) 195181) inline$$Diem_mint_$def$0$anon37_Else_correct))))))))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@18@@0 true) (= $abort_code@27@@0 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 195159) 195221) inline$$Diem_mint_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 195159) 195173) inline$$Diem_mint_$def$0$anon35_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$GetGlobal$0$ta@0@@0 inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 195157) 195159)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$GetGlobal$0$ta@0@@0 inline$$GetGlobal$0$a@1@@0) (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) inline$$GetGlobal$0$ta@0@@0 (|a#$Address| call3formal@$ret0@0@@11)))) (and (= $abort_flag@18@@0 $abort_flag@17@@0) (= $abort_code@27@@0 $abort_code@25@@0))) (and (=> (= (ControlFlow 0 195105) 195221) inline$$Diem_mint_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 195105) 195173) inline$$Diem_mint_$def$0$anon35_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| call3formal@$ret0@0@@11)) (and (=> (= (ControlFlow 0 195087) 195157) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 195087) 195105) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (=> (= inline$$GetGlobal$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (and (=> (= (ControlFlow 0 195081) (- 0 260523)) true) (=> (= (ControlFlow 0 195081) 195087) inline$$GetGlobal$0$anon0_correct@@0)))))
(let ((inline$$Diem_mint_$def$0$anon33_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_mint_$def$0$$t7@1) (= (ControlFlow 0 195165) 195081)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$Diem_mint_$def$0$anon16_correct  (=> (= $abort_code@29@@0 $abort_code@26@@0) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 194960) 194966)) inline$$Diem_mint_$def$0$Abort_correct))))
(let ((inline$$Diem_mint_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 194958) 194960)) inline$$Diem_mint_$def$0$anon16_correct)))
(let ((inline$$Diem_mint_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 194974) 194960) inline$$Diem_mint_$def$0$anon16_correct)))
(let ((inline$$Diem_mint_$def$0$anon33_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_mint_$def$0$$t7@1)) (= $abort_code@26@@0 (|i#$Integer| call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 194952) 194974) inline$$Diem_mint_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 194952) 194958) inline$$Diem_mint_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$anon31_Else_correct  (=> (not $abort_flag@17@@0) (and (=> (= (ControlFlow 0 194940) 195165) inline$$Diem_mint_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 194940) 194952) inline$$Diem_mint_$def$0$anon33_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$anon29_Else_correct  (=> (and (not $abort_flag@16@@0) (= inline$$Diem_mint_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@11))))) (=> (and (and (and (= inline$$Diem_mint_$def$0$$t8@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@17@@0)) (and (=> $abort_flag@17@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@17@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 4))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 194934) 195241) inline$$Diem_mint_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 194934) 194940) inline$$Diem_mint_$def$0$anon31_Else_correct))))))
(let ((inline$$Diem_mint_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@16@@0) (=> $abort_flag@16@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 tc_account@@2)))) ((_ is $Address) call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 194904) 195261) inline$$Diem_mint_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 194904) 194934) inline$$Diem_mint_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$anon4_correct  (=> (and (= inline$$Diem_mint_$def$0$$Diem_CurrencyInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 194868) 194904)) inline$$Diem_mint_$def$0$anon4$2_correct)))
(let ((inline$$Diem_mint_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 194808) 194868)) inline$$Diem_mint_$def$0$anon4_correct)))
(let ((inline$$Diem_mint_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 195285) 194868) inline$$Diem_mint_$def$0$anon4_correct)))
(let ((inline$$Diem_mint_$def$0$anon27_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 194800) 195285) inline$$Diem_mint_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 194800) 194808) inline$$Diem_mint_$def$0$anon28_Else_correct)))))
(let ((inline$$Diem_mint_$def$0$anon27_Then_correct  (and (=> (= (ControlFlow 0 195293) 195285) inline$$Diem_mint_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 195293) 194808) inline$$Diem_mint_$def$0$anon28_Else_correct))))
(let ((inline$$Diem_mint_$def$0$anon0_correct  (=> (not $abort_flag@15@@0) (and (=> (= (ControlFlow 0 194794) 195293) inline$$Diem_mint_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 194794) 194800) inline$$Diem_mint_$def$0$anon27_Else_correct)))))
(let ((inline$$Diem_mint_$direct_inter$0$anon0_correct  (=> ((_ is $Address) tc_account@@2) (=> (and (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) (= (ControlFlow 0 195299) 194794)) inline$$Diem_mint_$def$0$anon0_correct))))
(let ((inline$$Diem_mint_$direct_inter$0$Entry_correct  (and (=> (= (ControlFlow 0 194281) (- 0 260161)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_tiered_mint_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_tiered_mint_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))) (=> (= (ControlFlow 0 194281) 195299) inline$$Diem_mint_$direct_inter$0$anon0_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon84_Else$3_correct  (and (=> (= (ControlFlow 0 195307) (- 0 260116)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_tiered_mint_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DesignatedDealer_tiered_mint_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$4$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DesignatedDealer_tiered_mint_$def_verify$0$addr)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_tiered_mint_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DesignatedDealer_tiered_mint_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$4$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DesignatedDealer_tiered_mint_$def_verify$0$addr@@0))))))))))) (=> (= (ControlFlow 0 195307) 194281) inline$$Diem_mint_$direct_inter$0$Entry_correct)))))
(let ((inline$$WritebackToGlobal$4$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$4$l@1)) (=> (and (= |inline$$WritebackToGlobal$4$m'@2| $DesignatedDealer_Dealer_$memory) (= (ControlFlow 0 194063) 195307)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon84_Else$3_correct))))
(let ((inline$$WritebackToGlobal$4$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$4$l@1) (=> (and (= inline$$WritebackToGlobal$4$ta@1 (|ts#$Global| inline$$WritebackToGlobal$4$l@1)) (= inline$$WritebackToGlobal$4$a@1 (|a#$Global| inline$$WritebackToGlobal$4$l@1))) (=> (and (and (= inline$$WritebackToGlobal$4$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (= |inline$$WritebackToGlobal$4$m'@1| ($Memory (|domain#$Memory| $DesignatedDealer_Dealer_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1 inline$$WritebackToGlobal$4$v@1)))) (and (= |inline$$WritebackToGlobal$4$m'@2| |inline$$WritebackToGlobal$4$m'@1|) (= (ControlFlow 0 194117) 195307))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon84_Else$3_correct)))))
(let ((inline$$WritebackToGlobal$4$anon0_correct  (=> (= inline$$WritebackToGlobal$4$l@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (and (=> (= (ControlFlow 0 194053) 194117) inline$$WritebackToGlobal$4$anon3_Then_correct) (=> (= (ControlFlow 0 194053) 194063) inline$$WritebackToGlobal$4$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@0| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 193873) 194053)) inline$$WritebackToGlobal$4$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|) (= (ControlFlow 0 193929) 194053))) inline$$WritebackToGlobal$4$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 193837) 193929) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 193837) 193873) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (and (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) inline$$ReadRef$3$v@1)) (= (ControlFlow 0 193694) 193837)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon84_Else_correct  (=> (and (not $abort_flag@15@@0) (= (ControlFlow 0 193700) 193694)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$Event_emit_event$0$Entry_correct  (=> (= inline$$Event_emit_event$0$t@0 $DesignatedDealer_ReceivedMintEvent_type_value) (and (=> (= (ControlFlow 0 193625) 195341) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 193625) 193700) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon82_Else$2_correct  (and (=> (= (ControlFlow 0 193635) (- 0 259835)) true) (=> (= (ControlFlow 0 193635) 193625) inline$$Event_emit_event$0$Entry_correct))))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$3$dst@1)) (= (ControlFlow 0 193577) 193635)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon82_Else$2_correct)))
(let ((inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 193533) 193577)) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 193539) 193577) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 193527) 193539) inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 193527) 193533) inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 193519) 193577)) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@13) (let ((va@@68 (|v#$Vector| call3formal@$ret0@0@@13)))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
)))))) (forall ((inline$$DesignatedDealer_ReceivedMintEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DesignatedDealer_ReceivedMintEvent_pack$0$$$0 0) (< inline$$DesignatedDealer_ReceivedMintEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)) inline$$DesignatedDealer_ReceivedMintEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)) inline$$DesignatedDealer_ReceivedMintEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)) inline$$DesignatedDealer_ReceivedMintEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)) inline$$DesignatedDealer_ReceivedMintEvent_pack$0$$$0))
))) ((_ is $Address) dd_addr@@1)) (and (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) (= inline$$DesignatedDealer_ReceivedMintEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 call3formal@$ret0@0@@13) 1 dd_addr@@1) 2 amount) 3))))) (and (=> (= (ControlFlow 0 193511) 193527) inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 193511) 193519) inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon82_Else_correct  (=> (and (not $abort_flag@15@@0) (= (ControlFlow 0 193545) 193511)) inline$$DesignatedDealer_ReceivedMintEvent_pack$0$anon0_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon80_Else$1_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@15@@0) (=> $abort_flag@15@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@15@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@23@@0 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@15@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@13) (let ((va@@69 (|v#$Vector| call3formal@$ret0@0@@13)))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
)))))) (forall (($$0@@20 Int) ) (!  (=> (and (>= $$0@@20 0) (< $$0@@20 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)) $$0@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)) $$0@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)) $$0@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@13)) $$0@@20))
)))) (and (=> (= (ControlFlow 0 193257) 195361) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 193257) 193545) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $DesignatedDealer_Dealer_mint_event_handle) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $DesignatedDealer_Dealer_mint_event_handle))) (= (ControlFlow 0 193249) 193257))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon80_Else$1_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon80_Else_correct  (=> (and (not $abort_flag@14@@0) (= (ControlFlow 0 193255) 193249)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (= $abort_code@22@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@14@@0 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 193119) 195381) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 193119) 193255) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon80_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 193117) 193119)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1))) (= $abort_code@22@@0 $abort_code@21@@0)) (and (= $abort_flag@14@@0 $abort_flag@13@@0) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 193065) 195381) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 193065) 193255) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon80_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| dd_addr@@1)) (and (=> (= (ControlFlow 0 193035) 193117) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 193035) 193065) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 193029) (- 0 259397)) true) (=> (= (ControlFlow 0 193029) 193035) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon79_Else_correct  (=> (and (not $abort_flag@13@@0) (= (ControlFlow 0 193125) 193029)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon79_Then_correct  (=> (and $abort_flag@13@@0 (= $abort_code@31@@0 $abort_code@21@@0)) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory@1@@1) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195401) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon64$3_correct  (and (=> (= (ControlFlow 0 192664) (- 0 259091)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@0))))))))))))))) (=> (= $abort_flag@13@@0 $abort_flag@12@@0) (=> (and (= $abort_code@21@@0 $abort_code@19@@0) (= $DesignatedDealer_TierInfo_$memory@1@@1 |inline$$WritebackToGlobal$3$m'@2|)) (and (=> (= (ControlFlow 0 192664) 195401) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 192664) 193125) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon79_Else_correct))))))))
(let ((inline$$WritebackToGlobal$3$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$3$l@1)) (=> (and (= |inline$$WritebackToGlobal$3$m'@2| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192522) 192664)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon64$3_correct))))
(let ((inline$$WritebackToGlobal$3$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$3$l@1) (=> (and (= inline$$WritebackToGlobal$3$ta@1 (|ts#$Global| inline$$WritebackToGlobal$3$l@1)) (= inline$$WritebackToGlobal$3$a@1 (|a#$Global| inline$$WritebackToGlobal$3$l@1))) (=> (and (and (= inline$$WritebackToGlobal$3$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (= |inline$$WritebackToGlobal$3$m'@1| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1 inline$$WritebackToGlobal$3$v@1)))) (and (= |inline$$WritebackToGlobal$3$m'@2| |inline$$WritebackToGlobal$3$m'@1|) (= (ControlFlow 0 192576) 192664))) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon64$3_correct)))))
(let ((inline$$WritebackToGlobal$3$anon0_correct  (=> (= inline$$WritebackToGlobal$3$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 192512) 192576) inline$$WritebackToGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 192512) 192522) inline$$WritebackToGlobal$3$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$anon0_correct  (and (=> (= (ControlFlow 0 192390) (- 0 258837)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 192390) (- 0 258858)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@0)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j))))))))))))))))))))) (=> (= (ControlFlow 0 192390) 192512) inline$$WritebackToGlobal$3$anon0_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$Entry_correct  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= (ControlFlow 0 192242) 192390)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WriteRef$0$to'@1@@1|) (= (ControlFlow 0 192005) 192242)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 192061) 192242))) inline$$DesignatedDealer_TierInfo_$pack_ref$3$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|))) (and (=> (= (ControlFlow 0 191969) 192061) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 191969) 192005) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon96_Else_correct  (=> (and (not true) (= (ControlFlow 0 191832) 191969)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon96_Then_correct  (=> (and (= inline$$DesignatedDealer_validate_and_record_mint_$def$0$$trace_temp@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= (ControlFlow 0 192674) 191969)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@0) (|p#$Mutation| inline$$BorrowField$2$dst@1@@0) inline$$AddU64$0$dst@2@@0)) (and (=> (= (ControlFlow 0 191818) 192674) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 191818) 191832) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon96_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct@@0  (=> (= inline$$BorrowField$2$p@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (=> (and (and (= inline$$BorrowField$2$size@1@@0 (|size#$Path| inline$$BorrowField$2$p@1@@0)) (= inline$$BorrowField$2$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@0) inline$$BorrowField$2$size@1@@0 $DesignatedDealer_TierInfo_window_inflow) (+ inline$$BorrowField$2$size@1@@0 1)))) (and (= inline$$BorrowField$2$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) inline$$BorrowField$2$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))) $DesignatedDealer_TierInfo_window_inflow))) (= (ControlFlow 0 191759) 191818))) inline$$WriteRef$1$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon94_Else_correct  (=> (and (not $abort_flag@12@@0) (= (ControlFlow 0 191765) 191759)) inline$$BorrowField$2$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct  (=> (= $abort_flag@13@@0 true) (=> (and (= $abort_code@21@@0 $abort_code@20@@0) (= $DesignatedDealer_TierInfo_$memory@1@@1 $DesignatedDealer_TierInfo_$memory@0@@2)) (and (=> (= (ControlFlow 0 189589) 195401) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 189589) 193125) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon79_Else_correct))))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon9_correct  (=> (= $abort_code@20@@0 $abort_code@9@@2) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192880) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 192878) 192880)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon9_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon69_Then_correct  (=> (= (ControlFlow 0 192888) 192880) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon9_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon68_Then_correct  (=> $abort_flag@5@@2 (and (=> (= (ControlFlow 0 192872) 192888) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 192872) 192878) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon69_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon13_correct  (=> (= $abort_code@20@@0 $abort_code@10@@2) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192860) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 192858) 192860)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon13_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon71_Then_correct  (=> (= (ControlFlow 0 192868) 192860) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon13_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon70_Then_correct  (=> $abort_flag@6@@2 (and (=> (= (ControlFlow 0 192852) 192868) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 192852) 192858) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon71_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon23_correct  (=> (= $abort_code@20@@0 $abort_code@10@@2) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192814) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 192812) 192814)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon23_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon76_Then_correct  (=> (= (ControlFlow 0 192822) 192814) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon23_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon75_Then_correct  (=> $abort_flag@6@@2 (and (=> (= (ControlFlow 0 192806) 192822) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 192806) 192812) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon76_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon27_correct  (=> (= $abort_code@20@@0 $abort_code@11@@2) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192794) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 192792) 192794)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon27_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon78_Then_correct  (=> (= (ControlFlow 0 192802) 192794) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon27_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon77_Then_correct  (=> $abort_flag@7@@2 (and (=> (= (ControlFlow 0 192786) 192802) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 192786) 192792) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon78_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon35_correct  (=> (= $abort_code@20@@0 $abort_code@13@@1) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192774) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 192772) 192774)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon35_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon82_Then_correct  (=> (= (ControlFlow 0 192782) 192774) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon35_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon81_Then_correct  (=> $abort_flag@8@@2 (and (=> (= (ControlFlow 0 192766) 192782) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 192766) 192772) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon82_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon41_correct  (=> (= $abort_code@20@@0 $abort_code@14@@1) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192746) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 192744) 192746)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon41_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon85_Then_correct  (=> (= (ControlFlow 0 192754) 192746) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon41_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon84_Then_correct  (=> $abort_flag@9@@1 (and (=> (= (ControlFlow 0 192738) 192754) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 192738) 192744) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon85_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon49_correct  (=> (= $abort_code@20@@0 $abort_code@16@@0) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192726) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 192724) 192726)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon49_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon89_Then_correct  (=> (= (ControlFlow 0 192734) 192726) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon49_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon88_Then_correct  (=> $abort_flag@10@@0 (and (=> (= (ControlFlow 0 192718) 192734) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 192718) 192724) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon89_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon53_correct  (=> (= $abort_code@20@@0 $abort_code@17@@0) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192706) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 192704) 192706)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon53_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 192714) 192706) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon53_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon90_Then_correct  (=> $abort_flag@11@@0 (and (=> (= (ControlFlow 0 192698) 192714) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 192698) 192704) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon91_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon61_correct  (=> (= $abort_code@20@@0 $abort_code@19@@0) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 192686) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 192684) 192686)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon61_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon95_Then_correct  (=> (= (ControlFlow 0 192694) 192686) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon61_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon94_Then_correct  (=> $abort_flag@12@@0 (and (=> (= (ControlFlow 0 192678) 192694) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 192678) 192684) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon95_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (= $abort_code@19@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@12@@0 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 191629) 192678) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 191629) 191765) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon94_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| amount)) $MAX_U64) (= (ControlFlow 0 191627) 191629)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| amount))) (=> (and (and (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| amount)))) (= $abort_code@19@@0 $abort_code@17@@0)) (and (= $abort_flag@12@@0 $abort_flag@11@@0) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 191571) 192678) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 191571) 191765) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon94_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 191541) (- 0 258502)) true) (and (=> (= (ControlFlow 0 191541) 191627) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 191541) 191571) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon92_Then_correct  (=> (and (|b#$Boolean| inline$$Le$1$dst@1) (= (ControlFlow 0 191635) 191541)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon58_correct  (=> (= $abort_code@20@@0 $abort_code@18@@0) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 |inline$$WritebackToGlobal$2$m'@2|) (= (ControlFlow 0 191436) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 191434) 191436)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon58_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon93_Then_correct  (=> (= (ControlFlow 0 191444) 191436) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon58_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon92_Else$2_correct  (and (=> (= (ControlFlow 0 191428) (- 0 258400)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@1) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@1)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@1)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@2) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@2)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@2)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@2))))))))))))))) (=> (= $abort_code@18@@0 (|i#$Integer| call3formal@$ret0@0@@14)) (and (=> (= (ControlFlow 0 191428) 191444) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 191428) 191434) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon93_Else_correct)))))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 191282) 191428)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon92_Else$2_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1) (=> (and (= inline$$WritebackToGlobal$2$ta@1 (|ts#$Global| inline$$WritebackToGlobal$2$l@1)) (= inline$$WritebackToGlobal$2$a@1 (|a#$Global| inline$$WritebackToGlobal$2$l@1))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))) (= |inline$$WritebackToGlobal$2$m'@1| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1 inline$$WritebackToGlobal$2$v@1)))) (and (= |inline$$WritebackToGlobal$2$m'@2| |inline$$WritebackToGlobal$2$m'@1|) (= (ControlFlow 0 191336) 191428))) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon92_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct  (=> (= inline$$WritebackToGlobal$2$l@1 (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (and (=> (= (ControlFlow 0 191272) 191336) inline$$WritebackToGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 191272) 191282) inline$$WritebackToGlobal$2$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$anon0_correct@@0  (and (=> (= (ControlFlow 0 191150) (- 0 258146)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 191150) (- 0 258167)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@1) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@1 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@1)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@1) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@1 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@1)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@0) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@0))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@0)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@2) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@2 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@2)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@2) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@2 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@0) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@0))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@0))))))))))))))))))))) (=> (= (ControlFlow 0 191150) 191272) inline$$WritebackToGlobal$2$anon0_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$Entry_correct@@0  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= (ControlFlow 0 191002) 191150)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon92_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$1$dst@1)) (= (ControlFlow 0 191154) 191002)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$Entry_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon90_Else_correct  (=> (not $abort_flag@11@@0) (and (=> (= (ControlFlow 0 190821) 191635) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 190821) 191154) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon92_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon88_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_validate_and_record_mint_$def$0$$t28@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11@@0)) (and (=> $abort_flag@11@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@11@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@14) (>= (|i#$Integer| call3formal@$ret0@0@@14) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@14) $MAX_U64))) (and (=> (= (ControlFlow 0 190815) 192698) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 190815) 190821) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon90_Else_correct)))))
(let ((inline$$Le$1$anon0_correct  (=> (and (= inline$$Le$1$dst@1 ($Boolean (<= (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| inline$$Sub$0$dst@2@@1)))) (= (ControlFlow 0 190803) 190815)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon88_Else$1_correct)))
(let ((inline$$Le$1$Entry_correct  (and (=> (= (ControlFlow 0 190789) (- 0 258036)) true) (=> (= (ControlFlow 0 190789) 190803) inline$$Le$1$anon0_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon88_Else_correct  (=> (and (not $abort_flag@10@@0) (= (ControlFlow 0 190809) 190789)) inline$$Le$1$Entry_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@10@@0 true) (=> (and (= $abort_code@16@@0 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@0@@1)) (and (=> (= (ControlFlow 0 190733) 192718) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 190733) 190809) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon88_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@1  (=> (and (< (|i#$Integer| inline$$Vector_borrow$0$dst@2@@0) (|i#$Integer| amount)) (= (ControlFlow 0 190731) 190733)) inline$$Sub$0$anon3_Then$1_correct@@1)))
(let ((inline$$Sub$0$anon3_Else_correct@@1  (=> (<= (|i#$Integer| amount) (|i#$Integer| inline$$Vector_borrow$0$dst@2@@0)) (=> (and (and (= inline$$Sub$0$dst@1@@1 ($Integer (- (|i#$Integer| inline$$Vector_borrow$0$dst@2@@0) (|i#$Integer| amount)))) (= $abort_flag@10@@0 $abort_flag@9@@1)) (and (= $abort_code@16@@0 $abort_code@14@@1) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@1@@1))) (and (=> (= (ControlFlow 0 190679) 192718) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 190679) 190809) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon88_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 190653) (- 0 257948)) true) (and (=> (= (ControlFlow 0 190653) 190731) inline$$Sub$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 190653) 190679) inline$$Sub$0$anon3_Else_correct@@1)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon86_Then_correct  (=> (and (|b#$Boolean| inline$$Le$0$dst@1@@0) (= (ControlFlow 0 190739) 190653)) inline$$Sub$0$Entry_correct@@1)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon46_correct  (=> (= $abort_code@20@@0 $abort_code@15@@0) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 |inline$$WritebackToGlobal$1$m'@2|) (= (ControlFlow 0 190556) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 190554) 190556)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon46_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 190564) 190556) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon46_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon86_Else$2_correct  (and (=> (= (ControlFlow 0 190548) (- 0 257846)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@3) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@3)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@4) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@4))))))))))))))) (=> (= $abort_code@15@@0 (|i#$Integer| call3formal@$ret0@0@@15)) (and (=> (= (ControlFlow 0 190548) 190564) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 190548) 190554) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon87_Else_correct)))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 190402) 190548)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon86_Else$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 190456) 190548))) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon86_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (and (=> (= (ControlFlow 0 190392) 190456) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 190392) 190402) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$anon0_correct@@0  (and (=> (= (ControlFlow 0 190270) (- 0 257592)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 190270) (- 0 257613)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@1) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@1 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@1)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@1) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@1 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@1)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@0) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@0))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@0)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@2) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@2 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@2)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@2) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@2 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@0) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@0))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@0))))))))))))))))))))) (=> (= (ControlFlow 0 190270) 190392) inline$$WritebackToGlobal$1$anon0_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct@@0  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= (ControlFlow 0 190122) 190270)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon86_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$0$dst@1@@0)) (= (ControlFlow 0 190274) 190122)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon84_Else_correct  (=> (not $abort_flag@9@@1) (and (=> (= (ControlFlow 0 189941) 190739) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 189941) 190274) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon86_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon38$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_validate_and_record_mint_$def$0$$t24@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9@@1)) (and (=> $abort_flag@9@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@9@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@15) (>= (|i#$Integer| call3formal@$ret0@0@@15) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@15) $MAX_U64))) (and (=> (= (ControlFlow 0 189935) 192738) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 189935) 189941) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon84_Else_correct)))))
(let ((inline$$Le$0$anon0_correct@@0  (=> (and (= inline$$Le$0$dst@1@@0 ($Boolean (<= (|i#$Integer| amount) (|i#$Integer| inline$$Vector_borrow$0$dst@2@@0)))) (= (ControlFlow 0 189923) 189935)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon38$1_correct)))
(let ((inline$$Le$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 189909) (- 0 257482)) true) (=> (= (ControlFlow 0 189909) 189923) inline$$Le$0$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 189865) 189909)) inline$$Le$0$Entry_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon83_Then_correct  (=> (= (ControlFlow 0 192762) 189909) inline$$Le$0$Entry_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon81_Else_correct  (=> (not $abort_flag@8@@2) (and (=> (= (ControlFlow 0 189857) 192762) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 189857) 189865) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon83_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@0  (=> (= $abort_code@13@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@8@@2 true) (= inline$$Vector_borrow$0$dst@2@@0 inline$$Vector_borrow$0$dst@0@@0)) (and (=> (= (ControlFlow 0 189811) 192766) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 189811) 189857) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon81_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@0  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1@@0 0) (>= inline$$Vector_borrow$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)))) (= (ControlFlow 0 189809) 189811)) inline$$Vector_borrow$0$anon3_Then$1_correct@@0)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@0  (=> (not (or (< inline$$Vector_borrow$0$i_ind@1@@0 0) (>= inline$$Vector_borrow$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0))))) (=> (and (and (= inline$$Vector_borrow$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) inline$$Vector_borrow$0$i_ind@1@@0)) (= $abort_code@13@@1 $abort_code@11@@2)) (and (= $abort_flag@8@@2 $abort_flag@7@@2) (= inline$$Vector_borrow$0$dst@2@@0 inline$$Vector_borrow$0$dst@1@@0))) (and (=> (= (ControlFlow 0 189751) 192766) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 189751) 189857) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon81_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon0_correct@@0  (=> ((_ is $Vector) inline$$ReadRef$2$v@1@@0) (=> (and ((_ is $Integer) tier_index) (= inline$$Vector_borrow$0$i_ind@1@@0 (|i#$Integer| tier_index))) (and (=> (= (ControlFlow 0 189725) 189809) inline$$Vector_borrow$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 189725) 189751) inline$$Vector_borrow$0$anon3_Else_correct@@0))))))
(let ((inline$$Vector_borrow$0$Entry_correct@@0  (=> (and (= inline$$Vector_borrow$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 189711) 189725)) inline$$Vector_borrow$0$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon79_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@1@@0) (= (ControlFlow 0 189817) 189711)) inline$$Vector_borrow$0$Entry_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon32_correct  (=> (= $abort_code@20@@0 $abort_code@12@@1) (=> (and (= $DesignatedDealer_TierInfo_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 189585) 189589)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$Abort_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 189583) 189585)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon32_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon80_Then_correct  (=> (= (ControlFlow 0 189597) 189585) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon32_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon79_Else$2_correct  (and (=> (= (ControlFlow 0 189577) (- 0 257242)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@5 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@5) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@5)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@6 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@6) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@6 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@6)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def$0$coin_type@@6)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def$0$addr@@6))))))))))))))) (=> (= $abort_code@12@@1 (|i#$Integer| call3formal@$ret0@0@@16)) (and (=> (= (ControlFlow 0 189577) 189597) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 189577) 189583) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon80_Else_correct)))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 189431) 189577)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon79_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 189485) 189577))) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon79_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (and (=> (= (ControlFlow 0 189421) 189485) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 189421) 189431) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$anon0_correct@@0  (and (=> (= (ControlFlow 0 189299) (- 0 256988)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 189299) (- 0 257009)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@1) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@1 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@1)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@1) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@1 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@1)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@0) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@0))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@0)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@2) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@2 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@2)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@2) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@2 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@0) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@0))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@0))))))))))))))))))))) (=> (= (ControlFlow 0 189299) 189421) inline$$WritebackToGlobal$0$anon0_correct@@0)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= (ControlFlow 0 189151) 189299)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon79_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1@@0)) (= (ControlFlow 0 189303) 189151)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon77_Else_correct  (=> (not $abort_flag@7@@2) (and (=> (= (ControlFlow 0 188970) 189817) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 188970) 189303) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon79_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon75_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_validate_and_record_mint_$def$0$$t20@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7@@2)) (and (=> $abort_flag@7@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@7@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@16) (>= (|i#$Integer| call3formal@$ret0@0@@16) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@16) $MAX_U64))) (and (=> (= (ControlFlow 0 188964) 192786) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 188964) 188970) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon77_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct@@0  (=> (and (= inline$$Lt$0$dst@1@@0 ($Boolean (< (|i#$Integer| tier_index) (|i#$Integer| inline$$Vector_length$0$l@1@@0)))) (= (ControlFlow 0 188952) 188964)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon75_Else$1_correct)))
(let ((inline$$Lt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 188938) (- 0 256878)) true) (=> (= (ControlFlow 0 188938) 188952) inline$$Lt$0$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon75_Else_correct  (=> (and (not $abort_flag@6@@2) (= (ControlFlow 0 188958) 188938)) inline$$Lt$0$Entry_correct@@0)))
(let ((inline$$Vector_length$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@0) (= inline$$Vector_length$0$l@1@@0 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0))))) (and (=> (= (ControlFlow 0 188882) 192806) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 188882) 188958) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon75_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@0  (=> (and (= inline$$Vector_length$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 188870) 188882)) inline$$Vector_length$0$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 188831) 188870)) inline$$Vector_length$0$Entry_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon74_Then_correct  (=> (= (ControlFlow 0 192830) 188870) inline$$Vector_length$0$Entry_correct@@0)))
(let ((inline$$ReadRef$2$anon0_correct@@0  (=> (= inline$$ReadRef$2$v@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1@@0)) (and (=> (= (ControlFlow 0 188809) 192830) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 188809) 188831) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon74_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $DesignatedDealer_TierInfo_tiers) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))) $DesignatedDealer_TierInfo_tiers))) (= (ControlFlow 0 188771) 188809))) inline$$ReadRef$2$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 188617) 188771)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon73_Then_correct  (=> (= (ControlFlow 0 192838) 188771) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (and (=> (= (ControlFlow 0 188561) 192838) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 188561) 188617) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon73_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $DesignatedDealer_TierInfo_window_inflow) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))) $DesignatedDealer_TierInfo_window_inflow))) (= (ControlFlow 0 188523) 188561))) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 188369) 188523)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon72_Then_correct  (=> (and (= inline$$DesignatedDealer_validate_and_record_mint_$def$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= (ControlFlow 0 192848) 188523)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) call4formal@$ret0@0)) (and (=> (= (ControlFlow 0 188355) 192848) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 188355) 188369) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon72_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon70_Else_correct  (=> (and (not $abort_flag@6@@2) (= (ControlFlow 0 188361) 188355)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon68_Else$2_correct  (and (=> (= (ControlFlow 0 188298) (- 0 256388)) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@4 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@4)) $i_0@@4) (< $i_0@@4 (|i#$Integer| (|ub#$Range| $range_1@@4)))) (let ((i@@15 ($Integer $i_0@@4)))
(|b#$Boolean| ($Boolean (let (($range_3@@4 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@4)) $i_2@@4) (< $i_2@@4 (|i#$Integer| (|ub#$Range| $range_3@@4)))) (let ((j@@6 ($Integer $i_2@@4)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@15) (|i#$Integer| j@@6)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@15))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@6))))))))))))))))))))))) (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@4 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@4)) $i_0@@5) (< $i_0@@5 (|i#$Integer| (|ub#$Range| $range_1@@4)))) (let ((i@@15 ($Integer $i_0@@5)))
(|b#$Boolean| ($Boolean (let (($range_3@@4 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@4)) $i_2@@5) (< $i_2@@5 (|i#$Integer| (|ub#$Range| $range_3@@4)))) (let ((j@@6 ($Integer $i_2@@5)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@15) (|i#$Integer| j@@6)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@15))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@6)))))))))))))))))))))) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@2) (=> $abort_flag@6@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@6@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10@@2 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@6@@2) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 86400000000))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 86400000000))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_window_start)))))))) ($Boolean ($IsEqual_stratified call4formal@$ret0@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_window_start (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)))))) $DesignatedDealer_TierInfo_window_inflow ($Integer 0)) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DesignatedDealer_TierInfo_window_start (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)))))))))) ($Boolean ($IsEqual_stratified call4formal@$ret0@0 inline$$ReadRef$0$v@1@@1))))))) (=> (and (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0) (let ((va@@70 (|v#$Vector| call4formal@$ret0@0)))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_tiers)) (let ((va@@71 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
))))))) (forall (($$0@@21 Int) ) (!  (=> (and (>= $$0@@21 0) (< $$0@@21 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_tiers))) $$0@@21)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_tiers))) $$0@@21)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_tiers))) $$0@@21)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $DesignatedDealer_TierInfo_tiers))) $$0@@21))
))) (and (=> (= (ControlFlow 0 188298) 192852) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 188298) 188361) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon70_Else_correct))))))))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 188286) 188298)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon68_Else$2_correct)))
(let ((inline$$DesignatedDealer_TierInfo_$unpack_ref$0$anon0_correct@@0  (=> (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@5 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@5)) $i_0@@6) (< $i_0@@6 (|i#$Integer| (|ub#$Range| $range_1@@5)))) (let ((i@@16 ($Integer $i_0@@6)))
(|b#$Boolean| ($Boolean (let (($range_3@@5 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@5)) $i_2@@6) (< $i_2@@6 (|i#$Integer| (|ub#$Range| $range_3@@5)))) (let ((j@@7 ($Integer $i_2@@6)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@16) (|i#$Integer| j@@7)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@16))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@7)))))))))))))))))))))) (= (ControlFlow 0 188250) 188286)) inline$$ReadRef$0$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_TierInfo_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 188244) 188250)) inline$$DesignatedDealer_TierInfo_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon68_Else_correct  (=> (and (not $abort_flag@5@@2) (= (ControlFlow 0 188254) 188244)) inline$$DesignatedDealer_TierInfo_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@5@@2 true) (=> (and (= $abort_code@9@@2 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 188204) 192872) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 188204) 188254) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon68_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 188202) 188204)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0))) (= $abort_flag@5@@2 $abort_flag@4@@2)) (and (= $abort_code@9@@2 $abort_code@6@@2) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 188150) 192872) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 188150) 188254) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon68_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| dd_addr@@1)) (and (=> (= (ControlFlow 0 188120) 188202) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 188120) 188150) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (=> (= inline$$BorrowGlobal$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (and (=> (= (ControlFlow 0 188114) (- 0 256261)) true) (=> (= (ControlFlow 0 188114) 188120) inline$$BorrowGlobal$0$anon0_correct@@0)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon6$3_correct  (and (=> (= (ControlFlow 0 188210) (- 0 256218)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_validate_and_record_mint_$def$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_validate_and_record_mint_$def$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)) (=> (= (ControlFlow 0 188210) 188114) inline$$BorrowGlobal$0$Entry_correct@@0)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon6_correct  (=> (and (= inline$$DesignatedDealer_validate_and_record_mint_$def$0$$DesignatedDealer_TierInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1) true)) (= (ControlFlow 0 187911) 188210)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon6$3_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 187851) 187911)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon6_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon67_Then_correct  (=> (= (ControlFlow 0 192896) 187911) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon6_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon66_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 187843) 192896) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 187843) 187851) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon67_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon66_Then_correct  (and (=> (= (ControlFlow 0 192904) 192896) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 192904) 187851) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon67_Else_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon65_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 187835) 192904) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 187835) 187843) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon66_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon65_Then_correct  (and (=> (= (ControlFlow 0 192912) 192904) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 192912) 187843) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon66_Else_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon0_correct  (=> (not $abort_flag@4@@2) (and (=> (= (ControlFlow 0 187829) 192912) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 187829) 187835) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon65_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$direct_intra$0$anon0_correct  (=> ((_ is $Address) dd_addr@@1) (=> (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) (=> (and (and (and ((_ is $Integer) tier_index) (>= (|i#$Integer| tier_index) 0)) (<= (|i#$Integer| tier_index) $MAX_U64)) (= (ControlFlow 0 192916) 187829)) inline$$DesignatedDealer_validate_and_record_mint_$def$0$anon0_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$direct_intra$0$Entry_correct  (and (=> (= (ControlFlow 0 186357) (- 0 255989)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_tiered_mint_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_tiered_mint_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)) (=> (= (ControlFlow 0 186357) 192916) inline$$DesignatedDealer_validate_and_record_mint_$direct_intra$0$anon0_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon77_Then_correct  (=> (and (|b#$Boolean| inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t21@1) (= (ControlFlow 0 192922) 186357)) inline$$DesignatedDealer_validate_and_record_mint_$direct_intra$0$Entry_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon40_correct  (=> (= $abort_code@31@@0 $abort_code@8@@2) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 186214) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 186212) 186214)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon40_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon78_Then_correct  (=> (= (ControlFlow 0 186222) 186214) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon40_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon77_Else_correct  (=> (and (not (|b#$Boolean| inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t21@1)) (= $abort_code@8@@2 (|i#$Integer| call3formal@$ret0@0@@17))) (and (=> (= (ControlFlow 0 186206) 186222) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 186206) 186212) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon75_Else_correct  (=> (not $abort_flag@4@@2) (and (=> (= (ControlFlow 0 186194) 192922) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 186194) 186206) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon73_Then_correct  (=> (and (|b#$Boolean| call3formal@$ret0@0@@18) (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t21@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1))))) (=> (and (and (and (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t22@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@2)) (and (=> $abort_flag@4@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@17) (>= (|i#$Integer| call3formal@$ret0@0@@17) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@17) $MAX_U64))) (and (=> (= (ControlFlow 0 186188) 195405) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 186188) 186194) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon75_Else_correct))))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon32_correct  (=> (= $abort_code@31@@0 $abort_code@7@@2) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 186150) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 186148) 186150)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon32_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 186158) 186150) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon32_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon73_Else_correct  (=> (and (not (|b#$Boolean| call3formal@$ret0@0@@18)) (= $abort_code@7@@2 (|i#$Integer| call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 186142) 186158) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 186142) 186148) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon71_Else_correct  (=> (not $abort_flag@3@@3) (and (=> (= (ControlFlow 0 186130) 186188) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 186130) 186142) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon69_Else_correct  (=> (not $abort_flag@2@@3) (=> (and (and (and (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t19@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@3)) (and (=> $abort_flag@3@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@19) (>= (|i#$Integer| call3formal@$ret0@0@@19) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@19) $MAX_U64))) (and (=> (= (ControlFlow 0 186124) 195425) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 186124) 186130) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon71_Else_correct))))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon67_Then_correct  (=> (|b#$Boolean| inline$$Gt$0$dst@1@@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@3) (=> $abort_flag@2@@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| dd_addr@@1))))))) ((_ is $Boolean) call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 186114) 195445) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 186114) 186124) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon69_Else_correct))))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon20_correct  (=> (= $abort_code@31@@0 $abort_code@4@@3) (=> (and (and (= $DesignatedDealer_TierInfo_$memory@2@@1 $DesignatedDealer_TierInfo_$memory) (= $DesignatedDealer_Dealer_$memory@0@@0 $DesignatedDealer_Dealer_$memory)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 186094) 186100))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$Abort_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 186092) 186094)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon20_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon68_Then_correct  (=> (= (ControlFlow 0 186108) 186094) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon20_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon67_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1@@1)) (= $abort_code@4@@3 (|i#$Integer| call3formal@$ret0@0@@20))) (and (=> (= (ControlFlow 0 186086) 186108) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 186086) 186092) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon65_Else_correct  (=> (not $abort_flag@1@@3) (and (=> (= (ControlFlow 0 186074) 186114) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 186074) 186086) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon63_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t16@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3)) (and (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@20 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@20) (>= (|i#$Integer| call3formal@$ret0@0@@20) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@20) $MAX_U64))) (and (=> (= (ControlFlow 0 186068) 195465) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 186068) 186074) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct@@1  (=> (and (= inline$$Gt$0$dst@1@@1 ($Boolean (> (|i#$Integer| amount) (|i#$Integer| inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t14@1)))) (= (ControlFlow 0 186056) 186068)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon63_Else$1_correct)))
(let ((inline$$Gt$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 186042) (- 0 255583)) true) (=> (= (ControlFlow 0 186042) 186056) inline$$Gt$0$anon0_correct@@1))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon63_Else_correct  (=> (not $abort_flag@0@@3) (=> (and (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$t14@1 ($Integer 0)) (= (ControlFlow 0 186062) 186042)) inline$$Gt$0$Entry_correct@@1))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon8$4_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@0@@3) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@0@@3)) (and (=> $abort_flag@0@@3 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))))) (=> $abort_flag@0@@3 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 185990) 195485) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 185990) 186062) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon63_Else_correct))))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon8_correct  (=> (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)) true)) (=> (and (= inline$$DesignatedDealer_tiered_mint_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1) true)) (= (ControlFlow 0 185886) 185990)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon8$4_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 185800) 185886)) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon8_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 195509) 185886) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon8_correct)))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon61_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 185792) 195509) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 185792) 185800) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon61_Then_correct  (and (=> (= (ControlFlow 0 195517) 195509) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 195517) 185800) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon62_Else_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon60_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 185784) 195517) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 185784) 185792) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon60_Then_correct  (and (=> (= (ControlFlow 0 195525) 195517) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 195525) 185792) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon61_Else_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon59_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 185776) 195525) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 185776) 185784) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon59_Then_correct  (and (=> (= (ControlFlow 0 195533) 195525) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 195533) 185784) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon60_Else_correct))))
(let ((inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 185770) 195533) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 185770) 185776) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon59_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (and (and (and (forall (($inv_addr@@16 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16)) (let ((va@@72 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))
)) (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@73 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@73 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))
))) (and (forall (($inv_addr@@18 Int) ($inv_tv0@@7 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18)) (let ((va@@74 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))))
(let ((l@@74 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@75 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@75 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_currency_code)) (let ((va@@76 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@76 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@76) (<= l@@76 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@76)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76))
))))))) (forall (($$0@@22 Int) ) (!  (=> (and (>= $$0@@22 0) (< $$0@@22 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_currency_code))) $$0@@22)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_currency_code))) $$0@@22)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_currency_code))) $$0@@22)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_currency_code))) $$0@@22))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events)) (let ((va@@77 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@77 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@78 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@78 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78))
))))))) (forall (($$0@@23 Int) ) (!  (=> (and (>= $$0@@23 0) (< $$0@@23 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@23)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@23)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@23)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@23))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events)) (let ((va@@79 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@79 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@80 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@80 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@80) (<= l@@80 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@80)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80))
))))))) (forall (($$0@@24 Int) ) (!  (=> (and (>= $$0@@24 0) (< $$0@@24 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@24)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@24)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@24)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@24))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@81 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@81 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@82 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@82 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82))
))))))) (forall (($$0@@25 Int) ) (!  (=> (and (>= $$0@@25 0) (< $$0@@25 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@25)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@25)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@25)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@25))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@83 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@83 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@84 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@84 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84))
))))))) (forall (($$0@@26 Int) ) (!  (=> (and (>= $$0@@26 0) (< $$0@@26 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@26)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@26)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@26)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@26))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@85 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@85 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@86 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@86 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86))
))))))) (forall (($$0@@27 Int) ) (!  (=> (and (>= $$0@@27 0) (< $$0@@27 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@27)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@27)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@27)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@27))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@18))
)) (forall (($inv_addr@@19 Int) ($inv_tv0@@8 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@19)) (let ((va@@87 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@19))))
(let ((l@@87 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@19))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@19))) $Diem_MintCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@19))
)))) (and (and (forall (($inv_addr@@20 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20)) (let ((va@@88 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))))
(let ((l@@88 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) 1)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle)) (let ((va@@89 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))))
(let ((l@@89 (|l#$ValueArray| va@@89)))
 (and (and (<= 0 l@@89) (<= l@@89 $MAX_U64)) (forall ((x@@89 Int) ) (!  (=> (or (< x@@89 0) (>= x@@89 l@@89)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid)) (let ((va@@90 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))
(let ((l@@90 (|l#$ValueArray| va@@90)))
 (and (and (<= 0 l@@90) (<= l@@90 $MAX_U64)) (forall ((x@@90 Int) ) (!  (=> (or (< x@@90 0) (>= x@@90 l@@90)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90))
))))))) (forall (($$0@@28 Int) ) (!  (=> (and (>= $$0@@28 0) (< $$0@@28 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@28)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@28)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@28)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@28))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@20))
)) (forall (($inv_addr@@21 Int) ($inv_tv0@@9 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21)) (let ((va@@91 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))))
(let ((l@@91 (|l#$ValueArray| va@@91)))
 (and (and (<= 0 l@@91) (<= l@@91 $MAX_U64)) (forall ((x@@91 Int) ) (!  (=> (or (< x@@91 0) (>= x@@91 l@@91)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers)) (let ((va@@92 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@92 (|l#$ValueArray| va@@92)))
 (and (and (<= 0 l@@92) (<= l@@92 $MAX_U64)) (forall ((x@@92 Int) ) (!  (=> (or (< x@@92 0) (>= x@@92 l@@92)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92))
))))))) (forall (($$0@@29 Int) ) (!  (=> (and (>= $$0@@29 0) (< $$0@@29 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers))) $$0@@29)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers))) $$0@@29)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers))) $$0@@29)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers))) $$0@@29))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@6 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@7 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@6)) $i_0@@7) (< $i_0@@7 (|i#$Integer| (|ub#$Range| $range_1@@6)))) (let ((i@@17 ($Integer $i_0@@7)))
(|b#$Boolean| ($Boolean (let (($range_3@@6 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@7 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@6)) $i_2@@7) (< $i_2@@7 (|i#$Integer| (|ub#$Range| $range_3@@6)))) (let ((j@@8 ($Integer $i_2@@7)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@17) (|i#$Integer| j@@8)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@17))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@8))))))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@21))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@10 T@$Value) )  (=> ((_ is $Type) coin_type@@10) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@2 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@10)) 1) (|a#$Address| mint_cap_owner@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@2)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@11 T@$Value) )  (=> ((_ is $Type) coin_type@@11) (|b#$Boolean| ($Boolean (forall ((addr3@@1 T@$Value) )  (=> ((_ is $Address) addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@12 T@$Value) )  (=> ((_ is $Type) coin_type@@12) (|b#$Boolean| ($Boolean (forall ((addr1@@5 T@$Value) )  (=> ((_ is $Address) addr1@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@12)) 1) (|a#$Address| addr1@@5)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@13 T@$Value) )  (=> ((_ is $Type) coin_type@@13) (|b#$Boolean| ($Boolean (forall ((addr1@@6 T@$Value) )  (=> ((_ is $Address) addr1@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@13)) 1) (|a#$Address| addr1@@6)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 195539) 185770))))) inline$$DesignatedDealer_tiered_mint_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@4  (=> ((_ is $Address) tc_account@@2) (=> (and (and (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) ((_ is $Address) dd_addr@@1)) (and (and (and ((_ is $Integer) tier_index) (>= (|i#$Integer| tier_index) 0)) (<= (|i#$Integer| tier_index) $MAX_U64)) (= (ControlFlow 0 184096) 195539))) anon0$1_correct@@4))))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (|Select_[$TypeValueArray,$int]$bool| $Diem_CurrencyInfo_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))) (=> (and (|Select_[$TypeValueArray,$int]$bool| $DesignatedDealer_TierInfo_$CallerDomain@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd_addr@@1)) (= (ControlFlow 0 250267) 184096)) anon0_correct@@4))))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun tc_account@@3 () T@$Value)
(declare-fun $abort_flag@14@@1 () Bool)
(declare-fun $tv0@@14 () T@$TypeValue)
(declare-fun dd_addr@@2 () T@$Value)
(declare-fun tier_index@@0 () T@$Value)
(declare-fun new_upperbound () T@$Value)
(declare-fun $abort_code@20@@1 () Int)
(declare-fun $DesignatedDealer_TierInfo_$memory@0@@3 () T@$Memory)
(declare-fun $abort_flag@4@@3 () Bool)
(declare-fun $abort_code@7@@3 () Int)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t37@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun $abort_flag@13@@1 () Bool)
(declare-fun $abort_code@16@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun |inline$$Splice1$0$dst'@1| () T@$Mutation)
(declare-fun inline$$Vector_borrow_mut$0$dst@2 () T@$Mutation)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun |inline$$Vector_borrow_mut$0$v'| () T@$Value)
(declare-fun $abort_code@19@@1 () Int)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@4 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun $abort_code@5@@4 () Int)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun $abort_code@8@@3 () Int)
(declare-fun $abort_flag@5@@3 () Bool)
(declare-fun $abort_code@9@@3 () Int)
(declare-fun $abort_flag@6@@3 () Bool)
(declare-fun $abort_code@10@@3 () Int)
(declare-fun $abort_flag@7@@3 () Bool)
(declare-fun $abort_code@18@@1 () Int)
(declare-fun call3formal@$ret0@0@@21 () T@$Value)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0 () T@$Value)
(declare-fun inline$$Lt$3$dst@1 () T@$Value)
(declare-fun $abort_code@12@@2 () Int)
(declare-fun $abort_flag@9@@2 () Bool)
(declare-fun $abort_code@13@@2 () Int)
(declare-fun $abort_flag@10@@1 () Bool)
(declare-fun $abort_code@14@@2 () Int)
(declare-fun $abort_flag@11@@1 () Bool)
(declare-fun $abort_code@17@@1 () Int)
(declare-fun call3formal@$ret0@0@@22 () T@$Value)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1 () T@$Value)
(declare-fun inline$$Gt$1$dst@1@@0 () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@0 () T@$Mutation)
(declare-fun inline$$Vector_borrow_mut$0$i_ind@1 () Int)
(declare-fun inline$$ReadRef$2$v@1@@1 () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@1 () T@$Mutation)
(declare-fun $abort_code@15@@1 () Int)
(declare-fun $abort_flag@12@@1 () Bool)
(declare-fun inline$$Vector_borrow_mut$0$ta@0 () T@$TypeValue)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t53@1 () T@$Value)
(declare-fun inline$$Vector_borrow$1$dst@2 () T@$Value)
(declare-fun inline$$Vector_borrow$1$dst@0 () T@$Value)
(declare-fun inline$$Vector_borrow$1$i_ind@1 () Int)
(declare-fun inline$$ReadRef$3$v@1@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$1$dst@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@2 () T@$Value)
(declare-fun inline$$Vector_borrow$1$ta@0 () T@$TypeValue)
(declare-fun inline$$Sub$0$dst@0@@2 () T@$Value)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t49@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@2 () T@$Value)
(declare-fun $abort_flag@8@@3 () Bool)
(declare-fun $abort_code@11@@3 () Int)
(declare-fun |inline$$DesignatedDealer_update_tier_$def_verify$0$tmp#$19@1| () T@$Value)
(declare-fun inline$$Gt$2$dst@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t47@1 () T@$Value)
(declare-fun inline$$Gt$0$dst@1@@2 () T@$Value)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t48@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@2@@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t44@1 () T@$Value)
(declare-fun inline$$Vector_borrow$2$dst@2 () T@$Value)
(declare-fun inline$$Vector_borrow$2$dst@0 () T@$Value)
(declare-fun inline$$Vector_borrow$2$i_ind@1 () Int)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun inline$$Vector_borrow$2$dst@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun inline$$Vector_borrow$2$ta@0 () T@$TypeValue)
(declare-fun inline$$Lt$2$dst@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t39@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Lt$1$dst@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@0@@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1@@1 () Int)
(declare-fun inline$$ReadRef$1$v@1@@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0@@1 () T@$TypeValue)
(declare-fun inline$$Lt$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@6@@3 () Int)
(declare-fun call3formal@$ret0@0@@23 () T@$Value)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t34@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@2 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0@@1 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@2 () Int)
(declare-fun inline$$BorrowField$0$p@2@@2 () T@$Path)
(declare-fun inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@1 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t28@1 () T@$Value)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun call3formal@$ret0@0@@24 () T@$Value)
(declare-fun inline$$DesignatedDealer_update_tier_$def_verify$0$$t29@1 () T@$Value)
(declare-fun $DesignatedDealer_TierInfo_$CallerDomain@@3 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 263105) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 204929) (- 0 269404)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 204929) (- 0 269425)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 204929) (- 0 269454)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 204929) (- 0 269471)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2))))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2))))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 204929) (- 0 269501)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 204929) (- 0 269529)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound))))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound))))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 204929) (- 0 269593)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound))))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound))))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 204929) (- 0 269678)) (=> $abort_flag@14@@1 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound)))))))))) (=> (=> $abort_flag@14@@1 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound))))))))) (and (=> (= (ControlFlow 0 204929) (- 0 269946)) (=> $abort_flag@14@@1 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@14@@1 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (- (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| new_upperbound))))))) (= $abort_code@20@@1 (|i#$Integer| ($Integer 7)))))) (and (=> (= (ControlFlow 0 204929) (- 0 270291)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2))))) (=> (= (ControlFlow 0 204929) (- 0 270317)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)) ($Vector (let ((len@@25 (|l#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@27 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@27 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@26 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@27 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@27 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_window_start)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_window_inflow)) (+ len@@26 1)))) len@@25 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| tier_index@@0) new_upperbound) (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)))) $DesignatedDealer_TierInfo_tiers)))))) (+ len@@25 1)))))))))))))))))))))))))))))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon119_Then$1_correct  (=> (and (and (= $abort_flag@14@@1 $abort_flag@4@@3) (= $abort_code@20@@1 $abort_code@7@@3)) (and (= $DesignatedDealer_TierInfo_$memory@0@@3 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 204771) 204929))) anon0$2_correct@@5)))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$anon0_correct  (and (=> (= (ControlFlow 0 204765) (- 0 269102)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 204765) (- 0 269123)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_8 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_8) (< inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_8 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_8)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_10) (< inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_10 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_10)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$4$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$4$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$4$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$4$j)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_8@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_9)) inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_8@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_8@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_9)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$i ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_8@@0)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_10@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_11)) inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_10@@0) (< inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_10@@0 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$range_11)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$j ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$4$$i_10@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$4$i) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$4$j)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$4$i))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$4$j))))))))))))))))))))) (=> (= (ControlFlow 0 204765) 204771) inline$$DesignatedDealer_update_tier_$def_verify$0$anon119_Then$1_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$4$Entry_correct  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$4$$after@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 204617) 204765)) inline$$DesignatedDealer_TierInfo_$pack_ref$4$anon0_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon119_Then_correct  (=> (and (|b#$Boolean| inline$$DesignatedDealer_update_tier_$def_verify$0$$t37@1) (= (ControlFlow 0 204769) 204617)) inline$$DesignatedDealer_TierInfo_$pack_ref$4$Entry_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon98$4_correct  (and (=> (= (ControlFlow 0 202290) (- 0 268582)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_update_tier_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_update_tier_$def_verify$0$addr) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_update_tier_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_update_tier_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_update_tier_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_update_tier_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_update_tier_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_update_tier_$def_verify$0$addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_update_tier_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_update_tier_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_update_tier_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_update_tier_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_update_tier_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_update_tier_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_update_tier_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_update_tier_$def_verify$0$addr@@0))))))))))))))) (=> (and (and (= $abort_flag@14@@1 $abort_flag@13@@1) (= $abort_code@20@@1 $abort_code@16@@1)) (and (= $DesignatedDealer_TierInfo_$memory@0@@3 |inline$$WritebackToGlobal$0$m'@2@@1|) (= (ControlFlow 0 202290) 204929))) anon0$2_correct@@5)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@1| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 202148) 202290)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon98$4_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@1|) (= (ControlFlow 0 202202) 202290))) inline$$DesignatedDealer_update_tier_$def_verify$0$anon98$4_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (and (=> (= (ControlFlow 0 202138) 202202) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 202138) 202148) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$anon0_correct@@1  (and (=> (= (ControlFlow 0 202016) (- 0 268328)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 202016) (- 0 268349)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@3) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@3 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@3)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@3) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@3 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@3)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@1) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@1))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@1)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@4) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@4 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@4)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@4) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@4 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@4)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@1) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@1))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@1))))))))))))))))))))) (=> (= (ControlFlow 0 202016) 202138) inline$$WritebackToGlobal$0$anon0_correct@@1)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct@@1  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (= (ControlFlow 0 201868) 202016)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$anon0_correct@@1)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@1| inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 201631) 201868)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct@@1))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1)) (= |inline$$WritebackToReference$1$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$WritebackToReference$1$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@1| |inline$$WritebackToReference$1$dst'@1@@1|) (= (ControlFlow 0 201687) 201868))) inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct@@1)))
(let ((inline$$WritebackToReference$1$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (= inline$$WritebackToReference$1$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) (and (=> (= (ControlFlow 0 201595) 201687) inline$$WritebackToReference$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 201595) 201631) inline$$WritebackToReference$1$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowField$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@2| inline$$BorrowField$0$dst@1@@2) (= (ControlFlow 0 201396) 201595)) inline$$WritebackToReference$1$anon0_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowField$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2)) (= |inline$$WritebackToReference$0$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@2) inline$$WritebackToReference$0$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|v#$Mutation| inline$$BorrowField$0$dst@1@@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@2| |inline$$WritebackToReference$0$dst'@1@@2|) (= (ControlFlow 0 201452) 201595))) inline$$WritebackToReference$1$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@2 (|p#$Mutation| inline$$BorrowField$0$dst@1@@2))) (and (=> (= (ControlFlow 0 201360) 201452) inline$$WritebackToReference$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 201360) 201396) inline$$WritebackToReference$0$anon3_Else_correct@@2)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon147_Else_correct  (=> (and (not true) (= (ControlFlow 0 201223) 201360)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon147_Then_correct  (=> (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= (ControlFlow 0 202300) 201360)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| |inline$$Splice1$0$dst'@1|) (|p#$Mutation| |inline$$Splice1$0$dst'@1|) new_upperbound)) (and (=> (= (ControlFlow 0 201209) 202300) inline$$DesignatedDealer_update_tier_$def_verify$0$anon147_Then_correct) (=> (= (ControlFlow 0 201209) 201223) inline$$DesignatedDealer_update_tier_$def_verify$0$anon147_Else_correct)))))
(let ((inline$$Splice1$0$anon0_correct  (=> (and (= |inline$$Splice1$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@2) ($ConcatPath_stratified (|p#$Mutation| inline$$BorrowField$0$dst@1@@2) (|p#$Mutation| inline$$Vector_borrow_mut$0$dst@2)) (|v#$Mutation| inline$$Vector_borrow_mut$0$dst@2))) (= (ControlFlow 0 201150) 201209)) inline$$WriteRef$1$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon146_Else_correct  (=> (and (not true) (= (ControlFlow 0 201075) 201150)) inline$$Splice1$0$anon0_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon146_Then_correct  (=> (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= (ControlFlow 0 202310) 201150)) inline$$Splice1$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@2) (|p#$Mutation| inline$$BorrowField$0$dst@1@@2) |inline$$Vector_borrow_mut$0$v'|)) (and (=> (= (ControlFlow 0 201061) 202310) inline$$DesignatedDealer_update_tier_$def_verify$0$anon146_Then_correct) (=> (= (ControlFlow 0 201061) 201075) inline$$DesignatedDealer_update_tier_$def_verify$0$anon146_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon144_Else_correct  (=> (and (not $abort_flag@13@@1) (= (ControlFlow 0 201067) 201061)) inline$$WriteRef$0$anon0_correct@@2)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@14@@1 true) (= $abort_code@20@@1 $abort_code@19@@1)) (and (= $DesignatedDealer_TierInfo_$memory@0@@3 $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 199240) 204929))) anon0$2_correct@@5)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon11_correct  (=> (and (= $abort_code@19@@1 $abort_code@1@@4) (= (ControlFlow 0 204883) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon104_Else_correct  (=> (and (not true) (= (ControlFlow 0 204881) 204883)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon11_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon104_Then_correct  (=> (= (ControlFlow 0 204891) 204883) inline$$DesignatedDealer_update_tier_$def_verify$0$anon11_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon103_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 204875) 204891) inline$$DesignatedDealer_update_tier_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 204875) 204881) inline$$DesignatedDealer_update_tier_$def_verify$0$anon104_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon15_correct  (=> (and (= $abort_code@19@@1 $abort_code@2@@4) (= (ControlFlow 0 204863) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon106_Else_correct  (=> (and (not true) (= (ControlFlow 0 204861) 204863)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon15_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon106_Then_correct  (=> (= (ControlFlow 0 204871) 204863) inline$$DesignatedDealer_update_tier_$def_verify$0$anon15_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon105_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 204855) 204871) inline$$DesignatedDealer_update_tier_$def_verify$0$anon106_Then_correct) (=> (= (ControlFlow 0 204855) 204861) inline$$DesignatedDealer_update_tier_$def_verify$0$anon106_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon23_correct  (=> (and (= $abort_code@19@@1 $abort_code@4@@4) (= (ControlFlow 0 204843) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon110_Else_correct  (=> (and (not true) (= (ControlFlow 0 204841) 204843)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon23_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon110_Then_correct  (=> (= (ControlFlow 0 204851) 204843) inline$$DesignatedDealer_update_tier_$def_verify$0$anon23_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon109_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 204835) 204851) inline$$DesignatedDealer_update_tier_$def_verify$0$anon110_Then_correct) (=> (= (ControlFlow 0 204835) 204841) inline$$DesignatedDealer_update_tier_$def_verify$0$anon110_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon27_correct  (=> (and (= $abort_code@19@@1 $abort_code@4@@4) (= (ControlFlow 0 204823) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon112_Else_correct  (=> (and (not true) (= (ControlFlow 0 204821) 204823)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon27_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon112_Then_correct  (=> (= (ControlFlow 0 204831) 204823) inline$$DesignatedDealer_update_tier_$def_verify$0$anon27_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon111_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 204815) 204831) inline$$DesignatedDealer_update_tier_$def_verify$0$anon112_Then_correct) (=> (= (ControlFlow 0 204815) 204821) inline$$DesignatedDealer_update_tier_$def_verify$0$anon112_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon31_correct  (=> (and (= $abort_code@19@@1 $abort_code@5@@4) (= (ControlFlow 0 204803) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon114_Else_correct  (=> (and (not true) (= (ControlFlow 0 204801) 204803)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon31_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon114_Then_correct  (=> (= (ControlFlow 0 204811) 204803) inline$$DesignatedDealer_update_tier_$def_verify$0$anon31_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon113_Then_correct  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 204795) 204811) inline$$DesignatedDealer_update_tier_$def_verify$0$anon114_Then_correct) (=> (= (ControlFlow 0 204795) 204801) inline$$DesignatedDealer_update_tier_$def_verify$0$anon114_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon39_correct  (=> (and (= $abort_code@19@@1 $abort_code@7@@3) (= (ControlFlow 0 204783) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon118_Else_correct  (=> (and (not true) (= (ControlFlow 0 204781) 204783)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon39_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon118_Then_correct  (=> (= (ControlFlow 0 204791) 204783) inline$$DesignatedDealer_update_tier_$def_verify$0$anon39_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon117_Then_correct  (=> $abort_flag@4@@3 (and (=> (= (ControlFlow 0 204775) 204791) inline$$DesignatedDealer_update_tier_$def_verify$0$anon118_Then_correct) (=> (= (ControlFlow 0 204775) 204781) inline$$DesignatedDealer_update_tier_$def_verify$0$anon118_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon47_correct  (=> (and (= $abort_code@19@@1 $abort_code@8@@3) (= (ControlFlow 0 204430) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon122_Else_correct  (=> (and (not true) (= (ControlFlow 0 204428) 204430)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon47_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon122_Then_correct  (=> (= (ControlFlow 0 204438) 204430) inline$$DesignatedDealer_update_tier_$def_verify$0$anon47_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon121_Then_correct  (=> $abort_flag@5@@3 (and (=> (= (ControlFlow 0 204422) 204438) inline$$DesignatedDealer_update_tier_$def_verify$0$anon122_Then_correct) (=> (= (ControlFlow 0 204422) 204428) inline$$DesignatedDealer_update_tier_$def_verify$0$anon122_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon55_correct  (=> (and (= $abort_code@19@@1 $abort_code@9@@3) (= (ControlFlow 0 204402) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon126_Else_correct  (=> (and (not true) (= (ControlFlow 0 204400) 204402)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon55_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon126_Then_correct  (=> (= (ControlFlow 0 204410) 204402) inline$$DesignatedDealer_update_tier_$def_verify$0$anon55_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon125_Then_correct  (=> $abort_flag@6@@3 (and (=> (= (ControlFlow 0 204394) 204410) inline$$DesignatedDealer_update_tier_$def_verify$0$anon126_Then_correct) (=> (= (ControlFlow 0 204394) 204400) inline$$DesignatedDealer_update_tier_$def_verify$0$anon126_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon59_correct  (=> (and (= $abort_code@19@@1 $abort_code@10@@3) (= (ControlFlow 0 204382) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon128_Else_correct  (=> (and (not true) (= (ControlFlow 0 204380) 204382)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon59_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon128_Then_correct  (=> (= (ControlFlow 0 204390) 204382) inline$$DesignatedDealer_update_tier_$def_verify$0$anon59_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon127_Then_correct  (=> $abort_flag@7@@3 (and (=> (= (ControlFlow 0 204374) 204390) inline$$DesignatedDealer_update_tier_$def_verify$0$anon128_Then_correct) (=> (= (ControlFlow 0 204374) 204380) inline$$DesignatedDealer_update_tier_$def_verify$0$anon128_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon64_correct  (=> (and (= $abort_code@19@@1 $abort_code@18@@1) (= (ControlFlow 0 204356) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon130_Else_correct  (=> (and (not true) (= (ControlFlow 0 204354) 204356)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon64_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon130_Then_correct  (=> (= (ControlFlow 0 204364) 204356) inline$$DesignatedDealer_update_tier_$def_verify$0$anon64_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon129_Else$1_correct  (=> (= $abort_code@18@@1 (|i#$Integer| call3formal@$ret0@0@@21)) (and (=> (= (ControlFlow 0 204348) 204364) inline$$DesignatedDealer_update_tier_$def_verify$0$anon130_Then_correct) (=> (= (ControlFlow 0 204348) 204354) inline$$DesignatedDealer_update_tier_$def_verify$0$anon130_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$anon0_correct@@0  (and (=> (= (ControlFlow 0 204338) (- 0 268897)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 204338) (- 0 268918)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@1) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@1 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@1)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@1) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@1 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@1)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@0) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@0))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@0)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@2) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@2 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@2)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@0)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@2) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@2 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@0)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@0 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@0) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@0))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@0))))))))))))))))))))) (=> (= (ControlFlow 0 204338) 204348) inline$$DesignatedDealer_update_tier_$def_verify$0$anon129_Else$1_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$Entry_correct@@0  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 204190) 204338)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon129_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$3$dst@1)) (= (ControlFlow 0 204342) 204190)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$Entry_correct@@0)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon75_correct  (=> (and (= $abort_code@19@@1 $abort_code@12@@2) (= (ControlFlow 0 203280) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon136_Else_correct  (=> (and (not true) (= (ControlFlow 0 203278) 203280)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon75_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon136_Then_correct  (=> (= (ControlFlow 0 203288) 203280) inline$$DesignatedDealer_update_tier_$def_verify$0$anon75_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon135_Then_correct  (=> $abort_flag@9@@2 (and (=> (= (ControlFlow 0 203272) 203288) inline$$DesignatedDealer_update_tier_$def_verify$0$anon136_Then_correct) (=> (= (ControlFlow 0 203272) 203278) inline$$DesignatedDealer_update_tier_$def_verify$0$anon136_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon81_correct  (=> (and (= $abort_code@19@@1 $abort_code@13@@2) (= (ControlFlow 0 203252) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon139_Else_correct  (=> (and (not true) (= (ControlFlow 0 203250) 203252)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon81_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon139_Then_correct  (=> (= (ControlFlow 0 203260) 203252) inline$$DesignatedDealer_update_tier_$def_verify$0$anon81_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon138_Then_correct  (=> $abort_flag@10@@1 (and (=> (= (ControlFlow 0 203244) 203260) inline$$DesignatedDealer_update_tier_$def_verify$0$anon139_Then_correct) (=> (= (ControlFlow 0 203244) 203250) inline$$DesignatedDealer_update_tier_$def_verify$0$anon139_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon85_correct  (=> (and (= $abort_code@19@@1 $abort_code@14@@2) (= (ControlFlow 0 203232) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon141_Else_correct  (=> (and (not true) (= (ControlFlow 0 203230) 203232)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon85_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon141_Then_correct  (=> (= (ControlFlow 0 203240) 203232) inline$$DesignatedDealer_update_tier_$def_verify$0$anon85_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon140_Then_correct  (=> $abort_flag@11@@1 (and (=> (= (ControlFlow 0 203224) 203240) inline$$DesignatedDealer_update_tier_$def_verify$0$anon141_Then_correct) (=> (= (ControlFlow 0 203224) 203230) inline$$DesignatedDealer_update_tier_$def_verify$0$anon141_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon90_correct  (=> (and (= $abort_code@19@@1 $abort_code@17@@1) (= (ControlFlow 0 203206) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon143_Else_correct  (=> (and (not true) (= (ControlFlow 0 203204) 203206)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon90_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon143_Then_correct  (=> (= (ControlFlow 0 203214) 203206) inline$$DesignatedDealer_update_tier_$def_verify$0$anon90_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon142_Else$1_correct  (=> (= $abort_code@17@@1 (|i#$Integer| call3formal@$ret0@0@@22)) (and (=> (= (ControlFlow 0 203198) 203214) inline$$DesignatedDealer_update_tier_$def_verify$0$anon143_Then_correct) (=> (= (ControlFlow 0 203198) 203204) inline$$DesignatedDealer_update_tier_$def_verify$0$anon143_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$anon0_correct@@1  (and (=> (= (ControlFlow 0 203188) (- 0 268687)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 203188) (- 0 268708)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@3) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@3 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@3)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@3) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@3 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@3)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@1) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@1))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@1)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@4) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@4 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@4)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@4) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@4 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@4)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@1) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@1))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@1))))))))))))))))))))) (=> (= (ControlFlow 0 203188) 203198) inline$$DesignatedDealer_update_tier_$def_verify$0$anon142_Else$1_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$Entry_correct@@1  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 203040) 203188)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon142_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$1$dst@1@@0)) (= (ControlFlow 0 203192) 203040)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$Entry_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon93_correct  (=> (and (= $abort_code@19@@1 $abort_code@16@@1) (= (ControlFlow 0 202322) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon145_Else_correct  (=> (and (not true) (= (ControlFlow 0 202320) 202322)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon93_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon145_Then_correct  (=> (= (ControlFlow 0 202330) 202322) inline$$DesignatedDealer_update_tier_$def_verify$0$anon93_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon144_Then_correct  (=> $abort_flag@13@@1 (and (=> (= (ControlFlow 0 202314) 202330) inline$$DesignatedDealer_update_tier_$def_verify$0$anon145_Then_correct) (=> (= (ControlFlow 0 202314) 202320) inline$$DesignatedDealer_update_tier_$def_verify$0$anon145_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$anon3_Then$1_correct  (=> (= $abort_code@16@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@13@@1 true) (= inline$$Vector_borrow_mut$0$dst@2 inline$$Vector_borrow_mut$0$dst@0)) (and (=> (= (ControlFlow 0 200994) 202314) inline$$DesignatedDealer_update_tier_$def_verify$0$anon144_Then_correct) (=> (= (ControlFlow 0 200994) 201067) inline$$DesignatedDealer_update_tier_$def_verify$0$anon144_Else_correct))))))
(let ((inline$$Vector_borrow_mut$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow_mut$0$i_ind@1 0) (>= inline$$Vector_borrow_mut$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1)))) (= (ControlFlow 0 200992) 200994)) inline$$Vector_borrow_mut$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow_mut$0$anon3_Else_correct  (=> (not (or (< inline$$Vector_borrow_mut$0$i_ind@1 0) (>= inline$$Vector_borrow_mut$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1))))) (=> (and (and (= inline$$Vector_borrow_mut$0$dst@1 ($Mutation ($Local 0) ($Path (|Store_[$int]$int| (|p#$Path| $EmptyPath) 0 inline$$Vector_borrow_mut$0$i_ind@1) 1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1)) inline$$Vector_borrow_mut$0$i_ind@1))) (= $abort_code@16@@1 $abort_code@15@@1)) (and (= $abort_flag@13@@1 $abort_flag@12@@1) (= inline$$Vector_borrow_mut$0$dst@2 inline$$Vector_borrow_mut$0$dst@1))) (and (=> (= (ControlFlow 0 200934) 202314) inline$$DesignatedDealer_update_tier_$def_verify$0$anon144_Then_correct) (=> (= (ControlFlow 0 200934) 201067) inline$$DesignatedDealer_update_tier_$def_verify$0$anon144_Else_correct))))))
(let ((inline$$Vector_borrow_mut$0$anon0_correct  (=> (and (= inline$$Vector_borrow_mut$0$i_ind@1 (|i#$Integer| tier_index@@0)) ((_ is $Vector) inline$$ReadRef$2$v@1@@1)) (and (=> (= (ControlFlow 0 200886) 200992) inline$$Vector_borrow_mut$0$anon3_Then_correct) (=> (= (ControlFlow 0 200886) 200934) inline$$Vector_borrow_mut$0$anon3_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$Entry_correct  (=> (= inline$$Vector_borrow_mut$0$ta@0 $IntegerType) (and (=> (= (ControlFlow 0 200876) (- 0 267831)) true) (=> (= (ControlFlow 0 200876) 200886) inline$$Vector_borrow_mut$0$anon0_correct)))))
(let ((inline$$ReadRef$2$anon0_correct@@1  (=> (and (= inline$$ReadRef$2$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= (ControlFlow 0 200733) 200876)) inline$$Vector_borrow_mut$0$Entry_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon142_Then_correct  (=> (and (and (|b#$Boolean| inline$$Gt$1$dst@1@@0) (= $abort_flag@12@@1 $abort_flag@11@@1)) (and (= $abort_code@15@@1 $abort_code@14@@2) (= (ControlFlow 0 203220) 200733))) inline$$ReadRef$2$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon140_Else_correct  (=> (not $abort_flag@11@@1) (and (=> (= (ControlFlow 0 202859) 203220) inline$$DesignatedDealer_update_tier_$def_verify$0$anon142_Then_correct) (=> (= (ControlFlow 0 202859) 203192) inline$$DesignatedDealer_update_tier_$def_verify$0$anon142_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon138_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t53@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11@@1)) (and (=> $abort_flag@11@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@11@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@22 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@22) (>= (|i#$Integer| call3formal@$ret0@0@@22) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@22) $MAX_U64))) (and (=> (= (ControlFlow 0 202853) 203224) inline$$DesignatedDealer_update_tier_$def_verify$0$anon140_Then_correct) (=> (= (ControlFlow 0 202853) 202859) inline$$DesignatedDealer_update_tier_$def_verify$0$anon140_Else_correct)))))
(let ((inline$$Gt$1$anon0_correct@@0  (=> (and (= inline$$Gt$1$dst@1@@0 ($Boolean (> (|i#$Integer| new_upperbound) (|i#$Integer| inline$$Vector_borrow$1$dst@2)))) (= (ControlFlow 0 202841) 202853)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon138_Else$1_correct)))
(let ((inline$$Gt$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 202827) (- 0 267682)) true) (=> (= (ControlFlow 0 202827) 202841) inline$$Gt$1$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon138_Else_correct  (=> (and (not $abort_flag@10@@1) (= (ControlFlow 0 202847) 202827)) inline$$Gt$1$Entry_correct@@0)))
(let ((inline$$Vector_borrow$1$anon3_Then$1_correct  (=> (= $abort_code@13@@2 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@10@@1 true) (= inline$$Vector_borrow$1$dst@2 inline$$Vector_borrow$1$dst@0)) (and (=> (= (ControlFlow 0 202771) 203244) inline$$DesignatedDealer_update_tier_$def_verify$0$anon138_Then_correct) (=> (= (ControlFlow 0 202771) 202847) inline$$DesignatedDealer_update_tier_$def_verify$0$anon138_Else_correct))))))
(let ((inline$$Vector_borrow$1$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$1$i_ind@1 0) (>= inline$$Vector_borrow$1$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@0)))) (= (ControlFlow 0 202769) 202771)) inline$$Vector_borrow$1$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$1$anon3_Else_correct  (=> (not (or (< inline$$Vector_borrow$1$i_ind@1 0) (>= inline$$Vector_borrow$1$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@0))))) (=> (and (and (= inline$$Vector_borrow$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1@@0)) inline$$Vector_borrow$1$i_ind@1)) (= $abort_code@13@@2 $abort_code@12@@2)) (and (= $abort_flag@10@@1 $abort_flag@9@@2) (= inline$$Vector_borrow$1$dst@2 inline$$Vector_borrow$1$dst@1))) (and (=> (= (ControlFlow 0 202711) 203244) inline$$DesignatedDealer_update_tier_$def_verify$0$anon138_Then_correct) (=> (= (ControlFlow 0 202711) 202847) inline$$DesignatedDealer_update_tier_$def_verify$0$anon138_Else_correct))))))
(let ((inline$$Vector_borrow$1$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$3$v@1@@0) (=> (and ((_ is $Integer) inline$$Sub$0$dst@2@@2) (= inline$$Vector_borrow$1$i_ind@1 (|i#$Integer| inline$$Sub$0$dst@2@@2))) (and (=> (= (ControlFlow 0 202685) 202769) inline$$Vector_borrow$1$anon3_Then_correct) (=> (= (ControlFlow 0 202685) 202711) inline$$Vector_borrow$1$anon3_Else_correct))))))
(let ((inline$$Vector_borrow$1$Entry_correct  (=> (and (= inline$$Vector_borrow$1$ta@0 $IntegerType) (= (ControlFlow 0 202671) 202685)) inline$$Vector_borrow$1$anon0_correct)))
(let ((inline$$ReadRef$3$anon0_correct@@0  (=> (and (= inline$$ReadRef$3$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= (ControlFlow 0 202555) 202671)) inline$$Vector_borrow$1$Entry_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon137_Else_correct  (=> (and (not true) (= (ControlFlow 0 202523) 202555)) inline$$ReadRef$3$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon137_Then_correct  (=> (= (ControlFlow 0 203268) 202555) inline$$ReadRef$3$anon0_correct@@0)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon135_Else_correct  (=> (not $abort_flag@9@@2) (and (=> (= (ControlFlow 0 202517) 203268) inline$$DesignatedDealer_update_tier_$def_verify$0$anon137_Then_correct) (=> (= (ControlFlow 0 202517) 202523) inline$$DesignatedDealer_update_tier_$def_verify$0$anon137_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@9@@2 true) (=> (and (= $abort_code@12@@2 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2@@2 inline$$Sub$0$dst@0@@2)) (and (=> (= (ControlFlow 0 202503) 203272) inline$$DesignatedDealer_update_tier_$def_verify$0$anon135_Then_correct) (=> (= (ControlFlow 0 202503) 202517) inline$$DesignatedDealer_update_tier_$def_verify$0$anon135_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@2  (=> (and (< (|i#$Integer| tier_index@@0) (|i#$Integer| inline$$DesignatedDealer_update_tier_$def_verify$0$$t49@1)) (= (ControlFlow 0 202501) 202503)) inline$$Sub$0$anon3_Then$1_correct@@2)))
(let ((inline$$Sub$0$anon3_Else_correct@@2  (=> (<= (|i#$Integer| inline$$DesignatedDealer_update_tier_$def_verify$0$$t49@1) (|i#$Integer| tier_index@@0)) (=> (and (and (= inline$$Sub$0$dst@1@@2 ($Integer (- (|i#$Integer| tier_index@@0) (|i#$Integer| inline$$DesignatedDealer_update_tier_$def_verify$0$$t49@1)))) (= $abort_flag@9@@2 $abort_flag@8@@3)) (and (= $abort_code@12@@2 $abort_code@11@@3) (= inline$$Sub$0$dst@2@@2 inline$$Sub$0$dst@1@@2))) (and (=> (= (ControlFlow 0 202449) 203272) inline$$DesignatedDealer_update_tier_$def_verify$0$anon135_Then_correct) (=> (= (ControlFlow 0 202449) 202517) inline$$DesignatedDealer_update_tier_$def_verify$0$anon135_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 202423) (- 0 267449)) true) (and (=> (= (ControlFlow 0 202423) 202501) inline$$Sub$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 202423) 202449) inline$$Sub$0$anon3_Else_correct@@2)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon134_Then_correct  (=> (|b#$Boolean| |inline$$DesignatedDealer_update_tier_$def_verify$0$tmp#$19@1|) (=> (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t49@1 ($Integer 1)) (= (ControlFlow 0 202509) 202423)) inline$$Sub$0$Entry_correct@@2))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon134_Else_correct  (=> (and (and (not (|b#$Boolean| |inline$$DesignatedDealer_update_tier_$def_verify$0$tmp#$19@1|)) (= $abort_flag@12@@1 $abort_flag@8@@3)) (and (= $abort_code@15@@1 $abort_code@11@@3) (= (ControlFlow 0 200667) 200733))) inline$$ReadRef$2$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon68_correct  (=> (= |inline$$DesignatedDealer_update_tier_$def_verify$0$tmp#$19@1| inline$$Gt$2$dst@1) (and (=> (= (ControlFlow 0 203378) 202509) inline$$DesignatedDealer_update_tier_$def_verify$0$anon134_Then_correct) (=> (= (ControlFlow 0 203378) 200667) inline$$DesignatedDealer_update_tier_$def_verify$0$anon134_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon132_Else_correct  (=> (and (not true) (= (ControlFlow 0 203376) 203378)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon68_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon132_Then_correct  (=> (= (ControlFlow 0 203386) 203378) inline$$DesignatedDealer_update_tier_$def_verify$0$anon68_correct)))
(let ((inline$$Gt$2$anon0_correct  (=> (= inline$$Gt$2$dst@1 ($Boolean (> (|i#$Integer| tier_index@@0) (|i#$Integer| inline$$DesignatedDealer_update_tier_$def_verify$0$$t47@1)))) (and (=> (= (ControlFlow 0 203362) 203386) inline$$DesignatedDealer_update_tier_$def_verify$0$anon132_Then_correct) (=> (= (ControlFlow 0 203362) 203376) inline$$DesignatedDealer_update_tier_$def_verify$0$anon132_Else_correct)))))
(let ((inline$$Gt$2$Entry_correct  (and (=> (= (ControlFlow 0 203348) (- 0 267384)) true) (=> (= (ControlFlow 0 203348) 203362) inline$$Gt$2$anon0_correct))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon131_Then_correct  (=> (|b#$Boolean| inline$$Gt$0$dst@1@@2) (=> (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t47@1 ($Integer 0)) (= (ControlFlow 0 203368) 203348)) inline$$Gt$2$Entry_correct))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon70_correct  (=> (= |inline$$DesignatedDealer_update_tier_$def_verify$0$tmp#$19@1| inline$$DesignatedDealer_update_tier_$def_verify$0$$t48@1) (and (=> (= (ControlFlow 0 200657) 202509) inline$$DesignatedDealer_update_tier_$def_verify$0$anon134_Then_correct) (=> (= (ControlFlow 0 200657) 200667) inline$$DesignatedDealer_update_tier_$def_verify$0$anon134_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon133_Else_correct  (=> (and (not true) (= (ControlFlow 0 200655) 200657)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon70_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon133_Then_correct  (=> (= (ControlFlow 0 203296) 200657) inline$$DesignatedDealer_update_tier_$def_verify$0$anon70_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon131_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1@@2)) (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t48@1 ($Boolean false))) (and (=> (= (ControlFlow 0 200647) 203296) inline$$DesignatedDealer_update_tier_$def_verify$0$anon133_Then_correct) (=> (= (ControlFlow 0 200647) 200655) inline$$DesignatedDealer_update_tier_$def_verify$0$anon133_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct@@2  (=> (= inline$$Gt$0$dst@1@@2 ($Boolean (> (|i#$Integer| inline$$Vector_borrow$0$dst@2@@1) (|i#$Integer| new_upperbound)))) (and (=> (= (ControlFlow 0 200595) 203368) inline$$DesignatedDealer_update_tier_$def_verify$0$anon131_Then_correct) (=> (= (ControlFlow 0 200595) 200647) inline$$DesignatedDealer_update_tier_$def_verify$0$anon131_Else_correct)))))
(let ((inline$$Gt$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 200581) (- 0 267309)) true) (=> (= (ControlFlow 0 200581) 200595) inline$$Gt$0$anon0_correct@@2))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon129_Then_correct  (=> (and (and (|b#$Boolean| inline$$Lt$3$dst@1) (= $abort_code@11@@3 $abort_code@10@@3)) (and (= $abort_flag@8@@3 $abort_flag@7@@3) (= (ControlFlow 0 204370) 200581))) inline$$Gt$0$Entry_correct@@2)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon127_Else_correct  (=> (not $abort_flag@7@@3) (and (=> (= (ControlFlow 0 204009) 204370) inline$$DesignatedDealer_update_tier_$def_verify$0$anon129_Then_correct) (=> (= (ControlFlow 0 204009) 204342) inline$$DesignatedDealer_update_tier_$def_verify$0$anon129_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon125_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t44@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7@@3)) (and (=> $abort_flag@7@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@7@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@21 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@21) (>= (|i#$Integer| call3formal@$ret0@0@@21) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@21) $MAX_U64))) (and (=> (= (ControlFlow 0 204003) 204374) inline$$DesignatedDealer_update_tier_$def_verify$0$anon127_Then_correct) (=> (= (ControlFlow 0 204003) 204009) inline$$DesignatedDealer_update_tier_$def_verify$0$anon127_Else_correct)))))
(let ((inline$$Lt$3$anon0_correct  (=> (and (= inline$$Lt$3$dst@1 ($Boolean (< (|i#$Integer| new_upperbound) (|i#$Integer| inline$$Vector_borrow$2$dst@2)))) (= (ControlFlow 0 203991) 204003)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon125_Else$1_correct)))
(let ((inline$$Lt$3$Entry_correct  (and (=> (= (ControlFlow 0 203977) (- 0 267187)) true) (=> (= (ControlFlow 0 203977) 203991) inline$$Lt$3$anon0_correct))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon125_Else_correct  (=> (and (not $abort_flag@6@@3) (= (ControlFlow 0 203997) 203977)) inline$$Lt$3$Entry_correct)))
(let ((inline$$Vector_borrow$2$anon3_Then$1_correct  (=> (= $abort_code@9@@3 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@6@@3 true) (= inline$$Vector_borrow$2$dst@2 inline$$Vector_borrow$2$dst@0)) (and (=> (= (ControlFlow 0 203921) 204394) inline$$DesignatedDealer_update_tier_$def_verify$0$anon125_Then_correct) (=> (= (ControlFlow 0 203921) 203997) inline$$DesignatedDealer_update_tier_$def_verify$0$anon125_Else_correct))))))
(let ((inline$$Vector_borrow$2$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$2$i_ind@1 0) (>= inline$$Vector_borrow$2$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)))) (= (ControlFlow 0 203919) 203921)) inline$$Vector_borrow$2$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$2$anon3_Else_correct  (=> (not (or (< inline$$Vector_borrow$2$i_ind@1 0) (>= inline$$Vector_borrow$2$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1))))) (=> (and (and (= inline$$Vector_borrow$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) inline$$Vector_borrow$2$i_ind@1)) (= $abort_code@9@@3 $abort_code@8@@3)) (and (= $abort_flag@6@@3 $abort_flag@5@@3) (= inline$$Vector_borrow$2$dst@2 inline$$Vector_borrow$2$dst@1))) (and (=> (= (ControlFlow 0 203861) 204394) inline$$DesignatedDealer_update_tier_$def_verify$0$anon125_Then_correct) (=> (= (ControlFlow 0 203861) 203997) inline$$DesignatedDealer_update_tier_$def_verify$0$anon125_Else_correct))))))
(let ((inline$$Vector_borrow$2$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$4$v@1) (=> (and ((_ is $Integer) inline$$AddU64$0$dst@2@@1) (= inline$$Vector_borrow$2$i_ind@1 (|i#$Integer| inline$$AddU64$0$dst@2@@1))) (and (=> (= (ControlFlow 0 203835) 203919) inline$$Vector_borrow$2$anon3_Then_correct) (=> (= (ControlFlow 0 203835) 203861) inline$$Vector_borrow$2$anon3_Else_correct))))))
(let ((inline$$Vector_borrow$2$Entry_correct  (=> (and (= inline$$Vector_borrow$2$ta@0 $IntegerType) (= (ControlFlow 0 203821) 203835)) inline$$Vector_borrow$2$anon0_correct)))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= (ControlFlow 0 203705) 203821)) inline$$Vector_borrow$2$Entry_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon124_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$2$dst@1) (= (ControlFlow 0 203711) 203705)) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon124_Else_correct  (=> (and (and (not (|b#$Boolean| inline$$Lt$2$dst@1)) (= $abort_code@11@@3 $abort_code@8@@3)) (and (= $abort_flag@8@@3 $abort_flag@5@@3) (= (ControlFlow 0 203669) 200581))) inline$$Gt$0$Entry_correct@@2)))
(let ((inline$$Lt$2$anon0_correct  (=> (= inline$$Lt$2$dst@1 ($Boolean (< (|i#$Integer| inline$$AddU64$0$dst@2@@1) (|i#$Integer| inline$$Vector_length$0$l@1@@1)))) (and (=> (= (ControlFlow 0 203653) 203711) inline$$DesignatedDealer_update_tier_$def_verify$0$anon124_Then_correct) (=> (= (ControlFlow 0 203653) 203669) inline$$DesignatedDealer_update_tier_$def_verify$0$anon124_Else_correct)))))
(let ((inline$$Lt$2$Entry_correct  (and (=> (= (ControlFlow 0 203639) (- 0 267018)) true) (=> (= (ControlFlow 0 203639) 203653) inline$$Lt$2$anon0_correct))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon123_Else_correct  (=> (and (not true) (= (ControlFlow 0 203595) 203639)) inline$$Lt$2$Entry_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon123_Then_correct  (=> (= (ControlFlow 0 204418) 203639) inline$$Lt$2$Entry_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon121_Else_correct  (=> (not $abort_flag@5@@3) (and (=> (= (ControlFlow 0 203589) 204418) inline$$DesignatedDealer_update_tier_$def_verify$0$anon123_Then_correct) (=> (= (ControlFlow 0 203589) 203595) inline$$DesignatedDealer_update_tier_$def_verify$0$anon123_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@5@@3 true) (=> (and (= $abort_code@8@@3 $EXEC_FAILURE_CODE) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 203575) 204422) inline$$DesignatedDealer_update_tier_$def_verify$0$anon121_Then_correct) (=> (= (ControlFlow 0 203575) 203589) inline$$DesignatedDealer_update_tier_$def_verify$0$anon121_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| tier_index@@0) (|i#$Integer| inline$$DesignatedDealer_update_tier_$def_verify$0$$t39@1)) $MAX_U64) (= (ControlFlow 0 203573) 203575)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (>= $MAX_U64 (+ (|i#$Integer| tier_index@@0) (|i#$Integer| inline$$DesignatedDealer_update_tier_$def_verify$0$$t39@1))) (=> (and (and (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| tier_index@@0) (|i#$Integer| inline$$DesignatedDealer_update_tier_$def_verify$0$$t39@1)))) (= $abort_flag@5@@3 $abort_flag@4@@3)) (and (= $abort_code@8@@3 $abort_code@7@@3) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 203517) 204422) inline$$DesignatedDealer_update_tier_$def_verify$0$anon121_Then_correct) (=> (= (ControlFlow 0 203517) 203589) inline$$DesignatedDealer_update_tier_$def_verify$0$anon121_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 203487) (- 0 266911)) true) (and (=> (= (ControlFlow 0 203487) 203573) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 203487) 203517) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon120_Then_correct  (=> (|b#$Boolean| inline$$Lt$1$dst@1) (=> (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t39@1 ($Integer 1)) (= (ControlFlow 0 203581) 203487)) inline$$AddU64$0$Entry_correct@@1))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon120_Else_correct  (=> (and (and (not (|b#$Boolean| inline$$Lt$1$dst@1)) (= $abort_code@11@@3 $abort_code@7@@3)) (and (= $abort_flag@8@@3 $abort_flag@4@@3) (= (ControlFlow 0 200537) 200581))) inline$$Gt$0$Entry_correct@@2)))
(let ((inline$$Lt$1$anon0_correct  (=> (= inline$$Lt$1$dst@1 ($Boolean (< (|i#$Integer| inline$$Vector_borrow$0$dst@2@@1) (|i#$Integer| new_upperbound)))) (and (=> (= (ControlFlow 0 200521) 203581) inline$$DesignatedDealer_update_tier_$def_verify$0$anon120_Then_correct) (=> (= (ControlFlow 0 200521) 200537) inline$$DesignatedDealer_update_tier_$def_verify$0$anon120_Else_correct)))))
(let ((inline$$Lt$1$Entry_correct  (and (=> (= (ControlFlow 0 200507) (- 0 266866)) true) (=> (= (ControlFlow 0 200507) 200521) inline$$Lt$1$anon0_correct))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon119_Else_correct  (=> (and (not (|b#$Boolean| inline$$DesignatedDealer_update_tier_$def_verify$0$$t37@1)) (= (ControlFlow 0 200527) 200507)) inline$$Lt$1$Entry_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon117_Else_correct  (=> (and (not $abort_flag@4@@3) (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t37@1 ($Boolean ($IsEqual_stratified inline$$Vector_borrow$0$dst@2@@1 new_upperbound)))) (and (=> (= (ControlFlow 0 200457) 204769) inline$$DesignatedDealer_update_tier_$def_verify$0$anon119_Then_correct) (=> (= (ControlFlow 0 200457) 200527) inline$$DesignatedDealer_update_tier_$def_verify$0$anon119_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@1  (=> (= $abort_code@7@@3 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4@@3 true) (= inline$$Vector_borrow$0$dst@2@@1 inline$$Vector_borrow$0$dst@0@@1)) (and (=> (= (ControlFlow 0 200435) 204775) inline$$DesignatedDealer_update_tier_$def_verify$0$anon117_Then_correct) (=> (= (ControlFlow 0 200435) 200457) inline$$DesignatedDealer_update_tier_$def_verify$0$anon117_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@1  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1@@1 0) (>= inline$$Vector_borrow$0$i_ind@1@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@1)))) (= (ControlFlow 0 200433) 200435)) inline$$Vector_borrow$0$anon3_Then$1_correct@@1)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@1  (=> (not (or (< inline$$Vector_borrow$0$i_ind@1@@1 0) (>= inline$$Vector_borrow$0$i_ind@1@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@1))))) (=> (and (and (= inline$$Vector_borrow$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@1)) inline$$Vector_borrow$0$i_ind@1@@1)) (= $abort_code@7@@3 $abort_code@5@@4)) (and (= $abort_flag@4@@3 $abort_flag@3@@4) (= inline$$Vector_borrow$0$dst@2@@1 inline$$Vector_borrow$0$dst@1@@1))) (and (=> (= (ControlFlow 0 200375) 204775) inline$$DesignatedDealer_update_tier_$def_verify$0$anon117_Then_correct) (=> (= (ControlFlow 0 200375) 200457) inline$$DesignatedDealer_update_tier_$def_verify$0$anon117_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon0_correct@@1  (=> ((_ is $Vector) inline$$ReadRef$1$v@1@@1) (=> (and ((_ is $Integer) tier_index@@0) (= inline$$Vector_borrow$0$i_ind@1@@1 (|i#$Integer| tier_index@@0))) (and (=> (= (ControlFlow 0 200349) 200433) inline$$Vector_borrow$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 200349) 200375) inline$$Vector_borrow$0$anon3_Else_correct@@1))))))
(let ((inline$$Vector_borrow$0$Entry_correct@@1  (=> (and (= inline$$Vector_borrow$0$ta@0@@1 $IntegerType) (= (ControlFlow 0 200335) 200349)) inline$$Vector_borrow$0$anon0_correct@@1)))
(let ((inline$$ReadRef$1$anon0_correct@@1  (=> (and (= inline$$ReadRef$1$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= (ControlFlow 0 200219) 200335)) inline$$Vector_borrow$0$Entry_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon115_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@1@@1) (= (ControlFlow 0 200225) 200219)) inline$$ReadRef$1$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon36_correct  (=> (and (= $abort_code@19@@1 $abort_code@6@@3) (= (ControlFlow 0 200175) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon116_Else_correct  (=> (and (not true) (= (ControlFlow 0 200173) 200175)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon36_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon116_Then_correct  (=> (= (ControlFlow 0 200183) 200175) inline$$DesignatedDealer_update_tier_$def_verify$0$anon36_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon115_Else$1_correct  (=> (= $abort_code@6@@3 (|i#$Integer| call3formal@$ret0@0@@23)) (and (=> (= (ControlFlow 0 200167) 200183) inline$$DesignatedDealer_update_tier_$def_verify$0$anon116_Then_correct) (=> (= (ControlFlow 0 200167) 200173) inline$$DesignatedDealer_update_tier_$def_verify$0$anon116_Else_correct)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$anon0_correct@@1  (and (=> (= (ControlFlow 0 200157) (- 0 266547)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 200157) (- 0 266568)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@3) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@3 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@3)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@3) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@3 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@3)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@1) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@1))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@1)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@4) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@4 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@4)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@4) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@4 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@4)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@1) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@1))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@1))))))))))))))))))))) (=> (= (ControlFlow 0 200157) 200167) inline$$DesignatedDealer_update_tier_$def_verify$0$anon115_Else$1_correct)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$Entry_correct@@1  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 200009) 200157)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon115_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1@@1)) (= (ControlFlow 0 200161) 200009)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon113_Else_correct  (=> (not $abort_flag@3@@4) (and (=> (= (ControlFlow 0 199828) 200225) inline$$DesignatedDealer_update_tier_$def_verify$0$anon115_Then_correct) (=> (= (ControlFlow 0 199828) 200161) inline$$DesignatedDealer_update_tier_$def_verify$0$anon115_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon111_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t34@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@4)) (and (=> $abort_flag@3@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@23 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@23) (>= (|i#$Integer| call3formal@$ret0@0@@23) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@23) $MAX_U64))) (and (=> (= (ControlFlow 0 199822) 204795) inline$$DesignatedDealer_update_tier_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 199822) 199828) inline$$DesignatedDealer_update_tier_$def_verify$0$anon113_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct@@1  (=> (and (= inline$$Lt$0$dst@1@@1 ($Boolean (< (|i#$Integer| tier_index@@0) (|i#$Integer| inline$$Vector_length$0$l@1@@1)))) (= (ControlFlow 0 199810) 199822)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon111_Else$1_correct)))
(let ((inline$$Lt$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 199796) (- 0 266437)) true) (=> (= (ControlFlow 0 199796) 199810) inline$$Lt$0$anon0_correct@@1))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon111_Else_correct  (=> (and (not $abort_flag@2@@4) (= (ControlFlow 0 199816) 199796)) inline$$Lt$0$Entry_correct@@1)))
(let ((inline$$Vector_length$0$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@2) (= inline$$Vector_length$0$l@1@@1 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2))))) (and (=> (= (ControlFlow 0 199740) 204815) inline$$DesignatedDealer_update_tier_$def_verify$0$anon111_Then_correct) (=> (= (ControlFlow 0 199740) 199816) inline$$DesignatedDealer_update_tier_$def_verify$0$anon111_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@1  (=> (and (= inline$$Vector_length$0$ta@0@@1 $IntegerType) (= (ControlFlow 0 199728) 199740)) inline$$Vector_length$0$anon0_correct@@1)))
(let ((inline$$ReadRef$0$anon0_correct@@2  (=> (and (= inline$$ReadRef$0$v@1@@2 (|v#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= (ControlFlow 0 199683) 199728)) inline$$Vector_length$0$Entry_correct@@1)))
(let ((inline$$BorrowField$0$anon0_correct@@2  (=> (= inline$$BorrowField$0$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@2 (|size#$Path| inline$$BorrowField$0$p@1@@2)) (= inline$$BorrowField$0$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@2) inline$$BorrowField$0$size@1@@2 $DesignatedDealer_TierInfo_tiers) (+ inline$$BorrowField$0$size@1@@2 1)))) (and (= inline$$BorrowField$0$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$0$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $DesignatedDealer_TierInfo_tiers))) (= (ControlFlow 0 199645) 199683))) inline$$ReadRef$0$anon0_correct@@2))))
(let ((inline$$DesignatedDealer_TierInfo_$unpack_ref$0$anon0_correct@@1  (=> (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@7 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@8 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@7)) $i_0@@8) (< $i_0@@8 (|i#$Integer| (|ub#$Range| $range_1@@7)))) (let ((i@@18 ($Integer $i_0@@8)))
(|b#$Boolean| ($Boolean (let (($range_3@@7 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@8 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@7)) $i_2@@8) (< $i_2@@8 (|i#$Integer| (|ub#$Range| $range_3@@7)))) (let ((j@@9 ($Integer $i_2@@8)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@18) (|i#$Integer| j@@9)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@18))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@9)))))))))))))))))))))) (= (ControlFlow 0 199523) 199645)) inline$$BorrowField$0$anon0_correct@@2)))
(let ((inline$$DesignatedDealer_TierInfo_$unpack_ref$0$Entry_correct@@1  (=> (and (= inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 199517) 199523)) inline$$DesignatedDealer_TierInfo_$unpack_ref$0$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon109_Else_correct  (=> (and (not $abort_flag@2@@4) (= (ControlFlow 0 199527) 199517)) inline$$DesignatedDealer_TierInfo_$unpack_ref$0$Entry_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@2@@4 true) (=> (and (= $abort_code@4@@4 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 199477) 204835) inline$$DesignatedDealer_update_tier_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 199477) 199527) inline$$DesignatedDealer_update_tier_$def_verify$0$anon109_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 199475) 199477)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1))) (= $abort_flag@2@@4 $abort_flag@1@@4)) (and (= $abort_code@4@@4 $abort_code@2@@4) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 199423) 204835) inline$$DesignatedDealer_update_tier_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 199423) 199527) inline$$DesignatedDealer_update_tier_$def_verify$0$anon109_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| dd_addr@@2)) (and (=> (= (ControlFlow 0 199393) 199475) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 199393) 199423) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (=> (= inline$$BorrowGlobal$0$ta@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1)) (and (=> (= (ControlFlow 0 199387) (- 0 266201)) true) (=> (= (ControlFlow 0 199387) 199393) inline$$BorrowGlobal$0$anon0_correct@@1)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon107_Then_correct  (=> (|b#$Boolean| inline$$DesignatedDealer_update_tier_$def_verify$0$$t28@1) (and (=> (= (ControlFlow 0 199483) (- 0 266133)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_update_tier_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_update_tier_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)) (=> (= (ControlFlow 0 199483) 199387) inline$$BorrowGlobal$0$Entry_correct@@1))))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon20_correct  (=> (and (= $abort_code@19@@1 $abort_code@3@@4) (= (ControlFlow 0 199236) 199240)) inline$$DesignatedDealer_update_tier_$def_verify$0$Abort_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon108_Else_correct  (=> (and (not true) (= (ControlFlow 0 199234) 199236)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon20_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon108_Then_correct  (=> (= (ControlFlow 0 199248) 199236) inline$$DesignatedDealer_update_tier_$def_verify$0$anon20_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon107_Else_correct  (=> (and (not (|b#$Boolean| inline$$DesignatedDealer_update_tier_$def_verify$0$$t28@1)) (= $abort_code@3@@4 (|i#$Integer| call3formal@$ret0@0@@24))) (and (=> (= (ControlFlow 0 199228) 199248) inline$$DesignatedDealer_update_tier_$def_verify$0$anon108_Then_correct) (=> (= (ControlFlow 0 199228) 199234) inline$$DesignatedDealer_update_tier_$def_verify$0$anon108_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon105_Else_correct  (=> (not $abort_flag@1@@4) (and (=> (= (ControlFlow 0 199216) 199483) inline$$DesignatedDealer_update_tier_$def_verify$0$anon107_Then_correct) (=> (= (ControlFlow 0 199216) 199228) inline$$DesignatedDealer_update_tier_$def_verify$0$anon107_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon103_Else_correct  (=> (and (not $abort_flag@0@@4) (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t28@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2))))) (=> (and (and (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$t29@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@4)) (and (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@24 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@24) (>= (|i#$Integer| call3formal@$ret0@0@@24) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@24) $MAX_U64))) (and (=> (= (ControlFlow 0 199210) 204855) inline$$DesignatedDealer_update_tier_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 199210) 199216) inline$$DesignatedDealer_update_tier_$def_verify$0$anon105_Else_correct))))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon8$4_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) $abort_flag@0@@4) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) $abort_flag@0@@4)) (and (=> $abort_flag@0@@4 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))))) (=> $abort_flag@0@@4 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 199180) 204875) inline$$DesignatedDealer_update_tier_$def_verify$0$anon103_Then_correct) (=> (= (ControlFlow 0 199180) 199210) inline$$DesignatedDealer_update_tier_$def_verify$0$anon103_Else_correct))))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon8_correct  (=> (and (= inline$$DesignatedDealer_update_tier_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2) true)) (= (ControlFlow 0 199076) 199180)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon8$4_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon102_Else_correct  (=> (and (not true) (= (ControlFlow 0 199016) 199076)) inline$$DesignatedDealer_update_tier_$def_verify$0$anon8_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon102_Then_correct  (=> (= (ControlFlow 0 204899) 199076) inline$$DesignatedDealer_update_tier_$def_verify$0$anon8_correct)))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon101_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 199008) 204899) inline$$DesignatedDealer_update_tier_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 199008) 199016) inline$$DesignatedDealer_update_tier_$def_verify$0$anon102_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon101_Then_correct  (and (=> (= (ControlFlow 0 204907) 204899) inline$$DesignatedDealer_update_tier_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 204907) 199016) inline$$DesignatedDealer_update_tier_$def_verify$0$anon102_Else_correct))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon100_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 199000) 204907) inline$$DesignatedDealer_update_tier_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 199000) 199008) inline$$DesignatedDealer_update_tier_$def_verify$0$anon101_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon100_Then_correct  (and (=> (= (ControlFlow 0 204915) 204907) inline$$DesignatedDealer_update_tier_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 204915) 199008) inline$$DesignatedDealer_update_tier_$def_verify$0$anon101_Else_correct))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon99_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 198992) 204915) inline$$DesignatedDealer_update_tier_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 198992) 199000) inline$$DesignatedDealer_update_tier_$def_verify$0$anon100_Else_correct)))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon99_Then_correct  (and (=> (= (ControlFlow 0 204923) 204915) inline$$DesignatedDealer_update_tier_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 204923) 199000) inline$$DesignatedDealer_update_tier_$def_verify$0$anon100_Else_correct))))
(let ((inline$$DesignatedDealer_update_tier_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 198986) 204923) inline$$DesignatedDealer_update_tier_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 198986) 198992) inline$$DesignatedDealer_update_tier_$def_verify$0$anon99_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (and (forall (($inv_addr@@22 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22)) (let ((va@@93 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))))
(let ((l@@93 (|l#$ValueArray| va@@93)))
 (and (and (<= 0 l@@93) (<= l@@93 $MAX_U64)) (forall ((x@@93 Int) ) (!  (=> (or (< x@@93 0) (>= x@@93 l@@93)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))
)) (forall (($inv_addr@@23 Int) ($inv_tv0@@10 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23)) (let ((va@@94 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))))
(let ((l@@94 (|l#$ValueArray| va@@94)))
 (and (and (<= 0 l@@94) (<= l@@94 $MAX_U64)) (forall ((x@@94 Int) ) (!  (=> (or (< x@@94 0) (>= x@@94 l@@94)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers)) (let ((va@@95 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@95 (|l#$ValueArray| va@@95)))
 (and (and (<= 0 l@@95) (<= l@@95 $MAX_U64)) (forall ((x@@95 Int) ) (!  (=> (or (< x@@95 0) (>= x@@95 l@@95)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95))
))))))) (forall (($$0@@30 Int) ) (!  (=> (and (>= $$0@@30 0) (< $$0@@30 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers))) $$0@@30)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers))) $$0@@30)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers))) $$0@@30)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers))) $$0@@30))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@8 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@9 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@8)) $i_0@@9) (< $i_0@@9 (|i#$Integer| (|ub#$Range| $range_1@@8)))) (let ((i@@19 ($Integer $i_0@@9)))
(|b#$Boolean| ($Boolean (let (($range_3@@8 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@9 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@8)) $i_2@@9) (< $i_2@@9 (|i#$Integer| (|ub#$Range| $range_3@@8)))) (let ((j@@10 ($Integer $i_2@@9)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@19) (|i#$Integer| j@@10)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@19))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@10))))))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@23))
))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@14 T@$Value) )  (=> ((_ is $Type) coin_type@@14) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@3 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@14)) 1) (|a#$Address| mint_cap_owner@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@3)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@15 T@$Value) )  (=> ((_ is $Type) coin_type@@15) (|b#$Boolean| ($Boolean (forall ((addr1@@7 T@$Value) )  (=> ((_ is $Address) addr1@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@15)) 1) (|a#$Address| addr1@@7)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@16 T@$Value) )  (=> ((_ is $Type) coin_type@@16) (|b#$Boolean| ($Boolean (forall ((addr1@@8 T@$Value) )  (=> ((_ is $Address) addr1@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@16)) 1) (|a#$Address| addr1@@8)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 204927) 198986))) inline$$DesignatedDealer_update_tier_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@5  (=> (and ((_ is $Address) tc_account@@3) ((_ is $Address) dd_addr@@2)) (=> (and (and ((_ is $Integer) tier_index@@0) (>= (|i#$Integer| tier_index@@0) 0)) (<= (|i#$Integer| tier_index@@0) $MAX_U64)) (=> (and (and (and ((_ is $Integer) new_upperbound) (>= (|i#$Integer| new_upperbound) 0)) (<= (|i#$Integer| new_upperbound) $MAX_U64)) (= (ControlFlow 0 197005) 204927)) anon0$1_correct@@5)))))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DesignatedDealer_TierInfo_$CallerDomain@@3 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| dd_addr@@2)) (= (ControlFlow 0 263105) 197005)) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_flag@2@@5 () Bool)
(declare-fun $abort_flag@3@@5 () Bool)
(declare-fun $abort_flag@4@@4 () Bool)
(declare-fun $abort_flag@5@@4 () Bool)
(declare-fun $abort_flag@6@@4 () Bool)
(declare-fun $abort_flag@7@@4 () Bool)
(declare-fun |inline$$WritebackToGlobal$3$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$3$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$3$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$3$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$3$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$3$m'@1@@0| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@1 () Int)
(declare-fun inline$$BorrowField$2$p@2@@1 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@2 () T@$Value)
(declare-fun amount@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@2 () T@$Value)
(declare-fun inline$$Le$1$dst@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@7@@4 () Int)
(declare-fun call3formal@$ret0@0@@25 () T@$Value)
(declare-fun inline$$WritebackToGlobal$2$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@1@@0| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2 () T@$Value)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$t28@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@3 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@3 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@2@@2 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@3 () T@$Value)
(declare-fun inline$$Le$0$dst@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@5@@5 () Int)
(declare-fun call3formal@$ret0@0@@26 () T@$Value)
(declare-fun inline$$WritebackToGlobal$1$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@0| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2 () T@$Value)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@0@@2 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1@@2 () Int)
(declare-fun inline$$ReadRef$2$v@1@@2 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1@@2 () T@$Value)
(declare-fun tier_index@@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0@@2 () T@$TypeValue)
(declare-fun inline$$Lt$0$dst@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@2| () T@$Memory)
(declare-fun $abort_code@3@@5 () Int)
(declare-fun call3formal@$ret0@0@@27 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@2 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@2 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@2 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@2| () T@$Memory)
(declare-fun inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2 () T@$Value)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@2 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0@@2 () T@$TypeValue)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@3 () Int)
(declare-fun inline$$BorrowField$0$p@2@@3 () T@$Path)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2@@2 () T@$Mutation)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@3 () T@$Value)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@2 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@2 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@2 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@2 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@2 () T@$Mutation)
(declare-fun dd_addr@@3 () T@$Value)
(declare-fun $tv0@@15 () T@$TypeValue)
(declare-fun inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DesignatedDealer_TierInfo_$CallerDomain@@4 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 270440) (let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon69_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon69_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon68_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 212575) 212591) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 212575) 212581) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon71_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon71_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon70_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 212555) 212571) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 212555) 212561) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon76_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon76_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon75_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 212509) 212525) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 212509) 212515) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon78_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon78_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon77_Then_correct  (=> $abort_flag@2@@5 (and (=> (= (ControlFlow 0 212489) 212505) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 212489) 212495) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon82_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon82_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon81_Then_correct  (=> $abort_flag@3@@5 (and (=> (= (ControlFlow 0 212469) 212485) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 212469) 212475) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon85_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon85_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon84_Then_correct  (=> $abort_flag@4@@4 (and (=> (= (ControlFlow 0 212441) 212457) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 212441) 212447) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon89_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon89_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon88_Then_correct  (=> $abort_flag@5@@4 (and (=> (= (ControlFlow 0 212421) 212437) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 212421) 212427) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon91_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon91_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon90_Then_correct  (=> $abort_flag@6@@4 (and (=> (= (ControlFlow 0 212401) 212417) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 212401) 212407) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon95_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon95_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon94_Then_correct  (=> $abort_flag@7@@4 (and (=> (= (ControlFlow 0 212381) 212397) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 212381) 212387) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon64$3_correct  (=> (= (ControlFlow 0 212367) (- 0 274579)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr))))))))))))))))))
(let ((inline$$WritebackToGlobal$3$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$3$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$3$m'@2@@0| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 212225) 212367)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon64$3_correct))))
(let ((inline$$WritebackToGlobal$3$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$3$l@1@@0) (=> (and (= inline$$WritebackToGlobal$3$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$3$l@1@@0)) (= inline$$WritebackToGlobal$3$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$3$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$3$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$3$ta@1@@0 inline$$WritebackToGlobal$3$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|))) (= |inline$$WritebackToGlobal$3$m'@1@@0| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$3$ta@1@@0 inline$$WritebackToGlobal$3$a@1@@0 inline$$WritebackToGlobal$3$v@1@@0)))) (and (= |inline$$WritebackToGlobal$3$m'@2@@0| |inline$$WritebackToGlobal$3$m'@1@@0|) (= (ControlFlow 0 212279) 212367))) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon64$3_correct)))))
(let ((inline$$WritebackToGlobal$3$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$3$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (and (=> (= (ControlFlow 0 212215) 212279) inline$$WritebackToGlobal$3$anon3_Then_correct@@0) (=> (= (ControlFlow 0 212215) 212225) inline$$WritebackToGlobal$3$anon3_Else_correct@@0)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$anon0_correct@@1  (and (=> (= (ControlFlow 0 212093) (- 0 274325)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 212093) (- 0 274346)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@3) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@3 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@3)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@3) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@3 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@3)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@1) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@1))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@1)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@4) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@4 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_9@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_8@@4)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@1)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@4) (< inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@4 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$range_11@@1)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@1 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$3$$i_10@@4)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@1) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$i@@1))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$3$j@@1))))))))))))))))))))) (=> (= (ControlFlow 0 212093) 212215) inline$$WritebackToGlobal$3$anon0_correct@@0)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$3$Entry_correct@@1  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$3$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (= (ControlFlow 0 211945) 212093)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@3| |inline$$WriteRef$0$to'@1@@3|) (= (ControlFlow 0 211708) 211945)) inline$$DesignatedDealer_TierInfo_$pack_ref$3$Entry_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3)) (= |inline$$WritebackToReference$0$dst'@1@@3| ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) inline$$WritebackToReference$0$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@2|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@3| |inline$$WritebackToReference$0$dst'@1@@3|) (= (ControlFlow 0 211764) 211945))) inline$$DesignatedDealer_TierInfo_$pack_ref$3$Entry_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (= inline$$WritebackToReference$0$dstPath@1@@3 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|))) (and (=> (= (ControlFlow 0 211672) 211764) inline$$WritebackToReference$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 211672) 211708) inline$$WritebackToReference$0$anon3_Else_correct@@3)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon96_Else_correct  (=> (and (not true) (= (ControlFlow 0 211535) 211672)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon96_Then_correct  (=> (and (= inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= (ControlFlow 0 212377) 211672)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$WriteRef$1$anon0_correct@@2  (=> (= |inline$$WriteRef$1$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@1) (|p#$Mutation| inline$$BorrowField$2$dst@1@@1) inline$$AddU64$0$dst@2@@2)) (and (=> (= (ControlFlow 0 211521) 212377) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 211521) 211535) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct@@1  (=> (= inline$$BorrowField$2$p@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (=> (and (and (= inline$$BorrowField$2$size@1@@1 (|size#$Path| inline$$BorrowField$2$p@1@@1)) (= inline$$BorrowField$2$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@1) inline$$BorrowField$2$size@1@@1 $DesignatedDealer_TierInfo_window_inflow) (+ inline$$BorrowField$2$size@1@@1 1)))) (and (= inline$$BorrowField$2$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) inline$$BorrowField$2$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))) $DesignatedDealer_TierInfo_window_inflow))) (= (ControlFlow 0 211462) 211521))) inline$$WriteRef$1$anon0_correct@@2))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon94_Else_correct  (=> (and (not $abort_flag@7@@4) (= (ControlFlow 0 211468) 211462)) inline$$BorrowField$2$anon0_correct@@1)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@7@@4 true) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@0@@2)) (and (=> (= (ControlFlow 0 211332) 212381) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 211332) 211468) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1@@2) (|i#$Integer| amount@@0)) $MAX_U64) (= (ControlFlow 0 211330) 211332)) inline$$AddU64$0$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$0$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1@@2) (|i#$Integer| amount@@0))) (= inline$$AddU64$0$dst@1@@2 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1@@2) (|i#$Integer| amount@@0))))) (and (= $abort_flag@7@@4 $abort_flag@6@@4) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@1@@2))) (and (=> (= (ControlFlow 0 211274) 212381) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 211274) 211468) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 211244) (- 0 273999)) true) (and (=> (= (ControlFlow 0 211244) 211330) inline$$AddU64$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 211244) 211274) inline$$AddU64$0$anon3_Else_correct@@2)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon92_Then_correct  (=> (and (|b#$Boolean| inline$$Le$1$dst@1@@0) (= (ControlFlow 0 211338) 211244)) inline$$AddU64$0$Entry_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon93_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon93_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon92_Else$2_correct  (and (=> (= (ControlFlow 0 211131) (- 0 273897)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@0)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@1))))))))))))))) (=> (= $abort_code@7@@4 (|i#$Integer| call3formal@$ret0@0@@25)) (and (=> (= (ControlFlow 0 211131) 211147) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 211131) 211137) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon93_Else_correct)))))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2@@0| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 210985) 211131)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon92_Else$2_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@0) (=> (and (= inline$$WritebackToGlobal$2$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$2$l@1@@0)) (= inline$$WritebackToGlobal$2$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$2$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@0 inline$$WritebackToGlobal$2$a@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))) (= |inline$$WritebackToGlobal$2$m'@1@@0| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@0 inline$$WritebackToGlobal$2$a@1@@0 inline$$WritebackToGlobal$2$v@1@@0)))) (and (= |inline$$WritebackToGlobal$2$m'@2@@0| |inline$$WritebackToGlobal$2$m'@1@@0|) (= (ControlFlow 0 211039) 211131))) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon92_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$2$l@1@@0 (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (and (=> (= (ControlFlow 0 210975) 211039) inline$$WritebackToGlobal$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 210975) 210985) inline$$WritebackToGlobal$2$anon3_Else_correct@@0)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$anon0_correct@@2  (and (=> (= (ControlFlow 0 210853) (- 0 273643)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 210853) (- 0 273664)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@5) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@5 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@5)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@5) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@5 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@5)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@2) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@2)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@2))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@6) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@6 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_9@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_8@@6)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@6) (< inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@6 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$range_11@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$2$$i_10@@6)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@2) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@2)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$i@@2))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$2$j@@2))))))))))))))))))))) (=> (= (ControlFlow 0 210853) 210975) inline$$WritebackToGlobal$2$anon0_correct@@0)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$2$Entry_correct@@2  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$2$$after@0@@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= (ControlFlow 0 210705) 210853)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$anon0_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon92_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$1$dst@1@@0)) (= (ControlFlow 0 210857) 210705)) inline$$DesignatedDealer_TierInfo_$pack_ref$2$Entry_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon90_Else_correct  (=> (not $abort_flag@6@@4) (and (=> (= (ControlFlow 0 210524) 211338) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 210524) 210857) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon88_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$t28@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@4)) (and (=> $abort_flag@6@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@25 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@25) (>= (|i#$Integer| call3formal@$ret0@0@@25) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@25) $MAX_U64))) (and (=> (= (ControlFlow 0 210518) 212401) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 210518) 210524) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$Le$1$anon0_correct@@0  (=> (and (= inline$$Le$1$dst@1@@0 ($Boolean (<= (|i#$Integer| inline$$ReadRef$1$v@1@@2) (|i#$Integer| inline$$Sub$0$dst@2@@3)))) (= (ControlFlow 0 210506) 210518)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon88_Else$1_correct)))
(let ((inline$$Le$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 210492) (- 0 273532)) true) (=> (= (ControlFlow 0 210492) 210506) inline$$Le$1$anon0_correct@@0))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon88_Else_correct  (=> (and (not $abort_flag@5@@4) (= (ControlFlow 0 210512) 210492)) inline$$Le$1$Entry_correct@@0)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@3  (=> (and (= $abort_flag@5@@4 true) (= inline$$Sub$0$dst@2@@3 inline$$Sub$0$dst@0@@3)) (and (=> (= (ControlFlow 0 210436) 212421) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 210436) 210512) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct@@3  (=> (and (< (|i#$Integer| inline$$Vector_borrow$0$dst@2@@2) (|i#$Integer| amount@@0)) (= (ControlFlow 0 210434) 210436)) inline$$Sub$0$anon3_Then$1_correct@@3)))
(let ((inline$$Sub$0$anon3_Else_correct@@3  (=> (and (and (<= (|i#$Integer| amount@@0) (|i#$Integer| inline$$Vector_borrow$0$dst@2@@2)) (= inline$$Sub$0$dst@1@@3 ($Integer (- (|i#$Integer| inline$$Vector_borrow$0$dst@2@@2) (|i#$Integer| amount@@0))))) (and (= $abort_flag@5@@4 $abort_flag@4@@4) (= inline$$Sub$0$dst@2@@3 inline$$Sub$0$dst@1@@3))) (and (=> (= (ControlFlow 0 210382) 212421) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 210382) 210512) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 210356) (- 0 273453)) true) (and (=> (= (ControlFlow 0 210356) 210434) inline$$Sub$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 210356) 210382) inline$$Sub$0$anon3_Else_correct@@3)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon86_Then_correct  (=> (and (|b#$Boolean| inline$$Le$0$dst@1@@1) (= (ControlFlow 0 210442) 210356)) inline$$Sub$0$Entry_correct@@3)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon87_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon87_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon86_Else$2_correct  (and (=> (= (ControlFlow 0 210251) (- 0 273351)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@2)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@3) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@3))))))))))))))) (=> (= $abort_code@5@@5 (|i#$Integer| call3formal@$ret0@0@@26)) (and (=> (= (ControlFlow 0 210251) 210267) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 210251) 210257) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon87_Else_correct)))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@0| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 210105) 210251)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon86_Else$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@0)) (= inline$$WritebackToGlobal$1$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))) (= |inline$$WritebackToGlobal$1$m'@1@@0| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0 inline$$WritebackToGlobal$1$v@1@@0)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@0| |inline$$WritebackToGlobal$1$m'@1@@0|) (= (ControlFlow 0 210159) 210251))) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon86_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$1$l@1@@0 (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (and (=> (= (ControlFlow 0 210095) 210159) inline$$WritebackToGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 210095) 210105) inline$$WritebackToGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$anon0_correct@@2  (and (=> (= (ControlFlow 0 209973) (- 0 273097)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 209973) (- 0 273118)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@5) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@5 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@5)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@5) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@5 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@5)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@2) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@2)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@2))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@6) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@6 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_9@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_8@@6)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@6) (< inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@6 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$range_11@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$1$$i_10@@6)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@2) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@2)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$i@@2))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$1$j@@2))))))))))))))))))))) (=> (= (ControlFlow 0 209973) 210095) inline$$WritebackToGlobal$1$anon0_correct@@0)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct@@2  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$1$$after@0@@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= (ControlFlow 0 209825) 209973)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$anon0_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon86_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$0$dst@1@@1)) (= (ControlFlow 0 209977) 209825)) inline$$DesignatedDealer_TierInfo_$pack_ref$1$Entry_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon84_Else_correct  (=> (not $abort_flag@4@@4) (and (=> (= (ControlFlow 0 209644) 210442) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 209644) 209977) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon38$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$t24@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@4)) (and (=> $abort_flag@4@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@26 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@26) (>= (|i#$Integer| call3formal@$ret0@0@@26) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@26) $MAX_U64))) (and (=> (= (ControlFlow 0 209638) 212441) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 209638) 209644) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$Le$0$anon0_correct@@1  (=> (and (= inline$$Le$0$dst@1@@1 ($Boolean (<= (|i#$Integer| amount@@0) (|i#$Integer| inline$$Vector_borrow$0$dst@2@@2)))) (= (ControlFlow 0 209626) 209638)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon38$1_correct)))
(let ((inline$$Le$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 209612) (- 0 272986)) true) (=> (= (ControlFlow 0 209612) 209626) inline$$Le$0$anon0_correct@@1))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 209568) 209612)) inline$$Le$0$Entry_correct@@1)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon83_Then_correct  (=> (= (ControlFlow 0 212465) 209612) inline$$Le$0$Entry_correct@@1)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon81_Else_correct  (=> (not $abort_flag@3@@5) (and (=> (= (ControlFlow 0 209560) 212465) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 209560) 209568) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@3@@5 true) (= inline$$Vector_borrow$0$dst@2@@2 inline$$Vector_borrow$0$dst@0@@2)) (and (=> (= (ControlFlow 0 209514) 212469) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 209514) 209560) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@2  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1@@2 0) (>= inline$$Vector_borrow$0$i_ind@1@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@2)))) (= (ControlFlow 0 209512) 209514)) inline$$Vector_borrow$0$anon3_Then$1_correct@@2)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@2  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@1@@2 0) (>= inline$$Vector_borrow$0$i_ind@1@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@2))))) (= inline$$Vector_borrow$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@2)) inline$$Vector_borrow$0$i_ind@1@@2))) (and (= $abort_flag@3@@5 $abort_flag@2@@5) (= inline$$Vector_borrow$0$dst@2@@2 inline$$Vector_borrow$0$dst@1@@2))) (and (=> (= (ControlFlow 0 209454) 212469) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 209454) 209560) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct@@2  (=> ((_ is $Vector) inline$$ReadRef$2$v@1@@2) (=> (and ((_ is $Integer) tier_index@@1) (= inline$$Vector_borrow$0$i_ind@1@@2 (|i#$Integer| tier_index@@1))) (and (=> (= (ControlFlow 0 209428) 209512) inline$$Vector_borrow$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 209428) 209454) inline$$Vector_borrow$0$anon3_Else_correct@@2))))))
(let ((inline$$Vector_borrow$0$Entry_correct@@2  (=> (and (= inline$$Vector_borrow$0$ta@0@@2 $IntegerType) (= (ControlFlow 0 209414) 209428)) inline$$Vector_borrow$0$anon0_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon79_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@1@@2) (= (ControlFlow 0 209520) 209414)) inline$$Vector_borrow$0$Entry_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon80_Else_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon80_Then_correct true))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon79_Else$2_correct  (and (=> (= (ControlFlow 0 209280) (- 0 272755)) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@4) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@4)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@5 T@$Value) )  (=> ((_ is $Address) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@5) (|b#$Boolean| ($Boolean (forall ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$addr@@5))))))))))))))) (=> (= $abort_code@3@@5 (|i#$Integer| call3formal@$ret0@0@@27)) (and (=> (= (ControlFlow 0 209280) 209300) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 209280) 209286) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon80_Else_correct)))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@2  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@2| $DesignatedDealer_TierInfo_$memory) (= (ControlFlow 0 209134) 209280)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon79_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@2  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@2 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@2)) (= inline$$WritebackToGlobal$0$a@1@@2 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@2))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@2 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))) (= |inline$$WritebackToGlobal$0$m'@1@@2| ($Memory (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2 inline$$WritebackToGlobal$0$v@1@@2)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@2| |inline$$WritebackToGlobal$0$m'@1@@2|) (= (ControlFlow 0 209188) 209280))) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon79_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@2  (=> (= inline$$WritebackToGlobal$0$l@1@@2 (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (and (=> (= (ControlFlow 0 209124) 209188) inline$$WritebackToGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 209124) 209134) inline$$WritebackToGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$anon0_correct@@2  (and (=> (= (ControlFlow 0 209002) (- 0 272501)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 209002) (- 0 272522)) (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@5) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@5 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@5)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@5) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@5 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@5)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@2) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@2)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@2))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@6) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@6 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_9@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_8@@6)))
(|b#$Boolean| ($Boolean (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@2)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@6) (< inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@6 (|i#$Integer| (|ub#$Range| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$range_11@@2)))) (let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@2 ($Integer inline$$DesignatedDealer_TierInfo_$pack_ref$0$$i_10@@6)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@2) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@2)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$i@@2))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| inline$$DesignatedDealer_TierInfo_$pack_ref$0$j@@2))))))))))))))))))))) (=> (= (ControlFlow 0 209002) 209124) inline$$WritebackToGlobal$0$anon0_correct@@2)))))))
(let ((inline$$DesignatedDealer_TierInfo_$pack_ref$0$Entry_correct@@2  (=> (and (= inline$$DesignatedDealer_TierInfo_$pack_ref$0$$after@0@@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= (ControlFlow 0 208854) 209002)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$anon0_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon79_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1@@2)) (= (ControlFlow 0 209006) 208854)) inline$$DesignatedDealer_TierInfo_$pack_ref$0$Entry_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon77_Else_correct  (=> (not $abort_flag@2@@5) (and (=> (= (ControlFlow 0 208673) 209520) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 208673) 209006) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon75_Else$1_correct  (=> (and (and (and (= inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$t20@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@5)) (and (=> $abort_flag@2@@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@27 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@27) (>= (|i#$Integer| call3formal@$ret0@0@@27) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@27) $MAX_U64))) (and (=> (= (ControlFlow 0 208667) 212489) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 208667) 208673) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct@@2  (=> (and (= inline$$Lt$0$dst@1@@2 ($Boolean (< (|i#$Integer| tier_index@@1) (|i#$Integer| inline$$Vector_length$0$l@1@@2)))) (= (ControlFlow 0 208655) 208667)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon75_Else$1_correct)))
(let ((inline$$Lt$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 208641) (- 0 272391)) true) (=> (= (ControlFlow 0 208641) 208655) inline$$Lt$0$anon0_correct@@2))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon75_Else_correct  (=> (and (not $abort_flag@1@@5) (= (ControlFlow 0 208661) 208641)) inline$$Lt$0$Entry_correct@@2)))
(let ((inline$$Vector_length$0$anon0_correct@@2  (=> (and ((_ is $Vector) inline$$ReadRef$2$v@1@@2) (= inline$$Vector_length$0$l@1@@2 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@2))))) (and (=> (= (ControlFlow 0 208585) 212509) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 208585) 208661) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@2  (=> (and (= inline$$Vector_length$0$ta@0@@2 $IntegerType) (= (ControlFlow 0 208573) 208585)) inline$$Vector_length$0$anon0_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 208534) 208573)) inline$$Vector_length$0$Entry_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 212533) 208573) inline$$Vector_length$0$Entry_correct@@2)))
(let ((inline$$ReadRef$2$anon0_correct@@2  (=> (= inline$$ReadRef$2$v@1@@2 (|v#$Mutation| inline$$BorrowField$1$dst@1@@1)) (and (=> (= (ControlFlow 0 208512) 212533) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 208512) 208534) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (=> (and (and (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1)) (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $DesignatedDealer_TierInfo_tiers) (+ inline$$BorrowField$1$size@1@@1 1)))) (and (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))) $DesignatedDealer_TierInfo_tiers))) (= (ControlFlow 0 208474) 208512))) inline$$ReadRef$2$anon0_correct@@2))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 208320) 208474)) inline$$BorrowField$1$anon0_correct@@1)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon73_Then_correct  (=> (= (ControlFlow 0 212541) 208474) inline$$BorrowField$1$anon0_correct@@1)))
(let ((inline$$ReadRef$1$anon0_correct@@2  (=> (= inline$$ReadRef$1$v@1@@2 (|v#$Mutation| inline$$BorrowField$0$dst@1@@3)) (and (=> (= (ControlFlow 0 208264) 212541) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 208264) 208320) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@3  (=> (= inline$$BorrowField$0$p@1@@3 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (=> (and (and (= inline$$BorrowField$0$size@1@@3 (|size#$Path| inline$$BorrowField$0$p@1@@3)) (= inline$$BorrowField$0$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@3) inline$$BorrowField$0$size@1@@3 $DesignatedDealer_TierInfo_window_inflow) (+ inline$$BorrowField$0$size@1@@3 1)))) (and (= inline$$BorrowField$0$dst@1@@3 ($Mutation (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|) inline$$BorrowField$0$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))) $DesignatedDealer_TierInfo_window_inflow))) (= (ControlFlow 0 208226) 208264))) inline$$ReadRef$1$anon0_correct@@2))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 208072) 208226)) inline$$BorrowField$0$anon0_correct@@3)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon72_Then_correct  (=> (and (= inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= (ControlFlow 0 212551) 208226)) inline$$BorrowField$0$anon0_correct@@3)))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) call4formal@$ret0@0@@0)) (and (=> (= (ControlFlow 0 208058) 212551) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 208058) 208072) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon70_Else_correct  (=> (and (not $abort_flag@1@@5) (= (ControlFlow 0 208064) 208058)) inline$$WriteRef$0$anon0_correct@@3)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon68_Else$2_correct  (and (=> (= (ControlFlow 0 208001) (- 0 271900)) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@9)) $i_0@@10) (< $i_0@@10 (|i#$Integer| (|ub#$Range| $range_1@@9)))) (let ((i@@20 ($Integer $i_0@@10)))
(|b#$Boolean| ($Boolean (let (($range_3@@9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@9)) $i_2@@10) (< $i_2@@10 (|i#$Integer| (|ub#$Range| $range_3@@9)))) (let ((j@@11 ($Integer $i_2@@10)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@20) (|i#$Integer| j@@11)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@20))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@11))))))))))))))))))))))) (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@11 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@9)) $i_0@@11) (< $i_0@@11 (|i#$Integer| (|ub#$Range| $range_1@@9)))) (let ((i@@20 ($Integer $i_0@@11)))
(|b#$Boolean| ($Boolean (let (($range_3@@9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@11 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@9)) $i_2@@11) (< $i_2@@11 (|i#$Integer| (|ub#$Range| $range_3@@9)))) (let ((j@@11 ($Integer $i_2@@11)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@20) (|i#$Integer| j@@11)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@20))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@11)))))))))))))))))))))) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@5) (=> $abort_flag@1@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@1@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@5 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@1@@5) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 86400000000))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 86400000000))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_window_start)))))))) ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_window_start (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)))))) $DesignatedDealer_TierInfo_window_inflow ($Integer 0)) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $DesignatedDealer_TierInfo_window_start (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)))))))))) ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 inline$$ReadRef$0$v@1@@3))))))) (=> (and (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@0) (let ((va@@96 (|v#$Vector| call4formal@$ret0@0@@0)))
(let ((l@@96 (|l#$ValueArray| va@@96)))
 (and (and (<= 0 l@@96) (<= l@@96 $MAX_U64)) (forall ((x@@96 Int) ) (!  (=> (or (< x@@96 0) (>= x@@96 l@@96)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_tiers)) (let ((va@@97 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@97 (|l#$ValueArray| va@@97)))
 (and (and (<= 0 l@@97) (<= l@@97 $MAX_U64)) (forall ((x@@97 Int) ) (!  (=> (or (< x@@97 0) (>= x@@97 l@@97)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97))
))))))) (forall (($$0@@31 Int) ) (!  (=> (and (>= $$0@@31 0) (< $$0@@31 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_tiers))) $$0@@31)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_tiers))) $$0@@31)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_tiers))) $$0@@31)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $DesignatedDealer_TierInfo_tiers))) $$0@@31))
))) (and (=> (= (ControlFlow 0 208001) 212555) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 208001) 208064) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon70_Else_correct))))))))
(let ((inline$$ReadRef$0$anon0_correct@@3  (=> (and (= inline$$ReadRef$0$v@1@@3 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (= (ControlFlow 0 207989) 208001)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon68_Else$2_correct)))
(let ((inline$$DesignatedDealer_TierInfo_$unpack_ref$0$anon0_correct@@2  (=> (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@2)) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@10 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@12 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@10)) $i_0@@12) (< $i_0@@12 (|i#$Integer| (|ub#$Range| $range_1@@10)))) (let ((i@@21 ($Integer $i_0@@12)))
(|b#$Boolean| ($Boolean (let (($range_3@@10 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@2)) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@12 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@10)) $i_2@@12) (< $i_2@@12 (|i#$Integer| (|ub#$Range| $range_3@@10)))) (let ((j@@12 ($Integer $i_2@@12)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@21) (|i#$Integer| j@@12)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@21))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@2)) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@12)))))))))))))))))))))) (= (ControlFlow 0 207953) 207989)) inline$$ReadRef$0$anon0_correct@@3)))
(let ((inline$$DesignatedDealer_TierInfo_$unpack_ref$0$Entry_correct@@2  (=> (and (= inline$$DesignatedDealer_TierInfo_$unpack_ref$0$$before@0@@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (= (ControlFlow 0 207947) 207953)) inline$$DesignatedDealer_TierInfo_$unpack_ref$0$anon0_correct@@2)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon68_Else_correct  (=> (and (not $abort_flag@0@@5) (= (ControlFlow 0 207957) 207947)) inline$$DesignatedDealer_TierInfo_$unpack_ref$0$Entry_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@0@@5 true) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 207907) 212575) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 207907) 207957) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2)) (= (ControlFlow 0 207905) 207907)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@2  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2) (= inline$$BorrowGlobal$0$dst@1@@2 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2)))) (and (= $abort_flag@0@@5 false) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 207853) 212575) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 207853) 207957) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@2  (=> (= inline$$BorrowGlobal$0$a@1@@2 (|a#$Address| dd_addr@@3)) (and (=> (= (ControlFlow 0 207823) 207905) inline$$BorrowGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 207823) 207853) inline$$BorrowGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@2  (=> (= inline$$BorrowGlobal$0$ta@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1)) (and (=> (= (ControlFlow 0 207817) (- 0 271782)) true) (=> (= (ControlFlow 0 207817) 207823) inline$$BorrowGlobal$0$anon0_correct@@2)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon6$3_correct  (and (=> (= (ControlFlow 0 207913) (- 0 271739)) (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| dd_addr@@3))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| dd_addr@@3)) (=> (= (ControlFlow 0 207913) 207817) inline$$BorrowGlobal$0$Entry_correct@@2)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon6_correct  (=> (and (= inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$$DesignatedDealer_TierInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| dd_addr@@3) true)) (= (ControlFlow 0 207614) 207913)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon6$3_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 207554) 207614)) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon6_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon67_Then_correct  (=> (= (ControlFlow 0 212599) 207614) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon6_correct)))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon66_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 207546) 212599) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 207546) 207554) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon66_Then_correct  (and (=> (= (ControlFlow 0 212607) 212599) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 212607) 207554) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon67_Else_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon65_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 207538) 212607) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 207538) 207546) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon65_Then_correct  (and (=> (= (ControlFlow 0 212615) 212607) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 212615) 207546) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon66_Else_correct))))
(let ((inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 207532) 212615) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 207532) 207538) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon65_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (and (and (and (forall (($inv_addr@@24 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@24)) (let ((va@@98 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@24))))
(let ((l@@98 (|l#$ValueArray| va@@98)))
 (and (and (<= 0 l@@98) (<= l@@98 $MAX_U64)) (forall ((x@@98 Int) ) (!  (=> (or (< x@@98 0) (>= x@@98 l@@98)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@24))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@24))
)) (forall (($inv_addr@@25 Int) ($inv_tv0@@11 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25)) (let ((va@@99 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))))
(let ((l@@99 (|l#$ValueArray| va@@99)))
 (and (and (<= 0 l@@99) (<= l@@99 $MAX_U64)) (forall ((x@@99 Int) ) (!  (=> (or (< x@@99 0) (>= x@@99 l@@99)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers)) (let ((va@@100 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@100 (|l#$ValueArray| va@@100)))
 (and (and (<= 0 l@@100) (<= l@@100 $MAX_U64)) (forall ((x@@100 Int) ) (!  (=> (or (< x@@100 0) (>= x@@100 l@@100)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100))
))))))) (forall (($$0@@32 Int) ) (!  (=> (and (>= $$0@@32 0) (< $$0@@32 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers))) $$0@@32)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers))) $$0@@32)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers))) $$0@@32)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers))) $$0@@32))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1@@11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0@@13 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@11)) $i_0@@13) (< $i_0@@13 (|i#$Integer| (|ub#$Range| $range_1@@11)))) (let ((i@@22 ($Integer $i_0@@13)))
(|b#$Boolean| ($Boolean (let (($range_3@@11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2@@13 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@11)) $i_2@@13) (< $i_2@@13 (|i#$Integer| (|ub#$Range| $range_3@@11)))) (let ((j@@13 ($Integer $i_2@@13)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@22) (|i#$Integer| j@@13)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@22))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@13))))))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@25))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 212619) 207532)))) inline$$DesignatedDealer_validate_and_record_mint_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@6  (=> ((_ is $Address) dd_addr@@3) (=> (and (and ((_ is $Integer) amount@@0) (>= (|i#$Integer| amount@@0) 0)) (<= (|i#$Integer| amount@@0) $MAX_U64)) (=> (and (and (and ((_ is $Integer) tier_index@@1) (>= (|i#$Integer| tier_index@@1) 0)) (<= (|i#$Integer| tier_index@@1) $MAX_U64)) (= (ControlFlow 0 205882) 212619)) anon0$1_correct@@6)))))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DesignatedDealer_TierInfo_$CallerDomain@@4 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| dd_addr@@3)) (= (ControlFlow 0 270440) 205882)) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
